'------------------------------------------------------------------------------
'
'  WIN32API.INC -- Win32 API Declarations for PB/DLL
'  Copyright (C) 1997-99 PowerBASIC, Inc.
'  Some portions Copyright (C) 1994 Microsoft Corporation
'
'  This file contains only the Equate, Type, and Declare statements for
'  Win32 APIs.
'
'  You have a royalty-free right to use, modify, reproduce and distribute
'  this file (and/or any modified version) in any way you find useful,
'  provided that you agree that both PowerBASIC and Microsoft have no
'  warranty, obligation or liability for its contents.  Refer to the
'  PowerBASIC DLL Compiler Reference Guide for further information.
'
'  Last Update: May 28, 1999
'
'------------------------------------------------------------------------------

%WINAPI                                      = 1
%TRUE                                        = 1
%FALSE                                       = 0
%NULL                                        = 0

' File attributes
%Normal                                      = &B000000
%ReadOnly                                    = &B000001
%Hidden                                      = &B000010
%System                                      = &B000100
%vLabel                                      = &B001000
%SubDir                                      = &B010000
%Archive                                     = &B100000

'Common RGB Colors
%Black                                       = &H000000???
%Blue                                        = &HFF0000???
%Green                                       = &H00FF00???
%Cyan                                        = &HFFFF00???
%Red                                         = &H0000FF???
%Magenta                                     = &HFF00FF???
%Yellow                                      = &H00FFFF???
%White                                       = &HFFFFFF???
%Gray                                        = &H808080???

%ANYSIZE_ARRAY                               = 1
%INVALID_HANDLE_VALUE                        = -1
%DELETE                                      = &H10000
%READ_CONTROL                                = &H20000
%WRITE_DAC                                   = &H40000
%WRITE_OWNER                                 = &H80000
%SYNCHRONIZE                                 = &H00100000???

%STANDARD_RIGHTS_READ                        = %READ_CONTROL
%STANDARD_RIGHTS_WRITE                       = %READ_CONTROL
%STANDARD_RIGHTS_EXECUTE                     = %READ_CONTROL
%STANDARD_RIGHTS_REQUIRED                    = &H000F0000???
%STANDARD_RIGHTS_ALL                         = &H001F0000???

%SPECIFIC_RIGHTS_ALL                         = &HFFFF

%SID_REVISION                                = 1     ' Current revision level
%SID_MAX_SUB_AUTHORITIES                     = 15
%SID_RECOMMENDED_SUB_AUTHORITIES             = 1     ' Will change to around 6 in a future release.

%SIDTYPEUSER                                 = 1
%SIDTYPEGROUP                                = 2
%SIDTYPEDOMAIN                               = 3
%SIDTYPEALIAS                                = 4
%SIDTYPEWELLKNOWNGROUP                       = 5
%SIDTYPEDELETEDACCOUNT                       = 6
%SIDTYPEINVALID                              = 7
%SIDTYPEUNKNOWN                              = 8

%SV_HIDDEN                                   = 1
%SV_VISIBLE                                  = 0

%SECURITY_NULL_RID                           = &H0
%SECURITY_WORLD_RID                          = &H0
%SECURITY_LOCAL_RID                          = &H0

%SECURITY_CREATOR_OWNER_RID                  = &H0
%SECURITY_CREATOR_GROUP_RID                  = &H1
%SECURITY_DIALUP_RID                         = &H1
%SECURITY_NETWORK_RID                        = &H2
%SECURITY_BATCH_RID                          = &H3
%SECURITY_INTERACTIVE_RID                    = &H4
%SECURITY_SERVICE_RID                        = &H6
%SECURITY_ANONYMOUS_LOGON_RID                = &H7
%SECURITY_LOGON_IDS_RID                      = &H5
%SECURITY_LOCAL_SYSTEM_RID                   = &H12
%SECURITY_NT_NON_UNIQUE                      = &H15
%SECURITY_BUILTIN_DOMAIN_RID                 = &H20

%SERVICE_WIN32_OWN_PROCESS                   = &H00000010
%SERVICE_WIN32_SHARE_PROCESS                 = &H00000020
%SERVICE_WIN32                               = (%SERVICE_WIN32_OWN_PROCESS OR %SERVICE_WIN32_SHARE_PROCESS)

'start types
%SERVICE_BOOT_START                          = &H00000000
%SERVICE_SYSTEM_START                        = &H00000001
%SERVICE_AUTO_START                          = &H00000002
%SERVICE_DEMAND_START                        = &H00000003
%SERVICE_DISABLED                            = &H00000004

' Error control type

%SERVICE_ERROR_IGNORE                        = &H00000000
%SERVICE_ERROR_NORMAL                        = &H00000001
%SERVICE_ERROR_SEVERE                        = &H00000002
%SERVICE_ERROR_CRITICAL                      = &H00000003

%USER_PRIV_GUEST                             = 0
%USER_PRIV_USER                              = 1
%USER_PRIV_ADMIN                             = 2

' Defines for the READ flags for Eventlogging

%EVENTLOG_SEQUENTIAL_READ                    = &H0001
%EVENTLOG_SEEK_READ                          = &H0002
%EVENTLOG_FORWARDS_READ                      = &H0004
%EVENTLOG_BACKWARDS_READ                     = &H0008

' The types of events that can be logged.

%EVENTLOG_SUCCESS                            = &H0000
%EVENTLOG_ERROR_TYPE                         = &H0001
%EVENTLOG_WARNING_TYPE                       = &H0002
%EVENTLOG_INFORMATION_TYPE                   = &H0004
%EVENTLOG_AUDIT_SUCCESS                      = &H0008
%EVENTLOG_AUDIT_FAILURE                      = &H0010

' Defines for the WRITE flags used by Auditing for paired events
' These are not implemented in Product 1

%EVENTLOG_START_PAIRED_EVENT                 = &H0001
%EVENTLOG_END_PAIRED_EVENT                   = &H0002
%EVENTLOG_END_ALL_PAIRED_EVENTS              = &H0004
%EVENTLOG_PAIRED_EVENT_ACTIVE                = &H0008
%EVENTLOG_PAIRED_EVENT_INACTIVE              = &H0010

%DOMAIN_USER_RID_ADMIN                       = &H1F4
%DOMAIN_USER_RID_GUEST                       = &H1F5

%DOMAIN_GROUP_RID_ADMINS                     = &H200
%DOMAIN_GROUP_RID_USERS                      = &H201
%DOMAIN_GROUP_RID_GUESTS                     = &H202


%DOMAIN_ALIAS_RID_ADMINS                     = &H220
%DOMAIN_ALIAS_RID_USERS                      = &H221
%DOMAIN_ALIAS_RID_GUESTS                     = &H222
%DOMAIN_ALIAS_RID_POWER_USERS                = &H223
%DOMAIN_ALIAS_RID_ACCOUNT_OPS                = &H224
%DOMAIN_ALIAS_RID_SYSTEM_OPS                 = &H225
%DOMAIN_ALIAS_RID_PRINT_OPS                  = &H226
%DOMAIN_ALIAS_RID_BACKUP_OPS                 = &H227
%DOMAIN_ALIAS_RID_REPLICATOR                 = &H228

%SE_GROUP_MANDATORY                          = &H1
%SE_GROUP_ENABLED_BY_DEFAULT                 = &H2
%SE_GROUP_ENABLED                            = &H4
%SE_GROUP_OWNER                              = &H8
%SE_GROUP_LOGON_ID                           = &HC0000000

%FILE_BEGIN                                  = 0
%FILE_CURRENT                                = 1
%FILE_END                                    = 2

%FILE_FLAG_POSIX_SEMANTICS                   = &H1000000
%FILE_FLAG_BACKUP_SEMANTICS                  = &H2000000
%FILE_FLAG_DELETE_ON_CLOSE                   = &H4000000
%FILE_FLAG_SEQUENTIAL_SCAN                   = &H8000000
%FILE_FLAG_RANDOM_ACCESS                     = &H10000000
%FILE_FLAG_NO_BUFFERING                      = &H20000000
%FILE_FLAG_OVERLAPPED                        = &H40000000
%FILE_FLAG_WRITE_THROUGH                     = &H80000000

%CREATE_NEW                                  = 1
%CREATE_ALWAYS                               = 2
%OPEN_EXISTING                               = 3
%OPEN_ALWAYS                                 = 4
%TRUNCATE_EXISTING                           = 5

%VWIN32_DIOC_DOS_IOCTL                       = 1 ' DOS IOCTL commands
%VWIN32_DIOC_DOS_INT25                       = 2 ' absolute disk read
%VWIN32_DIOC_DOS_INT26                       = 3 ' absolute disk write
%VWIN32_DIOC_DOS_INT13                       = 4 ' INT 13
%VWIN32_DIOC_DOS_DRIVEINFO                   = 6 ' Win95B or later

%FILE_DEVICE_DISK                            = &H07???
%FILE_DEVICE_FILE_SYSTEM                     = &H09???
%FILE_DEVICE_BATTERY                         = &H29???
%FILE_DEVICE_BUS_EXTENDER                    = &H2A???
%FILE_DEVICE_MODEM                           = &H2B???
%FILE_DEVICE_VDM                             = &H2C???
%FILE_DEVICE_MASS_STORAGE                    = &H2D???

%METHOD_BUFFERED                             = 0???
%METHOD_IN_DIRECT                            = 1???
%METHOD_OUT_DIRECT                           = 2???
%METHOD_NEITHER                              = 3???

%IOCTL_DISK_BASE                             = %FILE_DEVICE_DISK
%IOCTL_STORAGE_BASE                          = %FILE_DEVICE_MASS_STORAGE

%IOCTL_STORAGE_CHECK_VERIFY                  = &H002D4800???
%IOCTL_STORAGE_MEDIA_REMOVAL                 = &H002D4801???
%IOCTL_STORAGE_EJECT_MEDIA                   = &H002D4808???
%IOCTL_STORAGE_LOAD_MEDIA                    = &H002D480C???

%IOCTL_STORAGE_RESERVE                       = &H00AD0001???
%IOCTL_STORAGE_RELEASE                       = &H00AD4001???
%IOCTL_STORAGE_FIND_NEW_DEVICES              = &H00AD8001???
%IOCTL_STORAGE_GET_MEDIA_TYPES               = &H00ED0000???

%FSCTL_REQUEST_OPLOCK_LEVEL_1                = &H90000???
%FSCTL_OPBATCH_ACK_CLOSE_PENDING             = &H90000???
%FSCTL_ALLOW_EXTENDED_DASD_IO                = &H9000C???
%FSCTL_REQUEST_OPLOCK_LEVEL_2                = &H94000???
%FSCTL_OPLOCK_BREAK_NOTIFY                   = &H94000???
%FSCTL_READ_PROPERTY_DATA                    = &H9400C???
%FSCTL_DUMP_PROPERTY_DATA                    = &H9400C???
%FSCTL_REQUEST_BATCH_OPLOCK                  = &H98000???
%FSCTL_LOCK_VOLUME                           = &H98000???
%FSCTL_SET_OBJECT_ID                         = &H98002???
%FSCTL_WRITE_PROPERTY_DATA                   = &H9800C???
%FSCTL_OPLOCK_BREAK_ACKNOWLEDGE              = &H9C000???
%FSCTL_UNLOCK_VOLUME                         = &H9C000???
%FSCTL_GET_OBJECT_ID                         = &H9C000???
%FSCTL_FIND_FILES_BY_SID                     = &H9C00C???
%FSCTL_DISMOUNT_VOLUME                       = &HB0000???
%FSCTL_MARK_VOLUME_DIRTY                     = &HB0000???
%FSCTL_DELETE_OBJECT_ID                      = &HB0002???
%FSCTL_ENUM_USN_DATA                         = &HB000D???
%FSCTL_SET_REPARSE_POINT                     = &HB4002???
%FSCTL_SECURITY_ID_CHECK                     = &HB400D???
%FSCTL_IS_VOLUME_MOUNTED                     = &HB8000???
%FSCTL_GET_REPARSE_POINT                     = &HB8000???
%FSCTL_QUERY_RETRIEVAL_POINTERS              = &HB800C???
%FSCTL_READ_USN_JOURNAL                      = &HB800D???
%FSCTL_IS_PATHNAME_VALID                     = &HBC000???
%FSCTL_GET_COMPRESSION                       = &HBC000???
%FSCTL_DELETE_REPARSE_POINT                  = &HBC002???
%FSCTL_SET_OBJECT_ID_EXTENDED                = &HBC002???
%FSCTL_OPLOCK_BREAK_ACK_NO_2                 = &HD0000???
%FSCTL_CREATE_OR_GET_OBJECT_ID               = &HD0000???
%FSCTL_ENABLE_UPGRADE                        = &HD0002???
%FSCTL_SET_COMPRESSION                       = &HD0003???
%FSCTL_INVALIDATE_VOLUMES                    = &HD4000???
%FSCTL_SET_ENCRYPTION                        = &HD4000???
%FSCTL_SET_SPARSE                            = &HD4002???
%FSCTL_QUERY_FAT_BPB                         = &HD8000???
%FSCTL_SET_ZERO_DATA                         = &HD8002???
%FSCTL_ENCRYPTION_FSCTL_IO                   = &HD800C???
%FSCTL_REQUEST_FILTER_OPLOCK                 = &HDC000???
%FSCTL_MARK_AS_SYSTEM_HIVE                   = &HDC00C???
%FSCTL_WRITE_RAW_ENCRYPTED                   = &HDC00C???
%FSCTL_QUERY_ALLOCATED_RANGES                = &HDC00D???
%FSCTL_FILESYSTEM_GET_STATISTICS             = &HF0000???
%FSCTL_EXTEND_VOLUME                         = &HF0000???
%FSCTL_GET_RETRIEVAL_POINTERS                = &HF000C???
%FSCTL_READ_RAW_ENCRYPTED                    = &HF000C???
%FSCTL_GET_NTFS_VOLUME_DATA                  = &HF4000???
%FSCTL_MOVE_FILE                             = &HF4000???
%FSCTL_CREATE_USN_JOURNAL                    = &HF400D???
%FSCTL_GET_NTFS_FILE_RECORD                  = &HF8000???
%FSCTL_IS_VOLUME_DIRTY                       = &HF8000???
%FSCTL_READ_FILE_USN_DATA                    = &HF800D???
%FSCTL_GET_HFS_INFORMATION                   = &HFC000???
%FSCTL_GET_VOLUME_BITMAP                     = &HFC00C???
%FSCTL_WRITE_USN_CLOSE_RECORD                = &HFC00D???

%FILE_ANY_ACCESS                             = 0%
%FILE_READ_ACCESS                            = 1%
%FILE_WRITE_ACCESS                           = 2%

%PIPE_ACCESS_INBOUND                         = &H1
%PIPE_ACCESS_OUTBOUND                        = &H2
%PIPE_ACCESS_DUPLEX                          = &H3

%PIPE_CLIENT_END                             = &H0
%PIPE_SERVER_END                             = &H1

%PIPE_WAIT                                   = &H0
%PIPE_NOWAIT                                 = &H1
%PIPE_READMODE_BYTE                          = &H0
%PIPE_READMODE_MESSAGE                       = &H2
%PIPE_TYPE_BYTE                              = &H0
%PIPE_TYPE_MESSAGE                           = &H4

%PIPE_UNLIMITED_INSTANCES                    = 255

%SECURITY_CONTEXT_TRACKING                   = &H40000
%SECURITY_EFFECTIVE_ONLY                     = &H80000

%SECURITY_SQOS_PRESENT                       = &H100000
%SECURITY_VALID_SQOS_FLAGS                   = &H1F0000

%SP_SERIALCOMM                               = &H1&

%PST_UNSPECIFIED                             = &H0&
%PST_RS232                                   = &H1&
%PST_PARALLELPORT                            = &H2&
%PST_RS422                                   = &H3&
%PST_RS423                                   = &H4&
%PST_RS449                                   = &H5&
%PST_FAX                                     = &H21&
%PST_SCANNER                                 = &H22&
%PST_NETWORK_BRIDGE                          = &H100&
%PST_LAT                                     = &H101&
%PST_TCPIP_TELNET                            = &H102&
%PST_X25                                     = &H103&

%PCF_DTRDSR                                  = &H1&
%PCF_RTSCTS                                  = &H2&
%PCF_RLSD                                    = &H4&
%PCF_PARITY_CHECK                            = &H8&
%PCF_XONXOFF                                 = &H10&
%PCF_SETXCHAR                                = &H20&
%PCF_TOTALTIMEOUTS                           = &H40&
%PCF_INTTIMEOUTS                             = &H80&
%PCF_SPECIALCHARS                            = &H100&
%PCF_16BITMODE                               = &H200&

%DLL_PROCESS_DETACH                          = 0
%DLL_PROCESS_ATTACH                          = 1
%DLL_THREAD_ATTACH                           = 2
%DLL_THREAD_DETACH                           = 3

%SP_PARITY                                   = &H1&
%SP_BAUD                                     = &H2&
%SP_DATABITS                                 = &H4&
%SP_STOPBITS                                 = &H8&
%SP_HANDSHAKING                              = &H10&
%SP_PARITY_CHECK                             = &H20&
%SP_RLSD                                     = &H40&

%BAUD_075                                    = &H1&
%BAUD_110                                    = &H2&
%BAUD_134_5                                  = &H4&
%BAUD_150                                    = &H8&
%BAUD_300                                    = &H10&
%BAUD_600                                    = &H20&
%BAUD_1200                                   = &H40&
%BAUD_1800                                   = &H80&
%BAUD_2400                                   = &H100&
%BAUD_4800                                   = &H200&
%BAUD_7200                                   = &H400&
%BAUD_9600                                   = &H800&
%BAUD_14400                                  = &H1000&
%BAUD_19200                                  = &H2000&
%BAUD_38400                                  = &H4000&
%BAUD_56K                                    = &H8000&
%BAUD_128K                                   = &H10000
%BAUD_115200                                 = &H20000
%BAUD_57600                                  = &H40000
%BAUD_USER                                   = &H10000000

%DATABITS_5                                  = &H1&
%DATABITS_6                                  = &H2&
%DATABITS_7                                  = &H4&
%DATABITS_8                                  = &H8&
%DATABITS_16                                 = &H10&
%DATABITS_16X                                = &H20&

%STOPBITS_10                                 = &H1&
%STOPBITS_15                                 = &H2&
%STOPBITS_20                                 = &H4&
%PARITY_NONE                                 = &H100&
%PARITY_ODD                                  = &H200&
%PARITY_EVEN                                 = &H400&
%PARITY_MARK                                 = &H800&
%PARITY_SPACE                                = &H1000&

%DTR_CONTROL_DISABLE                         = &H0
%DTR_CONTROL_ENABLE                          = &H1
%DTR_CONTROL_HANDSHAKE                       = &H2

%RTS_CONTROL_DISABLE                         = &H0
%RTS_CONTROL_ENABLE                          = &H1
%RTS_CONTROL_HANDSHAKE                       = &H2
%RTS_CONTROL_TOGGLE                          = &H3

%SHFMT_ID_DEFAULT                            = &HFFFF
%SHFMT_OPT_FULL                              = &H1
%SHFMT_OPT_SYSONLY                           = &H2
%SHFMT_NOFORMAT                              = &HFFFFFFFD
%SHFMT_CANCEL                                = &HFFFFFFFE
%SHFMT_ERROR                                 = &HFFFFFFFF

%GMEM_FIXED                                  = &H0
%GMEM_MOVEABLE                               = &H2
%GMEM_NOCOMPACT                              = &H10
%GMEM_NODISCARD                              = &H20
%GMEM_ZEROINIT                               = &H40
%GMEM_MODIFY                                 = &H80
%GMEM_DISCARDABLE                            = &H100
%GMEM_NOT_BANKED                             = &H1000
%GMEM_SHARE                                  = &H2000
%GMEM_DDESHARE                               = &H2000
%GMEM_NOTIFY                                 = &H4000
%GMEM_LOWER                                  = %GMEM_NOT_BANKED
%GMEM_VALID_FLAGS                            = &H7F72
%GMEM_INVALID_HANDLE                         = &H8000

%MIIM_STATE                                  = &H00000001
%MIIM_ID                                     = &H00000002
%MIIM_SUBMENU                                = &H00000004
%MIIM_CHECKMARKS                             = &H00000008
%MIIM_TYPE                                   = &H00000010
%MIIM_DATA                                   = &H00000020

%GMEM_DISCARDED                              = &H4000
%GMEM_LOCKCOUNT                              = &HFF

%GHND                                        = %GMEM_MOVEABLE OR %GMEM_ZEROINIT
%GPTR                                        = %GMEM_FIXED OR %GMEM_ZEROINIT

%LMEM_FIXED                                  = &H0
%LMEM_MOVEABLE                               = &H2
%LMEM_NOCOMPACT                              = &H10
%LMEM_NODISCARD                              = &H20
%LMEM_ZEROINIT                               = &H40
%LMEM_MODIFY                                 = &H80
%LMEM_DISCARDABLE                            = &HF00
%LMEM_VALID_FLAGS                            = &HF72
%LMEM_INVALID_HANDLE                         = &H8000

%LHND                                        = %LMEM_MOVEABLE + %LMEM_ZEROINIT
%LPTR                                        = %LMEM_FIXED + %LMEM_ZEROINIT

%NONZEROLHND                                 = %LMEM_MOVEABLE
%NONZEROLPTR                                 = %LMEM_FIXED

%LMEM_DISCARDED                              = &H4000
%LMEM_LOCKCOUNT                              = &HFF

%HEAP_NO_SERIALIZE                           = &H1???
%HEAP_GROWABLE                               = &H2???
%HEAP_GENERATE_EXCEPTIONS                    = &H4???
%HEAP_ZERO_MEMORY                            = &H8???

%DEBUG_PROCESS                               = &H1
%DEBUG_ONLY_THIS_PROCESS                     = &H2

%CREATE_SUSPENDED                            = &H4

%DETACHED_PROCESS                            = &H8

%CREATE_NEW_CONSOLE                          = &H10

%NORMAL_PRIORITY_CLASS                       = &H20
%IDLE_PRIORITY_CLASS                         = &H40
%HIGH_PRIORITY_CLASS                         = &H80
%REALTIME_PRIORITY_CLASS                     = &H100

%CREATE_NEW_PROCESS_GROUP                    = &H200

%CREATE_NO_WINDOW                            = &H8000000

%PROFILE_USER                                = &H10000000
%PROFILE_KERNEL                              = &H20000000
%PROFILE_SERVER                              = &H40000000

%MAXLONG                                     = &H7FFFFFFF&
%THREAD_BASE_PRIORITY_MIN                    = -2
%THREAD_BASE_PRIORITY_MAX                    = 2
%THREAD_BASE_PRIORITY_LOWRT                  = 15
%THREAD_BASE_PRIORITY_IDLE                   = -15
%THREAD_PRIORITY_LOWEST                      = %THREAD_BASE_PRIORITY_MIN
%THREAD_PRIORITY_BELOW_NORMAL                = %THREAD_PRIORITY_LOWEST + 1
%THREAD_PRIORITY_NORMAL                      = 0
%THREAD_PRIORITY_HIGHEST                     = %THREAD_BASE_PRIORITY_MAX
%THREAD_PRIORITY_ABOVE_NORMAL                = %THREAD_PRIORITY_HIGHEST - 1
%THREAD_PRIORITY_ERROR_RETURN                = %MAXLONG

%THREAD_PRIORITY_TIME_CRITICAL               = %THREAD_BASE_PRIORITY_LOWRT
%THREAD_PRIORITY_IDLE                        = %THREAD_BASE_PRIORITY_IDLE

%APPLICATION_ERROR_MASK                      = &H20000000
%ERROR_SEVERITY_SUCCESS                      = &H0
%ERROR_SEVERITY_INFORMATIONAL                = &H40000000
%ERROR_SEVERITY_WARNING                      = &H80000000
%ERROR_SEVERITY_ERROR                        = &HC0000000

%MINCHAR                                     = &H80?
%MAXCHAR                                     = &H7F?
%MINSHORT                                    = &H8000%
%MAXSHORT                                    = &H7FFF%
%MINLONG                                     = &H80000000&
%MAXBYTE                                     = &HFF?
%MAXWORD                                     = &HFFFF??
%MAXDWORD                                    = &HFFFFFFFF???

%LANG_NEUTRAL                                = &H0
%LANG_BULGARIAN                              = &H2
%LANG_CHINESE                                = &H4
%LANG_CZECH                                  = &H5
%LANG_DANISH                                 = &H6
%LANG_ENGLISH                                = &H9
%LANG_SPANISH                                = &HA
%LANG_FINNISH                                = &HB
%LANG_FRENCH                                 = &HC
%LANG_GERMAN                                 = &H7
%LANG_GREEK                                  = &H8
%LANG_HUNGARIAN                              = &HE
%LANG_ICELANDIC                              = &HF
%LANG_ITALIAN                                = &H10
%LANG_JAPANESE                               = &H11
%LANG_KOREAN                                 = &H12
%LANG_DUTCH                                  = &H13
%LANG_NORWEGIAN                              = &H14
%LANG_POLISH                                 = &H15
%LANG_PORTUGUESE                             = &H16
%LANG_ROMANIAN                               = &H18
%LANG_RUSSIAN                                = &H19
%LANG_CROATIAN                               = &H1A
%LANG_SLOVAK                                 = &H1B
%LANG_SLOVENIAN                              = &H24
%LANG_SWEDISH                                = &H1D
%LANG_TURKISH                                = &H1F

%SUBLANG_NEUTRAL                             = &H0  '  language neutral
%SUBLANG_DEFAULT                             = &H1  '  user default
%SUBLANG_SYS_DEFAULT                         = &H2  '  system default

%SUBLANG_CHINESE_TRADITIONAL                 = &H1  '  Chinese (Taiwan)
%SUBLANG_CHINESE_SIMPLIFIED                  = &H2  '  Chinese (PR China)
%SUBLANG_CHINESE_HONGKONG                    = &H3  '  Chinese (Hong Kong)
%SUBLANG_CHINESE_SINGAPORE                   = &H4  '  Chinese (Singapore)
%SUBLANG_DUTCH                               = &H1  '  Dutch
%SUBLANG_DUTCH_BELGIAN                       = &H2  '  Dutch (Belgian)
%SUBLANG_ENGLISH_US                          = &H1  '  English (USA)
%SUBLANG_ENGLISH_UK                          = &H2  '  English (UK)
%SUBLANG_ENGLISH_AUS                         = &H3  '  English (Australian)
%SUBLANG_ENGLISH_CAN                         = &H4  '  English (Canadian)
%SUBLANG_ENGLISH_NZ                          = &H5  '  English (New Zealand)
%SUBLANG_ENGLISH_EIRE                        = &H6  '  English (Irish)
%SUBLANG_FRENCH                              = &H1  '  French
%SUBLANG_FRENCH_BELGIAN                      = &H2  '  French (Belgian)
%SUBLANG_FRENCH_CANADIAN                     = &H3  '  French (Canadian)
%SUBLANG_FRENCH_SWISS                        = &H4  '  French (Swiss)
%SUBLANG_GERMAN                              = &H1  '  German
%SUBLANG_GERMAN_SWISS                        = &H2  '  German (Swiss)
%SUBLANG_GERMAN_AUSTRIAN                     = &H3  '  German (Austrian)
%SUBLANG_ITALIAN                             = &H1  '  Italian
%SUBLANG_ITALIAN_SWISS                       = &H2  '  Italian (Swiss)
%SUBLANG_NORWEGIAN_BOKMAL                    = &H1  '  Norwegian (Bokma
%SUBLANG_NORWEGIAN_NYNORSK                   = &H2  '  Norwegian (Nynorsk)
%SUBLANG_PORTUGUESE                          = &H2  '  Portuguese
%SUBLANG_PORTUGUESE_BRAZILIAN                = &H1  '  Portuguese (Brazilian)
%SUBLANG_SPANISH                             = &H1  '  Spanish (Castilian)
%SUBLANG_SPANISH_MEXICAN                     = &H2  '  Spanish (Mexican)
%SUBLANG_SPANISH_MODERN                      = &H3  '  Spanish (Modern)

%SORT_DEFAULT                                = &H0  '  sorting default

%SORT_JAPANESE_XJIS                          = &H0  '  Japanese JIS order
%SORT_JAPANESE_UNICODE                       = &H1  '  Japanese Unicode order

%SORT_CHINESE_BIG5                           = &H0  '  Chinese BIG5 order
%SORT_CHINESE_UNICODE                        = &H1  '  Chinese Unicode order

%SORT_KOREAN_KSC                             = &H0  '  Korean KSC order
%SORT_KOREAN_UNICODE                         = &H1  '  Korean Unicode order

%FILE_READ_DATA                              = &H1  '  file pipe
%FILE_LIST_DIRECTORY                         = &H1  '  directory
%FILE_WRITE_DATA                             = &H2  '  file pipe
%FILE_ADD_FILE                               = &H2  '  directory
%FILE_APPEND_DATA                            = &H4  '  file
%FILE_ADD_SUBDIRECTORY                       = &H4  '  directory
%FILE_CREATE_PIPE_INSTANCE                   = &H4  '  named pipe
%FILE_READ_EA                                = &H8  '  file directory
%FILE_READ_PROPERTIES                        = %FILE_READ_EA
%FILE_WRITE_EA                               = &H10 '  file directory
%FILE_WRITE_PROPERTIES                       = %FILE_WRITE_EA
%FILE_EXECUTE                                = &H20 '  file
%FILE_TRAVERSE                               = &H20 '  directory
%FILE_DELETE_CHILD                           = &H40 '  directory
%FILE_READ_ATTRIBUTES                        = &H80 '  all
%FILE_WRITE_ATTRIBUTES                       = &H100 '  all
%FILE_ALL_ACCESS                             = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H1FF
%FILE_GENERIC_READ                           = %STANDARD_RIGHTS_READ OR %FILE_READ_DATA OR %FILE_READ_ATTRIBUTES OR %FILE_READ_EA OR %SYNCHRONIZE
%FILE_GENERIC_WRITE                          = %STANDARD_RIGHTS_WRITE OR %FILE_WRITE_DATA OR %FILE_WRITE_ATTRIBUTES OR %FILE_WRITE_EA OR %FILE_APPEND_DATA OR %SYNCHRONIZE
%FILE_GENERIC_EXECUTE                        = %STANDARD_RIGHTS_EXECUTE OR %FILE_READ_ATTRIBUTES OR %FILE_EXECUTE OR %SYNCHRONIZE
%FILE_SHARE_READ                             = &H1
%FILE_SHARE_WRITE                            = &H2
%FILE_ATTRIBUTE_READONLY                     = &H1
%FILE_ATTRIBUTE_HIDDEN                       = &H2
%FILE_ATTRIBUTE_SYSTEM                       = &H4
%FILE_ATTRIBUTE_DIRECTORY                    = &H10
%FILE_ATTRIBUTE_ARCHIVE                      = &H20
%FILE_ATTRIBUTE_NORMAL                       = &H80
%FILE_ATTRIBUTE_TEMPORARY                    = &H100
%FILE_ATTRIBUTE_COMPRESSED                   = &H800
%FILE_NOTIFY_CHANGE_FILE_NAME                = &H1
%FILE_NOTIFY_CHANGE_DIR_NAME                 = &H2
%FILE_NOTIFY_CHANGE_ATTRIBUTES               = &H4
%FILE_NOTIFY_CHANGE_SIZE                     = &H8
%FILE_NOTIFY_CHANGE_LAST_WRITE               = &H10
%FILE_NOTIFY_CHANGE_SECURITY                 = &H100
%MAILSLOT_NO_MESSAGE                         = -1
%MAILSLOT_WAIT_FOREVER                       = -1
%FILE_CASE_SENSITIVE_SEARCH                  = &H1
%FILE_CASE_PRESERVED_NAMES                   = &H2
%FILE_UNICODE_ON_DISK                        = &H4
%FILE_PERSISTENT_ACLS                        = &H8
%FILE_FILE_COMPRESSION                       = &H10
%FILE_VOLUME_IS_COMPRESSED                   = &H8000
%IO_COMPLETION_MODIFY_STATE                  = &H2
%IO_COMPLETION_ALL_ACCESS                    = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &H3
%DUPLICATE_CLOSE_SOURCE                      = &H1
%DUPLICATE_SAME_ACCESS                       = &H2

%ACCESS_SYSTEM_SECURITY                      = &H1000000

%MAXIMUM_ALLOWED                             = &H2000000

%GENERIC_READ                                = &H80000000
%GENERIC_WRITE                               = &H40000000
%GENERIC_EXECUTE                             = &H20000000
%GENERIC_ALL                                 = &H10000000

%ACL_REVISION                                = 2
%ACL_REVISION1                               = 1
%ACL_REVISION2                               = 2

%ACCESS_ALLOWED_ACE_TYPE                     = &H0
%ACCESS_DENIED_ACE_TYPE                      = &H1
%SYSTEM_AUDIT_ACE_TYPE                       = &H2
%SYSTEM_ALARM_ACE_TYPE                       = &H3

%HELPINFO_WINDOW                             = 1
%HELPINFO_MENUITEM                           = 2

%OBJECT_INHERIT_ACE                          = &H1
%CONTAINER_INHERIT_ACE                       = &H2
%NO_PROPAGATE_INHERIT_ACE                    = &H4
%INHERIT_ONLY_ACE                            = &H8
%VALID_INHERIT_FLAGS                         = &HF

%SUCCESSFUL_ACCESS_ACE_FLAG                  = &H40
%FAILED_ACCESS_ACE_FLAG                      = &H80

%ACLREVISIONINFORMATION                      = 1
%ACLSIZEINFORMATION                          = 2

%SECURITY_DESCRIPTOR_REVISION                = 1
%SECURITY_DESCRIPTOR_REVISION1               = 1
%SECURITY_DESCRIPTOR_MIN_LENGTH              = 20

%SE_OWNER_DEFAULTED                          = &H1
%SE_GROUP_DEFAULTED                          = &H2
%SE_DACL_PRESENT                             = &H4
%SE_DACL_DEFAULTED                           = &H8
%SE_SACL_PRESENT                             = &H10
%SE_SACL_DEFAULTED                           = &H20
%SE_SELF_RELATIVE                            = &H8000

%SE_PRIVILEGE_ENABLED_BY_DEFAULT             = &H1
%SE_PRIVILEGE_ENABLED                        = &H2
%SE_PRIVILEGE_USED_FOR_ACCESS                = &H80000000

%PRIVILEGE_SET_ALL_NECESSARY                 = 1

%SECURITYANONYMOUS                           = 1
%SECURITYIDENTIFICATION                      = 2

%REG_OPTION_RESERVED                         = 0     ' Parameter is reserved
%REG_OPTION_NON_VOLATILE                     = 0     ' Key is preserved when system is rebooted
%REG_OPTION_VOLATILE                         = 1     ' Key is not preserved when system is rebooted
%REG_OPTION_CREATE_LINK                      = 2     ' Created key is a symbolic link
%REG_OPTION_BACKUP_RESTORE                   = 4     ' open for backup or restore

%REG_NONE                                    = 0     ' No value type
%REG_SZ                                      = 1     ' Unicode nul terminated string
%REG_EXPAND_SZ                               = 2     ' Unicode nul terminated string
%REG_BINARY                                  = 3     ' Free form binary
%REG_DWORD                                   = 4     ' 32-bit number
%REG_DWORD_LITTLE_ENDIAN                     = 4     ' 32-bit number (same as REG_DWORD)
%REG_DWORD_BIG_ENDIAN                        = 5     ' 32-bit number
%REG_LINK                                    = 6     ' Symbolic Link (unicode)
%REG_MULTI_SZ                                = 7     ' Multiple Unicode strings
%REG_RESOURCE_LIST                           = 8     ' Resource list in the resource map
%REG_FULL_RESOURCE_DESCRIPTOR                = 9     ' Resource list in the hardware description
%REG_RESOURCE_REQUIREMENTS_LIST              = 10
%REG_CREATED_NEW_KEY                         = &H1   ' New Registry Key created
%REG_OPENED_EXISTING_KEY                     = &H2   ' Existing Key opened
%REG_WHOLE_HIVE_VOLATILE                     = &H1   ' Restore whole hive volatile
%REG_REFRESH_HIVE                            = &H2   ' Unwind changes to last flush
%REG_NOTIFY_CHANGE_NAME                      = &H1   ' Create or delete (child)
%REG_NOTIFY_CHANGE_ATTRIBUTES                = &H2
%REG_NOTIFY_CHANGE_LAST_SET                  = &H4   ' Time stamp
%REG_NOTIFY_CHANGE_SECURITY                  = &H8
%REG_LEGAL_CHANGE_FILTER                     = %REG_NOTIFY_CHANGE_NAME OR %REG_NOTIFY_CHANGE_ATTRIBUTES OR %REG_NOTIFY_CHANGE_LAST_SET OR %REG_NOTIFY_CHANGE_SECURITY
%REG_LEGAL_OPTION                            = %REG_OPTION_RESERVED OR %REG_OPTION_NON_VOLATILE OR %REG_OPTION_VOLATILE OR %REG_OPTION_CREATE_LINK OR %REG_OPTION_BACKUP_RESTORE

%KEY_QUERY_VALUE                             = &H1
%KEY_SET_VALUE                               = &H2
%KEY_CREATE_SUB_KEY                          = &H4
%KEY_ENUMERATE_SUB_KEYS                      = &H8
%KEY_NOTIFY                                  = &H10
%KEY_CREATE_LINK                             = &H20
%KEY_READ                                    = %STANDARD_RIGHTS_READ OR %KEY_QUERY_VALUE OR %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY AND (NOT %SYNCHRONIZE)
%KEY_WRITE                                   = %STANDARD_RIGHTS_WRITE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY AND (NOT %SYNCHRONIZE)
%KEY_EXECUTE                                 = %KEY_READ
%KEY_ALL_ACCESS                              = %STANDARD_RIGHTS_ALL OR %KEY_QUERY_VALUE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY OR %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY OR %KEY_CREATE_LINK AND (NOT %SYNCHRONIZE)

%EXCEPTION_DEBUG_EVENT                       = 1
%CREATE_THREAD_DEBUG_EVENT                   = 2
%CREATE_PROCESS_DEBUG_EVENT                  = 3
%EXIT_THREAD_DEBUG_EVENT                     = 4
%EXIT_PROCESS_DEBUG_EVENT                    = 5
%LOAD_DLL_DEBUG_EVENT                        = 6
%UNLOAD_DLL_DEBUG_EVENT                      = 7
%OUTPUT_DEBUG_STRING_EVENT                   = 8
%RIP_EVENT                                   = 9

%EXCEPTION_MAXIMUM_PARAMETERS                = 15

%DRIVE_UNKNOWN                               = 0
%DRIVE_NO_ROOT_DIR                           = 1
%DRIVE_REMOVABLE                             = 2
%DRIVE_FIXED                                 = 3
%DRIVE_REMOTE                                = 4
%DRIVE_CDROM                                 = 5
%DRIVE_RAMDISK                               = 6

%FILE_TYPE_UNKNOWN                           = &H0
%FILE_TYPE_DISK                              = &H1
%FILE_TYPE_CHAR                              = &H2
%FILE_TYPE_PIPE                              = &H3
%FILE_TYPE_REMOTE                            = &H8000

%STD_INPUT_HANDLE                            = -10&
%STD_OUTPUT_HANDLE                           = -11&
%STD_ERROR_HANDLE                            = -12&

%NOPARITY                                    = 0
%ODDPARITY                                   = 1
%EVENPARITY                                  = 2
%MARKPARITY                                  = 3
%SPACEPARITY                                 = 4

%ONESTOPBIT                                  = 0
%ONE5STOPBITS                                = 1
%TWOSTOPBITS                                 = 2

%IGNORE                                      = 0        '  Ignore signal
%INFINITE                                    = &HFFFF   '  Infinite timeout

' Comm Baud Rate indices
%CBR_110                                     = 110
%CBR_300                                     = 300
%CBR_600                                     = 600
%CBR_1200                                    = 1200
%CBR_2400                                    = 2400
%CBR_4800                                    = 4800
%CBR_9600                                    = 9600
%CBR_14400                                   = 14400
%CBR_19200                                   = 19200
%CBR_38400                                   = 38400
%CBR_56000                                   = 56000
%CBR_57600                                   = 57600
%CBR_115200                                  = 115200
%CBR_128000                                  = 128000
%CBR_256000                                  = 256000

' Error Flags
%CE_RXOVER                                   = &H1       '  Receive Queue overflow
%CE_OVERRUN                                  = &H2       '  Receive Overrun Error
%CE_RXPARITY                                 = &H4       '  Receive Parity Error
%CE_FRAME                                    = &H8       '  Receive Framing error
%CE_BREAK                                    = &H10      '  Break Detected
%CE_TXFULL                                   = &H100     '  TX Queue is full
%CE_PTO                                      = &H200     '  LPTx Timeout
%CE_IOE                                      = &H400     '  LPTx I/O Error
%CE_DNS                                      = &H800     '  LPTx Device not selected
%CE_OOP                                      = &H1000    '  LPTx Out-Of-Paper
%CE_MODE                                     = &H8000    '  Requested mode unsupported

%IE_BADID                                    = -1        '  Invalid or unsupported id
%IE_OPEN                                     = -2        '  Device Already Open
%IE_NOPEN                                    = -3        '  Device Not Open
%IE_MEMORY                                   = -4        '  Unable to allocate queues
%IE_DEFAULT                                  = -5        '  Error in default parameters
%IE_HARDWARE                                 = -10       '  Hardware Not Present
%IE_BYTESIZE                                 = -11       '  Illegal Byte Size
%IE_BAUDRATE                                 = -12       '  Unsupported BaudRate

' Events
%EV_RXCHAR                                   = &H1       '  Any Character received
%EV_RXFLAG                                   = &H2       '  Received certain character
%EV_TXEMPTY                                  = &H4       '  Transmitt Queue Empty
%EV_CTS                                      = &H8       '  CTS changed state
%EV_DSR                                      = &H10      '  DSR changed state
%EV_RLSD                                     = &H20      '  RLSD changed state
%EV_BREAK                                    = &H40      '  BREAK received
%EV_ERR                                      = &H80      '  Line status error occurred
%EV_RING                                     = &H100     '  Ring signal detected
%EV_PERR                                     = &H200     '  Printer error occured
%EV_RX80FULL                                 = &H400     '  Receive buffer is 80 percent full
%EV_EVENT1                                   = &H800     '  Provider specific event 1
%EV_EVENT2                                   = &H1000    '  Provider specific event 2

%SETXOFF                                     = 1         '  Simulate XOFF received
%SETXON                                      = 2         '  Simulate XON received
%SETRTS                                      = 3         '  Set RTS high
%CLRRTS                                      = 4         '  Set RTS low
%SETDTR                                      = 5         '  Set DTR high
%CLRDTR                                      = 6         '  Set DTR low
%RESETDEV                                    = 7         '  Reset device if possible
%SETBREAK                                    = 8         '  Set the device break line
%CLRBREAK                                    = 9         '  Clear the device break line

%PURGE_TXABORT                               = &H1       '  Kill the pending/current writes to the comm port.
%PURGE_RXABORT                               = &H2       '  Kill the pending/current reads to the comm port.
%PURGE_TXCLEAR                               = &H4       '  Kill the transmit queue if there.
%PURGE_RXCLEAR                               = &H8       '  Kill the typeahead buffer if there.

%LPTx                                        = &H80      '  Set if ID is for LPT device

%MS_CTS_ON                                   = &H10&
%MS_DSR_ON                                   = &H20&
%MS_RING_ON                                  = &H40&
%MS_RLSD_ON                                  = &H80&

%S_QUEUEEMPTY                                = 0
%S_THRESHOLD                                 = 1
%S_ALLTHRESHOLD                              = 2

%S_NORMAL                                    = 0
%S_LEGATO                                    = 1
%S_STACCATO                                  = 2

%S_PERIOD512                                 = 0   '  Freq = N/512 high pitch, less coarse hiss
%S_PERIOD1024                                = 1   '  Freq = N/1024
%S_PERIOD2048                                = 2   '  Freq = N/2048 low pitch, more coarse hiss
%S_PERIODVOICE                               = 3   '  Source is frequency from voice channel (3)
%S_WHITE512                                  = 4   '  Freq = N/512 high pitch, less coarse hiss
%S_WHITE1024                                 = 5   '  Freq = N/1024
%S_WHITE2048                                 = 6   '  Freq = N/2048 low pitch, more coarse hiss
%S_WHITEVOICE                                = 7   '  Source is frequency from voice channel (3)

%S_SERDVNA                                   = -1  '  Device not available
%S_SEROFM                                    = -2  '  Out of memory
%S_SERMACT                                   = -3  '  Music active
%S_SERQFUL                                   = -4  '  Queue full
%S_SERBDNT                                   = -5  '  Invalid note
%S_SERDLN                                    = -6  '  Invalid note length
%S_SERDCC                                    = -7  '  Invalid note count
%S_SERDTP                                    = -8  '  Invalid tempo
%S_SERDVL                                    = -9  '  Invalid volume
%S_SERDMD                                    = -10 '  Invalid mode
%S_SERDSH                                    = -11 '  Invalid shape
%S_SERDPT                                    = -12 '  Invalid pitch
%S_SERDFQ                                    = -13 '  Invalid frequency
%S_SERDDR                                    = -14 '  Invalid duration
%S_SERDSR                                    = -15 '  Invalid source
%S_SERDST                                    = -16 '  Invalid state

%NMPWAIT_WAIT_FOREVER                        = &HFFFF
%NMPWAIT_NOWAIT                              = &H1
%NMPWAIT_USE_DEFAULT_WAIT                    = &H0
%FS_CASE_IS_PRESERVED                        = %FILE_CASE_PRESERVED_NAMES
%FS_CASE_SENSITIVE                           = %FILE_CASE_SENSITIVE_SEARCH
%FS_UNICODE_STORED_ON_DISK                   = %FILE_UNICODE_ON_DISK
%FS_PERSISTENT_ACLS                          = %FILE_PERSISTENT_ACLS

%SECTION_QUERY                               = &H1
%SECTION_MAP_WRITE                           = &H2
%SECTION_MAP_READ                            = &H4
%SECTION_MAP_EXECUTE                         = &H8
%SECTION_EXTEND_SIZE                         = &H10
%SECTION_ALL_ACCESS                          = %STANDARD_RIGHTS_REQUIRED OR %SECTION_QUERY OR %SECTION_MAP_WRITE OR %SECTION_MAP_READ OR %SECTION_MAP_EXECUTE OR %SECTION_EXTEND_SIZE

%FILE_MAP_COPY                               = %SECTION_QUERY
%FILE_MAP_WRITE                              = %SECTION_MAP_WRITE
%FILE_MAP_READ                               = %SECTION_MAP_READ
%FILE_MAP_ALL_ACCESS                         = %SECTION_ALL_ACCESS

' OpenFile() Flags
%OF_READ                                     = &H0
%OF_WRITE                                    = &H1
%OF_READWRITE                                = &H2
%OF_SHARE_COMPAT                             = &H0
%OF_SHARE_EXCLUSIVE                          = &H10
%OF_SHARE_DENY_WRITE                         = &H20
%OF_SHARE_DENY_READ                          = &H30
%OF_SHARE_DENY_NONE                          = &H40
%OF_PARSE                                    = &H100
%OF_DELETE                                   = &H200
%OF_VERIFY                                   = &H400
%OF_CANCEL                                   = &H800
%OF_CREATE                                   = &H1000
%OF_PROMPT                                   = &H2000
%OF_EXIST                                    = &H4000
%OF_REOPEN                                   = &H8000

%OFS_MAXPATHNAME                             = 128

%DONT_RESOLVE_DLL_REFERENCES                 = &H1

%TC_NORMAL                                   = 0
%TC_HARDERR                                  = 1
%TC_GP_TRAP                                  = 2
%TC_SIGNAL                                   = 3

%MAX_LEADBYTES                               = 12          '  5 ranges, 2 bytes ea., 0 term.

%WC_DEFAULTCHECK                             = &H100       '  check for default char
%WC_COMPOSITECHECK                           = &H200       '  convert composite to precomposed
%WC_DISCARDNS                                = &H10        '  discard non-spacing chars
%WC_SEPCHARS                                 = &H20        '  generate separate chars
%WC_DEFAULTCHAR                              = &H40        '  replace w/ default char

%CT_CTYPE1                                   = &H1         '  ctype 1 information
%CT_CTYPE2                                   = &H2         '  ctype 2 information
%CT_CTYPE3                                   = &H4         '  ctype 3 information

%C1_UPPER                                    = &H1     '  upper case
%C1_LOWER                                    = &H2     '  lower case
%C1_DIGIT                                    = &H4     '  decimal digits
%C1_SPACE                                    = &H8     '  spacing characters
%C1_PUNCT                                    = &H10    '  punctuation characters
%C1_CNTRL                                    = &H20    '  control characters
%C1_BLANK                                    = &H40    '  blank characters
%C1_XDIGIT                                   = &H80    '  other digits
%C1_ALPHA                                    = &H100   '  any letter

%C2_LEFTTORIGHT                              = &H1     '  left to right
%C2_RIGHTTOLEFT                              = &H2     '  right to left

%C2_EUROPENUMBER                             = &H3     '  European number, digit
%C2_EUROPESEPARATOR                          = &H4     '  European numeric separator
%C2_EUROPETERMINATOR                         = &H5     '  European numeric terminator
%C2_ARABICNUMBER                             = &H6     '  Arabic number
%C2_COMMONSEPARATOR                          = &H7     '  common numeric separator

%C2_BLOCKSEPARATOR                           = &H8     '  block separator
%C2_SEGMENTSEPARATOR                         = &H9     '  segment separator
%C2_WHITESPACE                               = &HA     '  white space
%C2_OTHERNEUTRAL                             = &HB     '  other neutrals

%C2_NOTAPPLICABLE                            = &H0     '  no implicit directionality

%C3_NONSPACING                               = &H1     '  nonspacing character
%C3_DIACRITIC                                = &H2     '  diacritic mark
%C3_VOWELMARK                                = &H4     '  vowel mark
%C3_SYMBOL                                   = &H8     '  symbols

%C3_NOTAPPLICABLE                            = &H0     '  ctype 3 is not applicable

%NORM_IGNORECASE                             = &H1         '  ignore case
%NORM_IGNORENONSPACE                         = &H2         '  ignore nonspacing chars
%NORM_IGNORESYMBOLS                          = &H4         '  ignore symbols

%MAP_FOLDCZONE                               = &H10        '  fold compatibility zone chars
%MAP_PRECOMPOSED                             = &H20        '  convert to precomposed chars
%MAP_COMPOSITE                               = &H40        '  convert to composite chars
%MAP_FOLDDIGITS                              = &H80        '  all digits to ASCII 0-9

%LCMAP_LOWERCASE                             = &H100       '  lower case letters
%LCMAP_UPPERCASE                             = &H200       '  upper case letters
%LCMAP_SORTKEY                               = &H400       '  WC sort key (normalize)
%LCMAP_BYTEREV                               = &H800       '  byte reversal

%SORT_STRINGSORT                             = &H1000      '  use string sort method

%CP_ACP                                      = 0  '  default to ANSI code page
%CP_OEMCP                                    = 1  '  default to OEM  code page

%CTRY_DEFAULT                                = 0

%CTRY_AUSTRALIA                              = 61  '  Australia
%CTRY_AUSTRIA                                = 43  '  Austria
%CTRY_BELGIUM                                = 32  '  Belgium
%CTRY_BRAZIL                                 = 55  '  Brazil
%CTRY_CANADA                                 = 2   '  Canada
%CTRY_DENMARK                                = 45  '  Denmark
%CTRY_FINLAND                                = 358 '  Finland
%CTRY_FRANCE                                 = 33  '  France
%CTRY_GERMANY                                = 49  '  Germany
%CTRY_ICELAND                                = 354 '  Iceland
%CTRY_IRELAND                                = 353 '  Ireland
%CTRY_ITALY                                  = 39  '  Italy
%CTRY_JAPAN                                  = 81  '  Japan
%CTRY_MEXICO                                 = 52  '  Mexico
%CTRY_NETHERLANDS                            = 31  '  Netherlands
%CTRY_NEW_ZEALAND                            = 64  '  New Zealand
%CTRY_NORWAY                                 = 47  '  Norway
%CTRY_PORTUGAL                               = 351 '  Portugal
%CTRY_PRCHINA                                = 86  '  PR China
%CTRY_SOUTH_KOREA                            = 82  '  South Korea
%CTRY_SPAIN                                  = 34  '  Spain
%CTRY_SWEDEN                                 = 46  '  Sweden
%CTRY_SWITZERLAND                            = 41  '  Switzerland
%CTRY_TAIWAN                                 = 886 '  Taiwan
%CTRY_UNITED_KINGDOM                         = 44  '  United Kingdom
%CTRY_UNITED_STATES                          = 1   '  United States

%LOCALE_NOUSEROVERRIDE                       = &H80000000  '  do not use user overrides

%LOCALE_USER_DEFAULT                         = &H0000&
%LOCALE_SYSTEM_DEFAULT                       = &H0800&
%LOCALE_ILANGUAGE                            = &H1         '  language id
%LOCALE_SLANGUAGE                            = &H2         '  localized name of language
%LOCALE_SENGLANGUAGE                         = &H1001      '  English name of language
%LOCALE_SABBREVLANGNAME                      = &H3         '  abbreviated language name
%LOCALE_SNATIVELANGNAME                      = &H4         '  native name of language
%LOCALE_ICOUNTRY                             = &H5         '  country code
%LOCALE_SCOUNTRY                             = &H6         '  localized name of country
%LOCALE_SENGCOUNTRY                          = &H1002      '  English name of country
%LOCALE_SABBREVCTRYNAME                      = &H7         '  abbreviated country name
%LOCALE_SNATIVECTRYNAME                      = &H8         '  native name of country
%LOCALE_IDEFAULTLANGUAGE                     = &H9         '  default language id
%LOCALE_IDEFAULTCOUNTRY                      = &HA         '  default country code
%LOCALE_IDEFAULTCODEPAGE                     = &HB         '  default code page

%LOCALE_SLIST                                = &HC         '  list item separator
%LOCALE_IMEASURE                             = &HD         '  0 = metric, 1 = US

%LOCALE_SDECIMAL                             = &HE         '  decimal separator
%LOCALE_STHOUSAND                            = &HF         '  thousand separator
%LOCALE_SGROUPING                            = &H10        '  digit grouping
%LOCALE_IDIGITS                              = &H11        '  number of fractional digits
%LOCALE_ILZERO                               = &H12        '  leading zeros for decimal
%LOCALE_SNATIVEDIGITS                        = &H13        '  native ascii 0-9

%LOCALE_SCURRENCY                            = &H14        '  local monetary symbol
%LOCALE_SINTLSYMBOL                          = &H15        '  intl monetary symbol
%LOCALE_SMONDECIMALSEP                       = &H16        '  monetary decimal separator
%LOCALE_SMONTHOUSANDSEP                      = &H17        '  monetary thousand separator
%LOCALE_SMONGROUPING                         = &H18        '  monetary grouping
%LOCALE_ICURRDIGITS                          = &H19        '  # local monetary digits
%LOCALE_IINTLCURRDIGITS                      = &H1A        '  # intl monetary digits
%LOCALE_ICURRENCY                            = &H1B        '  positive currency mode
%LOCALE_INEGCURR                             = &H1C        '  negative currency mode

%LOCALE_SDATE                                = &H1D        '  date separator
%LOCALE_STIME                                = &H1E        '  time separator
%LOCALE_SSHORTDATE                           = &H1F        '  short date format string
%LOCALE_SLONGDATE                            = &H20        '  long date format string
%LOCALE_STIMEFORMAT                          = &H1003      '  time format string
%LOCALE_IDATE                                = &H21        '  short date format ordering
%LOCALE_ILDATE                               = &H22        '  long date format ordering
%LOCALE_ITIME                                = &H23        '  time format specifier
%LOCALE_ICENTURY                             = &H24        '  century format specifier
%LOCALE_ITLZERO                              = &H25        '  leading zeros in time field
%LOCALE_IDAYLZERO                            = &H26        '  leading zeros in day field
%LOCALE_IMONLZERO                            = &H27        '  leading zeros in month field
%LOCALE_S1159                                = &H28        '  AM designator
%LOCALE_S2359                                = &H29        '  PM designator

%LOCALE_SDAYNAME1                            = &H2A        '  long name for Monday
%LOCALE_SDAYNAME2                            = &H2B        '  long name for Tuesday
%LOCALE_SDAYNAME3                            = &H2C        '  long name for Wednesday
%LOCALE_SDAYNAME4                            = &H2D        '  long name for Thursday
%LOCALE_SDAYNAME5                            = &H2E        '  long name for Friday
%LOCALE_SDAYNAME6                            = &H2F        '  long name for Saturday
%LOCALE_SDAYNAME7                            = &H30        '  long name for Sunday
%LOCALE_SABBREVDAYNAME1                      = &H31        '  abbreviated name for Monday
%LOCALE_SABBREVDAYNAME2                      = &H32        '  abbreviated name for Tuesday
%LOCALE_SABBREVDAYNAME3                      = &H33        '  abbreviated name for Wednesday
%LOCALE_SABBREVDAYNAME4                      = &H34        '  abbreviated name for Thursday
%LOCALE_SABBREVDAYNAME5                      = &H35        '  abbreviated name for Friday
%LOCALE_SABBREVDAYNAME6                      = &H36        '  abbreviated name for Saturday
%LOCALE_SABBREVDAYNAME7                      = &H37        '  abbreviated name for Sunday
%LOCALE_SMONTHNAME1                          = &H38        '  long name for January
%LOCALE_SMONTHNAME2                          = &H39        '  long name for February
%LOCALE_SMONTHNAME3                          = &H3A        '  long name for March
%LOCALE_SMONTHNAME4                          = &H3B        '  long name for April
%LOCALE_SMONTHNAME5                          = &H3C        '  long name for May
%LOCALE_SMONTHNAME6                          = &H3D        '  long name for June
%LOCALE_SMONTHNAME7                          = &H3E        '  long name for July
%LOCALE_SMONTHNAME8                          = &H3F        '  long name for August
%LOCALE_SMONTHNAME9                          = &H40        '  long name for September
%LOCALE_SMONTHNAME10                         = &H41        '  long name for October
%LOCALE_SMONTHNAME11                         = &H42        '  long name for November
%LOCALE_SMONTHNAME12                         = &H43        '  long name for December
%LOCALE_SABBREVMONTHNAME1                    = &H44        '  abbreviated name for January
%LOCALE_SABBREVMONTHNAME2                    = &H45        '  abbreviated name for February
%LOCALE_SABBREVMONTHNAME3                    = &H46        '  abbreviated name for March
%LOCALE_SABBREVMONTHNAME4                    = &H47        '  abbreviated name for April
%LOCALE_SABBREVMONTHNAME5                    = &H48        '  abbreviated name for May
%LOCALE_SABBREVMONTHNAME6                    = &H49        '  abbreviated name for June
%LOCALE_SABBREVMONTHNAME7                    = &H4A        '  abbreviated name for July
%LOCALE_SABBREVMONTHNAME8                    = &H4B        '  abbreviated name for August
%LOCALE_SABBREVMONTHNAME9                    = &H4C        '  abbreviated name for September
%LOCALE_SABBREVMONTHNAME10                   = &H4D        '  abbreviated name for October
%LOCALE_SABBREVMONTHNAME11                   = &H4E        '  abbreviated name for November
%LOCALE_SABBREVMONTHNAME12                   = &H4F        '  abbreviated name for December
%LOCALE_SABBREVMONTHNAME13                   = &H100F

%LOCALE_SPOSITIVESIGN                        = &H50        '  positive sign
%LOCALE_SNEGATIVESIGN                        = &H51        '  negative sign
%LOCALE_IPOSSIGNPOSN                         = &H52        '  positive sign position
%LOCALE_INEGSIGNPOSN                         = &H53        '  negative sign position
%LOCALE_IPOSSYMPRECEDES                      = &H54        '  mon sym precedes pos amt
%LOCALE_IPOSSEPBYSPACE                       = &H55        '  mon sym sep by space from pos amt
%LOCALE_INEGSYMPRECEDES                      = &H56        '  mon sym precedes neg amt
%LOCALE_INEGSEPBYSPACE                       = &H57        '  mon sym sep by space from neg amt

%TIME_NOMINUTESORSECONDS                     = &H1&        '  do not use minutes or seconds
%TIME_NOSECONDS                              = &H2&        '  do not use seconds
%TIME_NOTIMEMARKER                           = &H4&        '  do not use time marker
%TIME_FORCE24HOURFORMAT                      = &H8&        '  always use 24 hour format

%TIME_ZONE_ID_INVALID                        = -1
%TIME_ZONE_ID_UNKNOWN                        = 0
%TIME_ZONE_ID_STANDARD                       = 1
%TIME_ZONE_ID_DAYLIGHT                       = 2

%DATE_SHORTDATE                              = &H1         '  use short date picture
%DATE_LONGDATE                               = &H2         '  use long date picture

%LR_DEFAULTCOLOR                             = &H0000
%LR_MONOCHROME                               = &H0001
%LR_COLOR                                    = &H0002
%LR_COPYRETURNORG                            = &H0004
%LR_COPYDELETEORG                            = &H0008
%LR_LOADFROMFILE                             = &H0010
%LR_LOADTRANSPARENT                          = &H0020
%LR_DEFAULTSIZE                              = &H0040
%LR_LOADMAP3DCOLORS                          = &H1000
%LR_CREATEDIBSECTION                         = &H2000
%LR_COPYFROMRESOURCE                         = &H4000
%LR_SHARED                                   = &H8000

%TF_FORCEDRIVE                               = &H80

%LOCKFILE_FAIL_IMMEDIATELY                   = &H1
%LOCKFILE_EXCLUSIVE_LOCK                     = &H2

%LNOTIFY_OUTOFMEM                            = 0
%LNOTIFY_MOVE                                = 1
%LNOTIFY_DISCARD                             = 2

%SLE_ERROR                                   = &H1
%SLE_MINORERROR                              = &H2
%SLE_WARNING                                 = &H3

%SEM_FAILCRITICALERRORS                      = &H1
%SEM_NOGPFAULTERRORBOX                       = &H2
%SEM_NOOPENFILEERRORBOX                      = &H8000

%RT_CURSOR                                   = 1&
%RT_BITMAP                                   = 2&
%RT_ICON                                     = 3&
%RT_MENU                                     = 4&
%RT_DIALOG                                   = 5&
%RT_STRING                                   = 6&
%RT_FONTDIR                                  = 7&
%RT_FONT                                     = 8&
%RT_ACCELERATOR                              = 9&
%RT_RCDATA                                   = 10&
%RT_MESSAGETABLE                             = 11
%RT_GROUP_CURSOR                             = 12
%RT_GROUP_ICON                               = 14
%RT_VERSION                                  = 16
%RT_NEWRESOURCE                              = &H2000
%RT_ERROR                                    = &H7FFF
%RT_NEWBITMAP                                = %RT_BITMAP OR %RT_NEWRESOURCE
%RT_NEWMENU                                  = %RT_MENU OR %RT_NEWRESOURCE
%RT_NEWDIALOG                                = %RT_DIALOG OR %RT_NEWRESOURCE

%DFC_CAPTION                                 = 1
%DFC_MENU                                    = 2
%DFC_SCROLL                                  = 3
%DFC_BUTTON                                  = 4

%DFCS_CAPTIONCLOSE                           = &H0000
%DFCS_CAPTIONMIN                             = &H0001
%DFCS_CAPTIONMAX                             = &H0002
%DFCS_CAPTIONRESTORE                         = &H0003
%DFCS_CAPTIONHELP                            = &H0004

%DFCS_MENUARROW                              = &H0000
%DFCS_MENUCHECK                              = &H0001
%DFCS_MENUBULLET                             = &H0002
%DFCS_MENUARROWRIGHT                         = &H0004

%DFCS_SCROLLUP                               = &H0000
%DFCS_SCROLLDOWN                             = &H0001
%DFCS_SCROLLLEFT                             = &H0002
%DFCS_SCROLLRIGHT                            = &H0003
%DFCS_SCROLLCOMBOBOX                         = &H0005
%DFCS_SCROLLSIZEGRIP                         = &H0008
%DFCS_SCROLLSIZEGRIPRIGHT                    = &H0010

%DFCS_BUTTONCHECK                            = &H0000
%DFCS_BUTTONRADIOIMAGE                       = &H0001
%DFCS_BUTTONRADIOMASK                        = &H0002
%DFCS_BUTTONRADIO                            = &H0004
%DFCS_BUTTON3STATE                           = &H0008
%DFCS_BUTTONPUSH                             = &H0010

%DFCS_INACTIVE                               = &H0100
%DFCS_PUSHED                                 = &H0200
%DFCS_CHECKED                                = &H0400
%DFCS_ADJUSTRECT                             = &H2000
%DFCS_FLAT                                   = &H4000
%DFCS_MONO                                   = &H8000

%DDD_RAW_TARGET_PATH                         = &H1
%DDD_REMOVE_DEFINITION                       = &H2
%DDD_EXACT_MATCH_ON_REMOVE                   = &H4

%MAX_PATH                                    = 260

%MOVEFILE_REPLACE_EXISTING                   = &H1
%MOVEFILE_COPY_ALLOWED                       = &H2
%MOVEFILE_DELAY_UNTIL_REBOOT                 = &H4

%TOKENUSER                                   = 1
%TOKENGROUPS                                 = 2
%TOKENPRIVILEGES                             = 3
%TOKENOWNER                                  = 4
%TOKENPRIMARYGROUP                           = 5
%TOKENDEFAULTDACL                            = 6
%TOKENSOURCE                                 = 7
%TOKENTYPE                                   = 8
%TOKENIMPERSONATIONLEVEL                     = 9
%TOKENSTATISTICS                             = 10

%GET_TAPE_MEDIA_INFORMATION                  = 0
%GET_TAPE_DRIVE_INFORMATION                  = 1

%SET_TAPE_MEDIA_INFORMATION                  = 0
%SET_TAPE_DRIVE_INFORMATION                  = 1

%FORMAT_MESSAGE_ALLOCATE_BUFFER              = &H100
%FORMAT_MESSAGE_IGNORE_INSERTS               = &H200
%FORMAT_MESSAGE_FROM_STRING                  = &H400
%FORMAT_MESSAGE_FROM_HMODULE                 = &H800
%FORMAT_MESSAGE_FROM_SYSTEM                  = &H1000
%FORMAT_MESSAGE_ARGUMENT_ARRAY               = &H2000
%FORMAT_MESSAGE_MAX_WIDTH_MASK               = &HFF

%TLS_OUT_OF_INDEXES                          = &HFFFF

%BACKUP_DATA                                 = &H1
%BACKUP_EA_DATA                              = &H2
%BACKUP_SECURITY_DATA                        = &H3
%BACKUP_ALTERNATE_DATA                       = &H4
%BACKUP_LINK                                 = &H5

'   Stream Attributes
%STREAM_MODIFIED_WHEN_READ                   = &H1
%STREAM_CONTAINS_SECURITY                    = &H2

'  Dual Mode API below this line. Dual Mode Types also included.

%STARTF_USESHOWWINDOW                        = &H1
%STARTF_USESIZE                              = &H2
%STARTF_USEPOSITION                          = &H4
%STARTF_USECOUNTCHARS                        = &H8
%STARTF_USEFILLATTRIBUTE                     = &H10
%STARTF_RUNFULLSCREEN                        = &H20        '  ignored for non-x86 platforms
%STARTF_FORCEONFEEDBACK                      = &H40
%STARTF_FORCEOFFFEEDBACK                     = &H80
%STARTF_USESTDHANDLES                        = &H100

%SHUTDOWN_NORETRY                            = &H1

%MAX_DEFAULTCHAR                             = 2
%CAL_ICALINTVALUE                            = &H1     '  calendar type
%CAL_SCALNAME                                = &H2     '  native name of calendar
%CAL_IYEAROFFSETRANGE                        = &H3     '  starting years of eras
%CAL_SERASTRING                              = &H4     '  era name for IYearOffsetRanges
%CAL_SSHORTDATE                              = &H5     '  Integer date format string
%CAL_SLONGDATE                               = &H6     '  long date format string
%CAL_SDAYNAME1                               = &H7     '  native name for Monday
%CAL_SDAYNAME2                               = &H8     '  native name for Tuesday
%CAL_SDAYNAME3                               = &H9     '  native name for Wednesday
%CAL_SDAYNAME4                               = &HA     '  native name for Thursday
%CAL_SDAYNAME5                               = &HB     '  native name for Friday
%CAL_SDAYNAME6                               = &HC     '  native name for Saturday
%CAL_SDAYNAME7                               = &HD     '  native name for Sunday
%CAL_SABBREVDAYNAME1                         = &HE     '  abbreviated name for Monday
%CAL_SABBREVDAYNAME2                         = &HF     '  abbreviated name for Tuesday
%CAL_SABBREVDAYNAME3                         = &H10    '  abbreviated name for Wednesday
%CAL_SABBREVDAYNAME4                         = &H11    '  abbreviated name for Thursday
%CAL_SABBREVDAYNAME5                         = &H12    '  abbreviated name for Friday
%CAL_SABBREVDAYNAME6                         = &H13    '  abbreviated name for Saturday
%CAL_SABBREVDAYNAME7                         = &H14    '  abbreviated name for Sunday
%CAL_SMONTHNAME1                             = &H15    '  native name for January
%CAL_SMONTHNAME2                             = &H16    '  native name for February
%CAL_SMONTHNAME3                             = &H17    '  native name for March
%CAL_SMONTHNAME4                             = &H18    '  native name for April
%CAL_SMONTHNAME5                             = &H19    '  native name for May
%CAL_SMONTHNAME6                             = &H1A    '  native name for June
%CAL_SMONTHNAME7                             = &H1B    '  native name for July
%CAL_SMONTHNAME8                             = &H1C    '  native name for August
%CAL_SMONTHNAME9                             = &H1D    '  native name for September
%CAL_SMONTHNAME10                            = &H1E    '  native name for October
%CAL_SMONTHNAME11                            = &H1F    '  native name for November
%CAL_SMONTHNAME12                            = &H20    '  native name for December
%CAL_SMONTHNAME13                            = &H21    '  native name for 13th month (if any)
%CAL_SABBREVMONTHNAME1                       = &H22    '  abbreviated name for January
%CAL_SABBREVMONTHNAME2                       = &H23    '  abbreviated name for February
%CAL_SABBREVMONTHNAME3                       = &H24    '  abbreviated name for March
%CAL_SABBREVMONTHNAME4                       = &H25    '  abbreviated name for April
%CAL_SABBREVMONTHNAME5                       = &H26    '  abbreviated name for May
%CAL_SABBREVMONTHNAME6                       = &H27    '  abbreviated name for June
%CAL_SABBREVMONTHNAME7                       = &H28    '  abbreviated name for July
%CAL_SABBREVMONTHNAME8                       = &H29    '  abbreviated name for August
%CAL_SABBREVMONTHNAME9                       = &H2A    '  abbreviated name for September
%CAL_SABBREVMONTHNAME10                      = &H2B    '  abbreviated name for October
%CAL_SABBREVMONTHNAME11                      = &H2C    '  abbreviated name for November
%CAL_SABBREVMONTHNAME12                      = &H2D    '  abbreviated name for December
%CAL_SABBREVMONTHNAME13                      = &H2E    '  abbreviated name for 13th month (if any)

%ENUM_ALL_CALENDARS                          = &HFFFF  '  enumerate all calendars

%CAL_GREGORIAN                               = 1       '  Gregorian (localized) calendar
%CAL_GREGORIAN_US                            = 2       '  Gregorian (U.S.) calendar
%CAL_JAPAN                                   = 3       '  Japanese Emperor Era calendar
%CAL_TAIWAN                                  = 4       '  Republic of China Era calendar
%CAL_KOREA                                   = 5       '  Korean Tangun Era calendar

%RIGHT_ALT_PRESSED                           = &H1     '  the right alt key is pressed.
%LEFT_ALT_PRESSED                            = &H2     '  the left alt key is pressed.
%RIGHT_CTRL_PRESSED                          = &H4     '  the right ctrl key is pressed.
%LEFT_CTRL_PRESSED                           = &H8     '  the left ctrl key is pressed.
%SHIFT_PRESSED                               = &H10    '  the shift key is pressed.
%NUMLOCK_ON                                  = &H20    '  the numlock light is on.
%SCROLLLOCK_ON                               = &H40    '  the scrolllock light is on.
%CAPSLOCK_ON                                 = &H80    '  the capslock light is on.
%ENHANCED_KEY                                = &H100   '  the key is enhanced.

%FROM_LEFT_1ST_BUTTON_PRESSED                = &H1
%RIGHTMOST_BUTTON_PRESSED                    = &H2
%FROM_LEFT_2ND_BUTTON_PRESSED                = &H4
%FROM_LEFT_3RD_BUTTON_PRESSED                = &H8
%FROM_LEFT_4TH_BUTTON_PRESSED                = &H10

%MOUSE_MOVED                                 = &H1
%DOUBLE_CLICK                                = &H2

%KEY_EVENT                                   = &H1     '  Event contains key event record
%MOUSE_EVENT                                 = &H2     '  Event contains mouse event record
%WINDOW_BUFFER_SIZE_EVENT                    = &H4     '  Event contains window change event record
%MENU_EVENT                                  = &H8     '  Event contains menu event record
%FOCUS_EVENT                                 = &H10    '  event contains focus change

%FOREGROUND_BLUE                             = &H1     '  text color contains blue.
%FOREGROUND_GREEN                            = &H2     '  text color contains green.
%FOREGROUND_RED                              = &H4     '  text color contains red.
%FOREGROUND_INTENSITY                        = &H8     '  text color is intensified.
%BACKGROUND_BLUE                             = &H10    '  background color contains blue.
%BACKGROUND_GREEN                            = &H20    '  background color contains green.
%BACKGROUND_RED                              = &H40    '  background color contains red.
%BACKGROUND_INTENSITY                        = &H80    '  background color is intensified.

%CTRL_C_EVENT                                = 0
%CTRL_BREAK_EVENT                            = 1
%CTRL_CLOSE_EVENT                            = 2
%CTRL_LOGOFF_EVENT                           = 5
%CTRL_SHUTDOWN_EVENT                         = 6

%ENABLE_PROCESSED_INPUT                      = &H1
%ENABLE_LINE_INPUT                           = &H2
%ENABLE_ECHO_INPUT                           = &H4
%ENABLE_WINDOW_INPUT                         = &H8
%ENABLE_MOUSE_INPUT                          = &H10

%ENABLE_PROCESSED_OUTPUT                     = &H1
%ENABLE_WRAP_AT_EOL_OUTPUT                   = &H2

%CONSOLE_TEXTMODE_BUFFER                     = 1

%R2_BLACK                                    = 1  '   0
%R2_NOTMERGEPEN                              = 2  '  DPon
%R2_MASKNOTPEN                               = 3  '  DPna
%R2_NOTCOPYPEN                               = 4  '  PN
%R2_MASKPENNOT                               = 5  '  PDna
%R2_NOT                                      = 6  '  Dn
%R2_XORPEN                                   = 7  '  DPx
%R2_NOTMASKPEN                               = 8  '  DPan
%R2_MASKPEN                                  = 9  '  DPa
%R2_NOTXORPEN                                = 10 '  DPxn
%R2_NOP                                      = 11 '  D
%R2_MERGENOTPEN                              = 12 '  DPno
%R2_COPYPEN                                  = 13 '  P
%R2_MERGEPENNOT                              = 14 '  PDno
%R2_MERGEPEN                                 = 15 '  DPo
%R2_WHITE                                    = 16 '   1
%R2_LAST                                     = 16

'  Ternary raster operations
%SRCCOPY                                     = &HCC0020 ' (DWORD) dest = source
%SRCPAINT                                    = &HEE0086 ' (DWORD) dest = source OR dest
%SRCAND                                      = &H8800C6 ' (DWORD) dest = source AND dest
%SRCINVERT                                   = &H660046 ' (DWORD) dest = source XOR dest
%SRCERASE                                    = &H440328 ' (DWORD) dest = source AND (NOT dest )
%NOTSRCCOPY                                  = &H330008 ' (DWORD) dest = (NOT source)
%NOTSRCERASE                                 = &H1100A6 ' (DWORD) dest = (NOT src) AND (NOT dest)
%MERGECOPY                                   = &HC000CA ' (DWORD) dest = (source AND pattern)
%MERGEPAINT                                  = &HBB0226 ' (DWORD) dest = (NOT source) OR dest
%PATCOPY                                     = &HF00021 ' (DWORD) dest = pattern
%PATPAINT                                    = &HFB0A09 ' (DWORD) dest = DPSnoo
%PATINVERT                                   = &H5A0049 ' (DWORD) dest = pattern XOR dest
%DSTINVERT                                   = &H550009 ' (DWORD) dest = (NOT dest)
%BLACKNESS                                   = &H42     ' (DWORD) dest = BLACK
%WHITENESS                                   = &HFF0062 ' (DWORD) dest = WHITE

%GDI_ERROR                                   = &HFFFF
%HGDI_ERROR                                  = &HFFFF

' Region Flags
%ERRORAPI                                    = 0
%NULLREGION                                  = 1
%SIMPLEREGION                                = 2
%COMPLEXREGION                               = 3

' CombineRgn() Styles
%RGN_AND                                     = 1
%RGN_OR                                      = 2
%RGN_XOR                                     = 3
%RGN_DIFF                                    = 4
%RGN_COPY                                    = 5
%RGN_MIN                                     = %RGN_AND
%RGN_MAX                                     = %RGN_COPY

' StretchBlt() Modes
%BLACKONWHITE                                = 1
%WHITEONBLACK                                = 2
%COLORONCOLOR                                = 3
%HALFTONE                                    = 4
%MAXSTRETCHBLTMODE                           = 4

' PolyFill() Modes
%ALTERNATE                                   = 1
%WINDING                                     = 2
%POLYFILL_LAST                               = 2

' Text Alignment Options
%TA_NOUPDATECP                               = 0
%TA_UPDATECP                                 = 1

%TA_LEFT                                     = 0
%TA_RIGHT                                    = 2
%TA_CENTER                                   = 6

%TA_TOP                                      = 0
%TA_BOTTOM                                   = 8
%TA_BASELINE                                 = 24
%TA_MASK                                     = %TA_BASELINE + %TA_CENTER + %TA_UPDATECP

%VTA_BASELINE                                = %TA_BASELINE
%VTA_LEFT                                    = %TA_BOTTOM
%VTA_RIGHT                                   = %TA_TOP
%VTA_CENTER                                  = %TA_CENTER
%VTA_BOTTOM                                  = %TA_RIGHT
%VTA_TOP                                     = %TA_LEFT

%ETO_GRAYED                                  = 1
%ETO_OPAQUE                                  = 2
%ETO_CLIPPED                                 = 4

%ASPECT_FILTERING                            = &H1

%DCB_RESET                                   = &H1
%DCB_ACCUMULATE                              = &H2
%DCB_DIRTY                                   = %DCB_ACCUMULATE
%DCB_SET                                     = %DCB_RESET OR %DCB_ACCUMULATE
%DCB_ENABLE                                  = &H4
%DCB_DISABLE                                 = &H8

' Metafile Functions
%META_SAVEDC                                 = &H01E
%META_REALIZEPALETTE                         = &H035
%META_SETPALENTRIES                          = &H037
%META_CREATEPALETTE                          = &H0F7
%META_SETBKMODE                              = &H102
%META_SETMAPMODE                             = &H103
%META_SETROP2                                = &H104
%META_SETRELABS                              = &H105
%META_SETPOLYFILLMODE                        = &H106
%META_SETSTRETCHBLTMODE                      = &H107
%META_SETTEXTCHAREXTRA                       = &H108
%META_RESTOREDC                              = &H127
%META_INVERTREGION                           = &H12A
%META_PAINTREGION                            = &H12B
%META_SELECTCLIPREGION                       = &H12C
%META_SELECTOBJECT                           = &H12D
%META_SETTEXTALIGN                           = &H12E
%META_RESIZEPALETTE                          = &H139
%META_DIBCREATEPATTERNBRUSH                  = &H142
%META_DELETEOBJECT                           = &H1F0
%META_CREATEPATTERNBRUSH                     = &H1F9
%META_SETBKCOLOR                             = &H201
%META_SETTEXTCOLOR                           = &H209
%META_SETTEXTJUSTIFICATION                   = &H20A
%META_SETWINDOWORG                           = &H20B
%META_SETWINDOWEXT                           = &H20C
%META_SETVIEWPORTORG                         = &H20D
%META_SETVIEWPORTEXT                         = &H20E
%META_OFFSETWINDOWORG                        = &H20F
%META_OFFSETVIEWPORTORG                      = &H211
%META_LINETO                                 = &H213
%META_MOVETO                                 = &H214
%META_OFFSETCLIPRGN                          = &H220
%META_FILLREGION                             = &H228
%META_SETMAPPERFLAGS                         = &H231
%META_SELECTPALETTE                          = &H234
%META_CREATEPENINDIRECT                      = &H2FA
%META_CREATEFONTINDIRECT                     = &H2FB
%META_CREATEBRUSHINDIRECT                    = &H2FC
%META_POLYGON                                = &H324
%META_POLYLINE                               = &H325
%META_SCALEWINDOWEXT                         = &H410
%META_SCALEVIEWPORTEXT                       = &H412
%META_EXCLUDECLIPRECT                        = &H415
%META_INTERSECTCLIPRECT                      = &H416
%META_ELLIPSE                                = &H418
%META_FLOODFILL                              = &H419
%META_RECTANGLE                              = &H41B
%META_SETPIXEL                               = &H41F
%META_FRAMEREGION                            = &H429
%META_ANIMATEPALETTE                         = &H436
%META_TEXTOUT                                = &H521
%META_POLYPOLYGON                            = &H538
%META_EXTFLOODFILL                           = &H548
%META_ROUNDRECT                              = &H61C
%META_PATBLT                                 = &H61D
%META_ESCAPE                                 = &H626
%META_CREATEREGION                           = &H6FF
%META_ARC                                    = &H817
%META_PIE                                    = &H81A
%META_CHORD                                  = &H830
%META_BITBLT                                 = &H922
%META_DIBBITBLT                              = &H940
%META_EXTTEXTOUT                             = &HA32
%META_STRETCHBLT                             = &HB23
%META_DIBSTRETCHBLT                          = &HB41
%META_SETDIBTODEV                            = &HD33
%META_STRETCHDIB                             = &HF43


' GDI Escapes
%NEWFRAME                                    = 1
%AbortDocC                                   = 2
%NEXTBAND                                    = 3
%SETCOLORTABLE                               = 4
%GETCOLORTABLE                               = 5
%FLUSHOUTPUT                                 = 6
%DRAFTMODE                                   = 7
%QUERYESCSUPPORT                             = 8
%SETABORTPROC                                = 9
%StartDocC                                   = 10
%EndDocC                                     = 11
%GETPHYSPAGESIZE                             = 12
%GETPRINTINGOFFSET                           = 13
%GETSCALINGFACTOR                            = 14
%MFCOMMENT                                   = 15
%GETPENWIDTH                                 = 16
%SETCOPYCOUNT                                = 17
%SELECTPAPERSOURCE                           = 18
%DEVICEDATA                                  = 19
%PASSTHROUGH                                 = 19
%GETTECHNOLGY                                = 20
%GETTECHNOLOGY                               = 20
%SETLINECAP                                  = 21
%SETLINEJOIN                                 = 22
%SetMiterLimitC                              = 23
%BANDINFO                                    = 24
%DRAWPATTERNRECT                             = 25
%GETVECTORPENSIZE                            = 26
%GETVECTORBRUSHSIZE                          = 27
%ENABLEDUPLEX                                = 28
%GETSETPAPERBINS                             = 29
%GETSETPRINTORIENT                           = 30
%ENUMPAPERBINS                               = 31
%SETDIBSCALING                               = 32
%EPSPRINTING                                 = 33
%ENUMPAPERMETRICS                            = 34
%GETSETPAPERMETRICS                          = 35
%POSTSCRIPT_DATA                             = 37
%POSTSCRIPT_IGNORE                           = 38
%MOUSETRAILS                                 = 39
%GETDEVICEUNITS                              = 42

%GETEXTENDEDTEXTMETRICS                      = 256
%GETEXTENTTABLE                              = 257
%GETPAIRKERNTABLE                            = 258
%GETTRACKKERNTABLE                           = 259
%ExtTextOutC                                 = 512
%GETFACENAME                                 = 513
%DOWNLOADFACE                                = 514
%ENABLERELATIVEWIDTHS                        = 768
%ENABLEPAIRKERNING                           = 769
%SETKERNTRACK                                = 770
%SETALLJUSTVALUES                            = 771
%SETCHARSET                                  = 772

%StretchBltC                                 = 2048
%GETSETSCREENPARAMS                          = 3072
%BEGIN_PATH                                  = 4096
%CLIP_TO_PATH                                = 4097
%END_PATH                                    = 4098
%EXT_DEVICE_CAPS                             = 4099
%RESTORE_CTM                                 = 4100
%SAVE_CTM                                    = 4101
%SET_ARC_DIRECTION                           = 4102
%SET_BACKGROUND_COLOR                        = 4103
%SET_POLY_MODE                               = 4104
%SET_SCREEN_ANGLE                            = 4105
%SET_SPREAD                                  = 4106
%TRANSFORM_CTM                               = 4107
%SET_CLIP_BOX                                = 4108
%SET_BOUNDS                                  = 4109
%SET_MIRROR_MODE                             = 4110
%OPENCHANNEL                                 = 4110
%DOWNLOADHEADER                              = 4111
%CLOSECHANNEL                                = 4112
%POSTSCRIPT_PASSTHROUGH                      = 4115
%ENCAPSULATED_POSTSCRIPT                     = 4116

' Spooler Error Codes
%SP_NOTREPORTED                              = &H4000
%SP_ERROR                                    = -1
%SP_APPABORT                                 = -2
%SP_USERABORT                                = -3
%SP_OUTOFDISK                                = -4
%SP_OUTOFMEMORY                              = -5

%PR_JOBSTATUS                                = &H0

'  Object Definitions for EnumObjects()
%OBJ_PEN                                     = 1
%OBJ_BRUSH                                   = 2
%OBJ_DC                                      = 3
%OBJ_METADC                                  = 4
%OBJ_PAL                                     = 5
%OBJ_FONT                                    = 6
%OBJ_BITMAP                                  = 7
%OBJ_REGION                                  = 8
%OBJ_METAFILE                                = 9
%OBJ_MEMDC                                   = 10
%OBJ_EXTPEN                                  = 11
%OBJ_ENHMETADC                               = 12
%OBJ_ENHMETAFILE                             = 13

'  xform stuff
%MWT_IDENTITY                                = 1
%MWT_LEFTMULTIPLY                            = 2
%MWT_RIGHTMULTIPLY                           = 3

%MWT_MIN                                     = %MWT_IDENTITY
%MWT_MAX                                     = %MWT_RIGHTMULTIPLY

%BI_RGB                                      = 0&
%BI_RLE8                                     = 1&
%BI_RLE4                                     = 2&
%BI_bitfields                                = 3&

%NTM_REGULAR                                 = &H40&
%NTM_BOLD                                    = &H20&
%NTM_ITALIC                                  = &H1&

%TMPF_FIXED_PITCH                            = &H1
%TMPF_VECTOR                                 = &H2
%TMPF_DEVICE                                 = &H8
%TMPF_TRUETYPE                               = &H4

%LF_FACESIZE                                 = 32
%LF_FULLFACESIZE                             = 64

%OUT_DEFAULT_PRECIS                          = 0
%OUT_STRING_PRECIS                           = 1
%OUT_CHARACTER_PRECIS                        = 2
%OUT_STROKE_PRECIS                           = 3
%OUT_TT_PRECIS                               = 4
%OUT_DEVICE_PRECIS                           = 5
%OUT_RASTER_PRECIS                           = 6
%OUT_TT_ONLY_PRECIS                          = 7
%OUT_OUTLINE_PRECIS                          = 8

%CLIP_DEFAULT_PRECIS                         = 0
%CLIP_CHARACTER_PRECIS                       = 1
%CLIP_STROKE_PRECIS                          = 2
%CLIP_MASK                                   = &HF
%CLIP_LH_ANGLES                              = 16
%CLIP_TT_ALWAYS                              = 32
%CLIP_EMBEDDED                               = 128

%DEFAULT_QUALITY                             = 0
%DRAFT_QUALITY                               = 1
%PROOF_QUALITY                               = 2

%DEFAULT_PITCH                               = 0
%FIXED_PITCH                                 = 1
%VARIABLE_PITCH                              = 2

%ANSI_CHARSET                                = 0
%DEFAULT_CHARSET                             = 1
%SYMBOL_CHARSET                              = 2
%SHIFTJIS_CHARSET                            = 128
%HANGEUL_CHARSET                             = 129
%CHINESEBIG5_CHARSET                         = 136
%OEM_CHARSET                                 = 255

' Font Families
'
%FF_DONTCARE                                 = 0       '  Don't care or don't know.
%FF_ROMAN                                    = 16      '  Variable stroke width, serifed.

' Times Roman, Century Schoolbook, etc.
%FF_SWISS                                    = 32      '  Variable stroke width, sans-serifed.

' Helvetica, Swiss, etc.
%FF_MODERN                                   = 48      '  Constant stroke width, serifed or sans-serifed.

' Pica, Elite, Courier, etc.
%FF_SCRIPT                                   = 64      '  Cursive, etc.
%FF_DECORATIVE                               = 80      '  Old English, etc.

' Font Weights
%FW_DONTCARE                                 = 0
%FW_THIN                                     = 100
%FW_EXTRALIGHT                               = 200
%FW_LIGHT                                    = 300
%FW_NORMAL                                   = 400
%FW_MEDIUM                                   = 500
%FW_SEMIBOLD                                 = 600
%FW_BOLD                                     = 700
%FW_EXTRABOLD                                = 800
%FW_HEAVY                                    = 900

%FW_ULTRALIGHT                               = %FW_EXTRALIGHT
%FW_REGULAR                                  = %FW_NORMAL
%FW_DEMIBOLD                                 = %FW_SEMIBOLD
%FW_ULTRABOLD                                = %FW_EXTRABOLD
%FW_BLACK                                    = %FW_HEAVY

%PANOSE_COUNT                                = 10
%PAN_FAMILYTYPE_INDEX                        = 0
%PAN_SERIFSTYLE_INDEX                        = 1
%PAN_WEIGHT_INDEX                            = 2
%PAN_PROPORTION_INDEX                        = 3
%PAN_CONTRAST_INDEX                          = 4
%PAN_STROKEVARIATION_INDEX                   = 5
%PAN_ARMSTYLE_INDEX                          = 6
%PAN_LETTERFORM_INDEX                        = 7
%PAN_MIDLINE_INDEX                           = 8
%PAN_XHEIGHT_INDEX                           = 9

%PAN_CULTURE_LATIN                           = 0

%PAN_ANY                                     = 0  '  Any
%PAN_NO_FIT                                  = 1  '  No Fit

%PAN_FAMILY_TEXT_DISPLAY                     = 2  '  Text and Display
%PAN_FAMILY_SCRIPT                           = 3  '  Script
%PAN_FAMILY_DECORATIVE                       = 4  '  Decorative
%PAN_FAMILY_PICTORIAL                        = 5  '  Pictorial

%PAN_SERIF_COVE                              = 2  '  Cove
%PAN_SERIF_OBTUSE_COVE                       = 3  '  Obtuse Cove
%PAN_SERIF_SQUARE_COVE                       = 4  '  Square Cove
%PAN_SERIF_OBTUSE_SQUARE_COVE                = 5  '  Obtuse Square Cove
%PAN_SERIF_SQUARE                            = 6  '  Square
%PAN_SERIF_THIN                              = 7  '  Thin
%PAN_SERIF_BONE                              = 8  '  Bone
%PAN_SERIF_EXAGGERATED                       = 9  '  Exaggerated
%PAN_SERIF_TRIANGLE                          = 10 '  Triangle
%PAN_SERIF_NORMAL_SANS                       = 11 '  Normal Sans
%PAN_SERIF_OBTUSE_SANS                       = 12 '  Obtuse Sans
%PAN_SERIF_PERP_SANS                         = 13 '  Prep Sans
%PAN_SERIF_FLARED                            = 14 '  Flared
%PAN_SERIF_ROUNDED                           = 15 '  Rounded

%PAN_WEIGHT_VERY_LIGHT                       = 2  '  Very Light
%PAN_WEIGHT_LIGHT                            = 3  '  Light
%PAN_WEIGHT_THIN                             = 4  '  Thin
%PAN_WEIGHT_BOOK                             = 5  '  Book
%PAN_WEIGHT_MEDIUM                           = 6  '  Medium
%PAN_WEIGHT_DEMI                             = 7  '  Demi
%PAN_WEIGHT_BOLD                             = 8  '  Bold
%PAN_WEIGHT_HEAVY                            = 9  '  Heavy
%PAN_WEIGHT_BLACK                            = 10 '  Black
%PAN_WEIGHT_NORD                             = 11 '  Nord

%PAN_PROP_OLD_STYLE                          = 2  '  Old Style
%PAN_PROP_MODERN                             = 3  '  Modern
%PAN_PROP_EVEN_WIDTH                         = 4  '  Even Width
%PAN_PROP_EXPANDED                           = 5  '  Expanded
%PAN_PROP_CONDENSED                          = 6  '  Condensed
%PAN_PROP_VERY_EXPANDED                      = 7  '  Very Expanded
%PAN_PROP_VERY_CONDENSED                     = 8  '  Very Condensed
%PAN_PROP_MONOSPACED                         = 9  '  Monospaced

%PAN_CONTRAST_NONE                           = 2  '  None
%PAN_CONTRAST_VERY_LOW                       = 3  '  Very Low
%PAN_CONTRAST_LOW                            = 4  '  Low
%PAN_CONTRAST_MEDIUM_LOW                     = 5  '  Medium Low
%PAN_CONTRAST_MEDIUM                         = 6  '  Medium
%PAN_CONTRAST_MEDIUM_HIGH                    = 7  '  Mediim High
%PAN_CONTRAST_HIGH                           = 8  '  High
%PAN_CONTRAST_VERY_HIGH                      = 9  '  Very High

%PAN_STROKE_GRADUAL_DIAG                     = 2  '  Gradual/Diagonal
%PAN_STROKE_GRADUAL_TRAN                     = 3  '  Gradual/Transitional
%PAN_STROKE_GRADUAL_VERT                     = 4  '  Gradual/Vertical
%PAN_STROKE_GRADUAL_HORZ                     = 5  '  Gradual/Horizontal
%PAN_STROKE_RAPID_VERT                       = 6  '  Rapid/Vertical
%PAN_STROKE_RAPID_HORZ                       = 7  '  Rapid/Horizontal
%PAN_STROKE_INSTANT_VERT                     = 8  '  Instant/Vertical

%PAN_STRAIGHT_ARMS_HORZ                      = 2  '  Straight Arms/Horizontal
%PAN_STRAIGHT_ARMS_WEDGE                     = 3  '  Straight Arms/Wedge
%PAN_STRAIGHT_ARMS_VERT                      = 4  '  Straight Arms/Vertical
%PAN_STRAIGHT_ARMS_SINGLE_SERIF              = 5  '  Straight Arms/Single-Serif
%PAN_STRAIGHT_ARMS_DOUBLE_SERIF              = 6  '  Straight Arms/Double-Serif
%PAN_BENT_ARMS_HORZ                          = 7  '  Non-Straight Arms/Horizontal
%PAN_BENT_ARMS_WEDGE                         = 8  '  Non-Straight Arms/Wedge
%PAN_BENT_ARMS_VERT                          = 9  '  Non-Straight Arms/Vertical
%PAN_BENT_ARMS_SINGLE_SERIF                  = 10 '  Non-Straight Arms/Single-Serif
%PAN_BENT_ARMS_DOUBLE_SERIF                  = 11 '  Non-Straight Arms/Double-Serif

%PAN_LETT_NORMAL_CONTACT                     = 2  '  Normal/Contact
%PAN_LETT_NORMAL_WEIGHTED                    = 3  '  Normal/Weighted
%PAN_LETT_NORMAL_BOXED                       = 4  '  Normal/Boxed
%PAN_LETT_NORMAL_FLATTENED                   = 5  '  Normal/Flattened
%PAN_LETT_NORMAL_ROUNDED                     = 6  '  Normal/Rounded
%PAN_LETT_NORMAL_OFF_CENTER                  = 7  '  Normal/Off Center
%PAN_LETT_NORMAL_SQUARE                      = 8  '  Normal/Square
%PAN_LETT_OBLIQUE_CONTACT                    = 9  '  Oblique/Contact
%PAN_LETT_OBLIQUE_WEIGHTED                   = 10 '  Oblique/Weighted
%PAN_LETT_OBLIQUE_BOXED                      = 11 '  Oblique/Boxed
%PAN_LETT_OBLIQUE_FLATTENED                  = 12 '  Oblique/Flattened
%PAN_LETT_OBLIQUE_ROUNDED                    = 13 '  Oblique/Rounded
%PAN_LETT_OBLIQUE_OFF_CENTER                 = 14 '  Oblique/Off Center
%PAN_LETT_OBLIQUE_SQUARE                     = 15 '  Oblique/Square

%PAN_MIDLINE_STANDARD_TRIMMED                = 2  '  Standard/Trimmed
%PAN_MIDLINE_STANDARD_POINTED                = 3  '  Standard/Pointed
%PAN_MIDLINE_STANDARD_SERIFED                = 4  '  Standard/Serifed
%PAN_MIDLINE_HIGH_TRIMMED                    = 5  '  High/Trimmed
%PAN_MIDLINE_HIGH_POINTED                    = 6  '  High/Pointed
%PAN_MIDLINE_HIGH_SERIFED                    = 7  '  High/Serifed
%PAN_MIDLINE_CONSTANT_TRIMMED                = 8  '  Constant/Trimmed
%PAN_MIDLINE_CONSTANT_POINTED                = 9  '  Constant/Pointed
%PAN_MIDLINE_CONSTANT_SERIFED                = 10 '  Constant/Serifed
%PAN_MIDLINE_LOW_TRIMMED                     = 11 '  Low/Trimmed
%PAN_MIDLINE_LOW_POINTED                     = 12 '  Low/Pointed
%PAN_MIDLINE_LOW_SERIFED                     = 13 '  Low/Serifed

%PAN_XHEIGHT_CONSTANT_SMALL                  = 2  '  Constant/Small
%PAN_XHEIGHT_CONSTANT_STD                    = 3  '  Constant/Standard
%PAN_XHEIGHT_CONSTANT_LARGE                  = 4  '  Constant/Large
%PAN_XHEIGHT_DUCKING_SMALL                   = 5  '  Ducking/Small
%PAN_XHEIGHT_DUCKING_STD                     = 6  '  Ducking/Standard
%PAN_XHEIGHT_DUCKING_LARGE                   = 7  '  Ducking/Large

%ELF_VENDOR_SIZE                             = 4

%ELF_VERSION                                 = 0
%ELF_CULTURE_LATIN                           = 0

'  EnumFonts Masks
%RASTER_FONTTYPE                             = &H1
%DEVICE_FONTTYPE                             = &H2
%TRUETYPE_FONTTYPE                           = &H4

' palette entry flags
%PC_RESERVED                                 = &H1  '  palette index used for animation
%PC_EXPLICIT                                 = &H2  '  palette index is explicit to device
%PC_NOCOLLAPSE                               = &H4  '  do not match color to system palette

' Background Modes
%TRANSPARENT                                 = 1
%OPAQUE                                      = 2
%BKMODE_LAST                                 = 2

'  Graphics Modes
%GM_COMPATIBLE                               = 1
%GM_ADVANCED                                 = 2
%GM_LAST                                     = 2

'  PolyDraw and GetPath point types
%PT_CLOSEFIGURE                              = &H1
%PT_LINETO                                   = &H2
%PT_BEZIERTO                                 = &H4
%PT_MOVETO                                   = &H6

'  Mapping Modes
%MM_TEXT                                     = 1
%MM_LOMETRIC                                 = 2
%MM_HIMETRIC                                 = 3
%MM_LOENGLISH                                = 4
%MM_HIENGLISH                                = 5
%MM_TWIPS                                    = 6
%MM_ISOTROPIC                                = 7
%MM_ANISOTROPIC                              = 8

'  Min and Max Mapping Mode values
%MM_MIN                                      = %MM_TEXT
%MM_MAX                                      = %MM_ANISOTROPIC
%MM_MAX_FIXEDSCALE                           = %MM_TWIPS

' Coordinate Modes
%ABSOLUTE                                    = 1
%RELATIVE                                    = 2

' Stock Logical Objects
%WHITE_BRUSH                                 = 0
%LTGRAY_BRUSH                                = 1
%GRAY_BRUSH                                  = 2
%DKGRAY_BRUSH                                = 3
%BLACK_BRUSH                                 = 4
%NULL_BRUSH                                  = 5
%HOLLOW_BRUSH                                = %NULL_BRUSH
%WHITE_PEN                                   = 6
%BLACK_PEN                                   = 7
%NULL_PEN                                    = 8
%OEM_FIXED_FONT                              = 10
%ANSI_FIXED_FONT                             = 11
%ANSI_VAR_FONT                               = 12
%SYSTEM_FONT                                 = 13
%DEVICE_DEFAULT_FONT                         = 14
%DEFAULT_PALETTE                             = 15
%SYSTEM_FIXED_FONT                           = 16
%STOCK_LAST                                  = 16

%CLR_INVALID                                 = &HFFFF

' Brush Styles
%BS_SOLID                                    = 0
%BS_NULL                                     = 1
%BS_HOLLOW                                   = %BS_NULL
%BS_HATCHED                                  = 2
%BS_PATTERN                                  = 3
%BS_INDEXED                                  = 4
%BS_DIBPATTERN                               = 5
%BS_DIBPATTERNPT                             = 6
%BS_PATTERN8X8                               = 7
%BS_DIBPATTERN8X8                            = 8

'  Hatch Styles
%HS_HORIZONTAL                               = 0     '  -----
%HS_VERTICAL                                 = 1     '  |||||
%HS_FDIAGONAL                                = 2     '  \\\\\
%HS_BDIAGONAL                                = 3     '  -----
%HS_CROSS                                    = 4     '  +++++
%HS_DIAGCROSS                                = 5     '  xxxxx
%HS_FDIAGONAL1                               = 6
%HS_BDIAGONAL1                               = 7
%HS_SOLID                                    = 8
%HS_DENSE1                                   = 9
%HS_DENSE2                                   = 10
%HS_DENSE3                                   = 11
%HS_DENSE4                                   = 12
%HS_DENSE5                                   = 13
%HS_DENSE6                                   = 14
%HS_DENSE7                                   = 15
%HS_DENSE8                                   = 16
%HS_NOSHADE                                  = 17
%HS_HALFTONE                                 = 18
%HS_SOLIDCLR                                 = 19
%HS_DITHEREDCLR                              = 20
%HS_SOLIDTEXTCLR                             = 21
%HS_DITHEREDTEXTCLR                          = 22
%HS_SOLIDBKCLR                               = 23
%HS_DITHEREDBKCLR                            = 24
%HS_API_MAX                                  = 25

'  Pen Styles
%PS_SOLID                                    = 0
%PS_DASH                                     = 1     '  -------
%PS_DOT                                      = 2     '  .......
%PS_DASHDOT                                  = 3     '  _._._._
%PS_DASHDOTDOT                               = 4     '  _.._.._
%PS_NULL                                     = 5
%PS_INSIDEFRAME                              = 6
%PS_USERSTYLE                                = 7
%PS_ALTERNATE                                = 8
%PS_STYLE_MASK                               = &HF

%PS_ENDCAP_ROUND                             = &H0
%PS_ENDCAP_SQUARE                            = &H100
%PS_ENDCAP_FLAT                              = &H200
%PS_ENDCAP_MASK                              = &HF00

%PS_JOIN_ROUND                               = &H0
%PS_JOIN_BEVEL                               = &H1000
%PS_JOIN_MITER                               = &H2000
%PS_JOIN_MASK                                = &HF000

%PS_COSMETIC                                 = &H0
%PS_GEOMETRIC                                = &H10000
%PS_TYPE_MASK                                = &HF0000

%AD_COUNTERCLOCKWISE                         = 1
%AD_CLOCKWISE                                = 2

'* WM_PRINT flags
%PRF_CHECKVISIBLE                            = &H00000001&
%PRF_NONCLIENT                               = &H00000002&
%PRF_CLIENT                                  = &H00000004&
%PRF_ERASEBKGND                              = &H00000008&
%PRF_CHILDREN                                = &H00000010&
%PRF_OWNED                                   = &H00000020&

'* 3D border styles
%BDR_RAISEDOUTER                             = &H0001
%BDR_SUNKENOUTER                             = &H0002
%BDR_RAISEDINNER                             = &H0004
%BDR_SUNKENINNER                             = &H0008

%BDR_OUTER                                   = &H0003
%BDR_RAISED                                  = &H0005
%BDR_SUNKEN                                  = &H000A
%BDR_INNER                                   = &H000C

%EDGE_RAISED                                 = %BDR_RAISEDOUTER OR %BDR_RAISEDINNER
%EDGE_SUNKEN                                 = %BDR_SUNKENOUTER OR %BDR_SUNKENINNER
%EDGE_ETCHED                                 = %BDR_SUNKENOUTER OR %BDR_RAISEDINNER
%EDGE_BUMP                                   = %BDR_RAISEDOUTER OR %BDR_SUNKENINNER

'* Border flags
%BF_LEFT                                     = &H0001
%BF_TOP                                      = &H0002
%BF_RIGHT                                    = &H0004
%BF_BOTTOM                                   = &H0008

%BF_TOPLEFT                                  = %BF_TOP OR %BF_LEFT
%BF_TOPRIGHT                                 = %BF_TOP OR %BF_RIGHT
%BF_BOTTOMLEFT                               = %BF_BOTTOM OR %BF_LEFT
%BF_BOTTOMRIGHT                              = %BF_BOTTOM OR %BF_RIGHT
%BF_RECT                                     = %BF_LEFT OR %BF_TOP OR %BF_RIGHT OR %BF_BOTTOM

%BF_DIAGONAL                                 = &H0010

' For diagonal lines, the BF_RECT flags specify the end point of the
' vector bounded by the rectangle parameter.
%BF_DIAGONAL_ENDTOPRIGHT                     = %BF_DIAGONAL OR %BF_TOP OR %BF_RIGHT
%BF_DIAGONAL_ENDTOPLEFT                      = %BF_DIAGONAL OR %BF_TOP OR %BF_LEFT
%BF_DIAGONAL_ENDBOTTOMLEFT                   = %BF_DIAGONAL OR %BF_BOTTOM OR %BF_LEFT
%BF_DIAGONAL_ENDBOTTOMRIGHT                  = %BF_DIAGONAL OR %BF_BOTTOM OR %BF_RIGHT

%BF_MIDDLE                                   = &H0800 '* Fill in the middle
%BF_SOFT                                     = &H1000 '* For softer buttons
%BF_ADJUST                                   = &H2000 '* Calculate the space left over
%BF_FLAT                                     = &H4000 '* For flat rather than 3D borders
%BF_MONO                                     = &H8000 '* For monochrome borders

'  Device Parameters for GetDeviceCaps()
%DRIVERVERSION                               = 0     '  Device driver version
%TECHNOLOGY                                  = 2     '  Device classification
%HORZSIZE                                    = 4     '  Horizontal size in millimeters
%VERTSIZE                                    = 6     '  Vertical size in millimeters
%HORZRES                                     = 8     '  Horizontal width in pixels
%VERTRES                                     = 10    '  Vertical width in pixels
%BITSPIXEL                                   = 12    '  Number of bits per pixel
%PLANES                                      = 14    '  Number of planes
%NUMBRUSHES                                  = 16    '  Number of brushes the device has
%NUMPENS                                     = 18    '  Number of pens the device has
%NUMMARKERS                                  = 20    '  Number of markers the device has
%NUMFONTS                                    = 22    '  Number of fonts the device has
%NUMCOLORS                                   = 24    '  Number of colors the device supports
%PDEVICESIZE                                 = 26    '  Size required for device descriptor
%CURVECAPS                                   = 28    '  Curve capabilities
%LINECAPS                                    = 30    '  Line capabilities
%POLYGONALCAPS                               = 32    '  Polygonal capabilities
%TEXTCAPS                                    = 34    '  Text capabilities
%CLIPCAPS                                    = 36    '  Clipping capabilities
%RASTERCAPS                                  = 38    '  Bitblt capabilities
%ASPECTX                                     = 40    '  Length of the X leg
%ASPECTY                                     = 42    '  Length of the Y leg
%ASPECTXY                                    = 44    '  Length of the hypotenuse

%LOGPIXELSX                                  = 88    '  Logical pixels/inch in X
%LOGPIXELSY                                  = 90    '  Logical pixels/inch in Y

%SIZEPALETTE                                 = 104   '  Number of entries in physical palette
%NUMRESERVED                                 = 106   '  Number of reserved entries in palette
%COLORRES                                    = 108   '  Actual color resolution

'  Printing related DeviceCaps. These replace the appropriate Escapes
%PHYSICALWIDTH                               = 110   '  Physical Width in device units
%PHYSICALHEIGHT                              = 111   '  Physical Height in device units
%PHYSICALOFFSETX                             = 112   '  Physical Printable Area x margin
%PHYSICALOFFSETY                             = 113   '  Physical Printable Area y margin
%SCALINGFACTORX                              = 114   '  Scaling factor x
%SCALINGFACTORY                              = 115   '  Scaling factor y

'  Device Capability Masks:

'  Device Technologies
%DT_PLOTTER                                  = 0     '  Vector plotter
%DT_RASDISPLAY                               = 1     '  Raster display
%DT_RASPRINTER                               = 2     '  Raster printer
%DT_RASCAMERA                                = 3     '  Raster camera
%DT_CHARSTREAM                               = 4     '  Character-stream, PLP
%DT_METAFILE                                 = 5     '  Metafile, VDM
%DT_DISPFILE                                 = 6     '  Display-file

'  Curve Capabilities
%CC_NONE                                     = 0     '  Curves not supported
%CC_CIRCLES                                  = 1     '  Can do circles
%CC_PIE                                      = 2     '  Can do pie wedges
%CC_CHORD                                    = 4     '  Can do chord arcs
%CC_ELLIPSES                                 = 8     '  Can do ellipese
%CC_WIDE                                     = 16    '  Can do wide lines
%CC_STYLED                                   = 32    '  Can do styled lines
%CC_WIDESTYLED                               = 64    '  Can do wide styled lines
%CC_INTERIORS                                = 128   '  Can do interiors
%CC_ROUNDRECT                                = 256   '

'  Line Capabilities
%LC_NONE                                     = 0     '  Lines not supported
%LC_POLYLINE                                 = 2     '  Can do polylines
%LC_MARKER                                   = 4     '  Can do markers
%LC_POLYMARKER                               = 8     '  Can do polymarkers
%LC_WIDE                                     = 16    '  Can do wide lines
%LC_STYLED                                   = 32    '  Can do styled lines
%LC_WIDESTYLED                               = 64    '  Can do wide styled lines
%LC_INTERIORS                                = 128   '  Can do interiors

'  Polygonal Capabilities
%PC_NONE                                     = 0     '  Polygonals not supported
%PC_POLYGON                                  = 1     '  Can do polygons
%PC_RECTANGLE                                = 2     '  Can do rectangles
%PC_WINDPOLYGON                              = 4     '  Can do winding polygons
%PC_TRAPEZOID                                = 4     '  Can do trapezoids
%PC_SCANLINE                                 = 8     '  Can do scanlines
%PC_WIDE                                     = 16    '  Can do wide borders
%PC_STYLED                                   = 32    '  Can do styled borders
%PC_WIDESTYLED                               = 64    '  Can do wide styled borders
%PC_INTERIORS                                = 128   '  Can do interiors

'  Polygonal Capabilities
%CP_NONE                                     = 0     '  No clipping of output
%CP_RECTANGLE                                = 1     '  Output clipped to rects
%CP_REGION                                   = 2     '

'  Text Capabilities
%TC_OP_CHARACTER                             = &H1     '  Can do OutputPrecision   CHARACTER
%TC_OP_STROKE                                = &H2     '  Can do OutputPrecision   STROKE
%TC_CP_STROKE                                = &H4     '  Can do ClipPrecision     STROKE
%TC_CR_90                                    = &H8     '  Can do CharRotAbility    90
%TC_CR_ANY                                   = &H10    '  Can do CharRotAbility    ANY
%TC_SF_X_YINDEP                              = &H20    '  Can do ScaleFreedom      X_YINDEPENDENT
%TC_SA_DOUBLE                                = &H40    '  Can do ScaleAbility      DOUBLE
%TC_SA_INTEGER                               = &H80    '  Can do ScaleAbility      INTEGER
%TC_SA_CONTIN                                = &H100   '  Can do ScaleAbility      CONTINUOUS
%TC_EA_DOUBLE                                = &H200   '  Can do EmboldenAbility   DOUBLE
%TC_IA_ABLE                                  = &H400   '  Can do ItalisizeAbility  ABLE
%TC_UA_ABLE                                  = &H800   '  Can do UnderlineAbility  ABLE
%TC_SO_ABLE                                  = &H1000  '  Can do StrikeOutAbility  ABLE
%TC_RA_ABLE                                  = &H2000  '  Can do RasterFontAble    ABLE
%TC_VA_ABLE                                  = &H4000  '  Can do VectorFontAble    ABLE
%TC_RESERVED                                 = &H8000
%TC_SCROLLBLT                                = &H10000 '  do text scroll with blt

'  Raster Capabilities
%RC_NONE                                     = 0
%RC_BITBLT                                   = 1       '  Can do standard BLT.
%RC_BANDING                                  = 2       '  Device requires banding support
%RC_SCALING                                  = 4       '  Device requires scaling support
%RC_BITMAP64                                 = 8       '  Device can support >64K bitmap
%RC_GDI20_OUTPUT                             = &H10    '  has 2.0 output calls
%RC_GDI20_STATE                              = &H20
%RC_SAVEBITMAP                               = &H40
%RC_DI_BITMAP                                = &H80    '  supports DIB to memory
%RC_PALETTE                                  = &H100   '  supports a palette
%RC_DIBTODEV                                 = &H200   '  supports DIBitsToDevice
%RC_BIGFONT                                  = &H400   '  supports >64K fonts
%RC_STRETCHBLT                               = &H800   '  supports StretchBlt
%RC_FLOODFILL                                = &H1000  '  supports FloodFill
%RC_STRETCHDIB                               = &H2000  '  supports StretchDIBits
%RC_OP_DX_OUTPUT                             = &H4000
%RC_DEVBITS                                  = &H8000

' DIB color table identifiers
%DIB_RGB_COLORS                              = 0 '  color table in RGBs
%DIB_PAL_COLORS                              = 1 '  color table in palette indices
%DIB_PAL_INDICES                             = 2 '  No color table indices into surf palette
%DIB_PAL_PHYSINDICES                         = 2 '  No color table indices into surf palette
%DIB_PAL_LOGINDICES                          = 4 '  No color table indices into DC palette

' constants for Get/SetSystemPaletteUse()
%SYSPAL_ERROR                                = 0
%SYSPAL_STATIC                               = 1
%SYSPAL_NOSTATIC                             = 2

' constants for CreateDIBitmap
%CBM_CREATEDIB                               = &H2     '  create DIB bitmap
%CBM_INIT                                    = &H4     '  initialize bitmap

' ExtFloodFill style flags
%FLOODFILLBORDER                             = 0
%FLOODFILLSURFACE                            = 1

'  size of a device name string
%CCHDEVICENAME                               = 32

'  size of a form name string
%CCHFORMNAME                                 = 32

' current version of specification
%DM_SPECVERSION                              = &H320

' field selection bits
%DM_ORIENTATION                              = &H1&
%DM_PAPERSIZE                                = &H2&
%DM_PAPERLENGTH                              = &H4&
%DM_PAPERWIDTH                               = &H8&
%DM_SCALE                                    = &H10&
%DM_COPIES                                   = &H100&
%DM_DEFAULTSOURCE                            = &H200&
%DM_PRINTQUALITY                             = &H400&
%DM_COLOR                                    = &H800&
%DM_DUPLEX                                   = &H1000&
%DM_YRESOLUTION                              = &H2000&
%DM_TTOPTION                                 = &H4000&
%DM_COLLATE                                  = &H8000
%DM_FORMNAME                                 = &H10000

'  orientation selections
%DMORIENT_PORTRAIT                           = 1
%DMORIENT_LANDSCAPE                          = 2

'  paper selections
%DMPAPER_LETTER                              = 1
%DMPAPER_FIRST                               = %DMPAPER_LETTER
'  Letter 8 1/2 x 11 in
%DMPAPER_LETTERSMALL                         = 2    '  Letter Small 8 1/2 x 11 in
%DMPAPER_TABLOID                             = 3    '  Tabloid 11 x 17 in
%DMPAPER_LEDGER                              = 4    '  Ledger 17 x 11 in
%DMPAPER_LEGAL                               = 5    '  Legal 8 1/2 x 14 in
%DMPAPER_STATEMENT                           = 6    '  Statement 5 1/2 x 8 1/2 in
%DMPAPER_EXECUTIVE                           = 7    '  Executive 7 1/4 x 10 1/2 in
%DMPAPER_A3                                  = 8    '  A3 297 x 420 mm
%DMPAPER_A4                                  = 9    '  A4 210 x 297 mm
%DMPAPER_A4SMALL                             = 10   '  A4 Small 210 x 297 mm
%DMPAPER_A5                                  = 11   '  A5 148 x 210 mm
%DMPAPER_B4                                  = 12   '  B4 250 x 354
%DMPAPER_B5                                  = 13   '  B5 182 x 257 mm
%DMPAPER_FOLIO                               = 14   '  Folio 8 1/2 x 13 in
%DMPAPER_QUARTO                              = 15   '  Quarto 215 x 275 mm
%DMPAPER_10X14                               = 16   '  1&H14 in
%DMPAPER_11X17                               = 17   '  11x17 in
%DMPAPER_NOTE                                = 18   '  Note 8 1/2 x 11 in
%DMPAPER_ENV_9                               = 19   '  Envelope #9 3 7/8 x 8 7/8
%DMPAPER_ENV_10                              = 20   '  Envelope #10 4 1/8 x 9 1/2
%DMPAPER_ENV_11                              = 21   '  Envelope #11 4 1/2 x 10 3/8
%DMPAPER_ENV_12                              = 22   '  Envelope #12 4 \276 x 11
%DMPAPER_ENV_14                              = 23   '  Envelope #14 5 x 11 1/2
%DMPAPER_CSHEET                              = 24   '  C size sheet
%DMPAPER_DSHEET                              = 25   '  D size sheet
%DMPAPER_ESHEET                              = 26   '  E size sheet
%DMPAPER_ENV_DL                              = 27   '  Envelope DL 110 x 220mm
%DMPAPER_ENV_C5                              = 28   '  Envelope C5 162 x 229 mm
%DMPAPER_ENV_C3                              = 29   '  Envelope C3  324 x 458 mm
%DMPAPER_ENV_C4                              = 30   '  Envelope C4  229 x 324 mm
%DMPAPER_ENV_C6                              = 31   '  Envelope C6  114 x 162 mm
%DMPAPER_ENV_C65                             = 32   '  Envelope C65 114 x 229 mm
%DMPAPER_ENV_B4                              = 33   '  Envelope B4  250 x 353 mm
%DMPAPER_ENV_B5                              = 34   '  Envelope B5  176 x 250 mm
%DMPAPER_ENV_B6                              = 35   '  Envelope B6  176 x 125 mm
%DMPAPER_ENV_ITALY                           = 36   '  Envelope 110 x 230 mm
%DMPAPER_ENV_MONARCH                         = 37   '  Envelope Monarch 3.875 x 7.5 in
%DMPAPER_ENV_PERSONAL                        = 38   '  6 3/4 Envelope 3 5/8 x 6 1/2 in
%DMPAPER_FANFOLD_US                          = 39   '  US Std Fanfold 14 7/8 x 11 in
%DMPAPER_FANFOLD_STD_GERMAN                  = 40   '  German Std Fanfold 8 1/2 x 12 in
%DMPAPER_FANFOLD_LGL_GERMAN                  = 41   '  German Legal Fanfold 8 1/2 x 13 in

%DMPAPER_LAST                                = %DMPAPER_FANFOLD_LGL_GERMAN

%DMPAPER_USER                                = 256

'  bin selections
%DMBIN_UPPER                                 = 1
%DMBIN_FIRST                                 = %DMBIN_UPPER

%DMBIN_ONLYONE                               = 1
%DMBIN_LOWER                                 = 2
%DMBIN_MIDDLE                                = 3
%DMBIN_MANUAL                                = 4
%DMBIN_ENVELOPE                              = 5
%DMBIN_ENVMANUAL                             = 6
%DMBIN_AUTO                                  = 7
%DMBIN_TRACTOR                               = 8
%DMBIN_SMALLFMT                              = 9
%DMBIN_LARGEFMT                              = 10
%DMBIN_LARGECAPACITY                         = 11
%DMBIN_CASSETTE                              = 14
%DMBIN_LAST                                  = %DMBIN_CASSETTE

%DMBIN_USER                                  = 256  '  device specific bins start here

'  print qualities
%DMRES_DRAFT                                 = -1
%DMRES_LOW                                   = -2
%DMRES_MEDIUM                                = -3
%DMRES_HIGH                                  = -4

'  color enable/disable for color printers
%DMCOLOR_MONOCHROME                          = 1
%DMCOLOR_COLOR                               = 2

'  duplex enable
%DMDUP_SIMPLEX                               = 1
%DMDUP_VERTICAL                              = 2
%DMDUP_HORIZONTAL                            = 3

'  TrueType options
%DMTT_BITMAP                                 = 1    '  print TT fonts as graphics
%DMTT_DOWNLOAD                               = 2    '  download TT fonts as soft fonts
%DMTT_SUBDEV                                 = 3    '  substitute device fonts for TT fonts

'  Collation selections
%DMCOLLATE_FALSE                             = 0
%DMCOLLATE_TRUE                              = 1

'  DEVMODE dmDisplayFlags flags

%DM_GRAYSCALE                                = &H1
%DM_INTERLACED                               = &H2

'  GetRegionData/ExtCreateRegion

%RDH_RECTANGLES                              = 1

' GetGlyphOutline constants
%GGO_METRICS                                 = 0
%GGO_BITMAP                                  = 1
%GGO_NATIVE                                  = 2

%TT_POLYGON_TYPE                             = 24

%TT_PRIM_LINE                                = 1
%TT_PRIM_QSPLINE                             = 2

' bits defined in wFlags of RASTERIZER_STATUS
%TT_AVAILABLE                                = &H1
%TT_ENABLED                                  = &H2

'  mode selections for the device mode function
%DM_UPDATE                                   = 1
%DM_COPY                                     = 2
%DM_PROMPT                                   = 4
%DM_MODIFY                                   = 8

%DM_IN_BUFFER                                = %DM_MODIFY
%DM_IN_PROMPT                                = %DM_PROMPT
%DM_OUT_BUFFER                               = %DM_COPY
%DM_OUT_DEFAULT                              = %DM_UPDATE

'  device capabilities indices
%DC_FIELDS                                   = 1
%DC_PAPERS                                   = 2
%DC_PAPERSIZE                                = 3
%DC_MINEXTENT                                = 4
%DC_MAXEXTENT                                = 5
%DC_BINS                                     = 6
%DC_DUPLEX                                   = 7
%DC_SIZE                                     = 8
%DC_EXTRA                                    = 9
%DC_VERSION                                  = 10
%DC_DRIVER                                   = 11
%DC_BINNAMES                                 = 12
%DC_ENUMRESOLUTIONS                          = 13
%DC_FILEDEPENDENCIES                         = 14
%DC_TRUETYPE                                 = 15
%DC_PAPERNAMES                               = 16
%DC_ORIENTATION                              = 17
%DC_COPIES                                   = 18

'  bit fields of the return value (DWORD) for DC_TRUETYPE
%DCTT_BITMAP                                 = &H1&
%DCTT_DOWNLOAD                               = &H2&
%DCTT_SUBDEV                                 = &H4&

'  Flags value for COLORADJUSTMENT
%CA_NEGATIVE                                 = &H1
%CA_LOG_FILTER                               = &H2

'  IlluminantIndex values
%ILLUMINANT_DEVICE_DEFAULT                   = 0
%ILLUMINANT_A                                = 1
%ILLUMINANT_B                                = 2
%ILLUMINANT_C                                = 3
%ILLUMINANT_D50                              = 4
%ILLUMINANT_D55                              = 5
%ILLUMINANT_D65                              = 6
%ILLUMINANT_D75                              = 7
%ILLUMINANT_F2                               = 8
%ILLUMINANT_MAX_INDEX                        = %ILLUMINANT_F2

%ILLUMINANT_TUNGSTEN                         = %ILLUMINANT_A
%ILLUMINANT_DAYLIGHT                         = %ILLUMINANT_C
%ILLUMINANT_FLUORESCENT                      = %ILLUMINANT_F2
%ILLUMINANT_NTSC                             = %ILLUMINANT_C

'  Min and max for RedGamma, GreenGamma, BlueGamma
%RGB_GAMMA_MIN                               = 2500 'words
%RGB_GAMMA_MAX                               = 65000

'  Min and max for ReferenceBlack and ReferenceWhite
%REFERENCE_WHITE_MIN                         = 6000 'words
%REFERENCE_WHITE_MAX                         = 10000
%REFERENCE_BLACK_MIN                         = 0
%REFERENCE_BLACK_MAX                         = 4000

'  Min and max for Contrast, Brightness, Colorfulness, RedGreenTint
%COLOR_ADJ_MIN                               = -100 'shorts
%COLOR_ADJ_MAX                               = 100

%FONTMAPPER_MAX                              = 10

%ENHMETA_SIGNATURE                           = &H464D4520

'  Stock object flag used in the object handle
' index in the enhanced metafile records.
'  E.g. The object xHandle index (%META_STOCK_OBJECT OR %BLACK_BRUSH)
'  represents the stock object BLACK_BRUSH.

%ENHMETA_STOCK_OBJECT                        = &H80000000

'  Enhanced metafile record types.

%EMR_HEADER                                  = 1
%EMR_POLYBEZIER                              = 2
%EMR_POLYGON                                 = 3
%EMR_POLYLINE                                = 4
%EMR_POLYBEZIERTO                            = 5
%EMR_POLYLINETO                              = 6
%EMR_POLYPOLYLINE                            = 7
%EMR_POLYPOLYGON                             = 8
%EMR_SETWINDOWEXTEX                          = 9
%EMR_SETWINDOWORGEX                          = 10
%EMR_SETVIEWPORTEXTEX                        = 11
%EMR_SETVIEWPORTORGEX                        = 12
%EMR_SETBRUSHORGEX                           = 13
%EMR_EOF                                     = 14
%EMR_SETPIXELV                               = 15
%EMR_SETMAPPERFLAGS                          = 16
%EMR_SETMAPMODE                              = 17
%EMR_SETBKMODE                               = 18
%EMR_SETPOLYFILLMODE                         = 19
%EMR_SETROP2                                 = 20
%EMR_SETSTRETCHBLTMODE                       = 21
%EMR_SETTEXTALIGN                            = 22
%EMR_SETCOLORADJUSTMENT                      = 23
%EMR_SETTEXTCOLOR                            = 24
%EMR_SETBKCOLOR                              = 25
%EMR_OFFSETCLIPRGN                           = 26
%EMR_MOVETOEX                                = 27
%EMR_SETMETARGN                              = 28
%EMR_EXCLUDECLIPRECT                         = 29
%EMR_INTERSECTCLIPRECT                       = 30
%EMR_SCALEVIEWPORTEXTEX                      = 31
%EMR_SCALEWINDOWEXTEX                        = 32
%EMR_SAVEDC                                  = 33
%EMR_RESTOREDC                               = 34
%EMR_SETWORLDTRANSFORM                       = 35
%EMR_MODIFYWORLDTRANSFORM                    = 36
%EMR_SELECTOBJECT                            = 37
%EMR_CREATEPEN                               = 38
%EMR_CREATEBRUSHINDIRECT                     = 39
%EMR_DELETEOBJECT                            = 40
%EMR_ANGLEARC                                = 41
%EMR_ELLIPSE                                 = 42
%EMR_RECTANGLE                               = 43
%EMR_ROUNDRECT                               = 44
%EMR_ARC                                     = 45
%EMR_CHORD                                   = 46
%EMR_PIE                                     = 47
%EMR_SELECTPALETTE                           = 48
%EMR_CREATEPALETTE                           = 49
%EMR_SETPALETTEENTRIES                       = 50
%EMR_RESIZEPALETTE                           = 51
%EMR_REALIZEPALETTE                          = 52
%EMR_EXTFLOODFILL                            = 53
%EMR_LINETO                                  = 54
%EMR_ARCTO                                   = 55
%EMR_POLYDRAW                                = 56
%EMR_SETARCDIRECTION                         = 57
%EMR_SETMITERLIMIT                           = 58
%EMR_BEGINPATH                               = 59
%EMR_ENDPATH                                 = 60
%EMR_CLOSEFIGURE                             = 61
%EMR_FILLPATH                                = 62
%EMR_STROKEANDFILLPATH                       = 63
%EMR_STROKEPATH                              = 64
%EMR_FLATTENPATH                             = 65
%EMR_WIDENPATH                               = 66
%EMR_SELECTCLIPPATH                          = 67
%EMR_ABORTPATH                               = 68

%EMR_GDICOMMENT                              = 70
%EMR_FILLRGN                                 = 71
%EMR_FRAMERGN                                = 72
%EMR_INVERTRGN                               = 73
%EMR_PAINTRGN                                = 74
%EMR_EXTSELECTCLIPRGN                        = 75
%EMR_BITBLT                                  = 76
%EMR_STRETCHBLT                              = 77
%EMR_MASKBLT                                 = 78
%EMR_PLGBLT                                  = 79
%EMR_SETDIBITSTODEVICE                       = 80
%EMR_STRETCHDIBITS                           = 81
%EMR_EXTCREATEFONTINDIRECTW                  = 82
%EMR_EXTTEXTOUTA                             = 83
%EMR_EXTTEXTOUTW                             = 84
%EMR_POLYBEZIER16                            = 85
%EMR_POLYGON16                               = 86
%EMR_POLYLINE16                              = 87
%EMR_POLYBEZIERTO16                          = 88
%EMR_POLYLINETO16                            = 89
%EMR_POLYPOLYLINE16                          = 90
%EMR_POLYPOLYGON16                           = 91
%EMR_POLYDRAW16                              = 92
%EMR_CREATEMONOBRUSH                         = 93
%EMR_CREATEDIBPATTERNBRUSHPT                 = 94
%EMR_EXTCREATEPEN                            = 95
%EMR_POLYTEXTOUTA                            = 96
%EMR_POLYTEXTOUTW                            = 97

%EMR_MIN                                     = 1
%EMR_MAX                                     = 97

'  StretchBlt() Modes
%STRETCH_ANDSCANS                            = 1
%STRETCH_ORSCANS                             = 2
%STRETCH_DELETESCANS                         = 3
%STRETCH_HALFTONE                            = 4

%TCI_SRCCHARSET                              = 1
%TCI_SRCCODEPAGE                             = 2
%TCI_SRCFONTSIG                              = 3

%MONO_FONT                                   = 8
%JOHAB_CHARSET                               = 130
%HEBREW_CHARSET                              = 177
%ARABIC_CHARSET                              = 178
%GREEK_CHARSET                               = 161
%TURKISH_CHARSET                             = 162
%THAI_CHARSET                                = 222
%EASTEUROPE_CHARSET                          = 238
%RUSSIAN_CHARSET                             = 204

%MAC_CHARSET                                 = 77
%BALTIC_CHARSET                              = 186

%FS_LATIN1                                   = &H1&
%FS_LATIN2                                   = &H2&
%FS_CYRILLIC                                 = &H4&
%FS_GREEK                                    = &H8&
%FS_TURKISH                                  = &H10&
%FS_HEBREW                                   = &H20&
%FS_ARABIC                                   = &H40&
%FS_BALTIC                                   = &H80&
%FS_THAI                                     = &H10000
%FS_JISJAPAN                                 = &H20000
%FS_CHINESESIMP                              = &H40000
%FS_WANSUNG                                  = &H80000
%FS_CHINESETRAD                              = &H100000
%FS_JOHAB                                    = &H200000
%FS_SYMBOL                                   = &H80000000
%DEFAULT_GUI_FONT                            = 17
'  current version of specification
%DM_RESERVED1                                = &H800000
%DM_RESERVED2                                = &H1000000
%DM_ICMMETHOD                                = &H2000000
%DM_ICMINTENT                                = &H4000000
%DM_MEDIATYPE                                = &H8000000
%DM_DITHERTYPE                               = &H10000000
%DMPAPER_ISO_B4                              = 42     '  B4 (ISO) 250 x 353 mm
%DMPAPER_JAPANESE_POSTCARD                   = 43     '  Japanese Postcard 100 x 148 mm
%DMPAPER_9X11                                = 44     '  9 x 11 in
%DMPAPER_10X11                               = 45     '  10 x 11 in
%DMPAPER_15X11                               = 46     '  15 x 11 in
%DMPAPER_ENV_INVITE                          = 47     '  Envelope Invite 220 x 220 mm
%DMPAPER_RESERVED_48                         = 48     '  RESERVED--DO NOT USE
%DMPAPER_RESERVED_49                         = 49     '  RESERVED--DO NOT USE
%DMPAPER_LETTER_EXTRA                        = 50     '  Letter Extra 9 \275 x 12 in
%DMPAPER_LEGAL_EXTRA                         = 51     '  Legal Extra 9 \275 x 15 in
%DMPAPER_TABLOID_EXTRA                       = 52     '  Tabloid Extra 11.69 x 18 in
%DMPAPER_A4_EXTRA                            = 53     '  A4 Extra 9.27 x 12.69 in
%DMPAPER_LETTER_TRANSVERSE                   = 54     '  Letter Transverse 8 \275 x 11 in
%DMPAPER_A4_TRANSVERSE                       = 55     '  A4 Transverse 210 x 297 mm
%DMPAPER_LETTER_EXTRA_TRANSVERSE             = 56     '  Letter Extra Transverse 9\275 x 12 in
%DMPAPER_A_PLUS                              = 57     '  SuperA/SuperA/A4 227 x 356 mm
%DMPAPER_B_PLUS                              = 58     '  SuperB/SuperB/A3 305 x 487 mm
%DMPAPER_LETTER_PLUS                         = 59     '  Letter Plus 8.5 x 12.69 in
%DMPAPER_A4_PLUS                             = 60     '  A4 Plus 210 x 330 mm
%DMPAPER_A5_TRANSVERSE                       = 61     '  A5 Transverse 148 x 210 mm
%DMPAPER_B5_TRANSVERSE                       = 62     '  B5 (JIS) Transverse 182 x 257 mm
%DMPAPER_A3_EXTRA                            = 63     '  A3 Extra 322 x 445 mm
%DMPAPER_A5_EXTRA                            = 64     '  A5 Extra 174 x 235 mm
%DMPAPER_B5_EXTRA                            = 65     '  B5 (ISO) Extra 201 x 276 mm
%DMPAPER_A2                                  = 66     '  A2 420 x 594 mm
%DMPAPER_A3_TRANSVERSE                       = 67     '  A3 Transverse 297 x 420 mm
%DMPAPER_A3_EXTRA_TRANSVERSE                 = 68     '  A3 Extra Transverse 322 x 445 mm
%DMTT_DOWNLOAD_OUTLINE                       = 4      '  download TT fonts as outline soft fonts

'  ICM methods
%DMICMMETHOD_NONE                            = 1      '  ICM disabled
%DMICMMETHOD_SYSTEM                          = 2      '  ICM handled by system
%DMICMMETHOD_DRIVER                          = 3      '  ICM handled by driver
%DMICMMETHOD_DEVICE                          = 4      '  ICM handled by device
%DMICMMETHOD_USER                            = 256    '  Device-specific methods start here

'  ICM Intents
%DMICM_SATURATE                              = 1      '  Maximize color saturation
%DMICM_CONTRAST                              = 2      '  Maximize color contrast
%DMICM_COLORMETRIC                           = 3      '  Use specific color metric
%DMICM_USER                                  = 256    '  Device-specific intents start here

'  Media types
%DMMEDIA_STANDARD                            = 1      '  Standard paper
%DMMEDIA_GLOSSY                              = 2      '  Glossy paper
%DMMEDIA_TRANSPARENCY                        = 3      '  Transparency

%DMMEDIA_USER                                = 256    '  Device-specific media start here

'  Dither types
%DMDITHER_NONE                               = 1      '  No dithering
%DMDITHER_COARSE                             = 2      '  Dither with a coarse brush
%DMDITHER_FINE                               = 3      '  Dither with a fine brush
%DMDITHER_LINEART                            = 4      '  LineArt dithering
%DMDITHER_GRAYSCALE                          = 5      '  Device does grayscaling
%DMDITHER_USER                               = 256    '  Device-specific dithers start here
%GGO_GRAY2_BITMAP                            = 4
%GGO_GRAY4_BITMAP                            = 5
%GGO_GRAY8_BITMAP                            = 6
%GGO_GLYPH_INDEX                             = &H80
%GCP_DBCS                                    = &H1
%GCP_REORDER                                 = &H2
%GCP_USEKERNING                              = &H8
%GCP_GLYPHSHAPE                              = &H10
%GCP_LIGATE                                  = &H20
%GCP_DIACRITIC                               = &H100
%GCP_KASHIDA                                 = &H400
%GCP_ERROR                                   = &H8000
%FLI_MASK                                    = &H103B
%GCP_JUSTIFY                                 = &H10000
%GCP_NODIACRITICS                            = &H20000
%FLI_GLYPHS                                  = &H40000
%GCP_CLASSIN                                 = &H80000
%GCP_MAXEXTENT                               = &H100000
%GCP_JUSTIFYIN                               = &H200000
%GCP_DISPLAYZWG                              = &H400000
%GCP_SYMSWAPOFF                              = &H800000
%GCP_NUMERICOVERRIDE                         = &H1000000
%GCP_NEUTRALOVERRIDE                         = &H2000000
%GCP_NUMERICSLATIN                           = &H4000000
%GCP_NUMERICSLOCAL                           = &H8000000
%GCPCLASS_LATIN                              = 1
%GCPCLASS_HEBREW                             = 2
%GCPCLASS_ARABIC                             = 2
%GCPCLASS_NEUTRAL                            = 3
%GCPCLASS_LOCALNUMBER                        = 4
%GCPCLASS_LATINNUMBER                        = 5
%GCPCLASS_LATINNUMERICTERMINATOR             = 6
%GCPCLASS_LATINNUMERICSEPARATOR              = 7
%GCPCLASS_NUMERICSEPARATOR                   = 8
%GCPCLASS_PREBOUNDRTL                        = &H80
%GCPCLASS_PREBOUNDLTR                        = &H40

%DC_BINADJUST                                = 19
%DC_EMF_COMPLIANT                            = 20
%DC_DATATYPE_PRODUCED                        = 21
%DC_COLLATE                                  = 22

%DCTT_DOWNLOAD_OUTLINE                       = &H8&

'  return values for DC_BINADJUST
%DCBA_FACEUPNONE                             = &H0
%DCBA_FACEUPCENTER                           = &H1
%DCBA_FACEUPLEFT                             = &H2
%DCBA_FACEUPRIGHT                            = &H3
%DCBA_FACEDOWNNONE                           = &H100
%DCBA_FACEDOWNCENTER                         = &H101
%DCBA_FACEDOWNLEFT                           = &H102
%DCBA_FACEDOWNRIGHT                          = &H103

%ICM_OFF                                     = 1
%ICM_ON                                      = 2
%ICM_QUERY                                   = 3

%EMR_SETICMMODE                              = 98
%EMR_CREATECOLORSPACE                        = 99
%EMR_SETCOLORSPACE                           = 100
%EMR_DELETECOLORSPACE                        = 101

' Scroll Bar Constants
%SB_HORZ                                     = 0
%SB_VERT                                     = 1
%SB_CTL                                      = 2
%SB_BOTH                                     = 3

' Scroll Bar Commands
%SB_LINEUP                                   = 0
%SB_LINELEFT                                 = 0
%SB_LINEDOWN                                 = 1
%SB_LINERIGHT                                = 1
%SB_PAGEUP                                   = 2
%SB_PAGELEFT                                 = 2
%SB_PAGEDOWN                                 = 3
%SB_PAGERIGHT                                = 3
%SB_THUMBPOSITION                            = 4
%SB_THUMBTRACK                               = 5
%SB_TOP                                      = 6
%SB_LEFT                                     = 6
%SB_BOTTOM                                   = 7
%SB_RIGHT                                    = 7
%SB_ENDSCROLL                                = 8

%SBM_SETSCROLLINFO                           = &H00E9
%SBM_GETSCROLLINFO                           = &H00EA

%SIF_RANGE                                   = &H0001
%SIF_PAGE                                    = &H0002
%SIF_POS                                     = &H0004
%SIF_DISABLENOSCROLL                         = &H0008
%SIF_TRACKPOS                                = &H0010
%SIF_ALL                                     = %SIF_RANGE OR %SIF_PAGE OR %SIF_POS OR %SIF_TRACKPOS

' ShowWindow() Commands
%SW_HIDE                                     = 0
%SW_SHOWNORMAL                               = 1
%SW_NORMAL                                   = 1
%SW_SHOWMINIMIZED                            = 2
%SW_SHOWMAXIMIZED                            = 3
%SW_MAXIMIZE                                 = 3
%SW_SHOWNOACTIVATE                           = 4
%SW_SHOW                                     = 5
%SW_MINIMIZE                                 = 6
%SW_SHOWMINNOACTIVE                          = 7
%SW_SHOWNA                                   = 8
%SW_RESTORE                                  = 9
%SW_SHOWDEFAULT                              = 10
%SW_MAX                                      = 10

' Old ShowWindow() Commands
%HIDE_WINDOW                                 = 0
%SHOW_OPENWINDOW                             = 1
%SHOW_ICONWINDOW                             = 2
%SHOW_FULLSCREEN                             = 3
%SHOW_OPENNOACTIVATE                         = 4

' Identifiers for the WM_SHOWWINDOW message
%SW_PARENTCLOSING                            = 1
%SW_OTHERZOOM                                = 2
%SW_PARENTOPENING                            = 3
%SW_OTHERUNZOOM                              = 4

' WM_KEYUP/DOWN/CHAR HIWORD(lParam) flags
%KF_EXTENDED                                 = &H100
%KF_DLGMODE                                  = &H800
%KF_MENUMODE                                 = &H1000
%KF_ALTDOWN                                  = &H2000
%KF_REPEAT                                   = &H4000
%KF_UP                                       = &H8000

' Virtual Keys, Standard Set
%VK_LBUTTON                                  = &H01
%VK_RBUTTON                                  = &H02
%VK_CANCEL                                   = &H03
%VK_MBUTTON                                  = &H04    '  NOT contiguous with L RBUTTON
%VK_BACK                                     = &H08
%VK_TAB                                      = &H09
%VK_CLEAR                                    = &H0C
%VK_RETURN                                   = &H0D
%VK_SHIFT                                    = &H10
%VK_CONTROL                                  = &H11
%VK_MENU                                     = &H12
%VK_PAUSE                                    = &H13
%VK_CAPITAL                                  = &H14
%VK_ESCAPE                                   = &H1B
%VK_SPACE                                    = &H20
%VK_PGUP                                     = &H21
%VK_PRIOR                                    = &H21
%VK_NEXT                                     = &H22
%VK_PGDN                                     = &H22
%VK_END                                      = &H23
%VK_HOME                                     = &H24
%VK_LEFT                                     = &H25
%VK_UP                                       = &H26
%VK_RIGHT                                    = &H27
%VK_DOWN                                     = &H28
%VK_SELECT                                   = &H29
%VK_PRINT                                    = &H2A
%VK_EXECUTE                                  = &H2B
%VK_SNAPSHOT                                 = &H2C
%VK_INSERT                                   = &H2D
%VK_DELETE                                   = &H2E
%VK_HELP                                     = &H2F

' VK_A thru VK_Z are the same as their ASCII equivalents: 'A' thru 'Z'
' VK_0 thru VK_9 are the same as their ASCII equivalents: '0' thru '9'


%VK_NUMPAD0                                  = &H60
%VK_NUMPAD1                                  = &H61
%VK_NUMPAD2                                  = &H62
%VK_NUMPAD3                                  = &H63
%VK_NUMPAD4                                  = &H64
%VK_NUMPAD5                                  = &H65
%VK_NUMPAD6                                  = &H66
%VK_NUMPAD7                                  = &H67
%VK_NUMPAD8                                  = &H68
%VK_NUMPAD9                                  = &H69
%VK_MULTIPLY                                 = &H6A
%VK_ADD                                      = &H6B
%VK_SEPARATOR                                = &H6C
%VK_SUBTRACT                                 = &H6D
%VK_DECIMAL                                  = &H6E
%VK_DIVIDE                                   = &H6F
%VK_F1                                       = &H70
%VK_F2                                       = &H71
%VK_F3                                       = &H72
%VK_F4                                       = &H73
%VK_F5                                       = &H74
%VK_F6                                       = &H75
%VK_F7                                       = &H76
%VK_F8                                       = &H77
%VK_F9                                       = &H78
%VK_F10                                      = &H79
%VK_F11                                      = &H7A
%VK_F12                                      = &H7B
%VK_F13                                      = &H7C
%VK_F14                                      = &H7D
%VK_F15                                      = &H7E
%VK_F16                                      = &H7F
%VK_F17                                      = &H80
%VK_F18                                      = &H81
%VK_F19                                      = &H82
%VK_F20                                      = &H83
%VK_F21                                      = &H84
%VK_F22                                      = &H85
%VK_F23                                      = &H86
%VK_F24                                      = &H87
%VK_NUMLOCK                                  = &H90
%VK_SCROLL                                   = &H91

'
'   VK_L VK_R - left and right Alt, Ctrl and Shift virtual keys.
'   Used only as parameters to GetAsyncKeyState() and GetKeyState().
'   No other API or message will distinguish left and right keys in this way.
'
%VK_LSHIFT                                   = &HA0
%VK_RSHIFT                                   = &HA1
%VK_LCONTROL                                 = &HA2
%VK_RCONTROL                                 = &HA3
%VK_LMENU                                    = &HA4
%VK_RMENU                                    = &HA5
%VK_ATTN                                     = &HF6
%VK_CRSEL                                    = &HF7
%VK_EXSEL                                    = &HF8
%VK_EREOF                                    = &HF9
%VK_PLAY                                     = &HFA
%VK_ZOOM                                     = &HFB
%VK_NONAME                                   = &HFC
%VK_PA1                                      = &HFD
%VK_OEM_CLEAR                                = &HFE

' SetWindowsHook() codes
%WH_MIN                                      = -1
%WH_MSGFILTER                                = -1
%WH_JOURNALRECORD                            = 0
%WH_JOURNALPLAYBACK                          = 1
%WH_KEYBOARD                                 = 2
%WH_GETMESSAGE                               = 3
%WH_CALLWNDPROC                              = 4
%WH_CBT                                      = 5
%WH_SYSMSGFILTER                             = 6
%WH_MOUSE                                    = 7
%WH_HARDWARE                                 = 8
%WH_DEBUG                                    = 9
%WH_SHELL                                    = 10
%WH_FOREGROUNDIDLE                           = 11
%WH_MAX                                      = 11

' Hook Codes
%HC_ACTION                                   = 0
%HC_GETNEXT                                  = 1
%HC_SKIP                                     = 2
%HC_NOREMOVE                                 = 3
%HC_NOREM                                    = %HC_NOREMOVE
%HC_SYSMODALON                               = 4
%HC_SYSMODALOFF                              = 5

' CBT Hook Codes
%HCBT_MOVESIZE                               = 0
%HCBT_MINMAX                                 = 1
%HCBT_QS                                     = 2
%HCBT_CREATEWND                              = 3
%HCBT_DESTROYWND                             = 4
%HCBT_ACTIVATE                               = 5
%HCBT_CLICKSKIPPED                           = 6
%HCBT_KEYSKIPPED                             = 7
%HCBT_SYSCOMMAND                             = 8
%HCBT_SETFOCUS                               = 9

%HSHELL_WINDOWCREATED                        = 1
%HSHELL_WINDOWDESTROYED                      = 2
%HSHELL_ACTIVATESHELLWINDOW                  = 3

' Keyboard Layout API
%HKL_PREV                                    = 0
%HKL_NEXT                                    = 1

%KLF_ACTIVATE                                = &H1
%KLF_SUBSTITUTE_OK                           = &H2
%KLF_UNLOADPREVIOUS                          = &H4
%KLF_REORDER                                 = &H8

' Size of KeyboardLayoutName (number of characters), including nul terminator
%KL_NAMELENGTH                               = 9

' Desktop-specific access flags
%DESKTOP_READOBJECTS                         = &H1&
%DESKTOP_CREATEWINDOW                        = &H2&
%DESKTOP_CREATEMENU                          = &H4&
%DESKTOP_HOOKCONTROL                         = &H8&
%DESKTOP_JOURNALRECORD                       = &H10&
%DESKTOP_JOURNALPLAYBACK                     = &H20&
%DESKTOP_ENUMERATE                           = &H40&
%DESKTOP_WRITEOBJECTS                        = &H80&

' Windowstation-specific access flags
%WINSTA_ENUMDESKTOPS                         = &H1&
%WINSTA_READATTRIBUTES                       = &H2&
%WINSTA_ACCESSCLIPBOARD                      = &H4&
%WINSTA_CREATEDESKTOP                        = &H8&
%WINSTA_WRITEATTRIBUTES                      = &H10&
%WINSTA_ACCESSPUBLICATOMS                    = &H20&
%WINSTA_EXITWINDOWS                          = &H40&
%WINSTA_ENUMERATE                            = &H100&
%WINSTA_READSCREEN                           = &H200&

' Window field offsets for GetWindowLong() and GetWindowWord()
%GWL_WNDPROC                                 = -4
%GWL_HINSTANCE                               = -6
%GWL_HWNDPARENT                              = -8
%GWL_STYLE                                   = -16
%GWL_EXSTYLE                                 = -20
%GWL_USERDATA                                = -21
%GWL_ID                                      = -12

' Class field offsets for GetClassLong() and GetClassWord()
%GCL_MENUNAME                                = -8
%GCL_HBRBACKGROUND                           = -10
%GCL_HCURSOR                                 = -12
%GCL_HICON                                   = -14
%GCL_HMODULE                                 = -16
%GCL_CBWNDEXTRA                              = -18
%GCL_CBCLSEXTRA                              = -20
%GCL_WNDPROC                                 = -24
%GCL_STYLE                                   = -26
%GCW_ATOM                                    = -32
%GCL_HICONSM                                 = -34 ' Patrice

' WH_MSGFILTER Filter Proc Codes
%MSGF_DIALOGBOX                              = 0
%MSGF_MESSAGEBOX                             = 1
%MSGF_MENU                                   = 2
%MSGF_MOVE                                   = 3
%MSGF_SIZE                                   = 4
%MSGF_SCROLLBAR                              = 5

' Private Window Messages Start Here:
%WM_USER                                     = &H400

' NOTE: All Message Numbers below &H0400 are RESERVED.

' Window Messages
%WM_NULL                                     = &H0
%WM_CREATE                                   = &H1
%WM_DESTROY                                  = &H2
%WM_MOVE                                     = &H3
%WM_SIZE                                     = &H5

%WM_ACTIVATE                                 = &H6
'
'  WM_ACTIVATE state values

%WA_INACTIVE                                 = 0
%WA_ACTIVE                                   = 1
%WA_CLICKACTIVE                              = 2

%WM_SETFOCUS                                 = &H7
%WM_KILLFOCUS                                = &H8
%WM_ENABLE                                   = &HA
%WM_SETREDRAW                                = &HB
%WM_SETTEXT                                  = &HC
%WM_GETTEXT                                  = &HD
%WM_GETTEXTLENGTH                            = &HE
%WM_PAINT                                    = &HF
%WM_CLOSE                                    = &H10
%WM_QUERYENDSESSION                          = &H11
%WM_QUIT                                     = &H12
%WM_QUERYOPEN                                = &H13
%WM_ERASEBKGND                               = &H14
%WM_SYSCOLORCHANGE                           = &H15
%WM_ENDSESSION                               = &H16
%WM_SHOWWINDOW                               = &H18
%WM_WININICHANGE                             = &H1A
%WM_SETTINGCHANGE                            = %WM_WININICHANGE
%WM_DEVMODECHANGE                            = &H1B
%WM_ACTIVATEAPP                              = &H1C
%WM_FONTCHANGE                               = &H1D
%WM_TIMECHANGE                               = &H1E
%WM_CANCELMODE                               = &H1F
%WM_SETCURSOR                                = &H20
%WM_MOUSEACTIVATE                            = &H21
%WM_CHILDACTIVATE                            = &H22
%WM_QUEUESYNC                                = &H23
%WM_GETMINMAXINFO                            = &H24
%WM_PAINTICON                                = &H26
%WM_ICONERASEBKGND                           = &H27
%WM_NEXTDLGCTL                               = &H28
%WM_SPOOLERSTATUS                            = &H2A
%WM_DRAWITEM                                 = &H2B
%WM_MEASUREITEM                              = &H2C
%WM_DELETEITEM                               = &H2D
%WM_VKEYTOITEM                               = &H2E
%WM_CHARTOITEM                               = &H2F
%WM_SETFONT                                  = &H30
%WM_GETFONT                                  = &H31
%WM_SETHOTKEY                                = &H32
%WM_GETHOTKEY                                = &H33
%WM_QUERYDRAGICON                            = &H37
%WM_COMPAREITEM                              = &H39
%WM_COMPACTING                               = &H41
%WM_OTHERWINDOWCREATED                       = &H42  '  no longer suported
%WM_OTHERWINDOWDESTROYED                     = &H43  '  no longer suported

%WM_COMMNOTIFY                               = &H44  '  no longer suported

' notifications passed in low word of lParam on WM_COMMNOTIFY messages
%CN_RECEIVE                                  = &H1
%CN_TRANSMIT                                 = &H2
%CN_EVENT                                    = &H4

%WM_WINDOWPOSCHANGING                        = &H46
%WM_WINDOWPOSCHANGED                         = &H47

%WM_POWER                                    = &H48
'
'  wParam for WM_POWER window message and DRV_POWER driver notification
%PWR_OK                                      = 1
%PWR_FAIL                                    = -1
%PWR_SUSPENDREQUEST                          = 1
%PWR_SUSPENDRESUME                           = 2
%PWR_CRITICALRESUME                          = 3

%WM_COPYDATA                                 = &H4A
%WM_CANCELJOURNAL                            = &H4B
%WM_NOTIFY                                   = &H4E
%WM_INPUTLANGUAGECHANGEREQUEST               = &H50
%WM_INPUTLANGUAGECHANGE                      = &H51
%WM_TCARD                                    = &H52
%WM_HELP                                     = &H53
%WM_USERCHANGED                              = &H54
%WM_NOTIFYFORMAT                             = &H55

%WM_CONTEXTMENU                              = &H7B
%WM_STYLECHANGING                            = &H7C
%WM_STYLECHANGED                             = &H7D
%WM_DISPLAYCHANGE                            = &H7E

%WM_GETICON                                  = &H7F
%WM_SETICON                                  = &H80
%WM_NCCREATE                                 = &H81
%WM_NCDESTROY                                = &H82
%WM_NCCALCSIZE                               = &H83
%WM_NCHITTEST                                = &H84
%WM_NCPAINT                                  = &H85
%WM_NCACTIVATE                               = &H86
%WM_GETDLGCODE                               = &H87
%WM_NCMOUSEMOVE                              = &HA0
%WM_NCLBUTTONDOWN                            = &HA1
%WM_NCLBUTTONUP                              = &HA2
%WM_NCLBUTTONDBLCLK                          = &HA3
%WM_NCRBUTTONDOWN                            = &HA4
%WM_NCRBUTTONUP                              = &HA5
%WM_NCRBUTTONDBLCLK                          = &HA6
%WM_NCMBUTTONDOWN                            = &HA7
%WM_NCMBUTTONUP                              = &HA8
%WM_NCMBUTTONDBLCLK                          = &HA9

%WM_KEYFIRST                                 = &H100
%WM_KEYDOWN                                  = &H100
%WM_KEYUP                                    = &H101
%WM_CHAR                                     = &H102
%WM_DEADCHAR                                 = &H103
%WM_SYSKEYDOWN                               = &H104
%WM_SYSKEYUP                                 = &H105
%WM_SYSCHAR                                  = &H106
%WM_SYSDEADCHAR                              = &H107
%WM_KEYLAST                                  = &H108
%WM_INITDIALOG                               = &H110
%WM_COMMAND                                  = &H111
%WM_SYSCOMMAND                               = &H112
%WM_TIMER                                    = &H113
%WM_HSCROLL                                  = &H114
%WM_VSCROLL                                  = &H115
%WM_INITMENU                                 = &H116
%WM_INITMENUPOPUP                            = &H117
%WM_MENUSELECT                               = &H11F
%WM_MENUCHAR                                 = &H120
%WM_ENTERIDLE                                = &H121
%WM_CTLCOLORMSGBOX                           = &H132
%WM_CTLCOLOREDIT                             = &H133
%WM_CTLCOLORLISTBOX                          = &H134
%WM_CTLCOLORBTN                              = &H135
%WM_CTLCOLORDLG                              = &H136
%WM_CTLCOLORSCROLLBAR                        = &H137
%WM_CTLCOLORSTATIC                           = &H138
%WM_MOUSEFIRST                               = &H200
%WM_MOUSEMOVE                                = &H200
%WM_LBUTTONDOWN                              = &H201
%WM_LBUTTONUP                                = &H202
%WM_LBUTTONDBLCLK                            = &H203
%WM_RBUTTONDOWN                              = &H204
%WM_RBUTTONUP                                = &H205
%WM_RBUTTONDBLCLK                            = &H206
%WM_MBUTTONDOWN                              = &H207
%WM_MBUTTONUP                                = &H208
%WM_MBUTTONDBLCLK                            = &H209
%WM_MOUSEWHEEL                               = &H20A
%WM_MOUSELAST                                = &H20A

%WM_PARENTNOTIFY                             = &H210
%WM_ENTERMENULOOP                            = &H211
%WM_EXITMENULOOP                             = &H212

%WM_SIZING                                   = &H214
%WM_CAPTURECHANGED                           = &H215
%WM_MOVING                                   = &H216

%WM_POWERBROADCAST                           = &H218
%WM_DEVICECHANGE                             = &H219
%WM_MDICREATE                                = &H220
%WM_MDIDESTROY                               = &H221
%WM_MDIACTIVATE                              = &H222
%WM_MDIRESTORE                               = &H223
%WM_MDINEXT                                  = &H224
%WM_MDIMAXIMIZE                              = &H225
%WM_MDITILE                                  = &H226
%WM_MDICASCADE                               = &H227
%WM_MDIICONARRANGE                           = &H228
%WM_MDIGETACTIVE                             = &H229
%WM_MDISETMENU                               = &H230
%WM_DROPFILES                                = &H233
%WM_MDIREFRESHMENU                           = &H234


%WM_CUT                                      = &H300
%WM_COPY                                     = &H301
%WM_PASTE                                    = &H302
%WM_CLEAR                                    = &H303
%WM_UNDO                                     = &H304
%WM_RENDERFORMAT                             = &H305
%WM_RENDERALLFORMATS                         = &H306
%WM_DESTROYCLIPBOARD                         = &H307
%WM_DRAWCLIPBOARD                            = &H308
%WM_PAINTCLIPBOARD                           = &H309
%WM_VSCROLLCLIPBOARD                         = &H30A
%WM_SIZECLIPBOARD                            = &H30B
%WM_ASKCBFORMATNAME                          = &H30C
%WM_CHANGECBCHAIN                            = &H30D
%WM_HSCROLLCLIPBOARD                         = &H30E
%WM_QUERYNEWPALETTE                          = &H30F
%WM_PALETTEISCHANGING                        = &H310
%WM_PALETTECHANGED                           = &H311
%WM_HOTKEY                                   = &H312
%WM_PRINTCLIENT                              = &H318

%WM_PENWINFIRST                              = &H380
%WM_PENWINLAST                               = &H38F

%WMSZ_LEFT                                   = 1
%WMSZ_RIGHT                                  = 2
%WMSZ_TOP                                    = 3
%WMSZ_TOPLEFT                                = 4
%WMSZ_TOPRIGHT                               = 5
%WMSZ_BOTTOM                                 = 6
%WMSZ_BOTTOMLEFT                             = 7
%WMSZ_BOTTOMRIGHT                            = 8

%ICON_SMALL                                  = 0
%ICON_BIG                                    = 1

' WM_SYNCTASK Commands
%ST_BEGINSWP                                 = 0
%ST_ENDSWP                                   = 1

' WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
%HTERROR                                     = -2
%HTTRANSPARENT                               = -1
%HTNOWHERE                                   = 0
%HTCLIENT                                    = 1
%HTCAPTION                                   = 2
%HTSYSMENU                                   = 3
%HTGROWBOX                                   = 4
%HTSIZE                                      = %HTGROWBOX
%HTMENU                                      = 5
%HTHSCROLL                                   = 6
%HTVSCROLL                                   = 7
%HTMINBUTTON                                 = 8
%HTMAXBUTTON                                 = 9
%HTLEFT                                      = 10
%HTRIGHT                                     = 11
%HTTOP                                       = 12
%HTTOPLEFT                                   = 13
%HTTOPRIGHT                                  = 14
%HTBOTTOM                                    = 15
%HTBOTTOMLEFT                                = 16
%HTBOTTOMRIGHT                               = 17
%HTBORDER                                    = 18
%HTREDUCE                                    = %HTMINBUTTON
%HTZOOM                                      = %HTMAXBUTTON
%HTSIZEFIRST                                 = %HTLEFT
%HTSIZELAST                                  = %HTBOTTOMRIGHT
%HTOBJECT                                    = 19 ' Patrice
%HTCLOSE                                     = 20 ' Patrice
%HTHELP                                      = 21 ' Patrice

'  SendMessageTimeout values
%SMTO_NORMAL                                 = &H0
%SMTO_BLOCK                                  = &H1
%SMTO_ABORTIFHUNG                            = &H2

' WM_MOUSEACTIVATE Return Codes
%MA_ACTIVATE                                 = 1
%MA_ACTIVATEANDEAT                           = 2
%MA_NOACTIVATE                               = 3
%MA_NOACTIVATEANDEAT                         = 4

' WM_SIZE message wParam values
%SIZE_RESTORED                               = 0
%SIZE_MINIMIZED                              = 1
%SIZE_MAXIMIZED                              = 2
%SIZE_MAXSHOW                                = 3
%SIZE_MAXHIDE                                = 4

' Obsolete constant names
%SIZENORMAL                                  = %SIZE_RESTORED
%SIZEICONIC                                  = %SIZE_MINIMIZED
%SIZEFULLSCREEN                              = %SIZE_MAXIMIZED
%SIZEZOOMSHOW                                = %SIZE_MAXSHOW
%SIZEZOOMHIDE                                = %SIZE_MAXHIDE

' WM_NCCALCSIZE return flags
%WVR_ALIGNTOP                                = &H10
%WVR_ALIGNLEFT                               = &H20
%WVR_ALIGNBOTTOM                             = &H40
%WVR_ALIGNRIGHT                              = &H80
%WVR_HREDRAW                                 = &H100
%WVR_VREDRAW                                 = &H200
%WVR_REDRAW                                  = %WVR_HREDRAW OR %WVR_VREDRAW
%WVR_VALIDRECTS                              = &H400

' Key State Masks for Mouse Messages
%MK_LBUTTON                                  = &H1
%MK_RBUTTON                                  = &H2
%MK_SHIFT                                    = &H4
%MK_CONTROL                                  = &H8
%MK_MBUTTON                                  = &H10

' Window Styles
%WS_OVERLAPPED                               = &H0&
%WS_POPUP                                    = &H80000000&
%WS_CHILD                                    = &H40000000&
%WS_MINIMIZE                                 = &H20000000&
%WS_VISIBLE                                  = &H10000000&
%WS_DISABLED                                 = &H8000000&
%WS_CLIPSIBLINGS                             = &H4000000&
%WS_CLIPCHILDREN                             = &H2000000&
%WS_MAXIMIZE                                 = &H1000000
%WS_CAPTION                                  = &HC00000&  '  WS_BORDER OR WS_DLGFRAME
%WS_BORDER                                   = &H800000&
%WS_DLGFRAME                                 = &H400000&
%WS_VSCROLL                                  = &H200000&
%WS_HSCROLL                                  = &H100000&
%WS_SYSMENU                                  = &H80000&
%WS_THICKFRAME                               = &H40000&
%WS_GROUP                                    = &H20000&
%WS_TABSTOP                                  = &H10000&
%WS_MINIMIZEBOX                              = &H20000&
%WS_MAXIMIZEBOX                              = &H10000&
%WS_TILED                                    = %WS_OVERLAPPED
%WS_ICONIC                                   = %WS_MINIMIZE
%WS_SIZEBOX                                  = %WS_THICKFRAME
%WS_OVERLAPPEDWIN                            = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME
%WS_OVERLAPPEDWINDOW                         = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_TILEDWINDOW                              = %WS_OVERLAPPEDWINDOW
%WS_POPUPWINDOW                              = %WS_POPUP OR %WS_BORDER OR %WS_SYSMENU
%WS_CHILDWINDOW                              = %WS_CHILD

%WS_EX_DLGMODALFRAME                         = &H00000001&
%WS_EX_NOPARENTNOTIFY                        = &H00000004&
%WS_EX_TOPMOST                               = &H00000008&
%WS_EX_ACCEPTFILES                           = &H00000010&
%WS_EX_TRANSPARENT                           = &H00000020&
%WS_EX_MDICHILD                              = &H00000040&
%WS_EX_TOOLWINDOW                            = &H00000080&
%WS_EX_SMCAPTION                             = &H00000080&
%WS_EX_WINDOWEDGE                            = &H00000100&
%WS_EX_CLIENTEDGE                            = &H00000200&
%WS_EX_CONTEXTHELP                           = &H00000400&
%WS_EX_RIGHT                                 = &H00001000&
%WS_EX_LEFT                                  = &H00000000&
%WS_EX_RTLREADING                            = &H00002000&
%WS_EX_LTRREADING                            = &H00000000&
%WS_EX_LEFTSCROLLBAR                         = &H00004000&
%WS_EX_RIGHTSCROLLBAR                        = &H00000000&
%WS_EX_CONTROLPARENT                         = &H00010000&
%WS_EX_STATICEDGE                            = &H00020000&
%WS_EX_APPWINDOW                             = &H00040000&
%WS_EX_OVERLAPPEDWINDOW                      = %WS_EX_WINDOWEDGE OR %WS_EX_CLIENTEDGE
%WS_EX_PALETTEWINDOW                         = %WS_EX_WINDOWEDGE OR %WS_EX_TOOLWINDOW OR %WS_EX_TOPMOST

%CS_VREDRAW                                  = &H1
%CS_HREDRAW                                  = &H2
%CS_KEYCVTWINDOW                             = &H4
%CS_DBLCLKS                                  = &H8
%CS_OWNDC                                    = &H20
%CS_CLASSDC                                  = &H40
%CS_PARENTDC                                 = &H80
%CS_NOKEYCVT                                 = &H100
%CS_NOCLOSE                                  = &H200
%CS_SAVEBITS                                 = &H800
%CS_BYTEALIGNCLIENT                          = &H1000
%CS_BYTEALIGNWINDOW                          = &H2000
%CS_PUBLICCLASS                              = &H4000
%CS_GLOBALCLASS                              = %CS_PUBLICCLASS

%CF_TEXT                                     =  1
%CF_BITMAP                                   =  2
%CF_METAFILEPICT                             =  3
%CF_SYLK                                     =  4
%CF_DIF                                      =  5
%CF_TIFF                                     =  6
%CF_OEMTEXT                                  =  7
%CF_DIB                                      =  8
%CF_PALETTE                                  =  9
%CF_PENDATA                                  = 10
%CF_RIFF                                     = 11
%CF_WAVE                                     = 12

%CF_OWNERDISPLAY                             = &H80
%CF_DSPTEXT                                  = &H81
%CF_DSPBITMAP                                = &H82
%CF_DSPMETAFILEPICT                          = &H83
%CF_DSPENHMETAFILE                           = &H8E

%CF_PRIVATEFIRST                             = &H200
%CF_PRIVATELAST                              = &H2FF

%CF_GDIOBJFIRST                              = &H300
%CF_GDIOBJLAST                               = &H3FF

%FVIRTKEY                                    = &H1        '  Assumed to be == TRUE
%FNOINVERT                                   = &H2
%FSHIFT                                      = &H4
%FCONTROL                                    = &H8
%FALT                                        = &H10

%WPF_SETMINPOSITION                          = &H1
%WPF_RESTORETOMAXIMIZED                      = &H2

' Owner draw control types
%ODT_MENU                                    = 1
%ODT_LISTBOX                                 = 2
%ODT_COMBOBOX                                = 3
%ODT_BUTTON                                  = 4

' Owner draw actions
%ODA_DRAWENTIRE                              = &H1
%ODA_SELECT                                  = &H2
%ODA_FOCUS                                   = &H4

' Owner draw state
%ODS_SELECTED                                = &H1
%ODS_GRAYED                                  = &H2
%ODS_DISABLED                                = &H4
%ODS_CHECKED                                 = &H8
%ODS_FOCUS                                   = &H10
%ODS_DEFAULT                                 = &H20 ' Patrice

' PeekMessage() Options
%PM_NOREMOVE                                 = &H0
%PM_REMOVE                                   = &H1
%PM_NOYIELD                                  = &H2

%MOD_ALT                                     = &H1
%MOD_CONTROL                                 = &H2
%MOD_SHIFT                                   = &H4

%IDHOT_SNAPWINDOW                            = -1    ' SHIFT-PRINTSCRN
%IDHOT_SNAPDESKTOP                           = -2    ' PRINTSCRN

%EWX_LOGOFF                                  = 0
%EWX_SHUTDOWN                                = 1
%EWX_REBOOT                                  = 2
%EWX_FORCE                                   = 4
%EWL_POWEROFF                                = 8

%EW_RESTARTWINDOWS                           = &H42

%READAPI                                     = 0        '  Flags for _lopen
%WRITEAPI                                    = 1
%READ_WRITE                                  = 2

' Special HWND value for use with PostMessage and SendMessage
%HWND_BROADCAST                              = &HFFFF&

%CW_USEDEFAULT                               = &H80000000???

%CWP_ALL                                     = &H0000
%CWP_SKIPINVISIBLE                           = &H0001
%CWP_SKIPDISABLED                            = &H0002
%CWP_SKIPTRANSPARENT                         = &H0004

%HWND_DESKTOP                                = 0

' SetWindowPos Flags
%SWP_NOSIZE                                  = &H1
%SWP_NOMOVE                                  = &H2
%SWP_NOZORDER                                = &H4
%SWP_NOREDRAW                                = &H8
%SWP_NOACTIVATE                              = &H10
%SWP_FRAMECHANGED                            = &H20        '  The frame changed: send WM_NCCALCSIZE
%SWP_SHOWWINDOW                              = &H40
%SWP_HIDEWINDOW                              = &H80
%SWP_NOCOPYBITS                              = &H100
%SWP_NOOWNERZORDER                           = &H200      '  Don't do owner Z ordering

%SWP_DRAWFRAME                               = %SWP_FRAMECHANGED
%SWP_NOREPOSITION                            = %SWP_NOOWNERZORDER

' SetWindowPos() hwndInsertAfter values
%HWND_TOP                                    = 0
%HWND_BOTTOM                                 = 1
%HWND_TOPMOST                                = -1
%HWND_NOTOPMOST                              = -2

%DLGWINDOWEXTRA                              = 30        '  Window extra bytes needed for private dialog classes

%KEYEVENTF_EXTENDEDKEY                       = &H1
%KEYEVENTF_KEYUP                             = &H2

%MOUSEEVENTF_MOVE                            = &H1 '  mouse move
%MOUSEEVENTF_LEFTDOWN                        = &H2 '  left button down
%MOUSEEVENTF_LEFTUP                          = &H4 '  left button up
%MOUSEEVENTF_RIGHTDOWN                       = &H8 '  right button down
%MOUSEEVENTF_RIGHTUP                         = &H10 '  right button up
%MOUSEEVENTF_MIDDLEDOWN                      = &H20 '  middle button down
%MOUSEEVENTF_MIDDLEUP                        = &H40 '  middle button up
%MOUSEEVENTF_WHEEL                           = &H0800 ' wheel button rolled
%MOUSEEVENTF_ABSOLUTE                        = &H8000 '  absolute move


' GetQueueStatus flags
%QS_KEY                                      = &H1
%QS_MOUSEMOVE                                = &H2
%QS_MOUSEBUTTON                              = &H4
%QS_POSTMESSAGE                              = &H8
%QS_TIMER                                    = &H10
%QS_PAINT                                    = &H20
%QS_SENDMESSAGE                              = &H40
%QS_HOTKEY                                   = &H80

%QS_MOUSE                                    = %QS_MOUSEMOVE OR %QS_MOUSEBUTTON

%QS_INPUT                                    = %QS_MOUSE OR %QS_KEY

%QS_ALLEVENTS                                = %QS_INPUT OR %QS_POSTMESSAGE OR %QS_TIMER OR %QS_PAINT OR %QS_HOTKEY

%QS_ALLINPUT                                 = %QS_SENDMESSAGE OR %QS_PAINT OR %QS_TIMER OR %QS_POSTMESSAGE OR %QS_MOUSEBUTTON OR %QS_MOUSEMOVE OR %QS_HOTKEY OR %QS_KEY

' GetSystemMetrics() codes
%SM_CXSCREEN                                 = 0
%SM_CYSCREEN                                 = 1
%SM_CXVSCROLL                                = 2
%SM_CYHSCROLL                                = 3
%SM_CYCAPTION                                = 4
%SM_CXBORDER                                 = 5
%SM_CYBORDER                                 = 6
%SM_CXDLGFRAME                               = 7
%SM_CYDLGFRAME                               = 8
%SM_CYVTHUMB                                 = 9
%SM_CXHTHUMB                                 = 10
%SM_CXICON                                   = 11
%SM_CYICON                                   = 12
%SM_CXCURSOR                                 = 13
%SM_CYCURSOR                                 = 14
%SM_CYMENU                                   = 15
%SM_CXFULLSCREEN                             = 16
%SM_CYFULLSCREEN                             = 17
%SM_CYKANJIWINDOW                            = 18
%SM_MOUSEPRESENT                             = 19
%SM_CYVSCROLL                                = 20
%SM_CXHSCROLL                                = 21
%SM_DEBUG                                    = 22
%SM_SWAPBUTTON                               = 23
%SM_RESERVED1                                = 24
%SM_RESERVED2                                = 25
%SM_RESERVED3                                = 26
%SM_RESERVED4                                = 27
%SM_CXMIN                                    = 28
%SM_CYMIN                                    = 29
%SM_CXSIZE                                   = 30
%SM_CYSIZE                                   = 31
%SM_CXFRAME                                  = 32
%SM_CYFRAME                                  = 33
%SM_CXMINTRACK                               = 34
%SM_CYMINTRACK                               = 35
%SM_CXDOUBLECLK                              = 36
%SM_CYDOUBLECLK                              = 37
%SM_CXICONSPACING                            = 38
%SM_CYICONSPACING                            = 39
%SM_MENUDROPALIGNMENT                        = 40
%SM_PENWINDOWS                               = 41
%SM_DBCSENABLED                              = 42
%SM_CMOUSEBUTTONS                            = 43

%SM_CXFIXEDFRAME                             = %SM_CXDLGFRAME  ' win40 name change
%SM_CYFIXEDFRAME                             = %SM_CYDLGFRAME  ' win40 name change
%SM_CXSIZEFRAME                              = %SM_CXFRAME     ' win40 name change
%SM_CYSIZEFRAME                              = %SM_CYFRAME     ' win40 name change

%SM_SECURE                                   = 44
%SM_CXEDGE                                   = 45
%SM_CYEDGE                                   = 46
%SM_CXMINSPACING                             = 47
%SM_CYMINSPACING                             = 48
%SM_CXSMICON                                 = 49
%SM_CYSMICON                                 = 50
%SM_CYSMCAPTION                              = 51
%SM_CXSMSIZE                                 = 52
%SM_CYSMSIZE                                 = 53
%SM_CXMENUSIZE                               = 54
%SM_CYMENUSIZE                               = 55
%SM_ARRANGE                                  = 56
%SM_CXMINIMIZED                              = 57
%SM_CYMINIMIZED                              = 58
%SM_CXMAXTRACK                               = 59
%SM_CYMAXTRACK                               = 60
%SM_CXMAXIMIZED                              = 61
%SM_CYMAXIMIZED                              = 62
%SM_NETWORK                                  = 63
%SM_CLEANBOOT                                = 67
%SM_CXDRAG                                   = 68
%SM_CYDRAG                                   = 69
%SM_SHOWSOUNDS                               = 70
%SM_CXMENUCHECK                              = 71   ' Use instead of GetMenuCheckMarkDimensions()
%SM_CYMENUCHECK                              = 72
%SM_SLOWMACHINE                              = 73
%SM_MIDEASTENABLED                           = 74
%SM_MOUSEWHEELPRESENT                        = 75
%SM_XVIRTUALSCREEN                           = 76
%SM_YVIRTUALSCREEN                           = 77
%SM_CXVIRTUALSCREEN                          = 78
%SM_CYVIRTUALSCREEN                          = 79
%SM_CMONITORS                                = 80
%SM_SAMEDISPLAYFORMAT                        = 81
%SM_CMETRICS                                 = 83

' Flags for TrackPopupMenu
%TPM_LEFTBUTTON                              = &H0&
%TPM_RIGHTBUTTON                             = &H2&
%TPM_LEFTALIGN                               = &H0&
%TPM_CENTERALIGN                             = &H4&
%TPM_RIGHTALIGN                              = &H8&

' DrawText() Format Flags
%DT_TOP                                      = &H0
%DT_LEFT                                     = &H0
%DT_CENTER                                   = &H1
%DT_RIGHT                                    = &H2
%DT_VCENTER                                  = &H4
%DT_BOTTOM                                   = &H8
%DT_WORDBREAK                                = &H10
%DT_SINGLELINE                               = &H20
%DT_EXPANDTABS                               = &H40
%DT_TABSTOP                                  = &H80
%DT_NOCLIP                                   = &H100
%DT_EXTERNALLEADING                          = &H200
%DT_CALCRECT                                 = &H400
%DT_NOPREFIX                                 = &H800
%DT_INTERNAL                                 = &H1000
%DT_EDITCONTROL                              = &H00002000
%DT_PATH_ELLIPSIS                            = &H00004000
%DT_END_ELLIPSIS                             = &H00008000
%DT_MODIFYSTRING                             = &H00010000
%DT_RTLREADING                               = &H00020000
%DT_WORD_ELLIPSIS                            = &H00040000

%DCX_WINDOW                                  = &H1&
%DCX_CACHE                                   = &H2&
%DCX_NORESETATTRS                            = &H4&
%DCX_CLIPCHILDREN                            = &H8&
%DCX_CLIPSIBLINGS                            = &H10&
%DCX_PARENTCLIP                              = &H20&

%DCX_EXCLUDERGN                              = &H40&
%DCX_INTERSECTRGN                            = &H80&

%DCX_EXCLUDEUPDATE                           = &H100&
%DCX_INTERSECTUPDATE                         = &H200&

%DCX_LOCKWINDOWUPDATE                        = &H400&

%DCX_NORECOMPUTE                             = &H100000
%DCX_VALIDATE                                = &H200000

%RDW_INVALIDATE                              = &H1
%RDW_INTERNALPAINT                           = &H2
%RDW_ERASE                                   = &H4

%RDW_VALIDATE                                = &H8
%RDW_NOINTERNALPAINT                         = &H10
%RDW_NOERASE                                 = &H20

%RDW_NOCHILDREN                              = &H40
%RDW_ALLCHILDREN                             = &H80

%RDW_UPDATENOW                               = &H100
%RDW_ERASENOW                                = &H200

%RDW_FRAME                                   = &H400
%RDW_NOFRAME                                 = &H800

%SW_SCROLLCHILDREN                           = &H1
%SW_INVALIDATE                               = &H2
%SW_ERASE                                    = &H4

' EnableScrollBar() flags
%ESB_ENABLE_BOTH                             = &H0
%ESB_DISABLE_BOTH                            = &H3

%ESB_DISABLE_LEFT                            = &H1
%ESB_DISABLE_RIGHT                           = &H2

%ESB_DISABLE_UP                              = &H1
%ESB_DISABLE_DOWN                            = &H2

%ESB_DISABLE_LTUP                            = %ESB_DISABLE_LEFT
%ESB_DISABLE_RTDN                            = %ESB_DISABLE_RIGHT

' MessageBox() Flags
%MB_OK                                       = &H0&
%MB_OKCANCEL                                 = &H1&
%MB_ABORTRETRYIGNORE                         = &H2&
%MB_YESNOCANCEL                              = &H3&
%MB_YESNO                                    = &H4&
%MB_RETRYCANCEL                              = &H5&

%MB_ICONHAND                                 = &H10&
%MB_ICONQUESTION                             = &H20&
%MB_ICONEXCLAMATION                          = &H30&
%MB_ICONASTERISK                             = &H40&

%MB_ICONERROR                                = %MB_ICONHAND
%MB_ICONINFORMATION                          = %MB_ICONASTERISK
%MB_ICONSTOP                                 = %MB_ICONHAND
%MB_ICONWARNING                              = %MB_ICONEXCLAMATION

%MB_DEFBUTTON1                               = &H0&
%MB_DEFBUTTON2                               = &H100&
%MB_DEFBUTTON3                               = &H200&

%MB_APPLMODAL                                = &H0&
%MB_SYSTEMMODAL                              = &H1000&
%MB_TASKMODAL                                = &H2000&

%MB_NOFOCUS                                  = &H8000&
%MB_SETFOREGROUND                            = &H10000
%MB_DEFAULT_DESKTOP_ONLY                     = &H20000

%MB_TYPEMASK                                 = &HF&
%MB_ICONMASK                                 = &HF0&
%MB_DEFMASK                                  = &HF00&
%MB_MODEMASK                                 = &H3000&
%MB_MISCMASK                                 = &HC000&
%MB_TOPMOST                                  = &H40000&
%MB_RIGHT                                    = &H80000&
%MB_RTLREADING                               = &H100000&

%MB_PRECOMPOSED                              = &H1         '  use precomposed chars
%MB_COMPOSITE                                = &H2         '  use composite chars
%MB_USEGLYPHCHARS                            = &H4         '  use glyph chars, not ctrl chars

' Color Types
%CTLCOLOR_MSGBOX                             = 0
%CTLCOLOR_EDIT                               = 1
%CTLCOLOR_LISTBOX                            = 2
%CTLCOLOR_BTN                                = 3
%CTLCOLOR_DLG                                = 4
%CTLCOLOR_SCROLLBAR                          = 5
%CTLCOLOR_STATIC                             = 6
%CTLCOLOR_MAX                                = 8   '  three bits max

%COLOR_SCROLLBAR                             = 0
%COLOR_BACKGROUND                            = 1
%COLOR_ACTIVECAPTION                         = 2
%COLOR_INACTIVECAPTION                       = 3
%COLOR_MENU                                  = 4
%COLOR_MSGBOX                                = 4
%COLOR_WINDOW                                = 5
%COLOR_WINDOWFRAME                           = 6
%COLOR_MENUTEXT                              = 7
%COLOR_MSGBOXTEXT                            = 7
%COLOR_WINDOWTEXT                            = 8
%COLOR_CAPTIONTEXT                           = 9
%COLOR_ACTIVEBORDER                          = 10
%COLOR_INACTIVEBORDER                        = 11
%COLOR_APPWORKSPACE                          = 12
%COLOR_HIGHLIGHT                             = 13
%COLOR_HIGHLIGHTTEXT                         = 14
%COLOR_BTNFACE                               = 15
%COLOR_BTNSHADOW                             = 16
%COLOR_GRAYTEXT                              = 17
%COLOR_BTNTEXT                               = 18
%COLOR_INACTIVECAPTIONTEXT                   = 19
%COLOR_BTNHIGHLIGHT                          = 20

%COLOR_3DDKSHADOW                            = 21
%COLOR_3DLIGHT                               = 22
%COLOR_INFOTEXT                              = 23
%COLOR_INFOBK                                = 24

%COLOR_DESKTOP                               = %COLOR_BACKGROUND
%COLOR_3DFACE                                = %COLOR_BTNFACE
%COLOR_3DSHADOW                              = %COLOR_BTNSHADOW
%COLOR_3DHIGHLIGHT                           = %COLOR_BTNHIGHLIGHT
%COLOR_3DHILIGHT                             = %COLOR_BTNHIGHLIGHT
%COLOR_BTNHILIGHT                            = %COLOR_BTNHIGHLIGHT


' GetWindow() Constants
%GW_HWNDFIRST                                = 0
%GW_HWNDLAST                                 = 1
%GW_HWNDNEXT                                 = 2
%GW_HWNDPREV                                 = 3
%GW_OWNER                                    = 4
%GW_CHILD                                    = 5
%GW_MAX                                      = 5

' Menu flags for Add/Check/EnableMenuItem()
%MF_INSERT                                   = &H0&
%MF_CHANGE                                   = &H80&
%MF_APPEND                                   = &H100&
%MF_DELETE                                   = &H200&
%MF_REMOVE                                   = &H1000&

%MF_BYCOMMAND                                = &H0&
%MF_BYPOSITION                               = &H400&

%MF_SEPARATOR                                = &H800&

%MF_ENABLED                                  = &H0&
%MF_GRAYED                                   = &H1&
%MF_DISABLED                                 = &H2&

%MF_UNCHECKED                                = &H0&
%MF_CHECKED                                  = &H8&
%MF_USECHECKBITMAPS                          = &H200&

%MF_STRING                                   = &H0&
%MF_BITMAP                                   = &H4&
%MF_OWNERDRAW                                = &H100&

%MF_POPUP                                    = &H10&
%MF_MENUBARBREAK                             = &H20&
%MF_MENUBREAK                                = &H40&

%MF_UNHILITE                                 = &H0&
%MF_HILITE                                   = &H80&

%MF_SYSMENU                                  = &H2000&
%MF_HELP                                     = &H4000&
%MF_MOUSESELECT                              = &H8000&

%MF_END                                      = &H80&

%MFT_STRING                                  = %MF_STRING
%MFT_BITMAP                                  = %MF_BITMAP
%MFT_MENUBARBREAK                            = %MF_MENUBARBREAK
%MFT_MENUBREAK                               = %MF_MENUBREAK
%MFT_OWNERDRAW                               = %MF_OWNERDRAW
%MFT_RADIOCHECK                              = &H00000200&


' System Menu Command Values
%SC_SIZE                                     = &HF000&
%SC_MOVE                                     = &HF010&
%SC_MINIMIZE                                 = &HF020&
%SC_MAXIMIZE                                 = &HF030&
%SC_NEXTWINDOW                               = &HF040&
%SC_PREVWINDOW                               = &HF050&
%SC_CLOSE                                    = &HF060&
%SC_VSCROLL                                  = &HF070&
%SC_HSCROLL                                  = &HF080&
%SC_MOUSEMENU                                = &HF090&
%SC_KEYMENU                                  = &HF100&
%SC_ARRANGE                                  = &HF110&
%SC_RESTORE                                  = &HF120&
%SC_TASKLIST                                 = &HF130&
%SC_SCREENSAVE                               = &HF140&
%SC_HOTKEY                                   = &HF150&

' Obsolete names
%SC_ICON                                     = %SC_MINIMIZE
%SC_ZOOM                                     = %SC_MAXIMIZE

' Standard Cursor IDs
%IDC_ARROW                                   = 32512&
%IDC_IBEAM                                   = 32513&
%IDC_WAIT                                    = 32514&
%IDC_CROSS                                   = 32515&
%IDC_UPARROW                                 = 32516&
%IDC_SIZE                                    = 32640&
%IDC_ICON                                    = 32641&
%IDC_SIZENWSE                                = 32642&
%IDC_SIZENESW                                = 32643&
%IDC_SIZEWE                                  = 32644&
%IDC_SIZENS                                  = 32645&
%IDC_SIZEALL                                 = 32646&
%IDC_NO                                      = 32648&
%IDC_HAND                                    = 32649&
%IDC_APPSTARTING                             = 32650&
%IDC_HELP                                    = 32651&

' OEM Resource Ordinal Numbers
%OBM_CLOSE                                   = 32754
%OBM_UPARROW                                 = 32753
%OBM_DNARROW                                 = 32752
%OBM_RGARROW                                 = 32751
%OBM_LFARROW                                 = 32750
%OBM_REDUCE                                  = 32749
%OBM_ZOOM                                    = 32748
%OBM_RESTORE                                 = 32747
%OBM_REDUCED                                 = 32746
%OBM_ZOOMD                                   = 32745
%OBM_RESTORED                                = 32744
%OBM_UPARROWD                                = 32743
%OBM_DNARROWD                                = 32742
%OBM_RGARROWD                                = 32741
%OBM_LFARROWD                                = 32740
%OBM_MNARROW                                 = 32739
%OBM_COMBO                                   = 32738
%OBM_UPARROWI                                = 32737
%OBM_DNARROWI                                = 32736
%OBM_RGARROWI                                = 32735
%OBM_LFARROWI                                = 32734

%OBM_OLD_CLOSE                               = 32767
%OBM_SIZE                                    = 32766
%OBM_OLD_UPARROW                             = 32765
%OBM_OLD_DNARROW                             = 32764
%OBM_OLD_RGARROW                             = 32763
%OBM_OLD_LFARROW                             = 32762
%OBM_BTSIZE                                  = 32761
%OBM_CHECK                                   = 32760
%OBM_CHECKBOXES                              = 32759
%OBM_BTNCORNERS                              = 32758
%OBM_OLD_REDUCE                              = 32757
%OBM_OLD_ZOOM                                = 32756
%OBM_OLD_RESTORE                             = 32755

%OCR_NORMAL                                  = 32512
%OCR_IBEAM                                   = 32513
%OCR_WAIT                                    = 32514
%OCR_CROSS                                   = 32515
%OCR_UP                                      = 32516
%OCR_SIZE                                    = 32640
%OCR_ICON                                    = 32641
%OCR_SIZENWSE                                = 32642
%OCR_SIZENESW                                = 32643
%OCR_SIZEWE                                  = 32644
%OCR_SIZENS                                  = 32645
%OCR_SIZEALL                                 = 32646
%OCR_ICOCUR                                  = 32647
%OCR_NO                                      = 32648 ' not in win3.1

%OIC_SAMPLE                                  = 32512
%OIC_HAND                                    = 32513
%OIC_QUES                                    = 32514
%OIC_BANG                                    = 32515
%OIC_NOTE                                    = 32516

%ORD_LANGDRIVER                              = 1 '  The ordinal number for the entry point of
'  language drivers.

' Standard Icon IDs
%IDI_APPLICATION                             = 32512&
%IDI_HAND                                    = 32513&
%IDI_ERROR                                   = 32513&
%IDI_QUESTION                                = 32514&
%IDI_EXCLAMATION                             = 32515&
%IDI_WARNING                                 = 32515&
%IDI_ASTERISK                                = 32516&
%IDI_INFORMATION                             = 32516&
%IDI_WINLOGO                                 = 32517&

' Dialog Box Command IDs
%IDOK                                        = 1
%IDCANCEL                                    = 2
%IDABORT                                     = 3
%IDRETRY                                     = 4
%IDIGNORE                                    = 5
%IDYES                                       = 6
%IDNO                                        = 7

' Control Manager Structures and Definitions

' Edit Control Styles
%ES_LEFT                                     = &H0&
%ES_CENTER                                   = &H1&
%ES_RIGHT                                    = &H2&
%ES_MULTILINE                                = &H4&
%ES_UPPERCASE                                = &H8&
%ES_LOWERCASE                                = &H10&
%ES_PASSWORD                                 = &H20&
%ES_AUTOVSCROLL                              = &H40&
%ES_AUTOHSCROLL                              = &H80&
%ES_NOHIDESEL                                = &H100&
%ES_OEMCONVERT                               = &H400&
%ES_READONLY                                 = &H800&
%ES_WANTRETURN                               = &H1000&
%ES_NUMBER                                   = &H2000&

' Edit Control Notification Codes
%EN_SETFOCUS                                 = &H100
%EN_KILLFOCUS                                = &H200
%EN_CHANGE                                   = &H300
%EN_UPDATE                                   = &H400
%EN_ERRSPACE                                 = &H500
%EN_MAXTEXT                                  = &H501
%EN_HSCROLL                                  = &H601
%EN_VSCROLL                                  = &H602

' Edit Control Messages
%EM_GETSEL                                   = &HB0
%EM_SETSEL                                   = &HB1
%EM_GETRECT                                  = &HB2
%EM_SETRECT                                  = &HB3
%EM_SETRECTNP                                = &HB4
%EM_SCROLL                                   = &HB5
%EM_LINESCROLL                               = &HB6
%EM_SCROLLCARET                              = &HB7
%EM_GETMODIFY                                = &HB8
%EM_SETMODIFY                                = &HB9
%EM_GETLINECOUNT                             = &HBA
%EM_LINEINDEX                                = &HBB
%EM_SETHANDLE                                = &HBC
%EM_GETHANDLE                                = &HBD
%EM_GETTHUMB                                 = &HBE
%EM_LINELENGTH                               = &HC1
%EM_REPLACESEL                               = &HC2
%EM_GETLINE                                  = &HC4
%EM_LIMITTEXT                                = &HC5
%EM_CANUNDO                                  = &HC6
%EM_UNDO                                     = &HC7
%EM_FMTLINES                                 = &HC8
%EM_LINEFROMCHAR                             = &HC9
%EM_SETTABSTOPS                              = &HCB
%EM_SETPASSWORDCHAR                          = &HCC
%EM_EMPTYUNDOBUFFER                          = &HCD
%EM_GETFIRSTVISIBLELINE                      = &HCE
%EM_SETREADONLY                              = &HCF
%EM_SETWORDBREAKPROC                         = &HD0
%EM_GETWORDBREAKPROC                         = &HD1
%EM_GETPASSWORDCHAR                          = &HD2
%EM_SETMARGINS                               = &HD3
%EM_GETMARGINS                               = &HD4
%EM_SETLIMITTEXT                             = %EM_LIMITTEXT
%EM_GETLIMITTEXT                             = &HD5
%EM_POSFROMCHAR                              = &HD6
%EM_CHARFROMPOS                              = &HD7

' EDITWORDBREAKPROC code values
%WB_LEFT                                     = 0
%WB_RIGHT                                    = 1
%WB_ISDELIMITER                              = 2

' Button Control Styles
%BS_TEXT                                     = &H0&
%BS_PUSHBUTTON                               = &H0&
%BS_DEFPUSHBUTTON                            = &H1&
%BS_DEFAULT                                  = %BS_DEFPUSHBUTTON
%BS_CHECKBOX                                 = &H2&
%BS_AUTOCHECKBOX                             = &H3&
%BS_RADIOBUTTON                              = &H4&
%BS_3STATE                                   = &H5&
%BS_AUTO3STATE                               = &H6&
%BS_GROUPBOX                                 = &H7&
%BS_USERBUTTON                               = &H8&
%BS_AUTORADIOBUTTON                          = &H9&
%BS_OWNERDRAW                                = &HB&
%BS_LEFTTEXT                                 = &H20&
%BS_ICON                                     = &H40&
%BS_BITMAP                                   = &H80&
%BS_LEFT                                     = &H100&
%BS_RIGHT                                    = &H200&
%BS_CENTER                                   = &H300&
%BS_TOP                                      = &H400&
%BS_BOTTOM                                   = &H800&
%BS_VCENTER                                  = &HC00&
%BS_PUSHLIKE                                 = &H1000&
%BS_MULTILINE                                = &H2000&
%BS_NOTIFY                                   = &H4000&
%BS_FLAT                                     = &H8000&
%BS_RIGHTBUTTON                              = %BS_LEFTTEXT

' User Button Notification Codes
%BN_CLICKED                                  = 0
%BN_PAINT                                    = 1
%BN_HILITE                                   = 2
%BN_UNHILITE                                 = 3
%BN_DISABLE                                  = 4
%BN_DOUBLECLICKED                            = 5
%BN_SETFOCUS                                 = 6
%BN_KILLFOCUS                                = 7
%BN_DBLCLK                                   = %BN_DOUBLECLICKED

' Button Control Messages
%BST_UNCHECKED                               = &H00
%BST_CHECKED                                 = &H01
%BST_INDETERMINATE                           = &H02
%BST_PUSHED                                  = &H04

%BM_GETCHECK                                 = &HF0
%BM_SETCHECK                                 = &HF1
%BM_GETSTATE                                 = &HF2
%BM_SETSTATE                                 = &HF3
%BM_SETSTYLE                                 = &HF4
%BM_CLICK                                    = &HF5
%BM_GETIMAGE                                 = &HF6
%BM_SETIMAGE                                 = &HF7

' Static Control Constants
%SS_LEFT                                     = &H0000&
%SS_CENTER                                   = &H0001&
%SS_RIGHT                                    = &H0002&
%SS_ICON                                     = &H0003&
%SS_BLACKRECT                                = &H0004&
%SS_GRAYRECT                                 = &H0005&
%SS_WHITERECT                                = &H0006&
%SS_BLACKFRAME                               = &H0007&
%SS_GRAYFRAME                                = &H0008&
%SS_WHITEFRAME                               = &H0009&
%SS_USERITEM                                 = &H000A&
%SS_SIMPLE                                   = &H000B&
%SS_LEFTNOWORDWRAP                           = &H000C&
%SS_NOWORDWRAP                               = %SS_LEFTNOWORDWRAP
%SS_BITMAP                                   = &H000E&
%SS_ETCHEDHORZ                               = &H0010&
%SS_ETCHEDVERT                               = &H0011&
%SS_ETCHEDFRAME                              = &H0012&
%SS_NOPREFIX                                 = &H0080& '  Don't do "&" character translation
%SS_NOTIFY                                   = &H0100&
%SS_CENTERIMAGE                              = &H0200&
%SS_RIGHTJUST                                = &H0400&
%SS_REALSIZEIMAGE                            = &H0800&
%SS_REALSIZE                                 = %SS_REALSIZEIMAGE
%SS_SUNKEN                                   = &H1000&
%SS_ENDELLIPSIS                              = &H4000&
%SS_PATHELLIPSIS                             = &H8000&
%SS_WORDELLIPSIS                             = &HC000&
%SS_ELLIPSISMASK                             = &HC000&

' Static Control Mesages
%STM_SETICON                                 = &H170
%STM_GETICON                                 = &H171
%STM_SETIMAGE                                = &H172
%STM_GETIMAGE                                = &H173
%STM_MSGMAX                                  = &H174

%STN_CLICKED                                 = 0
%STN_DBLCLK                                  = 1
%STN_ENABLE                                  = 2
%STN_DISABLE                                 = 3

%WC_DIALOG                                   = 8002&

'  Get/SetWindowWord/Long offsets for use with WC_DIALOG windows
%DWL_MSGRESULT                               = 0
%DWL_DLGPROC                                 = 4
%DWL_USER                                    = 8

' DlgDirList, DlgDirListComboBox flags values
%DDL_READWRITE                               = &H0
%DDL_READONLY                                = &H1
%DDL_HIDDEN                                  = &H2
%DDL_SYSTEM                                  = &H4
%DDL_DIRECTORY                               = &H10
%DDL_ARCHIVE                                 = &H20

%DDL_POSTMSGS                                = &H2000
%DDL_DRIVES                                  = &H4000
%DDL_EXCLUSIVE                               = &H8000

' Dialog Styles
%DS_ABSALIGN                                 = &H0001&
%DS_SYSMODAL                                 = &H0002&
%DS_3DLOOK                                   = &H0004&
%DS_FIXEDSYS                                 = &H0008&
%DS_NOFAILCREATE                             = &H0010&
%DS_LOCALEDIT                                = &H0020& '  Edit items get Local storage.
%DS_SETFONT                                  = &H0040& '  User specified font for Dlg controls
%DS_MODALFRAME                               = &H0080& '  Can be combined with WS_CAPTION
%DS_NOIDLEMSG                                = &H0100& '  WM_ENTERIDLE message will not be sent
%DS_SETFOREGROUND                            = &H0200& '  not in win3.1
%DS_CONTROL                                  = &H0400&
%DS_CENTER                                   = &H0800&
%DS_CENTERMOUSE                              = &H1000&
%DS_CONTEXTHELP                              = &H2000&

%DM_GETDEFID                                 = %WM_USER + 0
%DM_SETDEFID                                 = %WM_USER + 1
%DC_HASDEFID                                 = &H534      '&H534B

' Dialog Codes
%DLGC_WANTARROWS                             = &H1    '  Control wants arrow keys
%DLGC_WANTTAB                                = &H2    '  Control wants tab keys
%DLGC_WANTALLKEYS                            = &H4    '  Control wants all keys
%DLGC_WANTMESSAGE                            = &H4    '  Pass message to control
%DLGC_HASSETSEL                              = &H8    '  Understands EM_SETSEL message
%DLGC_DEFPUSHBUTTON                          = &H10   '  Default pushbutton
%DLGC_UNDEFPUSHBUTTON                        = &H20   '  Non-default pushbutton
%DLGC_RADIOBUTTON                            = &H40   '  Radio button
%DLGC_WANTCHARS                              = &H80   '  Want WM_CHAR messages
%DLGC_STATIC                                 = &H100  '  Static item: don't include
%DLGC_BUTTON                                 = &H2000 '  Button item: can be checked

%LB_CTLCODE                                  = 0&

' Listbox Return Values
%LB_OKAY                                     = 0
%LB_ERR                                      = -1
%LB_ERRSPACE                                 = -2

' The idStaticPath parameter to DlgDirList can have the following values
' ORed if the list box should show other details of the files along with
' the name of the files;
' all other details also will be returned

' Listbox Notification Codes
%LBN_ERRSPACE                                = -2
%LBN_SELCHANGE                               = 1
%LBN_DBLCLK                                  = 2
%LBN_SELCANCEL                               = 3
%LBN_SETFOCUS                                = 4
%LBN_KILLFOCUS                               = 5

' Listbox messages
%LB_ADDSTRING                                = &H180
%LB_INSERTSTRING                             = &H181
%LB_DELETESTRING                             = &H182
%LB_SELITEMRANGEEX                           = &H183
%LB_RESETCONTENT                             = &H184
%LB_SETSEL                                   = &H185
%LB_SETCURSEL                                = &H186
%LB_GETSEL                                   = &H187
%LB_GETCURSEL                                = &H188
%LB_GETTEXT                                  = &H189
%LB_GETTEXTLEN                               = &H18A
%LB_GETCOUNT                                 = &H18B
%LB_SELECTSTRING                             = &H18C
%LB_DIR                                      = &H18D
%LB_GETTOPINDEX                              = &H18E
%LB_FINDSTRING                               = &H18F
%LB_GETSELCOUNT                              = &H190
%LB_GETSELITEMS                              = &H191
%LB_SETTABSTOPS                              = &H192
%LB_GETHORIZONTALEXTENT                      = &H193
%LB_SETHORIZONTALEXTENT                      = &H194
%LB_SETCOLUMNWIDTH                           = &H195
%LB_ADDFILE                                  = &H196
%LB_SETTOPINDEX                              = &H197
%LB_GETITEMRECT                              = &H198
%LB_GETITEMDATA                              = &H199
%LB_SETITEMDATA                              = &H19A
%LB_SELITEMRANGE                             = &H19B
%LB_SETANCHORINDEX                           = &H19C
%LB_GETANCHORINDEX                           = &H19D
%LB_SETCARETINDEX                            = &H19E
%LB_GETCARETINDEX                            = &H19F
%LB_SETITEMHEIGHT                            = &H1A0
%LB_GETITEMHEIGHT                            = &H1A1
%LB_FINDSTRINGEXACT                          = &H1A2
%LB_SETLOCALE                                = &H1A5
%LB_GETLOCALE                                = &H1A6
%LB_SETCOUNT                                 = &H1A7
%LB_INITSTORAGE                              = &H1A8
%LB_ITEMFROMPOINT                            = &H1A9
%LB_MSGMAX                                   = &H1B0

' Listbox Styles
%LBS_NOTIFY                                  = &H1&
%LBS_SORT                                    = &H2&
%LBS_NOREDRAW                                = &H4&
%LBS_MULTIPLESEL                             = &H8&
%LBS_OWNERDRAWFIXED                          = &H10&
%LBS_OWNERDRAWVARIABLE                       = &H20&
%LBS_HASSTRINGS                              = &H40&
%LBS_USETABSTOPS                             = &H80&
%LBS_NOINTEGRALHEIGHT                        = &H100&
%LBS_MULTICOLUMN                             = &H200&
%LBS_WANTKEYBOARDINPUT                       = &H400&
%LBS_EXTENDEDSEL                             = &H800&
%LBS_DISABLENOSCROLL                         = &H1000&
%LBS_NODATA                                  = &H2000&
%LBS_NOSEL                                   = &H4000&
%LBS_STANDARD                                = %LBS_NOTIFY OR %LBS_SORT OR %WS_VSCROLL OR %WS_BORDER

' Combo Box return Values
%CB_OKAY                                     = 0
%CB_ERR                                      = -1
%CB_ERRSPACE                                 = -2

' Combo Box Notification Codes
%CBN_ERRSPACE                                = -1
%CBN_SELCHANGE                               = 1
%CBN_DBLCLK                                  = 2
%CBN_SETFOCUS                                = 3
%CBN_KILLFOCUS                               = 4
%CBN_EDITCHANGE                              = 5
%CBN_EDITUPDATE                              = 6
%CBN_DROPDOWN                                = 7
%CBN_CLOSEUP                                 = 8
%CBN_SELENDOK                                = 9
%CBN_SELENDCANCEL                            = 10
%CBN_SELCANCEL                               = %CBN_SELENDCANCEL

' Combo Box styles
%CBS_SIMPLE                                  = &H1&
%CBS_DROPDOWN                                = &H2&
%CBS_DROPDOWNLIST                            = &H3&
%CBS_OWNERDRAWFIXED                          = &H10&
%CBS_OWNERDRAWVARIABLE                       = &H20&
%CBS_AUTOHSCROLL                             = &H40&
%CBS_OEMCONVERT                              = &H80&
%CBS_SORT                                    = &H100&
%CBS_HASSTRINGS                              = &H200&
%CBS_NOINTEGRALHEIGHT                        = &H400&
%CBS_DISABLENOSCROLL                         = &H800&
%CBS_UPPERCASE                               = &H2000&

' Combo Box messages
%CB_GETEDITSEL                               = &H140
%CB_LIMITTEXT                                = &H141
%CB_SETEDITSEL                               = &H142
%CB_ADDSTRING                                = &H143
%CB_DELETESTRING                             = &H144
%CB_DIR                                      = &H145
%CB_GETCOUNT                                 = &H146
%CB_GETCURSEL                                = &H147
%CB_GETLBTEXT                                = &H148
%CB_GETLBTEXTLEN                             = &H149
%CB_INSERTSTRING                             = &H14A
%CB_RESETCONTENT                             = &H14B
%CB_FINDSTRING                               = &H14C
%CB_SELECTSTRING                             = &H14D
%CB_SETCURSEL                                = &H14E
%CB_SHOWDROPDOWN                             = &H14F
%CB_GETITEMDATA                              = &H150
%CB_SETITEMDATA                              = &H151
%CB_GETDROPPEDCONTROLRECT                    = &H152
%CB_SETITEMHEIGHT                            = &H153
%CB_GETITEMHEIGHT                            = &H154
%CB_SETEXTENDEDUI                            = &H155
%CB_GETEXTENDEDUI                            = &H156
%CB_GETDROPPEDSTATE                          = &H157
%CB_FINDSTRINGEXACT                          = &H158
%CB_SETLOCALE                                = &H159
%CB_GETLOCALE                                = &H15A
%CB_GETTOPINDEX                              = &H15B
%CB_SETTOPINDEX                              = &H15C
%CB_GETHORIZONTALEXTENT                      = &H15D
%CB_SETHORIZONTALEXTENT                      = &H15E
%CB_GETDROPPEDWIDTH                          = &H15F
%CB_SETDROPPEDWIDTH                          = &H160
%CB_INITSTORAGE                              = &H161
%CB_MSGMAX                                   = &H162

' Scroll Bar Styles
%SBS_HORZ                                    = &H0&
%SBS_VERT                                    = &H1&
%SBS_TOPALIGN                                = &H2&
%SBS_LEFTALIGN                               = &H2&
%SBS_BOTTOMALIGN                             = &H4&
%SBS_RIGHTALIGN                              = &H4&
%SBS_SIZEBOXTOPLEFTALIGN                     = &H2&
%SBS_SIZEBOXBOTTOMRIGHTALIGN                 = &H4&
%SBS_SIZEBOX                                 = &H8&
%SBS_SIZEGRIP                                = &H10&

'  Scroll bar messages
%SBM_SETPOS                                  = &HE0 ' not in win3.1
%SBM_GETPOS                                  = &HE1 ' not in win3.1
%SBM_SETRANGE                                = &HE2 ' not in win3.1
%SBM_SETRANGEREDRAW                          = &HE6 ' not in win3.1
%SBM_GETRANGE                                = &HE3 ' not in win3.1
%SBM_ENABLE_ARROWS                           = &HE4 ' not in win3.1

%MDIS_ALLCHILDSTYLES                         = &H1

' wParam values for WM_MDITILE and WM_MDICASCADE messages.
%MDITILE_VERTICAL                            = &H0
%MDITILE_HORIZONTAL                          = &H1
%MDITILE_SKIPDISABLED                        = &H2

' Commands to pass WinHelp()
%HELP_CONTEXT                                = &H1    '  Display topic in ulTopic
%HELP_QUIT                                   = &H2    '  Terminate help
%HELP_INDEX                                  = &H3    '  Display index
%HELP_CONTENTS                               = &H3&
%HELP_HELPONHELP                             = &H4    '  Display help on using help
%HELP_SETINDEX                               = &H5    '  Set current Index for multi index help
%HELP_SETCONTENTS                            = &H5&
%HELP_CONTEXTPOPUP                           = &H8&
%HELP_FORCEFILE                              = &H9&
%HELP_KEY                                    = &H101  '  Display topic for keyword in offabData
%HELP_COMMAND                                = &H102&
%HELP_PARTIALKEY                             = &H105&
%HELP_MULTIKEY                               = &H201&
%HELP_SETWINPOS                              = &H203&
%HELP_CONTEXTMENU                            = &H000A
%HELP_FINDER                                 = &H000B
%HELP_WM_HELP                                = &H000C
%HELP_SETPOPUP_POS                           = &H000D

%HELP_TCARD                                  = &H8000
%HELP_TCARD_DATA                             = &H0010
%HELP_TCARD_OTHER_CALLER                     = &H0011

' These are in winhelp.h in Win95.
%IDH_NO_HELP                                 = 28440
%IDH_MISSING_CONTEXT                         = 28441 ' Control doesn't have matching help context
%IDH_GENERIC_HELP_BUTTON                     = 28442 ' Property sheet help button
%IDH_OK                                      = 28443
%IDH_CANCEL                                  = 28444
%IDH_HELP                                    = 28445

' Parameter for SystemParametersInfo()
%SPI_GETBEEP                                 = 1
%SPI_SETBEEP                                 = 2
%SPI_GETMOUSE                                = 3
%SPI_SETMOUSE                                = 4
%SPI_GETBORDER                               = 5
%SPI_SETBORDER                               = 6
%SPI_GETKEYBOARDSPEED                        = 10
%SPI_SETKEYBOARDSPEED                        = 11
%SPI_LANGDRIVER                              = 12
%SPI_ICONHORIZONTALSPACING                   = 13
%SPI_GETSCREENSAVETIMEOUT                    = 14
%SPI_SETSCREENSAVETIMEOUT                    = 15
%SPI_GETSCREENSAVEACTIVE                     = 16
%SPI_SETSCREENSAVEACTIVE                     = 17
%SPI_GETGRIDGRANULARITY                      = 18
%SPI_SETGRIDGRANULARITY                      = 19
%SPI_SETDESKWALLPAPER                        = 20
%SPI_SETDESKPATTERN                          = 21
%SPI_GETKEYBOARDDELAY                        = 22
%SPI_SETKEYBOARDDELAY                        = 23
%SPI_ICONVERTICALSPACING                     = 24
%SPI_GETICONTITLEWRAP                        = 25
%SPI_SETICONTITLEWRAP                        = 26
%SPI_GETMENUDROPALIGNMENT                    = 27
%SPI_SETMENUDROPALIGNMENT                    = 28
%SPI_SETDOUBLECLKWIDTH                       = 29
%SPI_SETDOUBLECLKHEIGHT                      = 30
%SPI_GETICONTITLELOGFONT                     = 31
%SPI_SETDOUBLECLICKTIME                      = 32
%SPI_SETMOUSEBUTTONSWAP                      = 33
%SPI_SETICONTITLELOGFONT                     = 34
%SPI_GETFASTTASKSWITCH                       = 35
%SPI_SETFASTTASKSWITCH                       = 36
%SPI_SETDRAGFULLWINDOWS                      = 37
%SPI_GETDRAGFULLWINDOWS                      = 38
%SPI_GETNONCLIENTMETRICS                     = 41
%SPI_SETNONCLIENTMETRICS                     = 42
%SPI_GETMINIMIZEDMETRICS                     = 43
%SPI_SETMINIMIZEDMETRICS                     = 44
%SPI_GETICONMETRICS                          = 45
%SPI_SETICONMETRICS                          = 46
%SPI_SETWORKAREA                             = 47
%SPI_GETWORKAREA                             = 48
%SPI_SETPENWINDOWS                           = 49
%SPI_GETFILTERKEYS                           = 50
%SPI_SETFILTERKEYS                           = 51
%SPI_GETTOGGLEKEYS                           = 52
%SPI_SETTOGGLEKEYS                           = 53
%SPI_GETMOUSEKEYS                            = 54
%SPI_SETMOUSEKEYS                            = 55
%SPI_GETSHOWSOUNDS                           = 56
%SPI_SETSHOWSOUNDS                           = 57
%SPI_GETSTICKYKEYS                           = 58
%SPI_SETSTICKYKEYS                           = 59
%SPI_GETACCESSTIMEOUT                        = 60
%SPI_SETACCESSTIMEOUT                        = 61
%SPI_GETSERIALKEYS                           = 62
%SPI_SETSERIALKEYS                           = 63
%SPI_GETSOUNDSENTRY                          = 64
%SPI_SETSOUNDSENTRY                          = 65
%SPI_GETHIGHCONTRAST                         = 66
%SPI_SETHIGHCONTRAST                         = 67
%SPI_GETKEYBOARDPREF                         = 68
%SPI_SETKEYBOARDPREF                         = 69
%SPI_GETSCREENREADER                         = 70
%SPI_SETSCREENREADER                         = 71
%SPI_GETANIMATION                            = 72
%SPI_SETANIMATION                            = 73
%SPI_GETFONTSMOOTHING                        = 74
%SPI_SETFONTSMOOTHING                        = 75
%SPI_SETDRAGWIDTH                            = 76
%SPI_SETDRAGHEIGHT                           = 77
%SPI_SETHANDHELD                             = 78
%SPI_GETLOWPOWERTIMEOUT                      = 79
%SPI_GETPOWEROFFTIMEOUT                      = 80
%SPI_SETLOWPOWERTIMEOUT                      = 81
%SPI_SETPOWEROFFTIMEOUT                      = 82
%SPI_GETLOWPOWERACTIVE                       = 83
%SPI_GETPOWEROFFACTIVE                       = 84
%SPI_SETLOWPOWERACTIVE                       = 85
%SPI_SETPOWEROFFACTIVE                       = 86
%SPI_SETCURSORS                              = 87
%SPI_SETICONS                                = 88
%SPI_GETDEFAULTINPUTLANG                     = 89
%SPI_SETDEFAULTINPUTLANG                     = 90
%SPI_SETLANGTOGGLE                           = 91
%SPI_GETWINDOWSEXTENSION                     = 92
%SPI_SETMOUSETRAILS                          = 93
%SPI_GETMOUSETRAILS                          = 94
%SPI_SCREENSAVERRUNNING                      = 97
%SPI_SETMOUSEHOVERWIDTH                      = 99
%SPI_GETMOUSEHOVERHEIGHT                     = 100
%SPI_SETMOUSEHOVERHEIGHT                     = 101
%SPI_GETMOUSEHOVERTIME                       = 102
%SPI_SETMOUSEHOVERTIME                       = 103
%SPI_GETWHEELSCROLLLINES                     = 104
%SPI_SETWHEELSCROLLLINES                     = 105
%SPI_GETSHOWIMEUI                            = 110
%SPI_SETSHOWIMEUI                            = 111

%WHEEL_DELTA                                 = 120
%WHEEL_PAGESCROLL                            = &HFFFFFFFF

' SystemParametersInfo flags
%SPIF_UPDATEINIFILE                          = &H1
%SPIF_SENDWININICHANGE                       = &H2

'  DDE window messages
%WM_DDE_FIRST                                = &H3E0
%WM_DDE_INITIATE                             = %WM_DDE_FIRST
%WM_DDE_TERMINATE                            = %WM_DDE_FIRST + 1
%WM_DDE_ADVISE                               = %WM_DDE_FIRST + 2
%WM_DDE_UNADVISE                             = %WM_DDE_FIRST + 3
%WM_DDE_ACK                                  = %WM_DDE_FIRST + 4
%WM_DDE_DATA                                 = %WM_DDE_FIRST + 5
%WM_DDE_REQUEST                              = %WM_DDE_FIRST + 6
%WM_DDE_POKE                                 = %WM_DDE_FIRST + 7
%WM_DDE_EXECUTE                              = %WM_DDE_FIRST + 8
%WM_DDE_LAST                                 = %WM_DDE_FIRST + 8

'  conversation states (usState)
%XST_NULL                                    = 0  '  quiescent states
%XST_INCOMPLETE                              = 1
%XST_CONNECTED                               = 2
%XST_INIT1                                   = 3  '  mid-initiation states
%XST_INIT2                                   = 4
%XST_REQSENT                                 = 5  '  active conversation states
%XST_DATARCVD                                = 6
%XST_POKESENT                                = 7
%XST_POKEACKRCVD                             = 8
%XST_EXECSENT                                = 9
%XST_EXECACKRCVD                             = 10
%XST_ADVSENT                                 = 11
%XST_UNADVSENT                               = 12
%XST_ADVACKRCVD                              = 13
%XST_UNADVACKRCVD                            = 14
%XST_ADVDATASENT                             = 15
%XST_ADVDATAACKRCVD                          = 16

'  used in LOWORD(dwData1) of XTYP_ADVREQ callbacks...
%CADV_LATEACK                                = &HFFFF

'  conversation status bits (fsStatus)
%ST_CONNECTED                                = &H1
%ST_ADVISE                                   = &H2
%ST_ISLOCAL                                  = &H4
%ST_BLOCKED                                  = &H8
%ST_CLIENT                                   = &H10
%ST_TERMINATED                               = &H20
%ST_INLIST                                   = &H40
%ST_BLOCKNEXT                                = &H80
%ST_ISSELF                                   = &H100

'  DDE constants for wStatus field
%DDE_FACK                                    = &H8000
%DDE_FBUSY                                   = &H4000
%DDE_FDEFERUPD                               = &H4000
%DDE_FACKREQ                                 = &H8000
%DDE_FRELEASE                                = &H2000
%DDE_FREQUESTED                              = &H1000
%DDE_FAPPSTATUS                              = &HFF
%DDE_FNOTPROCESSED                           = &H0

%DDE_FACKRESERVED                            = NOT (%DDE_FACK OR %DDE_FBUSY OR %DDE_FAPPSTATUS)
%DDE_FADVRESERVED                            = NOT (%DDE_FACKREQ OR %DDE_FDEFERUPD)
%DDE_FDATRESERVED                            = NOT (%DDE_FACKREQ OR %DDE_FRELEASE OR %DDE_FREQUESTED)
%DDE_FPOKRESERVED                            = NOT (%DDE_FRELEASE)

'  codepage constants
%CP_WINANSI                                  = 1004  '  default codepage for windows old DDE convs.
%CP_WINUNICODE                               = 1200

'  transaction types
%XTYPF_NOBLOCK                               = &H2     '  CBR_BLOCK will not work
%XTYPF_NODATA                                = &H4     '  DDE_FDEFERUPD
%XTYPF_ACKREQ                                = &H8     '  DDE_FACKREQ

%XCLASS_MASK                                 = &HFC00
%XCLASS_BOOL                                 = &H1000
%XCLASS_DATA                                 = &H2000
%XCLASS_FLAGS                                = &H4000
%XCLASS_NOTIFICATION                         = &H8000

%XTYP_ERROR                                  = &H0 OR %XCLASS_NOTIFICATION OR %XTYPF_NOBLOCK
%XTYP_ADVDATA                                = &H10 OR %XCLASS_FLAGS
%XTYP_ADVREQ                                 = &H20 OR %XCLASS_DATA OR %XTYPF_NOBLOCK
%XTYP_ADVSTART                               = &H30 OR %XCLASS_BOOL
%XTYP_ADVSTOP                                = &H40 OR %XCLASS_NOTIFICATION
%XTYP_EXECUTE                                = &H50 OR %XCLASS_FLAGS
%XTYP_CONNECT                                = &H60 OR %XCLASS_BOOL OR %XTYPF_NOBLOCK
%XTYP_CONNECT_CONFIRM                        = &H70 OR %XCLASS_NOTIFICATION OR %XTYPF_NOBLOCK
%XTYP_XACT_COMPLETE                          = &H80 OR %XCLASS_NOTIFICATION
%XTYP_POKE                                   = &H90 OR %XCLASS_FLAGS
%XTYP_REGISTER                               = &HA0 OR %XCLASS_NOTIFICATION OR %XTYPF_NOBLOCK
%XTYP_REQUEST                                = &HB0 OR %XCLASS_DATA
%XTYP_DISCONNECT                             = &HC0 OR %XCLASS_NOTIFICATION OR %XTYPF_NOBLOCK
%XTYP_UNREGISTER                             = &HD0 OR %XCLASS_NOTIFICATION OR %XTYPF_NOBLOCK
%XTYP_WILDCONNECT                            = &HE0 OR %XCLASS_DATA OR %XTYPF_NOBLOCK

%XTYP_MASK                                   = &HF0
%XTYP_SHIFT                                  = 4  '  shift to turn XTYP_ into an index

'  Timeout constants
%TIMEOUT_ASYNC                               = &HFFFF

'  Transaction ID constants
%QID_SYNC                                    = &HFFFF

%CBR_BLOCK                                   = &HFFFF

' Callback filter flags for use with standard apps.
%CBF_FAIL_SELFCONNECTIONS                    = &H1000
%CBF_FAIL_CONNECTIONS                        = &H2000
%CBF_FAIL_ADVISES                            = &H4000
%CBF_FAIL_EXECUTES                           = &H8000
%CBF_FAIL_POKES                              = &H10000
%CBF_FAIL_REQUESTS                           = &H20000
%CBF_FAIL_ALLSVRXACTIONS                     = &H3F000

%CBF_SKIP_CONNECT_CONFIRMS                   = &H40000
%CBF_SKIP_REGISTRATIONS                      = &H80000
%CBF_SKIP_UNREGISTRATIONS                    = &H100000
%CBF_SKIP_DISCONNECTS                        = &H200000
%CBF_SKIP_ALLNOTIFICATIONS                   = &H3C0000

' Application command flags
%APPCMD_CLIENTONLY                           = &H10&
%APPCMD_FILTERINITS                          = &H20&
%APPCMD_MASK                                 = &HFF0&

' Application classification flags
%APPCLASS_STANDARD                           = &H0&
%APPCLASS_MASK                               = &HF&

%EC_ENABLEALL                                = 0
%EC_ENABLEONE                                = %ST_BLOCKNEXT
%EC_DISABLE                                  = %ST_BLOCKED
%EC_QUERYWAITING                             = 2

%DNS_REGISTER                                = &H1
%DNS_UNREGISTER                              = &H2
%DNS_FILTERON                                = &H4
%DNS_FILTEROFF                               = &H8

%HDATA_APPOWNED                              = &H1

%DMLERR_NO_ERROR                             = 0      '  must be 0

%DMLERR_FIRST                                = &H4000

%DMLERR_ADVACKTIMEOUT                        = &H4000
%DMLERR_BUSY                                 = &H4001
%DMLERR_DATAACKTIMEOUT                       = &H4002
%DMLERR_DLL_NOT_INITIALIZED                  = &H4003
%DMLERR_DLL_USAGE                            = &H4004
%DMLERR_EXECACKTIMEOUT                       = &H4005
%DMLERR_INVALIDPARAMETER                     = &H4006
%DMLERR_LOW_MEMORY                           = &H4007
%DMLERR_MEMORY_ERROR                         = &H4008
%DMLERR_NOTPROCESSED                         = &H4009
%DMLERR_NO_CONV_ESTABLISHED                  = &H400A
%DMLERR_POKEACKTIMEOUT                       = &H400B
%DMLERR_POSTMSG_FAILED                       = &H400C
%DMLERR_REENTRANCY                           = &H400D
%DMLERR_SERVER_DIED                          = &H400E
%DMLERR_SYS_ERROR                            = &H400F
%DMLERR_UNADVACKTIMEOUT                      = &H4010
%DMLERR_UNFOUND_QUEUE_ID                     = &H4011

%DMLERR_LAST                                 = &H4011

%MH_CREATE                                   = 1
%MH_KEEP                                     = 2
%MH_DELETE                                   = 3
%MH_CLEANUP                                  = 4

%MAX_MONITORS                                = 4
%APPCLASS_MONITOR                            = &H1&
%XTYP_MONITOR                                = &HF0 OR %XCLASS_NOTIFICATION OR %XTYPF_NOBLOCK

' Callback filter flags for use with MONITOR apps - 0 implies no monitor callbacks
%MF_HSZ_INFO                                 = &H1000000
%MF_SENDMSGS                                 = &H2000000
%MF_POSTMSGS                                 = &H4000000
%MF_CALLBACKS                                = &H8000000
%MF_ERRORS                                   = &H10000000
%MF_LINKS                                    = &H20000000
%MF_CONV                                     = &H40000000

%MF_MASK                                     = &HFF000000

%NO_ERROR                                    = 0 '  dderror

' The configuration registry database operation completed successfully.
%ERROR_SUCCESS                               = 0&

'   Incorrect function.
%ERROR_INVALID_FUNCTION                      = 1& '  dderror
%ERROR_FILE_NOT_FOUND                        = 2&
%ERROR_PATH_NOT_FOUND                        = 3&
%ERROR_TOO_MANY_OPEN_FILES                   = 4&
%ERROR_ACCESS_DENIED                         = 5&
%ERROR_INVALID_HANDLE                        = 6&
%ERROR_ARENA_TRASHED                         = 7&
%ERROR_NOT_ENOUGH_MEMORY                     = 8& '  dderror
%ERROR_INVALID_BLOCK                         = 9&
%ERROR_BAD_ENVIRONMENT                       = 10&
%ERROR_BAD_FORMAT                            = 11&
%ERROR_INVALID_ACCESS                        = 12&
%ERROR_INVALID_DATA                          = 13&
%ERROR_OUTOFMEMORY                           = 14&
%ERROR_INVALID_DRIVE                         = 15&
%ERROR_CURRENT_DIRECTORY                     = 16&
%ERROR_NOT_SAME_DEVICE                       = 17&
%ERROR_NO_MORE_FILES                         = 18&
%ERROR_WRITE_PROTECT                         = 19&
%ERROR_BAD_UNIT                              = 20&
%ERROR_NOT_READY                             = 21&
%ERROR_BAD_COMMAND                           = 22&
%ERROR_CRC                                   = 23&
%ERROR_BAD_LENGTH                            = 24&
%ERROR_SEEK                                  = 25&
%ERROR_NOT_DOS_DISK                          = 26&
%ERROR_SECTOR_NOT_FOUND                      = 27&
%ERROR_OUT_OF_PAPER                          = 28&
%ERROR_WRITE_FAULT                           = 29&
%ERROR_READ_FAULT                            = 30&
%ERROR_GEN_FAILURE                           = 31&
%ERROR_SHARING_VIOLATION                     = 32&
%ERROR_LOCK_VIOLATION                        = 33&
%ERROR_WRONG_DISK                            = 34&
%ERROR_SHARING_BUFFER_EXCEEDED               = 36&
%ERROR_HANDLE_EOF                            = 38&
%ERROR_HANDLE_DISK_FULL                      = 39&
%ERROR_NOT_SUPPORTED                         = 50&
%ERROR_REM_NOT_LIST                          = 51&
%ERROR_DUP_NAME                              = 52&
%ERROR_BAD_NETPATH                           = 53&
%ERROR_NETWORK_BUSY                          = 54&
%ERROR_DEV_NOT_EXIST                         = 55& '  dderror
%ERROR_TOO_MANY_CMDS                         = 56&
%ERROR_ADAP_HDW_ERR                          = 57&
%ERROR_BAD_NET_RESP                          = 58&
%ERROR_UNEXP_NET_ERR                         = 59&
%ERROR_BAD_REM_ADAP                          = 60&
%ERROR_PRINTQ_FULL                           = 61&
%ERROR_NO_SPOOL_SPACE                        = 62&
%ERROR_PRINT_CANCELLED                       = 63&
%ERROR_NETNAME_DELETED                       = 64&
%ERROR_NETWORK_ACCESS_DENIED                 = 65&
%ERROR_BAD_DEV_TYPE                          = 66&
%ERROR_BAD_NET_NAME                          = 67&
%ERROR_TOO_MANY_NAMES                        = 68&
%ERROR_TOO_MANY_SESS                         = 69&
%ERROR_SHARING_PAUSED                        = 70&
%ERROR_REQ_NOT_ACCEP                         = 71&
%ERROR_REDIR_PAUSED                          = 72&
%ERROR_FILE_EXISTS                           = 80&
%ERROR_CANNOT_MAKE                           = 82&
%ERROR_FAIL_I24                              = 83&
%ERROR_OUT_OF_STRUCTURES                     = 84&
%ERROR_ALREADY_ASSIGNED                      = 85&
%ERROR_INVALID_PASSWORD                      = 86&
%ERROR_INVALID_PARAMETER                     = 87& '  dderror
%ERROR_NET_WRITE_FAULT                       = 88&
%ERROR_NO_PROC_SLOTS                         = 89&

%ERROR_TOO_MANY_SEMAPHORES                   = 100&
%ERROR_EXCL_SEM_ALREADY_OWNED                = 101&
%ERROR_SEM_IS_SET                            = 102&
%ERROR_TOO_MANY_SEM_REQUESTS                 = 103&
%ERROR_INVALID_AT_INTERRUPT_TIME             = 104&
%ERROR_SEM_OWNER_DIED                        = 105&
%ERROR_SEM_USER_LIMIT                        = 106&
%ERROR_DISK_CHANGE                           = 107&
%ERROR_DRIVE_LOCKED                          = 108&
%ERROR_BROKEN_PIPE                           = 109&
%ERROR_OPEN_FAILED                           = 110&
%ERROR_BUFFER_OVERFLOW                       = 111&
%ERROR_DISK_FULL                             = 112&
%ERROR_NO_MORE_SEARCH_HANDLES                = 113&
%ERROR_INVALID_TARGET_HANDLE                 = 114&
%ERROR_INVALID_CATEGORY                      = 117&
%ERROR_INVALID_VERIFY_SWITCH                 = 118&
%ERROR_BAD_DRIVER_LEVEL                      = 119&
%ERROR_CALL_NOT_IMPLEMENTED                  = 120&
%ERROR_SEM_TIMEOUT                           = 121&
%ERROR_INSUFFICIENT_BUFFER                   = 122& '  dderror
%ERROR_INVALID_NAME                          = 123&
%ERROR_INVALID_LEVEL                         = 124&
%ERROR_NO_VOLUME_LABEL                       = 125&
%ERROR_MOD_NOT_FOUND                         = 126&
%ERROR_PROC_NOT_FOUND                        = 127&
%ERROR_WAIT_NO_CHILDREN                      = 128&
%ERROR_CHILD_NOT_COMPLETE                    = 129&
%ERROR_DIRECT_ACCESS_HANDLE                  = 130&
%ERROR_NEGATIVE_SEEK                         = 131&
%ERROR_SEEK_ON_DEVICE                        = 132&
%ERROR_IS_JOIN_TARGET                        = 133&
%ERROR_IS_JOINED                             = 134&
%ERROR_IS_SUBSTED                            = 135&
%ERROR_NOT_JOINED                            = 136&
%ERROR_NOT_SUBSTED                           = 137&
%ERROR_JOIN_TO_JOIN                          = 138&
%ERROR_SUBST_TO_SUBST                        = 139&
%ERROR_JOIN_TO_SUBST                         = 140&
%ERROR_SUBST_TO_JOIN                         = 141&
%ERROR_BUSY_DRIVE                            = 142&
%ERROR_SAME_DRIVE                            = 143&
%ERROR_DIR_NOT_ROOT                          = 144&
%ERROR_DIR_NOT_EMPTY                         = 145&
%ERROR_IS_SUBST_PATH                         = 146&
%ERROR_IS_JOIN_PATH                          = 147&
%ERROR_PATH_BUSY                             = 148&
%ERROR_IS_SUBST_TARGET                       = 149&
%ERROR_SYSTEM_TRACE                          = 150&
%ERROR_INVALID_EVENT_COUNT                   = 151&
%ERROR_TOO_MANY_MUXWAITERS                   = 152&
%ERROR_INVALID_LIST_FORMAT                   = 153&
%ERROR_LABEL_TOO_LONG                        = 154&
%ERROR_TOO_MANY_TCBS                         = 155&
%ERROR_SIGNAL_REFUSED                        = 156&
%ERROR_DISCARDED                             = 157&
%ERROR_NOT_LOCKED                            = 158&
%ERROR_BAD_THREADID_ADDR                     = 159&
%ERROR_BAD_ARGUMENTS                         = 160&
%ERROR_BAD_PATHNAME                          = 161&
%ERROR_SIGNAL_PENDING                        = 162&
%ERROR_MAX_THRDS_REACHED                     = 164&
%ERROR_LOCK_FAILED                           = 167&
%ERROR_BUSY                                  = 170&
%ERROR_CANCEL_VIOLATION                      = 173&
%ERROR_ATOMIC_LOCKS_NOT_SUPPORTED            = 174&
%ERROR_INVALID_SEGMENT_NUMBER                = 180&
%ERROR_INVALID_ORDINAL                       = 182&
%ERROR_ALREADY_EXISTS                        = 183&
%ERROR_INVALID_FLAG_NUMBER                   = 186&
%ERROR_SEM_NOT_FOUND                         = 187&
%ERROR_INVALID_STARTING_CODESEG              = 188&
%ERROR_INVALID_STACKSEG                      = 189&
%ERROR_INVALID_MODULETYPE                    = 190&
%ERROR_INVALID_EXE_SIGNATURE                 = 191&
%ERROR_EXE_MARKED_INVALID                    = 192&
%ERROR_BAD_EXE_FORMAT                        = 193&
%ERROR_ITERATED_DATA_EXCEEDS_64k             = 194&
%ERROR_INVALID_MINALLOCSIZE                  = 195&
%ERROR_DYNLINK_FROM_INVALID_RING             = 196&
%ERROR_IOPL_NOT_ENABLED                      = 197&
%ERROR_INVALID_SEGDPL                        = 198&
%ERROR_AUTODATASEG_EXCEEDS_64k               = 199&

%ERROR_RING2SEG_MUST_BE_MOVABLE              = 200&
%ERROR_RELOC_CHAIN_XEEDS_SEGLIM              = 201&
%ERROR_INFLOOP_IN_RELOC_CHAIN                = 202&
%ERROR_ENVVAR_NOT_FOUND                      = 203&
%ERROR_NO_SIGNAL_SENT                        = 205&
%ERROR_FILENAME_EXCED_RANGE                  = 206&
%ERROR_RING2_STACK_IN_USE                    = 207&
%ERROR_META_EXPANSION_TOO_LONG               = 208&
%ERROR_INVALID_SIGNAL_NUMBER                 = 209&
%ERROR_THREAD_1_INACTIVE                     = 210&
%ERROR_LOCKED                                = 212&
%ERROR_TOO_MANY_MODULES                      = 214&
%ERROR_NESTING_NOT_ALLOWED                   = 215&
%ERROR_BAD_PIPE                              = 230&
%ERROR_PIPE_BUSY                             = 231&
%ERROR_NO_DATA                               = 232&
%ERROR_PIPE_NOT_CONNECTED                    = 233&
%ERROR_MORE_DATA                             = 234& '  dderror
%ERROR_VC_DISCONNECTED                       = 240&
%ERROR_INVALID_EA_NAME                       = 254&
%ERROR_EA_LIST_INCONSISTENT                  = 255&
%ERROR_NO_MORE_ITEMS                         = 259&
%ERROR_CANNOT_COPY                           = 266&
%ERROR_DIRECTORY                             = 267&
%ERROR_EAS_DIDNT_FIT                         = 275&
%ERROR_EA_FILE_CORRUPT                       = 276&
%ERROR_EA_TABLE_FULL                         = 277&
%ERROR_INVALID_EA_HANDLE                     = 278&
%ERROR_EAS_NOT_SUPPORTED                     = 282&
%ERROR_NOT_OWNER                             = 288&
%ERROR_TOO_MANY_POSTS                        = 298&

%ERROR_MR_MID_NOT_FOUND                      = 317&

%ERROR_INVALID_ADDRESS                       = 487&

%ERROR_ARITHMETIC_OVERFLOW                   = 534&
%ERROR_PIPE_CONNECTED                        = 535&
%ERROR_PIPE_LISTENING                        = 536&

%ERROR_EA_ACCESS_DENIED                      = 994&
%ERROR_OPERATION_ABORTED                     = 995&
%ERROR_IO_INCOMPLETE                         = 996&
%ERROR_IO_PENDING                            = 997& '  dderror
%ERROR_NOACCESS                              = 998&
%ERROR_SWAPERROR                             = 999&

%ERROR_STACK_OVERFLOW                        = 1001&
%ERROR_INVALID_MESSAGE                       = 1002&
%ERROR_CAN_NOT_COMPLETE                      = 1003&
%ERROR_INVALID_FLAGS                         = 1004&
%ERROR_UNRECOGNIZED_VOLUME                   = 1005&
%ERROR_FILE_INVALID                          = 1006&
%ERROR_FULLSCREEN_MODE                       = 1007&
%ERROR_NO_TOKEN                              = 1008&
%ERROR_BADDB                                 = 1009&
%ERROR_BADKEY                                = 1010&
%ERROR_CANTOPEN                              = 1011&
%ERROR_CANTREAD                              = 1012&
%ERROR_CANTWRITE                             = 1013&
%ERROR_REGISTRY_RECOVERED                    = 1014&
%ERROR_REGISTRY_CORRUPT                      = 1015&
%ERROR_REGISTRY_IO_FAILED                    = 1016&
%ERROR_NOT_REGISTRY_FILE                     = 1017&
%ERROR_KEY_DELETED                           = 1018&
%ERROR_NO_LOG_SPACE                          = 1019&
%ERROR_KEY_HAS_CHILDREN                      = 1020&
%ERROR_CHILD_MUST_BE_VOLATILE                = 1021&
%ERROR_NOTIFY_ENUM_DIR                       = 1022&
%ERROR_DEPENDENT_SERVICES_RUNNING            = 1051&
%ERROR_INVALID_SERVICE_CONTROL               = 1052&
%ERROR_SERVICE_REQUEST_TIMEOUT               = 1053&
%ERROR_SERVICE_NO_THREAD                     = 1054&
%ERROR_SERVICE_DATABASE_LOCKED               = 1055&
%ERROR_SERVICE_ALREADY_RUNNING               = 1056&
%ERROR_INVALID_SERVICE_ACCOUNT               = 1057&
%ERROR_SERVICE_DISABLED                      = 1058&
%ERROR_CIRCULAR_DEPENDENCY                   = 1059&
%ERROR_SERVICE_DOES_NOT_EXIST                = 1060&
%ERROR_SERVICE_CANNOT_ACCEPT_CTRL            = 1061&
%ERROR_SERVICE_NOT_ACTIVE                    = 1062&
%ERROR_FAILED_SERVICE_CONTROLLER_CONNECT     = 1063&
%ERROR_EXCEPTION_IN_SERVICE                  = 1064&
%ERROR_DATABASE_DOES_NOT_EXIST               = 1065&
%ERROR_SERVICE_SPECIFIC_ERROR                = 1066&
%ERROR_PROCESS_ABORTED                       = 1067&
%ERROR_SERVICE_DEPENDENCY_FAIL               = 1068&
%ERROR_SERVICE_LOGON_FAILED                  = 1069&
%ERROR_SERVICE_START_HANG                    = 1070&
%ERROR_INVALID_SERVICE_LOCK                  = 1071&
%ERROR_SERVICE_MARKED_FOR_DELETE             = 1072&
%ERROR_SERVICE_EXISTS                        = 1073&
%ERROR_ALREADY_RUNNING_LKG                   = 1074&
%ERROR_SERVICE_DEPENDENCY_DELETED            = 1075&
%ERROR_BOOT_ALREADY_ACCEPTED                 = 1076&
%ERROR_SERVICE_NEVER_STARTED                 = 1077&
%ERROR_DUPLICATE_SERVICE_NAME                = 1078&
%ERROR_END_OF_MEDIA                          = 1100&
%ERROR_FILEMARK_DETECTED                     = 1101&
%ERROR_BEGINNING_OF_MEDIA                    = 1102&
%ERROR_SETMARK_DETECTED                      = 1103&
%ERROR_NO_DATA_DETECTED                      = 1104&
%ERROR_PARTITION_FAILURE                     = 1105&
%ERROR_INVALID_BLOCK_LENGTH                  = 1106&
%ERROR_DEVICE_NOT_PARTITIONED                = 1107&
%ERROR_UNABLE_TO_LOCK_MEDIA                  = 1108&
%ERROR_UNABLE_TO_UNLOAD_MEDIA                = 1109&
%ERROR_MEDIA_CHANGED                         = 1110&
%ERROR_BUS_RESET                             = 1111&
%ERROR_NO_MEDIA_IN_DRIVE                     = 1112&
%ERROR_NO_UNICODE_TRANSLATION                = 1113&
%ERROR_DLL_INIT_FAILED                       = 1114&
%ERROR_SHUTDOWN_IN_PROGRESS                  = 1115&
%ERROR_NO_SHUTDOWN_IN_PROGRESS               = 1116&
%ERROR_IO_DEVICE                             = 1117&
%ERROR_SERIAL_NO_DEVICE                      = 1118&
%ERROR_IRQ_BUSY                              = 1119&
%ERROR_MORE_WRITES                           = 1120&
%ERROR_COUNTER_TIMEOUT                       = 1121&
%ERROR_FLOPPY_ID_MARK_NOT_FOUND              = 1122&
%ERROR_FLOPPY_WRONG_CYLINDER                 = 1123&
%ERROR_FLOPPY_UNKNOWN_ERROR                  = 1124&
%ERROR_FLOPPY_BAD_REGISTERS                  = 1125&
%ERROR_DISK_RECALIBRATE_FAILED               = 1126&
%ERROR_DISK_OPERATION_FAILED                 = 1127&
%ERROR_DISK_RESET_FAILED                     = 1128&
%ERROR_EOM_OVERFLOW                          = 1129&
%ERROR_NOT_ENOUGH_SERVER_MEMORY              = 1130&
%ERROR_POSSIBLE_DEADLOCK                     = 1131&
%ERROR_MAPPED_ALIGNMENT                      = 1132&

%ERROR_INVALID_PIXEL_FORMAT                  = 2000&
%ERROR_BAD_DRIVER                            = 2001&
%ERROR_INVALID_WINDOW_STYLE                  = 2002&
%ERROR_METAFILE_NOT_SUPPORTED                = 2003&
%ERROR_TRANSFORM_NOT_SUPPORTED               = 2004&
%ERROR_CLIPPING_NOT_SUPPORTED                = 2005&

%ERROR_UNKNOWN_PRINT_MONITOR                 = 3000&
%ERROR_PRINTER_DRIVER_IN_USE                 = 3001&
%ERROR_SPOOL_FILE_NOT_FOUND                  = 3002&
%ERROR_SPL_NO_STARTDOC                       = 3003&
%ERROR_SPL_NO_ADDJOB                         = 3004&
%ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED     = 3005&
%ERROR_PRINT_MONITOR_ALREADY_INSTALLED       = 3006&

%ERROR_WINS_INTERNAL                         = 4000&
%ERROR_CAN_NOT_DEL_LOCAL_WINS                = 4001&
%ERROR_STATIC_INIT                           = 4002&
%ERROR_INC_BACKUP                            = 4003&
%ERROR_FULL_BACKUP                           = 4004&
%ERROR_REC_NON_EXISTENT                      = 4005&
%ERROR_RPL_NOT_ALLOWED                       = 4006&

%SEVERITY_SUCCESS                            = 0
%SEVERITY_ERROR                              = 1
%FACILITY_NT_BIT                             = &H10000000
%NOERROR                                     = 0

%E_UNEXPECTED                                = &H8000FFFF
%E_NOTIMPL                                   = &H80004001
%E_OUTOFMEMORY                               = &H8007000E
%E_INVALIDARG                                = &H80070057
%E_NOINTERFACE                               = &H80004002
%E_POINTER                                   = &H80004003
%E_HANDLE                                    = &H80070006
%E_ABORT                                     = &H80004004
%E_FAIL                                      = &H80004005
%E_ACCESSDENIED                              = &H80070005
%CO_E_INIT_TLS                               = &H80004006
%CO_E_INIT_SHARED_ALLOCATOR                  = &H80004007
%CO_E_INIT_MEMORY_ALLOCATOR                  = &H80004008
%CO_E_INIT_CLASS_CACHE                       = &H80004009
%CO_E_INIT_RPC_CHANNEL                       = &H8000400A
%CO_E_INIT_TLS_SET_CHANNEL_CONTROL           = &H8000400B
%CO_E_INIT_TLS_CHANNEL_CONTROL               = &H8000400C
%CO_E_INIT_UNACCEPTED_USER_ALLOCATOR         = &H8000400D
%CO_E_INIT_SCM_MUTEX_EXISTS                  = &H8000400E
%CO_E_INIT_SCM_FILE_MAPPING_EXISTS           = &H8000400F
%CO_E_INIT_SCM_MAP_VIEW_OF_FILE              = &H80004010
%CO_E_INIT_SCM_EXEC_FAILURE                  = &H80004011
%CO_E_INIT_ONLY_SINGLE_THREADED              = &H80004012
%S_OK                                        = &H0
%S_FALSE                                     = &H1
%OLE_E_FIRST                                 = &H80040000
%OLE_E_LAST                                  = &H800400FF
%OLE_S_FIRST                                 = &H40000
%OLE_S_LAST                                  = &H400FF
%OLE_E_OLEVERB                               = &H80040000
%OLE_E_ADVF                                  = &H80040001
%OLE_E_ENUM_NOMORE                           = &H80040002
%OLE_E_ADVISENOTSUPPORTED                    = &H80040003
%OLE_E_NOCONNECTION                          = &H80040004
%OLE_E_NOTRUNNING                            = &H80040005
%OLE_E_NOCACHE                               = &H80040006
%OLE_E_BLANK                                 = &H80040007
%OLE_E_CLASSDIFF                             = &H80040008
%OLE_E_CANT_GETMONIKER                       = &H80040009
%OLE_E_CANT_BINDTOSOURCE                     = &H8004000A
%OLE_E_STATIC                                = &H8004000B
%OLE_E_PROMPTSAVECANCELLED                   = &H8004000C
%OLE_E_INVALIDRECT                           = &H8004000D
%OLE_E_WRONGCOMPOBJ                          = &H8004000E
%OLE_E_INVALIDHWND                           = &H8004000F
%OLE_E_NOT_INPLACEACTIVE                     = &H80040010
%OLE_E_CANTCONVERT                           = &H80040011
%OLE_E_NOSTORAGE                             = &H80040012
%DV_E_FORMATETC                              = &H80040064
%DV_E_DVTARGETDEVICE                         = &H80040065
%DV_E_STGMEDIUM                              = &H80040066
%DV_E_STATDATA                               = &H80040067
%DV_E_LINDEX                                 = &H80040068
%DV_E_TYMED                                  = &H80040069
%DV_E_CLIPFORMAT                             = &H8004006A
%DV_E_DVASPECT                               = &H8004006B
%DV_E_DVTARGETDEVICE_SIZE                    = &H8004006C
%DV_E_NOIVIEWOBJECT                          = &H8004006D
%DRAGDROP_E_FIRST                            = &H80040100
%DRAGDROP_E_LAST                             = &H8004010F
%DRAGDROP_S_FIRST                            = &H40100
%DRAGDROP_S_LAST                             = &H4010F
%DRAGDROP_E_NOTREGISTERED                    = &H80040100
%DRAGDROP_E_ALREADYREGISTERED                = &H80040101
%DRAGDROP_E_INVALIDHWND                      = &H80040102
%CLASSFACTORY_E_FIRST                        = &H80040110
%CLASSFACTORY_E_LAST                         = &H8004011F
%CLASSFACTORY_S_FIRST                        = &H40110
%CLASSFACTORY_S_LAST                         = &H4011F
%CLASS_E_NOAGGREGATION                       = &H80040110
%CLASS_E_CLASSNOTAVAILABLE                   = &H80040111
%MARSHAL_E_FIRST                             = &H80040120
%MARSHAL_E_LAST                              = &H8004012F
%MARSHAL_S_FIRST                             = &H40120
%MARSHAL_S_LAST                              = &H4012F
%DATA_E_FIRST                                = &H80040130
%DATA_E_LAST                                 = &H8004013F
%DATA_S_FIRST                                = &H40130
%DATA_S_LAST                                 = &H4013F
%VIEW_E_FIRST                                = &H80040140
%VIEW_E_LAST                                 = &H8004014F
%VIEW_S_FIRST                                = &H40140
%VIEW_S_LAST                                 = &H4014F
%VIEW_E_DRAW                                 = &H80040140
%REGDB_E_FIRST                               = &H80040150
%REGDB_E_LAST                                = &H8004015F
%REGDB_S_FIRST                               = &H40150
%REGDB_S_LAST                                = &H4015F
%REGDB_E_READREGDB                           = &H80040150
%REGDB_E_WRITEREGDB                          = &H80040151
%REGDB_E_KEYMISSING                          = &H80040152
%REGDB_E_INVALIDVALUE                        = &H80040153
%REGDB_E_CLASSNOTREG                         = &H80040154
%REGDB_E_IIDNOTREG                           = &H80040155
%CACHE_E_FIRST                               = &H80040170
%CACHE_E_LAST                                = &H8004017F
%CACHE_S_FIRST                               = &H40170
%CACHE_S_LAST                                = &H4017F
%CACHE_E_NOCACHE_UPDATED                     = &H80040170
%OLEOBJ_E_FIRST                              = &H80040180
%OLEOBJ_E_LAST                               = &H8004018F
%OLEOBJ_S_FIRST                              = &H40180
%OLEOBJ_S_LAST                               = &H4018F
%OLEOBJ_E_NOVERBS                            = &H80040180
%OLEOBJ_E_INVALIDVERB                        = &H80040181
%CLIENTSITE_E_FIRST                          = &H80040190
%CLIENTSITE_E_LAST                           = &H8004019F
%CLIENTSITE_S_FIRST                          = &H40190
%CLIENTSITE_S_LAST                           = &H4019F
%INPLACE_E_NOTUNDOABLE                       = &H800401A0
%INPLACE_E_NOTOOLSPACE                       = &H800401A1
%INPLACE_E_FIRST                             = &H800401A0
%INPLACE_E_LAST                              = &H800401AF
%INPLACE_S_FIRST                             = &H401A0
%INPLACE_S_LAST                              = &H401AF
%ENUM_E_FIRST                                = &H800401B0
%ENUM_E_LAST                                 = &H800401BF
%ENUM_S_FIRST                                = &H401B0
%ENUM_S_LAST                                 = &H401BF
%CONVERT10_E_FIRST                           = &H800401C0
%CONVERT10_E_LAST                            = &H800401CF
%CONVERT10_S_FIRST                           = &H401C0
%CONVERT10_S_LAST                            = &H401CF
%CONVERT10_E_OLESTREAM_GET                   = &H800401C0
%CONVERT10_E_OLESTREAM_PUT                   = &H800401C1
%CONVERT10_E_OLESTREAM_FMT                   = &H800401C2
%CONVERT10_E_OLESTREAM_BITMAP_TO_DIB         = &H800401C3
%CONVERT10_E_STG_FMT                         = &H800401C4
%CONVERT10_E_STG_NO_STD_STREAM               = &H800401C5
%CONVERT10_E_STG_DIB_TO_BITMAP               = &H800401C6
%CLIPBRD_E_FIRST                             = &H800401D0
%CLIPBRD_E_LAST                              = &H800401DF
%CLIPBRD_S_FIRST                             = &H401D0
%CLIPBRD_S_LAST                              = &H401DF
%CLIPBRD_E_CANT_OPEN                         = &H800401D0
%CLIPBRD_E_CANT_EMPTY                        = &H800401D1
%CLIPBRD_E_CANT_SET                          = &H800401D2
%CLIPBRD_E_BAD_DATA                          = &H800401D3
%CLIPBRD_E_CANT_CLOSE                        = &H800401D4
%MK_E_FIRST                                  = &H800401E0
%MK_E_LAST                                   = &H800401EF
%MK_S_FIRST                                  = &H401E0
%MK_S_LAST                                   = &H401EF
%MK_E_CONNECTMANUALLY                        = &H800401E0
%MK_E_EXCEEDEDDEADLINE                       = &H800401E1
%MK_E_NEEDGENERIC                            = &H800401E2
%MK_E_UNAVAILABLE                            = &H800401E3
%MK_E_SYNTAX                                 = &H800401E4
%MK_E_NOOBJECT                               = &H800401E5
%MK_E_INVALIDEXTENSION                       = &H800401E6
%MK_E_INTERMEDIATEINTERFACENOTSUPPORTED      = &H800401E7
%MK_E_NOTBINDABLE                            = &H800401E8
%MK_E_NOTBOUND                               = &H800401E9
%MK_E_CANTOPENFILE                           = &H800401EA
%MK_E_MUSTBOTHERUSER                         = &H800401EB
%MK_E_NOINVERSE                              = &H800401EC
%MK_E_NOSTORAGE                              = &H800401ED
%MK_E_NOPREFIX                               = &H800401EE
%MK_E_ENUMERATION_FAILED                     = &H800401EF
%CO_E_FIRST                                  = &H800401F0
%CO_E_LAST                                   = &H800401FF
%CO_S_FIRST                                  = &H401F0
%CO_S_LAST                                   = &H401FF
%CO_E_NOTINITIALIZED                         = &H800401F0
%CO_E_ALREADYINITIALIZED                     = &H800401F1
%CO_E_CANTDETERMINECLASS                     = &H800401F2
%CO_E_CLASSSTRING                            = &H800401F3
%CO_E_IIDSTRING                              = &H800401F4
%CO_E_APPNOTFOUND                            = &H800401F5
%CO_E_APPSINGLEUSE                           = &H800401F6
%CO_E_ERRORINAPP                             = &H800401F7
%CO_E_DLLNOTFOUND                            = &H800401F8
%CO_E_ERRORINDLL                             = &H800401F9
%CO_E_WRONGOSFORAPP                          = &H800401FA
%CO_E_OBJNOTREG                              = &H800401FB
%CO_E_OBJISREG                               = &H800401FC
%CO_E_OBJNOTCONNECTED                        = &H800401FD
%CO_E_APPDIDNTREG                            = &H800401FE
%CO_E_RELEASED                               = &H800401FF
%OLE_S_USEREG                                = &H40000
%OLE_S_STATIC                                = &H40001
%OLE_S_MAC_CLIPFORMAT                        = &H40002
%DRAGDROP_S_DROP                             = &H40100
%DRAGDROP_S_CANCEL                           = &H40101
%DRAGDROP_S_USEDEFAULTCURSORS                = &H40102
%DATA_S_SAMEFORMATETC                        = &H40130
%VIEW_S_ALREADY_FROZEN                       = &H40140
%CACHE_S_FORMATETC_NOTSUPPORTED              = &H40170
%CACHE_S_SAMECACHE                           = &H40171
%CACHE_S_SOMECACHES_NOTUPDATED               = &H40172
%OLEOBJ_S_INVALIDVERB                        = &H40180
%OLEOBJ_S_CANNOT_DOVERB_NOW                  = &H40181
%OLEOBJ_S_INVALIDHWND                        = &H40182
%INPLACE_S_TRUNCATED                         = &H401A0
%CONVERT10_S_NO_PRESENTATION                 = &H401C0
%MK_S_REDUCED_TO_SELF                        = &H401E2
%MK_S_ME                                     = &H401E4
%MK_S_HIM                                    = &H401E5
%MK_S_US                                     = &H401E6
%MK_S_MONIKERALREADYREGISTERED               = &H401E7
%CO_E_CLASS_CREATE_FAILED                    = &H80080001
%CO_E_SCM_ERROR                              = &H80080002
%CO_E_SCM_RPC_FAILURE                        = &H80080003
%CO_E_BAD_PATH                               = &H80080004
%CO_E_SERVER_EXEC_FAILURE                    = &H80080005
%CO_E_OBJSRV_RPC_FAILURE                     = &H80080006
%MK_E_NO_NORMALIZED                          = &H80080007
%CO_E_SERVER_STOPPING                        = &H80080008
%MEM_E_INVALID_ROOT                          = &H80080009
%MEM_E_INVALID_LINK                          = &H80080010
%MEM_E_INVALID_SIZE                          = &H80080011
%DISP_E_UNKNOWNINTERFACE                     = &H80020001
%DISP_E_MEMBERNOTFOUND                       = &H80020003
%DISP_E_PARAMNOTFOUND                        = &H80020004
%DISP_E_TYPEMISMATCH                         = &H80020005
%DISP_E_UNKNOWNNAME                          = &H80020006
%DISP_E_NONAMEDARGS                          = &H80020007
%DISP_E_BADVARTYPE                           = &H80020008
%DISP_E_EXCEPTION                            = &H80020009
%DISP_E_OVERFLOW                             = &H8002000A
%DISP_E_BADINDEX                             = &H8002000B
%DISP_E_UNKNOWNLCID                          = &H8002000C
%DISP_E_ARRAYISLOCKED                        = &H8002000D
%DISP_E_BADPARAMCOUNT                        = &H8002000E
%DISP_E_PARAMNOTOPTIONAL                     = &H8002000F
%DISP_E_BADCALLEE                            = &H80020010
%DISP_E_NOTACOLLECTION                       = &H80020011
%TYPE_E_BUFFERTOOSMALL                       = &H80028016
%TYPE_E_INVDATAREAD                          = &H80028018
%TYPE_E_UNSUPFORMAT                          = &H80028019
%TYPE_E_REGISTRYACCESS                       = &H8002801C
%TYPE_E_LIBNOTREGISTERED                     = &H8002801D
%TYPE_E_UNDEFINEDTYPE                        = &H80028027
%TYPE_E_QUALIFIEDNAMEDISALLOWED              = &H80028028
%TYPE_E_INVALIDSTATE                         = &H80028029
%TYPE_E_WRONGTYPEKIND                        = &H8002802A
%TYPE_E_ELEMENTNOTFOUND                      = &H8002802B
%TYPE_E_AMBIGUOUSNAME                        = &H8002802C
%TYPE_E_NAMECONFLICT                         = &H8002802D
%TYPE_E_UNKNOWNLCID                          = &H8002802E
%TYPE_E_DLLFUNCTIONNOTFOUND                  = &H8002802F
%TYPE_E_BADMODULEKIND                        = &H800288BD
%TYPE_E_SIZETOOBIG                           = &H800288C5
%TYPE_E_DUPLICATEID                          = &H800288C6
%TYPE_E_INVALIDID                            = &H800288CF
%TYPE_E_TYPEMISMATCH                         = &H80028CA0
%TYPE_E_OUTOFBOUNDS                          = &H80028CA1
%TYPE_E_IOERROR                              = &H80028CA2
%TYPE_E_CANTCREATETMPFILE                    = &H80028CA3
%TYPE_E_CANTLOADLIBRARY                      = &H80029C4A
%TYPE_E_INCONSISTENTPROPFUNCS                = &H80029C83
%TYPE_E_CIRCULARTYPE                         = &H80029C84
%STG_E_INVALIDFUNCTION                       = &H80030001
%STG_E_FILENOTFOUND                          = &H80030002
%STG_E_PATHNOTFOUND                          = &H80030003
%STG_E_TOOMANYOPENFILES                      = &H80030004
%STG_E_ACCESSDENIED                          = &H80030005
%STG_E_INVALIDHANDLE                         = &H80030006
%STG_E_INSUFFICIENTMEMORY                    = &H80030008
%STG_E_INVALIDPOINTER                        = &H80030009
%STG_E_NOMOREFILES                           = &H80030012
%STG_E_DISKISWRITEPROTECTED                  = &H80030013
%STG_E_SEEKERROR                             = &H80030019
%STG_E_WRITEFAULT                            = &H8003001D
%STG_E_READFAULT                             = &H8003001E
%STG_E_SHAREVIOLATION                        = &H80030020
%STG_E_LOCKVIOLATION                         = &H80030021
%STG_E_FILEALREADYEXISTS                     = &H80030050
%STG_E_INVALIDPARAMETER                      = &H80030057
%STG_E_MEDIUMFULL                            = &H80030070
%STG_E_ABNORMALAPIEXIT                       = &H800300FA
%STG_E_INVALIDHEADER                         = &H800300FB
%STG_E_INVALIDNAME                           = &H800300FC
%STG_E_UNKNOWN                               = &H800300FD
%STG_E_UNIMPLEMENTEDFUNCTION                 = &H800300FE
%STG_E_INVALIDFLAG                           = &H800300FF
%STG_E_INUSE                                 = &H80030100
%STG_E_NOTCURRENT                            = &H80030101
%STG_E_REVERTED                              = &H80030102
%STG_E_CANTSAVE                              = &H80030103
%STG_E_OLDFORMAT                             = &H80030104
%STG_E_OLDDLL                                = &H80030105
%STG_E_SHAREREQUIRED                         = &H80030106
%STG_E_NOTFILEBASEDSTORAGE                   = &H80030107
%STG_E_EXTANTMARSHALLINGS                    = &H80030108
%STG_S_CONVERTED                             = &H30200
%RPC_E_CALL_REJECTED                         = &H80010001
%RPC_E_CALL_CANCELED                         = &H80010002
%RPC_E_CANTPOST_INSENDCALL                   = &H80010003
%RPC_E_CANTCALLOUT_INASYNCCALL               = &H80010004
%RPC_E_CANTCALLOUT_INEXTERNALCALL            = &H80010005
%RPC_E_CONNECTION_TERMINATED                 = &H80010006
%RPC_E_SERVER_DIED                           = &H80010007
%RPC_E_CLIENT_DIED                           = &H80010008
%RPC_E_INVALID_DATAPACKET                    = &H80010009
%RPC_E_CANTTRANSMIT_CALL                     = &H8001000A
%RPC_E_CLIENT_CANTMARSHAL_DATA               = &H8001000B
%RPC_E_CLIENT_CANTUNMARSHAL_DATA             = &H8001000C
%RPC_E_SERVER_CANTMARSHAL_DATA               = &H8001000D
%RPC_E_SERVER_CANTUNMARSHAL_DATA             = &H8001000E
%RPC_E_INVALID_DATA                          = &H8001000F
%RPC_E_INVALID_PARAMETER                     = &H80010010
%RPC_E_CANTCALLOUT_AGAIN                     = &H80010011
%RPC_E_SERVER_DIED_DNE                       = &H80010012
%RPC_E_SYS_CALL_FAILED                       = &H80010100
%RPC_E_OUT_OF_RESOURCES                      = &H80010101
%RPC_E_ATTEMPTED_MULTITHREAD                 = &H80010102
%RPC_E_NOT_REGISTERED                        = &H80010103
%RPC_E_FAULT                                 = &H80010104
%RPC_E_SERVERFAULT                           = &H80010105
%RPC_E_CHANGED_MODE                          = &H80010106
%RPC_E_INVALIDMETHOD                         = &H80010107
%RPC_E_DISCONNECTED                          = &H80010108
%RPC_E_RETRY                                 = &H80010109
%RPC_E_SERVERCALL_RETRYLATER                 = &H8001010A
%RPC_E_SERVERCALL_REJECTED                   = &H8001010B
%RPC_E_INVALID_CALLDATA                      = &H8001010C
%RPC_E_CANTCALLOUT_ININPUTSYNCCALL           = &H8001010D
%RPC_E_WRONG_THREAD                          = &H8001010E
%RPC_E_THREAD_NOT_INIT                       = &H8001010F
%RPC_E_UNEXPECTED                            = &H8001FFFF


' -------------------------
'
'  Winnet32 Status Codes
'                       
' -------------------------

'   The specified username is invalid.
%ERROR_BAD_USERNAME                          = 2202&

'   This network connection does not exist.
%ERROR_NOT_CONNECTED                         = 2250&

'   This network connection has files open or requests pending.
%ERROR_OPEN_FILES                            = 2401&

'   The device is in use by an active process and cannot be disconnected.
%ERROR_DEVICE_IN_USE                         = 2404&

'   The specified device name is invalid.
%ERROR_BAD_DEVICE                            = 1200&

'   The device is not currently connected but it is a remembered connection.
%ERROR_CONNECTION_UNAVAIL                    = 1201&

'   An attempt was made to remember a device that had previously been remembered.
%ERROR_DEVICE_ALREADY_REMEMBERED             = 1202&

'   No network provider accepted the given network path.
%ERROR_NO_NET_OR_BAD_PATH                    = 1203&

'   The specified network provider name is invalid.
%ERROR_BAD_PROVIDER                          = 1204&

'   Unable to open the network connection profile.
%ERROR_CANNOT_OPEN_PROFILE                   = 1205&

'   The network connection profile is corrupt.
%ERROR_BAD_PROFILE                           = 1206&

'   Cannot enumerate a non-container.
%ERROR_NOT_CONTAINER                         = 1207&

'   An extended error has occurred.
%ERROR_EXTENDED_ERROR                        = 1208&

'   The format of the specified group name is invalid.
%ERROR_INVALID_GROUPNAME                     = 1209&

'   The format of the specified computer name is invalid.
%ERROR_INVALID_COMPUTERNAME                  = 1210&

'   The format of the specified event name is invalid.
%ERROR_INVALID_EVENTNAME                     = 1211&

'   The format of the specified domain name is invalid.
%ERROR_INVALID_DOMAINNAME                    = 1212&

'   The format of the specified service name is invalid.
%ERROR_INVALID_SERVICENAME                   = 1213&

'   The format of the specified network name is invalid.
%ERROR_INVALID_NETNAME                       = 1214&

'   The format of the specified share name is invalid.
%ERROR_INVALID_SHARENAME                     = 1215&

'   The format of the specified password is invalid.
%ERROR_INVALID_PASSWORDNAME                  = 1216&

'   The format of the specified message name is invalid.
%ERROR_INVALID_MESSAGENAME                   = 1217&

'   The format of the specified message destination is invalid.
%ERROR_INVALID_MESSAGEDEST                   = 1218&

'   The credentials supplied conflict with an existing set of credentials.
%ERROR_SESSION_CREDENTIAL_CONFLICT           = 1219&

'   An attempt was made to establish a session to a Lan Manager server, but there
'   are already too many sessions established to that server.
%ERROR_REMOTE_SESSION_LIMIT_EXCEEDED         = 1220&

'   The workgroup or domain name is already in use by another computer on the
'   network.
%ERROR_DUP_DOMAINNAME                        = 1221&

'   The network is not present or not started.
%ERROR_NO_NETWORK                            = 1222&


' -------------------------
'
'  Security Status Codes
'
' -------------------------

'   Not all privileges referenced are assigned to the caller.
%ERROR_NOT_ALL_ASSIGNED                      = 1300&

'   Some mapping between account names and security IDs was not done.
%ERROR_SOME_NOT_MAPPED                       = 1301&

'   No system quota limits are specifically set for this account.
%ERROR_NO_QUOTAS_FOR_ACCOUNT                 = 1302&

'   No encryption key is available.  A well-known encryption key was returned.
%ERROR_LOCAL_USER_SESSION_KEY                = 1303&

'   The NT password is too complex to be converted to a LAN Manager
'   password.  The LAN Manager password returned is a NULL string.
%ERROR_NULL_LM_PASSWORD                      = 1304&

'   The revision level is unknown.
%ERROR_UNKNOWN_REVISION                      = 1305&

'   Indicates two revision levels are incompatible.
%ERROR_REVISION_MISMATCH                     = 1306&

'   This security ID may not be assigned as the owner of this object.
%ERROR_INVALID_OWNER                         = 1307&

'   This security ID may not be assigned as the primary group of an object.
%ERROR_INVALID_PRIMARY_GROUP                 = 1308&

'   An attempt has been made to operate on an impersonation token
'   by a thread that is not currently impersonating a client.
%ERROR_NO_IMPERSONATION_TOKEN                = 1309&

'   The group may not be disabled.
%ERROR_CANT_DISABLE_MANDATORY                = 1310&

'   There are currently no logon servers available to service the logon
'   request.
%ERROR_NO_LOGON_SERVERS                      = 1311&

'    A specified logon session does not exist.  It may already have
'    been terminated.
%ERROR_NO_SUCH_LOGON_SESSION                 = 1312&

'    A specified privilege does not exist.
%ERROR_NO_SUCH_PRIVILEGE                     = 1313&

'    A required privilege is not held by the client.
%ERROR_PRIVILEGE_NOT_HELD                    = 1314&

'   The name provided is not a properly formed account name.
%ERROR_INVALID_ACCOUNT_NAME                  = 1315&

'   The specified user already exists.
%ERROR_USER_EXISTS                           = 1316&

'   The specified user does not exist.
%ERROR_NO_SUCH_USER                          = 1317&

'   The specified group already exists.
%ERROR_GROUP_EXISTS                          = 1318&

'   The specified group does not exist.
%ERROR_NO_SUCH_GROUP                         = 1319&

'   Either the specified user account is already a member of the specified
'   group, or the specified group cannot be deleted because it contains
'   a member.
%ERROR_MEMBER_IN_GROUP                       = 1320&

'   The specified user account is not a member of the specified group account.
%ERROR_MEMBER_NOT_IN_GROUP                   = 1321&

'   The last remaining administration account cannot be disabled
'   or deleted.
%ERROR_LAST_ADMIN                            = 1322&

'   Unable to update the password.  The value provided as the current
'   password is incorrect.
%ERROR_WRONG_PASSWORD                        = 1323&

'   Unable to update the password.  The value provided for the new password
'   contains values that are not allowed in passwords.
%ERROR_ILL_FORMED_PASSWORD                   = 1324&

'   Unable to update the password because a password update rule has been
'   violated.
%ERROR_PASSWORD_RESTRICTION                  = 1325&

'   Logon failure: unknown user name or bad password.
%ERROR_LOGON_FAILURE                         = 1326&

'   Logon failure: user account restriction.
%ERROR_ACCOUNT_RESTRICTION                   = 1327&

'   Logon failure: account logon time restriction violation.
%ERROR_INVALID_LOGON_HOURS                   = 1328&

'   Logon failure: user not allowed to log on to this computer.
%ERROR_INVALID_WORKSTATION                   = 1329&

'   Logon failure: the specified account password has expired.
%ERROR_PASSWORD_EXPIRED                      = 1330&

'   Logon failure: account currently disabled.
%ERROR_ACCOUNT_DISABLED                      = 1331&

'   No mapping between account names and security IDs was done.
%ERROR_NONE_MAPPED                           = 1332&

'   Too many local user identifiers (LUIDs) were requested at one time.
%ERROR_TOO_MANY_LUIDS_REQUESTED              = 1333&

'   No more local user identifiers (LUIDs) are available.
%ERROR_LUIDS_EXHAUSTED                       = 1334&

'   The subauthority part of a security ID is invalid for this particular use.
%ERROR_INVALID_SUB_AUTHORITY                 = 1335&

'   The access control list (ACL) structure is invalid.
%ERROR_INVALID_ACL                           = 1336&

'   The security ID structure is invalid.
%ERROR_INVALID_SID                           = 1337&

'   The security descriptor structure is invalid.
%ERROR_INVALID_SECURITY_DESCR                = 1338&

'   The inherited access control list (ACL) or access control entry (ACE)
'   could not be built.
%ERROR_BAD_INHERITANCE_ACL                   = 1340&

'   The server is currently disabled.
%ERROR_SERVER_DISABLED                       = 1341&

'   The server is currently enabled.
%ERROR_SERVER_NOT_DISABLED                   = 1342&

'   The value provided was an invalid value for an identifier authority.
%ERROR_INVALID_ID_AUTHORITY                  = 1343&

'   No more memory is available for security information updates.
%ERROR_ALLOTTED_SPACE_EXCEEDED               = 1344&

'   The specified attributes are invalid, or incompatible with the
'   attributes for the group as a whole.
%ERROR_INVALID_GROUP_ATTRIBUTES              = 1345&

'   Either a required impersonation level was not provided, or the
'   provided impersonation level is invalid.
%ERROR_BAD_IMPERSONATION_LEVEL               = 1346&

'   Cannot open an anonymous level security token.
%ERROR_CANT_OPEN_ANONYMOUS                   = 1347&

'   The validation information class requested was invalid.
%ERROR_BAD_VALIDATION_CLASS                  = 1348&

'   The type of the token is inappropriate for its attempted use.
%ERROR_BAD_TOKEN_TYPE                        = 1349&

'   Unable to perform a security operation on an object
'   which has no associated security.
%ERROR_NO_SECURITY_ON_OBJECT                 = 1350&

'   Indicates a Windows NT Advanced Server could not be contacted or that
'   objects within the domain are protected such that necessary
'   information could not be retrieved.
%ERROR_CANT_ACCESS_DOMAIN_INFO               = 1351&

'   The security account manager (SAM) or local security
'   authority (LSA) server was in the wrong state to perform
'   the security operation.
%ERROR_INVALID_SERVER_STATE                  = 1352&

'   The domain was in the wrong state to perform the security operation.
%ERROR_INVALID_DOMAIN_STATE                  = 1353&

'   This operation is only allowed for the Primary Domain Controller of the domain.
%ERROR_INVALID_DOMAIN_ROLE                   = 1354&

'   The specified domain did not exist.
%ERROR_NO_SUCH_DOMAIN                        = 1355&

'   The specified domain already exists.
%ERROR_DOMAIN_EXISTS                         = 1356&

'   An attempt was made to exceed the limit on the number of domains per server.
%ERROR_DOMAIN_LIMIT_EXCEEDED                 = 1357&

'   Unable to complete the requested operation because of either a
'   catastrophic media failure or a data structure corruption on the disk.
%ERROR_INTERNAL_DB_CORRUPTION                = 1358&

'   The security account database contains an internal inconsistency.
%ERROR_INTERNAL_ERROR                        = 1359&

'   Generic access types were contained in an access mask which should
'   already be mapped to non-generic types.
%ERROR_GENERIC_NOT_MAPPED                    = 1360&

'   A security descriptor is not in the right format (absolute or self-relative).
%ERROR_BAD_DESCRIPTOR_FORMAT                 = 1361&

'   The requested action is restricted for use by logon processes
'   only.  The calling process has not registered as a logon process.
%ERROR_NOT_LOGON_PROCESS                     = 1362&

'   Cannot start a new logon session with an ID that is already in use.
%ERROR_LOGON_SESSION_EXISTS                  = 1363&

'   A specified authentication package is unknown.
%ERROR_NO_SUCH_PACKAGE                       = 1364&

'   The logon session is not in a state that is consistent with the
'   requested operation.
%ERROR_BAD_LOGON_SESSION_STATE               = 1365&

'   The logon session ID is already in use.
%ERROR_LOGON_SESSION_COLLISION               = 1366&

'   A logon request contained an invalid logon type value.
%ERROR_INVALID_LOGON_TYPE                    = 1367&

'   Unable to impersonate via a named pipe until data has been read
'   from that pipe.
%ERROR_CANNOT_IMPERSONATE                    = 1368&

'   The transaction state of a Registry subtree is incompatible with the
'   requested operation.
%ERROR_RXACT_INVALID_STATE                   = 1369&

'   An internal security database corruption has been encountered.
%ERROR_RXACT_COMMIT_FAILURE                  = 1370&

'   Cannot perform this operation on built-in accounts.
%ERROR_SPECIAL_ACCOUNT                       = 1371&

'   Cannot perform this operation on this built-in special group.
%ERROR_SPECIAL_GROUP                         = 1372&

'   Cannot perform this operation on this built-in special user.
%ERROR_SPECIAL_USER                          = 1373&

'   The user cannot be removed from a group because the group
'   is currently the user's primary group.
%ERROR_MEMBERS_PRIMARY_GROUP                 = 1374&

'   The token is already in use as a primary token.
%ERROR_TOKEN_ALREADY_IN_USE                  = 1375&

'   The specified local group does not exist.
%ERROR_NO_SUCH_ALIAS                         = 1376&

'   The specified account name is not a member of the local group.
%ERROR_MEMBER_NOT_IN_ALIAS                   = 1377&

'   The specified account name is already a member of the local group.
%ERROR_MEMBER_IN_ALIAS                       = 1378&

'   The specified local group already exists.
%ERROR_ALIAS_EXISTS                          = 1379&

'   Logon failure: the user has not been granted the requested
'   logon type at this computer.
%ERROR_LOGON_NOT_GRANTED                     = 1380&

'   The maximum number of secrets that may be stored in a single system has been
'   exceeded.
%ERROR_TOO_MANY_SECRETS                      = 1381&

'   The length of a secret exceeds the maximum length allowed.
%ERROR_SECRET_TOO_LONG                       = 1382&

'   The local security authority database contains an internal inconsistency.
%ERROR_INTERNAL_DB_ERROR                     = 1383&

'   During a logon attempt, the user's security context accumulated too many
'   security IDs.
%ERROR_TOO_MANY_CONTEXT_IDS                  = 1384&

'   Logon failure: the user has not been granted the requested logon type
'   at this computer.
%ERROR_LOGON_TYPE_NOT_GRANTED                = 1385&

'   A cross-encrypted password is necessary to change a user password.
%ERROR_NT_CROSS_ENCRYPTION_REQUIRED          = 1386&

'   A new member could not be added to a local group because the member does
'   not exist.
%ERROR_NO_SUCH_MEMBER                        = 1387&

'   A new member could not be added to a local group because the member has the
'   wrong account type.
%ERROR_INVALID_MEMBER                        = 1388&

'   Too many security IDs have been specified.
%ERROR_TOO_MANY_SIDS                         = 1389&

'   A cross-encrypted password is necessary to change this user password.
%ERROR_LM_CROSS_ENCRYPTION_REQUIRED          = 1390&

'   Indicates an ACL contains no inheritable components
%ERROR_NO_INHERITANCE                        = 1391&

'   The file or directory is corrupt and non-readable.
%ERROR_FILE_CORRUPT                          = 1392&

'   The disk structure is corrupt and non-readable.
%ERROR_DISK_CORRUPT                          = 1393&

'   There is no user session key for the specified logon session.
%ERROR_NO_USER_SESSION_KEY                   = 1394&

'  End of security error codes


' -------------------------
'
'  WinUser Error Codes  
'
' -------------------------

'   Invalid window handle.
%ERROR_INVALID_WINDOW_HANDLE                 = 1400&

'   Invalid menu handle.
%ERROR_INVALID_MENU_HANDLE                   = 1401&

'   Invalid cursor handle.
%ERROR_INVALID_CURSOR_HANDLE                 = 1402&

'   Invalid accelerator table handle.
%ERROR_INVALID_ACCEL_HANDLE                  = 1403&

'   Invalid hook handle.
%ERROR_INVALID_HOOK_HANDLE                   = 1404&

'   Invalid xHandle to a multiple-window position structure.
%ERROR_INVALID_DWP_HANDLE                    = 1405&

'   Cannot create a top-level child window.
%ERROR_TLW_WITH_WSCHILD                      = 1406&

'   Cannot find window class.
%ERROR_CANNOT_FIND_WND_CLASS                 = 1407&

'   Invalid window, belongs to other thread.
%ERROR_WINDOW_OF_OTHER_THREAD                = 1408&

'   Hot key is already registered.
%ERROR_HOTKEY_ALREADY_REGISTERED             = 1409&

'   Class already exists.
%ERROR_CLASS_ALREADY_EXISTS                  = 1410&

'   Class does not exist.
%ERROR_CLASS_DOES_NOT_EXIST                  = 1411&

'   Class still has open windows.
%ERROR_CLASS_HAS_WINDOWS                     = 1412&

'   Invalid index.
%ERROR_INVALID_INDEX                         = 1413&

'   Invalid icon handle.
%ERROR_INVALID_ICON_HANDLE                   = 1414&

'   Using private DIALOG window words.
%ERROR_PRIVATE_DIALOG_INDEX                  = 1415&

'   The listbox identifier was not found.
%ERROR_LISTBOX_ID_NOT_FOUND                  = 1416&

'   No wildcards were found.
%ERROR_NO_WILDCARD_CHARACTERS                = 1417&

'   Thread does not have a clipboard open.
%ERROR_CLIPBOARD_NOT_OPEN                    = 1418&

'   Hot key is not registered.
%ERROR_HOTKEY_NOT_REGISTERED                 = 1419&

'   The window is not a valid dialog window.
%ERROR_WINDOW_NOT_DIALOG                     = 1420&

'   Control ID not found.
%ERROR_CONTROL_ID_NOT_FOUND                  = 1421&

'   Invalid message for a combo box because it does not have an edit control.
%ERROR_INVALID_COMBOBOX_MESSAGE              = 1422&

'   The window is not a combo box.
%ERROR_WINDOW_NOT_COMBOBOX                   = 1423&

'   Height must be less than 256.
%ERROR_INVALID_EDIT_HEIGHT                   = 1424&

'   Invalid device context (DC) handle.
%ERROR_DC_NOT_FOUND                          = 1425&

'   Invalid hook procedure type.
%ERROR_INVALID_HOOK_FILTER                   = 1426&

'   Invalid hook procedure.
%ERROR_INVALID_FILTER_PROC                   = 1427&

'   Cannot set non-local hook without a module handle.
%ERROR_HOOK_NEEDS_HMOD                       = 1428&

'   This hook procedure can only be set Globally.
'
%ERROR_PUBLIC_ONLY_HOOK                      = 1429&

'   The journal hook procedure is already installed.
%ERROR_JOURNAL_HOOK_SET                      = 1430&

'   The hook procedure is not installed.
%ERROR_HOOK_NOT_INSTALLED                    = 1431&

'   Invalid message for single-selection listbox.
%ERROR_INVALID_LB_MESSAGE                    = 1432&

'   LB_SETCOUNT sent to non-lazy listbox.
%ERROR_SETCOUNT_ON_BAD_LB                    = 1433&

'   This list box does not support tab stops.
%ERROR_LB_WITHOUT_TABSTOPS                   = 1434&

'   Cannot destroy object created by another thread.
%ERROR_DESTROY_OBJECT_OF_OTHER_THREAD        = 1435&

'   Child windows cannot have menus.
%ERROR_CHILD_WINDOW_MENU                     = 1436&

'   The window does not have a system menu.
%ERROR_NO_SYSTEM_MENU                        = 1437&

'   Invalid message box style.
%ERROR_INVALID_MSGBOX_STYLE                  = 1438&

'   Invalid system-wide (SPI_) parameter.
%ERROR_INVALID_SPI_VALUE                     = 1439&

'   Screen already locked.
%ERROR_SCREEN_ALREADY_LOCKED                 = 1440&

'   All handles to windows in a multiple-window position structure must
'   have the same parent.
%ERROR_HWNDS_HAVE_DIFF_PARENT                = 1441&

'   The window is not a child window.
%ERROR_NOT_CHILD_WINDOW                      = 1442&

'   Invalid GW_ command.
%ERROR_INVALID_GW_COMMAND                    = 1443&

'   Invalid thread identifier.
%ERROR_INVALID_THREAD_ID                     = 1444&

'   Cannot process a message from a window that is not a multiple document
'   interface (MDI) window.
%ERROR_NON_MDICHILD_WINDOW                   = 1445&

'   Popup menu already active.
%ERROR_POPUP_ALREADY_ACTIVE                  = 1446&

'   The window does not have scroll bars.
%ERROR_NO_SCROLLBARS                         = 1447&

'   Scroll bar range cannot be greater than &H7FFF.
%ERROR_INVALID_SCROLLBAR_RANGE               = 1448&

'   Cannot show or remove the window in the way specified.
%ERROR_INVALID_SHOWWIN_COMMAND               = 1449&

'  End of WinUser error codes


' -------------------------
'                       
'  Eventlog Status Codes
'
' -------------------------

'   The event log file is corrupt.
%ERROR_EVENTLOG_FILE_CORRUPT                 = 1500&

'   No event log file could be opened, so the event logging service did not start.
%ERROR_EVENTLOG_CANT_START                   = 1501&

'   The event log file is full.
%ERROR_LOG_FILE_FULL                         = 1502&

'   The event log file has changed between reads.
%ERROR_EVENTLOG_FILE_CHANGED                 = 1503&

'  End of eventlog error codes


' -------------------------
'                       
'    RPC Status Codes
'                       
' -------------------------

'   The string binding is invalid.
%RPC_S_INVALID_STRING_BINDING                = 1700&

'   The binding xHandle is not the correct type.
%RPC_S_WRONG_KIND_OF_BINDING                 = 1701&

'   The binding xHandle is invalid.
%RPC_S_INVALID_BINDING                       = 1702&

'   The RPC protocol sequence is not supported.
%RPC_S_PROTSEQ_NOT_SUPPORTED                 = 1703&

'   The RPC protocol sequence is invalid.
%RPC_S_INVALID_RPC_PROTSEQ                   = 1704&

'   The string universal unique identifier (UUID) is invalid.
%RPC_S_INVALID_STRING_UUID                   = 1705&

'   The endpoint format is invalid.
%RPC_S_INVALID_ENDPOINT_FORMAT               = 1706&

'   The network address is invalid.
%RPC_S_INVALID_NET_ADDR                      = 1707&

'   No endpoint was found.
%RPC_S_NO_ENDPOINT_FOUND                     = 1708&

'   The timeout value is invalid.
%RPC_S_INVALID_TIMEOUT                       = 1709&

'   The object universal unique identifier (UUID) was not found.
%RPC_S_OBJECT_NOT_FOUND                      = 1710&

'   The object universal unique identifier (UUID) has already been registered.
%RPC_S_ALREADY_REGISTERED                    = 1711&

'   The type universal unique identifier (UUID) has already been registered.
%RPC_S_TYPE_ALREADY_REGISTERED               = 1712&

'   The RPC server is already listening.
%RPC_S_ALREADY_LISTENING                     = 1713&

'   No protocol sequences have been registered.
%RPC_S_NO_PROTSEQS_REGISTERED                = 1714&

'   The RPC server is not listening.
%RPC_S_NOT_LISTENING                         = 1715&

'   The manager type is unknown.
%RPC_S_UNKNOWN_MGR_TYPE                      = 1716&

'   The interface is unknown.
%RPC_S_UNKNOWN_IF                            = 1717&

'   There are no bindings.
%RPC_S_NO_BINDINGS                           = 1718&

'   There are no protocol sequences.
%RPC_S_NO_PROTSEQS                           = 1719&

'   The endpoint cannot be created.
%RPC_S_CANT_CREATE_ENDPOINT                  = 1720&

'   Not enough resources are available to complete this operation.
%RPC_S_OUT_OF_RESOURCES                      = 1721&

'   The RPC server is unavailable.
%RPC_S_SERVER_UNAVAILABLE                    = 1722&

'   The RPC server is too busy to complete this operation.
%RPC_S_SERVER_TOO_BUSY                       = 1723&

'   The network options are invalid.
%RPC_S_INVALID_NETWORK_OPTIONS               = 1724&

'   There is not a remote procedure call active in this thread.
%RPC_S_NO_CALL_ACTIVE                        = 1725&

'   The remote procedure call failed.
%RPC_S_CALL_FAILED                           = 1726&

'   The remote procedure call failed and did not execute.
%RPC_S_CALL_FAILED_DNE                       = 1727&

'   A remote procedure call (RPC) protocol error occurred.
%RPC_S_PROTOCOL_ERROR                        = 1728&

'   The transfer syntax is not supported by the RPC server.
%RPC_S_UNSUPPORTED_TRANS_SYN                 = 1730&

'   The universal unique identifier (UUID) type is not supported.
%RPC_S_UNSUPPORTED_TYPE                      = 1732&

'   The tag is invalid.
%RPC_S_INVALID_TAG                           = 1733&

'   The array bounds are invalid.
%RPC_S_INVALID_BOUND                         = 1734&

'   The binding does not contain an entry name.
%RPC_S_NO_ENTRY_NAME                         = 1735&

'   The name syntax is invalid.
%RPC_S_INVALID_NAME_SYNTAX                   = 1736&

'   The name syntax is not supported.
%RPC_S_UNSUPPORTED_NAME_SYNTAX               = 1737&

'   No network address is available to use to construct a universal
'   unique identifier (UUID).
%RPC_S_UUID_NO_ADDRESS                       = 1739&

'   The endpoint is a duplicate.
%RPC_S_DUPLICATE_ENDPOINT                    = 1740&

'   The authentication type is unknown.
%RPC_S_UNKNOWN_AUTHN_TYPE                    = 1741&

'   The maximum number of calls is too small.
%RPC_S_MAX_CALLS_TOO_SMALL                   = 1742&

'   The string is too long.
%RPC_S_STRING_TOO_LONG                       = 1743&

'   The RPC protocol sequence was not found.
%RPC_S_PROTSEQ_NOT_FOUND                     = 1744&

'   The procedure number is out of range.
%RPC_S_PROCNUM_OUT_OF_RANGE                  = 1745&

'   The binding does not contain any authentication information.
%RPC_S_BINDING_HAS_NO_AUTH                   = 1746&

'   The authentication service is unknown.
%RPC_S_UNKNOWN_AUTHN_SERVICE                 = 1747&

'   The authentication level is unknown.
%RPC_S_UNKNOWN_AUTHN_LEVEL                   = 1748&

'   The security context is invalid.
%RPC_S_INVALID_AUTH_IDENTITY                 = 1749&

'   The authorization service is unknown.
%RPC_S_UNKNOWN_AUTHZ_SERVICE                 = 1750&

'   The entry is invalid.
%EPT_S_INVALID_ENTRY                         = 1751&

'   The server endpoint cannot perform the operation.
%EPT_S_CANT_PERFORM_OP                       = 1752&

'   There are no more endpoints available from the endpoint mapper.
%EPT_S_NOT_REGISTERED                        = 1753&

'   No interfaces have been exported.
%RPC_S_NOTHING_TO_EXPORT                     = 1754&

'   The entry name is incomplete.
%RPC_S_INCOMPLETE_NAME                       = 1755&

'   The version option is invalid.
%RPC_S_INVALID_VERS_OPTION                   = 1756&

'   There are no more members.
%RPC_S_NO_MORE_MEMBERS                       = 1757&

'   There is nothing to unexport.
%RPC_S_NOT_ALL_OBJS_UNEXPORTED               = 1758&

'   The interface was not found.
%RPC_S_INTERFACE_NOT_FOUND                   = 1759&

'   The entry already exists.
%RPC_S_ENTRY_ALREADY_EXISTS                  = 1760&

'   The entry is not found.
%RPC_S_ENTRY_NOT_FOUND                       = 1761&

'   The name service is unavailable.
%RPC_S_NAME_SERVICE_UNAVAILABLE              = 1762&

'   The network address family is invalid.
%RPC_S_INVALID_NAF_ID                        = 1763&

'   The requested operation is not supported.
%RPC_S_CANNOT_SUPPORT                        = 1764&

'   No security context is available to allow impersonation.
%RPC_S_NO_CONTEXT_AVAILABLE                  = 1765&

'   An internal error occurred in a remote procedure call (RPC).
%RPC_S_INTERNAL_ERROR                        = 1766&

'   The RPC server attempted an integer division by zero.'
%RPC_S_ZERO_DIVIDE                           = 1767&

'   An addressing error occurred in the RPC server.
%RPC_S_ADDRESS_ERROR                         = 1768&

'   A floating-point operation at the RPC server caused a division by zero.
%RPC_S_FP_DIV_ZERO                           = 1769&

'   A floating-point underflow occurred at the RPC server.
%RPC_S_FP_UNDERFLOW                          = 1770&

'   A floating-point overflow occurred at the RPC server.
%RPC_S_FP_OVERFLOW                           = 1771&

'   The list of RPC servers available for the binding of auto handles
'   has been exhausted.
%RPC_X_NO_MORE_ENTRIES                       = 1772&

'   Unable to open the character translation table file.
%RPC_X_SS_CHAR_TRANS_OPEN_FAIL               = 1773&

'   The file containing the character translation table has fewer than
'   512 bytes.
%RPC_X_SS_CHAR_TRANS_SHORT_FILE              = 1774&

'   A null context xHandle was passed from the client to the host during
'   a remote procedure call.
%RPC_X_SS_IN_NULL_CONTEXT                    = 1775&

'   The context xHandle changed during a remote procedure call.
%RPC_X_SS_CONTEXT_DAMAGED                    = 1777&

'   The binding handles passed to a remote procedure call do not match.
%RPC_X_SS_HANDLES_MISMATCH                   = 1778&

'   The stub is unable to get the remote procedure call handle.
%RPC_X_SS_CANNOT_GET_CALL_HANDLE             = 1779&

'   A null reference pointer was passed to the stub.
%RPC_X_NULL_REF_POINTER                      = 1780&

'   The enumeration value is out of range.
%RPC_X_ENUM_VALUE_OUT_OF_RANGE               = 1781&

'   The byte count is too small.
%RPC_X_BYTE_COUNT_TOO_SMALL                  = 1782&

'   The stub received bad data.
%RPC_X_BAD_STUB_DATA                         = 1783&

'   The supplied user buffer is not valid for the requested operation.
%ERROR_INVALID_USER_BUFFER                   = 1784&

'   The disk media is not recognized.  It may not be formatted.
%ERROR_UNRECOGNIZED_MEDIA                    = 1785&

'   The workstation does not have a trust secret.
%ERROR_NO_TRUST_LSA_SECRET                   = 1786&

'   The SAM database on the Windows NT Advanced Server does not have a computer
'   account for this workstation trust relationship.
%ERROR_NO_TRUST_SAM_ACCOUNT                  = 1787&

'   The trust relationship between the primary domain and the trusted
'   domain failed.
%ERROR_TRUSTED_DOMAIN_FAILURE                = 1788&

'   The trust relationship between this workstation and the primary
'   domain failed.
%ERROR_TRUSTED_RELATIONSHIP_FAILURE          = 1789&

'   The network logon failed.
%ERROR_TRUST_FAILURE                         = 1790&

'   A remote procedure call is already in progress for this thread.
%RPC_S_CALL_IN_PROGRESS                      = 1791&

'   An attempt was made to logon, but the network logon service was not started.
%ERROR_NETLOGON_NOT_STARTED                  = 1792&

'   The user's account has expired.
%ERROR_ACCOUNT_EXPIRED                       = 1793&

'   The redirector is in use and cannot be unloaded.
%ERROR_REDIRECTOR_HAS_OPEN_HANDLES           = 1794&

'   The specified printer driver is already installed.
%ERROR_PRINTER_DRIVER_ALREADY_INSTALLED      = 1795&

'   The specified port is unknown.
%ERROR_UNKNOWN_PORT                          = 1796&

'   The printer driver is unknown.
%ERROR_UNKNOWN_PRINTER_DRIVER                = 1797&

'   The print processor is unknown.
'
%ERROR_UNKNOWN_PRINTPROCESSOR                = 1798&

'   The specified separator file is invalid.
%ERROR_INVALID_SEPARATOR_FILE                = 1799&

'   The specified priority is invalid.
%ERROR_INVALID_PRIORITY                      = 1800&

'   The printer name is invalid.
%ERROR_INVALID_PRINTER_NAME                  = 1801&

'   The printer already exists.
%ERROR_PRINTER_ALREADY_EXISTS                = 1802&

'   The printer command is invalid.
%ERROR_INVALID_PRINTER_COMMAND               = 1803&

'   The specified datatype is invalid.
%ERROR_INVALID_DATATYPE                      = 1804&

'   The Environment specified is invalid.
%ERROR_INVALID_ENVIRONMENT                   = 1805&

'   There are no more bindings.
%RPC_S_NO_MORE_BINDINGS                      = 1806&

'   The account used is an interdomain trust account.  Use your Global user account or local user account to access this server.
%ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT     = 1807&

'   The account used is a Computer Account.  Use your Global user account or local user account to access this server.
%ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT     = 1808&

'   The account used is an server trust account.  Use your Global user account or local user account to access this server.
%ERROR_NOLOGON_SERVER_TRUST_ACCOUNT          = 1809&

'   The name or security ID (SID) of the domain specified is inconsistent
'   with the trust information for that domain.
%ERROR_DOMAIN_TRUST_INCONSISTENT             = 1810&

'   The server is in use and cannot be unloaded.
%ERROR_SERVER_HAS_OPEN_HANDLES               = 1811&

'   The specified image file did not contain a resource section.
%ERROR_RESOURCE_DATA_NOT_FOUND               = 1812&

'   The specified resource type can not be found in the image file.
%ERROR_RESOURCE_TYPE_NOT_FOUND               = 1813&

'   The specified resource name can not be found in the image file.
%ERROR_RESOURCE_NAME_NOT_FOUND               = 1814&

'   The specified resource language ID cannot be found in the image file.
%ERROR_RESOURCE_LANG_NOT_FOUND               = 1815&

'   Not enough quota is available to process this command.
%ERROR_NOT_ENOUGH_QUOTA                      = 1816&

'   The group member was not found.
%RPC_S_GROUP_MEMBER_NOT_FOUND                = 1898&

'   The endpoint mapper database could not be created.
%EPT_S_CANT_CREATE                           = 1899&

'   The object universal unique identifier (UUID) is the nil UUID.
%RPC_S_INVALID_OBJECT                        = 1900&

'   The specified time is invalid.
%ERROR_INVALID_TIME                          = 1901&

'   The specified Form name is invalid.
%ERROR_INVALID_FORM_NAME                     = 1902&

'   The specified Form size is invalid
%ERROR_INVALID_FORM_SIZE                     = 1903&

'   The specified Printer xHandle is already being waited on
%ERROR_ALREADY_WAITING                       = 1904&

'   The specified Printer has been deleted
%ERROR_PRINTER_DELETED                       = 1905&

'   The state of the Printer is invalid
%ERROR_INVALID_PRINTER_STATE                 = 1906&

'   The list of servers for this workgroup is not currently available
%ERROR_NO_BROWSER_SERVERS_FOUND              = 6118&


' -------------------------
'  MMSystem Section
' -------------------------

' This section defines all the support for Multimedia applications

'  general constants
%MAXPNAMELEN                                 = 32  '  max product name length (including NULL)
%MAXERRORLENGTH                              = 128  '  max error text length (including final NULL)

'  values for wType field in MMTIME struct
%TIME_MS                                     = &H1     '  time in Milliseconds
%TIME_SAMPLES                                = &H2     '  number of wave samples
%TIME_BYTES                                  = &H4     '  current byte offset
%TIME_SMPTE                                  = &H8     '  SMPTE time
%TIME_MIDI                                   = &H10    '  MIDI time

%MAX_JOYSTICKOEMVXDNAME                      = 260

'  Multimedia Window Messages
%MM_JOY1MOVE                                 = &H3A0  '  joystick
%MM_JOY2MOVE                                 = &H3A1
%MM_JOY1ZMOVE                                = &H3A2
%MM_JOY2ZMOVE                                = &H3A3
%MM_JOY1BUTTONDOWN                           = &H3B5
%MM_JOY2BUTTONDOWN                           = &H3B6
%MM_JOY1BUTTONUP                             = &H3B7
%MM_JOY2BUTTONUP                             = &H3B8

%MM_MCINOTIFY                                = &H3B9  '  MCI
%MM_MCISYSTEM_STRING                         = &H3CA

%MM_WOM_OPEN                                 = &H3BB  '  waveform output
%MM_WOM_CLOSE                                = &H3BC
%MM_WOM_DONE                                 = &H3BD

%MM_WIM_OPEN                                 = &H3BE  '  waveform input
%MM_WIM_CLOSE                                = &H3BF
%MM_WIM_DATA                                 = &H3C0

%MM_MIM_OPEN                                 = &H3C1  '  MIDI input
%MM_MIM_CLOSE                                = &H3C2
%MM_MIM_DATA                                 = &H3C3
%MM_MIM_LONGDATA                             = &H3C4
%MM_MIM_ERROR                                = &H3C5
%MM_MIM_LONGERROR                            = &H3C6

%MM_MOM_OPEN                                 = &H3C7  '  MIDI output
%MM_MOM_CLOSE                                = &H3C8
%MM_MOM_DONE                                 = &H3C9

' String resource number bases (internal use)

%MMSYSERR_BASE                               = 0
%WAVERR_BASE                                 = 32
%MIDIERR_BASE                                = 64
%TIMERR_BASE                                 = 96   '  was 128, changed to match Win 31 Sonic
%JOYERR_BASE                                 = 160
%MCIERR_BASE                                 = 256

%MCI_STRING_OFFSET                           = 512  '  if this number is changed you MUST
'  alter the MCI_DEVTYPE_... list below
%MCI_VD_OFFSET                               = 1024
%MCI_CD_OFFSET                               = 1088
%MCI_WAVE_OFFSET                             = 1152
%MCI_SEQ_OFFSET                              = 1216

' General error return values
%MMSYSERR_NOERROR                            = 0  '  no error
%MMSYSERR_ERROR                              = %MMSYSERR_BASE + 1  '  unspecified error
%MMSYSERR_BADDEVICEID                        = %MMSYSERR_BASE + 2  '  device ID out of range
%MMSYSERR_NOTENABLED                         = %MMSYSERR_BASE + 3  '  driver failed enable
%MMSYSERR_ALLOCATED                          = %MMSYSERR_BASE + 4  '  device already allocated
%MMSYSERR_INVALHANDLE                        = %MMSYSERR_BASE + 5  '  device xHandle is invalid
%MMSYSERR_NODRIVER                           = %MMSYSERR_BASE + 6  '  no device driver present
%MMSYSERR_NOMEM                              = %MMSYSERR_BASE + 7  '  memory allocation error
%MMSYSERR_NOTSUPPORTED                       = %MMSYSERR_BASE + 8  '  function isn't supported
%MMSYSERR_BADERRNUM                          = %MMSYSERR_BASE + 9  '  error value out of range
%MMSYSERR_INVALFLAG                          = %MMSYSERR_BASE + 10 '  invalid flag passed
%MMSYSERR_INVALPARAM                         = %MMSYSERR_BASE + 11 '  invalid parameter passed
%MMSYSERR_HANDLEBUSY                         = %MMSYSERR_BASE + 12 '  xHandle being used
'  simultaneously on another
'  thread (eg callback)
%MMSYSERR_INVALIDALIAS                       = %MMSYSERR_BASE + 13 '  "Specified alias not found in WIN.INI
%MMSYSERR_LASTERROR                          = %MMSYSERR_BASE + 13 '  last error in range
%MM_MOM_POSITIONCB                           = &H3CA              '  Callback for MEVT_POSITIONCB
%MM_MCISIGNAL                                = &H3CB
%MM_MIM_MOREDATA                             = &H3CC                '  MIM_DONE w/ pending events
%MIDICAPS_STREAM                             = &H8               '  driver supports midiStreamOut directly

%MEVT_F_SHORT                                = &H0&
%MEVT_F_LONG                                 = &H80000000
%MEVT_F_CALLBACK                             = &H40000000
%MIDISTRM_ERROR                              = -2

'
'  Structures and defines for midiStreamProperty
'
%MIDIPROP_SET                                = &H80000000
%MIDIPROP_GET                                = &H40000000

'  These are intentionally both non-zero so the app cannot accidentally
'  leave the operation off and happen to appear to work due to default
'  action.

%MIDIPROP_TIMEDIV                            = &H1&
%MIDIPROP_TEMPO                              = &H2&

%MIXER_SHORT_NAME_CHARS                      = 16
%MIXER_LONG_NAME_CHARS                       = 64

'
'   MMRESULT error return values specific to the mixer API
'
'
%MIXERR_BASE                                 = 1024
%MIXERR_INVALLINE                            = %MIXERR_BASE + 0
%MIXERR_INVALCONTROL                         = %MIXERR_BASE + 1
%MIXERR_INVALVALUE                           = %MIXERR_BASE + 2
%MIXERR_LASTERROR                            = %MIXERR_BASE + 2


%MIXER_OBJECTF_HANDLE                        = &H80000000
%MIXER_OBJECTF_MIXER                         = &H0&
%MIXER_OBJECTF_HMIXER                        = %MIXER_OBJECTF_HANDLE OR %MIXER_OBJECTF_MIXER
%MIXER_OBJECTF_WAVEOUT                       = &H10000000
%MIXER_OBJECTF_HWAVEOUT                      = %MIXER_OBJECTF_HANDLE OR %MIXER_OBJECTF_WAVEOUT
%MIXER_OBJECTF_WAVEIN                        = &H20000000
%MIXER_OBJECTF_HWAVEIN                       = %MIXER_OBJECTF_HANDLE OR %MIXER_OBJECTF_WAVEIN
%MIXER_OBJECTF_MIDIOUT                       = &H30000000
%MIXER_OBJECTF_HMIDIOUT                      = %MIXER_OBJECTF_HANDLE OR %MIXER_OBJECTF_MIDIOUT
%MIXER_OBJECTF_MIDIIN                        = &H40000000
%MIXER_OBJECTF_HMIDIIN                       = %MIXER_OBJECTF_HANDLE OR %MIXER_OBJECTF_MIDIIN
%MIXER_OBJECTF_AUX                           = &H50000000

%MIXERLINE_LINEF_ACTIVE                      = &H1&
%MIXERLINE_LINEF_DISCONNECTED                = &H8000&
%MIXERLINE_LINEF_SOURCE                      = &H80000000

'   MIXERLINE.dwComponentType

'   component types for destinations and sources

%MIXERLINE_COMPONENTTYPE_DST_FIRST           = &H0&
%MIXERLINE_COMPONENTTYPE_DST_UNDEFINED       = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 0
%MIXERLINE_COMPONENTTYPE_DST_DIGITAL         = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 1
%MIXERLINE_COMPONENTTYPE_DST_LINE            = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 2
%MIXERLINE_COMPONENTTYPE_DST_MONITOR         = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 3
%MIXERLINE_COMPONENTTYPE_DST_SPEAKERS        = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 4
%MIXERLINE_COMPONENTTYPE_DST_HEADPHONES      = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 5
%MIXERLINE_COMPONENTTYPE_DST_TELEPHONE       = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 6
%MIXERLINE_COMPONENTTYPE_DST_WAVEIN          = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 7
%MIXERLINE_COMPONENTTYPE_DST_VOICEIN         = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 8
%MIXERLINE_COMPONENTTYPE_DST_LAST            = %MIXERLINE_COMPONENTTYPE_DST_FIRST + 8

%MIXERLINE_COMPONENTTYPE_SRC_FIRST           = &H1000&
%MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED       = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 0
%MIXERLINE_COMPONENTTYPE_SRC_DIGITAL         = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1
%MIXERLINE_COMPONENTTYPE_SRC_LINE            = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2
%MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE      = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3
%MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER     = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4
%MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC     = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5
%MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE       = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6
%MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER       = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7
%MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT         = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8
%MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY       = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9
%MIXERLINE_COMPONENTTYPE_SRC_ANALOG          = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10
%MIXERLINE_COMPONENTTYPE_SRC_LAST            = %MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10


'
'   MIXERLINE.Target.dwType
'
'
%MIXERLINE_TARGETTYPE_UNDEFINED              = 0
%MIXERLINE_TARGETTYPE_WAVEOUT                = 1
%MIXERLINE_TARGETTYPE_WAVEIN                 = 2
%MIXERLINE_TARGETTYPE_MIDIOUT                = 3
%MIXERLINE_TARGETTYPE_MIDIIN                 = 4
%MIXERLINE_TARGETTYPE_AUX                    = 5

%MIXER_GETLINEINFOF_DESTINATION              = &H0&
%MIXER_GETLINEINFOF_SOURCE                   = &H1&
%MIXER_GETLINEINFOF_LINEID                   = &H2&
%MIXER_GETLINEINFOF_COMPONENTTYPE            = &H3&
%MIXER_GETLINEINFOF_TARGETTYPE               = &H4&
%MIXER_GETLINEINFOF_QUERYMASK                = &HF&

%MIXERCONTROL_CONTROLF_UNIFORM               = &H1&
%MIXERCONTROL_CONTROLF_MULTIPLE              = &H2&
%MIXERCONTROL_CONTROLF_DISABLED              = &H80000000

'   MIXERCONTROL_CONTROLTYPE_xxx building block defines

%MIXERCONTROL_CT_CLASS_MASK                  = &HF0000000
%MIXERCONTROL_CT_CLASS_CUSTOM                = &H0&
%MIXERCONTROL_CT_CLASS_METER                 = &H10000000
%MIXERCONTROL_CT_CLASS_SWITCH                = &H20000000
%MIXERCONTROL_CT_CLASS_NUMBER                = &H30000000
%MIXERCONTROL_CT_CLASS_SLIDER                = &H40000000
%MIXERCONTROL_CT_CLASS_FADER                 = &H50000000
%MIXERCONTROL_CT_CLASS_TIME                  = &H60000000
%MIXERCONTROL_CT_CLASS_LIST                  = &H70000000
%MIXERCONTROL_CT_SUBCLASS_MASK               = &HF000000
%MIXERCONTROL_CT_SC_SWITCH_BOOLEAN           = &H0&
%MIXERCONTROL_CT_SC_SWITCH_BUTTON            = &H1000000
%MIXERCONTROL_CT_SC_METER_POLLED             = &H0&
%MIXERCONTROL_CT_SC_TIME_MICROSECS           = &H0&
%MIXERCONTROL_CT_SC_TIME_MILLISECS           = &H1000000
%MIXERCONTROL_CT_SC_LIST_SINGLE              = &H0&
%MIXERCONTROL_CT_SC_LIST_MULTIPLE            = &H1000000
%MIXERCONTROL_CT_UNITS_MASK                  = &HFF0000
%MIXERCONTROL_CT_UNITS_CUSTOM                = &H0&
%MIXERCONTROL_CT_UNITS_BOOLEAN               = &H10000
%MIXERCONTROL_CT_UNITS_SIGNED                = &H20000
%MIXERCONTROL_CT_UNITS_UNSIGNED              = &H30000
%MIXERCONTROL_CT_UNITS_DECIBELS              = &H40000 '  in 10ths
%MIXERCONTROL_CT_UNITS_PERCENT               = &H50000 '  in 10ths
'
'   Commonly used control types for specifying MIXERCONTROL.dwControlType
'
%MIXERCONTROL_CONTROLTYPE_CUSTOM             = %MIXERCONTROL_CT_CLASS_CUSTOM OR %MIXERCONTROL_CT_UNITS_CUSTOM
%MIXERCONTROL_CONTROLTYPE_BOOLEANMETER       = %MIXERCONTROL_CT_CLASS_METER OR %MIXERCONTROL_CT_SC_METER_POLLED OR %MIXERCONTROL_CT_UNITS_BOOLEAN
%MIXERCONTROL_CONTROLTYPE_SIGNEDMETER        = %MIXERCONTROL_CT_CLASS_METER OR %MIXERCONTROL_CT_SC_METER_POLLED OR %MIXERCONTROL_CT_UNITS_SIGNED
%MIXERCONTROL_CONTROLTYPE_PEAKMETER          = %MIXERCONTROL_CONTROLTYPE_SIGNEDMETER + 1
%MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER      = %MIXERCONTROL_CT_CLASS_METER OR %MIXERCONTROL_CT_SC_METER_POLLED OR %MIXERCONTROL_CT_UNITS_UNSIGNED
%MIXERCONTROL_CONTROLTYPE_BOOLEAN            = %MIXERCONTROL_CT_CLASS_SWITCH OR %MIXERCONTROL_CT_SC_SWITCH_BOOLEAN OR %MIXERCONTROL_CT_UNITS_BOOLEAN
%MIXERCONTROL_CONTROLTYPE_ONOFF              = %MIXERCONTROL_CONTROLTYPE_BOOLEAN + 1
%MIXERCONTROL_CONTROLTYPE_MUTE               = %MIXERCONTROL_CONTROLTYPE_BOOLEAN + 2
%MIXERCONTROL_CONTROLTYPE_MONO               = %MIXERCONTROL_CONTROLTYPE_BOOLEAN + 3
%MIXERCONTROL_CONTROLTYPE_LOUDNESS           = %MIXERCONTROL_CONTROLTYPE_BOOLEAN + 4
%MIXERCONTROL_CONTROLTYPE_STEREOENH          = %MIXERCONTROL_CONTROLTYPE_BOOLEAN + 5
%MIXERCONTROL_CONTROLTYPE_BUTTON             = %MIXERCONTROL_CT_CLASS_SWITCH OR %MIXERCONTROL_CT_SC_SWITCH_BUTTON OR %MIXERCONTROL_CT_UNITS_BOOLEAN
%MIXERCONTROL_CONTROLTYPE_DECIBELS           = %MIXERCONTROL_CT_CLASS_NUMBER OR %MIXERCONTROL_CT_UNITS_DECIBELS
%MIXERCONTROL_CONTROLTYPE_SIGNED             = %MIXERCONTROL_CT_CLASS_NUMBER OR %MIXERCONTROL_CT_UNITS_SIGNED
%MIXERCONTROL_CONTROLTYPE_UNSIGNED           = %MIXERCONTROL_CT_CLASS_NUMBER OR %MIXERCONTROL_CT_UNITS_UNSIGNED
%MIXERCONTROL_CONTROLTYPE_PERCENT            = %MIXERCONTROL_CT_CLASS_NUMBER OR %MIXERCONTROL_CT_UNITS_PERCENT
%MIXERCONTROL_CONTROLTYPE_SLIDER             = %MIXERCONTROL_CT_CLASS_SLIDER OR %MIXERCONTROL_CT_UNITS_SIGNED
%MIXERCONTROL_CONTROLTYPE_PAN                = %MIXERCONTROL_CONTROLTYPE_SLIDER + 1
%MIXERCONTROL_CONTROLTYPE_QSOUNDPAN          = %MIXERCONTROL_CONTROLTYPE_SLIDER + 2
%MIXERCONTROL_CONTROLTYPE_FADER              = %MIXERCONTROL_CT_CLASS_FADER OR %MIXERCONTROL_CT_UNITS_UNSIGNED
%MIXERCONTROL_CONTROLTYPE_VOLUME             = %MIXERCONTROL_CONTROLTYPE_FADER + 1
%MIXERCONTROL_CONTROLTYPE_BASS               = %MIXERCONTROL_CONTROLTYPE_FADER + 2
%MIXERCONTROL_CONTROLTYPE_TREBLE             = %MIXERCONTROL_CONTROLTYPE_FADER + 3
%MIXERCONTROL_CONTROLTYPE_EQUALIZER          = %MIXERCONTROL_CONTROLTYPE_FADER + 4
%MIXERCONTROL_CONTROLTYPE_SINGLESELECT       = %MIXERCONTROL_CT_CLASS_LIST OR %MIXERCONTROL_CT_SC_LIST_SINGLE OR %MIXERCONTROL_CT_UNITS_BOOLEAN
%MIXERCONTROL_CONTROLTYPE_MUX                = %MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1
%MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT     = %MIXERCONTROL_CT_CLASS_LIST OR %MIXERCONTROL_CT_SC_LIST_MULTIPLE OR %MIXERCONTROL_CT_UNITS_BOOLEAN
%MIXERCONTROL_CONTROLTYPE_MIXER              = %MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1
%MIXERCONTROL_CONTROLTYPE_MICROTIME          = %MIXERCONTROL_CT_CLASS_TIME OR %MIXERCONTROL_CT_SC_TIME_MICROSECS OR %MIXERCONTROL_CT_UNITS_UNSIGNED
%MIXERCONTROL_CONTROLTYPE_MILLITIME          = %MIXERCONTROL_CT_CLASS_TIME OR %MIXERCONTROL_CT_SC_TIME_MILLISECS OR %MIXERCONTROL_CT_UNITS_UNSIGNED
'
%MIXER_GETLINECONTROLSF_ALL                  = &H0&
%MIXER_GETLINECONTROLSF_ONEBYID              = &H1&
%MIXER_GETLINECONTROLSF_ONEBYTYPE            = &H2&
%MIXER_GETLINECONTROLSF_QUERYMASK            = &HF&

%MIXER_GETCONTROLDETAILSF_VALUE              = &H0&
%MIXER_GETCONTROLDETAILSF_LISTTEXT           = &H1&
%MIXER_GETCONTROLDETAILSF_QUERYMASK          = &HF&

%MIXER_SETCONTROLDETAILSF_VALUE              = &H0&
%MIXER_SETCONTROLDETAILSF_CUSTOM             = &H1&
%MIXER_SETCONTROLDETAILSF_QUERYMASK          = &HF&

'  constants used with JOYINFOEX
%JOY_BUTTON5                                 = &H10&
%JOY_BUTTON6                                 = &H20&
%JOY_BUTTON7                                 = &H40&
%JOY_BUTTON8                                 = &H80&
%JOY_BUTTON9                                 = &H100&
%JOY_BUTTON10                                = &H200&
%JOY_BUTTON11                                = &H400&
%JOY_BUTTON12                                = &H800&
%JOY_BUTTON13                                = &H1000&
%JOY_BUTTON14                                = &H2000&
%JOY_BUTTON15                                = &H4000&
%JOY_BUTTON16                                = &H8000&
%JOY_BUTTON17                                = &H10000
%JOY_BUTTON18                                = &H20000
%JOY_BUTTON19                                = &H40000
%JOY_BUTTON20                                = &H80000
%JOY_BUTTON21                                = &H100000
%JOY_BUTTON22                                = &H200000
%JOY_BUTTON23                                = &H400000
%JOY_BUTTON24                                = &H800000
%JOY_BUTTON25                                = &H1000000
%JOY_BUTTON26                                = &H2000000
%JOY_BUTTON27                                = &H4000000
%JOY_BUTTON28                                = &H8000000
%JOY_BUTTON29                                = &H10000000
%JOY_BUTTON30                                = &H20000000
%JOY_BUTTON31                                = &H40000000
%JOY_BUTTON32                                = &H80000000

'  constants used with JOYINFOEX structure
%JOY_POVCENTERED                             = -1
%JOY_POVFORWARD                              = 0
%JOY_POVRIGHT                                = 9000
%JOY_POVBACKWARD                             = 18000
%JOY_POVLEFT                                 = 27000
%JOY_RETURNX                                 = &H1&
%JOY_RETURNY                                 = &H2&
%JOY_RETURNZ                                 = &H4&
%JOY_RETURNR                                 = &H8&
%JOY_RETURNU                                 = &H10                             '  axis 5
%JOY_RETURNV                                 = &H20                             '  axis 6
%JOY_RETURNPOV                               = &H40&
%JOY_RETURNBUTTONS                           = &H80&
%JOY_RETURNRAWDATA                           = &H100&
%JOY_RETURNPOVCTS                            = &H200&
%JOY_RETURNCENTERED                          = &H400&
%JOY_USEDEADZONE                             = &H800&
%JOY_RETURNALL                               = %JOY_RETURNX OR %JOY_RETURNY OR %JOY_RETURNZ OR %JOY_RETURNR OR %JOY_RETURNU OR %JOY_RETURNV OR %JOY_RETURNPOV OR %JOY_RETURNBUTTONS
%JOY_CAL_READALWAYS                          = &H10000
%JOY_CAL_READXYONLY                          = &H20000
%JOY_CAL_READ3                               = &H40000
%JOY_CAL_READ4                               = &H80000
%JOY_CAL_READXONLY                           = &H100000
%JOY_CAL_READYONLY                           = &H200000
%JOY_CAL_READ5                               = &H400000
%JOY_CAL_READ6                               = &H800000
%JOY_CAL_READZONLY                           = &H1000000
%JOY_CAL_READRONLY                           = &H2000000
%JOY_CAL_READUONLY                           = &H4000000
%JOY_CAL_READVONLY                           = &H8000000

%WAVE_FORMAT_QUERY                           = &H1
%SND_PURGE                                   = &H40               '  purge non-static events for task
%SND_APPLICATION                             = &H80         '  look for application specific association
%WAVE_MAPPED                                 = &H4
%WAVE_FORMAT_DIRECT                          = &H8
%WAVE_FORMAT_DIRECT_QUERY                    = %WAVE_FORMAT_QUERY OR %WAVE_FORMAT_DIRECT
%MIM_MOREDATA                                = %MM_MIM_MOREDATA
%MOM_POSITIONCB                              = %MM_MOM_POSITIONCB

'  flags for dwFlags parm of midiInOpen()
%MIDI_IO_STATUS                              = &H20&

' Driver messages
%DRV_LOAD                                    = &H1
%DRV_ENABLE                                  = &H2
%DRV_OPEN                                    = &H3
%DRV_CLOSE                                   = &H4
%DRV_DISABLE                                 = &H5
%DRV_FREE                                    = &H6
%DRV_CONFIGURE                               = &H7
%DRV_QUERYCONFIGURE                          = &H8
%DRV_INSTALL                                 = &H9
%DRV_REMOVE                                  = &HA
%DRV_EXITSESSION                             = &HB
%DRV_POWER                                   = &HF
%DRV_RESERVED                                = &H800
%DRV_USER                                    = &H4000

' Supported return values for DRV_CONFIGURE message
%DRVCNF_CANCEL                               = &H0
%DRVCNF_OK                                   = &H1
%DRVCNF_RESTART                              = &H2

'  return values from DriverProc() function
%DRV_CANCEL                                  = %DRVCNF_CANCEL
%DRV_OK                                      = %DRVCNF_OK
%DRV_RESTART                                 = %DRVCNF_RESTART

%DRV_MCI_FIRST                               = %DRV_RESERVED
%DRV_MCI_LAST                                = %DRV_RESERVED + &HFFF

' Driver callback support

'  flags used with waveOutOpen(), waveInOpen(), midiInOpen(), and
'  midiOutOpen() to specify the type of the dwCallback parameter.
%CALLBACK_TYPEMASK                           = &H70000      '  callback type mask
%CALLBACK_NULL                               = &H0        '  no callback
%CALLBACK_WINDOW                             = &H10000      '  dwCallback is a HWND
%CALLBACK_TASK                               = &H20000      '  dwCallback is a HTASK
%CALLBACK_FUNCTION                           = &H30000      '  dwCallback is a FARPROC

'  manufacturer IDs
%MM_MICROSOFT                                = 1  '  Microsoft Corp.

'  product IDs
%MM_MIDI_MAPPER                              = 1  '  MIDI Mapper
%MM_WAVE_MAPPER                              = 2  '  Wave Mapper

%MM_SNDBLST_MIDIOUT                          = 3  '  Sound Blaster MIDI output port
%MM_SNDBLST_MIDIIN                           = 4  '  Sound Blaster MIDI input port
%MM_SNDBLST_SYNTH                            = 5  '  Sound Blaster internal synthesizer
%MM_SNDBLST_WAVEOUT                          = 6  '  Sound Blaster waveform output
%MM_SNDBLST_WAVEIN                           = 7  '  Sound Blaster waveform input

%MM_ADLIB                                    = 9  '  Ad Lib-compatible synthesizer

%MM_MPU401_MIDIOUT                           = 10  '  MPU401-compatible MIDI output port
%MM_MPU401_MIDIIN                            = 11  '  MPU401-compatible MIDI input port

%MM_PC_JOYSTICK                              = 12  '  Joystick adapter

'  flag values for uFlags parameter
%SND_SYNC                                    = &H0         '  play synchronously (default)
%SND_ASYNC                                   = &H1         '  play asynchronously

%SND_NODEFAULT                               = &H2         '  silence not default, if sound not found

%SND_MEMORY                                  = &H4         '  lpszSoundName points to a memory file
%SND_ALIAS                                   = &H10000     '  name is a WIN.INI [sounds] entry
%SND_FILENAME                                = &H20000     '  name is a file name
%SND_RESOURCE                                = &H40004     '  name is a resource name or atom
%SND_ALIAS_ID                                = &H110000    '  name is a WIN.INI [sounds] entry identifier

%SND_ALIAS_START                             = 0  '  must be > 4096 to keep strings in same section of resource file

%SND_LOOP                                    = &H8         '  loop the sound until next sndPlaySound
%SND_NOSTOP                                  = &H10        '  don't stop any currently playing sound
%SND_VALID                                   = &H1F        '  valid flags          / ;Internal /

%SND_NOWAIT                                  = &H2000      '  don't wait if the driver is busy

%SND_VALIDFLAGS                              = &H17201F    '  Set of valid flag bits.  Anything outside
'  this range will raise an error
%SND_RESERVED                                = &HFF000000  '  In particular these flags are reserved

%SND_TYPE_MASK                               = &H170007

'  waveform audio error return values
%WAVERR_BADFORMAT                            = %WAVERR_BASE + 0    '  unsupported wave format
%WAVERR_STILLPLAYING                         = %WAVERR_BASE + 1    '  still something playing
%WAVERR_UNPREPARED                           = %WAVERR_BASE + 2    '  header not prepared
%WAVERR_SYNC                                 = %WAVERR_BASE + 3    '  device is synchronous
%WAVERR_LASTERROR                            = %WAVERR_BASE + 3    '  last error in range

'  wave callback messages
%WOM_OPEN                                    = %MM_WOM_OPEN
%WOM_CLOSE                                   = %MM_WOM_CLOSE
%WOM_DONE                                    = %MM_WOM_DONE
%WIM_OPEN                                    = %MM_WIM_OPEN
%WIM_CLOSE                                   = %MM_WIM_CLOSE
%WIM_DATA                                    = %MM_WIM_DATA

'  device ID for wave device mapper
%WAVE_MAPPER                                 = -1&

'  flags for dwFlags parameter in waveOutOpen() and waveInOpen()

%WAVE_ALLOWSYNC                              = &H2
%WAVE_VALID                                  = &H3         '  ;Internal

'  flags for dwFlags field of WAVEHDR
%WHDR_DONE                                   = &H1         '  done bit
%WHDR_PREPARED                               = &H2         '  set if this header has been prepared
%WHDR_BEGINLOOP                              = &H4         '  loop start block
%WHDR_ENDLOOP                                = &H8         '  loop end block
%WHDR_INQUEUE                                = &H10        '  reserved for driver
%WHDR_VALID                                  = &H1F        '  valid flags      / ;Internal /

'  flags for dwSupport field of WAVEOUTCAPS
%WAVECAPS_PITCH                              = &H1         '  supports pitch control
%WAVECAPS_PLAYBACKRATE                       = &H2         '  supports playback rate control
%WAVECAPS_VOLUME                             = &H4         '  supports volume control
%WAVECAPS_LRVOLUME                           = &H8         '  separate left-right volume control
%WAVECAPS_SYNC                               = &H10

'  defines for dwFormat field of WAVEINCAPS and WAVEOUTCAPS
%WAVE_INVALIDFORMAT                          = &H0              '  invalid format
%WAVE_FORMAT_1M08                            = &H1              '  11.025 kHz, Mono,   8-bit
%WAVE_FORMAT_1S08                            = &H2              '  11.025 kHz, Stereo, 8-bit
%WAVE_FORMAT_1M16                            = &H4              '  11.025 kHz, Mono,   16-bit
%WAVE_FORMAT_1S16                            = &H8              '  11.025 kHz, Stereo, 16-bit
%WAVE_FORMAT_2M08                            = &H10             '  22.05  kHz, Mono,   8-bit
%WAVE_FORMAT_2S08                            = &H20             '  22.05  kHz, Stereo, 8-bit
%WAVE_FORMAT_2M16                            = &H40             '  22.05  kHz, Mono,   16-bit
%WAVE_FORMAT_2S16                            = &H80             '  22.05  kHz, Stereo, 16-bit
%WAVE_FORMAT_4M08                            = &H100            '  44.1   kHz, Mono,   8-bit
%WAVE_FORMAT_4S08                            = &H200            '  44.1   kHz, Stereo, 8-bit
%WAVE_FORMAT_4M16                            = &H400            '  44.1   kHz, Mono,   16-bit
%WAVE_FORMAT_4S16                            = &H800            '  44.1   kHz, Stereo, 16-bit

'  flags for wFormatTag field of WAVEFORMAT
%WAVE_FORMAT_PCM                             = 1  '  Needed in resource files so outside #ifndef RC_INVOKED

'  MIDI error return values
%MIDIERR_UNPREPARED                          = %MIDIERR_BASE + 0   '  header not prepared
%MIDIERR_STILLPLAYING                        = %MIDIERR_BASE + 1   '  still something playing
%MIDIERR_NOMAP                               = %MIDIERR_BASE + 2   '  no current map
%MIDIERR_NOTREADY                            = %MIDIERR_BASE + 3   '  hardware is still busy
%MIDIERR_NODEVICE                            = %MIDIERR_BASE + 4   '  port no longer connected
%MIDIERR_INVALIDSETUP                        = %MIDIERR_BASE + 5   '  invalid setup
%MIDIERR_LASTERROR                           = %MIDIERR_BASE + 5   '  last error in range

'  MIDI callback messages
%MIM_OPEN                                    = %MM_MIM_OPEN
%MIM_CLOSE                                   = %MM_MIM_CLOSE
%MIM_DATA                                    = %MM_MIM_DATA
%MIM_LONGDATA                                = %MM_MIM_LONGDATA
%MIM_ERROR                                   = %MM_MIM_ERROR
%MIM_LONGERROR                               = %MM_MIM_LONGERROR
%MOM_OPEN                                    = %MM_MOM_OPEN
%MOM_CLOSE                                   = %MM_MOM_CLOSE
%MOM_DONE                                    = %MM_MOM_DONE

'  device ID for MIDI mapper
%MIDIMAPPER                                  = -1  '  Cannot be cast to DWORD as RC complains
%MIDI_MAPPER                                 = -1&

'  flags for wFlags parm of midiOutCachePatches(), midiOutCacheDrumPatches()
%MIDI_CACHE_ALL                              = 1
%MIDI_CACHE_BESTFIT                          = 2
%MIDI_CACHE_QUERY                            = 3
%MIDI_UNCACHE                                = 4
%MIDI_CACHE_VALID                            = %MIDI_CACHE_ALL OR %MIDI_CACHE_BESTFIT OR %MIDI_CACHE_QUERY OR %MIDI_UNCACHE  '  ;Internal

'  flags for wTechnology field of MIDIOUTCAPS structure
%MOD_MIDIPORT                                = 1  '  output port
%MOD_SYNTH                                   = 2  '  generic internal synth
%MOD_SQSYNTH                                 = 3  '  square wave internal synth
%MOD_FMSYNTH                                 = 4  '  FM internal synth
%MOD_MAPPER                                  = 5  '  MIDI mapper

'  flags for dwSupport field of MIDIOUTCAPS
%MIDICAPS_VOLUME                             = &H1         '  supports volume control
%MIDICAPS_LRVOLUME                           = &H2         '  separate left-right volume control
%MIDICAPS_CACHE                              = &H4

'  flags for dwFlags field of MIDIHDR structure
%MHDR_DONE                                   = &H1         '  done bit
%MHDR_PREPARED                               = &H2         '  set if header prepared
%MHDR_INQUEUE                                = &H4         '  reserved for driver
%MHDR_VALID                                  = &H7         '  valid flags / ;Internal /

'  device ID for aux device mapper
%AUX_MAPPER                                  = -1&

'  flags for wTechnology field in AUXCAPS structure
%AUXCAPS_CDAUDIO                             = 1  '  audio from internal CD-ROM drive
%AUXCAPS_AUXIN                               = 2  '  audio from auxiliary input jacks

'  flags for dwSupport field in AUXCAPS structure
%AUXCAPS_VOLUME                              = &H1         '  supports volume control
%AUXCAPS_LRVOLUME                            = &H2         '  separate left-right volume control

'  timer error return values
%TIMERR_NOERROR                              = 0  '  no error
%TIMERR_NOCANDO                              = %TIMERR_BASE + 1 '  request not completed
%TIMERR_STRUCT                               = %TIMERR_BASE + 33 '  time struct size

'  flags for wFlags parameter of timeSetEvent() function
%TIME_ONESHOT                                = 0  '  program timer for single event
%TIME_PERIODIC                               = 1  '  program for continuous periodic event

'  joystick error return values
%JOYERR_NOERROR                              = 0  '  no error
%JOYERR_PARMS                                = %JOYERR_BASE + 5 '  bad parameters
%JOYERR_NOCANDO                              = %JOYERR_BASE + 6 '  request not completed
%JOYERR_UNPLUGGED                            = %JOYERR_BASE + 7 '  joystick is unplugged

'  constants used with JOYINFO structure and MM_JOY messages
%JOY_BUTTON1                                 = &H1
%JOY_BUTTON2                                 = &H2
%JOY_BUTTON3                                 = &H4
%JOY_BUTTON4                                 = &H8
%JOY_BUTTON1CHG                              = &H100
%JOY_BUTTON2CHG                              = &H200
%JOY_BUTTON3CHG                              = &H400
%JOY_BUTTON4CHG                              = &H800

'  joystick ID constants
%JOYSTICKID1                                 = 0
%JOYSTICKID2                                 = 1

'  MMIO error return values
%MMIOERR_BASE                                = 256
%MMIOERR_FILENOTFOUND                        = %MMIOERR_BASE + 1  '  file not found
%MMIOERR_OUTOFMEMORY                         = %MMIOERR_BASE + 2  '  out of memory
%MMIOERR_CANNOTOPEN                          = %MMIOERR_BASE + 3  '  cannot open
%MMIOERR_CANNOTCLOSE                         = %MMIOERR_BASE + 4  '  cannot close
%MMIOERR_CANNOTREAD                          = %MMIOERR_BASE + 5  '  cannot read
%MMIOERR_CANNOTWRITE                         = %MMIOERR_BASE + 6 '  cannot write
%MMIOERR_CANNOTSEEK                          = %MMIOERR_BASE + 7  '  cannot seek
%MMIOERR_CANNOTEXPAND                        = %MMIOERR_BASE + 8  '  cannot expand file
%MMIOERR_CHUNKNOTFOUND                       = %MMIOERR_BASE + 9  '  chunk not found
%MMIOERR_UNBUFFERED                          = %MMIOERR_BASE + 10 '  file is unbuffered

%MMIO_RWMODE                                 = &H3         '  mask to get bits used for opening
'  file for reading/writing/both
%MMIO_SHAREMODE                              = &H70        '  file sharing mode number

'  constants for dwFlags field of MMIOINFO
%MMIO_CREATE                                 = &H1000      '  create new file (or truncate file)
%MMIO_PARSE                                  = &H100       '  parse new file returning path
%MMIO_DELETE                                 = &H200       '  create new file (or truncate file)
%MMIO_EXIST                                  = &H4000      '  checks for existence of file
%MMIO_ALLOCBUF                               = &H10000     '  mmioOpen() should allocate a buffer
%MMIO_GETTEMP                                = &H20000     '  mmioOpen() should retrieve temp name

%MMIO_DIRTY                                  = &H10000000  '  I/O buffer is dirty
'  MMIO_DIRTY is also used in the <dwFlags> field of MMCKINFO structure

%MMIO_OPEN_VALID                             = &H3FFFF     '  valid flags for mmioOpen / ;Internal /

'  read/write mode numbers (bit field MMIO_RWMODE)
%MMIO_READ                                   = &H0         '  open file for reading only
%MMIO_WRITE                                  = &H1         '  open file for writing only
%MMIO_READWRITE                              = &H2         '  open file for reading and writing

'  share mode numbers (bit field MMIO_SHAREMODE)
%MMIO_COMPAT                                 = &H0         '  compatibility mode
%MMIO_EXCLUSIVE                              = &H10        '  exclusive-access mode
%MMIO_DENYWRITE                              = &H20        '  deny writing to other processes
%MMIO_DENYREAD                               = &H30        '  deny reading to other processes
%MMIO_DENYNONE                               = &H40        '  deny nothing to other processes

'  flags for other functions
%MMIO_FHOPEN                                 = &H10    '  mmioClose(): keep file xHandle open
%MMIO_EMPTYBUF                               = &H10    '  mmioFlush(): empty the I/O buffer
%MMIO_TOUPPER                                = &H10    '  mmioStringToFOURCC(): cvt. to u-case
%MMIO_INSTALLPROC                            = &H10000     '  mmioInstallIOProc(): install MMIOProc
%MMIO_PUBLICPROC                             = &H10000000  '  mmioInstallIOProc: install Globally
%MMIO_UNICODEPROC                            = &H1000000   '  mmioInstallIOProc(): Unicode MMIOProc
%MMIO_REMOVEPROC                             = &H20000     '  mmioInstallIOProc(): remove MMIOProc
%MMIO_FINDPROC                               = &H40000     '  mmioInstallIOProc(): find an MMIOProc
%MMIO_FINDCHUNK                              = &H10    '  mmioDescend(): find a chunk by ID
%MMIO_FINDRIFF                               = &H20    '  mmioDescend(): find a LIST chunk
%MMIO_FINDLIST                               = &H40    '  mmioDescend(): find a RIFF chunk
%MMIO_CREATERIFF                             = &H20    '  mmioCreateChunk(): make a LIST chunk
%MMIO_CREATELIST                             = &H40    '  mmioCreateChunk(): make a RIFF chunk

%MMIO_VALIDPROC                              = &H11070000  '  valid for mmioInstallIOProc / ;Internal /

'  message numbers for MMIOPROC I/O procedure functions
%MMIOM_READ                                  = %MMIO_READ  '  read (must equal MMIO_READ!)
%MMIOM_WRITE                                 = %MMIO_WRITE  '  write (must equal MMIO_WRITE!)
%MMIOM_SEEK                                  = 2  '  seek to a new position in file
%MMIOM_OPEN                                  = 3  '  open file
%MMIOM_CLOSE                                 = 4  '  close file
%MMIOM_WRITEFLUSH                            = 5  '  write and flush
%MMIOM_RENAME                                = 6  '  rename specified file
%MMIOM_USER                                  = &H8000  '  beginning of user-defined messages

'  flags for mmioSeek()
%SEEK_SET                                    = 0  '  seek to an absolute position
%SEEK_CUR                                    = 1  '  seek relative to current position
%SEEK_END                                    = 2  '  seek relative to end of file

'  other constants
%MMIO_DEFAULTBUFFER                          = 8192  '  default buffer size

'   MCI error return values
%MCIERR_INVALID_DEVICE_ID                    = %MCIERR_BASE + 1
%MCIERR_UNRECOGNIZED_KEYWORD                 = %MCIERR_BASE + 3
%MCIERR_UNRECOGNIZED_COMMAND                 = %MCIERR_BASE + 5
%MCIERR_HARDWARE                             = %MCIERR_BASE + 6
%MCIERR_INVALID_DEVICE_NAME                  = %MCIERR_BASE + 7
%MCIERR_OUT_OF_MEMORY                        = %MCIERR_BASE + 8
%MCIERR_DEVICE_OPEN                          = %MCIERR_BASE + 9
%MCIERR_CANNOT_LOAD_DRIVER                   = %MCIERR_BASE + 10
%MCIERR_MISSING_COMMAND_STRING               = %MCIERR_BASE + 11
%MCIERR_PARAM_OVERFLOW                       = %MCIERR_BASE + 12
%MCIERR_MISSING_STRING_ARGUMENT              = %MCIERR_BASE + 13
%MCIERR_BAD_INTEGER                          = %MCIERR_BASE + 14
%MCIERR_PARSER_INTERNAL                      = %MCIERR_BASE + 15
%MCIERR_DRIVER_INTERNAL                      = %MCIERR_BASE + 16
%MCIERR_MISSING_PARAMETER                    = %MCIERR_BASE + 17
%MCIERR_UNSUPPORTED_FUNCTION                 = %MCIERR_BASE + 18
%MCIERR_FILE_NOT_FOUND                       = %MCIERR_BASE + 19
%MCIERR_DEVICE_NOT_READY                     = %MCIERR_BASE + 20
%MCIERR_INTERNAL                             = %MCIERR_BASE + 21
%MCIERR_DRIVER                               = %MCIERR_BASE + 22
%MCIERR_CANNOT_USE_ALL                       = %MCIERR_BASE + 23
%MCIERR_MULTIPLE                             = %MCIERR_BASE + 24
%MCIERR_EXTENSION_NOT_FOUND                  = %MCIERR_BASE + 25
%MCIERR_OUTOFRANGE                           = %MCIERR_BASE + 26
%MCIERR_FLAGS_NOT_COMPATIBLE                 = %MCIERR_BASE + 28
%MCIERR_FILE_NOT_SAVED                       = %MCIERR_BASE + 30
%MCIERR_DEVICE_TYPE_REQUIRED                 = %MCIERR_BASE + 31
%MCIERR_DEVICE_LOCKED                        = %MCIERR_BASE + 32
%MCIERR_DUPLICATE_ALIAS                      = %MCIERR_BASE + 33
%MCIERR_BAD_CONSTANT                         = %MCIERR_BASE + 34
%MCIERR_MUST_USE_SHAREABLE                   = %MCIERR_BASE + 35
%MCIERR_MISSING_DEVICE_NAME                  = %MCIERR_BASE + 36
%MCIERR_BAD_TIME_FORMAT                      = %MCIERR_BASE + 37
%MCIERR_NO_CLOSING_QUOTE                     = %MCIERR_BASE + 38
%MCIERR_DUPLICATE_FLAGS                      = %MCIERR_BASE + 39
%MCIERR_INVALID_FILE                         = %MCIERR_BASE + 40
%MCIERR_NULL_PARAMETER_BLOCK                 = %MCIERR_BASE + 41
%MCIERR_UNNAMED_RESOURCE                     = %MCIERR_BASE + 42
%MCIERR_NEW_REQUIRES_ALIAS                   = %MCIERR_BASE + 43
%MCIERR_NOTIFY_ON_AUTO_OPEN                  = %MCIERR_BASE + 44
%MCIERR_NO_ELEMENT_ALLOWED                   = %MCIERR_BASE + 45
%MCIERR_NONAPPLICABLE_FUNCTION               = %MCIERR_BASE + 46
%MCIERR_ILLEGAL_FOR_AUTO_OPEN                = %MCIERR_BASE + 47
%MCIERR_FILENAME_REQUIRED                    = %MCIERR_BASE + 48
%MCIERR_EXTRA_CHARACTERS                     = %MCIERR_BASE + 49
%MCIERR_DEVICE_NOT_INSTALLED                 = %MCIERR_BASE + 50
%MCIERR_GET_CD                               = %MCIERR_BASE + 51
%MCIERR_SET_CD                               = %MCIERR_BASE + 52
%MCIERR_SET_DRIVE                            = %MCIERR_BASE + 53
%MCIERR_DEVICE_LENGTH                        = %MCIERR_BASE + 54
%MCIERR_DEVICE_ORD_LENGTH                    = %MCIERR_BASE + 55
%MCIERR_NO_INTEGER                           = %MCIERR_BASE + 56

%MCIERR_WAVE_OUTPUTSINUSE                    = %MCIERR_BASE + 64
%MCIERR_WAVE_SETOUTPUTINUSE                  = %MCIERR_BASE + 65
%MCIERR_WAVE_INPUTSINUSE                     = %MCIERR_BASE + 66
%MCIERR_WAVE_SETINPUTINUSE                   = %MCIERR_BASE + 67
%MCIERR_WAVE_OUTPUTUNSPECIFIED               = %MCIERR_BASE + 68
%MCIERR_WAVE_INPUTUNSPECIFIED                = %MCIERR_BASE + 69
%MCIERR_WAVE_OUTPUTSUNSUITABLE               = %MCIERR_BASE + 70
%MCIERR_WAVE_SETOUTPUTUNSUITABLE             = %MCIERR_BASE + 71
%MCIERR_WAVE_INPUTSUNSUITABLE                = %MCIERR_BASE + 72
%MCIERR_WAVE_SETINPUTUNSUITABLE              = %MCIERR_BASE + 73

%MCIERR_SEQ_DIV_INCOMPATIBLE                 = %MCIERR_BASE + 80
%MCIERR_SEQ_PORT_INUSE                       = %MCIERR_BASE + 81
%MCIERR_SEQ_PORT_NONEXISTENT                 = %MCIERR_BASE + 82
%MCIERR_SEQ_PORT_MAPNODEVICE                 = %MCIERR_BASE + 83
%MCIERR_SEQ_PORT_MISCERROR                   = %MCIERR_BASE + 84
%MCIERR_SEQ_TIMER                            = %MCIERR_BASE + 85
%MCIERR_SEQ_PORTUNSPECIFIED                  = %MCIERR_BASE + 86
%MCIERR_SEQ_NOMIDIPRESENT                    = %MCIERR_BASE + 87

%MCIERR_NO_WINDOW                            = %MCIERR_BASE + 90
%MCIERR_CREATEWINDOW                         = %MCIERR_BASE + 91
%MCIERR_FILE_READ                            = %MCIERR_BASE + 92
%MCIERR_FILE_WRITE                           = %MCIERR_BASE + 93

'  All custom device driver errors must be >= this value
%MCIERR_CUSTOM_DRIVER_BASE                   = %MCIERR_BASE + 256

'  Message numbers must be in the range between MCI_FIRST and MCI_LAST

%MCI_FIRST                                   = &H800
'  Messages &H801 and &H802 are reserved
%MCI_OPEN                                    = &H803
%MCI_CLOSE                                   = &H804
%MCI_ESCAPE                                  = &H805
%MCI_PLAY                                    = &H806
%MCI_SEEK                                    = &H807
%MCI_STOP                                    = &H808
%MCI_PAUSE                                   = &H809
%MCI_INFO                                    = &H80A
%MCI_GETDEVCAPS                              = &H80B
%MCI_SPIN                                    = &H80C
%MCI_SET                                     = &H80D
%MCI_STEP                                    = &H80E
%MCI_RECORD                                  = &H80F
%MCI_SYSINFO                                 = &H810
%MCI_BREAK                                   = &H811
%MCI_SOUND                                   = &H812
%MCI_SAVE                                    = &H813
%MCI_STATUS                                  = &H814

%MCI_CUE                                     = &H830

%MCI_REALIZE                                 = &H840
%MCI_WINDOW                                  = &H841
%MCI_PUT                                     = &H842
%MCI_WHERE                                   = &H843
%MCI_FREEZE                                  = &H844
%MCI_UNFREEZE                                = &H845

%MCI_LOAD                                    = &H850
%MCI_CUT                                     = &H851
%MCI_COPY                                    = &H852
%MCI_PASTE                                   = &H853
%MCI_UPDATE                                  = &H854
%MCI_RESUME                                  = &H855
%MCI_DELETE                                  = &H856

%MCI_LAST                                    = &HFFF

'  the next &H400 message ID's are reserved for custom drivers
'  all custom MCI command messages must be >= than this value
%MCI_USER_MESSAGES                           = &H400 + %MCI_FIRST
%MCI_ALL_DEVICE_ID                           = -1 '  Matches all MCI devices

'  constants for predefined MCI device types
%MCI_DEVTYPE_VCR                             = 513
%MCI_DEVTYPE_VIDEODISC                       = 514
%MCI_DEVTYPE_OVERLAY                         = 515
%MCI_DEVTYPE_CD_AUDIO                        = 516
%MCI_DEVTYPE_DAT                             = 517
%MCI_DEVTYPE_SCANNER                         = 518
%MCI_DEVTYPE_ANIMATION                       = 519
%MCI_DEVTYPE_DIGITAL_VIDEO                   = 520
%MCI_DEVTYPE_OTHER                           = 521
%MCI_DEVTYPE_WAVEFORM_AUDIO                  = 522
%MCI_DEVTYPE_SEQUENCER                       = 523

%MCI_DEVTYPE_FIRST                           = %MCI_DEVTYPE_VCR
%MCI_DEVTYPE_LAST                            = %MCI_DEVTYPE_SEQUENCER

%MCI_DEVTYPE_FIRST_USER                      = &H1000

'  return values for 'status mode' command
%MCI_MODE_NOT_READY                          = %MCI_STRING_OFFSET + 12
%MCI_MODE_STOP                               = %MCI_STRING_OFFSET + 13
%MCI_MODE_PLAY                               = %MCI_STRING_OFFSET + 14
%MCI_MODE_RECORD                             = %MCI_STRING_OFFSET + 15
%MCI_MODE_SEEK                               = %MCI_STRING_OFFSET + 16
%MCI_MODE_PAUSE                              = %MCI_STRING_OFFSET + 17
%MCI_MODE_OPEN                               = %MCI_STRING_OFFSET + 18

'  constants used in 'set time format' and 'status time format' commands
%MCI_FORMAT_MILLISECONDS                     = 0
%MCI_FORMAT_HMS                              = 1
%MCI_FORMAT_MSF                              = 2
%MCI_FORMAT_FRAMES                           = 3
%MCI_FORMAT_SMPTE_24                         = 4
%MCI_FORMAT_SMPTE_25                         = 5
%MCI_FORMAT_SMPTE_30                         = 6
%MCI_FORMAT_SMPTE_30DROP                     = 7
%MCI_FORMAT_BYTES                            = 8
%MCI_FORMAT_SAMPLES                          = 9
%MCI_FORMAT_TMSF                             = 10

'  Flags for wParam of the MM_MCINOTIFY message
%MCI_NOTIFY_SUCCESSFUL                       = &H1
%MCI_NOTIFY_SUPERSEDED                       = &H2
%MCI_NOTIFY_ABORTED                          = &H4
%MCI_NOTIFY_FAILURE                          = &H8

'  common flags for dwFlags parameter of MCI command messages
%MCI_NOTIFY                                  = &H1&
%MCI_WAIT                                    = &H2&
%MCI_FROM                                    = &H4&
%MCI_TO                                      = &H8&
%MCI_TRACK                                   = &H10&

'  flags for dwFlags parameter of MCI_OPEN command message
%MCI_OPEN_SHAREABLE                          = &H100&
%MCI_OPEN_ELEMENT                            = &H200&
%MCI_OPEN_ALIAS                              = &H400&
%MCI_OPEN_ELEMENT_ID                         = &H800&
%MCI_OPEN_TYPE_ID                            = &H1000&
%MCI_OPEN_TYPE                               = &H2000&

'  flags for dwFlags parameter of MCI_SEEK command message
%MCI_SEEK_TO_START                           = &H100&
%MCI_SEEK_TO_END                             = &H200&

'  flags for dwFlags parameter of MCI_STATUS command message
%MCI_STATUS_ITEM                             = &H100&
%MCI_STATUS_START                            = &H200&

'  flags for dwItem field of the MCI_STATUS_PARMS parameter block
%MCI_STATUS_LENGTH                           = &H1&
%MCI_STATUS_POSITION                         = &H2&
%MCI_STATUS_NUMBER_OF_TRACKS                 = &H3&
%MCI_STATUS_MODE                             = &H4&
%MCI_STATUS_MEDIA_PRESENT                    = &H5&
%MCI_STATUS_TIME_FORMAT                      = &H6&
%MCI_STATUS_READY                            = &H7&
%MCI_STATUS_CURRENT_TRACK                    = &H8&

'  flags for dwFlags parameter of MCI_INFO command message
%MCI_INFO_PRODUCT                            = &H100&
%MCI_INFO_FILE                               = &H200&

'  flags for dwFlags parameter of MCI_GETDEVCAPS command message
%MCI_GETDEVCAPS_ITEM                         = &H100&

'  flags for dwItem field of the MCI_GETDEVCAPS_PARMS parameter block
%MCI_GETDEVCAPS_CAN_RECORD                   = &H1&
%MCI_GETDEVCAPS_HAS_AUDIO                    = &H2&
%MCI_GETDEVCAPS_HAS_VIDEO                    = &H3&
%MCI_GETDEVCAPS_DEVICE_TYPE                  = &H4&
%MCI_GETDEVCAPS_USES_FILES                   = &H5&
%MCI_GETDEVCAPS_COMPOUND_DEVICE              = &H6&
%MCI_GETDEVCAPS_CAN_EJECT                    = &H7&
%MCI_GETDEVCAPS_CAN_PLAY                     = &H8&
%MCI_GETDEVCAPS_CAN_SAVE                     = &H9&

'  flags for dwFlags parameter of MCI_SYSINFO command message
%MCI_SYSINFO_QUANTITY                        = &H100&
%MCI_SYSINFO_OPEN                            = &H200&
%MCI_SYSINFO_NAME                            = &H400&
%MCI_SYSINFO_INSTALLNAME                     = &H800&

'  flags for dwFlags parameter of MCI_SET command message
%MCI_SET_DOOR_OPEN                           = &H100&
%MCI_SET_DOOR_CLOSED                         = &H200&
%MCI_SET_TIME_FORMAT                         = &H400&
%MCI_SET_AUDIO                               = &H800&
%MCI_SET_VIDEO                               = &H1000&
%MCI_SET_ON                                  = &H2000&
%MCI_SET_OFF                                 = &H4000&

'  flags for dwAudio field of MCI_SET_PARMS or MCI_SEQ_SET_PARMS
%MCI_SET_AUDIO_ALL                           = &H4001&
%MCI_SET_AUDIO_LEFT                          = &H4002&
%MCI_SET_AUDIO_RIGHT                         = &H4003&

'  flags for dwFlags parameter of MCI_BREAK command message
%MCI_BREAK_KEY                               = &H100&
%MCI_BREAK_HWND                              = &H200&
%MCI_BREAK_OFF                               = &H400&

'  flags for dwFlags parameter of MCI_RECORD command message
%MCI_RECORD_INSERT                           = &H100&
%MCI_RECORD_OVERWRITE                        = &H200&

'  flags for dwFlags parameter of MCI_SOUND command message
%MCI_SOUND_NAME                              = &H100&

'  flags for dwFlags parameter of MCI_SAVE command message
%MCI_SAVE_FILE                               = &H100&

'  flags for dwFlags parameter of MCI_LOAD command message
%MCI_LOAD_FILE                               = &H100&

%MCI_VD_MODE_PARK                            = %MCI_VD_OFFSET + 1

'  return ID's for videodisc MCI_GETDEVCAPS command

'  flag for dwReturn field of MCI_STATUS_PARMS
'  MCI_STATUS command, (dwItem == MCI_VD_STATUS_MEDIA_TYPE)
%MCI_VD_MEDIA_CLV                            = %MCI_VD_OFFSET + 2
%MCI_VD_MEDIA_CAV                            = %MCI_VD_OFFSET + 3
%MCI_VD_MEDIA_OTHER                          = %MCI_VD_OFFSET + 4

%MCI_VD_FORMAT_TRACK                         = &H4001

'  flags for dwFlags parameter of MCI_PLAY command message
%MCI_VD_PLAY_REVERSE                         = &H10000
%MCI_VD_PLAY_FAST                            = &H20000
%MCI_VD_PLAY_SPEED                           = &H40000
%MCI_VD_PLAY_SCAN                            = &H80000
%MCI_VD_PLAY_SLOW                            = &H100000

'  flag for dwFlags parameter of MCI_SEEK command message
%MCI_VD_SEEK_REVERSE                         = &H10000

'  flags for dwItem field of MCI_STATUS_PARMS parameter block
%MCI_VD_STATUS_SPEED                         = &H4002&
%MCI_VD_STATUS_FORWARD                       = &H4003&
%MCI_VD_STATUS_MEDIA_TYPE                    = &H4004&
%MCI_VD_STATUS_SIDE                          = &H4005&
%MCI_VD_STATUS_DISC_SIZE                     = &H4006&

'  flags for dwFlags parameter of MCI_GETDEVCAPS command message
%MCI_VD_GETDEVCAPS_CLV                       = &H10000
%MCI_VD_GETDEVCAPS_CAV                       = &H20000

%MCI_VD_SPIN_UP                              = &H10000
%MCI_VD_SPIN_DOWN                            = &H20000

'  flags for dwItem field of MCI_GETDEVCAPS_PARMS parameter block
%MCI_VD_GETDEVCAPS_CAN_REVERSE               = &H4002&
%MCI_VD_GETDEVCAPS_FAST_RATE                 = &H4003&
%MCI_VD_GETDEVCAPS_SLOW_RATE                 = &H4004&
%MCI_VD_GETDEVCAPS_NORMAL_RATE               = &H4005&

'  flags for the dwFlags parameter of MCI_STEP command message
%MCI_VD_STEP_FRAMES                          = &H10000
%MCI_VD_STEP_REVERSE                         = &H20000

'  flag for the MCI_ESCAPE command message
%MCI_VD_ESCAPE_STRING                        = &H100&

%MCI_WAVE_PCM                                = %MCI_WAVE_OFFSET + 0
%MCI_WAVE_MAPPER                             = %MCI_WAVE_OFFSET + 1

'  flags for the dwFlags parameter of MCI_OPEN command message
%MCI_WAVE_OPEN_BUFFER                        = &H10000

'  flags for the dwFlags parameter of MCI_SET command message
%MCI_WAVE_SET_FORMATTAG                      = &H10000
%MCI_WAVE_SET_CHANNELS                       = &H20000
%MCI_WAVE_SET_SAMPLESPERSEC                  = &H40000
%MCI_WAVE_SET_AVGBYTESPERSEC                 = &H80000
%MCI_WAVE_SET_BLOCKALIGN                     = &H100000
%MCI_WAVE_SET_BITSPERSAMPLE                  = &H200000

'  flags for the dwFlags parameter of MCI_STATUS, MCI_SET command messages
%MCI_WAVE_INPUT                              = &H400000
%MCI_WAVE_OUTPUT                             = &H800000

'  flags for the dwItem field of MCI_STATUS_PARMS parameter block
%MCI_WAVE_STATUS_FORMATTAG                   = &H4001&
%MCI_WAVE_STATUS_CHANNELS                    = &H4002&
%MCI_WAVE_STATUS_SAMPLESPERSEC               = &H4003&
%MCI_WAVE_STATUS_AVGBYTESPERSEC              = &H4004&
%MCI_WAVE_STATUS_BLOCKALIGN                  = &H4005&
%MCI_WAVE_STATUS_BITSPERSAMPLE               = &H4006&
%MCI_WAVE_STATUS_LEVEL                       = &H4007&

'  flags for the dwFlags parameter of MCI_SET command message
%MCI_WAVE_SET_ANYINPUT                       = &H4000000
%MCI_WAVE_SET_ANYOUTPUT                      = &H8000000

'  flags for the dwFlags parameter of MCI_GETDEVCAPS command message
%MCI_WAVE_GETDEVCAPS_INPUTS                  = &H4001&
%MCI_WAVE_GETDEVCAPS_OUTPUTS                 = &H4002&

'  flags for the dwReturn field of MCI_STATUS_PARMS parameter block
'  MCI_STATUS command, (dwItem == MCI_SEQ_STATUS_DIVTYPE)
%MCI_SEQ_DIV_PPQN                            = 0 + %MCI_SEQ_OFFSET
%MCI_SEQ_DIV_SMPTE_24                        = 1 + %MCI_SEQ_OFFSET
%MCI_SEQ_DIV_SMPTE_25                        = 2 + %MCI_SEQ_OFFSET
%MCI_SEQ_DIV_SMPTE_30DROP                    = 3 + %MCI_SEQ_OFFSET
%MCI_SEQ_DIV_SMPTE_30                        = 4 + %MCI_SEQ_OFFSET

'  flags for the dwMaster field of MCI_SEQ_SET_PARMS parameter block
'  MCI_SET command, (dwFlags == MCI_SEQ_SET_MASTER)
%MCI_SEQ_FORMAT_SONGPTR                      = &H4001
%MCI_SEQ_FILE                                = &H4002
%MCI_SEQ_MIDI                                = &H4003
%MCI_SEQ_SMPTE                               = &H4004
%MCI_SEQ_NONE                                = 65533

%MCI_SEQ_MAPPER                              = 65535

'  flags for the dwItem field of MCI_STATUS_PARMS parameter block
%MCI_SEQ_STATUS_TEMPO                        = &H4002&
%MCI_SEQ_STATUS_PORT                         = &H4003&
%MCI_SEQ_STATUS_SLAVE                        = &H4007&
%MCI_SEQ_STATUS_MASTER                       = &H4008&
%MCI_SEQ_STATUS_OFFSET                       = &H4009&
%MCI_SEQ_STATUS_DIVTYPE                      = &H400A&

'  flags for the dwFlags parameter of MCI_SET command message
%MCI_SEQ_SET_TEMPO                           = &H10000
%MCI_SEQ_SET_PORT                            = &H20000
%MCI_SEQ_SET_SLAVE                           = &H40000
%MCI_SEQ_SET_MASTER                          = &H80000
%MCI_SEQ_SET_OFFSET                          = &H1000000

'  flags for dwFlags parameter of MCI_OPEN command message
%MCI_ANIM_OPEN_WS                            = &H10000
%MCI_ANIM_OPEN_PARENT                        = &H20000
%MCI_ANIM_OPEN_NOSTATIC                      = &H40000

'  flags for dwFlags parameter of MCI_PLAY command message
%MCI_ANIM_PLAY_SPEED                         = &H10000
%MCI_ANIM_PLAY_REVERSE                       = &H20000
%MCI_ANIM_PLAY_FAST                          = &H40000
%MCI_ANIM_PLAY_SLOW                          = &H80000
%MCI_ANIM_PLAY_SCAN                          = &H100000

'  flags for dwFlags parameter of MCI_STEP command message
%MCI_ANIM_STEP_REVERSE                       = &H10000
%MCI_ANIM_STEP_FRAMES                        = &H20000

'  flags for dwItem field of MCI_STATUS_PARMS parameter block
%MCI_ANIM_STATUS_SPEED                       = &H4001&
%MCI_ANIM_STATUS_FORWARD                     = &H4002&
%MCI_ANIM_STATUS_HWND                        = &H4003&
%MCI_ANIM_STATUS_HPAL                        = &H4004&
%MCI_ANIM_STATUS_STRETCH                     = &H4005&

'  flags for the dwFlags parameter of MCI_INFO command message
%MCI_ANIM_INFO_TEXT                          = &H10000

'  flags for dwItem field of MCI_GETDEVCAPS_PARMS parameter block
%MCI_ANIM_GETDEVCAPS_CAN_REVERSE             = &H4001&
%MCI_ANIM_GETDEVCAPS_FAST_RATE               = &H4002&
%MCI_ANIM_GETDEVCAPS_SLOW_RATE               = &H4003&
%MCI_ANIM_GETDEVCAPS_NORMAL_RATE             = &H4004&
%MCI_ANIM_GETDEVCAPS_PALETTES                = &H4006&
%MCI_ANIM_GETDEVCAPS_CAN_STRETCH             = &H4007&
%MCI_ANIM_GETDEVCAPS_MAX_WINDOWS             = &H4008&

'  flags for the MCI_REALIZE command message
%MCI_ANIM_REALIZE_NORM                       = &H10000
%MCI_ANIM_REALIZE_BKGD                       = &H20000

'  flags for dwFlags parameter of MCI_WINDOW command message
%MCI_ANIM_WINDOW_HWND                        = &H10000
%MCI_ANIM_WINDOW_STATE                       = &H40000
%MCI_ANIM_WINDOW_TEXT                        = &H80000
%MCI_ANIM_WINDOW_ENABLE_STRETCH              = &H100000
%MCI_ANIM_WINDOW_DISABLE_STRETCH             = &H200000

'  flags for hWnd field of MCI_ANIM_WINDOW_PARMS parameter block
'  MCI_WINDOW command message, (dwFlags == MCI_ANIM_WINDOW_HWND)
%MCI_ANIM_WINDOW_DEFAULT                     = &H0&

'  flags for dwFlags parameter of MCI_PUT command message
%MCI_ANIM_RECT                               = &H10000
%MCI_ANIM_PUT_SOURCE                         = &H20000      '  also  MCI_WHERE
%MCI_ANIM_PUT_DESTINATION                    = &H40000      '  also  MCI_WHERE

'  flags for dwFlags parameter of MCI_WHERE command message
%MCI_ANIM_WHERE_SOURCE                       = &H20000
%MCI_ANIM_WHERE_DESTINATION                  = &H40000

'  flags for dwFlags parameter of MCI_UPDATE command message
%MCI_ANIM_UPDATE_HDC                         = &H20000

'  flags for dwFlags parameter of MCI_OPEN command message
%MCI_OVLY_OPEN_WS                            = &H10000
%MCI_OVLY_OPEN_PARENT                        = &H20000

'  flags for dwFlags parameter of MCI_STATUS command message
%MCI_OVLY_STATUS_HWND                        = &H4001&
%MCI_OVLY_STATUS_STRETCH                     = &H4002&

'  flags for dwFlags parameter of MCI_INFO command message
%MCI_OVLY_INFO_TEXT                          = &H10000

'  flags for dwItem field of MCI_GETDEVCAPS_PARMS parameter block
%MCI_OVLY_GETDEVCAPS_CAN_STRETCH             = &H4001&
%MCI_OVLY_GETDEVCAPS_CAN_FREEZE              = &H4002&
%MCI_OVLY_GETDEVCAPS_MAX_WINDOWS             = &H4003&

'  flags for dwFlags parameter of MCI_WINDOW command message
%MCI_OVLY_WINDOW_HWND                        = &H10000
%MCI_OVLY_WINDOW_STATE                       = &H40000
%MCI_OVLY_WINDOW_TEXT                        = &H80000
%MCI_OVLY_WINDOW_ENABLE_STRETCH              = &H100000
%MCI_OVLY_WINDOW_DISABLE_STRETCH             = &H200000

'  flags for hWnd parameter of MCI_OVLY_WINDOW_PARMS parameter block
%MCI_OVLY_WINDOW_DEFAULT                     = &H0&

'  flags for dwFlags parameter of MCI_PUT command message
%MCI_OVLY_RECT                               = &H10000
%MCI_OVLY_PUT_SOURCE                         = &H20000
%MCI_OVLY_PUT_DESTINATION                    = &H40000
%MCI_OVLY_PUT_FRAME                          = &H80000
%MCI_OVLY_PUT_VIDEO                          = &H100000

'  flags for dwFlags parameter of MCI_WHERE command message
%MCI_OVLY_WHERE_SOURCE                       = &H20000
%MCI_OVLY_WHERE_DESTINATION                  = &H40000
%MCI_OVLY_WHERE_FRAME                        = &H80000
%MCI_OVLY_WHERE_VIDEO                        = &H100000

%CAPS1                                       = 94              '  other caps
%C1_TRANSPARENT                              = &H1     '  new raster cap
%NEWTRANSPARENT                              = 3  '  use with SetBkMode()

%QUERYROPSUPPORT                             = 40  '  use to determine ROP support

%SELECTDIB                                   = 41  '  DIB.DRV select dib escape

' ----------------
' shell association database management functions
' -----------------

'  error values for ShellExecute() beyond the regular WinExec() codes
%SE_ERR_SHARE                                = 26
%SE_ERR_ASSOCINCOMPLETE                      = 27
%SE_ERR_DDETIMEOUT                           = 28
%SE_ERR_DDEFAIL                              = 29
%SE_ERR_DDEBUSY                              = 30
%SE_ERR_NOASSOC                              = 31

%PRINTER_CONTROL_PAUSE                       = 1
%PRINTER_CONTROL_RESUME                      = 2
%PRINTER_CONTROL_PURGE                       = 3

%PRINTER_STATUS_PAUSED                       = &H1
%PRINTER_STATUS_ERROR                        = &H2
%PRINTER_STATUS_PENDING_DELETION             = &H4
%PRINTER_STATUS_PAPER_JAM                    = &H8
%PRINTER_STATUS_PAPER_OUT                    = &H10
%PRINTER_STATUS_MANUAL_FEED                  = &H20
%PRINTER_STATUS_PAPER_PROBLEM                = &H40
%PRINTER_STATUS_OFFLINE                      = &H80
%PRINTER_STATUS_IO_ACTIVE                    = &H100
%PRINTER_STATUS_BUSY                         = &H200
%PRINTER_STATUS_PRINTING                     = &H400
%PRINTER_STATUS_OUTPUT_BIN_FULL              = &H800
%PRINTER_STATUS_NOT_AVAILABLE                = &H1000
%PRINTER_STATUS_WAITING                      = &H2000
%PRINTER_STATUS_PROCESSING                   = &H4000
%PRINTER_STATUS_INITIALIZING                 = &H8000
%PRINTER_STATUS_WARMING_UP                   = &H10000
%PRINTER_STATUS_TONER_LOW                    = &H20000
%PRINTER_STATUS_NO_TONER                     = &H40000
%PRINTER_STATUS_PAGE_PUNT                    = &H80000
%PRINTER_STATUS_USER_INTERVENTION            = &H100000
%PRINTER_STATUS_OUT_OF_MEMORY                = &H200000
%PRINTER_STATUS_DOOR_OPEN                    = &H400000

%PRINTER_ATTRIBUTE_QUEUED                    = &H1
%PRINTER_ATTRIBUTE_DIRECT                    = &H2
%PRINTER_ATTRIBUTE_DEFAULT                   = &H4
%PRINTER_ATTRIBUTE_SHARED                    = &H8
%PRINTER_ATTRIBUTE_NETWORK                   = &H10
%PRINTER_ATTRIBUTE_HIDDEN                    = &H20
%PRINTER_ATTRIBUTE_LOCAL                     = &H40

%NO_PRIORITY                                 = 0
%MAX_PRIORITY                                = 99
%MIN_PRIORITY                                = 1
%DEF_PRIORITY                                = 1

%JOB_CONTROL_PAUSE                           = 1
%JOB_CONTROL_RESUME                          = 2
%JOB_CONTROL_CANCEL                          = 3
%JOB_CONTROL_RESTART                         = 4

%JOB_STATUS_PAUSED                           = &H1
%JOB_STATUS_ERROR                            = &H2
%JOB_STATUS_DELETING                         = &H4
%JOB_STATUS_SPOOLING                         = &H8
%JOB_STATUS_PRINTING                         = &H10
%JOB_STATUS_OFFLINE                          = &H20
%JOB_STATUS_PAPEROUT                         = &H40
%JOB_STATUS_PRINTED                          = &H80

%JOB_POSITION_UNSPECIFIED                    = 0

%FORM_BUILTIN                                = &H1

%PRINTER_CONTROL_SET_STATUS                  = 4
%PRINTER_ATTRIBUTE_WORK_OFFLINE              = &H400
%PRINTER_ATTRIBUTE_ENABLE_BIDI               = &H800
%JOB_CONTROL_DELETE                          = 5
%JOB_STATUS_USER_INTERVENTION                = &H10000

%DI_CHANNEL                                  = 1                  '  start direct read/write channel,
%DI_READ_SPOOL_JOB                           = 3

%DI_MASK                                     = &H0001
%DI_IMAGE                                    = &H0002
%DI_NORMAL                                   = &H0003
%DI_COMPAT                                   = &H0004
%DI_DEFAULTSIZE                              = &H0008

%PORT_TYPE_WRITE                             = &H1
%PORT_TYPE_READ                              = &H2
%PORT_TYPE_REDIRECTED                        = &H4
%PORT_TYPE_NET_ATTACHED                      = &H8

%PRINTER_ENUM_DEFAULT                        = &H1
%PRINTER_ENUM_LOCAL                          = &H2
%PRINTER_ENUM_CONNECTIONS                    = &H4
%PRINTER_ENUM_FAVORITE                       = &H4
%PRINTER_ENUM_NAME                           = &H8
%PRINTER_ENUM_REMOTE                         = &H10
%PRINTER_ENUM_SHARED                         = &H20
%PRINTER_ENUM_NETWORK                        = &H40

%PRINTER_ENUM_EXPAND                         = &H4000
%PRINTER_ENUM_CONTAINER                      = &H8000

%PRINTER_ENUM_ICONMASK                       = &HFF0000
%PRINTER_ENUM_ICON1                          = &H10000
%PRINTER_ENUM_ICON2                          = &H20000
%PRINTER_ENUM_ICON3                          = &H40000
%PRINTER_ENUM_ICON4                          = &H80000
%PRINTER_ENUM_ICON5                          = &H100000
%PRINTER_ENUM_ICON6                          = &H200000
%PRINTER_ENUM_ICON7                          = &H400000
%PRINTER_ENUM_ICON8                          = &H800000

%PRINTER_CHANGE_ADD_PRINTER                  = &H1
%PRINTER_CHANGE_SET_PRINTER                  = &H2
%PRINTER_CHANGE_DELETE_PRINTER               = &H4
%PRINTER_CHANGE_PRINTER                      = &HFF
%PRINTER_CHANGE_ADD_JOB                      = &H100
%PRINTER_CHANGE_SET_JOB                      = &H200
%PRINTER_CHANGE_DELETE_JOB                   = &H400
%PRINTER_CHANGE_WRITE_JOB                    = &H800
%PRINTER_CHANGE_JOB                          = &HFF00
%PRINTER_CHANGE_ADD_FORM                     = &H10000
%PRINTER_CHANGE_SET_FORM                     = &H20000
%PRINTER_CHANGE_DELETE_FORM                  = &H40000
%PRINTER_CHANGE_FORM                         = &H70000
%PRINTER_CHANGE_ADD_PORT                     = &H100000
%PRINTER_CHANGE_CONFIGURE_PORT               = &H200000
%PRINTER_CHANGE_DELETE_PORT                  = &H400000
%PRINTER_CHANGE_PORT                         = &H700000
%PRINTER_CHANGE_ADD_PRINT_PROCESSOR          = &H1000000
%PRINTER_CHANGE_DELETE_PRINT_PROCESSOR       = &H4000000
%PRINTER_CHANGE_PRINT_PROCESSOR              = &H7000000
%PRINTER_CHANGE_ADD_PRINTER_DRIVER           = &H10000000
%PRINTER_CHANGE_DELETE_PRINTER_DRIVER        = &H40000000
%PRINTER_CHANGE_PRINTER_DRIVER               = &H70000000
%PRINTER_CHANGE_TIMEOUT                      = &H80000000
%PRINTER_CHANGE_ALL                          = &H7777FFFF

%PRINTER_ERROR_INFORMATION                   = &H80000000
%PRINTER_ERROR_WARNING                       = &H40000000
%PRINTER_ERROR_SEVERE                        = &H20000000

%PRINTER_ERROR_OUTOFPAPER                    = &H1
%PRINTER_ERROR_JAM                           = &H2
%PRINTER_ERROR_OUTOFTONER                    = &H4

%SERVER_ACCESS_ADMINISTER                    = &H1
%SERVER_ACCESS_ENUMERATE                     = &H2

%PRINTER_ACCESS_ADMINISTER                   = &H4
%PRINTER_ACCESS_USE                          = &H8

%JOB_ACCESS_ADMINISTER                       = &H10

' Access rights for print servers

%SERVER_ALL_ACCESS                           = %STANDARD_RIGHTS_REQUIRED OR %SERVER_ACCESS_ADMINISTER OR %SERVER_ACCESS_ENUMERATE
%SERVER_READ                                 = %STANDARD_RIGHTS_READ OR %SERVER_ACCESS_ENUMERATE
%SERVER_WRITE                                = %STANDARD_RIGHTS_WRITE OR %SERVER_ACCESS_ADMINISTER OR %SERVER_ACCESS_ENUMERATE
%SERVER_EXECUTE                              = %STANDARD_RIGHTS_EXECUTE OR %SERVER_ACCESS_ENUMERATE

' Access rights for printers
%PRINTER_ALL_ACCESS                          = %STANDARD_RIGHTS_REQUIRED OR %PRINTER_ACCESS_ADMINISTER OR %PRINTER_ACCESS_USE
%PRINTER_READ                                = %STANDARD_RIGHTS_READ OR %PRINTER_ACCESS_USE
%PRINTER_WRITE                               = %STANDARD_RIGHTS_WRITE OR %PRINTER_ACCESS_USE
%PRINTER_EXECUTE                             = %STANDARD_RIGHTS_EXECUTE OR %PRINTER_ACCESS_USE

' Access rights for jobs
%JOB_ALL_ACCESS                              = %STANDARD_RIGHTS_REQUIRED OR %JOB_ACCESS_ADMINISTER
%JOB_READ                                    = %STANDARD_RIGHTS_READ OR %JOB_ACCESS_ADMINISTER
%JOB_WRITE                                   = %STANDARD_RIGHTS_WRITE OR %JOB_ACCESS_ADMINISTER
%JOB_EXECUTE                                 = %STANDARD_RIGHTS_EXECUTE OR %JOB_ACCESS_ADMINISTER

'  Windows Network support

'  RESOURCE ENUMERATION

%RESOURCE_CONNECTED                          = &H1
%RESOURCE_PUBLICNET                          = &H2
%RESOURCE_GLOBALNET                          = &H2
%RESOURCE_REMEMBERED                         = &H3
%RESOURCE_RECENT                             = &H4
%RESOURCE_CONTEXT                            = &H5

%RESOURCETYPE_ANY                            = &H0
%RESOURCETYPE_DISK                           = &H1
%RESOURCETYPE_PRINT                          = &H2
%RESOURCETYPE_UNKNOWN                        = &HFFFF

%RESOURCEUSAGE_CONNECTABLE                   = &H1
%RESOURCEUSAGE_CONTAINER                     = &H2
%RESOURCEUSAGE_RESERVED                      = &H80000000

%RESOURCEDISPLAYTYPE_GENERIC                 = &H0
%RESOURCEDISPLAYTYPE_DOMAIN                  = &H1
%RESOURCEDISPLAYTYPE_SERVER                  = &H2
%RESOURCEDISPLAYTYPE_SHARE                   = &H3
%RESOURCEDISPLAYTYPE_FILE                    = &H4
%RESOURCEDISPLAYTYPE_GROUP                   = &H5

%CONNECT_UPDATE_PROFILE                      = &H1

%WN_SUCCESS                                  = %NO_ERROR
%WN_NOT_SUPPORTED                            = %ERROR_NOT_SUPPORTED
%WN_NET_ERROR                                = %ERROR_UNEXP_NET_ERR
%WN_MORE_DATA                                = %ERROR_MORE_DATA
%WN_BAD_POINTER                              = %ERROR_INVALID_ADDRESS
%WN_BAD_VALUE                                = %ERROR_INVALID_PARAMETER
%WN_BAD_PASSWORD                             = %ERROR_INVALID_PASSWORD
%WN_ACCESS_DENIED                            = %ERROR_ACCESS_DENIED
%WN_FUNCTION_BUSY                            = %ERROR_BUSY
%WN_WINDOWS_ERROR                            = %ERROR_UNEXP_NET_ERR
%WN_BAD_USER                                 = %ERROR_BAD_USERNAME
%WN_OUT_OF_MEMORY                            = %ERROR_NOT_ENOUGH_MEMORY
%WN_NO_NETWORK                               = %ERROR_NO_NETWORK
%WN_EXTENDED_ERROR                           = %ERROR_EXTENDED_ERROR

' Connection

%WN_NOT_CONNECTED                            = %ERROR_NOT_CONNECTED
%WN_OPEN_FILES                               = %ERROR_OPEN_FILES
%WN_DEVICE_IN_USE                            = %ERROR_DEVICE_IN_USE
%WN_BAD_NETNAME                              = %ERROR_BAD_NET_NAME
%WN_BAD_LOCALNAME                            = %ERROR_BAD_DEVICE
%WN_ALREADY_CONNECTED                        = %ERROR_ALREADY_ASSIGNED
%WN_DEVICE_ERROR                             = %ERROR_GEN_FAILURE
%WN_CONNECTION_CLOSED                        = %ERROR_CONNECTION_UNAVAIL
%WN_NO_NET_OR_BAD_PATH                       = %ERROR_NO_NET_OR_BAD_PATH
%WN_BAD_PROVIDER                             = %ERROR_BAD_PROVIDER
%WN_CANNOT_OPEN_PROFILE                      = %ERROR_CANNOT_OPEN_PROFILE
%WN_BAD_PROFILE                              = %ERROR_BAD_PROFILE

' Enumeration

%WN_BAD_HANDLE                               = %ERROR_INVALID_HANDLE
%WN_NO_MORE_ENTRIES                          = %ERROR_NO_MORE_ITEMS
%WN_NOT_CONTAINER                            = %ERROR_NOT_CONTAINER

%WN_NO_ERROR                                 = %NO_ERROR

' This section contains the definitions
' for portable NetBIOS 3.0 support.

%NCBNAMSZ                                    = 16  '  absolute length of a net name
%MAX_LANA                                    = 254  '  lana's in range 0 to MAX_LANA

%NAME_FLAGS_MASK                             = &H87

%GROUP_NAME                                  = &H80
%UNIQUE_NAME                                 = &H0

%REGISTERING                                 = &H0
%REGISTERED                                  = &H4
%DEREGISTERED                                = &H5
%DUPLICATE                                   = &H6
%DUPLICATE_DEREG                             = &H7

' Values for state
%LISTEN_OUTSTANDING                          = &H1
%CALL_PENDING                                = &H2
%SESSION_ESTABLISHED                         = &H3
%HANGUP_PENDING                              = &H4
%HANGUP_COMPLETE                             = &H5
%SESSION_ABORTED                             = &H6

' NCB Command codes
%NCBCALL                                     = &H10  '  NCB CALL
%NCBLISTEN                                   = &H11  '  NCB LISTEN
%NCBHANGUP                                   = &H12  '  NCB HANG UP
%NCBSEND                                     = &H14  '  NCB SEND
%NCBRECV                                     = &H15  '  NCB RECEIVE
%NCBRECVANY                                  = &H16  '  NCB RECEIVE ANY
%NCBCHAINSEND                                = &H17  '  NCB CHAIN SEND
%NCBDGSEND                                   = &H20  '  NCB SEND DATAGRAM
%NCBDGRECV                                   = &H21  '  NCB RECEIVE DATAGRAM
%NCBDGSENDBC                                 = &H22  '  NCB SEND BROADCAST DATAGRAM
%NCBDGRECVBC                                 = &H23  '  NCB RECEIVE BROADCAST DATAGRAM
%NCBADDNAME                                  = &H30  '  NCB ADD NAME
%NCBDELNAME                                  = &H31  '  NCB DELETE NAME
%NCBRESET                                    = &H32  '  NCB RESET
%NCBASTAT                                    = &H33  '  NCB ADAPTER STATUS
%NCBSSTAT                                    = &H34  '  NCB SESSION STATUS
%NCBCANCEL                                   = &H35  '  NCB CANCEL
%NCBADDGRNAME                                = &H36  '  NCB ADD GROUP NAME
%NCBENUM                                     = &H37  '  NCB ENUMERATE LANA NUMBERS
%NCBUNLINK                                   = &H70  '  NCB UNLINK
%NCBSENDNA                                   = &H71  '  NCB SEND NO ACK
%NCBCHAINSENDNA                              = &H72  '  NCB CHAIN SEND NO ACK
%NCBLANSTALERT                               = &H73  '  NCB LAN STATUS ALERT
%NCBACTION                                   = &H77  '  NCB ACTION
%NCBFINDNAME                                 = &H78  '  NCB FIND NAME
%NCBTRACE                                    = &H79  '  NCB TRACE

%ASYNCH                                      = &H80  '  high bit set == asynchronous

' NCB Return codes
%NRC_GOODRET                                 = &H0   '  good return
'  also returned when ASYNCH request accepted
%NRC_BUFLEN                                  = &H1   '  illegal buffer length
%NRC_ILLCMD                                  = &H3   '  illegal command
%NRC_CMDTMO                                  = &H5   '  command timed out
%NRC_INCOMP                                  = &H6   '  message incomplete, issue another command
%NRC_BADDR                                   = &H7   '  illegal buffer address
%NRC_SNUMOUT                                 = &H8   '  session number out of range
%NRC_NORES                                   = &H9   '  no resource available
%NRC_SCLOSED                                 = &HA   '  session closed
%NRC_CMDCAN                                  = &HB   '  command cancelled
%NRC_DUPNAME                                 = &HD   '  duplicate name
%NRC_NAMTFUL                                 = &HE   '  name table full
%NRC_ACTSES                                  = &HF   '  no deletions, name has active sessions
%NRC_LOCTFUL                                 = &H11  '  local session table full
%NRC_REMTFUL                                 = &H12  '  remote session table full
%NRC_ILLNN                                   = &H13  '  illegal name number
%NRC_NOCALL                                  = &H14  '  no callname
%NRC_NOWILD                                  = &H15  '  cannot put  in NCB_NAME
%NRC_INUSE                                   = &H16  '  name in use on remote adapter
%NRC_NAMERR                                  = &H17  '  name deleted
%NRC_SABORT                                  = &H18  '  session ended abnormally
%NRC_NAMCONF                                 = &H19  '  name conflict detected
%NRC_IFBUSY                                  = &H21  '  interface busy, IRET before retrying
%NRC_TOOMANY                                 = &H22  '  too many commands outstanding, retry later
%NRC_BRIDGE                                  = &H23  '  ncb_lana_num field invalid
%NRC_CANOCCR                                 = &H24  '  command completed while cancel occurring
%NRC_CANCEL                                  = &H26  '  command not valid to cancel
%NRC_DUPENV                                  = &H30  '  name defined by anther local process
%NRC_ENVNOTDEF                               = &H34  '  environment undefined. RESET required
%NRC_OSRESNOTAV                              = &H35  '  required OS resources exhausted
%NRC_MAXAPPS                                 = &H36  '  max number of applications exceeded
%NRC_NOSAPS                                  = &H37  '  no saps available for netbios
%NRC_NORESOURCES                             = &H38  '  requested resources are not available
%NRC_INVADDRESS                              = &H39  '  invalid ncb address or length > segment
%NRC_INVDDID                                 = &H3B  '  invalid NCB DDID
%NRC_LOCKFAIL                                = &H3C  '  lock of user area failed
%NRC_OPENERR                                 = &H3F  '  NETBIOS not loaded
%NRC_SYSTEM                                  = &H40  '  system error

%NRC_PENDING                                 = &HFF  '  asynchronous command is not yet finished

' Legal values for expression in except().
%EXCEPTION_EXECUTE_HANDLER                   = 1
%EXCEPTION_CONTINUE_SEARCH                   = 0
%EXCEPTION_CONTINUE_EXECUTION                = -1

' UI dialog constants and types

' ----Constants--------------------------------------------------------------
%ctlFirst                                    = &H400
%ctlLast                                     = &H4FF
'  Push buttons
%psh1                                        = &H400
%psh2                                        = &H401
%psh3                                        = &H402
%psh4                                        = &H403
%psh5                                        = &H404
%psh6                                        = &H405
%psh7                                        = &H406
%psh8                                        = &H407
%psh9                                        = &H408
%psh10                                       = &H409
%psh11                                       = &H40A
%psh12                                       = &H40B
%psh13                                       = &H40C
%psh14                                       = &H40D
%psh15                                       = &H40E
%pshHelp                                     = %psh15
%psh16                                       = &H40F
'  Checkboxes
%chx1                                        = &H410
%chx2                                        = &H411
%chx3                                        = &H412
%chx4                                        = &H413
%chx5                                        = &H414
%chx6                                        = &H415
%chx7                                        = &H416
%chx8                                        = &H417
%chx9                                        = &H418
%chx10                                       = &H419
%chx11                                       = &H41A
%chx12                                       = &H41B
%chx13                                       = &H41C
%chx14                                       = &H41D
%chx15                                       = &H41E
%chx16                                       = &H41D
'  Radio buttons
%rad1                                        = &H420
%rad2                                        = &H421
%rad3                                        = &H422
%rad4                                        = &H423
%rad5                                        = &H424
%rad6                                        = &H425
%rad7                                        = &H426
%rad8                                        = &H427
%rad9                                        = &H428
%rad10                                       = &H429
%rad11                                       = &H42A
%rad12                                       = &H42B
%rad13                                       = &H42C
%rad14                                       = &H42D
%rad15                                       = &H42E
%rad16                                       = &H42F
'  Groups, frames, rectangles, and icons
%grp1                                        = &H430
%grp2                                        = &H431
%grp3                                        = &H432
%grp4                                        = &H433
%frm1                                        = &H434
%frm2                                        = &H435
%frm3                                        = &H436
%frm4                                        = &H437
%rct1                                        = &H438
%rct2                                        = &H439
%rct3                                        = &H43A
%rct4                                        = &H43B
%ico1                                        = &H43C
%ico2                                        = &H43D
%ico3                                        = &H43E
%ico4                                        = &H43F
'  Static text
%stc1                                        = &H440
%stc2                                        = &H441
%stc3                                        = &H442
%stc4                                        = &H443
%stc5                                        = &H444
%stc6                                        = &H445
%stc7                                        = &H446
%stc8                                        = &H447
%stc9                                        = &H448
%stc10                                       = &H449
%stc11                                       = &H44A
%stc12                                       = &H44B
%stc13                                       = &H44C
%stc14                                       = &H44D
%stc15                                       = &H44E
%stc16                                       = &H44F
%stc17                                       = &H450
%stc18                                       = &H451
%stc19                                       = &H452
%stc20                                       = &H453
%stc21                                       = &H454
%stc22                                       = &H455
%stc23                                       = &H456
%stc24                                       = &H457
%stc25                                       = &H458
%stc26                                       = &H459
%stc27                                       = &H45A
%stc28                                       = &H45B
%stc29                                       = &H45C
%stc30                                       = &H45D
%stc31                                       = &H45E
%stc32                                       = &H45F
'  Listboxes
%lst1                                        = &H460
%lst2                                        = &H461
%lst3                                        = &H462
%lst4                                        = &H463
%lst5                                        = &H464
%lst6                                        = &H465
%lst7                                        = &H466
%lst8                                        = &H467
%lst9                                        = &H468
%lst10                                       = &H469
%lst11                                       = &H46A
%lst12                                       = &H46B
%lst13                                       = &H46C
%lst14                                       = &H46D
%lst15                                       = &H46E
%lst16                                       = &H46F
'  Combo boxes
%cmb1                                        = &H470
%cmb2                                        = &H471
%cmb3                                        = &H472
%cmb4                                        = &H473
%cmb5                                        = &H474
%cmb6                                        = &H475
%cmb7                                        = &H476
%cmb8                                        = &H477
%cmb9                                        = &H478
%cmb10                                       = &H479
%cmb11                                       = &H47A
%cmb12                                       = &H47B
%cmb13                                       = &H47C
%cmb14                                       = &H47D
%cmb15                                       = &H47E
%cmb16                                       = &H47F
'  Edit controls
%edt1                                        = &H480
%edt2                                        = &H481
%edt3                                        = &H482
%edt4                                        = &H483
%edt5                                        = &H484
%edt6                                        = &H485
%edt7                                        = &H486
%edt8                                        = &H487
%edt9                                        = &H488
%edt10                                       = &H489
%edt11                                       = &H48A
%edt12                                       = &H48B
%edt13                                       = &H48C
%edt14                                       = &H48D
%edt15                                       = &H48E
%edt16                                       = &H48F
'  Scroll bars
%scr1                                        = &H490
%scr2                                        = &H491
%scr3                                        = &H492
%scr4                                        = &H493
%scr5                                        = &H494
%scr6                                        = &H495
%scr7                                        = &H496
%scr8                                        = &H497

%FILEOPENORD                                 = 1536
%MULTIFILEOPENORD                            = 1537
%PRINTDLGORD                                 = 1538
%PRNSETUPDLGORD                              = 1539
%FINDDLGORD                                  = 1540
%REPLACEDLGORD                               = 1541
%FONTDLGORD                                  = 1542
%FORMATDLGORD31                              = 1543
%FORMATDLGORD30                              = 1544

%HKEY_CLASSES_ROOT                           = &H80000000
%HKEY_CURRENT_USER                           = &H80000001
%HKEY_LOCAL_MACHINE                          = &H80000002
%HKEY_USERS                                  = &H80000003
%HKEY_PERFORMANCE_DATA                       = &H80000004
%HKEY_CURRENT_CONFIG                         = &H80000005
%HKEY_DYN_DATA                               = &H80000006
%HKEY_DYNAMIC_DATA                           = %HKEY_DYN_DATA

%HKCR                                        = %HKEY_CLASSES_ROOT
%HKCU                                        = %HKEY_CURRENT_USER
%HKLM                                        = %HKEY_LOCAL_MACHINE
%HKU                                         = %HKEY_USERS
%HKPD                                        = %HKEY_PERFORMANCE_DATA
%HKCC                                        = %HKEY_CURRENT_CONFIG
%HKDD                                        = %HKEY_DYN_DATA

' Value to indicate no change to an optional parameter
%SERVICE_NO_CHANGE                           = &HFFFF

' Service State -- for Enum Requests (Bit Mask)
%SERVICE_ACTIVE                              = &H1
%SERVICE_INACTIVE                            = &H2
%SERVICE_STATE_ALL                           = %SERVICE_ACTIVE OR %SERVICE_INACTIVE

' Controls
%SERVICE_CONTROL_STOP                        = &H1
%SERVICE_CONTROL_PAUSE                       = &H2
%SERVICE_CONTROL_CONTINUE                    = &H3
%SERVICE_CONTROL_INTERROGATE                 = &H4
%SERVICE_CONTROL_SHUTDOWN                    = &H5

' Service State -- for CurrentState
%SERVICE_STOPPED                             = &H1
%SERVICE_START_PENDING                       = &H2
%SERVICE_STOP_PENDING                        = &H3
%SERVICE_RUNNING                             = &H4
%SERVICE_CONTINUE_PENDING                    = &H5
%SERVICE_PAUSE_PENDING                       = &H6
%SERVICE_PAUSED                              = &H7

' Controls Accepted  (Bit Mask)
%SERVICE_ACCEPT_STOP                         = &H1
%SERVICE_ACCEPT_PAUSE_CONTINUE               = &H2
%SERVICE_ACCEPT_SHUTDOWN                     = &H4

' Service Control Manager object specific access types
%SC_MANAGER_CONNECT                          = &H1
%SC_MANAGER_CREATE_SERVICE                   = &H2
%SC_MANAGER_ENUMERATE_SERVICE                = &H4
%SC_MANAGER_LOCK                             = &H8
%SC_MANAGER_QUERY_LOCK_STATUS                = &H10
%SC_MANAGER_MODIFY_BOOT_CONFIG               = &H20

%SC_MANAGER_ALL_ACCESS                       = %STANDARD_RIGHTS_REQUIRED OR %SC_MANAGER_CONNECT OR %SC_MANAGER_CREATE_SERVICE OR %SC_MANAGER_ENUMERATE_SERVICE OR %SC_MANAGER_LOCK _
                                               OR %SC_MANAGER_QUERY_LOCK_STATUS OR %SC_MANAGER_MODIFY_BOOT_CONFIG

' Service object specific access type
%SERVICE_QUERY_CONFIG                        = &H1
%SERVICE_CHANGE_CONFIG                       = &H2
%SERVICE_QUERY_STATUS                        = &H4
%SERVICE_ENUMERATE_DEPENDENTS                = &H8
%SERVICE_START                               = &H10
%SERVICE_STOP                                = &H20
%SERVICE_PAUSE_CONTINUE                      = &H40
%SERVICE_INTERROGATE                         = &H80
%SERVICE_USER_DEFINED_CONTROL                = &H100

%SERVICE_ALL_ACCESS                          = %STANDARD_RIGHTS_REQUIRED OR %SERVICE_QUERY_CONFIG OR %SERVICE_CHANGE_CONFIG OR %SERVICE_QUERY_STATUS _
                                               OR %SERVICE_ENUMERATE_DEPENDENTS OR %SERVICE_START OR %SERVICE_STOP OR %SERVICE_PAUSE_CONTINUE OR %SERVICE_INTERROGATE OR %SERVICE_USER_DEFINED_CONTROL


%PERF_DATA_VERSION                           = 1
%PERF_DATA_REVISION                          = 1

%PERF_NO_INSTANCES                           = -1  '  no instances

' The counter type is the "or" of the following values as described below
'
' select one of the following to indicate the counter's data size
%PERF_SIZE_DWORD                             = &H0
%PERF_SIZE_LARGE                             = &H100
%PERF_SIZE_ZERO                              = &H200       '  for Zero Length fields
%PERF_SIZE_VARIABLE_LEN                      = &H300       '  length is in CounterLength field of Counter Definition struct

' select one of the following values to indicate the counter field usage
%PERF_TYPE_NUMBER                            = &H0         '  a number (not a counter)
%PERF_TYPE_COUNTER                           = &H400       '  an increasing numeric value
%PERF_TYPE_TEXT                              = &H800       '  a text field
%PERF_TYPE_ZERO                              = &HC00       '  displays a zero

' If the PERF_TYPE_NUMBER field was selected, then select one of the
' following to describe the Number
%PERF_NUMBER_HEX                             = &H0         '  display as HEX value
%PERF_NUMBER_DECIMAL                         = &H10000     '  display as a decimal integer
%PERF_NUMBER_DEC_1000                        = &H20000     '  display as a decimal/1000
'
' If the PERF_TYPE_COUNTER value was selected then select one of the
' following to indicate the type of counter
%PERF_COUNTER_VALUE                          = &H0         '  display counter value
%PERF_COUNTER_RATE                           = &H10000     '  divide ctr / delta time
%PERF_COUNTER_FRACTION                       = &H20000     '  divide ctr / base
%PERF_COUNTER_BASE                           = &H30000     '  base value used in fractions
%PERF_COUNTER_ELAPSED                        = &H40000     '  subtract counter from current time
%PERF_COUNTER_QUEUELEN                       = &H50000     '  Use Queuelen processing func.
%PERF_COUNTER_HISTOGRAM                      = &H60000     '  Counter begins or ends a histogram

' If the PERF_TYPE_TEXT value was selected, then select one of the
' following to indicate the type of TEXT data.
%PERF_TEXT_UNICODE                           = &H0         '  type of text in text field
%PERF_TEXT_ASCII                             = &H10000     '  ASCII using the CodePage field

' Timer SubTypes
%PERF_TIMER_TICK                             = &H0         '  use system perf. freq for base
%PERF_TIMER_100NS                            = &H100000    '  use 100 NS timer time base units
%PERF_OBJECT_TIMER                           = &H200000    '  use the object timer freq

' Any types that have calculations performed can use one or more of
' the following calculation modification flags listed here
%PERF_DELTA_COUNTER                          = &H400000    '  compute difference first
%PERF_DELTA_BASE                             = &H800000    '  compute base diff as well
%PERF_INVERSE_COUNTER                        = &H1000000   '  show as 1.00-value (assumes:
%PERF_MULTI_COUNTER                          = &H2000000   '  sum of multiple instances

' Select one of the following values to indicate the display suffix (if any)
%PERF_DISPLAY_NO_SUFFIX                      = &H0         '  no suffix
%PERF_DISPLAY_PER_SEC                        = &H10000000  '  "/sec"
%PERF_DISPLAY_PERCENT                        = &H20000000  '  "%"
%PERF_DISPLAY_SECONDS                        = &H30000000  '  "secs"
%PERF_DISPLAY_NOSHOW                         = &H40000000  '  value is not displayed

' Predefined counter types

' 32-bit Counter.  Divide delta by delta time.  Display suffix: "/sec"
%PERF_COUNTER_COUNTER                        = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_TICK OR %PERF_DELTA_COUNTER OR %PERF_DISPLAY_PER_SEC

' 64-bit Timer.  Divide delta by delta time.  Display suffix: "%"
%PERF_COUNTER_TIMER                          = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_TICK OR %PERF_DELTA_COUNTER OR %PERF_DISPLAY_PERCENT

' Queue Length Space-Time Product. Divide delta by delta time. No Display Suffix.
%PERF_COUNTER_QUEUELEN_TYPE                  = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_QUEUELEN OR %PERF_TIMER_TICK OR %PERF_DELTA_COUNTER OR %PERF_DISPLAY_NO_SUFFIX

' 64-bit Counter.  Divide delta by delta time. Display Suffix: "/sec"
%PERF_COUNTER_BULK_COUNT                     = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_TICK OR %PERF_DELTA_COUNTER OR %PERF_DISPLAY_PER_SEC

' Indicates the counter is not a  counter but rather Unicode text Display as text.
%PERF_COUNTER_TEXT                           = %PERF_SIZE_VARIABLE_LEN OR %PERF_TYPE_TEXT OR %PERF_TEXT_UNICODE OR %PERF_DISPLAY_NO_SUFFIX

' Indicates the data is a counter  which should not be
' time averaged on display (such as an error counter on a serial line)
' Display as is.  No Display Suffix.
%PERF_COUNTER_RAWCOUNT                       = %PERF_SIZE_DWORD OR %PERF_TYPE_NUMBER OR %PERF_NUMBER_DECIMAL OR %PERF_DISPLAY_NO_SUFFIX

' A count which is either 1 or 0 on each sampling interrupt (% busy)
' Divide delta by delta base. Display Suffix: "%"
%PERF_SAMPLE_FRACTION                        = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_FRACTION OR %PERF_DELTA_COUNTER OR %PERF_DELTA_BASE OR %PERF_DISPLAY_PERCENT

' A count which is sampled on each sampling interrupt (queue length)
' Divide delta by delta time. No Display Suffix.
%PERF_SAMPLE_COUNTER                         = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_TICK OR %PERF_DELTA_COUNTER OR %PERF_DISPLAY_NO_SUFFIX

' A label: no data is associated with this counter (it has 0 length)
' Do not display.
%PERF_COUNTER_NODATA                         = %PERF_SIZE_ZERO OR %PERF_DISPLAY_NOSHOW

' 64-bit Timer inverse (e.g., idle is measured, but display busy as Integer)
' Display 100 - delta divided by delta time.  Display suffix: "%"
%PERF_COUNTER_TIMER_INV                      = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_TICK OR %PERF_DELTA_COUNTER OR %PERF_INVERSE_COUNTER OR %PERF_DISPLAY_PERCENT

' The divisor for a sample, used with the previous counter to form a
' sampled %.  You must check for >0 before dividing by this!  This
' counter will directly follow the  numerator counter.  It should not
' be displayed to the user.
%PERF_SAMPLE_BASE                            = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_BASE OR %PERF_DISPLAY_NOSHOW OR &H1         '  for compatibility with pre-beta versions

' A timer which, when divided by an average base, produces a time
' in seconds which is the average time of some operation.  This
' timer times total operations, and  the base is the number of opera-
' tions.  Display Suffix: "sec"
%PERF_AVERAGE_TIMER                          = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_FRACTION OR %PERF_DISPLAY_SECONDS

' Used as the denominator in the computation of time or count
' averages.  Must directly follow the numerator counter.  Not dis-
' played to the user.
%PERF_AVERAGE_BASE                           = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_BASE OR %PERF_DISPLAY_NOSHOW OR &H2         '  for compatibility with pre-beta versions

' A bulk count which, when divided (typically) by the number of
' operations, gives (typically) the number of bytes per operation.
' No Display Suffix.
%PERF_AVERAGE_BULK                           = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_FRACTION OR %PERF_DISPLAY_NOSHOW

' 64-bit Timer in 100 nsec units. Display delta divided by
' delta time.  Display suffix: "%"
%PERF_100NSEC_TIMER                          = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_100NS OR %PERF_DELTA_COUNTER OR %PERF_DISPLAY_PERCENT

' 64-bit Timer inverse (e.g., idle is measured, but display busy  AS Integer)
' Display 100 - delta divided by delta time.  Display suffix: "%"
%PERF_100NSEC_TIMER_INV                      = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_100NS OR %PERF_DELTA_COUNTER OR %PERF_INVERSE_COUNTER OR %PERF_DISPLAY_PERCENT

' 64-bit Timer.  Divide delta by delta time.  Display suffix: "%"
' Timer for multiple instances, so result can exceed 100%.
%PERF_COUNTER_MULTI_TIMER                    = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_DELTA_COUNTER OR %PERF_TIMER_TICK OR %PERF_MULTI_COUNTER OR %PERF_DISPLAY_PERCENT

' 64-bit Timer inverse (e.g., idle is measured, but display busy  AS Integer)
' Display 100  _MULTI_BASE - delta divided by delta time.
' Display suffix: "%" Timer for multiple instances, so result
' can exceed 100%.  Followed by a counter of type _MULTI_BASE.
%PERF_COUNTER_MULTI_TIMER_INV                = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_RATE OR %PERF_DELTA_COUNTER OR %PERF_MULTI_COUNTER OR %PERF_TIMER_TICK OR %PERF_INVERSE_COUNTER OR %PERF_DISPLAY_PERCENT

' Number of instances to which the preceding _MULTI_..._INV counter
' applies.  Used as a factor to get the percentage.
%PERF_COUNTER_MULTI_BASE                     = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_BASE OR %PERF_MULTI_COUNTER OR %PERF_DISPLAY_NOSHOW

' 64-bit Timer in 100 nsec units. Display delta divided by delta time.
' Display suffix: "%" Timer for multiple instances, so result can exceed 100%.
%PERF_100NSEC_MULTI_TIMER                    = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_DELTA_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_100NS OR %PERF_MULTI_COUNTER OR %PERF_DISPLAY_PERCENT

' 64-bit Timer inverse (e.g., idle is measured, but display busy  AS Integer)
' Display 100  _MULTI_BASE - delta divided by delta time.
' Display suffix: "%" Timer for multiple instances, so result
' can exceed 100%.  Followed by a counter of type _MULTI_BASE.
%PERF_100NSEC_MULTI_TIMER_INV                = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_DELTA_COUNTER OR %PERF_COUNTER_RATE OR %PERF_TIMER_100NS OR %PERF_MULTI_COUNTER OR %PERF_INVERSE_COUNTER OR %PERF_DISPLAY_PERCENT

' Indicates the data is a fraction of the following counter  which
' should not be time averaged on display (such as free space over
' total space.) Display as is.  Display the quotient as "%".
%PERF_RAW_FRACTION                           = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_FRACTION OR %PERF_DISPLAY_PERCENT

' Indicates the data is a base for the preceding counter which should
' not be time averaged on display (such as free space over total space.)
%PERF_RAW_BASE                               = %PERF_SIZE_DWORD OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_BASE OR %PERF_DISPLAY_NOSHOW OR &H3         '  for compatibility with pre-beta versions

' The data collected in this counter is actually the start time of the
' item being measured. For display, this data is subtracted from the
' sample time to yield the elapsed time as the difference between the two.
' In the definition below, the PerfTime field of the Object contains
' the sample time as indicated by the PERF_OBJECT_TIMER bit and the
' difference is scaled by the PerfFreq of the Object to convert the time
' units into seconds.
%PERF_ELAPSED_TIME                           = %PERF_SIZE_LARGE OR %PERF_TYPE_COUNTER OR %PERF_COUNTER_ELAPSED OR %PERF_OBJECT_TIMER OR %PERF_DISPLAY_SECONDS

' The following counter type can be used with the preceding types to
' define a range of values to be displayed in a histogram.
%PERF_COUNTER_HISTOGRAM_TYPE                 = &H80000000  ' Counter begins or ends a histogram

' The following are used to determine the level of detail associated
' with the counter.  The user will be setting the level of detail
' that should be displayed at any given time.
%PERF_DETAIL_NOVICE                          = 100 '  The uninformed can understand it
%PERF_DETAIL_ADVANCED                        = 200 '  For the advanced user
%PERF_DETAIL_EXPERT                          = 300 '  For the expert user
%PERF_DETAIL_WIZARD                          = 400 '  For the system designer

%PERF_NO_UNIQUE_ID                           = -1

'  LZEXPAND error return codes
%LZERROR_BADINHANDLE                         = -1  '  invalid input handle
%LZERROR_BADOUTHANDLE                        = -2 '  invalid output handle
%LZERROR_READ                                = -3         '  corrupt compressed file format
%LZERROR_WRITE                               = -4        '  out of space for output file
%LZERROR_PUBLICLOC                           = -5    '  insufficient memory for LZFile struct
%LZERROR_GLOBLOCK                            = -6     '  bad Global handle
%LZERROR_BADVALUE                            = -7     '  input parameter out of range
%LZERROR_UNKNOWNALG                          = -8   '  compression algorithm not recognized

%VK_PROCESSKEY                               = &HE5

%STYLE_DESCRIPTION_SIZE                      = 32

'  the IME related messages
%WM_CONVERTREQUESTEX                         = &H108
%WM_IME_STARTCOMPOSITION                     = &H10D
%WM_IME_ENDCOMPOSITION                       = &H10E
%WM_IME_COMPOSITION                          = &H10F
%WM_IME_KEYLAST                              = &H10F

%WM_IME_SETCONTEXT                           = &H281
%WM_IME_NOTIFY                               = &H282
%WM_IME_CONTROL                              = &H283
%WM_IME_COMPOSITIONFULL                      = &H284
%WM_IME_SELECT                               = &H285
%WM_IME_CHAR                                 = &H286

%WM_IME_KEYDOWN                              = &H290
%WM_IME_KEYUP                                = &H291

'  wParam for WM_IME_CONTROL
%IMC_GETCANDIDATEPOS                         = &H7
%IMC_SETCANDIDATEPOS                         = &H8
%IMC_GETCOMPOSITIONFONT                      = &H9
%IMC_SETCOMPOSITIONFONT                      = &HA
%IMC_GETCOMPOSITIONWINDOW                    = &HB
%IMC_SETCOMPOSITIONWINDOW                    = &HC
%IMC_GETSTATUSWINDOWPOS                      = &HF
%IMC_SETSTATUSWINDOWPOS                      = &H10
%IMC_CLOSESTATUSWINDOW                       = &H21
%IMC_OPENSTATUSWINDOW                        = &H22


'  wParam for WM_IME_CONTROL to the soft keyboard
'  dwAction for ImmNotifyIME
%NI_OPENCANDIDATE                            = &H10
%NI_CLOSECANDIDATE                           = &H11
%NI_SELECTCANDIDATESTR                       = &H12
%NI_CHANGECANDIDATELIST                      = &H13
%NI_FINALIZECONVERSIONRESULT                 = &H14
%NI_COMPOSITIONSTR                           = &H15
%NI_SETCANDIDATE_PAGESTART                   = &H16
%NI_SETCANDIDATE_PAGESIZE                    = &H17

'  lParam for WM_IME_SETCONTEXT
%ISC_SHOWUICANDIDATEWINDOW                   = &H1
%ISC_SHOWUICOMPOSITIONWINDOW                 = &H80000000
%ISC_SHOWUIGUIDELINE                         = &H40000000
%ISC_SHOWUIALLCANDIDATEWINDOW                = &HF
%ISC_SHOWUIALL                               = &HC000000F

'  dwIndex for ImmNotifyIME/NI_COMPOSITIONSTR
%CPS_COMPLETE                                = &H1
%CPS_CONVERT                                 = &H2
%CPS_REVERT                                  = &H3
%CPS_CANCEL                                  = &H4

'  Windows for Simplified Chinese Edition hot key ID from &H10 - &H2F
%IME_CHOTKEY_IME_NONIME_TOGGLE               = &H10
%IME_CHOTKEY_SHAPE_TOGGLE                    = &H11
%IME_CHOTKEY_SYMBOL_TOGGLE                   = &H12

'  Windows for Japanese Edition hot key ID from &H30 - &H4F
%IME_JHOTKEY_CLOSE_OPEN                      = &H30

'  Windows for Korean Edition hot key ID from &H50 - &H6F
%IME_KHOTKEY_SHAPE_TOGGLE                    = &H50
%IME_KHOTKEY_HANJACONVERT                    = &H51
%IME_KHOTKEY_ENGLISH                         = &H52

'  Windows for Tranditional Chinese Edition hot key ID from &H70 - &H8F
%IME_THOTKEY_IME_NONIME_TOGGLE               = &H70
%IME_THOTKEY_SHAPE_TOGGLE                    = &H71
%IME_THOTKEY_SYMBOL_TOGGLE                   = &H72

'  direct switch hot key ID from &H100 - &H11F
%IME_HOTKEY_DSWITCH_FIRST                    = &H100
%IME_HOTKEY_DSWITCH_LAST                     = &H11F

'  IME private hot key from &H200 - &H21F
%IME_ITHOTKEY_RESEND_RESULTSTR               = &H200
%IME_ITHOTKEY_PREVIOUS_COMPOSITION           = &H201
%IME_ITHOTKEY_UISTYLE_TOGGLE                 = &H202

'  parameter of ImmGetCompositionString
%GCS_COMPREADSTR                             = &H1
%GCS_COMPREADATTR                            = &H2
%GCS_COMPREADCLAUSE                          = &H4
%GCS_COMPSTR                                 = &H8
%GCS_COMPATTR                                = &H10
%GCS_COMPCLAUSE                              = &H20
%GCS_CURSORPOS                               = &H80
%GCS_DELTASTART                              = &H100
%GCS_RESULTREADSTR                           = &H200
%GCS_RESULTREADCLAUSE                        = &H400
%GCS_RESULTSTR                               = &H800
%GCS_RESULTCLAUSE                            = &H1000

'  style bit flags for WM_IME_COMPOSITION
%CS_INSERTCHAR                               = &H2000
%CS_NOMOVECARET                              = &H4000

'  bits of fdwInit of INPUTCONTEXT
'  IME property bits
%IME_PROP_AT_CARET                           = &H10000
%IME_PROP_SPECIAL_UI                         = &H20000
%IME_PROP_CANDLIST_START_FROM_1              = &H40000
%IME_PROP_UNICODE                            = &H80000

'  IME UICapability bits
%UI_CAP_2700                                 = &H1
%UI_CAP_ROT90                                = &H2
%UI_CAP_ROTANY                               = &H4

'  ImmSetCompositionString Capability bits
%SCS_CAP_COMPSTR                             = &H1
%SCS_CAP_MAKEREAD                            = &H2

'  IME WM_IME_SELECT inheritance Capability bits
%SELECT_CAP_CONVERSION                       = &H1
%SELECT_CAP_SENTENCE                         = &H2

'  ID for deIndex of ImmGetGuideLine
%GGL_LEVEL                                   = &H1
%GGL_INDEX                                   = &H2
%GGL_STRING                                  = &H3
%GGL_PRIVATE                                 = &H4

'  ID for dwLevel of GUIDELINE Structure
%GL_LEVEL_NOGUIDELINE                        = &H0
%GL_LEVEL_FATAL                              = &H1
%GL_LEVEL_ERROR                              = &H2
%GL_LEVEL_WARNING                            = &H3
%GL_LEVEL_INFORMATION                        = &H4

'  ID for dwIndex of GUIDELINE Structure
%GL_ID_UNKNOWN                               = &H0
%GL_ID_NOMODULE                              = &H1
%GL_ID_NODICTIONARY                          = &H10
%GL_ID_CANNOTSAVE                            = &H11
%GL_ID_NOCONVERT                             = &H20
%GL_ID_TYPINGERROR                           = &H21
%GL_ID_TOOMANYSTROKE                         = &H22
%GL_ID_READINGCONFLICT                       = &H23
%GL_ID_INPUTREADING                          = &H24
%GL_ID_INPUTRADICAL                          = &H25
%GL_ID_INPUTCODE                             = &H26
%GL_ID_INPUTSYMBOL                           = &H27
%GL_ID_CHOOSECANDIDATE                       = &H28
%GL_ID_REVERSECONVERSION                     = &H29
%GL_ID_PRIVATE_FIRST                         = &H8000
%GL_ID_PRIVATE_LAST                          = &HFFFF

'  ID for dwIndex of ImmGetProperty
%IGP_PROPERTY                                = &H4
%IGP_CONVERSION                              = &H8
%IGP_SENTENCE                                = &HC
%IGP_UI                                      = &H10
%IGP_SETCOMPSTR                              = &H14
%IGP_SELECT                                  = &H18

'  dwIndex for ImmSetCompositionString API
%SCS_SETSTR                                  = %GCS_COMPREADSTR OR %GCS_COMPSTR
%SCS_CHANGEATTR                              = %GCS_COMPREADATTR OR %GCS_COMPATTR
%SCS_CHANGECLAUSE                            = %GCS_COMPREADCLAUSE OR %GCS_COMPCLAUSE

'  attribute for COMPOSITIONSTRING Structure
%ATTR_INPUT                                  = &H0
%ATTR_TARGET_CONVERTED                       = &H1
%ATTR_CONVERTED                              = &H2
%ATTR_TARGET_NOTCONVERTED                    = &H3
%ATTR_INPUT_ERROR                            = &H4

'  bit field for IMC_SETCOMPOSITIONWINDOW, IMC_SETCANDIDATEWINDOW
%CFS_DEFAULT                                 = &H0
%CFS_RECT                                    = &H1
%CFS_POINT                                   = &H2
%CFS_SCREEN                                  = &H4
%CFS_FORCE_POSITION                          = &H20
%CFS_CANDIDATEPOS                            = &H40
%CFS_EXCLUDE                                 = &H80

'  conversion direction for ImmGetConversionList
%GCL_CONVERSION                              = &H1
%GCL_REVERSECONVERSION                       = &H2
%GCL_REVERSE_LENGTH                          = &H3

'  bit field for conversion mode
%IME_CMODE_ALPHANUMERIC                      = &H0
%IME_CMODE_NATIVE                            = &H1
%IME_CMODE_CHINESE                           = %IME_CMODE_NATIVE
%IME_CMODE_HANGEUL                           = %IME_CMODE_NATIVE
%IME_CMODE_JAPANESE                          = %IME_CMODE_NATIVE
%IME_CMODE_KATAKANA                          = &H2                   '  only effect under IME_CMODE_NATIVE
%IME_CMODE_LANGUAGE                          = &H3
%IME_CMODE_FULLSHAPE                         = &H8
%IME_CMODE_ROMAN                             = &H10
%IME_CMODE_CHARCODE                          = &H20
%IME_CMODE_HANJACONVERT                      = &H40
%IME_CMODE_SOFTKBD                           = &H80
%IME_CMODE_NOCONVERSION                      = &H100
%IME_CMODE_EUDC                              = &H200
%IME_CMODE_SYMBOL                            = &H400

%IME_SMODE_NONE                              = &H0
%IME_SMODE_PLAURALCLAUSE                     = &H1
%IME_SMODE_SINGLECONVERT                     = &H2
%IME_SMODE_AUTOMATIC                         = &H4
%IME_SMODE_PHRASEPREDICT                     = &H8

'  style of candidate
%IME_CAND_UNKNOWN                            = &H0
%IME_CAND_READ                               = &H1
%IME_CAND_CODE                               = &H2
%IME_CAND_MEANING                            = &H3
%IME_CAND_RADICAL                            = &H4
%IME_CAND_STROKE                             = &H5

'  wParam of report message WM_IME_NOTIFY
%IMN_CLOSESTATUSWINDOW                       = &H1
%IMN_OPENSTATUSWINDOW                        = &H2
%IMN_CHANGECANDIDATE                         = &H3
%IMN_CLOSECANDIDATE                          = &H4
%IMN_OPENCANDIDATE                           = &H5
%IMN_SETCONVERSIONMODE                       = &H6
%IMN_SETSENTENCEMODE                         = &H7
%IMN_SETOPENSTATUS                           = &H8
%IMN_SETCANDIDATEPOS                         = &H9
%IMN_SETCOMPOSITIONFONT                      = &HA
%IMN_SETCOMPOSITIONWINDOW                    = &HB
%IMN_SETSTATUSWINDOWPOS                      = &HC
%IMN_GUIDELINE                               = &HD
%IMN_PRIVATE                                 = &HE

'  error code of ImmGetCompositionString
%IMM_ERROR_NODATA                            = -1
%IMM_ERROR_GENERAL                           = -2

'  dialog mode of ImmConfigureIME
%IME_CONFIG_GENERAL                          = 1
%IME_CONFIG_REGISTERWORD                     = 2
%IME_CONFIG_SELECTDICTIONARY                 = 3

'  dialog mode of ImmEscape
%IME_ESC_QUERY_SUPPORT                       = &H3
%IME_ESC_RESERVED_FIRST                      = &H4
%IME_ESC_RESERVED_LAST                       = &H7FF
%IME_ESC_PRIVATE_FIRST                       = &H800
%IME_ESC_PRIVATE_LAST                        = &HFFF
%IME_ESC_SEQUENCE_TO_INTERNAL                = &H1001
%IME_ESC_GET_EUDC_DICTIONARY                 = &H1003
%IME_ESC_SET_EUDC_DICTIONARY                 = &H1004
%IME_ESC_MAX_KEY                             = &H1005
%IME_ESC_IME_NAME                            = &H1006
%IME_ESC_SYNC_HOTKEY                         = &H1007
%IME_ESC_HANJA_MODE                          = &H1008

'  style of word registration
%IME_REGWORD_STYLE_EUDC                      = &H1
%IME_REGWORD_STYLE_USER_FIRST                = &H80000000
%IME_REGWORD_STYLE_USER_LAST                 = &HFFFF

'  type of soft keyboard
'  for Windows Tranditional Chinese Edition
%SOFTKEYBOARD_TYPE_T1                        = &H1
'  for Windows Simplified Chinese Edition
%SOFTKEYBOARD_TYPE_C1                        = &H2

'  Dial Options
%DIALOPTION_BILLING                          = &H40          '  Supports wait for bong "$"
%DIALOPTION_QUIET                            = &H80            '  Supports wait for quiet "@"
%DIALOPTION_DIALTONE                         = &H100        '  Supports wait for dial tone "W"

'  SpeakerVolume for MODEMDEVCAPS
%MDMVOLFLAG_LOW                              = &H1
%MDMVOLFLAG_MEDIUM                           = &H2
%MDMVOLFLAG_HIGH                             = &H4

'  SpeakerVolume for MODEMSETTINGS
%MDMVOL_LOW                                  = &H0
%MDMVOL_MEDIUM                               = &H1
%MDMVOL_HIGH                                 = &H2

'  SpeakerMode for MODEMDEVCAPS
%MDMSPKRFLAG_OFF                             = &H1
%MDMSPKRFLAG_DIAL                            = &H2
%MDMSPKRFLAG_ON                              = &H4
%MDMSPKRFLAG_CALLSETUP                       = &H8

'  SpeakerMode for MODEMSETTINGS
%MDMSPKR_OFF                                 = &H0
%MDMSPKR_DIAL                                = &H1
%MDMSPKR_ON                                  = &H2
%MDMSPKR_CALLSETUP                           = &H3

'  Modem Options
%MDM_COMPRESSION                             = &H1
%MDM_ERROR_CONTROL                           = &H2
%MDM_FORCED_EC                               = &H4
%MDM_CELLULAR                                = &H8
%MDM_FLOWCONTROL_HARD                        = &H10
%MDM_FLOWCONTROL_SOFT                        = &H20
%MDM_CCITT_OVERRIDE                          = &H40
%MDM_SPEED_ADJUST                            = &H80
%MDM_TONE_DIAL                               = &H100
%MDM_BLIND_DIAL                              = &H200
%MDM_V23_OVERRIDE                            = &H400

%ABM_NEW                                     = &H0
%ABM_REMOVE                                  = &H1
%ABM_QUERYPOS                                = &H2
%ABM_SETPOS                                  = &H3
%ABM_GETSTATE                                = &H4
%ABM_GETTASKBARPOS                           = &H5
%ABM_ACTIVATE                                = &H6               '  lParam == TRUE/FALSE means activate/deactivate
%ABM_GETAUTOHIDEBAR                          = &H7
%ABM_SETAUTOHIDEBAR                          = &H8          '  this can fail at any time.  MUST check the result
'  lParam = TRUE/FALSE  Set/Unset
'  uEdge = what edge
%ABM_WINDOWPOSCHANGED                        = &H9


'  these are put in the wparam of callback messages
%ABN_STATECHANGE                             = &H0
%ABN_POSCHANGED                              = &H1
%ABN_FULLSCREENAPP                           = &H2
%ABN_WINDOWARRANGE                           = &H3 '  lParam == TRUE means hide

'  flags for get state

%ABS_AUTOHIDE                                = &H1
%ABS_ALWAYSONTOP                             = &H2
%ABE_LEFT                                    = 0
%ABE_TOP                                     = 1
%ABE_RIGHT                                   = 2
%ABE_BOTTOM                                  = 3

%EIRESID                                     = -1

%FO_MOVE                                     = &H1
%FO_COPY                                     = &H2
%FO_DELETE                                   = &H3
%FO_RENAME                                   = &H4
%FOF_MULTIDESTFILES                          = &H1
%FOF_CONFIRMMOUSE                            = &H2
%FOF_SILENT                                  = &H4    ' don't create progress/report
%FOF_RENAMEONCOLLISION                       = &H8
%FOF_NOCONFIRMATION                          = &H10   ' Don't prompt the user.
%FOF_WANTMAPPINGHANDLE                       = &H20   ' Fill in SHFILEOPSTRUCT.hNameMappings
'  Must be freed using SHFreeNameMappings
%FOF_ALLOWUNDO                               = &H40
%FOF_FILESONLY                               = &H80   ' on *.*, do only files
%FOF_SIMPLEPROGRESS                          = &H100  ' means don't show names of files
%FOF_NOCONFIRMMKDIR                          = &H200  ' don't confirm making any needed dirs

%PO_DELETE                                   = &H13   ' printer is being deleted
%PO_RENAME                                   = &H14   ' printer is being renamed
%PO_PORTCHANGE                               = &H20   ' port this printer connected to is being changed
'  if this id is set, the strings received by
'  the copyhook are a doubly-null terminated
'  list of strings.  The first is the printer
'  name and the second is the printer port.
%PO_REN_PORT                                 = &H34   ' PO_RENAME and PO_PORTCHANGE at same time.

'  no POF_ flags currently defined
'  regular WinExec() codes
%SE_ERR_FNF                                  = 2      ' file not found
%SE_ERR_PNF                                  = 3      ' path not found
%SE_ERR_ACCESSDENIED                         = 5      ' access denied
%SE_ERR_OOM                                  = 8      ' out of memory
%SE_ERR_DLLNOTFOUND                          = 32


'  Note CLASSKEY overrides CLASSNAME
%SEE_MASK_CLASSNAME                          = &H1
%SEE_MASK_CLASSKEY                           = &H3

'  Note INVOKEIDLIST overrides IDLIST
%SEE_MASK_IDLIST                             = &H4
%SEE_MASK_INVOKEIDLIST                       = &HC
%SEE_MASK_ICON                               = &H10
%SEE_MASK_HOTKEY                             = &H20
%SEE_MASK_NOCLOSEPROCESS                     = &H40
%SEE_MASK_CONNECTNETDRV                      = &H80
%SEE_MASK_FLAG_DDEWAIT                       = &H100
%SEE_MASK_DOENVSUBST                         = &H200
%SEE_MASK_FLAG_NO_UI                         = &H400

%NIM_ADD                                     = &H0
%NIM_MODIFY                                  = &H1
%NIM_DELETE                                  = &H2

%NIF_MESSAGE                                 = &H1
%NIF_ICON                                    = &H2
%NIF_TIP                                     = &H4

%SHGFI_ICON                                  = &H100   '  get icon
%SHGFI_DISPLAYNAME                           = &H200   '  get display name
%SHGFI_TYPENAME                              = &H400   '  get type name
%SHGFI_ATTRIBUTES                            = &H800   '  get attributes
%SHGFI_ICONLOCATION                          = &H1000  '  get icon location
%SHGFI_EXETYPE                               = &H2000  '  return exe type
%SHGFI_SYSICONINDEX                          = &H4000  '  get system icon index
%SHGFI_LINKOVERLAY                           = &H8000  '  put a link overlay on icon
%SHGFI_SELECTED                              = &H10000 '  show icon in selected state
%SHGFI_LARGEICON                             = &H0     '  get large icon
%SHGFI_SMALLICON                             = &H1     '  get small icon
%SHGFI_OPENICON                              = &H2     '  get open icon
%SHGFI_SHELLICONSIZE                         = &H4     '  get shell size icon
%SHGFI_PIDL                                  = &H8     '  pszPath is a pidl
%SHGFI_USEFILEATTRIBUTES                     = &H10    '  use passed dwFileAttribute

%SHGNLI_PIDL                                 = &H1     '  pszLinkTo is a pidl
%SHGNLI_PREFIXNAME                           = &H2     '  Make name "Shortcut to xxx"

'  ----- Symbols -----
%VS_VERSION_INFO                             = 1
%VS_USER_DEFINED                             = 100

'  ----- VS_VERSION.dwFileFlags -----
%VS_FFI_SIGNATURE                            = &HFEEF04BD
%VS_FFI_STRUCVERSION                         = &H10000
%VS_FFI_FILEFLAGSMASK                        = &H3F&

'  ----- VS_VERSION.dwFileFlags -----
%VS_FF_DEBUG                                 = &H1&
%VS_FF_PRERELEASE                            = &H2&
%VS_FF_PATCHED                               = &H4&
%VS_FF_PRIVATEBUILD                          = &H8&
%VS_FF_INFOINFERRED                          = &H10&
%VS_FF_SPECIALBUILD                          = &H20&

'  ----- VS_VERSION.dwFileOS -----
%VOS_UNKNOWN                                 = &H0&
%VOS_DOS                                     = &H10000
%VOS_OS216                                   = &H20000
%VOS_OS232                                   = &H30000
%VOS_NT                                      = &H40000

%VOS__BASE                                   = &H0&
%VOS__WINDOWS16                              = &H1&
%VOS__PM16                                   = &H2&
%VOS__PM32                                   = &H3&
%VOS__WINDOWS32                              = &H4&

%VOS_DOS_WINDOWS16                           = &H10001
%VOS_DOS_WINDOWS32                           = &H10004
%VOS_OS216_PM16                              = &H20002
%VOS_OS232_PM32                              = &H30003
%VOS_NT_WINDOWS32                            = &H40004

'  ----- VS_VERSION.dwFileType -----
%VFT_UNKNOWN                                 = &H0&
%VFT_APP                                     = &H1&
%VFT_DLL                                     = &H2&
%VFT_DRV                                     = &H3&
%VFT_FONT                                    = &H4&
%VFT_VXD                                     = &H5&
%VFT_STATIC_LIB                              = &H7&

'  ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV -----
%VFT2_UNKNOWN                                = &H0&
%VFT2_DRV_PRINTER                            = &H1&
%VFT2_DRV_KEYBOARD                           = &H2&
%VFT2_DRV_LANGUAGE                           = &H3&
%VFT2_DRV_DISPLAY                            = &H4&
%VFT2_DRV_MOUSE                              = &H5&
%VFT2_DRV_NETWORK                            = &H6&
%VFT2_DRV_SYSTEM                             = &H7&
%VFT2_DRV_INSTALLABLE                        = &H8&
%VFT2_DRV_SOUND                              = &H9&
%VFT2_DRV_COMM                               = &HA&
%VFT2_DRV_INPUTMETHOD                        = &HB&

'  ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_FONT -----
%VFT2_FONT_RASTER                            = &H1&
%VFT2_FONT_VECTOR                            = &H2&
%VFT2_FONT_TRUETYPE                          = &H3&

'  ----- VerFindFile() flags -----
%VFFF_ISSHAREDFILE                           = &H1

%VFF_CURNEDEST                               = &H1
%VFF_FILEINUSE                               = &H2
%VFF_BUFFTOOSMALL                            = &H4

'  ----- VerInstallFile() flags -----
%VIFF_FORCEINSTALL                           = &H1
%VIFF_DONTDELETEOLD                          = &H2

%VIF_TEMPFILE                                = &H1&
%VIF_MISMATCH                                = &H2&
%VIF_SRCOLD                                  = &H4&

%VIF_DIFFLANG                                = &H8&
%VIF_DIFFCODEPG                              = &H10&
%VIF_DIFFTYPE                                = &H20&

%VIF_WRITEPROT                               = &H40&
%VIF_FILEINUSE                               = &H80&
%VIF_OUTOFSPACE                              = &H100&
%VIF_ACCESSVIOLATION                         = &H200&
%VIF_SHARINGVIOLATION                        = &H400&
%VIF_CANNOTCREATE                            = &H800&
%VIF_CANNOTDELETE                            = &H1000&
%VIF_CANNOTRENAME                            = &H2000&
%VIF_CANNOTDELETECUR                         = &H4000&
%VIF_OUTOFMEMORY                             = &H8000&

%VIF_CANNOTREADSRC                           = &H10000
%VIF_CANNOTREADDST                           = &H20000
%VIF_BUFFTOOSMALL                            = &H40000

%PROCESS_HEAP_REGION                         = &H1
%PROCESS_HEAP_UNCOMMITTED_RANGE              = &H2
%PROCESS_HEAP_ENTRY_BUSY                     = &H4
%PROCESS_HEAP_ENTRY_MOVEABLE                 = &H10
%PROCESS_HEAP_ENTRY_DDESHARE                 = &H20

'%NORMAL_PRIORITY_CLASS                       = &H00000020
'%IDLE_PRIORITY_CLASS                         = &H00000040
'%HIGH_PRIORITY_CLASS                         = &H00000080
'%REALTIME_PRIORITY_CLASS                     = &H00000100
'%CREATE_NEW_PROCESS_GROUP                    = &H00000200
'%CREATE_UNICODE_ENVIRONMENT                  = &H00000400
'%CREATE_SEPARATE_WOW_VDM                     = &H00000800
'%CREATE_SHARED_WOW_VDM                       = &H00001000
'%CREATE_DEFAULT_ERROR_MODE                   = &H04000000

%PROCESS_TERMINATE         = &H0001???
%PROCESS_CREATE_THREAD     = &H0002
%PROCESS_VM_OPERATION      = &H0008
%PROCESS_VM_READ           = &H0010
%PROCESS_VM_WRITE          = &H0020
%PROCESS_DUP_HANDLE        = &H0040
%PROCESS_CREATE_PROCESS    = &H0080
%PROCESS_SET_QUOTA         = &H0100
%PROCESS_SET_INFORMATION   = &H0200
%PROCESS_QUERY_INFORMATION = &H0400
%PROCESS_ALL_ACCESS        = %STANDARD_RIGHTS_REQUIRED OR %SYNCHRONIZE OR &HFFF???

'  GetBinaryType return values.

%SCS_32BIT_BINARY                            = 0
%SCS_DOS_BINARY                              = 1
%SCS_WOW_BINARY                              = 2
%SCS_PIF_BINARY                              = 3
%SCS_POSIX_BINARY                            = 4
%SCS_OS216_BINARY                            = 5

'  Logon Support APIs

%LOGON32_LOGON_INTERACTIVE                   = 2
%LOGON32_LOGON_BATCH                         = 4
%LOGON32_LOGON_SERVICE                       = 5

%LOGON32_PROVIDER_DEFAULT                    = 0
%LOGON32_PROVIDER_WINNT35                    = 1

'  dwPlatformId defines:
'
%VER_PLATFORM_WIN32s                         = 0
%VER_PLATFORM_WIN32_WINDOWS                  = 1
%VER_PLATFORM_WIN32_NT                       = 2

%AC_LINE_OFFLINE                             = &H0
%AC_LINE_ONLINE                              = &H1
%AC_LINE_BACKUP_POWER                        = &H2
%AC_LINE_UNKNOWN                             = &HFF
%BATTERY_FLAG_HIGH                           = &H1
%BATTERY_FLAG_LOW                            = &H2
%BATTERY_FLAG_CRITICAL                       = &H4
%BATTERY_FLAG_CHARGING                       = &H8
%BATTERY_FLAG_NO_BATTERY                     = &H80
%BATTERY_FLAG_UNKNOWN                        = &HFF
%BATTERY_PERCENTAGE_UNKNOWN                  = &HFF
%BATTERY_LIFE_UNKNOWN                        = &HFFFF

%CDM_FIRST                                   = %WM_USER + 100
%CDM_LAST                                    = %WM_USER + 200
%CDM_GETSPEC                                 = %CDM_FIRST + &H0
%CDM_GETFILEPATH                             = %CDM_FIRST + &H1
%CDM_GETFOLDERPATH                           = %CDM_FIRST + &H2
%CDM_GETFOLDERIDLIST                         = %CDM_FIRST + &H3
%CDM_SETCONTROLTEXT                          = %CDM_FIRST + &H4
%CDM_HIDECONTROL                             = %CDM_FIRST + &H5
%CDM_SETDEFEXT                               = %CDM_FIRST + &H6

%SIMULATED_FONTTYPE                          = &H8000
%PRINTER_FONTTYPE                            = &H4000
%SCREEN_FONTTYPE                             = &H2000
%BOLD_FONTTYPE                               = &H100
%ITALIC_FONTTYPE                             = &H200
%REGULAR_FONTTYPE                            = &H400

%WM_PSD_PAGESETUPDLG                         = %WM_USER
%WM_PSD_FULLPAGERECT                         = %WM_USER + 1
%WM_PSD_MINMARGINRECT                        = %WM_USER + 2
%WM_PSD_MARGINRECT                           = %WM_USER + 3
%WM_PSD_GREEKTEXTRECT                        = %WM_USER + 4
%WM_PSD_ENVSTAMPRECT                         = %WM_USER + 5
%WM_PSD_YAFULLPAGERECT                       = %WM_USER + 6

%PSD_DEFAULTMINMARGINS                       = &H0 '  default (printer's)
%PSD_INWININIINTLMEASURE                     = &H0 '  1st of 4 possible

%PSD_MINMARGINS                              = &H1 '  use caller's
%PSD_MARGINS                                 = &H2 '  use caller's
%PSD_INTHOUSANDTHSOFINCHES                   = &H4 '  2nd of 4 possible
%PSD_INHUNDREDTHSOFMILLIMETERS               = &H8 '  3rd of 4 possible
%PSD_DISABLEMARGINS                          = &H10
%PSD_DISABLEPRINTER                          = &H20
%PSD_NOWARNING                               = &H80 '  must be same as PD_*
%PSD_DISABLEORIENTATION                      = &H100
%PSD_RETURNDEFAULT                           = &H400 '  must be same as PD_*
%PSD_DISABLEPAPER                            = &H200
%PSD_SHOWHELP                                = &H800 '  must be same as PD_*
%PSD_ENABLEPAGESETUPHOOK                     = &H2000 '  must be same as PD_*
%PSD_ENABLEPAGESETUPTEMPLATE                 = &H8000 '  must be same as PD_*
%PSD_ENABLEPAGESETUPTEMPLATEHANDLE           = &H20000 '  must be same as PD_*
%PSD_ENABLEPAGEPAINTHOOK                     = &H40000
%PSD_DISABLEPAGEPAINTING                     = &H80000

'ALL_TRANSPORTS                              = "M\0\0\0"
'CFSEPCHAR                                   = "+"  '  compound file name separator char.
'COLOROKSTRING                               = "commdlg_ColorOK"
'FILEOKSTRING                                = "commdlg_FileNameOK"
'FINDMSGSTRING                               = "commdlg_FindReplace"
'HELPMSGSTRING                               = "commdlg_help"
'LBSELCHSTRING                               = "commdlg_LBSelChangedNotify"
'MS_NBF                                      = "MNBF"
'SC_GROUP_IDENTIFIER                         = "+"
'SERVICES_ACTIVE_DATABASE                    = "ServicesActive"
'SERVICES_FAILED_DATABASE                    = "ServicesFailed"
'SETRGBSTRING                                = "commdlg_SetRGBColor"
'SE_ASSIGNPRIMARYTOKEN_NAME                  = "SeAssignPrimaryTokenPrivilege"
'SE_AUDIT_NAME                               = "SeAuditPrivilege"
'SE_BACKUP_NAME                              = "SeBackupPrivilege"
'SE_CHANGE_NOTIFY_NAME                       = "SeChangeNotifyPrivilege"
'SE_CREATE_PAGEFILE_NAME                     = "SeCreatePagefilePrivilege"
'SE_CREATE_PERMANENT_NAME                    = "SeCreatePermanentPrivilege"
'SE_CREATE_TOKEN_NAME                        = "SeCreateTokenPrivilege"
'SE_DEBUG_NAME                               = "SeDebugPrivilege"
'SE_INCREASE_QUOTA_NAME                      = "SeIncreaseQuotaPrivilege"
'SE_INC_BASE_PRIORITY_NAME                   = "SeIncreaseBasePriorityPrivilege"
'SE_LOAD_DRIVER_NAME                         = "SeLoadDriverPrivilege"
'SE_LOCK_MEMORY_NAME                         = "SeLockMemoryPrivilege"
'SE_MACHINE_ACCOUNT_NAME                     = "SeMachineAccountPrivilege"
'SE_PROF_SINGLE_PROCESS_NAME                 = "SeProfileSingleProcessPrivilege"
'SE_REMOTE_SHUTDOWN_NAME                     = "SeRemoteShutdownPrivilege"
'SE_RESTORE_NAME                             = "SeRestorePrivilege"
'SE_SECURITY_NAME                            = "SeSecurityPrivilege"
'SE_SHUTDOWN_NAME                            = "SeShutdownPrivilege"
'SE_SYSTEMTIME_NAME                          = "SeSystemtimePrivilege"
'SE_SYSTEM_ENVIRONMENT_NAME                  = "SeSystemEnvironmentPrivilege"
'SE_SYSTEM_PROFILE_NAME                      = "SeSystemProfilePrivilege"
'SE_TAKE_OWNERSHIP_NAME                      = "SeTakeOwnershipPrivilege"
'SE_TCB_NAME                                 = "SeTcbPrivilege"
'SE_UNSOLICITED_INPUT_NAME                   = "SeUnsolicitedInputPrivilege"
'SHAREVISTRING                               = "commdlg_ShareViolation"
'SZDDESYS_ITEM_FORMATS                       = "Formats"
'SZDDESYS_ITEM_HELP                          = "Help"
'SZDDESYS_ITEM_RTNMSG                        = "ReturnMessage"
'SZDDESYS_ITEM_STATUS                        = "Status"
'SZDDESYS_ITEM_SYSITEMS                      = "SysItems"
'SZDDESYS_ITEM_TOPICS                        = "Topics"
'SZDDESYS_TOPIC                              = "System"
'SZDDE_ITEM_ITEMLIST                         = "TopicItemList"

'====== WM_NOTIFY codes (NMHDR.code values) ==================================

%NM_FIRST                                    = (0???-  0???)  ' generic to all controls
%NM_LAST                                     = (0???-99???)

%DBG_CONTINUE                                = &H00010002&
%DBG_TERMINATE_THREAD                        = &H40010003&
%DBG_TERMINATE_PROCESS                       = &H40010004&
%DBG_CONTROL_C                               = &H40010005&
%DBG_CONTROL_BREAK                           = &H40010008&
%DBG_EXCEPTION_NOT_HANDLED                   = &H80010001&

'
'  Define the size of the 80387 save area, which is in the context frame.
'
%SIZE_OF_80387_REGISTERS          = 80

%STATUS_WAIT_0                    = &H00000000&
%STATUS_ABANDONED_WAIT_0          = &H00000080&
%STATUS_USER_APC                  = &H000000C0&
%STATUS_TIMEOUT                   = &H00000102&
%STATUS_PENDING                   = &H00000103&
%STATUS_DATATYPE_MISALIGNMENT     = &H80000002&
%STATUS_BREAKPOINT                = &H80000003&
%STATUS_SINGLE_STEP               = &H80000004&
%STATUS_ACCESS_VIOLATION          = &HC0000005&
%STATUS_IN_PAGE_ERROR             = &HC0000006&
%STATUS_NO_MEMORY                 = &HC0000017&
%STATUS_ILLEGAL_INSTRUCTION       = &HC000001D&
%STATUS_NONCONTINUABLE_EXCEPTION  = &HC0000025&
%STATUS_INVALID_DISPOSITION       = &HC0000026&
%STATUS_ARRAY_BOUNDS_EXCEEDED     = &HC000008C&
%STATUS_FLOAT_DENORMAL_OPERAND    = &HC000008D&
%STATUS_FLOAT_DIVIDE_BY_ZERO      = &HC000008E&
%STATUS_FLOAT_INEXACT_RESULT      = &HC000008F&
%STATUS_FLOAT_INVALID_OPERATION   = &HC0000090&
%STATUS_FLOAT_OVERFLOW            = &HC0000091&
%STATUS_FLOAT_STACK_CHECK         = &HC0000092&
%STATUS_FLOAT_UNDERFLOW           = &HC0000093&
%STATUS_INTEGER_DIVIDE_BY_ZERO    = &HC0000094&
%STATUS_INTEGER_OVERFLOW          = &HC0000095&
%STATUS_PRIVILEGED_INSTRUCTION    = &HC0000096&
%STATUS_STACK_OVERFLOW            = &HC00000FD&
%STATUS_CONTROL_C_EXIT            = &HC000013A&

%WAIT_TIMEOUT                     = %STATUS_TIMEOUT
%WAIT_OBJECT_0                    = %STATUS_WAIT_0
%WAIT_ABANDONED                   = %STATUS_ABANDONED_WAIT_0

%EXCEPTION_CONTINUABLE            = 0      ' Continuable exception
%EXCEPTION_NONCONTINUABLE         = &H1    ' Noncontinuable exception

%EXCEPTION_ACCESS_VIOLATION       = %STATUS_ACCESS_VIOLATION
%EXCEPTION_DATATYPE_MISALIGNMENT  = %STATUS_DATATYPE_MISALIGNMENT
%EXCEPTION_BREAKPOINT             = %STATUS_BREAKPOINT
%EXCEPTION_SINGLE_STEP            = %STATUS_SINGLE_STEP
%EXCEPTION_ARRAY_BOUNDS_EXCEEDED  = %STATUS_ARRAY_BOUNDS_EXCEEDED
%EXCEPTION_FLT_DENORMAL_OPERAND   = %STATUS_FLOAT_DENORMAL_OPERAND
%EXCEPTION_FLT_DIVIDE_BY_ZERO     = %STATUS_FLOAT_DIVIDE_BY_ZERO
%EXCEPTION_FLT_INEXACT_RESULT     = %STATUS_FLOAT_INEXACT_RESULT
%EXCEPTION_FLT_INVALID_OPERATION  = %STATUS_FLOAT_INVALID_OPERATION
%EXCEPTION_FLT_OVERFLOW           = %STATUS_FLOAT_OVERFLOW
%EXCEPTION_FLT_STACK_CHECK        = %STATUS_FLOAT_STACK_CHECK
%EXCEPTION_FLT_UNDERFLOW          = %STATUS_FLOAT_UNDERFLOW
%EXCEPTION_INT_DIVIDE_BY_ZERO     = %STATUS_INTEGER_DIVIDE_BY_ZERO
%EXCEPTION_INT_OVERFLOW           = %STATUS_INTEGER_OVERFLOW
%EXCEPTION_PRIV_INSTRUCTION       = %STATUS_PRIVILEGED_INSTRUCTION
%EXCEPTION_IN_PAGE_ERROR          = %STATUS_IN_PAGE_ERROR

%CONTEXT_i386                     = &H00010000    ' this assumes that i386 and
%CONTEXT_i486                     = &H00010000    ' i486 have identical context records

%CONTEXT_CONTROL                  = %CONTEXT_i386 OR &H00000001& ' SS:SP, CS:IP, FLAGS, BP
%CONTEXT_INTEGER                  = %CONTEXT_i386 OR &H00000002& ' AX, BX, CX, DX, SI, DI
%CONTEXT_SEGMENTS                 = %CONTEXT_i386 OR &H00000004& ' DS, ES, FS, GS
%CONTEXT_FLOATING_POINT           = %CONTEXT_i386 OR &H00000008& ' 387 state
%CONTEXT_DEBUG_REGISTERS          = %CONTEXT_i386 OR &H00000010& ' DB 0-3,6,7

%CONTEXT_FULL                     = %CONTEXT_CONTROL OR %CONTEXT_INTEGER OR %CONTEXT_SEGMENTS

' Directory Entries

%IMAGE_DIRECTORY_ENTRY_EXPORT       =  0   ' Export Directory
%IMAGE_DIRECTORY_ENTRY_IMPORT       =  1   ' Import Directory
%IMAGE_DIRECTORY_ENTRY_RESOURCE     =  2   ' Resource Directory
%IMAGE_DIRECTORY_ENTRY_EXCEPTION    =  3   ' Exception Directory
%IMAGE_DIRECTORY_ENTRY_SECURITY     =  4   ' Security Directory
%IMAGE_DIRECTORY_ENTRY_BASERELOC    =  5   ' Base Relocation Table
%IMAGE_DIRECTORY_ENTRY_DEBUG        =  6   ' Debug Directory
%IMAGE_DIRECTORY_ENTRY_COPYRIGHT    =  7   ' Description String
%IMAGE_DIRECTORY_ENTRY_GLOBALPTR    =  8   ' Machine Value (MIPS GP)
%IMAGE_DIRECTORY_ENTRY_TLS          =  9   ' TLS Directory
%IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG  = 10   ' Load Configuration Directory
%IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT = 11   ' Bound Import Directory in headers
%IMAGE_DIRECTORY_ENTRY_IAT          = 12   ' Import Address Table
%IMAGE_NUMBEROF_DIRECTORY_ENTRIES   = 16

%IMAGE_BITMAP                       = 0
%IMAGE_ICON                         = 1
%IMAGE_CURSOR                       = 2
%IMAGE_ENHMETAFILE                  = 3

%PROCESSOR_INTEL_386                = 386
%PROCESSOR_INTEL_486                = 486
%PROCESSOR_INTEL_PENTIUM            = 586
%PROCESSOR_MIPS_R4000               = 4000
%PROCESSOR_ALPHA_21064              = 21064

%VT_EMPTY                           = 0
%VT_NULL                            = 1
%VT_I2                              = 2
%VT_I4                              = 3
%VT_R4                              = 4
%VT_R8                              = 5
%VT_CY                              = 6
%VT_DATE                            = 7
%VT_BSTR                            = 8
%VT_DISPATCH                        = 9
%VT_ERROR                           = 10
%VT_BOOL                            = 11
%VT_VARIANT                         = 12
%VT_UNKNOWN                         = 13
%VT_I1                              = 16
%VT_UI1                             = 17
%VT_UI2                             = 18
%VT_UI4                             = 19
%VT_I8                              = 20
%VT_UI8                             = 21
%VT_INT                             = 22
%VT_UINT                            = 23
%VT_VOID                            = 24
%VT_HRESULT                         = 25
%VT_PTR                             = 26
%VT_SAFEARRAY                       = 27
%VT_CARRAY                          = 28
%VT_USERDEFINED                     = 29
%VT_LPSTR                           = 30
%VT_LPWSTR                          = 31
%VT_FILETIME                        = 64
%VT_BLOB                            = 65
%VT_STREAM                          = 66
%VT_STORAGE                         = 67
%VT_STREAMED_OBJECT                 = 68
%VT_STORED_OBJECT                   = 69
%VT_BLOB_OBJECT                     = 70
%VT_CF                              = 71
%VT_CLSID                           = 72

%VT_VECTOR                          = &H1000
%VT_ARRAY                           = &H2000
%VT_BYREF                           = &H4000
%VT_RESERVED                        = &H8000

'&&&

'
' ** User Defined Types
'

UNION VARIANTDATA
  bVal AS BYTE           ' VT_UI1
  iVal AS INTEGER        ' VT_I2
  lVal AS LONG           ' VT_I4
  fltVal AS SINGLE       ' VT_R4
  dblVal AS DOUBLE       ' VT_R8
  boolVal AS LONG        ' VT_BOOL
  scode AS LONG          ' VT_ERROR
  cyVal AS LONG          ' VT_CY
  date AS DOUBLE         ' VT_DATE
  bstrVal AS LONG        ' VT_BSTR
  punkVal AS DWORD       ' VT_UNKNOWN
  pdispVal AS DWORD      ' VT_DISPATCH
  parray AS DWORD        ' VT_ARRAY|*
  pbVal AS BYTE PTR      ' VT_BYREF|VT_UI1
  piVal AS INTEGER PTR   ' VT_BYREF|VT_I2
  plVal AS LONG PTR      ' VT_BYREF|VT_I4
  pfltVal AS SINGLE PTR  ' VT_BYREF|VT_R4
  pdblVal AS DOUBLE PTR  ' VT_BYREF|VT_R8
  pboolVal AS LONG PTR   ' VT_BYREF|VT_BOOL
  pscode AS LONG PTR     ' VT_BYREF|VT_ERROR
  pcyVal AS LONG PTR     ' VT_BYREF|VT_CY
  pdate AS DOUBLE PTR    ' VT_BYREF|VT_DATE
  pbstrVal AS LONG PTR   ' VT_BYREF|VT_BSTR
  ppunkVal AS DWORD PTR  ' VT_BYREF|VT_UNKNOWN
  ppdispVal AS DWORD PTR ' VT_BYREF|VT_DISPATCH
  psArray AS DWORD PTR   ' VT_ARRAY|*
  pVariant AS DWORD PTR  ' VT_BYREF|VT_VARIANT
  pByRef AS DWORD        ' Generic ByRef
END UNION

TYPE VARIANT
  vt         AS WORD  'VARTYPE
  wReserved1 AS WORD
  wReserved2 AS WORD
  wReserved3 AS WORD
  vd         AS VARIANTDATA
END TYPE

TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE RECTL
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE POINTL
  x AS LONG
  y AS LONG
END TYPE

TYPE apiSIZE
  cx AS LONG
  cy AS LONG
END TYPE

TYPE POINTS
  x AS INTEGER
  y AS INTEGER
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS DWORD
  lParam AS DWORD
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE SID_AND_ATTRIBUTES
  Sid AS LONG
  Attributes AS LONG
END TYPE

TYPE SID_IDENTIFIER_AUTHORITY
  Value(6) AS BYTE
END TYPE

' Structure that defines the header of the Eventlog record. This is the
' fixed-sized portion before all the variable-length strings, binary
' data and pad bytes.
'
' TimeGenerated is the time it was generated at the client.
' TimeWritten is the time it was put into the log at the server end.

TYPE EVENTLOGRECORD
  Length AS LONG               ' Length of full record
  Reserved AS LONG             ' Used by the service
  RecordNumber AS LONG         ' Absolute record number
  TimeGenerated AS LONG        ' Seconds since 1-1-1970
  TimeWritten AS LONG          ' Seconds since 1-1-1970
  EventID AS LONG
  EventType AS WORD
  NumStrings AS WORD
  EventCategory AS WORD
  ReservedFlags AS WORD        ' For use with paired events (auditing)
  ClosingRecordNumber AS LONG  ' For use with paired events (auditing)
  StringOffset AS LONG         ' Offset from beginning of record
  UserSidLength AS LONG
  UserSidOffset AS LONG
  DataLength AS LONG
  DataOffset AS LONG           ' Offset from beginning of record
  '
  ' Then follow:
  '
  ' WCHAR SourceName[]
  ' WCHAR Computername[]
  ' SID   UserSid
  ' WCHAR Strings[]
  ' BYTE  Data[]
  ' CHAR  Pad[]
  ' DWORD Length;
END TYPE

TYPE OVERLAPPED
  Internal AS LONG
  InternalHigh AS LONG
  offset AS DWORD
  OffsetHigh AS DWORD
  hEvent AS LONG
END TYPE

TYPE SECURITY_ATTRIBUTES
  nLength AS LONG
  lpSecurityDescriptor AS LONG
  bInheritHandle AS LONG
END TYPE

TYPE PROCESS_INFORMATION
  hProcess AS LONG
  hThread AS LONG
  dwProcessId AS LONG
  dwThreadId AS LONG
END TYPE

TYPE FILETIME
  dwLowDateTime AS DWORD
  dwHighDateTime AS DWORD
END TYPE

TYPE SYSTEMTIME
  wYear AS INTEGER
  wMonth AS INTEGER
  wDayOfWeek AS INTEGER
  wDay AS INTEGER
  wHour AS INTEGER
  wMinute AS INTEGER
  wSecond AS INTEGER
  wMilliseconds AS INTEGER
END TYPE

TYPE COMMPROP
  wPacketLength AS INTEGER
  wPacketVersion AS INTEGER
  dwServiceMask AS LONG
  dwReserved1 AS LONG
  dwMaxTxQueue AS LONG
  dwMaxRxQueue AS LONG
  dwMaxBaud AS LONG
  dwProvSubType AS LONG
  dwProvCapabilities AS LONG
  dwSettableParams AS LONG
  dwSettableBaud AS LONG
  wSettableData AS INTEGER
  wSettableStopParity AS INTEGER
  dwCurrentTxQueue AS LONG
  dwCurrentRxQueue AS LONG
  dwProvSpec1 AS LONG
  dwProvSpec2 AS LONG
  wcProvChar(1) AS INTEGER
END TYPE

TYPE COMSTAT
  fCtsHold AS LONG
  fDsrHold AS LONG
  fRlsdHold AS LONG
  fXoffHold AS LONG
  fXoffSent AS LONG
  fEof AS LONG
  fTxim AS LONG
  fReserved AS LONG
  cbInQue AS LONG
  cbOutQue AS LONG
END TYPE

TYPE DCB
  DCBlength AS LONG
  BaudRate AS LONG
  fbits AS LONG        ' fBinary
                       ' fParity
                       ' fOutxCtsFlow
                       ' fOutxDsrFlow
                       ' fDtrControl
                       ' fDsrSensitivity
                       ' fTXContinueOnXoff
                       ' fOutX
                       ' fInX
                       ' fErrorChar
                       ' fNull
                       ' fRtsControl
                       ' fAbortOnError
                       ' fDummy2

  wReserved AS INTEGER
  XonLim AS INTEGER
  XoffLim AS INTEGER
  ByteSize AS BYTE
  Parity AS BYTE
  StopBits AS BYTE
  XonChar AS BYTE
  XoffChar AS BYTE
  ErrorChar AS BYTE
  EofChar AS BYTE
  EvtChar AS BYTE
  wReserved2 AS INTEGER
END TYPE

TYPE COMMTIMEOUTS
  ReadIntervalTimeout AS LONG
  ReadTotalTimeoutMultiplier AS LONG
  ReadTotalTimeoutConstant AS LONG
  WriteTotalTimeoutMultiplier AS LONG
  WriteTotalTimeoutConstant AS LONG
END TYPE

TYPE SYSTEM_INFO
  dwOemID AS LONG
  dwPageSize AS LONG
  lpMinimumApplicationAddress AS LONG
  lpMaximumApplicationAddress AS LONG
  dwActiveProcessorMask AS LONG
  dwNumberOrfProcessors AS LONG
  dwProcessorType AS LONG
  dwAllocationGranularity AS LONG
  wProcessorLevel AS INTEGER
  wProcessorRevision AS INTEGER
END TYPE

TYPE MEMORYSTATUS
  dwLength AS LONG
  dwMemoryLoad AS LONG
  dwTotalPhys AS LONG
  dwAvailPhys AS LONG
  dwTotalPageFile AS LONG
  dwAvailPageFile AS LONG
  dwTotalVirtual AS LONG
  dwAvailVirtual AS LONG
END TYPE

TYPE TPMPARAMS
  cbSize AS LONG
  rcExclude AS Rect
END TYPE

'   Define the generic mapping array.  This is used to denote the
'   mapping of each generic access right to a specific access mask.

TYPE GENERIC_MAPPING
  GenericRead AS LONG
  GenericWrite AS LONG
  GenericExecute AS LONG
  GenericAll AS LONG
END TYPE

TYPE LUID
  LowPart AS DWORD
  HighPart AS LONG
END TYPE


TYPE LUID_AND_ATTRIBUTES
  pLuid AS LUID
  Attributes AS LONG
END TYPE

TYPE ACL
  AclRevision AS BYTE
  Sbz1 AS BYTE
  AclSize AS INTEGER
  AceCount AS INTEGER
  Sbz2 AS INTEGER
END TYPE

TYPE ACE_HEADER
  AceType AS BYTE
  AceFlags AS BYTE
  AceSize AS LONG
END TYPE

TYPE ACCESS_ALLOWED_ACE
  Header AS ACE_HEADER
  Mask AS LONG
  SidStart AS LONG
END TYPE

TYPE ACCESS_DENIED_ACE
  Header AS ACE_HEADER
  Mask AS LONG
  SidStart AS LONG
END TYPE

TYPE SYSTEM_AUDIT_ACE
  Header AS ACE_HEADER
  Mask AS LONG
  SidStart AS LONG
END TYPE

TYPE SYSTEM_ALARM_ACE
  Header AS ACE_HEADER
  Mask AS LONG
  SidStart AS LONG
END TYPE

TYPE ACL_REVISION_INFORMATION
  AclRevision AS LONG
END TYPE

TYPE ACL_SIZE_INFORMATION
  AceCount AS LONG
  AclBytesInUse AS LONG
  AclBytesFree AS LONG
END TYPE

TYPE SECURITY_DESCRIPTOR
  Revision AS BYTE
  Sbz1 AS BYTE
  nControl AS LONG
  Owner AS LONG
  Group AS LONG
  Sacl AS ACL
  Dacl AS ACL
END TYPE

TYPE PRIVILEGE_SET
  PrivilegeCount AS LONG
  nControl AS LONG
  Privilege(%ANYSIZE_ARRAY) AS LUID_AND_ATTRIBUTES
END TYPE

TYPE EXCEPTION_RECORD
  ExceptionCode AS LONG
  ExceptionFlags AS LONG
  pExceptionRecord AS EXCEPTION_RECORD PTR
  ExceptionAddress AS DWORD
  NumberParameters AS LONG
  ExceptionInformation(%EXCEPTION_MAXIMUM_PARAMETERS) AS LONG
END TYPE

TYPE EXCEPTION_DEBUG_INFO
  pExceptionRecord AS EXCEPTION_RECORD
  dwFirstChance AS LONG
END TYPE

TYPE CREATE_THREAD_DEBUG_INFO
  hThread AS LONG
  lpThreadLocalBase AS LONG
  lpStartAddress AS LONG
END TYPE

TYPE CREATE_PROCESS_DEBUG_INFO
  hFile AS LONG
  hProcess AS LONG
  hThread AS LONG
  lpBaseOfImage AS LONG
  dwDebugInfoFileOffset AS LONG
  nDebugInfoSize AS LONG
  lpThreadLocalBase AS LONG
  lpStartAddress AS LONG
  lpImageName AS ASCIIZ PTR
  fUnicode AS LONG
END TYPE

TYPE EXIT_THREAD_DEBUG_INFO
  dwExitCode AS LONG
END TYPE

TYPE EXIT_PROCESS_DEBUG_INFO
  dwExitCode AS LONG
END TYPE

TYPE LOAD_DLL_DEBUG_INFO
  hFile AS LONG
  lpBaseOfDll AS LONG
  dwDebugInfoFileOffset AS LONG
  nDebugInfoSize AS LONG
  lpImageName AS ASCIIZ PTR
  fUnicode AS INTEGER
END TYPE

TYPE UNLOAD_DLL_DEBUG_INFO
  lpBaseOfDll AS LONG
END TYPE

TYPE OUTPUT_DEBUG_STRING_INFO
  lpDebugStringData AS ASCIIZ PTR
  fUnicode AS INTEGER
  nDebugStringLength AS INTEGER
END TYPE

TYPE RIP_INFO
  dwError AS LONG
  dwType AS LONG
END TYPE

' OpenFile() Structure
TYPE OFSTRUCT
  cBytes AS BYTE
  fFixedDisk AS BYTE
  nErrCode AS INTEGER
  Reserved1 AS INTEGER
  Reserved2 AS INTEGER
  szPathName(%OFS_MAXPATHNAME) AS BYTE
END TYPE

TYPE WNDCLASSEX
  cbSize AS LONG
  style AS LONG
  lpfnWndProc AS LONG
  cbClsExtra AS LONG
  cbWndExtra AS LONG
  hInstance AS LONG
  hIcon AS LONG
  hCursor AS LONG
  hbrBackground AS LONG
  lpszMenuName AS ASCIIZ PTR
  lpszClassName AS ASCIIZ PTR
  hIconSm AS LONG
END TYPE

TYPE WNDCLASS
  style AS LONG
  lpfnwndproc AS LONG
  cbClsextra AS LONG
  cbWndExtra AS LONG
  hInstance AS LONG
  hIcon AS LONG
  hCursor AS LONG
  hbrBackground AS LONG
  lpszMenuName AS ASCIIZ PTR
  lpszClassName AS ASCIIZ PTR
END TYPE

TYPE CRITICAL_SECTION
  dummy AS STRING * 24
END TYPE

TYPE BY_HANDLE_FILE_INFORMATION
  dwFileAttributes AS LONG
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  dwVolumeSerialNumber AS LONG
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  nNumberOfLinks AS LONG
  nFileIndexHigh AS LONG
  nFileIndexLow AS LONG
END TYPE

TYPE MEMORY_BASIC_INFORMATION
  BaseAddress AS LONG
  AllocationBase AS LONG
  AllocationProtect AS LONG
  RegionSize AS LONG
  State AS LONG
  Protect AS LONG
  lType AS LONG
END TYPE

TYPE EVENTLOGRECORD
  Length AS LONG                        'Length of full record
  Reserved AS LONG                      'Used by the service
  RecordNumber AS LONG                  'Absolute record number
  TimeGenerated AS LONG                 'Seconds since 1-1-1970
  TimeWritten AS LONG                   'Seconds since 1-1-1970
  EventID AS LONG
  EventType AS INTEGER
  NumStrings AS INTEGER
  EventCategory AS INTEGER
  ReservedFlags AS INTEGER              'For use with paired events (auditing)
  ClosingRecordNumber AS LONG           'For use with paired events (auditing)
  StringOffset AS LONG                  'Offset from beginning of record
  UserSidLength AS LONG
  UserSidOffset AS LONG
  DataLength AS LONG
  DataOffset AS LONG                    'Offset from beginning of record
END TYPE

TYPE TOKEN_GROUPS
  GroupCount AS LONG
  Groups(%ANYSIZE_ARRAY) AS SID_AND_ATTRIBUTES
END TYPE

TYPE TOKEN_PRIVILEGES
  PrivilegeCount AS LONG
  Privileges(%ANYSIZE_ARRAY) AS LUID_AND_ATTRIBUTES
END TYPE

TYPE FLOATING_SAVE_AREA
  ControlWord AS DWORD
  StatusWord AS DWORD
  TagWord AS DWORD
  ErrorOffset AS DWORD
  ErrorSelector AS DWORD
  DataOffset AS DWORD
  DataSelector AS DWORD
  RegisterArea(0 TO %SIZE_OF_80387_REGISTERS - 1) AS BYTE
  Cr0NpxState AS DWORD
END TYPE

'
' Context Frame
'
'  This frame has a several purposes: 1) it is used as an argument to
'  NtContinue, 2) is is used to constuct a call frame for APC delivery,
'  and 3) it is used in the user level thread creation routines.
'
'  The layout of the record conforms to a standard call frame.
'
TYPE CONTEXT
  '
  ' The flags values within this flag control the contents of
  ' a CONTEXT record.
  '
  ' If the context record is used as an input parameter, then
  ' for each portion of the context record controlled by a flag
  ' whose value is set, it is assumed that that portion of the
  ' context record contains valid context. If the context record
  ' is being used to modify a threads context, then only that
  ' portion of the threads context will be modified.
  '
  ' If the context record is used as an IN OUT parameter to capture
  ' the context of a thread, then only those portions of the thread's
  ' context corresponding to set flags will be returned.
  '
  ' The context record is never used as an OUT only parameter.
  '
  ContextFlags AS DWORD

  ' This section is specified/returned if CONTEXT_DEBUG_REGISTERS is
  ' set in ContextFlags.  Note that CONTEXT_DEBUG_REGISTERS is NOT
  ' included in CONTEXT_FULL.
  Dr0 AS DWORD
  Dr1 AS DWORD
  Dr2 AS DWORD
  Dr3 AS DWORD
  Dr6 AS DWORD
  Dr7 AS DWORD

  ' This section is specified/returned if the
  ' ContextFlags word contians the flag CONTEXT_FLOATING_POINT.
  FloatSave AS FLOATING_SAVE_AREA

  ' This section is specified/returned if the
  ' ContextFlags word contians the flag CONTEXT_SEGMENTS.
  regGs AS DWORD
  regFs AS DWORD
  regEs AS DWORD
  regDs AS DWORD

  ' This section is specified/returned if the
  ' ContextFlags word contians the flag CONTEXT_INTEGER.
  regEdi AS DWORD
  regEsi AS DWORD
  regEbx AS DWORD
  regEdx AS DWORD
  regEcx AS DWORD
  regEax AS DWORD

  ' This section is specified/returned if the
  ' ContextFlags word contians the flag CONTEXT_CONTROL.
  regEbp AS DWORD
  regEip AS DWORD
  regCs AS DWORD      ' MUST BE SANITIZED
  regFlag AS DWORD    ' MUST BE SANITIZED
  regEsp AS DWORD
  regSs AS DWORD
END TYPE

TYPE DIOC_REGISTERS
  regEBX AS DWORD
  regEDX AS DWORD
  regECX AS DWORD
  regEAX AS DWORD
  regEDI AS DWORD
  regESI AS DWORD
  regFlags AS DWORD
END TYPE

TYPE EXCEPTION_POINTERS
  pExceptionRecord AS EXCEPTION_RECORD
  ContextRecord AS CONTEXT
END TYPE

TYPE LDT_BYTES                          'Defined for use in LDT_ENTRY Type
  BaseMid AS BYTE
  Flags1 AS BYTE
  Flags2 AS BYTE
  BaseHi AS BYTE
END TYPE

TYPE LDT_ENTRY
  LimitLow AS INTEGER
  BaseLow AS INTEGER
  HighWord AS LONG                      'Can use LDT_BYTES Type
END TYPE

TYPE TIME_ZONE_INFORMATION
  Bias AS LONG
  StandardName AS STRING * 64
  StandardDate AS SYSTEMTIME
  StandardBias AS LONG
  DaylightName AS STRING * 64
  DaylightDate AS SYSTEMTIME
  DaylightBias AS LONG
END TYPE

TYPE LARGE_INTEGER
  lowpart AS DWORD
  highpart AS LONG
END TYPE

' Stream ID type
TYPE WIN32_STREAM_ID
  dwStreamID AS LONG
  dwStreamAttributes AS LONG
  qsize AS LARGE_INTEGER
  dwStreamNameSize AS LONG
  cStreamName AS BYTE
END TYPE

TYPE STARTUPINFO
  cb AS LONG
  lpReserved AS ASCIIZ PTR
  lpDesktop AS ASCIIZ PTR
  lpTitle AS ASCIIZ PTR
  dwX AS LONG
  dwY AS LONG
  dwXSize AS LONG
  dwYSize AS LONG
  dwXCountChars AS LONG
  dwYCountChars AS LONG
  dwFillAttribute AS LONG
  dwFlags AS LONG
  wShowWindow AS INTEGER
  cbReserved2 AS INTEGER
  lpReserved2 AS BYTE
  hStdInput AS LONG
  hStdOutput AS LONG
  hStdError AS LONG
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS LONG
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS LONG
  dwReserved1 AS LONG
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternate AS ASCIIZ * 14
END TYPE

TYPE CPINFO
  MaxCharSize AS LONG                   'max length (Byte) of a char
  DefaultChar(%MAX_DEFAULTCHAR) AS BYTE 'default character
  LeadByte(%MAX_LEADBYTES) AS BYTE      'lead byte ranges
END TYPE

TYPE NUMBERFMT
  NumDigits AS LONG                     'number of decimal digits
  LeadingZero AS LONG                   'if leading zero in decimal fields
  Grouping AS LONG                      'group size left of decimal
  lpDecimalSep AS ASCIIZ PTR            'ptr to decimal separator string
  lpThousandSep AS ASCIIZ PTR           'ptr to thousand separator string
  NegativeOrder AS LONG                 'negative number ordering
END TYPE

TYPE CURRENCYFMT
  NumDigits AS LONG                     'number of decimal digits
  LeadingZero AS LONG                   'if leading zero in decimal fields
  Grouping AS LONG                      'group size left of decimal
  lpDecimalSep AS ASCIIZ PTR            'ptr to decimal separator string
  lpThousandSep AS ASCIIZ PTR           'ptr to thousand separator string
  NegativeOrder AS LONG                 'negative currency ordering
  PositiveOrder AS LONG                 'positive currency ordering
  lpCurrencySymbol AS ASCIIZ PTR        'ptr to currency symbol string
END TYPE

' The following section contains the public data structures, data types,
' and procedures exported by the NT console subsystem.

TYPE COORD
  x AS INTEGER
  y AS INTEGER
END TYPE

TYPE SMALL_RECT
  xLeft AS INTEGER
  xTop AS INTEGER
  xRight AS INTEGER
  xBottom AS INTEGER
END TYPE

TYPE KEY_EVENT_RECORD
  bKeyDown AS LONG
  wRepeatCount AS INTEGER
  wVirtualKeyCode AS INTEGER
  wVirtualScanCode AS INTEGER
  uChar AS INTEGER
  dwControlKeyState AS LONG
END TYPE

TYPE MOUSE_EVENT_RECORD
  dwMousePosition AS COORD
  dwButtonState AS LONG
  dwControlKeyState AS LONG
  dwEventFlags AS LONG
END TYPE

TYPE WINDOW_BUFFER_SIZE_RECORD
  dwSize AS COORD
END TYPE

TYPE MENU_EVENT_RECORD
  dwCommandId AS LONG
END TYPE

TYPE FOCUS_EVENT_RECORD
  bSetFocus AS LONG
END TYPE

UNION EventStruc
  KeyEvent AS KEY_EVENT_RECORD
  MouseEvent AS MOUSE_EVENT_RECORD
  WindowBufferSizeEvent AS WINDOW_BUFFER_SIZE_RECORD
  MenuEvent AS MENU_EVENT_RECORD
  FocusEvent AS FOCUS_EVENT_RECORD
END UNION

TYPE INPUT_RECORD
  EventType AS DWORD
  Event AS EventStruc
END TYPE

TYPE CHAR_INFO
  Ch AS INTEGER
  Attributes AS INTEGER
END TYPE

TYPE CONSOLE_SCREEN_BUFFER_INFO
  dwSize AS COORD
  dwCursorPosition AS COORD
  wAttributes AS INTEGER
  srWindow AS SMALL_RECT
  dwMaximumWindowSize AS COORD
END TYPE

TYPE CONSOLE_CURSOR_INFO
  dwSize AS LONG
  bVisible AS LONG
END TYPE

TYPE XFORM
  eM11 AS DOUBLE
  eM12 AS DOUBLE
  eM21 AS DOUBLE
  eM22 AS DOUBLE
  eDx AS DOUBLE
  eDy AS DOUBLE
END TYPE

' Bitmap Header Definition
TYPE BITMAP                             '14 bytes
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS INTEGER
  bmBitsPixel AS INTEGER
  bmBits AS LONG
END TYPE

TYPE RGBTRIPLE
  rgbtBlue AS BYTE
  rgbtGreen AS BYTE
  rgbtRed AS BYTE
END TYPE

TYPE RGBQUAD
  rgbBlue AS BYTE
  rgbGreen AS BYTE
  rgbRed AS BYTE
  rgbReserved AS BYTE
END TYPE

' structures for defining DIBs

TYPE BITMAPCOREHEADER                   '12 bytes
  bcSize AS LONG
  bcWidth AS INTEGER
  bcHeight AS INTEGER
  bcPlanes AS INTEGER
  bcBitCount AS INTEGER
END TYPE

TYPE BITMAPINFOHEADER                   '40 bytes
  biSize AS LONG
  biWidth AS LONG
  biHeight AS LONG
  biPlanes AS INTEGER
  biBitCount AS INTEGER
  biCompression AS LONG
  biSizeImage AS LONG
  biXPelsPerMeter AS LONG
  biYPelsPerMeter AS LONG
  biClrUsed AS LONG
  biClrImportant AS LONG
END TYPE

TYPE BITMAPINFO
  bmiHeader AS BITMAPINFOHEADER
  bmiColors(256) AS RGBQUAD
END TYPE

TYPE BITMAPCOREINFO
  bmciHeader AS BITMAPCOREHEADER
  bmciColors AS RGBTRIPLE
END TYPE

TYPE BITMAPFILEHEADER
  bfType AS INTEGER
  bfSize AS LONG
  bfReserved1 AS INTEGER
  bfReserved2 AS INTEGER
  bfOffBits AS LONG
END TYPE

TYPE HANDLETABLE
  objectHandle(1) AS LONG
END TYPE

TYPE METARECORD
  rdSize AS LONG
  rdFunction AS INTEGER
  rdParm(1) AS INTEGER
END TYPE

TYPE METAFILEPICT
  mm AS LONG
  xExt AS LONG
  yExt AS LONG
  hMF AS LONG
END TYPE

TYPE METAHEADER
  mtType AS INTEGER
  mtHeaderSize AS INTEGER
  mtVersion AS INTEGER
  mtSize AS LONG
  mtNoObjects AS INTEGER
  mtMaxRecord AS LONG
  mtNoParameters AS INTEGER
END TYPE

TYPE ENHMETARECORD
  iType AS LONG
  nSize AS LONG
  dParm(1) AS LONG
END TYPE

TYPE SIZEL
  cx AS LONG
  cy AS LONG
END TYPE

TYPE ENHMETAHEADER
  iType AS LONG
  nSize AS LONG
  rclBounds AS RECTL
  rclFrame AS RECTL
  dSignature AS LONG
  nVersion AS LONG
  nBytes AS LONG
  nRecords AS LONG
  nHandles AS INTEGER
  sReserved AS INTEGER
  nDescription AS LONG
  offDescription AS LONG
  nPalEntries AS LONG
  szlDevice AS SIZEL
  szlMillimeters AS SIZEL
END TYPE

TYPE TEXTMETRIC
  tmHeight AS LONG
  tmAscent AS LONG
  tmDescent AS LONG
  tmInternalLeading AS LONG
  tmExternalLeading AS LONG
  tmAveCharWidth AS LONG
  tmMaxCharWidth AS LONG
  tmWeight AS LONG
  tmOverhang AS LONG
  tmDigitizedAspectX AS LONG
  tmDigitizedAspectY AS LONG
  tmFirstChar AS BYTE
  tmLastChar AS BYTE
  tmDefaultChar AS BYTE
  tmBreakChar AS BYTE
  tmItalic AS BYTE
  tmUnderlined AS BYTE
  tmStruckOut AS BYTE
  tmPitchAndFamily AS BYTE
  tmCharSet AS BYTE
END TYPE

' Structure passed to FONTENUMPROC
' NOTE: NEWTEXTMETRIC is the same as TEXTMETRIC plus 4 new fields
TYPE NEWTEXTMETRIC
  tmHeight AS LONG
  tmAscent AS LONG
  tmDescent AS LONG
  tmInternalLeading AS LONG
  tmExternalLeading AS LONG
  tmAveCharWidth AS LONG
  tmMaxCharWidth AS LONG
  tmWeight AS LONG
  tmOverhang AS LONG
  tmDigitizedAspectX AS LONG
  tmDigitizedAspectY AS LONG
  tmFirstChar AS BYTE
  tmLastChar AS BYTE
  tmDefaultChar AS BYTE
  tmBreakChar AS BYTE
  tmItalic AS BYTE
  tmUnderlined AS BYTE
  tmStruckOut AS BYTE
  tmPitchAndFamily AS BYTE
  tmCharSet AS BYTE
  ntmFlags AS LONG
  ntmSizeEM AS LONG
  ntmCellHeight AS LONG
  ntmAveWidth AS LONG
END TYPE

' GDI Logical Objects:

TYPE PELARRAY
  paXCount AS LONG
  paYCount AS LONG
  paXExt AS LONG
  paYExt AS LONG
  paRGBs AS INTEGER
END TYPE

' Logical Brush (or Pattern)
TYPE LOGBRUSH
  lbStyle AS LONG
  lbColor AS LONG
  lbHatch AS LONG
END TYPE

' Logical Pen
TYPE LOGPEN
  lopnStyle AS LONG
  lopnWidth AS POINTAPI
  lopnColor AS LONG
END TYPE

TYPE EXTLOGPEN
  elpPenStyle AS LONG
  elpWidth AS LONG
  elpBrushStyle AS LONG
  elpColor AS LONG
  elpHatch AS LONG
  elpNumEntries AS LONG
  elpStyleEntry(1) AS LONG
END TYPE

TYPE PALETTEENTRY
  peRed AS BYTE
  peGreen AS BYTE
  peBlue AS BYTE
  peFlags AS BYTE
END TYPE

' Logical Palette
TYPE LOGPALETTE
  palVersion AS INTEGER
  palNumEntries AS INTEGER
  palPalEntry(1) AS PALETTEENTRY
END TYPE

TYPE LOGFONT
  lfHeight AS LONG
  lfWidth AS LONG
  lfEscapement AS LONG
  lfOrientation AS LONG
  lfWeight AS LONG
  lfItalic AS BYTE
  lfUnderline AS BYTE
  lfStrikeOut AS BYTE
  lfCharSet AS BYTE
  lfOutPrecision AS BYTE
  lfClipPrecision AS BYTE
  lfQuality AS BYTE
  lfPitchAndFamily AS BYTE
  lfFaceName As Asciiz * 32 '(%LF_FACESIZE) AS BYTE
END TYPE

TYPE NONCLIENTMETRICS
  cbSize AS LONG
  iBorderWidth AS LONG
  iScrollWidth AS LONG
  iScrollHeight AS LONG
  iCaptionWidth AS LONG
  iCaptionHeight AS LONG
  lfCaptionFont AS LOGFONT
  iSMCaptionWidth AS LONG
  iSMCaptionHeight AS LONG
  lfSMCaptionFont AS LOGFONT
  iMenuWidth AS LONG
  iMenuHeight AS LONG
  lfMenuFont AS LOGFONT
  lfStatusFont AS LOGFONT
  lfMessageFont AS LOGFONT
END TYPE

TYPE ENUMLOGFONT
  elfLogFont AS LOGFONT
  elfFullName(%LF_FULLFACESIZE) AS BYTE
  elfStyle(%LF_FACESIZE) AS BYTE
END TYPE

TYPE PANOSE
  ulculture AS LONG
  bFamilyType AS BYTE
  bSerifStyle AS BYTE
  bWeight AS BYTE
  bProportion AS BYTE
  bContrast AS BYTE
  bStrokeVariation AS BYTE
  bArmStyle AS BYTE
  bLetterform AS BYTE
  bMidline AS BYTE
  bXHeight AS BYTE
END TYPE

TYPE EXTLOGFONT
  elfLogFont AS LOGFONT
  elfFullName(%LF_FULLFACESIZE) AS BYTE
  elfStyle(%LF_FACESIZE) AS BYTE
  elfVersion AS LONG
  elfStyleSize AS LONG
  elfMatch AS LONG
  elfReserved AS LONG
  elfVendorId(%ELF_VENDOR_SIZE) AS BYTE
  elfCulture AS LONG
  elfPanose AS PANOSE
END TYPE

TYPE DEVMODE
  dmDeviceName AS ASCIIZ * %CCHDEVICENAME
  dmSpecVersion AS WORD
  dmDriverVersion AS WORD
  dmSize AS WORD
  dmDriverExtra AS WORD
  dmFields AS DWORD
  dmOrientation AS INTEGER
  dmPaperSize AS INTEGER
  dmPaperLength AS INTEGER
  dmPaperWidth AS INTEGER
  dmScale AS INTEGER
  dmCopies AS INTEGER
  dmDefaultSource AS INTEGER
  dmPrintQuality AS INTEGER
  dmColor AS INTEGER
  dmDuplex AS INTEGER
  dmYResolution AS INTEGER
  dmTTOption AS INTEGER
  dmCollate AS INTEGER
  dmFormName AS ASCIIZ * %CCHFORMNAME
  dmLogPixels AS WORD
  dmBitsPerPel AS DWORD
  dmPelsWidth AS LONG
  dmPelsHeight AS LONG
  dmDisplayFlags AS LONG
  dmDisplayFrequency AS LONG
  dmICMMethod As  Dword
    dmICMIntent As  Dword              ' The last 7 members were added !
    dmMediaType As  Dword
    dmDitherType As  Dword
    dmICCManufacturer As  Dword
    dmICCModel As  Dword
    dmPanningWidth As  Dword
    dmPanningHeight As  Dword
END TYPE

TYPE RGNDATAHEADER
  dwSize AS LONG
  iType AS LONG
  nCount AS LONG
  nRgnSize AS LONG
  rcBound AS Rect
END TYPE

TYPE RGNDATA
  rdh AS RGNDATAHEADER
  Buffer AS BYTE
END TYPE

TYPE ABC
  abcA AS LONG
  abcB AS LONG
  abcC AS LONG
END TYPE

TYPE ABCFLOAT
  abcfA AS DOUBLE
  abcfB AS DOUBLE
  abcfC AS DOUBLE
END TYPE

TYPE OUTLINETEXTMETRIC
  otmSize AS LONG
  otmTextMetrics AS TEXTMETRIC
  otmFiller AS BYTE
  otmPanoseNumber AS PANOSE
  otmfsSelection AS LONG
  otmfsType AS LONG
  otmsCharSlopeRise AS LONG
  otmsCharSlopeRun AS LONG
  otmItalicAngle AS LONG
  otmEMSquare AS LONG
  otmAscent AS LONG
  otmDescent AS LONG
  otmLineGap AS LONG
  otmsCapEmHeight AS LONG
  otmsXHeight AS LONG
  otmrcFontBox AS Rect
  otmMacAscent AS LONG
  otmMacDescent AS LONG
  otmMacLineGap AS LONG
  otmusMinimumPPEM AS LONG
  otmptSubscriptSize AS POINTAPI
  otmptSubscriptOffset AS POINTAPI
  otmptSuperscriptSize AS POINTAPI
  otmptSuperscriptOffset AS POINTAPI
  otmsStrikeoutSize AS LONG
  otmsStrikeoutPosition AS LONG
  otmsUnderscorePosition AS LONG
  otmsUnderscoreSize AS LONG
  otmpFamilyName AS ASCIIZ PTR
  otmpFaceName AS ASCIIZ PTR
  otmpStyleName AS ASCIIZ PTR
  otmpFullName AS ASCIIZ PTR
END TYPE

TYPE POLYTEXT
  x AS LONG
  y AS LONG
  n AS LONG
  lpStr AS ASCIIZ PTR
  uiFlags AS LONG
  rcl AS Rect
  pdx AS LONG
END TYPE

TYPE FIXED
  fract AS INTEGER
  Value AS INTEGER
END TYPE

TYPE MAT2
  eM11 AS FIXED
  eM12 AS FIXED
  eM21 AS FIXED
  eM22 AS FIXED
END TYPE

TYPE GLYPHMETRICS
  gmBlackBoxX AS LONG
  gmBlackBoxY AS LONG
  gmptGlyphOrigin AS POINTAPI
  gmCellIncX AS INTEGER
  gmCellIncY AS INTEGER
END TYPE

TYPE POINTFX
  x AS FIXED
  y AS FIXED
END TYPE

TYPE TTPOLYCURVE
  wType AS INTEGER
  cpfx AS INTEGER
  apfx AS POINTFX
END TYPE

TYPE TTPOLYGONHEADER
  cb AS LONG
  dwType AS LONG
  pfxStart AS POINTFX
END TYPE

TYPE RASTERIZER_STATUS
  nSize AS INTEGER
  wFlags AS INTEGER
  nLanguageID AS INTEGER
END TYPE

' Enhanced metafile constants

TYPE COLORADJUSTMENT
  caSize AS INTEGER
  caFlags AS INTEGER
  caIlluminantIndex AS INTEGER
  caRedGamma AS INTEGER
  caGreenGamma AS INTEGER
  caBlueGamma AS INTEGER
  caReferenceBlack AS INTEGER
  caReferenceWhite AS INTEGER
  caContrast AS INTEGER
  caBrightness AS INTEGER
  caColorfulness AS INTEGER
  caRedGreenTint AS INTEGER
END TYPE

TYPE DOCINFO
  cbSize AS LONG
  lpszDocName AS ASCIIZ PTR
  lpszOutput AS ASCIIZ PTR
  lpszpDataType AS ASCIIZ PTR
  fwType AS DWORD
END TYPE

TYPE KERNINGPAIR
  wFirst AS INTEGER
  wSecond AS INTEGER
  iKernAmount AS LONG
END TYPE

TYPE emr
  iType AS LONG
  nSize AS LONG
END TYPE

TYPE emrtext
  ptlReference AS POINTL
  nchars AS LONG
  offString AS LONG
  fOptions AS LONG
  rcl AS RECTL
  offDx AS LONG
END TYPE

TYPE EMRABORTPATH
  pEmr AS emr
END TYPE

TYPE EMRBEGINPATH
  pEmr AS emr
END TYPE

TYPE EMRENDPATH
  pEmr AS emr
END TYPE

TYPE EMRCLOSEFIGURE
  pEmr AS emr
END TYPE

TYPE EMRFLATTENPATH
  pEmr AS emr
END TYPE

TYPE EMRWIDENPATH
  pEmr AS emr
END TYPE

TYPE EMRSETMETARGN
  pEmr AS emr
END TYPE

TYPE EMREMRSAVEDC
  pEmr AS emr
END TYPE

TYPE EMRREALIZEPALETTE
  pEmr AS emr
END TYPE

TYPE EMRSELECTCLIPPATH
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETBKMODE
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETMAPMODE
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETPOLYFILLMODE
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETROP2
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETSTRETCHBLTMODE
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETTEXTALIGN
  pEmr AS emr
  iMode AS LONG
END TYPE

TYPE EMRSETMITERLIMIT
  pEmr AS emr
  eMiterLimit AS DOUBLE
END TYPE

TYPE EMRRESTOREDC
  pEmr AS emr
  iRelative AS LONG
END TYPE

TYPE EMRSETARCDIRECTION
  pEmr AS emr
  iArcDirection AS LONG
END TYPE

TYPE EMRSETMAPPERFLAGS
  pEmr AS emr
  dwFlags AS LONG
END TYPE

TYPE EMRSETTEXTCOLOR
  pEmr AS emr
  crColor AS LONG
END TYPE

TYPE EMRSETBKCOLOR
  pEmr AS emr
  crColor AS LONG
END TYPE

TYPE EMRSELECTOBJECT
  pEmr AS emr
  ihObject AS LONG
END TYPE

TYPE EMRDELETEOBJECT
  pEmr AS emr
  ihObject AS LONG
END TYPE

TYPE EMRSELECTPALETTE
  pEmr AS emr
  ihPal AS LONG
END TYPE

TYPE EMRRESIZEPALETTE
  pEmr AS emr
  ihPal AS LONG
  cEntries AS LONG
END TYPE

TYPE EMRSETPALETTEENTRIES
  pEmr AS emr
  ihPal AS LONG
  iStart AS LONG
  cEntries AS LONG
  aPalEntries(1) AS PALETTEENTRY
END TYPE

TYPE EMRSETCOLORADJUSTMENT
  pEmr AS emr
  ColorAdjustment AS ColorAdjustment
END TYPE

TYPE EMRGDICOMMENT
  pEmr AS emr
  cbData AS LONG
  xData(1) AS INTEGER
END TYPE

TYPE EMREOF
  pEmr AS emr
  nPalEntries AS LONG
  offPalEntries AS LONG
  nSizeLast AS LONG
END TYPE

TYPE EMRLINETO
  pEmr AS emr
  ptl AS POINTL
END TYPE

TYPE EMRMOVETOEX
  pEmr AS emr
  ptl AS POINTL
END TYPE

TYPE EMROFFSETCLIPRGN
  pEmr AS emr
  ptlOffset AS POINTL
END TYPE

TYPE EMRFILLPATH
  pEmr AS emr
  rclBounds AS RECTL
END TYPE

TYPE EMRSTROKEANDFILLPATH
  pEmr AS emr
  rclBounds AS RECTL
END TYPE

TYPE EMRSTROKEPATH
  pEmr AS emr
  rclBounds AS RECTL
END TYPE

TYPE EMREXCLUDECLIPRECT
  pEmr AS emr
  rclClip AS RECTL
END TYPE

TYPE EMRINTERSECTCLIPRECT
  pEmr AS emr
  rclClip AS RECTL
END TYPE

TYPE EMRSETVIEWPORTORGEX
  pEmr AS emr
  ptlOrigin AS POINTL
END TYPE

TYPE EMRSETWINDOWORGEX
  pEmr AS emr
  ptlOrigin AS POINTL
END TYPE

TYPE EMRSETBRUSHORGEX
  pEmr AS emr
  ptlOrigin AS POINTL
END TYPE

TYPE EMRSETVIEWPORTEXTEX
  pEmr AS emr
  szlExtent AS SIZEL
END TYPE

TYPE EMRSETWINDOWEXTEX
  pEmr AS emr
  szlExtent AS SIZEL
END TYPE

TYPE EMRSCALEVIEWPORTEXTEX
  pEmr AS emr
  xNum AS LONG
  xDenom AS LONG
  yNum AS LONG
  yDemon AS LONG
END TYPE

TYPE EMRSCALEWINDOWEXTEX
  pEmr AS emr
  xNum AS LONG
  xDenom AS LONG
  yNum AS LONG
  yDemon AS LONG
END TYPE

TYPE EMRSETWORLDTRANSFORM
  pEmr AS emr
  xform AS XFORM
END TYPE

TYPE EMRMODIFYWORLDTRANSFORM
  pEmr AS emr
  xform AS XFORM
  iMode AS LONG
END TYPE

TYPE EMRSETPIXELV
  pEmr AS emr
  ptlPixel AS POINTL
  crColor AS LONG
END TYPE

TYPE EMREXTFLOODFILL
  pEmr AS emr
  ptlStart AS POINTL
  crColor AS LONG
  iMode AS LONG
END TYPE

TYPE EMRELLIPSE
  pEmr AS emr
  rclBox AS RECTL
END TYPE

TYPE EMRRECTANGLE
  pEmr AS emr
  rclBox AS RECTL
END TYPE

TYPE EMRROUNDRECT
  pEmr AS emr
  rclBox AS RECTL
  szlCorner AS SIZEL
END TYPE

TYPE EMRARC
  pEmr AS emr
  rclBox AS RECTL
  ptlStart AS POINTL
  ptlEnd AS POINTL
END TYPE

TYPE EMRARCTO
  pEmr AS emr
  rclBox AS RECTL
  ptlStart AS POINTL
  ptlEnd AS POINTL
END TYPE

TYPE EMRCHORD
  pEmr AS emr
  rclBox AS RECTL
  ptlStart AS POINTL
  ptlEnd AS POINTL
END TYPE

TYPE EMRPIE
  pEmr AS emr
  rclBox AS RECTL
  ptlStart AS POINTL
  ptlEnd AS POINTL
END TYPE

TYPE EMRANGLEARC
  pEmr AS emr
  ptlCenter AS POINTL
  nRadius AS LONG
  eStartAngle AS DOUBLE
  eSweepAngle AS DOUBLE
END TYPE

TYPE EMRPOLYLINE
  pEmr AS emr
  rclBounds AS RECTL
  cptl AS LONG
  aptl(1) AS POINTL
END TYPE

TYPE EMRPOLYBEZIER
  pEmr AS emr
  rclBounds AS RECTL
  cptl AS LONG
  aptl(1) AS POINTL
END TYPE

TYPE EMRPOLYGON
  pEmr AS emr
  rclBounds AS RECTL
  cptl AS LONG
  aptl(1) AS POINTL
END TYPE

TYPE EMRPOLYBEZIERTO
  pEmr AS emr
  rclBounds AS RECTL
  cptl AS LONG
  aptl(1) AS POINTL
END TYPE

TYPE EMRPOLYLINE16
  pEmr AS emr
  rclBounds AS RECTL
  cpts AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRPOLYBEZIER16
  pEmr AS emr
  rclBounds AS RECTL
  cpts AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRPOLYGON16
  pEmr AS emr
  rclBounds AS RECTL
  cpts AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRPLOYBEZIERTO16
  pEmr AS emr
  rclBounds AS RECTL
  cpts AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRPOLYLINETO16
  pEmr AS emr
  rclBounds AS RECTL
  cpts AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRPOLYDRAW
  pEmr AS emr
  rclBounds AS RECTL
  cptl AS LONG
  aptl(1) AS POINTL
  abTypes(1) AS INTEGER
END TYPE

TYPE EMRPOLYDRAW16
  pEmr AS emr
  rclBounds AS RECTL
  cpts AS LONG
  apts(1) AS POINTS
  abTypes(1) AS INTEGER
END TYPE

TYPE EMRPOLYPOLYLINE
  pEmr AS emr
  rclBounds AS RECTL
  nPolys AS LONG
  cptl AS LONG
  aPolyCounts(1) AS LONG
  aptl(1) AS POINTL
END TYPE

TYPE EMRPOLYPOLYGON
  pEmr AS emr
  rclBounds AS RECTL
  nPolys AS LONG
  cptl AS LONG
  aPolyCounts(1) AS LONG
  aptl(1) AS POINTL
END TYPE

TYPE EMRPOLYPOLYLINE16
  pEmr AS emr
  rclBounds AS RECTL
  nPolys AS LONG
  cpts AS LONG
  aPolyCounts(1) AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRPOLYPOLYGON16
  pEmr AS emr
  rclBounds AS RECTL
  nPolys AS LONG
  cpts AS LONG
  aPolyCounts(1) AS LONG
  apts(1) AS POINTS
END TYPE

TYPE EMRINVERTRGN
  pEmr AS emr
  rclBounds AS RECTL
  cbRgnData AS LONG
  RgnData(1) AS INTEGER
END TYPE

TYPE EMRPAINTRGN
  pEmr AS emr
  rclBounds AS RECTL
  cbRgnData AS LONG
  RgnData(1) AS INTEGER
END TYPE

TYPE EMRFILLRGN
  pEmr AS emr
  rclBounds AS RECTL
  cbRgnData AS LONG
  ihBrush AS LONG
  RgnData(1) AS INTEGER
END TYPE

TYPE EMRFRAMERGN
  pEmr AS emr
  rclBounds AS RECTL
  cbRgnData AS LONG
  ihBrush AS LONG
  szlStroke AS SIZEL
  RgnData(1) AS INTEGER
END TYPE

TYPE EMREXTSELECTCLIPRGN
  pEmr AS emr
  cbRgnData AS LONG
  iMode AS LONG
  RgnData(1) AS INTEGER
END TYPE

TYPE EMREXTTEXTOUT
  pEmr AS emr
  rclBounds AS RECTL
  iGraphicsMode AS LONG
  exScale AS DOUBLE
  eyScale AS DOUBLE
  emrtext AS emrtext
END TYPE

TYPE EMRBITBLT
  pEmr AS emr
  rclBounds AS RECTL
  xDest AS LONG
  yDest AS LONG
  cxDest AS LONG
  cyDest AS LONG
  dwRop AS LONG
  xSrc AS LONG
  ySrc AS LONG
  xformSrc AS xform
  crBkColorSrc AS LONG
  iUsageSrc AS LONG
  offBmiSrc AS LONG
  cbBmiSrc AS LONG
  offBitsSrc AS LONG
  cbBitsSrc AS LONG
END TYPE

TYPE EMRSTRETCHBLT
  pEmr AS emr
  rclBounds AS RECTL
  xDest AS LONG
  yDest AS LONG
  cxDest AS LONG
  cyDest AS LONG
  dwRop AS LONG
  xSrc AS LONG
  ySrc AS LONG
  xformSrc AS xform
  crBkColorSrc AS LONG
  iUsageSrc AS LONG
  offBmiSrc AS LONG
  cbBmiSrc AS LONG
  offBitsSrc AS LONG
  cbBitsSrc AS LONG
  cxSrc AS LONG
  cySrc AS LONG
END TYPE

TYPE EMRMASKBLT
  pEmr AS emr
  rclBounds AS RECTL
  xDest AS LONG
  yDest AS LONG
  cxDest AS LONG
  cyDest AS LONG
  dwRop AS LONG
  xSrc2 AS LONG
  cyDest2 AS LONG
  dwRop2 AS LONG
  xSrc AS LONG
  ySrc AS LONG
  xformSrc AS XFORM
  crBkColorSrc AS LONG
  iUsageSrc AS LONG
  offBmiSrc AS LONG
  cbBmiSrc AS LONG
  offBitsSrc AS LONG
  cbBitsSrc AS LONG
  xMask AS LONG
  yMask AS LONG
  iUsageMask AS LONG
  offBmiMask AS LONG
  cbBmiMask AS LONG
  offBitsMask AS LONG
  cbBitsMask AS LONG
END TYPE

TYPE EMRPLGBLT
  pEmr AS emr
  rclBounds AS RECTL
  aptlDest(3) AS POINTL
  xSrc AS LONG
  ySrc AS LONG
  cxSrc AS LONG
  cySrc AS LONG
  xformSrc AS XFORM
  crBkColorSrc AS LONG
  iUsageSrc AS LONG
  offBmiSrc AS LONG
  cbBmiSrc AS LONG
  offBitsSrc AS LONG
  cbBitsSrc AS LONG
  xMask AS LONG
  yMask AS LONG
  iUsageMask AS LONG
  offBmiMask AS LONG
  cbBmiMask AS LONG
  offBitsMask AS LONG
  cbBitsMask AS LONG
END TYPE

TYPE EMRSETDIBITSTODEVICE
  pEmr AS emr
  rclBounds AS RECTL
  xDest AS LONG
  yDest AS LONG
  xSrc AS LONG
  ySrc AS LONG
  cxSrc AS LONG
  cySrc AS LONG
  offBmiSrc AS LONG
  cbBmiSrc AS LONG
  offBitsSrc AS LONG
  cbBitsSrc AS LONG
  iUsageSrc AS LONG
  iStartScan AS LONG
  cScans AS LONG
END TYPE

TYPE EMRSTRETCHDIBITS
  pEmr AS emr
  rclBounds AS RECTL
  xDest AS LONG
  yDest AS LONG
  xSrc AS LONG
  ySrc AS LONG
  cxSrc AS LONG
  cySrc AS LONG
  offBmiSrc AS LONG
  cbBmiSrc AS LONG
  offBitsSrc AS LONG
  cbBitsSrc AS LONG
  iUsageSrc AS LONG
  dwRop AS LONG
  cxDest AS LONG
  cyDest AS LONG
END TYPE

TYPE EMREXTCREATEFONTINDIRECT
  pEmr AS emr
  ihFont AS LONG
  elfw AS EXTLOGFONT
END TYPE

TYPE EMRCREATEPALETTE
  pEmr AS emr
  ihPal AS LONG
  lgpl AS LOGPALETTE
END TYPE

TYPE EMRCREATEPEN
  pEmr AS emr
  ihPen AS LONG
  lopn AS LOGPEN
END TYPE

TYPE EMREXTCREATEPEN
  pEmr AS emr
  ihPen AS LONG
  offBmi AS LONG
  cbBmi AS LONG
  offBits AS LONG
  cbBits AS LONG
  elp AS EXTLOGPEN
END TYPE

TYPE EMRCREATEBRUSHINDIRECT
  pEmr AS emr
  ihBrush AS LONG
  lb AS LOGBRUSH
END TYPE

TYPE EMRCREATEMONOBRUSH
  pEmr AS emr
  ihBrush AS LONG
  iUsage AS LONG
  offBmi AS LONG
  cbBmi AS LONG
  offBits AS LONG
  cbBits AS LONG
END TYPE

TYPE EMRCREATEDIBPATTERNBRUSHPT
  pEmr AS emr
  ihBursh AS LONG
  iUsage AS LONG
  offBmi AS LONG
  cbBmi AS LONG
  offBits AS LONG
  cbBits AS LONG
END TYPE

TYPE BITMAPV4HEADER
  bV4Size AS LONG
  bV4Width AS LONG
  bV4Height AS LONG
  bV4Planes AS INTEGER
  bV4BitCount AS INTEGER
  bV4V4Compression AS LONG
  bV4SizeImage AS LONG
  bV4XPelsPerMeter AS LONG
  bV4YPelsPerMeter AS LONG
  bV4ClrUsed AS LONG
  bV4ClrImportant AS LONG
  bV4RedMask AS LONG
  bV4GreenMask AS LONG
  bV4BlueMask AS LONG
  bV4AlphaMask AS LONG
  bV4CSType AS LONG
  bV4Endpoints AS LONG
  bV4GammaRed AS LONG
  bV4GammaGreen AS LONG
  bV4GammaBlue AS LONG
END TYPE

TYPE FONTSIGNATURE
  fsUsb(4) AS LONG
  fsCsb(2) AS LONG
END TYPE

TYPE CHARSETINFO
  ciCharset AS LONG
  ciACP AS LONG
  fs AS FONTSIGNATURE
END TYPE

TYPE LOCALESIGNATURE
  lsUsb(4) AS LONG
  lsCsbDefault(2) AS LONG
  lsCsbSupported(2) AS LONG
END TYPE

TYPE NEWTEXTMETRICEX
  ntmTm AS NEWTEXTMETRIC
  ntmFontSig AS FONTSIGNATURE
END TYPE

TYPE ENUMLOGFONTEX
  elfLogFont AS LOGFONT
  elfFullName(%LF_FULLFACESIZE) AS BYTE
  elfStyle(%LF_FACESIZE) AS BYTE
  elfScript(%LF_FACESIZE) AS BYTE
END TYPE

TYPE GCP_RESULTS
  lStructSize AS LONG
  lpOutString AS ASCIIZ PTR
  lpOrder AS LONG
  lpDX AS LONG
  lpCaretPos AS LONG
  lpClass AS ASCIIZ PTR
  lpGlyphs AS ASCIIZ PTR
  nGlyphs AS LONG
  nMaxFit AS LONG
END TYPE

TYPE CIEXYZ
  ciexyzX AS LONG
  ciexyzY AS LONG
  ciexyzZ AS LONG
END TYPE

TYPE CIEXYZTRIPLE
  ciexyzRed AS CIEXYZ
  ciexyzGreen AS CIEXYZ
  ciexyBlue AS CIEXYZ
END TYPE

TYPE LOGCOLORSPACE
  lcsSignature AS LONG
  lcsVersion AS LONG
  lcsSize AS LONG
  lcsCSType AS LONG
  lcsIntent AS LONG
  lcsEndPoints AS CIEXYZTRIPLE
  lcsGammaRed AS LONG
  lcsGammaGreen AS LONG
  lcsGammaBlue AS LONG
  lcsFileName AS ASCIIZ * %MAX_PATH
END TYPE

TYPE EMRSELECTCOLORSPACE
  pEmr AS emr
  ihCS AS LONG                          'ColorSpace xHandle index
END TYPE

TYPE EMRCREATECOLORSPACE
  pEmr AS emr
  ihCS AS LONG                          'ColorSpace xHandle index
  lcs AS LOGCOLORSPACE
END TYPE

' HCBT_ACTIVATE structure pointed to by lParam
TYPE CBTACTIVATESTRUCT
  fMouse AS LONG
  hWndActive AS LONG
END TYPE

' Message Structure used in Journaling
TYPE EVENTMSG
  message AS LONG
  paramL AS LONG
  paramH AS LONG
  time AS LONG
  hwnd AS LONG
END TYPE

TYPE CWPSTRUCT
  lParam AS LONG
  wParam AS LONG
  message AS LONG
  hwnd AS LONG
END TYPE

TYPE DEBUGHOOKINFO
  hModuleHook AS LONG
  Reserved AS LONG
  lParam AS LONG
  wParam AS LONG
  code AS LONG
END TYPE


TYPE MOUSEHOOKSTRUCT
  pt AS POINTAPI
  hwnd AS LONG
  wHitTestCode AS LONG
  dwExtraInfo AS LONG
END TYPE

' Message structure

TYPE MINMAXINFO
  ptReserved AS POINTAPI
  ptMaxSize AS POINTAPI
  ptMaxPosition AS POINTAPI
  ptMinTrackSize AS POINTAPI
  ptMaxTrackSize AS POINTAPI
END TYPE

TYPE COPYDATASTRUCT
  dwData AS LONG
  cbData AS LONG
  lpData AS LONG
END TYPE

' WM_WINDOWPOSCHANGING/CHANGED struct pointed to by lParam
TYPE WINDOWPOS
  hwnd AS LONG
  hWndInsertAfter AS LONG
  x AS LONG
  y AS LONG
  cx AS LONG
  cy AS LONG
  flags AS LONG
END TYPE

TYPE ACCEL
  fVirt AS BYTE
  key AS INTEGER
  cmd AS INTEGER
END TYPE

TYPE PAINTSTRUCT
  hdc AS LONG
  fErase AS LONG
  rcPaint AS Rect
  fRestore AS LONG
  fIncUpdate AS LONG
  rgbReserved(1 to 32) AS BYTE
END TYPE

TYPE CREATESTRUCT
  lpCreateParams AS LONG
  hInstance AS LONG
  hMenu AS LONG
  hWndParent AS LONG
  cy AS LONG
  cx AS LONG
  y AS LONG
  x AS LONG
  style AS LONG
  lpszName AS ASCIIZ PTR
  lpszClass AS ASCIIZ PTR
  ExStyle AS LONG
END TYPE

' HCBT_CREATEWND parameters pointed to by lParam
TYPE CBT_CREATEWND
  lpcs AS CREATESTRUCT
  hWndInsertAfter AS LONG
END TYPE

TYPE WINDOWPLACEMENT
  Length AS LONG
  flags AS LONG
  showCmd AS LONG
  ptMinPosition AS POINTAPI
  ptMaxPosition AS POINTAPI
  rcNormalPosition AS Rect
END TYPE

' MEASUREITEMSTRUCT for ownerdraw
TYPE MEASUREITEMSTRUCT
  CtlType AS LONG
  CtlID AS LONG
  itemID AS LONG
  itemWidth AS LONG
  itemHeight AS LONG
  itemData AS LONG
END TYPE

' DRAWITEMSTRUCT for ownerdraw
TYPE DRAWITEMSTRUCT
  CtlType AS LONG
  CtlID AS LONG
  itemID AS LONG
  itemAction AS LONG
  itemState AS LONG
  hwndItem AS LONG
  hdc AS LONG
  rcItem AS Rect
  itemData AS LONG
END TYPE

' DELETEITEMSTRUCT for ownerdraw
TYPE DELETEITEMSTRUCT
  CtlType AS LONG
  CtlID AS LONG
  itemID AS LONG
  hwndItem AS LONG
  itemData AS LONG
END TYPE

' COMPAREITEMSTRUCT for ownerdraw sorting
TYPE COMPAREITEMSTRUCT
  CtlType AS LONG
  CtlID AS LONG
  hwndItem AS LONG
  itemID1 AS LONG
  itemData1 AS LONG
  itemID2 AS LONG
  itemData2 AS LONG
END TYPE

Type WNDCLASS
  style As Long
  lpfnwndproc As Long
  cbClsextra As Long
  cbWndExtra As Long
  hInstance As Long
  hIcon As Long
  hCursor As Long
  hbrBackground As Long
  lpszMenuName As Asciiz Ptr
  lpszClassName As Asciiz Ptr
END TYPE

TYPE DlgTemplate
  Style         AS DWORD
  ExtendedStyle AS DWORD
  NumberOfItems AS WORD
  x             AS WORD
  y             AS WORD
  cx            AS WORD
  cy            AS WORD
END TYPE

TYPE DlgItemTemplate
  Style         AS DWORD
  ExtendedStyle AS DWORD
  x             AS WORD
  y             AS WORD
  cx            AS WORD
  cy            AS WORD
  ID            AS WORD
END TYPE

' Menu item resource format
TYPE MENUITEMTEMPLATEHEADER
  versionNumber AS INTEGER
  offset AS INTEGER
END TYPE

TYPE MENUITEMTEMPLATE
  mtOption AS INTEGER
  mtID AS INTEGER
  mtString AS BYTE
END TYPE

TYPE ICONINFO
  fIcon AS LONG
  xHotspot AS LONG
  yHotspot AS LONG
  hbmMask AS LONG
  hbmColor AS LONG
END TYPE

TYPE MDICREATESTRUCT
  szClass AS ASCIIZ PTR
  szTitle AS ASCIIZ PTR
  hOwner AS LONG
  x AS LONG
  y AS LONG
  cx AS LONG
  cy AS LONG
  style AS LONG
  lParam AS LONG
END TYPE

TYPE CLIENTCREATESTRUCT
  hWindowMenu AS LONG
  idFirstChild AS LONG
END TYPE

'  Help engine section.

TYPE MULTIKEYHELP
  mkSize AS LONG
  mkKeylist AS BYTE
  szKeyphrase AS ASCIIZ * 253           'Array length is arbitrary; may be changed
END TYPE

TYPE HELPWININFO
  wStructSize AS LONG
  x AS LONG
  y AS LONG
  dx AS LONG
  dy AS LONG
  wMax AS LONG
  rgchMember AS ASCIIZ * 2
END TYPE

TYPE DDEACK
  bAppReturnCode AS INTEGER
  Reserved AS INTEGER
  fbusy AS INTEGER
  fack AS INTEGER
END TYPE

' ----------------------------------------------------------------------------
TYPE DDEADVISE
  Reserved AS INTEGER
  fDeferUpd AS INTEGER
  fAckReq AS INTEGER
  cfFormat AS INTEGER
END TYPE

TYPE DDEDATA
  unused AS INTEGER
  fresponse AS INTEGER
  fRelease AS INTEGER
  Reserved AS INTEGER
  fAckReq AS INTEGER
  cfFormat AS INTEGER
  Value(1) AS BYTE
END TYPE

TYPE DDEPOKE
  unused AS INTEGER
  fRelease AS INTEGER
  fReserved AS INTEGER
  cfFormat AS INTEGER
  Value(1) AS BYTE
END TYPE

TYPE DDELN
  unused AS INTEGER
  fRelease AS INTEGER
  fDeferUpd AS INTEGER
  fAckReq AS INTEGER
  cfFormat AS INTEGER
END TYPE

TYPE DDEUP
  unused AS INTEGER
  fAck AS INTEGER
  fRelease AS INTEGER
  fReserved AS INTEGER
  fAckReq AS INTEGER
  cfFormat AS INTEGER
  xRGB(1) AS BYTE
END TYPE

TYPE HSZPAIR
  hszSvc AS LONG
  hszTopic AS LONG
END TYPE

TYPE SECURITY_QUALITY_OF_SERVICE
  Length AS LONG
  Impersonationlevel AS INTEGER
  ContextTrackingMode AS INTEGER
  EffectiveOnly AS LONG
END TYPE

TYPE CONVCONTEXT
  cb AS LONG
  wFlags AS LONG
  wCountryID AS LONG
  iCodePage AS LONG
  dwLangID AS LONG
  dwSecurity AS LONG
  qos AS SECURITY_QUALITY_OF_SERVICE
END TYPE

TYPE CONVINFO
  cb AS LONG
  hUser AS LONG
  hConvPartner AS LONG
  hszSvcPartner AS LONG
  hszServiceReq AS LONG
  hszTopic AS LONG
  hszItem AS LONG
  wFmt AS LONG
  wType AS LONG
  wStatus AS LONG
  wConvst AS LONG
  wLastError AS LONG
  hConvList AS LONG
  ConvCtxt AS CONVCONTEXT
  hwnd AS LONG
  hwndPartner AS LONG
END TYPE

TYPE DDEML_MSG_HOOK_DATA                'new for NT
  uiLo AS LONG                          'unpacked lo and hi parts of lParam
  uiHi AS LONG
  cbData AS LONG                        'amount of data in message, if any. May be > than 32 bytes.
  xData(8) AS LONG                      'data peeking by DDESPY is limited to 32 bytes.
END TYPE

TYPE MONMSGSTRUCT
  cb AS LONG
  hwndTo AS LONG
  dwTime AS LONG
  htask AS LONG
  wMsg AS LONG
  wParam AS LONG
  lParam AS LONG
  dmhd AS DDEML_MSG_HOOK_DATA           'new for NT
END TYPE

TYPE MONCBSTRUCT
  cb AS LONG
  dwTime AS LONG
  htask AS LONG
  dwRet AS LONG
  wType AS LONG
  wFmt AS LONG
  hConv AS LONG
  hsz1 AS LONG
  hsz2 AS LONG
  hData AS LONG
  dwData1 AS LONG
  dwData2 AS LONG
  cc AS CONVCONTEXT                     'new for NT for XTYP_CONNECT callbacks
  cbData AS LONG                        'new for NT for data peeking
  xData(8) AS LONG                      'new for NT for data peeking
END TYPE

TYPE MONHSZSTRUCT
  cb AS LONG
  fsAction AS LONG                      'MH_ value
  dwTime AS LONG
  hsz AS LONG
  htask AS LONG
  str AS BYTE
END TYPE

TYPE MONERRSTRUCT
  cb AS LONG
  wLastError AS LONG
  dwTime AS LONG
  htask AS LONG
END TYPE

TYPE MONLINKSTRUCT
  cb AS LONG
  dwTime AS LONG
  htask AS LONG
  fEstablished AS LONG
  fNoData AS LONG
  hszSvc AS LONG
  hszTopic AS LONG
  hszItem AS LONG
  wFmt AS LONG
  fServer AS LONG
  hConvServer AS LONG
  hConvClient AS LONG
END TYPE

TYPE MONCONVSTRUCT
  cb AS LONG
  fConnect AS LONG
  dwTime AS LONG
  htask AS LONG
  hszSvc AS LONG
  hszTopic AS LONG
  hConvClient AS LONG                   'Globally unique value != apps local hConv
  hConvServer AS LONG                   'Globally unique value != apps local hConv
END TYPE

TYPE smpte
  hour AS BYTE
  minute AS BYTE
  sec AS BYTE
  frame AS BYTE
  fps AS BYTE
  dummy AS BYTE
  pad(2) AS BYTE
END TYPE

TYPE midi
  songptrpos AS LONG
END TYPE

TYPE MMTIME
  wType AS LONG
  u AS LONG
END TYPE

TYPE MIDIEVENT
  dwDeltaTime AS LONG                   'Ticks since last event
  dwStreamID AS LONG                    'Reserved; must be zero
  dwEvent AS LONG                       'Event type and parameters
  dwParms(1) AS LONG                    'Parameters if this is a long event
END TYPE

TYPE MIDISTRMBUFFVER
  dwVersion AS LONG                     'Stream buffer format version
  dwMid AS LONG                         'Manufacturer ID as defined in MMREG.H
  dwOEMVersion AS LONG                  'Manufacturer version for custom ext
END TYPE

'  Type codes which go in the high byte of the event DWORD of a stream buffer

'  Type codes 00-7F contain parameters within the low 24 bits
'  Type codes 80-FF contain a length of their parameter in the low 24
'  bits, followed by their parameter data in the buffer. The event
'  DWORD contains the exact byte length; the parm data itself must be
'  padded to be an even multiple of 4 Byte long.

TYPE MIDIPROPTIMEDIV
  cbStruct AS LONG
  dwTimeDiv AS LONG
END TYPE

TYPE MIDIPROPTEMPO
  cbStruct AS LONG
  dwTempo AS LONG
END TYPE

TYPE MIXERCAPS
  wMid AS INTEGER                       'manufacturer id
  wPid AS INTEGER                       'product id
  vDriverVersion AS LONG                'version of the driver
  szPname AS ASCIIZ * %MAXPNAMELEN      'product name
  fdwSupport AS LONG                    'misc. support bits
  cDestinations AS LONG                 'count of destinations
END TYPE

TYPE Target                             'for use in MIXERLINE and others (embedded structure)
  dwType AS LONG                        'MIXERLINE_TARGETTYPE_xxxx
  dwDeviceID AS LONG                    'target device ID of device type
  wMid AS INTEGER                       'of target device
  wPid AS INTEGER                       '"
  vDriverVersion AS LONG                '"
  szPname AS ASCIIZ * %MAXPNAMELEN
END TYPE

TYPE MIXERLINE
  cbStruct AS LONG                      'size of MIXERLINE structure
  dwDestination AS LONG                 'zero based destination index
  dwSource AS LONG                      'zero based source index (if source)
  dwLineID AS LONG                      'unique line id for mixer device
  fdwLine AS LONG                       'state/information about line
  dwUser AS LONG                        'driver specific information
  dwComponentType AS LONG               'component type line connects to
  cChannels AS LONG                     'number of channels line supports
  cConnections AS LONG                  'number of connections (possible)
  cControls AS LONG                     'number of controls at this line
  szShortName AS ASCIIZ * %MIXER_SHORT_NAME_CHARS
  szName AS ASCIIZ * %MIXER_LONG_NAME_CHARS

  'lpTarget AS Target                   ' Patrice

  dwType AS LONG                        ' Patrice
  dwDeviceID AS LONG                    ' Patrice
  wMid  AS INTEGER                      ' Patrice
  wPid AS INTEGER                       ' Patrice
  vDriverVersion AS LONG                ' Patrice
  szPname As ASCIIZ * %MAXPNAMELEN      ' Patrice
END TYPE

'   MIXERCONTROL

TYPE MIXERCONTROL
  cbStruct AS LONG                      'size in Byte of MIXERCONTROL
  dwControlID AS LONG                   'unique control id for mixer device
  dwControlType AS LONG                 'MIXERCONTROL_CONTROLTYPE_xxx
  fdwControl AS LONG                    'MIXERCONTROL_CONTROLF_xxx
  cMultipleItems AS LONG                'if MIXERCONTROL_CONTROLF_MULTIPLE set
  szShortName AS ASCIIZ * %MIXER_SHORT_NAME_CHARS
  szName AS ASCIIZ * %MIXER_LONG_NAME_CHARS
  'Bounds AS DOUBLE                     ' Patrice
  'Metrics AS LONG                      ' Patrice
  lMinimum AS LONG                      ' Patrice Minimum value
  lMaximum AS LONG                      ' Patrice Maximum value
  reserved(10) AS LONG                  ' Patrice reserved structure space
END TYPE

'
'   MIXERCONTROL.fdwControl

'   MIXERLINECONTROLS
'
TYPE MIXERLINECONTROLS
  cbStruct AS LONG                      'size in Byte of MIXERLINECONTROLS
  dwLineID AS LONG                      'line id (from MIXERLINE.dwLineID)
'  MIXER_GETLINECONTROLSF_ONEBYID or
  dwControl AS LONG                     'MIXER_GETLINECONTROLSF_ONEBYTYPE
  cControls AS LONG                     'count of controls pmxctrl points to
  cbmxctrl AS LONG                      'size in Byte of _one_ MIXERCONTROL
  'pamxctrl AS MIXERCONTROL             ' Patrice 'pointer to first MIXERCONTROL array
  pamxctrl AS LONG                      ' Patrice pointer to first MIXERCONTROL array
END TYPE

TYPE MIXERCONTROLDETAILS
  cbStruct AS LONG                      'size in Byte of MIXERCONTROLDETAILS
  dwControlID AS LONG                   'control id to get/set details on
  cChannels AS LONG                     'number of channels in paDetails array
  item AS LONG                          'hwndOwner or cMultipleItems
  cbDetails AS LONG                     'size of _one_ details_XX struct
  paDetails AS LONG                     'pointer to array of details_XX structs
END TYPE

'   MIXER_GETCONTROLDETAILSF_LISTTEXT

TYPE MIXERCONTROLDETAILS_LISTTEXT
  dwParam1 AS LONG
  dwParam2 AS LONG
  szName AS ASCIIZ * %MIXER_LONG_NAME_CHARS
END TYPE

'   MIXER_GETCONTROLDETAILSF_VALUE

TYPE MIXERCONTROLDETAILS_BOOLEAN
  fValue AS LONG
END TYPE

TYPE MIXERCONTROLDETAILS_SIGNED
  lValue AS LONG
END TYPE

TYPE MIXERCONTROLDETAILS_UNSIGNED
  dwValue AS LONG
END TYPE

TYPE JOYINFOEX
  dwSize AS LONG                        'size of structure
  dwFlags AS LONG                       'flags to indicate what to return
  dwXpos AS LONG                        'x position
  dwYpos AS LONG                        'y position
  dwZpos AS LONG                        'z position
  dwRpos AS LONG                        'rudder/4th axis position
  dwUpos AS LONG                        '5th axis position
  dwVpos AS LONG                        '6th axis position
  dwButtons AS LONG                     'button states
  dwButtonNumber AS LONG                'current button number pressed
  dwPOV AS LONG                         'point of view state
  dwReserved1 AS LONG                   'reserved for communication between winmm driver
  dwReserved2 AS LONG                   'reserved for future expansion
END TYPE

TYPE DRVCONFIGINFO
  dwDCISize AS LONG
  lpszDCISectionName AS ASCIIZ PTR
  lpszDCIAliasName AS ASCIIZ PTR
  dnDevNode AS LONG
END TYPE

TYPE WAVEHDR
  lpData AS ASCIIZ PTR
  dwBufferLength AS LONG
  dwBytesRecorded AS LONG
  dwUser AS LONG
  dwFlags AS LONG
  dwLoops AS LONG
  lpNext AS LONG
  Reserved AS LONG
END TYPE

TYPE WAVEOUTCAPS
  wMid AS INTEGER
  wPid AS INTEGER
  vDriverVersion AS LONG
  szPname AS ASCIIZ * %MAXPNAMELEN
  dwFormats AS LONG
  wChannels AS INTEGER
  dwSupport AS LONG
END TYPE

TYPE WAVEINCAPS
  wMid AS INTEGER
  wPid AS INTEGER
  vDriverVersion AS LONG
  szPname AS ASCIIZ * %MAXPNAMELEN
  dwFormats AS LONG
  wChannels AS INTEGER
END TYPE

TYPE WAVEFORMAT
  wFormatTag AS INTEGER
  nChannels AS INTEGER
  nSamplesPerSec AS LONG
  nAvgBytesPerSec AS LONG
  nBlockAlign AS INTEGER
END TYPE

TYPE WAVEFORMATEX
  wFormatTag AS INTEGER
  nChannels AS INTEGER
  nSamplesPerSec AS LONG
  nAvgBytesPerSec AS LONG
  nBlockAlign AS INTEGER
  wBitsPerSample AS WORD
  cbSize AS WORD
END TYPE

TYPE PCMWAVEFORMAT
  wf AS WAVEFORMAT
  wBitsPerSample AS INTEGER
END TYPE

TYPE MIDIOUTCAPS
  wMid AS INTEGER
  wPid AS INTEGER
  vDriverVersion AS LONG
  szPname AS ASCIIZ * %MAXPNAMELEN
  wTechnology AS INTEGER
  wVoices AS INTEGER
  wNotes AS INTEGER
  wChannelMask AS INTEGER
  dwSupport AS LONG
END TYPE

TYPE MIDIINCAPS
  wMid AS INTEGER
  wPid AS INTEGER
  vDriverVersion AS LONG
  szPname AS ASCIIZ * %MAXPNAMELEN
END TYPE

TYPE MIDIHDR
  lpData AS ASCIIZ PTR
  dwBufferLength AS LONG
  dwBytesRecorded AS LONG
  dwUser AS LONG
  dwFlags AS LONG
  lpNext AS LONG
  Reserved AS LONG
END TYPE

TYPE AUXCAPS
  wMid AS INTEGER
  wPid AS INTEGER
  vDriverVersion AS LONG
  szPname AS ASCIIZ * %MAXPNAMELEN
  wTechnology AS INTEGER
  dwSupport AS LONG
END TYPE

TYPE TIMECAPS
  wPeriodMin AS LONG
  wPeriodMax AS LONG
END TYPE

TYPE JOYCAPS
  wMid AS INTEGER
  wPid AS INTEGER
  szPname AS ASCIIZ * %MAXPNAMELEN
  wXmin AS LONG
  wXmax AS LONG
  wYmin AS LONG
  wYmax AS LONG
  wZmin AS LONG
  wZmax AS LONG
  wNumButtons AS LONG
  wPeriodMin AS LONG
  wPeriodMax AS LONG
  wRmin AS LONG
  wRmax AS LONG
  wUmin AS LONG
  wUmax AS LONG
  wVmin AS LONG
  wVmax AS LONG
  wCaps AS LONG
  wMaxAxes AS LONG
  wNumAxes AS LONG
  wMaxButtons AS LONG
  szRegKey AS ASCIIZ * %MAXPNAMELEN
  szOEMVxD AS ASCIIZ * %MAX_JOYSTICKOEMVXDNAME
END TYPE

TYPE JOYINFO
  wXpos AS LONG
  wYpos AS LONG
  wZpos AS LONG
  wButtons AS LONG
END TYPE

TYPE MMIOINFO
  dwFlags AS LONG
  fccIOProc AS LONG
  pIOProc AS LONG
  wErrorRet AS LONG
  htask AS LONG
  cchBuffer AS LONG
  pchBuffer AS ASCIIZ PTR
  pchNext AS ASCIIZ PTR
  pchEndRead AS ASCIIZ PTR
  pchEndWrite AS ASCIIZ PTR
  lBufOffset AS LONG
  lDiskOffset AS LONG
  adwInfo(4) AS LONG
  dwReserved1 AS LONG
  dwReserved2 AS LONG
  hmmio AS LONG
END TYPE

TYPE MMCKINFO
  ckid AS LONG
  ckSize AS LONG
  fccType AS LONG
  dwDataOffset AS LONG
  dwFlags AS LONG
END TYPE

TYPE MCI_GENERIC_PARMS
  dwCallback AS LONG
END TYPE

TYPE MCI_OPEN_PARMS
  dwCallback AS LONG
  wDeviceID AS LONG
  lpstrDeviceType AS ASCIIZ PTR
  lpstrElementName AS ASCIIZ PTR
  lpstrAlias AS ASCIIZ PTR
END TYPE

TYPE MCI_PLAY_PARMS
  dwCallback AS LONG
  dwFrom AS LONG
  dwTo AS LONG
END TYPE

TYPE MCI_SEEK_PARMS
  dwCallback AS LONG
  dwTo AS LONG
END TYPE

TYPE MCI_STATUS_PARMS
  dwCallback AS LONG
  dwReturn AS LONG
  dwItem AS LONG
  dwTrack AS INTEGER
END TYPE

TYPE MCI_INFO_PARMS
  dwCallback AS LONG
  lpstrReturn AS ASCIIZ PTR
  dwRetSize AS LONG
END TYPE

TYPE MCI_GETDEVCAPS_PARMS
  dwCallback AS LONG
  dwReturn AS LONG
  dwIten AS LONG
END TYPE

TYPE MCI_SYSINFO_PARMS
  dwCallback AS LONG
  lpstrReturn AS ASCIIZ PTR
  dwRetSize AS LONG
  dwNumber AS LONG
  wDeviceType AS LONG
END TYPE

TYPE MCI_SET_PARMS
  dwCallback AS LONG
  dwTimeFormat AS LONG
  dwAudio AS LONG
END TYPE

TYPE MCI_BREAK_PARMS
  dwCallback AS LONG
  nVirtKey AS LONG
  hwndBreak AS LONG
END TYPE

TYPE MCI_SOUND_PARMS
  dwCallback AS LONG
  lpstrSoundName AS ASCIIZ PTR
END TYPE

TYPE MCI_SAVE_PARMS
  dwCallback AS LONG
  lpFileName AS ASCIIZ PTR
END TYPE

TYPE MCI_LOAD_PARMS
  dwCallback AS LONG
  lpFileName AS ASCIIZ PTR
END TYPE

TYPE MCI_RECORD_PARMS
  dwCallback AS LONG
  dwFrom AS LONG
  dwTo AS LONG
END TYPE

TYPE MCI_VD_PLAY_PARMS
  dwCallback AS LONG
  dwFrom AS LONG
  dwTo AS LONG
  dwSpeed AS LONG
END TYPE

TYPE MCI_VD_STEP_PARMS
  dwCallback AS LONG
  dwFrames AS LONG
END TYPE

TYPE MCI_VD_ESCAPE_PARMS
  dwCallback AS LONG
  lpstrCommand AS ASCIIZ PTR
END TYPE

TYPE MCI_WAVE_OPEN_PARMS
  dwCallback AS LONG
  wDeviceID AS LONG
  lpstrDeviceType AS ASCIIZ PTR
  lpstrElementName AS ASCIIZ PTR
  lpstrAlias AS ASCIIZ PTR
  dwBufferSeconds AS LONG
END TYPE

TYPE MCI_WAVE_DELETE_PARMS
  dwCallback AS LONG
  dwFrom AS LONG
  dwTo AS LONG
END TYPE

TYPE MCI_WAVE_SET_PARMS
  dwCallback AS LONG
  dwTimeFormat AS LONG
  dwAudio AS LONG
  wInput AS LONG
  wOutput AS LONG
  wFormatTag AS INTEGER
  wReserved2 AS INTEGER
  nChannels AS INTEGER
  wReserved3 AS INTEGER
  nSamplesPerSec AS LONG
  nAvgBytesPerSec AS LONG
  nBlockAlign AS INTEGER
  wReserved4 AS INTEGER
  wBitsPerSample AS INTEGER
  wReserved5 AS INTEGER
END TYPE

TYPE MCI_SEQ_SET_PARMS
  dwCallback AS LONG
  dwTimeFormat AS LONG
  dwAudio AS LONG
  dwTempo AS LONG
  dwPort AS LONG
  dwSlave AS LONG
  dwMaster AS LONG
  dwOffset AS LONG
END TYPE

TYPE MCI_ANIM_OPEN_PARMS
  dwCallback AS LONG
  wDeviceID AS LONG
  lpstrDeviceType AS ASCIIZ PTR
  lpstrElementName AS ASCIIZ PTR
  lpstrAlias AS ASCIIZ PTR
  dwStyle AS LONG
  hWndParent AS LONG
END TYPE

TYPE MCI_ANIM_PLAY_PARMS
  dwCallback AS LONG
  dwFrom AS LONG
  dwTo AS LONG
  dwSpeed AS LONG
END TYPE

TYPE MCI_ANIM_STEP_PARMS
  dwCallback AS LONG
  dwFrames AS LONG
END TYPE

TYPE MCI_ANIM_WINDOW_PARMS
  dwCallback AS LONG
  hwnd AS LONG
  nCmdShow AS LONG
  lpstrText AS ASCIIZ PTR
END TYPE

TYPE MCI_ANIM_RECT_PARMS
  dwCallback AS LONG
  rc AS Rect
END TYPE

TYPE MCI_ANIM_UPDATE_PARMS
  dwCallback AS LONG
  rc AS Rect
  hdc AS LONG
END TYPE

TYPE MCI_OVLY_OPEN_PARMS
  dwCallback AS LONG
  wDeviceID AS LONG
  lpstrDeviceType AS ASCIIZ PTR
  lpstrElementName AS ASCIIZ PTR
  lpstrAlias AS ASCIIZ PTR
  dwStyle AS LONG
  hWndParent AS LONG
END TYPE

TYPE MCI_OVLY_WINDOW_PARMS
  dwCallback AS LONG
  hwnd AS LONG
  nCmdShow AS LONG
  lpstrText AS ASCIIZ PTR
END TYPE

TYPE MCI_OVLY_RECT_PARMS
  dwCallback AS LONG
  rc AS Rect
END TYPE

TYPE MCI_OVLY_SAVE_PARMS
  dwCallback AS LONG
  lpFileName AS ASCIIZ PTR
  rc AS Rect
END TYPE

TYPE MCI_OVLY_LOAD_PARMS
  dwCallback AS LONG
  lpFileName AS ASCIIZ PTR
  rc AS Rect
END TYPE

' -------------
' Print APIs
' -------------

TYPE PRINTER_INFO_1
  flags AS LONG
  pDescription AS ASCIIZ PTR
  pName AS ASCIIZ PTR
  pComment AS ASCIIZ PTR
END TYPE

TYPE PRINTER_INFO_2
  pServerName AS ASCIIZ PTR
  pPrinterName AS ASCIIZ PTR
  pShareName AS ASCIIZ PTR
  pPortName AS ASCIIZ PTR
  pDriverName AS ASCIIZ PTR
  pComment AS ASCIIZ PTR
  pLocation AS ASCIIZ PTR
  pDevMode AS DEVMODE
  pSepFile AS ASCIIZ PTR
  pPrintProcessor AS ASCIIZ PTR
  pDatatype AS ASCIIZ PTR
  pParameters AS ASCIIZ PTR
  pSecurityDescriptor AS SECURITY_DESCRIPTOR
  Attributes AS LONG
  Priority AS LONG
  DefaultPriority AS LONG
  StartTime AS LONG
  UntilTime AS LONG
  Status AS LONG
  cJobs AS LONG
  AveragePPM AS LONG
END TYPE

TYPE PRINTER_INFO_3
  pSecurityDescriptor AS SECURITY_DESCRIPTOR
END TYPE

TYPE PRINTER_INFO_4
  pPrinterName AS ASCIIZ PTR
  pServerName AS ASCIIZ PTR
  Attributes AS LONG
END TYPE

' Type 5 is Win95 only

TYPE PRINTER_INFO_5
  pPrinterName AS ASCIIZ PTR
  pPortName AS ASCIIZ PTR
  Attributes AS LONG
  DeviceNotSelected AS LONG
  TransmissionRetryTimeout AS LONG
END TYPE

TYPE JOB_INFO_1
  JobId AS LONG
  pPrinterName AS ASCIIZ PTR
  pMachineName AS ASCIIZ PTR
  pUserName AS ASCIIZ PTR
  pDocument AS ASCIIZ PTR
  pDatatype AS ASCIIZ PTR
  pStatus AS ASCIIZ PTR
  Status AS LONG
  Priority AS LONG
  Position AS LONG
  TotalPages AS LONG
  PagesPrinted AS LONG
  Submitted AS SYSTEMTIME
END TYPE

TYPE JOB_INFO_2
  JobId AS LONG
  pPrinterName AS ASCIIZ PTR
  pMachineName AS ASCIIZ PTR
  pUserName AS ASCIIZ PTR
  pDocument AS ASCIIZ PTR
  pNotifyName AS ASCIIZ PTR
  pDatatype AS ASCIIZ PTR
  pPrintProcessor AS ASCIIZ PTR
  pParameters AS ASCIIZ PTR
  pDriverName AS ASCIIZ PTR
  pDevMode AS DEVMODE
  pStatus AS ASCIIZ PTR
  pSecurityDescriptor AS SECURITY_DESCRIPTOR
  Status AS LONG
  Priority AS LONG
  Position AS LONG
  StartTime AS LONG
  UntilTime AS LONG
  TotalPages AS LONG
  nSize AS LONG
  Submitted AS SYSTEMTIME
  time AS LONG
  PagesPrinted AS LONG
END TYPE

TYPE ADDJOB_INFO_1
  Path AS ASCIIZ PTR
  JobId AS LONG
END TYPE

TYPE DRIVER_INFO_1
  pName AS ASCIIZ PTR
END TYPE

TYPE DRIVER_INFO_2
  cVersion AS LONG
  pName AS ASCIIZ PTR
  pEnvironment AS ASCIIZ PTR
  pDriverPath AS ASCIIZ PTR
  pDataFile AS ASCIIZ PTR
  pConfigFile AS ASCIIZ PTR
END TYPE

TYPE DOC_INFO_1
  pDocName AS ASCIIZ PTR
  pOutputFile AS ASCIIZ PTR
  pDatatype AS ASCIIZ PTR
END TYPE

TYPE FORM_INFO_1
  pName AS ASCIIZ PTR
  nSize AS SIZEL
  ImageableArea AS RECTL
END TYPE

TYPE PRINTPROCESSOR_INFO_1
  pName AS ASCIIZ PTR
END TYPE

TYPE PORT_INFO_1
  pName AS ASCIIZ PTR
END TYPE

TYPE MONITOR_INFO_1
  pName AS ASCIIZ PTR
END TYPE

TYPE MONITOR_INFO_2
  pName AS ASCIIZ PTR
  pEnvironment AS ASCIIZ PTR
  pDLLName AS ASCIIZ PTR
END TYPE

TYPE DATATYPES_INFO_1
  pName AS ASCIIZ PTR
END TYPE

TYPE PRINTER_DEFAULTS
  pDatatype AS ASCIIZ PTR
  pDevMode AS DEVMODE
  DesiredAccess AS LONG
END TYPE

TYPE PRINTER_INFO_4
  pPrinterName AS ASCIIZ PTR
  pServerName AS ASCIIZ PTR
  Attributes AS LONG
END TYPE

TYPE PRINTER_INFO_5
  pPrinterName AS ASCIIZ PTR
  pPortName AS ASCIIZ PTR
  Attributes AS LONG
  DeviceNotSelectedTimeout AS LONG
  TransmissionRetryTimeout AS LONG
END TYPE

TYPE DRIVER_INFO_3
  cVersion AS LONG
  pName AS ASCIIZ PTR
  pEnvironment AS ASCIIZ PTR
  pDriverPath AS ASCIIZ PTR
  pDataFile AS ASCIIZ PTR
  pConfigFile AS ASCIIZ PTR
  pHelpFile AS ASCIIZ PTR
  pDependentFiles AS ASCIIZ PTR
  pMonitorName AS ASCIIZ PTR
  pDefaultDataType AS ASCIIZ PTR
END TYPE

TYPE DOC_INFO_2
  pDocName AS ASCIIZ PTR
  pOutputFile AS ASCIIZ PTR
  pDatatype AS ASCIIZ PTR
  dwMode AS LONG
  JobId AS LONG
END TYPE

TYPE PORT_INFO_2
  pPortName AS ASCIIZ PTR
  pMonitorName AS ASCIIZ PTR
  pDescription AS ASCIIZ PTR
  fPortType AS LONG
  Reserved AS LONG
END TYPE

TYPE PROVIDOR_INFO_1
  pName AS ASCIIZ PTR
  pEnvironment AS ASCIIZ PTR
  pDLLName AS ASCIIZ PTR
END TYPE

TYPE NETRESOURCE
  dwScope AS LONG
  dwType AS LONG
  dwDisplayType AS LONG
  dwUsage AS LONG
  lpLocalName AS ASCIIZ PTR
  lpRemoteName AS ASCIIZ PTR
  lpComment AS ASCIIZ PTR
  lpProvider AS ASCIIZ PTR
END TYPE

TYPE NCB
  ncb_command AS BYTE
  ncb_retcode AS BYTE
  ncb_lsn AS BYTE
  ncb_num AS BYTE
  ncb_buffer AS ASCIIZ PTR
  ncb_length AS WORD
  ncb_callname AS STRING * %NCBNAMSZ
  ncb_name AS STRING * %NCBNAMSZ
  ncb_rto AS BYTE
  ncb_sto AS BYTE
  ncb_post AS DWORD
  ncb_lana_num AS BYTE
  ncb_cmd_cplt AS BYTE
  ncb_reserve(10) AS BYTE
  ncb_event AS LONG
END TYPE

TYPE ADAPTER_STATUS
  adapter_address(6) AS BYTE
  rev_major AS BYTE
  reserved0 AS BYTE
  adapter_type AS BYTE
  rev_minor AS BYTE
  duration AS WORD
  frmr_recv AS WORD
  frmr_xmit AS WORD
  iframe_recv_err AS WORD
  xmit_aborts AS WORD
  xmit_success AS DWORD
  recv_success AS DWORD
  iframe_xmit_err AS WORD
  recv_buff_unavail AS WORD
  t1_timeouts AS WORD
  ti_timeouts AS WORD
  Reserved1 AS DWORD
  free_ncbs AS WORD
  max_cfg_ncbs AS WORD
  max_ncbs AS WORD
  xmit_buf_unavail AS WORD
  max_dgram_size AS WORD
  pending_sess AS WORD
  max_cfg_sess AS WORD
  max_sess AS WORD
  max_sess_pkt_size AS WORD
  name_count AS WORD
END TYPE

TYPE FIND_NAME_BUFFER
 Length AS BYTE
 access_control AS BYTE
 frame_control AS BYTE
 destination_addr(6) AS BYTE
 source_addr(6) AS BYTE
 routing_info(18) AS BYTE
END TYPE

TYPE FIND_NAME_HEADER
 node_count AS WORD
 Reserved AS BYTE
 unique_group AS BYTE
END TYPE

TYPE LANA_ENUM
 Length AS BYTE
 lana(%MAX_LANA) AS BYTE
END TYPE

TYPE NAME_BUFFER
 xname AS STRING * %NCBNAMSZ
 name_num AS BYTE
 name_flags AS BYTE
END TYPE

TYPE SESSION_HEADER
 sess_name AS BYTE
 num_sess AS BYTE
 rcv_dg_outstanding AS BYTE
 rcv_any_outstanding AS BYTE
END TYPE

TYPE SESSION_BUFFER
 lsn AS BYTE
 State AS BYTE
 local_name AS STRING * %NCBNAMSZ
 remote_name AS STRING * %NCBNAMSZ
 rcvs_outstanding AS BYTE
 sends_outstanding AS BYTE
END TYPE

TYPE ACTION_HEADER
  transport_id AS LONG
  action_code AS INTEGER
  Reserved AS INTEGER
END TYPE

TYPE CRGB
  bRed AS BYTE
  bGreen AS BYTE
  bBlue AS BYTE
  bExtra AS BYTE
END TYPE

TYPE SERVICE_STATUS
  dwServiceType AS LONG
  dwCurrentState AS LONG
  dwControlsAccepted AS LONG
  dwWin32ExitCode AS LONG
  dwServiceSpecificExitCode AS LONG
  dwCheckPoint AS LONG
  dwWaitHint AS LONG
END TYPE

TYPE ENUM_SERVICE_STATUS
  lpServiceName AS ASCIIZ PTR
  lpDisplayName AS ASCIIZ PTR
  ServiceStatus AS SERVICE_STATUS
END TYPE

TYPE QUERY_SERVICE_LOCK_STATUS
  fIsLocked AS LONG
  lpLockOwner AS ASCIIZ PTR
  dwLockDuration AS LONG
END TYPE

TYPE QUERY_SERVICE_CONFIG
  dwServiceType AS LONG
  dwStartType AS LONG
  dwErrorControl AS LONG
  lpBinaryPathName AS ASCIIZ PTR
  lpLoadOrderGroup AS ASCIIZ PTR
  dwTagId AS LONG
  lpDependencies AS ASCIIZ PTR
  lpServiceStartName AS ASCIIZ PTR
  lpDisplayName AS ASCIIZ PTR
END TYPE

TYPE SERVICE_TABLE_ENTRY
  lpServiceName AS ASCIIZ PTR
  lpServiceProc AS LONG
END TYPE

TYPE PERF_DATA_BLOCK
  Signature AS ASCIIZ * 4
  LittleEndian AS LONG
  Version AS LONG
  Revision AS LONG
  TotalByteLength AS LONG
  HeaderLength AS LONG
  NumObjectTypes AS LONG
  DefaultObject AS LONG
  SystemTime AS SYSTEMTIME
  PerfTime AS LARGE_INTEGER
  PerfFreq AS LARGE_INTEGER
  PerTime100nSec AS LARGE_INTEGER
  SystemNameLength AS LONG
  SystemNameOffset AS LONG
END TYPE

TYPE PERF_OBJECT_TYPE
  TotalByteLength AS LONG
  DefinitionLength AS LONG
  HeaderLength AS LONG
  ObjectNameTitleIndex AS LONG
  ObjectNameTitle AS ASCIIZ PTR
  ObjectHelpTitleIndex AS LONG
  ObjectHelpTitle AS ASCIIZ PTR
  DetailLevel AS LONG
  NumCounters AS LONG
  DefaultCounter AS LONG
  NumInstances AS LONG
  CodePage AS LONG
  PerfTime AS LARGE_INTEGER
  PerfFreq AS LARGE_INTEGER
END TYPE

TYPE PERF_COUNTER_DEFINITION
  ByteLength AS LONG
  CounterNameTitleIndex AS LONG
  CounterNameTitle AS ASCIIZ PTR
  CounterHelpTitleIndex AS LONG
  CounterHelpTitle AS ASCIIZ PTR
  DefaultScale AS LONG
  DetailLevel AS LONG
  CounterType AS LONG
  CounterSize AS LONG
  CounterOffset AS LONG
END TYPE

TYPE PERF_INSTANCE_DEFINITION
  ByteLength AS LONG
  ParentObjectTitleIndex AS LONG
  ParentObjectInstance AS LONG
  UniqueID AS LONG
  NameOffset AS LONG
  NameLength AS LONG
END TYPE

TYPE PERF_COUNTER_BLOCK
  ByteLength AS LONG
END TYPE

TYPE COMPOSITIONFORM
  dwStyle AS LONG
  ptCurrentPos AS POINTAPI
  rcArea AS Rect
END TYPE

TYPE CANDIDATEFORM
  dwIndex AS LONG
  dwStyle AS LONG
  ptCurrentPos AS POINTAPI
  rcArea AS Rect
END TYPE

TYPE CANDIDATELIST
  dwSize AS LONG
  dwStyle AS LONG
  dwCount AS LONG
  dwSelection AS LONG
  dwPageStart AS LONG
  dwPageSize AS LONG
  dwOffset(1) AS LONG
END TYPE

TYPE STYLEBUF
  dwStyle AS LONG
  szDescription AS ASCIIZ * %STYLE_DESCRIPTION_SIZE
END TYPE

TYPE MODEMDEVCAPS
  dwActualSize AS LONG
  dwRequiredSize AS LONG
  dwDevSpecificOffset AS LONG
  dwDevSpecificSize AS LONG
'  product and version identification
  dwModemProviderVersion AS LONG
  dwModemManufacturerOffset AS LONG
  dwModemManufacturerSize AS LONG
  dwModemModelOffset AS LONG
  dwModemModelSize AS LONG
  dwModemVersionOffset AS LONG
  dwModemVersionSize AS LONG
'  local option capabilities
  dwDialOptions AS LONG                 'bitmap of supported values
  dwCallSetupFailTimer AS LONG          'maximum in seconds
  dwInactivityTimeout AS LONG           'maximum in seconds
  dwSpeakerVolume AS LONG               'bitmap of supported values
  dwSpeakerMode AS LONG                 'bitmap of supported values
  dwModemOptions AS LONG                'bitmap of supported values
  dwMaxDTERate AS LONG                  'maximum value in bit/s
  dwMaxDCERate AS LONG                  'maximum value in bit/s
                                        'Variable portion for proprietary expansion
  abVariablePortion(1) AS BYTE
END TYPE

TYPE MODEMSETTINGS
  dwActualSize AS LONG
  dwRequiredSize AS LONG
  dwDevSpecificOffset AS LONG
  dwDevSpecificSize AS LONG
'  static local options (read/write)
  dwCallSetupFailTimer AS LONG          'seconds
  dwInactivityTimeout AS LONG           'seconds
  dwSpeakerVolume AS LONG               'level
  dwSpeakerMode AS LONG                 'mode
  dwPreferredModemOptions AS LONG       'bitmap
'  negotiated options (read only) for current or last call
  dwNegotiatedModemOptions AS LONG      'bitmap
  dwNegotiatedDCERate AS LONG           'bit/s
'  Variable portion for proprietary expansion
  abVariablePortion(1) AS BYTE
END TYPE

TYPE DRAGINFO
  uSize AS LONG                         'init with sizeof(DRAGINFO)
  pt AS POINTAPI
  fNC AS LONG
  lpFileList AS ASCIIZ PTR
  grfKeyState AS LONG
END TYPE

' AppBar stuff

TYPE APPBARDATA
  cbSize AS LONG
  hwnd AS LONG
  uCallbackMessage AS LONG
  uEdge AS LONG
  rc AS Rect
  lParam AS LONG                        'message specific
END TYPE

TYPE SHFILEOPSTRUCT
  hwnd AS LONG
  wFunc AS LONG
  pFrom AS ASCIIZ PTR
  pTo AS ASCIIZ PTR
  fFlags AS INTEGER
  fAnyOperationsAborted AS LONG
  hNameMappings AS LONG
  lpszProgressTitle AS ASCIIZ PTR       'only used if FOF_SIMPLEPROGRESS
END TYPE

TYPE SHNAMEMAPPING
  pszOldPath AS ASCIIZ PTR
  pszNewPath AS ASCIIZ PTR
  cchOldPath AS LONG
  cchNewPath AS LONG
END TYPE

TYPE SHELLEXECUTEINFO
  cbSize AS LONG
  fMask AS LONG
  hwnd AS LONG
  lpVerb AS ASCIIZ PTR
  lpFile AS ASCIIZ PTR
  lpParameters AS ASCIIZ PTR
  lpDirectory AS ASCIIZ PTR
  nShow AS LONG
  hInstApp AS LONG
'  Optional fields
  lpIDList AS LONG
  lpClass AS ASCIIZ PTR
  hkeyClass AS LONG
  dwHotKey AS LONG
  hIcon AS LONG
  hProcess AS LONG
END TYPE

TYPE NOTIFYICONDATA
  cbSize AS LONG
  hwnd AS LONG
  uID AS LONG
  uFlags AS LONG
  uCallbackMessage AS LONG
  hIcon AS LONG
  szTip AS ASCIIZ * 64
END TYPE

TYPE SHFILEINFO
  hIcon AS LONG                         'out: icon
  iIcon AS LONG                         'out: icon index
  dwAttributes AS LONG                  'out: SFGAO_ flags
  szDisplayName AS ASCIIZ * %MAX_PATH   'out: display name (or path)
  szTypeName AS ASCIIZ * 80             'out: type name
END TYPE

TYPE VS_FIXEDFILEINFO
  dwSignature AS LONG
  dwStrucVersion AS LONG                'e.g. &H00000042 = "0.42"
  dwFileVersionMS AS LONG               'e.g. &H00030075 = "3.75"
  dwFileVersionLS AS LONG               'e.g. &H00000031 = "0.31"
  dwProductVersionMS AS LONG            'e.g. &H00030010 = "3.10"
  dwProductVersionLS AS LONG            'e.g. &H00000031 = "0.31"
  dwFileFlagsMask AS LONG               '= &H3F for version "0.42"
  dwFileFlags AS LONG                   'e.g. VFF_DEBUG OR %VFF_PRERELEASE
  dwFileOS AS LONG                      'e.g. VOS_DOS_WINDOWS16
  dwFileType AS LONG                    'e.g. VFT_DRIVER
  dwFileSubtype AS LONG                 'e.g. VFT2_DRV_KEYBOARD
  dwFileDateMS AS LONG                  'e.g. 0
  dwFileDateLS AS LONG                  'e.g. 0
END TYPE

TYPE ICONMETRICS
  cbSize AS LONG
  iHorzSpacing AS LONG
  iVertSpacing AS LONG
  iTitleWrap AS LONG
  lfFont AS LOGFONT
END TYPE

TYPE HELPINFO
  cbSize AS LONG
  iContextType AS LONG
  iCtrlId AS LONG
  hItemHandle AS LONG
  dwContextId AS LONG
  MousePos AS POINTAPI
END TYPE

TYPE ANIMATIONINFO
  cbSize AS LONG
  iMinAnimate AS LONG
END TYPE

TYPE MINIMIZEDMETRICS
  cbSize AS LONG
  iWidth AS LONG
  iHorzGap AS LONG
  iVertGap AS LONG
  iArrange AS LONG
  lfFont AS LOGFONT
END TYPE

TYPE OSVERSIONINFO
  dwOSVersionInfoSize AS LONG
  dwMajorVersion AS LONG
  dwMinorVersion AS LONG
  dwBuildNumber AS LONG
  dwPlatformId AS LONG
  szCSDVersion AS ASCIIZ * 128          'Maintenance string for PSS usage
END TYPE

TYPE SYSTEM_POWER_STATUS
  ACLineStatus AS BYTE
  BatteryFlag AS BYTE
  BatteryLifePercent AS BYTE
  Reserved1 AS BYTE
  BatteryLifeTime AS LONG
  BatteryFullLifeTime AS LONG
END TYPE

TYPE NMHDR
  hwndFrom AS LONG
  idfrom AS LONG
  code AS LONG
END TYPE

TYPE DEVNAMES
  wDriverOffset AS INTEGER
  wDeviceOffset AS INTEGER
  wOutputOffset AS INTEGER
  wDefault AS INTEGER
END TYPE

TYPE PAGESETUPDLGAPI
  lStructSize AS LONG
  hwndOwner AS LONG
  hDevMode AS LONG
  hDevNames AS LONG
  flags AS LONG
  ptPaperSize AS POINTAPI
  rtMinMargin AS Rect
  rtMargin AS Rect
  hInstance AS LONG
  lCustData AS LONG
  lpfnPageSetupHook AS LONG
  lpfnPagePaintHook AS LONG
  lpPageSetupTemplateName AS ASCIIZ PTR
  hPageSetupTemplate AS LONG
END TYPE

TYPE COMMCONFIG
  dwSize AS LONG
  wVersion AS INTEGER
  wReserved AS INTEGER
  dcbx AS DCB
  dwProviderSubType AS LONG
  dwProviderOffset AS LONG
  dwProviderSize AS LONG
  wcProviderData AS BYTE
END TYPE

TYPE PIXELFORMATDESCRIPTOR
  nSize AS INTEGER
  nVersion AS INTEGER
  dwFlags AS LONG
  iPixelType AS BYTE
  cColorBits AS BYTE
  cRedBits AS BYTE
  cRedShift AS BYTE
  cGreenBits AS BYTE
  cGreenShift AS BYTE
  cBlueBits AS BYTE
  cBlueShift AS BYTE
  cAlphaBits AS BYTE
  cAlphaShift AS BYTE
  cAccumBits AS BYTE
  cAccumRedBits AS BYTE
  cAccumGreenBits AS BYTE
  cAccumBlueBits AS BYTE
  cAccumAlphaBits AS BYTE
  cDepthBits AS BYTE
  cStencilBits AS BYTE
  cAuxBuffers AS BYTE
  iLayerType AS BYTE
  bReserved AS BYTE
  dwLayerMask AS LONG
  dwVisibleMask AS LONG
  dwDamageMask AS LONG
END TYPE

TYPE DRAWTEXTPARAMS
  cbSize AS LONG
  iTabLength AS LONG
  iLeftMargin AS LONG
  iRightMargin AS LONG
  uiLengthDrawn AS LONG
END TYPE

TYPE MENUITEMINFO
  cbSize AS LONG
  fMask AS LONG
  fType AS LONG
  fState AS LONG
  wID AS LONG
  hSubMenu AS LONG
  hbmpChecked AS LONG
  hbmpUnchecked AS LONG
  dwItemData AS LONG
  dwTypeData AS ASCIIZ PTR
  cch AS LONG
END TYPE

TYPE SCROLLINFO
  cbSize AS LONG
  fMask AS LONG
  nMin AS LONG
  nMax AS LONG
  nPage AS LONG
  nPos AS LONG
  nTrackPos AS LONG
END TYPE

TYPE MSGBOXPARAMS
  cbSize AS LONG
  hwndOwner AS LONG
  hInstance AS LONG
  lpszText AS ASCIIZ PTR
  lpszCaption AS ASCIIZ PTR
  dwStyle AS LONG
  lpszIcon AS ASCIIZ PTR
  dwContextHelpId AS LONG
  lpfnMsgBoxCallback AS LONG
  dwLanguageId AS LONG
END TYPE

TYPE EXCEPTION_DEBUG_INFO
  ExceptionRecord AS EXCEPTION_RECORD
  dwFirstChange AS DWORD
END TYPE

TYPE CREATE_THREAD_DEBUG_INFO
  hThread AS LONG
  lpThreadLocalBase AS DWORD
  lpStartAddress AS DWORD
END TYPE

TYPE CREATE_PROCESS_DEBUG_INFO
  hFile AS LONG
  hProcess AS LONG
  hThread AS LONG
  lpBaseOfImage AS DWORD
  dwDebugInfoFileOffset AS DWORD
  nDebugInfoSize AS DWORD
  lpThreadLocalBase AS DWORD
  lpStartAdress AS DWORD
  lpImageName AS DWORD
  fUnicode AS WORD
END TYPE

TYPE EXIT_THREAD_DEBUG_INFO
  dwExitCode AS DWORD
END TYPE

TYPE EXIT_PROCESS_DEBUG_INFO
  dwExitCode AS DWORD
END TYPE

TYPE OUTPUT_DEBUG_STRING_INFO
  lpDebugStringData AS ASCIIZ PTR * 1024
  fUnicode AS WORD
  nDebugStringLength AS WORD
END TYPE

TYPE RIP_INFO
  dwError AS DWORD
  dwType AS DWORD
END TYPE

UNION DEBUGEVENTUNION
  Exception AS EXCEPTION_DEBUG_INFO
  CreateThread AS CREATE_THREAD_DEBUG_INFO
  CreateProcessInfo AS CREATE_PROCESS_DEBUG_INFO
  ExitThread AS EXIT_THREAD_DEBUG_INFO
  ExitProcess AS EXIT_PROCESS_DEBUG_INFO
  LoadDll AS LOAD_DLL_DEBUG_INFO
  UnloadDll AS UNLOAD_DLL_DEBUG_INFO
  DebugString AS OUTPUT_DEBUG_STRING_INFO
  RipInfo AS RIP_INFO
END UNION

TYPE DEBUG_EVENT
  dwDebugEventCode AS DWORD
  dwProcessId AS DWORD
  dwThreadId AS DWORD
  u AS DebugEventUnion
END TYPE

TYPE TBBUTTON
  iBitmap AS LONG
  idCommand AS LONG
  fsState AS BYTE
  fsStyle AS BYTE
  reserved(1 to 2) AS BYTE
  dwData AS DWORD
  iString AS LONG
END TYPE

TYPE COLORMAP
  cmFrom AS DWORD
  cmTo AS DWORD
END TYPE

TYPE TBNOTIFY
  hdr AS NMHDR
  iItem AS LONG
  Button AS TBBUTTON
  cchText AS LONG
  pszText AS ASCIIZ PTR
END TYPE

TYPE TBREPLACEBITMAP
  hInstOld AS LONG
  nIDOld AS WORD
  hInstNew AS LONG
  nIDNew AS WORD
  nButtons AS LONG
END TYPE

TYPE TBSAVEPARAMSA
  hkr AS LONG
  pszSubKey AS ASCIIZ PTR
  pszValueName AS ASCIIZ PTR
END TYPE

TYPE TBADDBITMAP
  hInst AS LONG
  nID AS WORD
END TYPE

TYPE TOOLINFO
  cbSize AS WORD
  uFlags AS WORD
  hwnd AS LONG
  uId AS WORD
  rec AS RECT
  hinst AS LONG
  lpszText AS ASCIIZ PTR
END TYPE

TYPE TTHITTESTINFO
  hwnd AS LONG
  pt AS POINTAPI
  ti AS TOOLINFO
END TYPE

TYPE TOOLTIPTEXT
  hdr AS NMHDR
  lpszText AS ASCIIZ PTR
  szText AS ASCIIZ * 80
  hinst AS LONG
  uFlags AS WORD
END TYPE

TYPE AuxVol
  vLow AS INTEGER
  vHigh AS INTEGER
END TYPE

UNION AuxVolume
  tAux AS AuxVol
  dwAux AS DWORD
END UNION

TYPE HITTESTINFO
  hwnd AS LONG
  pt AS POINTAPI
  ti AS TOOLINFO
END TYPE

TYPE DBGTHREAD
  hThread AS LONG
  lpStartAddress AS DWORD
  bfState AS LONG
  nNext AS DBGTHREAD PTR
END TYPE

TYPE DbgProcess
  hDbgHeap AS LONG
  dwProcessID AS LONG
  dwThreadID AS LONG
  hProcess AS LONG
  hFile AS LONG
  lpImage AS DWORD
END TYPE

TYPE IMAGE_DATA_DIRECTORY
  VirtualAddress AS DWORD
  nSize AS DWORD
END TYPE

TYPE IMAGE_OPTIONAL_HEADER
  '
  ' Standard fields.
  '
  Magic AS WORD
  MajorLinkerVersion AS BYTE
  MinorLinkerVersion AS BYTE
  SizeOfCode AS DWORD
  SizeOfInitializedData AS DWORD
  SizeOfUninitializedData AS DWORD
  AddressOfEntryPoint AS DWORD
  BaseOfCode AS DWORD
  BaseOfData AS DWORD

  '
  ' NT additional fields.
  '
  ImageBase AS DWORD
  SectionAlignment AS DWORD
  FileAlignment AS DWORD
  MajorOperatingSystemVersion AS WORD
  MinorOperatingSystemVersion AS WORD
  MajorImageVersion AS WORD
  MinorImageVersion AS WORD
  MajorSubsystemVersion AS WORD
  MinorSubsystemVersion AS WORD
  Reserved1 AS DWORD
  SizeOfImage AS DWORD
  SizeOfHeaders AS DWORD
  CheckSum AS DWORD
  Subsystem AS WORD
  DllCharacteristics AS WORD
  SizeOfStackReserve AS DWORD
  SizeOfStackCommit AS DWORD
  SizeOfHeapReserve AS DWORD
  SizeOfHeapCommit AS DWORD
  LoaderFlags AS DWORD
  NumberOfRvaAndSizes AS DWORD
  DataDirectory(%IMAGE_NUMBEROF_DIRECTORY_ENTRIES) AS IMAGE_DATA_DIRECTORY
END TYPE

TYPE IMAGE_FILE_HEADER
  Machine AS WORD
  NumberOfSections AS WORD
  TimeDateStamp AS DWORD
  PointerToSymbolTable AS DWORD
  NumberOfSymbols AS DWORD
  SizeOfOptionalHeader AS WORD
  Characteristics AS WORD
END TYPE

TYPE IMAGE_NT_HEADERS
  Signature AS DWORD
  FileHeader AS IMAGE_FILE_HEADER
  OptionalHeader AS IMAGE_OPTIONAL_HEADER
END TYPE

TYPE IMAGE_EXPORT_DIRECTORY
  Characteristics AS DWORD
  TimeDateStamp AS DWORD
  MajorVersion AS WORD
  MinorVersion AS WORD
  nName AS DWORD
  nBase AS DWORD
  NumberOfFunctions AS DWORD
  NumberOfNames AS DWORD
  AddressOfFunctions AS DWORD PTR
  AddressOfNames AS DWORD PTR
  AddressOfNameOrdinals AS WORD PTR
END TYPE

TYPE IMAGE_DOS_HEADER          ' DOS .EXE header
  e_magic AS WORD              ' Magic number
  e_cblp AS WORD               ' Bytes on last page of file
  e_cp AS WORD                 ' Pages in file
  e_crlc AS WORD               ' Relocations
  e_cparhdr AS WORD            ' Size of header in paragraphs
  e_minalloc AS WORD           ' Minimum extra paragraphs needed
  e_maxalloc AS WORD           ' Maximum extra paragraphs needed
  e_ss AS WORD                 ' Initial (relative) SS value
  e_sp AS WORD                 ' Initial SP value
  e_csum AS WORD               ' Checksum
  e_ip AS WORD                 ' Initial IP value
  e_cs AS WORD                 ' Initial (relative) CS value
  e_lfarlc AS WORD             ' File address of relocation table
  e_ovno AS WORD               ' Overlay number
  e_res(4) AS WORD             ' Reserved words
  e_oemid AS WORD              ' OEM identifier (for e_oeminfo)
  e_oeminfo AS WORD            ' OEM information; e_oemid specific
  e_res2(10) AS WORD           ' Reserved words
  e_lfanew AS LONG             ' File address of new exe header
END TYPE

TYPE USER_INFO_3
   ' Level 0 starts here
  uName AS LONG                ' pointer to Unicode string
   ' Level 1 starts here
  Password AS LONG             ' pointer to Unicode string
  PasswordAge AS LONG          '
  Privilege AS LONG            '
  HomeDir AS LONG              ' pointer to Unicode string
  Comment AS LONG              ' pointer to Unicode string
  Flags AS LONG                '
  ScriptPath AS LONG           ' pointer to Unicode string
   ' Level 2 starts here
  AuthFlags AS LONG            '
  FullName AS LONG             ' pointer to Unicode string
  UserComment AS LONG          ' pointer to Unicode string
  Parms AS LONG                ' pointer to Unicode string
  Workstations AS LONG         ' pointer to Unicode string
  LastLogon AS LONG            '
  LastLogoff AS LONG           '
  AcctExpires AS LONG          '
  MaxStorage AS LONG           '
  UnitsPerWeek AS LONG         '
  LogonHours AS LONG           ' pointer to 21 byte bitmap
  BadPwCount AS LONG           '
  NumLogons AS LONG            '
  LogonServer AS LONG          ' pointer to Unicode string
  CountryCode AS LONG          '
  CodePage AS LONG             '
   ' Level 3 starts here
  UserID AS LONG               '
  PrimaryGroupID AS LONG       '
  Profile AS LONG              ' pointer to Unicode string
  HomeDirDrive AS LONG         ' pointer to Unicode string
  PasswordExpired AS LONG      ' boolean
END TYPE

TYPE WKSTA_USER_INFO_1
  wkui_username     AS BYTE PTR
  wkui_logon_domain AS BYTE PTR
  wkui_oth_domains  AS BYTE PTR
  wkui_logon_server AS BYTE PTR
END TYPE

TYPE GROUP_INFO_2
  uName AS LONG                ' pointer to Unicode string
  Comment AS LONG              ' pointer to Unicode string
  GroupID AS LONG              '
  Attributes AS LONG           '
END TYPE

TYPE SERVER_INFO_100
  sv_platform_id AS LONG    '
  sv_name AS BYTE PTR       ' workstation name
END TYPE

TYPE SERVER_INFO_101
  sv_platform_id AS LONG    '
  sv_name AS BYTE PTR       ' workstation name
  sv_version_major AS LONG  '
  sv_version_minor AS LONG  '
  sv_type AS LONG           '
  sv_comment AS BYTE PTR    '
END TYPE

TYPE SERVER_INFO_102           '
  sv_platform_id AS LONG    '
  sv_name AS BYTE PTR       '
  sv_version_major AS LONG  '
  sv_version_minor AS LONG  '
  sv_type AS LONG           '
  sv_comment AS BYTE PTR    '
  sv_users AS LONG          '
  sv_disc AS LONG           '
  sv_hidden AS LONG         '
  sv_announce AS LONG       '
  sv_anndelta AS LONG       '
  sv_licenses AS LONG       '
  sv_userpath AS BYTE PTR   '
END TYPE

TYPE SERVER_INFO_402
  sv_ulist_mtime AS LONG
  sv_glist_mtime AS LONG
  sv_alist_mtime AS LONG
  sv_alerts AS BYTE PTR
  sv_security AS LONG
  sv_numadmin AS LONG
  sv_lanmask AS LONG
  sv_guestacct AS BYTE PTR
  sv_chdevs AS LONG
  sv_chdevq AS LONG
  sv_chdevjobs AS LONG
  sv_connections AS LONG
  sv_shares AS LONG
  sv_openfiles AS LONG
  sv_sessopens AS LONG
  sv_sessvcs AS LONG
  sv_sessreqs AS LONG
  sv_opensearch AS LONG
  sv_activelocks AS LONG
  sv_numreqbuf AS LONG
  sv_sizreqbuf AS LONG
  sv_numbigbuf AS LONG
  sv_numfiletasks AS LONG
  sv_alertsched AS LONG
  sv_erroralert AS LONG
  sv_logonalert AS LONG
  sv_accessalert AS LONG
  sv_diskalert AS LONG
  sv_netioalert AS LONG
  sv_maxauditsz AS LONG
  sv_srvheuristics AS BYTE PTR
END TYPE

TYPE SERVER_INFO_403
  sv403_ulist_mtime AS LONG
  sv_glist_mtime AS LONG
  sv_alist_mtime AS LONG
  sv_alerts AS BYTE PTR
  sv_security AS LONG
  sv_numadmin AS LONG
  sv_lanmask AS LONG
  sv_guestacct AS BYTE PTR
  sv_chdevs AS LONG
  sv_chdevq AS LONG
  sv_chdevjobs AS LONG
  sv_connections AS LONG
  sv_shares AS LONG
  sv_openfiles AS LONG
  sv_sessopens AS LONG
  sv_sessvcs AS LONG
  sv_sessreqs AS LONG
  sv_opensearch AS LONG
  sv_activelocks AS LONG
  sv_numreqbuf AS LONG
  sv_sizreqbuf AS LONG
  sv_numbigbuf AS LONG
  sv_numfiletasks AS LONG
  sv_alertsched AS LONG
  sv_erroralert AS LONG
  sv_logonalert AS LONG
  sv_accessalert AS LONG
  sv_diskalert AS LONG
  sv_netioalert AS LONG
  sv_maxauditsz AS LONG
  sv_srvheuristics AS BYTE PTR
  sv_auditedevents AS LONG
  sv_autoprofile AS LONG
  sv_autopath AS BYTE PTR
END TYPE

TYPE SERVER_INFO_502
  sv_sessopens AS LONG
  sv_sessvcs AS LONG
  sv_opensearch AS LONG
  sv_sizreqbuf AS LONG
  sv_initworkitems AS LONG
  sv_maxworkitems AS LONG
  sv_rawworkitems AS LONG
  sv_irpstacksize AS LONG
  sv_maxrawbuflen AS LONG
  sv_sessusers AS LONG
  sv_sessconns AS LONG
  sv_maxpagedmemoryusage AS LONG
  sv_maxnonpagedmemoryusage AS LONG
  sv_enablesoftcompat AS LONG
  sv_enableforcedlogoff AS LONG
  sv_timesource AS LONG
  sv_acceptdownlevelapis AS LONG
  sv_lmannounce AS LONG
END TYPE

TYPE SERVER_INFO_503
  sv_sessopens AS LONG
  sv_sessvcs AS LONG
  sv_opensearch AS LONG
  sv_sizreqbuf AS LONG
  sv_initworkitems AS LONG
  sv_maxworkitems AS LONG
  sv_rawworkitems AS LONG
  sv_irpstacksize AS LONG
  sv_maxrawbuflen AS LONG
  sv_sessusers AS LONG
  sv_sessconns AS LONG
  sv_maxpagedmemoryusage AS LONG
  sv_maxnonpagedmemoryusage AS LONG
  sv_enablesoftcompat AS LONG
  sv_enableforcedlogoff AS LONG
  sv_timesource AS LONG
  sv_acceptdownlevelapis AS LONG
  sv_lmannounce AS LONG
  sv_domain AS BYTE PTR
  sv_maxcopyreadlen AS LONG
  sv_maxcopywritelen AS LONG
  sv_minkeepsearch AS LONG
  sv_maxkeepsearch AS LONG
  sv_minkeepcomplsearch AS LONG
  sv_maxkeepcomplsearch AS LONG
  sv_threadcountadd AS LONG
  sv_numblockthreads AS LONG
  sv_scavtimeout AS LONG
  sv_minrcvqueue AS LONG
  sv_minfreeworkitems AS LONG
  sv_xactmemsize AS LONG
  sv_threadpriority AS LONG
  sv_maxmpxct AS LONG
  sv_oplockbreakwait AS LONG
  sv_oplockbreakresponsewait AS LONG
  sv_enableoplocks AS LONG
  sv_enableoplockforceclose AS LONG
  sv_enablefcbopens AS LONG
  sv_enableraw AS LONG
  sv_enablesharednetdrives AS LONG
  sv_minfreeconnections AS LONG
  sv_maxfreeconnections AS LONG
END TYPE

TYPE SERVER_INFO_599
  sv_sessopens AS LONG
  sv_sessvcs AS LONG
  sv_opensearch AS LONG
  sv_sizreqbuf AS LONG
  sv_initworkitems AS LONG
  sv_maxworkitems AS LONG
  sv_rawworkitems AS LONG
  sv_irpstacksize AS LONG
  sv_maxrawbuflen AS LONG
  sv_sessusers AS LONG
  sv_sessconns AS LONG
  sv_maxpagedmemoryusage AS LONG
  sv_maxnonpagedmemoryusage AS LONG
  sv_enablesoftcompat AS LONG
  sv_enableforcedlogoff AS LONG
  sv_timesource AS LONG
  sv_acceptdownlevelapis AS LONG
  sv_lmannounce AS LONG
  sv_domain AS BYTE PTR
  sv_maxcopyreadlen AS LONG
  sv_maxcopywritelen AS LONG
  sv_minkeepsearch AS LONG
  sv_maxkeepsearch AS LONG
  sv_minkeepcomplsearch AS LONG
  sv_maxkeepcomplsearch AS LONG
  sv_threadcountadd AS LONG
  sv_numblockthreads AS LONG
  sv_scavtimeout AS LONG
  sv_minrcvqueue AS LONG
  sv_minfreeworkitems AS LONG
  sv_xactmemsize AS LONG
  sv_threadpriority AS LONG
  sv_maxmpxct AS LONG
  sv_oplockbreakwait AS LONG
  sv_oplockbreakresponsewait AS LONG
  sv_enableoplocks AS LONG
  sv_enableoplockforceclose AS LONG
  sv_enablefcbopens AS LONG
  sv_enableraw AS LONG
  sv_enablesharednetdrives AS LONG
  sv_minfreeconnections AS LONG
  sv_maxfreeconnections AS LONG
  sv_initsesstable AS LONG
  sv_initconntable AS LONG
  sv_initfiletable AS LONG
  sv_initsearchtable AS LONG
  sv_alertschedule AS LONG
  sv_errorthreshold AS LONG
  sv_networkerrorthreshold AS LONG
  sv_diskspacethreshold AS LONG
  sv_reserved AS LONG
  sv_maxlinkdelay AS LONG
  sv_minlinkthroughput AS LONG
  sv_linkinfovalidtime AS LONG
  sv_scavqosinfoupdatetime AS LONG
  sv_maxworkitemidletime AS LONG
END TYPE

TYPE SERVER_INFO_598
  sv_maxrawworkitems AS LONG
  sv_maxthreadsperqueue AS LONG
  sv_producttype AS LONG
  sv_serversize AS LONG
  sv_connectionlessautodisc AS LONG
  sv_sharingviolationretries AS LONG
  sv_sharingviolationdelay AS LONG
  sv_maxglobalopensearch AS LONG
  sv_removeduplicatesearches AS LONG
  sv_lockviolationoffset AS LONG
  sv_lockviolationdelay AS LONG
  sv_mdlreadswitchover AS LONG
  sv_cachedopenlimit AS LONG
  sv_otherqueueaffinity AS LONG
  sv_restrictnullsessaccess AS LONG
  sv_enablewfw311directipx AS LONG
  sv_queuesamplesecs AS LONG
  sv_balancecount AS LONG
  sv_preferredaffinity AS LONG
  sv_maxfreerfcbs AS LONG
  sv_maxfreemfcbs AS LONG
  sv_maxfreelfcbs AS LONG
  sv_maxfreepagedpoolchunks AS LONG
  sv_minpagedpoolchunksize AS LONG
  sv_maxpagedpoolchunksize AS LONG
  sv_sendsfrompreferredprocessor AS LONG
  sv_cacheddirectorylimit AS LONG
  sv_maxcopylength AS LONG
  sv_enablebulktransfer AS LONG
  sv_enablecompression AS LONG
  sv_autosharewks AS LONG
  sv_autoshareserver AS LONG
  sv_enablesecuritysignature AS LONG
  sv_requiresecuritysignature AS LONG
  sv_minclientbuffersize AS LONG
  sv_serverguid AS LONG  'GUID
  sv_ConnectionNoSessionsTimeout AS LONG
END TYPE

TYPE SERVER_INFO_1005
  sv_comment AS BYTE PTR
END TYPE

TYPE SERVER_INFO_1107
  sv_users AS LONG
END TYPE

TYPE SERVER_INFO_1010
  sv_disc AS LONG
END TYPE

TYPE SERVER_INFO_1016
  sv_hidden AS LONG
END TYPE

TYPE SERVER_INFO_1017
  sv_announce AS LONG
END TYPE

TYPE SERVER_INFO_1018
  sv_anndelta AS LONG
END TYPE

TYPE SERVER_INFO_1501
  sv_sessopens AS LONG
END TYPE

TYPE SERVER_INFO_1502
  sv_sessvcs AS LONG
END TYPE

TYPE SERVER_INFO_1503
  sv_opensearch AS LONG
END TYPE

TYPE SERVER_INFO_1506
  sv_maxworkitems AS LONG
END TYPE

TYPE SERVER_INFO_1509
  sv_maxrawbuflen AS LONG
END TYPE

TYPE SERVER_INFO_1510
  sv_sessusers AS LONG
END TYPE

TYPE SERVER_INFO_1511
  sv_sessconns AS LONG
END TYPE

TYPE SERVER_INFO_1512
  sv_maxnonpagedmemoryusage AS LONG
END TYPE

TYPE SERVER_INFO_1513
  sv_maxpagedmemoryusage AS LONG
END TYPE

TYPE SERVER_INFO_1514
  sv_enablesoftcompat AS LONG
END TYPE

TYPE SERVER_INFO_1515
  sv_enableforcedlogoff AS LONG
END TYPE

TYPE SERVER_INFO_1516
  sv_timesource AS LONG
END TYPE

TYPE SERVER_INFO_1518
  sv_lmannounce AS LONG
END TYPE

TYPE SERVER_INFO_1520
  sv_maxcopyreadlen AS LONG
END TYPE

TYPE SERVER_INFO_1521
  sv_maxcopywritelen AS LONG
END TYPE

TYPE SERVER_INFO_1522
  sv_minkeepsearch AS LONG
END TYPE

TYPE SERVER_INFO_1523
  sv_maxkeepsearch AS LONG
END TYPE

TYPE SERVER_INFO_1524
  sv_minkeepcomplsearch AS LONG
END TYPE

TYPE SERVER_INFO_1525
  sv_maxkeepcomplsearch AS LONG
END TYPE

TYPE SERVER_INFO_1528
  sv_scavtimeout AS LONG
END TYPE

TYPE SERVER_INFO_1529
  sv_minrcvqueue AS LONG
END TYPE

TYPE SERVER_INFO_1530
  sv_minfreeworkitems AS LONG
END TYPE

TYPE SERVER_INFO_1533
  sv_maxmpxct AS LONG
END TYPE

TYPE SERVER_INFO_1534
  sv_oplockbreakwait AS LONG
END TYPE

TYPE SERVER_INFO_1535
  sv_oplockbreakresponsewait AS LONG
END TYPE

TYPE SERVER_INFO_1536
  sv_enableoplocks AS LONG
END TYPE

TYPE SERVER_INFO_1537
  sv_enableoplockforceclose AS LONG
END TYPE

TYPE SERVER_INFO_1538
  sv_enablefcbopens AS LONG
END TYPE

TYPE SERVER_INFO_1539
  sv_enableraw AS LONG
END TYPE

TYPE SERVER_INFO_1540
  sv_enablesharednetdrives AS LONG
END TYPE

TYPE SERVER_INFO_1541
  sv_minfreeconnections AS LONG
END TYPE

TYPE SERVER_INFO_1542
  sv_maxfreeconnections AS LONG
END TYPE

TYPE SERVER_INFO_1543
  sv_initsesstable AS LONG
END TYPE

TYPE SERVER_INFO_1544
  sv_initconntable AS LONG
END TYPE

TYPE SERVER_INFO_1545
  sv_initfiletable AS LONG
END TYPE

TYPE SERVER_INFO_1546
  sv_initsearchtable AS LONG
END TYPE

TYPE SERVER_INFO_1547
  sv_alertschedule AS LONG
END TYPE

TYPE SERVER_INFO_1548
  sv_errorthreshold AS LONG
END TYPE

TYPE SERVER_INFO_1549
  sv_networkerrorthreshold AS LONG
END TYPE

TYPE SERVER_INFO_1550
  sv_diskspacethreshold AS LONG
END TYPE

TYPE SERVER_INFO_1552
  sv_maxlinkdelay AS LONG
END TYPE

TYPE SERVER_INFO_1553
  sv_minlinkthroughput AS LONG
END TYPE

TYPE SERVER_INFO_1554
  sv_linkinfovalidtime AS LONG
END TYPE

TYPE SERVER_INFO_1555
  sv_scavqosinfoupdatetime AS LONG
END TYPE

TYPE SERVER_INFO_1556
  sv_maxworkitemidletime AS LONG
END TYPE

TYPE SERVER_INFO_1557
  sv_maxrawworkitems AS LONG
END TYPE

TYPE SERVER_INFO_1560
  sv_producttype AS LONG
END TYPE

TYPE SERVER_INFO_1561
  sv_serversize AS LONG
END TYPE

TYPE SERVER_INFO_1562
  sv_connectionlessautodisc AS LONG
END TYPE

TYPE SERVER_INFO_1563
  sv_sharingviolationretries AS LONG
END TYPE

TYPE SERVER_INFO_1564
  sv_sharingviolationdelay AS LONG
END TYPE

TYPE SERVER_INFO_1565
  sv_maxglobalopensearch AS LONG
END TYPE

TYPE SERVER_INFO_1566
  sv_removeduplicatesearches AS LONG
END TYPE

TYPE SERVER_INFO_1567
  sv_lockviolationretries AS LONG
END TYPE

TYPE SERVER_INFO_1568
  sv_lockviolationoffset AS LONG
END TYPE

TYPE SERVER_INFO_1569
  sv_lockviolationdelay AS LONG
END TYPE

TYPE SERVER_INFO_1570
  sv_mdlreadswitchover AS LONG
END TYPE

TYPE SERVER_INFO_1571
  sv_cachedopenlimit AS LONG
END TYPE

TYPE SERVER_INFO_1572
  sv_criticalthreads AS LONG
END TYPE

TYPE SERVER_INFO_1573
  sv_restrictnullsessaccess AS LONG
END TYPE

TYPE SERVER_INFO_1574
  sv_enablewfw311directipx AS LONG
END TYPE

TYPE SERVER_INFO_1575
  sv_otherqueueaffinity AS LONG
END TYPE

TYPE SERVER_INFO_1576
  sv_queuesamplesecs AS LONG
END TYPE

TYPE SERVER_INFO_1577
  sv_balancecount AS LONG
END TYPE

TYPE SERVER_INFO_1578
  sv_preferredaffinity AS LONG
END TYPE

TYPE SERVER_INFO_1579
  sv_maxfreerfcbs AS LONG
END TYPE

TYPE SERVER_INFO_1580
  sv_maxfreemfcbs AS LONG
END TYPE

TYPE SERVER_INFO_1581
  sv_maxfreemlcbs AS LONG
END TYPE

TYPE SERVER_INFO_1582
  sv_maxfreepagedpoolchunks AS LONG
END TYPE

TYPE SERVER_INFO_1583
  sv_minpagedpoolchunksize AS LONG
END TYPE

TYPE SERVER_INFO_1584
  sv_maxpagedpoolchunksize AS LONG
END TYPE

TYPE SERVER_INFO_1585
  sv_sendsfrompreferredprocessor AS LONG
END TYPE

TYPE SERVER_INFO_1586
  sv_maxthreadsperqueue AS LONG
END TYPE

TYPE SERVER_INFO_1587
  sv_cacheddirectorylimit AS LONG
END TYPE

TYPE SERVER_INFO_1588
  sv_maxcopylength AS LONG
END TYPE

TYPE SERVER_INFO_1589
  sv_enablebulktransfer AS LONG
END TYPE

TYPE SERVER_INFO_1590
  sv_enablecompression AS LONG
END TYPE

TYPE SERVER_INFO_1591
  sv_autosharewks AS LONG
END TYPE

TYPE SERVER_INFO_1592
  sv_autosharewks AS LONG
END TYPE

TYPE SERVER_INFO_1593
  sv_enablesecuritysignature AS LONG
END TYPE

TYPE SERVER_INFO_1594
  sv_requiresecuritysignature AS LONG
END TYPE

TYPE SERVER_INFO_1595
  sv_minclientbuffersize AS LONG
END TYPE

TYPE SERVER_INFO_1596
  sv_ConnectionNoSessionsTimeout AS LONG
END TYPE

'
' ** KERNEL32.DLL Declares
'
DECLARE FUNCTION AddAtom LIB "KERNEL32.DLL" ALIAS "AddAtomA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION AllocConsole LIB "KERNEL32.DLL" ALIAS "AllocConsole" () AS LONG
DECLARE FUNCTION BackupRead LIB "KERNEL32.DLL" ALIAS "BackupRead" (BYVAL hFile AS LONG, lpBuffer AS BYTE, BYVAL nNumberOfBytesToRead AS LONG, lpNumberOfBytesRead AS LONG, BYVAL bAbort AS LONG, _
                 BYVAL bProcessSecurity AS LONG, lpContext AS ANY) AS LONG
DECLARE FUNCTION BackupSeek LIB "KERNEL32.DLL" ALIAS "BackupSeek" (BYVAL hFile AS LONG, BYVAL dwLowBytesToSeek AS LONG, BYVAL dwHighBytesToSeek AS LONG, lpdwLowByteSeeked AS LONG, _
                 lpdwHighByteSeeked AS LONG, lpContext AS LONG) AS LONG
DECLARE FUNCTION BackupWrite LIB "KERNEL32.DLL" ALIAS "BackupWrite" (BYVAL hFile AS LONG, lpBuffer AS BYTE, BYVAL nNumberOfBytesToWrite AS LONG, lpNumberOfBytesWritten AS LONG, _
                 BYVAL bAbort AS LONG, BYVAL bProcessSecurity AS LONG, lpContext AS LONG) AS LONG
DECLARE FUNCTION WinBeep LIB "KERNEL32.DLL" ALIAS "Beep" (BYVAL dwFreq AS LONG, BYVAL dwDuration AS LONG) AS LONG
DECLARE FUNCTION BeginUpdateResource LIB "KERNEL32.DLL" ALIAS "BeginUpdateResourceA" (pFileName AS ASCIIZ, BYVAL bDeleteExistingResources AS LONG) AS LONG
DECLARE FUNCTION BuildCommDCB LIB "KERNEL32.DLL" ALIAS "BuildCommDCBA" (lpDef AS ASCIIZ, lpDCB AS DCB) AS LONG
DECLARE FUNCTION BuildCommDCBAndTimeouts LIB "KERNEL32.DLL" ALIAS "BuildCommDCBAndTimeoutsA" (lpDef AS ASCIIZ, lpDCB AS DCB, lpCommTimeouts AS COMMTIMEOUTS) AS LONG
DECLARE FUNCTION CallNamedPipe LIB "KERNEL32.DLL" ALIAS "CallNamedPipeA" (lpNamedPipeName AS ASCIIZ, lpInBuffer AS ANY, BYVAL nInBufferSize AS LONG, lpOutBuffer AS ANY, BYVAL nOutBufferSize AS LONG, lpBytesRead AS LONG, _
                 BYVAL nTimeOut AS LONG) AS LONG
DECLARE FUNCTION ClearCommBreak LIB "KERNEL32.DLL" ALIAS "ClearCommBreak" (BYVAL nCid AS LONG) AS LONG
DECLARE FUNCTION ClearCommError LIB "KERNEL32.DLL" ALIAS "ClearCommError" (BYVAL hFile AS LONG, lpErrors AS LONG, lpStat AS COMSTAT) AS LONG
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS LONG) AS LONG
DECLARE FUNCTION CommConfigDialog LIB "KERNEL32.DLL" ALIAS "CommConfigDialogA" (lpszName AS ASCIIZ, BYVAL hWnd AS LONG, lpCC AS COMMCONFIG) AS LONG
DECLARE FUNCTION CompareFileTime LIB "KERNEL32.DLL" ALIAS "CompareFileTime" (lpFileTime1 AS FILETIME, lpFileTime2 AS FILETIME) AS LONG
DECLARE FUNCTION CompareString LIB "KERNEL32.DLL" ALIAS "CompareStringA" (BYVAL Locale AS LONG, BYVAL dwCmpFlags AS LONG, lpString1 AS ASCIIZ, BYVAL cchCount1 AS LONG, lpString2 AS ASCIIZ, BYVAL cchCount2 AS LONG) AS LONG
DECLARE FUNCTION ConnectNamedPipe LIB "KERNEL32.DLL" ALIAS "ConnectNamedPipe" (BYVAL hNamedPipe AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION ContinueDebugEvent LIB "KERNEL32.DLL" ALIAS "ContinueDebugEvent" (BYVAL dwProcessId AS LONG, BYVAL dwThreadId AS LONG, BYVAL dwContinueStatus AS LONG) AS LONG
DECLARE FUNCTION ConvertDefaultLocale LIB "KERNEL32.DLL" ALIAS "ConvertDefaultLocale" (BYVAL Locale AS LONG) AS LONG
DECLARE FUNCTION CopyFile LIB "KERNEL32.DLL" ALIAS "CopyFileA" (lpExistingFileName AS ASCIIZ, lpNewFileName AS ASCIIZ, BYVAL bFailIfExists AS LONG) AS LONG
DECLARE FUNCTION CreateConsoleScreenBuffer LIB "KERNEL32.DLL" ALIAS "CreateConsoleScreenBuffer" (BYVAL dwDesiredAccess AS LONG, BYVAL dwShareMode AS LONG, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwFlags AS LONG, _
                 BYVAL lpScreenBufferData AS LONG) AS LONG
DECLARE FUNCTION CreateDirectory LIB "KERNEL32.DLL" ALIAS "CreateDirectoryA" (lpPathName AS ASCIIZ, lpSecurityAttributes AS SECURITY_ATTRIBUTES) AS LONG
DECLARE FUNCTION CreateDirectoryEx LIB "KERNEL32.DLL" ALIAS "CreateDirectoryExA" (lpTemplateDirectory AS ASCIIZ, lpNewDirectory AS ASCIIZ, lpSecurityAttributes AS SECURITY_ATTRIBUTES) AS LONG
DECLARE FUNCTION CreateEvent LIB "KERNEL32.DLL" ALIAS "CreateEventA" (lpEventAttributes AS SECURITY_ATTRIBUTES, BYVAL bManualReset AS LONG, BYVAL bInitialState AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateFile LIB "KERNEL32.DLL" ALIAS "CreateFileA" (lpFileName AS ASCIIZ, BYVAL dwDesiredAccess AS DWORD, BYVAL dwShareMode AS DWORD, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwCreationDisposition AS DWORD, _
                 BYVAL dwFlagsAndAttributes AS DWORD, BYVAL hTemplateFile AS LONG) AS LONG
DECLARE FUNCTION CreateFileMapping LIB "KERNEL32.DLL" ALIAS "CreateFileMappingA" (BYVAL hFile AS LONG, lpFileMappigAttributes AS SECURITY_ATTRIBUTES, BYVAL flProtect AS LONG, BYVAL dwMaximumSizeHigh AS LONG, BYVAL dwMaximumSizeLow AS LONG, _
                 lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateIoCompletionPort LIB "KERNEL32.DLL" ALIAS "CreateIoCompletionPort" (BYVAL FileHandle AS LONG, BYVAL ExistingCompletionPort AS LONG, BYVAL CompletionKey AS LONG, BYVAL NumberOfConcurrentThreads AS LONG) AS LONG
DECLARE FUNCTION CreateMailslot LIB "KERNEL32.DLL" ALIAS "CreateMailslotA" (lpName AS ASCIIZ, BYVAL nMaxMessageSize AS LONG, BYVAL lReadTimeout AS LONG, lpSecurityAttributes AS SECURITY_ATTRIBUTES) AS LONG
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateNamedPipe LIB "KERNEL32.DLL" ALIAS "CreateNamedPipeA" (lpName AS ASCIIZ, BYVAL dwOpenMode AS LONG, BYVAL dwPipeMode AS LONG, BYVAL nMaxInstances AS LONG, BYVAL nOutBufferSize AS LONG, BYVAL nInBufferSize AS LONG, _
                 BYVAL nDefaultTimeOut AS LONG, lpSecurityAttributes AS SECURITY_ATTRIBUTES) AS LONG
DECLARE FUNCTION CreatePipe LIB "KERNEL32.DLL" ALIAS "CreatePipe" (phReadPipe AS LONG, phWritePipe AS LONG, lpPipeAttributes AS SECURITY_ATTRIBUTES, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION CreateProcess LIB "KERNEL32.DLL" ALIAS "CreateProcessA" (lpApplicationName AS ASCIIZ, lpCommandLine AS ASCIIZ, lpProcessAttributes AS SECURITY_ATTRIBUTES, lpThreadAttributes AS SECURITY_ATTRIBUTES, _
                 BYVAL bInheritHandles AS LONG, BYVAL dwCreationFlags AS LONG, lpEnvironment AS ANY, lpCurrentDriectory AS ASCIIZ, lpStartupInfo AS STARTUPINFO, lpProcessInformation AS PROCESS_INFORMATION) AS LONG
DECLARE FUNCTION CreateProcessAsUser LIB "KERNEL32.DLL" ALIAS "CreateProcessAsUserA" (BYVAL hToken AS LONG, lpApplicationName AS ASCIIZ, lpCommandLine AS ASCIIZ, lpProcessAttributes AS SECURITY_ATTRIBUTES, _
                 lpThreadAttributes AS SECURITY_ATTRIBUTES, BYVAL bInheritHandles AS LONG, BYVAL dwCreationFlags AS LONG, lpEnvironment AS ASCIIZ, lpCurrentDirectory AS ASCIIZ, lpStartupInfo AS STARTUPINFO, _
                 lpProcessInformation AS PROCESS_INFORMATION) AS LONG
DECLARE FUNCTION CreateRemoteThread LIB "KERNEL32.DLL" ALIAS "CreateRemoteThread" (BYVAL hProcess AS LONG, lpThreadAttributes AS SECURITY_ATTRIBUTES, BYVAL dwStackSize AS LONG, lpStartAddress AS LONG, lpParameter AS ANY, _
                 BYVAL dwCreationFlags AS LONG, lpThreadId AS LONG) AS LONG
DECLARE FUNCTION CreateSemaphore LIB "KERNEL32.DLL" ALIAS "CreateSemaphoreA" (lpSemaphoreAttributes AS SECURITY_ATTRIBUTES, BYVAL lInitialCount AS LONG, BYVAL lMaximumCount AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateTapePartition LIB "KERNEL32.DLL" ALIAS "CreateTapePartition" (BYVAL hDevice AS LONG, BYVAL dwPartitionMethod AS LONG, BYVAL dwCount AS LONG, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION CreateThread LIB "KERNEL32.DLL" ALIAS "CreateThread" (lpThreadAttributes AS SECURITY_ATTRIBUTES, BYVAL dwStackSize AS LONG, BYVAL StartAddress AS LONG, BYVAL lpParameter AS LONG, BYVAL dwCreationFlags AS LONG, lpThreadId AS LONG) AS LONG
DECLARE FUNCTION DebugActiveProcess LIB "KERNEL32.DLL" ALIAS "DebugActiveProcess" (BYVAL dwProcessId AS LONG) AS LONG
DECLARE FUNCTION DefineDosDevice LIB "KERNEL32.DLL" ALIAS "DefineDosDeviceA" (BYVAL dwFlags AS LONG, lpDeviceName AS ASCIIZ, lpTargetPath AS ASCIIZ) AS LONG
DECLARE FUNCTION DeleteAtom LIB "KERNEL32.DLL" ALIAS "DeleteAtom" (BYVAL nAtom AS LONG) AS LONG
DECLARE FUNCTION DeleteFile LIB "KERNEL32.DLL" ALIAS "DeleteFileA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeviceIoControl LIB "KERNEL32.DLL" ALIAS "DeviceIoControl" (BYVAL hDevice AS LONG, BYVAL dwIoControlCode AS LONG, lpInBuffer AS ANY, BYVAL nInBufferSize AS LONG, lpOutBuffer AS ANY, BYVAL nOutBufferSize AS LONG, _
                 lpBytesReturned AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION DisableThreadLibraryCalls LIB "KERNEL32.DLL" ALIAS "DisableThreadLibraryCalls" (BYVAL hLibModule AS LONG) AS LONG
DECLARE FUNCTION DisconnectNamedPipe LIB "KERNEL32.DLL" ALIAS "DisconnectNamedPipe" (BYVAL hNamedPipe AS LONG) AS LONG
DECLARE FUNCTION DosDateTimeToFileTime LIB "KERNEL32.DLL" ALIAS "DosDateTimeToFileTime" (BYVAL wFatDate AS LONG, BYVAL wFatTime AS LONG, lpFileTime AS FILETIME) AS LONG
DECLARE FUNCTION DuplicateHandle LIB "KERNEL32.DLL" ALIAS "DuplicateHandle" (BYVAL hSourceProcessHandle AS LONG, BYVAL hSourceHandle AS LONG, BYVAL hTargetProcessHandle AS LONG, lpTargetHandle AS LONG, BYVAL dwDesiredAccess AS LONG, _
                 BYVAL bInheritHandle AS LONG, BYVAL dwOptions AS LONG) AS LONG
DECLARE FUNCTION EndUpdateResource LIB "KERNEL32.DLL" ALIAS "EndUpdateResourceA" (BYVAL hUpdate AS LONG, BYVAL fDiscard AS LONG) AS LONG
DECLARE FUNCTION EnumCalendarInfo LIB "KERNEL32.DLL" ALIAS "EnumCalendarInfoA" (BYVAL lpCalInfoEnumProc AS LONG, BYVAL Locale AS LONG, BYVAL Calendar AS LONG, BYVAL CalType AS LONG) AS LONG
DECLARE FUNCTION EnumDateFormats LIB "KERNEL32.DLL" ALIAS "EnumDateFormats" (BYVAL lpDateFmtEnumProc AS LONG, BYVAL Locale AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION EnumResourceLanguages LIB "KERNEL32.DLL" ALIAS "EnumResourceLanguagesA" (BYVAL hModule AS LONG, lpType AS ASCIIZ, lpName AS ASCIIZ, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumResourceNames LIB "KERNEL32.DLL" ALIAS "EnumResourceNamesA" (BYVAL hModule AS LONG, lpType AS ASCIIZ, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumResourceTypes LIB "KERNEL32.DLL" ALIAS "EnumResourceTypesA" (BYVAL hModule AS LONG, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumSystemCodePages LIB "KERNEL32.DLL" ALIAS "EnumSystemCodePages" (BYVAL lpCodePageEnumProc AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION EnumSystemLocales LIB "KERNEL32.DLL" ALIAS "EnumSystemLocales" (BYVAL lpLocaleEnumProc AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION EnumTimeFormats LIB "KERNEL32.DLL" ALIAS "EnumTimeFormats" (BYVAL lpTimeFmtEnumProc AS LONG, BYVAL Locale AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION EraseTape LIB "KERNEL32.DLL" ALIAS "EraseTape" (BYVAL hDevice AS LONG, BYVAL dwEraseType AS LONG, BYVAL bimmediate AS LONG) AS LONG
DECLARE FUNCTION EscapeCommFunction LIB "KERNEL32.DLL" ALIAS "EscapeCommFunction" (BYVAL nCid AS LONG, BYVAL nFunc AS LONG) AS LONG
DECLARE FUNCTION ExpandEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "ExpandEnvironmentStringsA" (lpSrc AS ASCIIZ, lpDst AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION FileTimeToDosDateTime LIB "KERNEL32.DLL" ALIAS "FileTimeToDosDateTime" (lpFileTime AS FILETIME, lpFatDate AS WORD, lpFatTime AS WORD) AS LONG
DECLARE FUNCTION FileTimeToLocalFileTime LIB "KERNEL32.DLL" ALIAS "FileTimeToLocalFileTime" (lpFileTime AS FILETIME, lpLocalFileTime AS FILETIME) AS LONG
DECLARE FUNCTION FileTimeToSystemTime LIB "KERNEL32.DLL" ALIAS "FileTimeToSystemTime" (lpFileTime AS FILETIME, lpSystemTime AS SYSTEMTIME) AS LONG
DECLARE FUNCTION FillConsoleOutputAttribute LIB "KERNEL32.DLL" ALIAS "FillConsoleOutputAttribute" (BYVAL hConsoleOutput AS LONG, BYVAL wAttribute AS LONG, BYVAL nLength AS LONG, dwWriteCoord AS COORD, lpNumberOfAttrsWritten AS LONG) AS LONG
DECLARE FUNCTION FillConsoleOutputCharacter LIB "KERNEL32.DLL" ALIAS "FillConsoleOutputCharacterA" (BYVAL hConsoleOutput AS LONG, BYVAL cCharacter AS BYTE, BYVAL nLength AS LONG, dwWriteCoord AS COORD, lpNumberOfCharsWritten AS LONG) AS LONG
DECLARE FUNCTION FindAtom LIB "KERNEL32.DLL" ALIAS "FindAtomA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS LONG) AS LONG
DECLARE FUNCTION FindCloseChangeNotification LIB "KERNEL32.DLL" ALIAS "FindCloseChangeNotification" (BYVAL hChangeHandle AS LONG) AS LONG
DECLARE FUNCTION FindFirstChangeNotification LIB "KERNEL32.DLL" ALIAS "FindFirstChangeNotificationA" (lpPathName AS ASCIIZ, BYVAL bWatchSubtree AS LONG, BYVAL dwNotifyFilter AS LONG) AS LONG
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION FindNextChangeNotification LIB "KERNEL32.DLL" ALIAS "FindNextChangeNotification" (BYVAL hChangeHandle AS LONG) AS LONG
DECLARE FUNCTION FindNextFile LIB "KERNEL32.DLL" ALIAS "FindNextFileA" (BYVAL hFindFile AS LONG, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION FindResource LIB "KERNEL32.DLL" ALIAS "FindResourceA" (BYVAL hInstance AS LONG, lpName AS ASCIIZ, lpType AS ASCIIZ) AS LONG
DECLARE FUNCTION FindResourceEx LIB "KERNEL32.DLL" ALIAS "FindResourceExA" (BYVAL hModule AS LONG, lpType AS ASCIIZ, lpName AS ASCIIZ, BYVAL wLanguage AS LONG) AS LONG
DECLARE FUNCTION FlushConsoleInputBuffer LIB "KERNEL32.DLL" ALIAS "FlushConsoleInputBuffer" (BYVAL hConsoleInput AS LONG) AS LONG
DECLARE FUNCTION FlushFileBuffers LIB "KERNEL32.DLL" ALIAS "FlushFileBuffers" (BYVAL hFile AS LONG) AS LONG
DECLARE FUNCTION FlushInstructionCache LIB "KERNEL32.DLL" ALIAS "FlushInstructionCache" (BYVAL hProcess AS LONG, lpBaseAddress AS ANY, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION FlushViewOfFile LIB "KERNEL32.DLL" ALIAS "FlushViewOfFile" (lpBaseAddress AS ANY, BYVAL dwNumberOfBytesToFlush AS LONG) AS LONG
DECLARE FUNCTION FoldString LIB "KERNEL32.DLL" ALIAS "FoldStringA" (BYVAL dwMapFlags AS LONG, lpSrcStr AS ASCIIZ, BYVAL cchSrc AS LONG, lpDestStr AS ASCIIZ, BYVAL cchDest AS LONG) AS LONG
DECLARE FUNCTION FormatMessage LIB "KERNEL32.DLL" ALIAS "FormatMessageA" (BYVAL dwFlags AS LONG, lpSource AS ANY, BYVAL dwMessageId AS LONG, BYVAL dwLanguageId AS LONG, lpBuffer AS ASCIIZ, BYVAL nSize AS LONG, Arguments AS LONG) AS LONG
DECLARE FUNCTION FreeConsole LIB "KERNEL32.DLL" ALIAS "FreeConsole" () AS LONG
DECLARE FUNCTION FreeEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "FreeEnvironmentStringsA" (lpsz AS ASCIIZ) AS LONG
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS LONG) AS LONG
DECLARE FUNCTION FreeResource LIB "KERNEL32.DLL" ALIAS "FreeResource" (BYVAL hResData AS LONG) AS LONG
DECLARE FUNCTION GenerateConsoleCtrlEvent LIB "KERNEL32.DLL" ALIAS "GenerateConsoleCtrlEvent" (BYVAL dwCtrlEvent AS LONG, BYVAL dwProcessGroupId AS LONG) AS LONG
DECLARE FUNCTION GetACP LIB "KERNEL32.DLL" ALIAS "GetACP" () AS LONG
DECLARE FUNCTION GetAtomName LIB "KERNEL32.DLL" ALIAS "GetAtomNameA" (BYVAL nAtom AS LONG, lpBuffer AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetBinaryType LIB "KERNEL32.DLL" ALIAS "GetBinaryTypeA" (lpApplicationName AS ASCIIZ, lpBinaryType AS LONG) AS LONG
DECLARE FUNCTION GetCPInfo LIB "KERNEL32.DLL" ALIAS "GetCPInfo" (BYVAL CodePage AS LONG, lpCPInfo AS CPINFO) AS LONG
DECLARE FUNCTION GetCommConfig LIB "KERNEL32.DLL" ALIAS "GetCommConfig" (BYVAL hCommDev AS LONG, lpCC AS COMMCONFIG, lpdwSize AS LONG) AS LONG
DECLARE FUNCTION GetCommMask LIB "KERNEL32.DLL" ALIAS "GetCommMask" (BYVAL hFile AS LONG, lpEvtMask AS LONG) AS LONG
DECLARE FUNCTION GetCommModemStatus LIB "KERNEL32.DLL" ALIAS "GetCommModemStatus" (BYVAL hFile AS LONG, lpModemStat AS LONG) AS LONG
DECLARE FUNCTION GetCommProperties LIB "KERNEL32.DLL" ALIAS "GetCommProperties" (BYVAL hFile AS LONG, lpCommProp AS COMMPROP) AS LONG
DECLARE FUNCTION GetCommState LIB "KERNEL32.DLL" ALIAS "GetCommState" (BYVAL nCid AS LONG, lpDCB AS DCB) AS LONG
DECLARE FUNCTION GetCommTimeouts LIB "KERNEL32.DLL" ALIAS "GetCommTimeouts" (BYVAL hFile AS LONG, lpCommTimeouts AS COMMTIMEOUTS) AS LONG
DECLARE FUNCTION GetCommandLine LIB "KERNEL32.DLL" ALIAS "GetCommandLineA" () AS DWORD
DECLARE FUNCTION GetCompressedFileSize LIB "KERNEL32.DLL" ALIAS "GetCompressedFileSizeA" (lpFileName AS ASCIIZ, lpFileSizeHigh AS LONG) AS LONG
DECLARE FUNCTION GetComputerName LIB "KERNEL32.DLL" ALIAS "GetComputerNameA" (lpBuffer AS ASCIIZ, nSize AS LONG) AS LONG
DECLARE FUNCTION GetConsoleCP LIB "KERNEL32.DLL" ALIAS "GetConsoleCP" () AS LONG
DECLARE FUNCTION GetConsoleCursorInfo LIB "KERNEL32.DLL" ALIAS "GetConsoleCursorInfo" (BYVAL hConsoleOutput AS LONG, lpConsoleCursorInfo AS CONSOLE_CURSOR_INFO) AS LONG
DECLARE FUNCTION GetConsoleMode LIB "KERNEL32.DLL" ALIAS "GetConsoleMode" (BYVAL hConsoleHandle AS LONG, lpMode AS LONG) AS LONG
DECLARE FUNCTION GetConsoleOutputCP LIB "KERNEL32.DLL" ALIAS "GetConsoleOutputCP" () AS LONG
DECLARE FUNCTION GetConsoleScreenBufferInfo LIB "KERNEL32.DLL" ALIAS "GetConsoleScreenBufferInfo" (BYVAL hConsoleOutput AS LONG, lpConsoleScreenBufferInfo AS CONSOLE_SCREEN_BUFFER_INFO) AS LONG
DECLARE FUNCTION GetConsoleTitle LIB "KERNEL32.DLL" ALIAS "GetConsoleTitleA" (lpConsoleTitle AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetCurrencyFormat LIB "KERNEL32.DLL" ALIAS "GetCurrencyFormatA" (BYVAL Locale AS LONG, BYVAL dwFlags AS LONG, lpValue AS ASCIIZ, lpFormat AS CURRENCYFMT, lpCurrencyStr AS ASCIIZ, BYVAL cchCurrency AS LONG) AS LONG
DECLARE FUNCTION GetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "GetCurrentDirectoryA" (BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ) AS LONG
DECLARE FUNCTION GetCurrentProcess LIB "KERNEL32.DLL" ALIAS "GetCurrentProcess" () AS LONG
DECLARE FUNCTION GetCurrentProcessId LIB "KERNEL32.DLL" ALIAS "GetCurrentProcessId" () AS LONG
DECLARE FUNCTION GetCurrentThread LIB "KERNEL32.DLL" ALIAS "GetCurrentThread" () AS LONG
DECLARE FUNCTION GetCurrentThreadId LIB "KERNEL32.DLL" ALIAS "GetCurrentThreadId" () AS LONG
DECLARE FUNCTION GetDateFormat LIB "KERNEL32.DLL" ALIAS "GetDateFormatA" (BYVAL Locale AS LONG, BYVAL dwFlags AS LONG, lpDate AS SYSTEMTIME, lpFormat AS ASCIIZ, lpDateStr AS ASCIIZ, BYVAL cchDate AS LONG) AS LONG
DECLARE FUNCTION GetDefaultCommConfig LIB "KERNEL32.DLL" ALIAS "GetDefaultCommConfigA" (lpszName AS ASCIIZ, lpCC AS COMMCONFIG, lpdwSize AS LONG) AS LONG
DECLARE FUNCTION GetDiskFreeSpace LIB "KERNEL32.DLL" ALIAS "GetDiskFreeSpaceA" (lpRootPathName AS ASCIIZ, lpSectorsPerCluster AS DWORD, lpBytesPerSector AS DWORD, lpNumberOfFreeClusters AS DWORD, lpTotalNumberOfClusters AS DWORD) AS LONG
DECLARE FUNCTION GetDiskFreeSpaceEx LIB "KERNEL32.DLL" ALIAS "GetDiskFreeSpaceExA" (lpPathName AS ASCIIZ, lpFreeBytesAvailableToCaller AS QUAD, lpTotalNumberOfBytes AS QUAD, lpTotalNumberOfFreeBytes AS QUAD) AS LONG
DECLARE FUNCTION GetDriveType LIB "KERNEL32.DLL" ALIAS "GetDriveTypeA" (nDrive AS ASCIIZ) AS LONG
DECLARE FUNCTION GetEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "GetEnvironmentStringsA" () AS DWORD
DECLARE FUNCTION GetEnvironmentVariable LIB "KERNEL32.DLL" ALIAS "GetEnvironmentVariableA" (lpName AS ASCIIZ, lpBuffer AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetExitCodeProcess LIB "KERNEL32.DLL" ALIAS "GetExitCodeProcess" (BYVAL hProcess AS LONG, lpExitCode AS LONG) AS LONG
DECLARE FUNCTION GetExitCodeThread LIB "KERNEL32.DLL" ALIAS "GetExitCodeThread" (BYVAL hThread AS LONG, lpExitCode AS LONG) AS LONG
DECLARE FUNCTION GetFileAttributes LIB "KERNEL32.DLL" ALIAS "GetFileAttributesA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetFileInformationByHandle LIB "KERNEL32.DLL" ALIAS "GetFileInformationByHandle" (BYVAL hFile AS LONG, lpFileInformation AS BY_HANDLE_FILE_INFORMATION) AS LONG
DECLARE FUNCTION GetFileSize LIB "KERNEL32.DLL" ALIAS "GetFileSize" (BYVAL hFile AS LONG, lpFileSizeHigh AS LONG) AS LONG
DECLARE FUNCTION GetFileTime LIB "KERNEL32.DLL" ALIAS "GetFileTime" (BYVAL hFile AS LONG, lpCreationTime AS FILETIME, lpLastAccessTime AS FILETIME, lpLastWriteTime AS FILETIME) AS LONG
DECLARE FUNCTION GetFileType LIB "KERNEL32.DLL" ALIAS "GetFileType" (BYVAL hFile AS LONG) AS LONG
DECLARE FUNCTION GetFullPathName LIB "KERNEL32.DLL" ALIAS "GetFullPathNameA" (lpFileName AS ASCIIZ, BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ, BYVAL lpFilePart AS LONG) AS LONG
DECLARE FUNCTION GetHandleInformation LIB "KERNEL32.DLL" ALIAS "GetHandleInformation" (BYVAL hObject AS LONG, lpdwFlags AS LONG) AS LONG
DECLARE FUNCTION GetLargestConsoleWindowSize LIB "KERNEL32.DLL" ALIAS "GetLargestConsoleWindowSize" (BYVAL hConsoleOutput AS LONG) AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetLocaleInfo LIB "KERNEL32.DLL" ALIAS "GetLocaleInfoA" (BYVAL Locale AS LONG, BYVAL LCType AS LONG, lpLCData AS ASCIIZ, BYVAL cchData AS LONG) AS LONG
DECLARE FUNCTION GetLogicalDriveStrings LIB "KERNEL32.DLL" ALIAS "GetLogicalDriveStringsA" (BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ) AS LONG
DECLARE FUNCTION GetLogicalDrives LIB "KERNEL32.DLL" ALIAS "GetLogicalDrives" () AS LONG
DECLARE FUNCTION GetMailslotInfo LIB "KERNEL32.DLL" ALIAS "GetMailslotInfo" (BYVAL hMailslot AS LONG, lpMaxMessageSize AS LONG, lpNextSize AS LONG, lpMessageCount AS LONG, lpReadTimeout AS LONG) AS LONG
DECLARE FUNCTION GetModuleFileName LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameA" (BYVAL hModule AS LONG, lpFileName AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetNamedPipeHandleState LIB "KERNEL32.DLL" ALIAS "GetNamedPipeHandleStateA" (BYVAL hNamedPipe AS LONG, lpState AS LONG, lpCurInstances AS LONG, lpMaxCollectionCount AS LONG, lpCollectDataTimeout AS LONG, _
                 lpUserName AS ASCIIZ, BYVAL nMaxUserNameSize AS LONG) AS LONG
DECLARE FUNCTION GetNamedPipeInfo LIB "KERNEL32.DLL" ALIAS "GetNamedPipeInfo" (BYVAL hNamedPipe AS LONG, lpFlags AS LONG, lpOutBufferSize AS LONG, lpInBufferSize AS LONG, lpMaxInstances AS LONG) AS LONG
DECLARE FUNCTION GetNumberFormat LIB "KERNEL32.DLL" ALIAS "GetNumberFormatA" (BYVAL Locale AS LONG, BYVAL dwFlags AS LONG, lpValue AS ASCIIZ, lpFormat AS NUMBERFMT, lpNumberStr AS ASCIIZ, BYVAL cchNumber AS LONG) AS LONG
DECLARE FUNCTION GetNumberOfConsoleInputEvents LIB "KERNEL32.DLL" ALIAS "GetNumberOfConsoleInputEvents" (BYVAL hConsoleInput AS LONG, lpNumberOfEvents AS LONG) AS LONG
DECLARE FUNCTION GetNumberOfConsoleMouseButtons LIB "KERNEL32.DLL" ALIAS "GetNumberOfConsoleMouseButtons" (lpNumberOfMouseButtons AS LONG) AS LONG
DECLARE FUNCTION GetOEMCP LIB "KERNEL32.DLL" ALIAS "GetOEMCP" () AS LONG
DECLARE FUNCTION GetOverlappedResult LIB "KERNEL32.DLL" ALIAS "GetOverlappedResult" (BYVAL hFile AS LONG, lpOverlapped AS OVERLAPPED, lpNumberOfBytesTransferred AS LONG, BYVAL bWait AS LONG) AS LONG
DECLARE FUNCTION GetPriorityClass LIB "KERNEL32.DLL" ALIAS "GetPriorityClass" (BYVAL hProcess AS LONG) AS LONG
DECLARE FUNCTION GetPrivateProfileInt LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileIntA" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, BYVAL nDefault AS LONG, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetPrivateProfileSection LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileSectionA" (lpAppName AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS LONG, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetPrivateProfileString LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStringA" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS LONG, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS LONG, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetProcessAffinityMask LIB "KERNEL32.DLL" ALIAS "GetProcessAffinityMask" (BYVAL hProcess AS LONG, lpProcessAffinityMask AS LONG, SystemAffinityMask AS LONG) AS LONG
DECLARE FUNCTION GetProcessHeap LIB "KERNEL32.DLL" ALIAS "GetProcessHeap" () AS LONG
DECLARE FUNCTION GetProcessHeaps LIB "KERNEL32.DLL" ALIAS "GetProcessHeaps" (BYVAL NumberOfHeaps AS LONG, ProcessHeaps AS LONG) AS LONG
DECLARE FUNCTION GetProcessShutdownParameters LIB "KERNEL32.DLL" ALIAS "GetProcessShutdownParameters" (lpdwLevel AS LONG, lpdwFlags AS LONG) AS LONG
DECLARE FUNCTION GetProcessTimes LIB "KERNEL32.DLL" ALIAS "GetProcessTimes" (BYVAL hProcess AS LONG, lpCreationTime AS FILETIME, lpExitTime AS FILETIME, lpKernelTime AS FILETIME, lpUserTime AS FILETIME) AS LONG
DECLARE FUNCTION GetProcessWorkingSetSize LIB "KERNEL32.DLL" ALIAS "GetProcessWorkingSetSize" (BYVAL hProcess AS LONG, lpMinimumWorkingSetSize AS LONG, lpMaximumWorkingSetSize AS LONG) AS LONG
DECLARE FUNCTION GetProfileInt LIB "KERNEL32.DLL" ALIAS "GetProfileIntA" (lpAppName AS ASCIIZ, lpKeyName AS ASCIIZ, BYVAL nDefault AS LONG) AS LONG
DECLARE FUNCTION GetProfileSection LIB "KERNEL32.DLL" ALIAS "GetProfileSectionA" (lpAppName AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetProfileString LIB "KERNEL32.DLL" ALIAS "GetProfileStringA" (lpAppName AS ASCIIZ, lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetQueuedCompletionStatus LIB "KERNEL32.DLL" ALIAS "GetQueuedCompletionStatus" (BYVAL CompletionPort AS LONG, lpNumberOfBytesTransferred AS LONG, lpCompletionKey AS LONG, lpOverlapped AS LONG, BYVAL dwMilliseconds AS LONG) AS LONG
DECLARE FUNCTION GetShortPathName LIB "KERNEL32.DLL" ALIAS "GetShortPathNameA" (lpszLongPath AS ASCIIZ, lpszShortPath AS ASCIIZ, BYVAL cchBuffer AS LONG) AS LONG
DECLARE FUNCTION GetStdHandle LIB "KERNEL32.DLL" ALIAS "GetStdHandle" (BYVAL nStdHandle AS LONG) AS LONG
DECLARE FUNCTION GetStringTypeA LIB "KERNEL32.DLL" ALIAS "GetStringTypeA" (BYVAL lcid AS LONG, BYVAL dwInfoType AS LONG, lpSrcStr AS ASCIIZ, BYVAL cchSrc AS LONG, lpCharType AS LONG) AS LONG
DECLARE FUNCTION GetStringTypeEx LIB "KERNEL32.DLL" ALIAS "GetStringTypeExA" (BYVAL Locale AS LONG, BYVAL dwInfoType AS LONG, lpSrcStr AS ASCIIZ, BYVAL cchSrc AS LONG, lpCharType AS LONG) AS LONG
DECLARE FUNCTION GetStringTypeW LIB "KERNEL32.DLL" ALIAS "GetStringTypeW" (BYVAL dwInfoType AS LONG, lpSrcStr AS ASCIIZ, BYVAL cchSrc AS LONG, lpCharType AS LONG) AS LONG
DECLARE FUNCTION GetSystemDefaultLCID LIB "KERNEL32.DLL" ALIAS "GetSystemDefaultLCID" () AS LONG
DECLARE FUNCTION GetSystemDefaultLangID LIB "KERNEL32.DLL" ALIAS "GetSystemDefaultLangID" () AS LONG
DECLARE FUNCTION GetSystemDirectory LIB "KERNEL32.DLL" ALIAS "GetSystemDirectoryA" (lpBuffer AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetSystemPowerStatus LIB "KERNEL32.DLL" ALIAS "GetSystemPowerStatus" (lpSystemPowerStatus AS SYSTEM_POWER_STATUS) AS LONG
DECLARE FUNCTION GetSystemTimeAdjustment LIB "KERNEL32.DLL" ALIAS "GetSystemTimeAdjustment" (lpTimeAdjustment AS LONG, lpTimeIncrement AS LONG, lpTimeAdjustmentDisabled AS LONG) AS LONG
DECLARE FUNCTION GetTapeParameters LIB "KERNEL32.DLL" ALIAS "GetTapeParameters" (BYVAL hDevice AS LONG, BYVAL dwOperation AS LONG, lpdwSize AS LONG, lpTapeInformation AS ANY) AS LONG
DECLARE FUNCTION GetTapePosition LIB "KERNEL32.DLL" ALIAS "GetTapePosition" (BYVAL hDevice AS LONG, BYVAL dwPositionType AS LONG, lpdwPartition AS LONG, lpdwOffsetLow AS LONG, lpdwOffsetHigh AS LONG) AS LONG
DECLARE FUNCTION GetTapeStatus LIB "KERNEL32.DLL" ALIAS "GetTapeStatus" (BYVAL hDevice AS LONG) AS LONG
DECLARE FUNCTION GetTempFileName LIB "KERNEL32.DLL" ALIAS "GetTempFileNameA" (lpszPath AS ASCIIZ, lpPrefixString AS ASCIIZ, BYVAL wUnique AS LONG, lpTempFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetTempPath LIB "KERNEL32.DLL" ALIAS "GetTempPathA" (BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ) AS LONG
DECLARE FUNCTION GetThreadContext LIB "KERNEL32.DLL" ALIAS "GetThreadContext" (BYVAL hThread AS LONG, lpContext AS CONTEXT) AS LONG
DECLARE FUNCTION GetThreadLocale LIB "KERNEL32.DLL" ALIAS "GetThreadLocale" () AS LONG
DECLARE FUNCTION GetThreadPriority LIB "KERNEL32.DLL" ALIAS "GetThreadPriority" (BYVAL hThread AS LONG) AS LONG
DECLARE FUNCTION GetThreadSelectorEntry LIB "KERNEL32.DLL" ALIAS "GetThreadSelectorEntry" (BYVAL hThread AS LONG, BYVAL dwSelector AS LONG, lpSelectorEntry AS LDT_ENTRY) AS LONG
DECLARE FUNCTION GetThreadTimes LIB "KERNEL32.DLL" ALIAS "GetThreadTimes" (BYVAL hThread AS LONG, lpCreationTime AS FILETIME, lpExitTime AS FILETIME, lpKernelTime AS FILETIME, lpUserTime AS FILETIME) AS LONG
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION GetTimeFormat LIB "KERNEL32.DLL" ALIAS "GetTimeFormatA" (BYVAL Locale AS LONG, BYVAL dwFlags AS LONG, lpTime AS SYSTEMTIME, lpFormat AS ASCIIZ, lpTimeStr AS ASCIIZ, BYVAL cchTime AS LONG) AS LONG
DECLARE FUNCTION GetTimeZoneInformation LIB "KERNEL32.DLL" ALIAS "GetTimeZoneInformation" (lpTimeZoneInformation AS TIME_ZONE_INFORMATION) AS LONG
DECLARE FUNCTION GetUserDefaultLCID LIB "KERNEL32.DLL" ALIAS "GetUserDefaultLCID" () AS LONG
DECLARE FUNCTION GetUserDefaultLangID LIB "KERNEL32.DLL" ALIAS "GetUserDefaultLangID" () AS LONG
DECLARE FUNCTION GetVersion LIB "KERNEL32.DLL" ALIAS "GetVersion" () AS LONG
DECLARE FUNCTION GetVersionEx LIB "KERNEL32.DLL" ALIAS "GetVersionExA" (lpVersionInformation AS OSVERSIONINFO) AS LONG
DECLARE FUNCTION GetVolumeInformation LIB "KERNEL32.DLL" ALIAS "GetVolumeInformationA" (lpRootPathName AS ASCIIZ, lpVolumeNameBuffer AS ASCIIZ, BYVAL nVolumeNameSize AS LONG, lpVolumeSerialNumber AS LONG, lpMaximumComponentLength AS LONG, _
                 lpFileSystemFlags AS LONG, lpFileSystemNameBuffer AS ASCIIZ, BYVAL nFileSystemNameSize AS LONG) AS LONG
DECLARE FUNCTION GetWindowsDirectory LIB "KERNEL32.DLL" ALIAS "GetWindowsDirectoryA" (lpBuffer AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GlobalAddAtom LIB "KERNEL32.DLL" ALIAS "GlobalAddAtomA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GlobalAlloc LIB "KERNEL32.DLL" ALIAS "GlobalAlloc" (BYVAL wFlags AS LONG, BYVAL dwBytes AS LONG) AS LONG
DECLARE FUNCTION GlobalCompact LIB "KERNEL32.DLL" ALIAS "GlobalCompact" (BYVAL dwMinFree AS LONG) AS LONG
DECLARE FUNCTION GlobalDeleteAtom LIB "KERNEL32.DLL" ALIAS "GlobalDeleteAtom" (BYVAL nAtom AS LONG) AS LONG
DECLARE FUNCTION GlobalFindAtom LIB "KERNEL32.DLL" ALIAS "GlobalFindAtomA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GlobalFlags LIB "KERNEL32.DLL" ALIAS "GlobalFlags" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalFree LIB "KERNEL32.DLL" ALIAS "GlobalFree" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalGetAtomName LIB "KERNEL32.DLL" ALIAS "GlobalGetAtomNameA" (BYVAL nAtom AS LONG, lpBuffer AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GlobalHandle LIB "KERNEL32.DLL" ALIAS "GlobalHandle" (wMem AS ANY) AS LONG
DECLARE FUNCTION GlobalLock LIB "KERNEL32.DLL" ALIAS "GlobalLock" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalReAlloc LIB "KERNEL32.DLL" ALIAS "GlobalReAlloc" (BYVAL hMem AS LONG, BYVAL dwBytes AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION GlobalSize LIB "KERNEL32.DLL" ALIAS "GlobalSize" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalUnWire LIB "KERNEL32.DLL" ALIAS "GlobalUnWire" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalUnlock LIB "KERNEL32.DLL" ALIAS "GlobalUnlock" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION GlobalWire LIB "KERNEL32.DLL" ALIAS "GlobalWire" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION HeapAlloc LIB "KERNEL32.DLL" ALIAS "HeapAlloc" (BYVAL hHeap AS LONG, BYVAL dwFlags AS LONG, BYVAL dwBytes AS LONG) AS LONG
DECLARE FUNCTION HeapCompact LIB "KERNEL32.DLL" ALIAS "HeapCompact" (BYVAL hHeap AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION HeapCreate LIB "KERNEL32.DLL" ALIAS "HeapCreate" (BYVAL flOptions AS LONG, BYVAL dwInitialSize AS LONG, BYVAL dwMaximumSize AS LONG) AS LONG
DECLARE FUNCTION HeapDestroy LIB "KERNEL32.DLL" ALIAS "HeapDestroy" (BYVAL hHeap AS LONG) AS LONG
DECLARE FUNCTION HeapFree LIB "KERNEL32.DLL" ALIAS "HeapFree" (BYVAL hHeap AS LONG, BYVAL dwFlags AS LONG, lpMem AS ANY) AS LONG
DECLARE FUNCTION HeapLock LIB "KERNEL32.DLL" ALIAS "HeapLock" (BYVAL hHeap AS LONG) AS LONG
DECLARE FUNCTION HeapReAlloc LIB "KERNEL32.DLL" ALIAS "HeapReAlloc" (BYVAL hHeap AS LONG, BYVAL dwFlags AS LONG, lpMem AS ANY, BYVAL dwBytes AS LONG) AS LONG
DECLARE FUNCTION HeapSize LIB "KERNEL32.DLL" ALIAS "HeapSize" (BYVAL hHeap AS LONG, BYVAL dwFlags AS LONG, lpMem AS ANY) AS LONG
DECLARE FUNCTION HeapUnlock LIB "KERNEL32.DLL" ALIAS "HeapUnlock" (BYVAL hHeap AS LONG) AS LONG
DECLARE FUNCTION HeapValidate LIB "KERNEL32.DLL" ALIAS "HeapValidate" (BYVAL hHeap AS LONG, BYVAL dwFlags AS LONG, lpMem AS ANY) AS LONG
DECLARE FUNCTION ImpersonateLoggedOnUser LIB "KERNEL32.DLL" ALIAS "ImpersonateLoggedOnUser" (BYVAL hToken AS LONG) AS LONG
DECLARE FUNCTION InitAtomTable LIB "KERNEL32.DLL" ALIAS "InitAtomTable" (BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION InterlockedDecrement LIB "KERNEL32.DLL" ALIAS "InterlockedDecrement" (lpAddend AS LONG) AS LONG
DECLARE FUNCTION InterlockedExchange LIB "KERNEL32.DLL" ALIAS "InterlockedExchange" (xTarget AS LONG, BYVAL xValue AS LONG) AS LONG
DECLARE FUNCTION InterlockedIncrement LIB "KERNEL32.DLL" ALIAS "InterlockedIncrement" (lpAddend AS LONG) AS LONG
DECLARE FUNCTION IsBadCodePtr LIB "KERNEL32.DLL" ALIAS "IsBadCodePtr" (BYVAL lpfn AS LONG) AS LONG
DECLARE FUNCTION IsBadHugeReadPtr LIB "KERNEL32.DLL" ALIAS "IsBadHugeReadPtr" (lp AS ANY, BYVAL ucb AS LONG) AS LONG
DECLARE FUNCTION IsBadHugeWritePtr LIB "KERNEL32.DLL" ALIAS "IsBadHugeWritePtr" (lp AS ANY, BYVAL ucb AS LONG) AS LONG
DECLARE FUNCTION IsBadReadPtr LIB "KERNEL32.DLL" ALIAS "IsBadReadPtr" (BYVAL lp AS LONG, BYVAL ucb AS LONG) AS LONG
DECLARE FUNCTION IsBadStringPtr LIB "KERNEL32.DLL" ALIAS "IsBadStringPtrA" (lpsz AS ASCIIZ, BYVAL ucchMax AS LONG) AS LONG
DECLARE FUNCTION IsBadWritePtr LIB "KERNEL32.DLL" ALIAS "IsBadWritePtr" (BYVAL lp AS LONG, BYVAL ucb AS LONG) AS LONG
DECLARE FUNCTION IsDBCSLeadByte LIB "KERNEL32.DLL" ALIAS "IsDBCSLeadByte" (BYVAL bTestChar AS BYTE) AS LONG
DECLARE FUNCTION IsDBCSLeadByte LIB "KERNEL32.DLL" ALIAS "IsDBCSLeadByte" (BYVAL TestChar AS BYTE) AS LONG
DECLARE FUNCTION IsValidCodePage LIB "KERNEL32.DLL" ALIAS "IsValidCodePage" (BYVAL CodePage AS LONG) AS LONG
DECLARE FUNCTION IsValidLocale LIB "KERNEL32.DLL" ALIAS "IsValidLocale" (BYVAL Locale AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION LCMapString LIB "KERNEL32.DLL" ALIAS "LCMapStringA" (BYVAL Locale AS LONG, BYVAL dwMapFlags AS LONG, lpSrcStr AS ASCIIZ, BYVAL cchSrc AS LONG, lpDestStr AS ASCIIZ, BYVAL cchDest AS LONG) AS LONG
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadLibraryEx LIB "KERNEL32.DLL" ALIAS "LoadLibraryExA" (lpLibFileName AS ASCIIZ, BYVAL hFile AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION LoadModule LIB "KERNEL32.DLL" ALIAS "LoadModule" (lpModuleName AS ASCIIZ, lpParameterBlock AS ANY) AS LONG
DECLARE FUNCTION LoadResource LIB "KERNEL32.DLL" ALIAS "LoadResource" (BYVAL hInstance AS LONG, BYVAL hResInfo AS LONG) AS LONG
DECLARE FUNCTION LocalAlloc LIB "KERNEL32.DLL" ALIAS "LocalAlloc" (BYVAL wFlags AS LONG, BYVAL wBytes AS LONG) AS LONG
DECLARE FUNCTION LocalCompact LIB "KERNEL32.DLL" ALIAS "LocalCompact" (BYVAL uMinFree AS LONG) AS LONG
DECLARE FUNCTION LocalFileTimeToFileTime LIB "KERNEL32.DLL" ALIAS "LocalFileTimeToFileTime" (lpLocalFileTime AS FILETIME, lpFileTime AS FILETIME) AS LONG
DECLARE FUNCTION LocalFlags LIB "KERNEL32.DLL" ALIAS "LocalFlags" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION LocalFree LIB "KERNEL32.DLL" ALIAS "LocalFree" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION LocalHandle LIB "KERNEL32.DLL" ALIAS "LocalHandle" (wMem AS ANY) AS LONG
DECLARE FUNCTION LocalLock LIB "KERNEL32.DLL" ALIAS "LocalLock" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION LocalReAlloc LIB "KERNEL32.DLL" ALIAS "LocalReAlloc" (BYVAL hMem AS LONG, BYVAL wBytes AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION LocalShrink LIB "KERNEL32.DLL" ALIAS "LocalShrink" (BYVAL hMem AS LONG, BYVAL cbNewSize AS LONG) AS LONG
DECLARE FUNCTION LocalSize LIB "KERNEL32.DLL" ALIAS "LocalSize" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION LocalUnlock LIB "KERNEL32.DLL" ALIAS "LocalUnlock" (BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION LockFile LIB "KERNEL32.DLL" ALIAS "LockFile" (BYVAL hFile AS LONG, BYVAL dwFileOffsetLow AS LONG, BYVAL dwFileOffsetHigh AS LONG, BYVAL nNumberOfBytesToLockLow AS LONG, BYVAL nNumberOfBytesToLockHigh AS LONG) AS LONG
DECLARE FUNCTION LockFileEx LIB "KERNEL32.DLL" ALIAS "LockFileEx" (BYVAL hFile AS LONG, BYVAL dwFlags AS LONG, BYVAL dwReserved AS LONG, BYVAL nNumberOfBytesToLockLow AS LONG, BYVAL nNumberOfBytesToLockHigh AS LONG, _
                 lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION LockResource LIB "KERNEL32.DLL" ALIAS "LockResource" (BYVAL hResData AS LONG) AS LONG
DECLARE FUNCTION LogonUser LIB "KERNEL32.DLL" ALIAS "LogonUserA" (lpszUsername AS ASCIIZ, lpszDomain AS ASCIIZ, lpszPassword AS ASCIIZ, BYVAL dwLogonType AS LONG, BYVAL dwLogonProvider AS LONG, phToken AS LONG) AS LONG
DECLARE FUNCTION MapViewOfFile LIB "KERNEL32.DLL" ALIAS "MapViewOfFile" (BYVAL hFileMappingObject AS LONG, BYVAL dwDesiredAccess AS LONG, BYVAL dwFileOffsetHigh AS LONG, BYVAL dwFileOffsetLow AS LONG, BYVAL dwNumberOfBytesToMap AS LONG) AS LONG
DECLARE FUNCTION MapViewOfFile LIB "KERNEL32.DLL" ALIAS "MapViewOfFile" (BYVAL hFileMappingObject AS LONG, BYVAL dwDesiredAccess AS LONG, BYVAL dwFileOffsetHigh AS LONG, BYVAL dwFileOffsetLow AS LONG, BYVAL dwNumberOfBytesToMap AS LONG) AS LONG
DECLARE FUNCTION MapViewOfFileEx LIB "KERNEL32.DLL" ALIAS "MapViewOfFileEx" (BYVAL hFileMappingObject AS LONG, BYVAL dwDesiredAccess AS LONG, BYVAL dwFileOffsetHigh AS LONG, BYVAL dwFileOffsetLow AS LONG, BYVAL dwNumberOfBytesToMap AS LONG, _
                 lpBaseAddress AS ANY) AS LONG
DECLARE FUNCTION MoveFile LIB "KERNEL32.DLL" ALIAS "MoveFileA" (lpExistingFileName AS ASCIIZ, lpNewFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION MoveFileEx LIB "KERNEL32.DLL" ALIAS "MoveFileExA" (lpExistingFileName AS ASCIIZ, lpNewFileName AS ASCIIZ, BYVAL dwFlags AS LONG) AS LONG

'DECLARE FUNCTION MoveMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" (BYVAL lpDest AS LONG, BYVAL lpSource AS LONG, BYVAL cbMove AS LONG) AS LONG
'Patrice
DECLARE SUB CopyMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" (lpDest AS ANY, lpSource AS ANY, BYVAL cb&)

DECLARE FUNCTION MulDiv LIB "KERNEL32.DLL" ALIAS "MulDiv" (BYVAL nNumber AS LONG, BYVAL nNumerator AS LONG, BYVAL nDenominator AS LONG) AS LONG
DECLARE FUNCTION MultiByteToWideChar LIB "KERNEL32.DLL" ALIAS "MultiByteToWideChar" (BYVAL CodePage AS LONG, BYVAL dwFlags AS LONG, lpMultiByteStr AS ASCIIZ, BYVAL cchMultiByte AS LONG, lpWideCharStr AS ASCIIZ, BYVAL cchWideChar AS LONG) AS LONG
DECLARE FUNCTION ObjectOpenAuditAlarm LIB "KERNEL32.DLL" ALIAS "ObjectOpenAuditAlarmA" (SubsystemName AS ASCIIZ, HandleId AS ANY, ObjectTypeName AS ASCIIZ, ObjectName AS ASCIIZ, pSecurityDescriptor AS SECURITY_DESCRIPTOR, _
                 BYVAL ClientToken AS LONG, BYVAL DesiredAccess AS LONG, BYVAL GrantedAccess AS LONG, Privileges AS PRIVILEGE_SET, BYVAL ObjectCreation AS LONG, BYVAL AccessGranted AS LONG, BYVAL GenerateOnClose AS LONG) AS LONG
DECLARE FUNCTION OpenEvent LIB "KERNEL32.DLL" ALIAS "OpenEventA" (BYVAL dwDesiredAccess AS LONG, BYVAL bInheritHandle AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION OpenFile LIB "KERNEL32.DLL" ALIAS "OpenFile" (lpFileName AS ASCIIZ, lpReOpenBuff AS OFSTRUCT, BYVAL wStyle AS LONG) AS LONG
DECLARE FUNCTION OpenFileMapping LIB "KERNEL32.DLL" ALIAS "OpenFileMappingA" (BYVAL dwDesiredAccess AS LONG, BYVAL bInheritHandle AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION OpenMutex LIB "KERNEL32.DLL" ALIAS "OpenMutexA" (BYVAL dwDesiredAccess AS LONG, BYVAL bInheritHandle AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION OpenProcess LIB "KERNEL32.DLL" ALIAS "OpenProcess" (BYVAL dwDesiredAccess AS DWORD, BYVAL bInheritHandle AS LONG, BYVAL dwProcessId AS DWORD) AS LONG
DECLARE FUNCTION OpenSemaphore LIB "KERNEL32.DLL" ALIAS "OpenSemaphoreA" (BYVAL dwDesiredAccess AS LONG, BYVAL bInheritHandle AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION PeekNamedPipe LIB "KERNEL32.DLL" ALIAS "PeekNamedPipe" (BYVAL hNamedPipe AS LONG, lpBuffer AS ANY, BYVAL nBufferSize AS LONG, lpBytesRead AS LONG, lpTotalBytesAvail AS LONG, lpBytesLeftThisMessage AS LONG) AS LONG
DECLARE FUNCTION PrepareTape LIB "KERNEL32.DLL" ALIAS "PrepareTape" (BYVAL hDevice AS LONG, BYVAL dwOperation AS LONG, BYVAL bimmediate AS LONG) AS LONG
DECLARE FUNCTION PulseEvent LIB "KERNEL32.DLL" ALIAS "PulseEvent" (BYVAL hEvent AS LONG) AS LONG
DECLARE FUNCTION PurgeComm LIB "KERNEL32.DLL" ALIAS "PurgeComm" (BYVAL hFile AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION QueryDosDevice LIB "KERNEL32.DLL" ALIAS "QueryDosDeviceA" (lpDeviceName AS ASCIIZ, lpTargetPath AS ASCIIZ, BYVAL ucchMax AS LONG) AS LONG
DECLARE FUNCTION QueryPerformanceCounter LIB "KERNEL32.DLL" ALIAS "QueryPerformanceCounter" (lpPerformanceCount AS LARGE_INTEGER) AS LONG
DECLARE FUNCTION QueryPerformanceFrequency LIB "KERNEL32.DLL" ALIAS "QueryPerformanceFrequency" (lpFrequency AS LARGE_INTEGER) AS LONG
DECLARE FUNCTION ReadConsole LIB "KERNEL32.DLL" ALIAS "ReadConsoleA" (BYVAL hConsoleInput AS LONG, lpBuffer AS ANY, BYVAL nNumberOfCharsToRead AS LONG, lpNumberOfCharsRead AS LONG, lpReserved AS ANY) AS LONG
DECLARE FUNCTION ReadConsoleInput LIB "KERNEL32.DLL" ALIAS "ReadConsoleInputA" (BYVAL hConsoleInput AS LONG, lpBuffer AS ANY, BYVAL nNumberOfCharsToRead AS LONG, lpNumberOfCharsRead AS LONG) AS LONG
DECLARE FUNCTION ReadConsoleOutput LIB "KERNEL32.DLL" ALIAS "ReadConsoleOutputA" (BYVAL hConsoleOutput AS LONG, lpBuffer AS CHAR_INFO, dwBufferSize AS COORD, dwBufferCoord AS COORD, lpReadRegion AS SMALL_RECT) AS LONG
DECLARE FUNCTION ReadConsoleOutputAttribute LIB "KERNEL32.DLL" ALIAS "ReadConsoleOutputAttribute" (BYVAL hConsoleOutput AS LONG, lpAttribute AS LONG, BYVAL nLength AS LONG, dwReadCoord AS COORD, lpNumberOfAttrsRead AS LONG) AS LONG
DECLARE FUNCTION ReadConsoleOutputCharacter LIB "KERNEL32.DLL" ALIAS "ReadConsoleOutputCharacterA" (BYVAL hConsoleOutput AS LONG, lpCharacter AS ASCIIZ, BYVAL nLength AS LONG, dwReadCoord AS COORD, lpNumberOfCharsRead AS LONG) AS LONG
DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS LONG, lpNumberOfBytesRead AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION ReadFileEx LIB "KERNEL32.DLL" ALIAS "ReadFileEx" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS LONG, lpOverlapped AS OVERLAPPED, BYVAL lpCompletionRoutine AS LONG) AS LONG
DECLARE FUNCTION ReadProcessMemory LIB "KERNEL32.DLL" ALIAS "ReadProcessMemory" (BYVAL hProcess AS LONG, BYVAL lpBaseAddress AS LONG, lpBuffer AS ANY, BYVAL nSize AS LONG, lpNumberOfBytesWritten AS LONG) AS LONG
DECLARE FUNCTION ReleaseMutex LIB "KERNEL32.DLL" ALIAS "ReleaseMutex" (BYVAL hMutex AS LONG) AS LONG
DECLARE FUNCTION ReleaseSemaphore LIB "KERNEL32.DLL" ALIAS "ReleaseSemaphore" (BYVAL hSemaphore AS LONG, BYVAL lReleaseCount AS LONG, lpPreviousCount AS LONG) AS LONG
DECLARE FUNCTION RemoveDirectory LIB "KERNEL32.DLL" ALIAS "RemoveDirectoryA" (lpPathName AS ASCIIZ) AS LONG
DECLARE FUNCTION ResetEvent LIB "KERNEL32.DLL" ALIAS "ResetEvent" (BYVAL hEvent AS LONG) AS LONG
DECLARE FUNCTION ResumeThread LIB "KERNEL32.DLL" ALIAS "ResumeThread" (BYVAL hThread AS LONG) AS LONG
DECLARE FUNCTION ScrollConsoleScreenBuffer LIB "KERNEL32.DLL" ALIAS "ScrollConsoleScreenBufferA" (BYVAL hConsoleOutput AS LONG, lpScrollRectangle AS SMALL_RECT, lpClipRectangle AS SMALL_RECT, dwDestinationOrigin AS COORD, _
                 lpFill AS CHAR_INFO) AS LONG
DECLARE FUNCTION SearchPath LIB "KERNEL32.DLL" ALIAS "SearchPathA" (lpPath AS ASCIIZ, lpFileName AS ASCIIZ, lpExtension AS ASCIIZ, BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ, lpFilePart AS ASCIIZ) AS LONG
DECLARE FUNCTION SetCommBreak LIB "KERNEL32.DLL" ALIAS "SetCommBreak" (BYVAL nCid AS LONG) AS LONG
DECLARE FUNCTION SetCommConfig LIB "KERNEL32.DLL" ALIAS "SetCommConfig" (BYVAL hCommDev AS LONG, lpCC AS COMMCONFIG, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION SetCommMask LIB "KERNEL32.DLL" ALIAS "SetCommMask" (BYVAL hFile AS LONG, BYVAL dwEvtMask AS LONG) AS LONG
DECLARE FUNCTION SetCommState LIB "KERNEL32.DLL" ALIAS "SetCommState" (BYVAL hCommDev AS LONG, lpDCB AS DCB) AS LONG
DECLARE FUNCTION SetCommTimeouts LIB "KERNEL32.DLL" ALIAS "SetCommTimeouts" (BYVAL hFile AS LONG, lpCommTimeouts AS COMMTIMEOUTS) AS LONG
DECLARE FUNCTION SetComputerName LIB "KERNEL32.DLL" ALIAS "SetComputerNameA" (lpComputerName AS ASCIIZ) AS LONG
DECLARE FUNCTION SetConsoleActiveScreenBuffer LIB "KERNEL32.DLL" ALIAS "SetConsoleActiveScreenBuffer" (BYVAL hConsoleOutput AS LONG) AS LONG
DECLARE FUNCTION SetConsoleCP LIB "KERNEL32.DLL" ALIAS "SetConsoleCP" (BYVAL wCodePageID AS LONG) AS LONG
DECLARE FUNCTION SetConsoleCtrlHandler LIB "KERNEL32.DLL" ALIAS "SetConsoleCtrlHandler" (BYVAL HandlerRoutine AS LONG, BYVAL nAdd AS LONG) AS LONG
DECLARE FUNCTION SetConsoleCursorInfo LIB "KERNEL32.DLL" ALIAS "SetConsoleCursorInfo" (BYVAL hConsoleOutput AS LONG, lpConsoleCursorInfo AS CONSOLE_CURSOR_INFO) AS LONG
DECLARE FUNCTION SetConsoleCursorPosition LIB "KERNEL32.DLL" ALIAS "SetConsoleCursorPosition" (BYVAL hConsoleOutput AS LONG, dwCursorPosition AS COORD) AS LONG
DECLARE FUNCTION SetConsoleMode LIB "KERNEL32.DLL" ALIAS "SetConsoleMode" (BYVAL hConsoleHandle AS LONG, BYVAL dwMode AS LONG) AS LONG
DECLARE FUNCTION SetConsoleOutputCP LIB "KERNEL32.DLL" ALIAS "SetConsoleOutputCP" (BYVAL wCodePageID AS LONG) AS LONG
DECLARE FUNCTION SetConsoleScreenBufferSize LIB "KERNEL32.DLL" ALIAS "SetConsoleScreenBufferSize" (BYVAL hConsoleOutput AS LONG, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION SetConsoleTextAttribute LIB "KERNEL32.DLL" ALIAS "SetConsoleTextAttribute" (BYVAL hConsoleOutput AS LONG, BYVAL wAttributes AS LONG) AS LONG
DECLARE FUNCTION SetConsoleTitle LIB "KERNEL32.DLL" ALIAS "SetConsoleTitleA" (lpConsoleTitle AS ASCIIZ) AS LONG
DECLARE FUNCTION SetConsoleWindowInfo LIB "KERNEL32.DLL" ALIAS "SetConsoleWindowInfo" (BYVAL hConsoleOutput AS LONG, BYVAL bAbsolute AS LONG, lpConsoleWindow AS SMALL_RECT) AS LONG
DECLARE FUNCTION SetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "SetCurrentDirectoryA" (lpPathName AS ASCIIZ) AS LONG
DECLARE FUNCTION SetDefaultCommConfig LIB "KERNEL32.DLL" ALIAS "SetDefaultCommConfigA" (lpszName AS ASCIIZ, lpCC AS COMMCONFIG, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION SetEndOfFile LIB "KERNEL32.DLL" ALIAS "SetEndOfFile" (BYVAL hFile AS LONG) AS LONG
DECLARE FUNCTION SetEnvironmentVariable LIB "KERNEL32.DLL" ALIAS "SetEnvironmentVariableA" (lpName AS ASCIIZ, lpValue AS ASCIIZ) AS LONG
DECLARE FUNCTION SetErrorMode LIB "KERNEL32.DLL" ALIAS "SetErrorMode" (BYVAL wMode AS LONG) AS LONG
DECLARE FUNCTION SetEvent LIB "KERNEL32.DLL" ALIAS "SetEvent" (BYVAL hEvent AS LONG) AS LONG
DECLARE FUNCTION SetFileAttributes LIB "KERNEL32.DLL" ALIAS "SetFileAttributesA" (lpFileName AS ASCIIZ, BYVAL dwFileAttributes AS LONG) AS LONG
DECLARE FUNCTION SetFilePointer LIB "KERNEL32.DLL" ALIAS "SetFilePointer" (BYVAL hFile AS LONG, BYVAL lDistanceToMove AS LONG, lpDistanceToMoveHigh AS LONG, BYVAL dwMoveMethod AS LONG) AS LONG
DECLARE FUNCTION SetFileTime LIB "KERNEL32.DLL" ALIAS "SetFileTime" (BYVAL hFile AS LONG, lpCreationTime AS FILETIME, lpLastAccessTime AS FILETIME, lpLastWriteTime AS FILETIME) AS LONG
DECLARE FUNCTION SetHandleCount LIB "KERNEL32.DLL" ALIAS "SetHandleCount" (BYVAL wNumber AS LONG) AS LONG
DECLARE FUNCTION SetHandleInformation LIB "KERNEL32.DLL" ALIAS "SetHandleInformation" (BYVAL hObject AS LONG, BYVAL dwMask AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION SetLocalTime LIB "KERNEL32.DLL" ALIAS "SetLocalTime" (lpSystemTime AS SYSTEMTIME) AS LONG
DECLARE FUNCTION SetLocaleInfo LIB "KERNEL32.DLL" ALIAS "SetLocaleInfoA" (BYVAL Locale AS LONG, BYVAL LCType AS LONG, lpLCData AS ASCIIZ) AS LONG
DECLARE FUNCTION SetMailslotInfo LIB "KERNEL32.DLL" ALIAS "SetMailslotInfo" (BYVAL hMailslot AS LONG, BYVAL lReadTimeout AS LONG) AS LONG
DECLARE FUNCTION SetNamedPipeHandleState LIB "KERNEL32.DLL" ALIAS "SetNamedPipeHandleState" (BYVAL hNamedPipe AS LONG, lpMode AS LONG, lpMaxCollectionCount AS LONG, lpCollectDataTimeout AS LONG) AS LONG
DECLARE FUNCTION SetPriorityClass LIB "KERNEL32.DLL" ALIAS "SetPriorityClass" (BYVAL hProcess AS LONG, BYVAL dwPriorityClass AS LONG) AS LONG
DECLARE FUNCTION SetProcessShutdownParameters LIB "KERNEL32.DLL" ALIAS "SetProcessShutdownParameters" (BYVAL dwLevel AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION SetProcessWorkingSetSize LIB "KERNEL32.DLL" ALIAS "SetProcessWorkingSetSize" (BYVAL hProcess AS LONG, BYVAL dwMinimumWorkingSetSize AS LONG, BYVAL dwMaximumWorkingSetSize AS LONG) AS LONG
DECLARE FUNCTION SetStdHandle LIB "KERNEL32.DLL" ALIAS "SetStdHandle" (BYVAL nStdHandle AS LONG, BYVAL nHandle AS LONG) AS LONG
DECLARE FUNCTION SetSystemPowerState LIB "KERNEL32.DLL" ALIAS "SetSystemPowerState" (BYVAL fSuspend AS LONG, BYVAL fForce AS LONG) AS LONG
DECLARE FUNCTION SetSystemTime LIB "KERNEL32.DLL" ALIAS "SetSystemTime" (lpSystemTime AS SYSTEMTIME) AS LONG
DECLARE FUNCTION SetSystemTimeAdjustment LIB "KERNEL32.DLL" ALIAS "SetSystemTimeAdjustment" (BYVAL dwTimeAdjustment AS LONG, BYVAL bTimeAdjustmentDisabled AS LONG) AS LONG
DECLARE FUNCTION SetTapeParameters LIB "KERNEL32.DLL" ALIAS "SetTapeParameters" (BYVAL hDevice AS LONG, BYVAL dwOperation AS LONG, lpTapeInformation AS ANY) AS LONG
DECLARE FUNCTION SetTapePosition LIB "KERNEL32.DLL" ALIAS "SetTapePosition" (BYVAL hDevice AS LONG, BYVAL dwPositionMethod AS LONG, BYVAL dwPartition AS LONG, BYVAL dwOffsetLow AS LONG, BYVAL dwOffsetHigh AS LONG, BYVAL bimmediate AS LONG) AS LONG
DECLARE FUNCTION SetThreadAffinityMask LIB "KERNEL32.DLL" ALIAS "SetThreadAffinityMask" (BYVAL hThread AS LONG, BYVAL dwThreadAffinityMask AS LONG) AS LONG
DECLARE FUNCTION SetThreadContext LIB "KERNEL32.DLL" ALIAS "SetThreadContext" (BYVAL hThread AS LONG, lpContext AS CONTEXT) AS LONG
DECLARE FUNCTION SetThreadLocale LIB "KERNEL32.DLL" ALIAS "SetThreadLocale" (BYVAL Locale AS LONG) AS LONG
DECLARE FUNCTION SetThreadPriority LIB "KERNEL32.DLL" ALIAS "SetThreadPriority" (BYVAL hThread AS LONG, BYVAL nPriority AS LONG) AS LONG
DECLARE FUNCTION SetTimeZoneInformation LIB "KERNEL32.DLL" ALIAS "SetTimeZoneInformation" (lpTimeZoneInformation AS TIME_ZONE_INFORMATION) AS LONG
DECLARE FUNCTION SetUnhandledExceptionFilter LIB "KERNEL32.DLL" ALIAS "SetUnhandledExceptionFilter" (BYVAL lpTopLevelExceptionFilter AS LONG) AS LONG
DECLARE FUNCTION SetVolumeLabel LIB "KERNEL32.DLL" ALIAS "SetVolumeLabelA" (lpRootPathName AS ASCIIZ, lpVolumeName AS ASCIIZ) AS LONG
DECLARE FUNCTION SetupComm LIB "KERNEL32.DLL" ALIAS "SetupComm" (BYVAL hFile AS LONG, BYVAL dwInQueue AS LONG, BYVAL dwOutQueue AS LONG) AS LONG
DECLARE FUNCTION SizeofResource LIB "KERNEL32.DLL" ALIAS "SizeofResource" (BYVAL hInstance AS LONG, BYVAL hResInfo AS LONG) AS LONG
DECLARE FUNCTION SleepEx LIB "KERNEL32.DLL" ALIAS "SleepEx" (BYVAL dwMilliseconds AS LONG, BYVAL bAlertable AS LONG) AS LONG
DECLARE FUNCTION SuspendThread LIB "KERNEL32.DLL" ALIAS "SuspendThread" (BYVAL hThread AS LONG) AS LONG
DECLARE FUNCTION SystemTimeToFileTime LIB "KERNEL32.DLL" ALIAS "SystemTimeToFileTime" (lpSystemTime AS SYSTEMTIME, lpFileTime AS FILETIME) AS LONG
DECLARE FUNCTION SystemTimeToTzSpecificLocalTime LIB "KERNEL32.DLL" ALIAS "SystemTimeToTzSpecificLocalTime" (lpTimeZoneInformation AS TIME_ZONE_INFORMATION, lpUniversalTime AS SYSTEMTIME, lpLocalTime AS SYSTEMTIME) AS LONG
DECLARE FUNCTION TerminateProcess LIB "KERNEL32.DLL" ALIAS "TerminateProcess" (BYVAL hProcess AS LONG, BYVAL uExitCode AS LONG) AS LONG
DECLARE FUNCTION TerminateThread LIB "KERNEL32.DLL" ALIAS "TerminateThread" (BYVAL hThread AS LONG, BYVAL dwExitCode AS LONG) AS LONG
DECLARE FUNCTION TlsAlloc LIB "KERNEL32.DLL" ALIAS "TlsAlloc" () AS LONG
DECLARE FUNCTION TlsFree LIB "KERNEL32.DLL" ALIAS "TlsFree" (BYVAL dwTlsIndex AS LONG) AS LONG
DECLARE FUNCTION TlsGetValue LIB "KERNEL32.DLL" ALIAS "TlsGetValue" (BYVAL dwTlsIndex AS LONG) AS LONG
DECLARE FUNCTION TlsSetValue LIB "KERNEL32.DLL" ALIAS "TlsSetValue" (BYVAL dwTlsIndex AS LONG, lpTlsValue AS ANY) AS LONG
DECLARE FUNCTION TransactNamedPipe LIB "KERNEL32.DLL" ALIAS "TransactNamedPipe" (BYVAL hNamedPipe AS LONG, lpInBuffer AS ANY, BYVAL nInBufferSize AS LONG, lpOutBuffer AS ANY, BYVAL nOutBufferSize AS LONG, lpBytesRead AS LONG, _
                 lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION TransmitCommChar LIB "KERNEL32.DLL" ALIAS "TransmitCommChar" (BYVAL nCid AS LONG, BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION UnhandledExceptionFilter LIB "KERNEL32.DLL" ALIAS "UnhandledExceptionFilter" (ExceptionInfo AS EXCEPTION_POINTERS) AS LONG
DECLARE FUNCTION UnlockFile LIB "KERNEL32.DLL" ALIAS "UnlockFile" (BYVAL hFile AS LONG, BYVAL dwFileOffsetLow AS LONG, BYVAL dwFileOffsetHigh AS LONG, BYVAL nNumberOfBytesToUnlockLow AS LONG, BYVAL nNumberOfBytesToUnlockHigh AS LONG) AS LONG
DECLARE FUNCTION UnlockFileEx LIB "KERNEL32.DLL" ALIAS "UnlockFileEx" (BYVAL hFile AS LONG, BYVAL dwReserved AS LONG, BYVAL nNumberOfBytesToUnlockLow AS LONG, BYVAL nNumberOfBytesToUnlockHigh AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION UnmapViewOfFile LIB "KERNEL32.DLL" ALIAS "UnmapViewOfFile" (lpBaseAddress AS ANY) AS LONG
DECLARE FUNCTION UpdateResource LIB "KERNEL32.DLL" ALIAS "UpdateResourceA" (BYVAL hUpdate AS LONG, lpType AS ASCIIZ, lpName AS ASCIIZ, BYVAL wLanguage AS LONG, lpData AS ANY, BYVAL cbData AS LONG) AS LONG
DECLARE FUNCTION VerLanguageName LIB "KERNEL32.DLL" ALIAS "VerLanguageNameA" (BYVAL wLang AS LONG, szLang AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION VirtualAlloc LIB "KERNEL32.DLL" ALIAS "VirtualAlloc" (lpAddress AS ANY, BYVAL dwSize AS LONG, BYVAL flAllocationType AS LONG, BYVAL flProtect AS LONG) AS LONG
DECLARE FUNCTION VirtualFree LIB "KERNEL32.DLL" ALIAS "VirtualFree" (lpAddress AS ANY, BYVAL dwSize AS LONG, BYVAL dwFreeType AS LONG) AS LONG
DECLARE FUNCTION VirtualLock LIB "KERNEL32.DLL" ALIAS "VirtualLock" (lpAddress AS ANY, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION VirtualProtect LIB "KERNEL32.DLL" ALIAS "VirtualProtect" (lpAddress AS ANY, BYVAL dwSize AS LONG, BYVAL flNewProtect AS LONG, lpflOldProtect AS LONG) AS LONG
DECLARE FUNCTION VirtualProtectEx LIB "KERNEL32.DLL" ALIAS "VirtualProtectEx" (BYVAL hProcess AS LONG, lpAddress AS ANY, BYVAL dwSize AS LONG, BYVAL flNewProtect AS LONG, lpflOldProtect AS LONG) AS LONG
DECLARE FUNCTION VirtualQuery LIB "KERNEL32.DLL" ALIAS "VirtualQuery" (lpAddress AS ANY, lpBuffer AS MEMORY_BASIC_INFORMATION, BYVAL dwLength AS LONG) AS LONG
DECLARE FUNCTION VirtualQueryEx LIB "KERNEL32.DLL" ALIAS "VirtualQueryEx" (BYVAL hProcess AS LONG, lpAddress AS ANY, lpBuffer AS MEMORY_BASIC_INFORMATION, BYVAL dwLength AS LONG) AS LONG
DECLARE FUNCTION VirtualUnlock LIB "KERNEL32.DLL" ALIAS "VirtualUnlock" (lpAddress AS ANY, BYVAL dwSize AS LONG) AS LONG
DECLARE FUNCTION WaitCommEvent LIB "KERNEL32.DLL" ALIAS "WaitCommEvent" (BYVAL hFile AS LONG, lpEvtMask AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION WaitForDebugEvent LIB "KERNEL32.DLL" ALIAS "WaitForDebugEvent" (lpde AS DEBUG_EVENT, BYVAL dwTimeOut AS LONG) AS LONG
DECLARE FUNCTION WaitForMultipleObjects LIB "KERNEL32.DLL" ALIAS "WaitForMultipleObjects" (BYVAL nCount AS LONG, lpHandles AS LONG, BYVAL bWaitAll AS LONG, BYVAL dwMilliseconds AS LONG) AS LONG
DECLARE FUNCTION WaitForMultipleObjectsEx LIB "KERNEL32.DLL" ALIAS "WaitForMultipleObjectsEx" (BYVAL nCount AS LONG, lpHandles AS LONG, BYVAL bWaitAll AS LONG, BYVAL dwMilliseconds AS LONG, BYVAL bAlertable AS LONG) AS LONG
DECLARE FUNCTION WaitForSingleObject LIB "KERNEL32.DLL" ALIAS "WaitForSingleObject" (BYVAL hHandle AS LONG, BYVAL dwMilliseconds AS LONG) AS LONG
DECLARE FUNCTION WaitForSingleObjectEx LIB "KERNEL32.DLL" ALIAS "WaitForSingleObjectEx" (BYVAL hHandle AS LONG, BYVAL dwMilliseconds AS LONG, BYVAL bAlertable AS LONG) AS LONG
DECLARE FUNCTION WaitNamedPipe LIB "KERNEL32.DLL" ALIAS "WaitNamedPipeA" (lpNamedPipeName AS ASCIIZ, BYVAL nTimeOut AS LONG) AS LONG
DECLARE FUNCTION WideCharToMultiByte LIB "KERNEL32.DLL" ALIAS "WideCharToMultiByte" (BYVAL CodePage AS LONG, BYVAL dwFlags AS LONG, lpWideCharStr AS ASCIIZ, BYVAL cchWideChar AS LONG, lpMultiByteStr AS ASCIIZ, BYVAL cchMultiByte AS LONG, _
                 lpDefaultChar AS ASCIIZ, BYVAL lpUsedDefaultChar AS LONG) AS LONG
DECLARE FUNCTION WinExec LIB "KERNEL32.DLL" ALIAS "WinExec" (lpCmdLine AS ASCIIZ, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION WriteConsole LIB "KERNEL32.DLL" ALIAS "WriteConsoleA" (BYVAL hConsoleOutput AS LONG, lpBuffer AS ASCIIZ, BYVAL nNumberOfCharsToWrite AS LONG, lpNumberOfCharsWritten AS LONG, BYVAL lpReserved AS LONG) AS LONG
DECLARE FUNCTION WriteConsoleInput LIB "KERNEL32.DLL" ALIAS "WriteConsoleInputA" (BYVAL hConsoleInput AS LONG, lpBuffer AS INPUT_RECORD, BYVAL nLength AS LONG, lpNumberOfEventsWritten AS LONG) AS LONG
DECLARE FUNCTION WriteConsoleOutput LIB "KERNEL32.DLL" ALIAS "WriteConsoleOutputA" (BYVAL hConsoleOutput AS LONG, lpBuffer AS CHAR_INFO, dwBufferSize AS COORD, dwBufferCoord AS COORD, lpWriteRegion AS SMALL_RECT) AS LONG
DECLARE FUNCTION WriteConsoleOutputAttribute LIB "KERNEL32.DLL" ALIAS "WriteConsoleOutputAttribute" (BYVAL hConsoleOutput AS LONG, lpAttribute AS LONG, BYVAL nLength AS LONG, dwWriteCoord AS COORD, lpNumberOfAttrsWritten AS LONG) AS LONG
DECLARE FUNCTION WriteConsoleOutputCharacter LIB "KERNEL32.DLL" ALIAS "WriteConsoleOutputCharacterA" (BYVAL hConsoleOutput AS LONG, lpCharacter AS ASCIIZ, BYVAL nLength AS LONG, dwWriteCoord AS COORD, lpNumberOfCharsWritten AS LONG) AS LONG
DECLARE FUNCTION WriteFile LIB "KERNEL32.DLL" ALIAS "WriteFile" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL nNumberOfBytesToWrite AS LONG, lpNumberOfBytesWritten AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION WriteFileEx LIB "KERNEL32.DLL" ALIAS "WriteFileEx" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL nNumberOfBytesToWrite AS LONG, lpOverlapped AS OVERLAPPED, BYVAL lpCompletionRoutine AS LONG) AS LONG
DECLARE FUNCTION WritePrivateProfileSection LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileSectionA" (lpAppName AS ASCIIZ, lpString AS ASCIIZ, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION WritePrivateProfileString LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStringA" (lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpString AS ASCIIZ, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION WriteProcessMemory LIB "KERNEL32.DLL" ALIAS "WriteProcessMemory" (BYVAL hProcess AS LONG, lpBaseAddress AS ANY, lpBuffer AS ANY, BYVAL nSize AS LONG, lpNumberOfBytesWritten AS LONG) AS LONG
DECLARE FUNCTION WriteProfileSection LIB "KERNEL32.DLL" ALIAS "WriteProfileSectionA" (lpAppName AS ASCIIZ, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION WriteProfileString LIB "KERNEL32.DLL" ALIAS "WriteProfileStringA" (lpszSection AS ASCIIZ, lpszKeyName AS ASCIIZ, lpszString AS ASCIIZ) AS LONG
DECLARE FUNCTION WriteTapemark LIB "KERNEL32.DLL" ALIAS "WriteTapemark" (BYVAL hDevice AS LONG, BYVAL dwTapemarkType AS LONG, BYVAL dwTapemarkCount AS LONG, BYVAL bimmediate AS LONG) AS LONG
DECLARE FUNCTION hread LIB "KERNEL32.DLL" ALIAS "_hread" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL lBytes AS LONG) AS LONG
DECLARE FUNCTION hwrite LIB "KERNEL32.DLL" ALIAS "_hwrite" (BYVAL hFile AS LONG, lpBuffer AS ASCIIZ, BYVAL lBytes AS LONG) AS LONG
DECLARE FUNCTION lclose LIB "KERNEL32.DLL" ALIAS "_lclose" (BYVAL hFile AS LONG) AS LONG
DECLARE FUNCTION lcreat LIB "KERNEL32.DLL" ALIAS "_lcreat" (lpPathName AS ASCIIZ, BYVAL iAttribute AS LONG) AS LONG
DECLARE FUNCTION llseek LIB "KERNEL32.DLL" ALIAS "_llseek" (BYVAL hFile AS LONG, BYVAL lOffset AS LONG, BYVAL iOrigin AS LONG) AS LONG
DECLARE FUNCTION lopen LIB "KERNEL32.DLL" ALIAS "_lopen" (lpPathName AS ASCIIZ, BYVAL iReadWrite AS LONG) AS LONG
DECLARE FUNCTION lread LIB "KERNEL32.DLL" ALIAS "_lread" (BYVAL hFile AS LONG, lpBuffer AS ANY, BYVAL wBytes AS LONG) AS LONG
DECLARE FUNCTION lstrcat LIB "KERNEL32.DLL" ALIAS "lstrcatA" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS LONG
DECLARE FUNCTION lstrcmp LIB "KERNEL32.DLL" ALIAS "lstrcmpA" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS LONG
DECLARE FUNCTION lstrcmpi LIB "KERNEL32.DLL" ALIAS "lstrcmpiA" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS LONG
DECLARE FUNCTION lstrcpy LIB "KERNEL32.DLL" ALIAS "lstrcpyA" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ) AS LONG
DECLARE FUNCTION lstrcpyn LIB "KERNEL32.DLL" ALIAS "lstrcpynA" (lpString1 AS ASCIIZ, lpString2 AS ASCIIZ, BYVAL iMaxLength AS LONG) AS LONG
DECLARE FUNCTION lstrlen LIB "KERNEL32.DLL" ALIAS "lstrlenA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION lstrlenw LIB "KERNEL32.DLL" ALIAS "lstrlenW" (lpString AS ANY) AS LONG
DECLARE FUNCTION lwrite LIB "KERNEL32.DLL" ALIAS "_lwrite" (BYVAL hFile AS LONG, lpBuffer AS ASCIIZ, BYVAL wBytes AS LONG) AS LONG
DECLARE SUB DebugBreak LIB "KERNEL32.DLL" ALIAS "DebugBreak" ()
DECLARE SUB DeleteCriticalSection LIB "KERNEL32.DLL" ALIAS "DeleteCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB EnterCriticalSection LIB "KERNEL32.DLL" ALIAS "EnterCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB ExitProcess LIB "KERNEL32.DLL" ALIAS "ExitProcess" (BYVAL uExitCode AS LONG)
DECLARE SUB ExitThread LIB "KERNEL32.DLL" ALIAS "ExitThread" (BYVAL dwExitCode AS LONG)
DECLARE SUB FatalAppExit LIB "KERNEL32.DLL" ALIAS "FatalAppExitA" (BYVAL uAction AS LONG, lpMessageText AS ASCIIZ)
DECLARE SUB FatalExit LIB "KERNEL32.DLL" ALIAS "FatalExit" (BYVAL code AS LONG)
DECLARE SUB FreeLibraryAndExitThread LIB "KERNEL32.DLL" ALIAS "FreeLibraryAndExitThread" (BYVAL hLibModule AS LONG, BYVAL dwExitCode AS LONG)
DECLARE SUB GetLocalTime LIB "KERNEL32.DLL" ALIAS "GetLocalTime" (lpSystemTime AS SYSTEMTIME)
DECLARE SUB GetStartupInfo LIB "KERNEL32.DLL" ALIAS "GetStartupInfoA" (lpStartupInfo AS STARTUPINFO)
DECLARE SUB GetSystemInfo LIB "KERNEL32.DLL" ALIAS "GetSystemInfo" (lpSystemInfo AS SYSTEM_INFO)
DECLARE SUB GetSystemTime LIB "KERNEL32.DLL" ALIAS "GetSystemTime" (lpSystemTime AS SYSTEMTIME)
DECLARE SUB GlobalFix LIB "KERNEL32.DLL" ALIAS "GlobalFix" (BYVAL hMem AS LONG)
DECLARE SUB GlobalMemoryStatus LIB "KERNEL32.DLL" ALIAS "GlobalMemoryStatus" (lpBuffer AS MEMORYSTATUS)
DECLARE SUB GlobalUnfix LIB "KERNEL32.DLL" ALIAS "GlobalUnfix" (BYVAL hMem AS LONG)
DECLARE SUB InitializeCriticalSection LIB "KERNEL32.DLL" ALIAS "InitializeCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB LeaveCriticalSection LIB "KERNEL32.DLL" ALIAS "LeaveCriticalSection" (lpCriticalSection AS CRITICAL_SECTION)
DECLARE SUB OutputDebugString LIB "KERNEL32.DLL" ALIAS "OutputDebugStringA" (lpOutputString AS ASCIIZ)
DECLARE SUB RaiseException LIB "KERNEL32.DLL" ALIAS "RaiseException" (BYVAL dwExceptionCode AS LONG, BYVAL dwExceptionFlags AS LONG, BYVAL nNumberOfArguments AS LONG, lpArguments AS LONG)
Declare Sub SetDebugErrorLevel LIB "USER32.DLL" Alias "SetDebugErrorLevel" (ByVal dwLevel As Long)
DECLARE SUB SetFileApisToANSI LIB "KERNEL32.DLL" ALIAS "SetFileApisToANSI" ()
DECLARE SUB SetFileApisToOEM LIB "KERNEL32.DLL" ALIAS "SetFileApisToOEM" ()
DECLARE SUB SetLastError LIB "KERNEL32.DLL" ALIAS "SetLastError" (BYVAL dwErrCode AS LONG)
Declare Sub SetLastErrorEx LIB "USER32.DLL" Alias "SetLastErrorEx" (ByVal dwErrCode As Long, ByVal dwType As Long)
DECLARE SUB apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS LONG)

'
' ** ADVAPI32.DLL
'
DECLARE FUNCTION AbortSystemShutdown LIB "ADVAPI32.DLL" ALIAS "AbortSystemShutdownA" (lpMachineName AS ASCIIZ) AS LONG
DECLARE FUNCTION AccessCheck LIB "ADVAPI32.DLL" ALIAS "AccessCheck" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL ClientToken AS LONG, BYVAL DesiredAccess AS LONG, GenericMapping AS GENERIC_MAPPING, PrivilegeSet AS PRIVILEGE_SET, _
                 PrivilegeSetLength AS LONG, GrantedAccess AS LONG, BYVAL Status AS LONG) AS LONG
DECLARE FUNCTION AccessCheckAndAuditAlarm LIB "ADVAPI32.DLL" ALIAS "AccessCheckAndAuditAlarmA" (SubsystemName AS ASCIIZ, HandleId AS ANY, ObjectTypeName AS ASCIIZ, ObjectName AS ASCIIZ, SecurityDescriptor AS SECURITY_DESCRIPTOR, _
                 BYVAL DesiredAccess AS LONG, GenericMapping AS GENERIC_MAPPING, BYVAL ObjectCreation AS LONG, GrantedAccess AS LONG, BYVAL AccessStatus AS LONG, BYVAL pfGenerateOnClose AS LONG) AS LONG
DECLARE FUNCTION AddAccessAllowedAce LIB "ADVAPI32.DLL" ALIAS "AddAccessAllowedAce" (pAcl AS ACL, BYVAL dwAceRevision AS LONG, BYVAL AccessMask AS LONG, pSid AS ANY) AS LONG
DECLARE FUNCTION AddAccessDeniedAce LIB "ADVAPI32.DLL" ALIAS "AddAccessDeniedAce" (pAcl AS ACL, BYVAL dwAceRevision AS LONG, BYVAL AccessMask AS LONG, pSid AS ANY) AS LONG
DECLARE FUNCTION AddAce LIB "ADVAPI32.DLL" ALIAS "AddAce" (pAcl AS ACL, BYVAL dwAceRevision AS LONG, BYVAL dwStartingAceIndex AS LONG, pAceList AS ANY, BYVAL nAceListLength AS LONG) AS LONG
DECLARE FUNCTION AddAuditAccessAce LIB "ADVAPI32.DLL" ALIAS "AddAuditAccessAce" (pAcl AS ACL, BYVAL dwAceRevision AS LONG, BYVAL dwAccessMask AS LONG, pSid AS ANY, BYVAL bAuditSuccess AS LONG, BYVAL bAuditFailure AS LONG) AS LONG
DECLARE FUNCTION AdjustTokenGroups LIB "ADVAPI32.DLL" ALIAS "AdjustTokenGroups" (BYVAL TokenHandle AS LONG, BYVAL ResetToDefault AS LONG, NewState AS TOKEN_GROUPS, BYVAL BufferLength AS LONG, PreviousState AS TOKEN_GROUPS, _
                 ReturnLength AS LONG) AS LONG
DECLARE FUNCTION AdjustTokenPrivileges LIB "ADVAPI32.DLL" ALIAS "AdjustTokenPrivileges" (BYVAL TokenHandle AS LONG, BYVAL DisableAllPrivileges AS LONG, NewState AS TOKEN_PRIVILEGES, BYVAL BufferLength AS LONG, PreviousState AS TOKEN_PRIVILEGES, _
                 ReturnLength AS LONG) AS LONG
DECLARE FUNCTION AllocateAndInitializeSid LIB "ADVAPI32.DLL" ALIAS "AllocateAndInitializeSid" (pIdentifierAuthority AS SID_IDENTIFIER_AUTHORITY, BYVAL nSubAuthorityCount AS BYTE, BYVAL nSubAuthority0 AS LONG, BYVAL nSubAuthority1 AS LONG, _
                 BYVAL nSubAuthority2 AS LONG, BYVAL nSubAuthority3 AS LONG, BYVAL nSubAuthority4 AS LONG, BYVAL nSubAuthority5 AS LONG, BYVAL nSubAuthority6 AS LONG, BYVAL nSubAuthority7 AS LONG, lpPSid AS LONG) AS LONG
DECLARE FUNCTION AllocateLocallyUniqueId LIB "ADVAPI32.DLL" ALIAS "AllocateLocallyUniqueId" (xLuid AS LARGE_INTEGER) AS LONG
DECLARE FUNCTION AreAllAccessesGranted LIB "ADVAPI32.DLL" ALIAS "AreAllAccessesGranted" (BYVAL GrantedAccess AS LONG, BYVAL DesiredAccess AS LONG) AS LONG
DECLARE FUNCTION AreAnyAccessesGranted LIB "ADVAPI32.DLL" ALIAS "AreAnyAccessesGranted" (BYVAL GrantedAccess AS LONG, BYVAL DesiredAccess AS LONG) AS LONG
DECLARE FUNCTION BackupEventLog LIB "ADVAPI32.DLL" ALIAS "BackupEventLogA" (BYVAL hEventLog AS LONG, lpBackupFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION ChangeServiceConfig LIB "ADVAPI32.DLL" ALIAS "ChangeServiceConfigA" (BYVAL hService AS LONG, BYVAL dwServiceType AS LONG, BYVAL dwStartType AS LONG, BYVAL dwErrorControl AS LONG, lpBinaryPathName AS ASCIIZ, _
                 lpLoadOrderGroup AS ASCIIZ, lpdwTagId AS LONG, lpDependencies AS ASCIIZ, lpServiceStartName AS ASCIIZ, lpPassword AS ASCIIZ, lpDisplayName AS ASCIIZ) AS LONG
DECLARE FUNCTION ClearEventLog LIB "ADVAPI32.DLL" ALIAS "ClearEventLogA" (BYVAL hEventLog AS LONG, lpBackupFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION CloseEventLog LIB "ADVAPI32.DLL" ALIAS "CloseEventLog" (BYVAL hEventLog AS LONG) AS LONG
DECLARE FUNCTION CloseServiceHandle LIB "ADVAPI32.DLL" ALIAS "CloseServiceHandle" (BYVAL hSCObject AS LONG) AS LONG
DECLARE FUNCTION ControlService LIB "ADVAPI32.DLL" ALIAS "ControlService" (BYVAL hService AS LONG, BYVAL dwControl AS LONG, lpServiceStatus AS SERVICE_STATUS) AS LONG
DECLARE FUNCTION CopySid LIB "ADVAPI32.DLL" ALIAS "CopySid" (BYVAL nDestinationSidLength AS LONG, pDestinationSid AS ANY, pSourceSid AS ANY) AS LONG
DECLARE FUNCTION CreatePrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "CreatePrivateObjectSecurity" (ParentDescriptor AS SECURITY_DESCRIPTOR, CreatorDescriptor AS SECURITY_DESCRIPTOR, NewDescriptor AS SECURITY_DESCRIPTOR, _
                 BYVAL IsDirectoryObject AS LONG, BYVAL Token AS LONG, GenericMapping AS GENERIC_MAPPING) AS LONG
DECLARE FUNCTION CreateService LIB "ADVAPI32.DLL" ALIAS "CreateServiceA" (BYVAL hSCManager AS LONG, lpServiceName AS ASCIIZ, lpDisplayName AS ASCIIZ, BYVAL dwDesiredAccess AS LONG, BYVAL dwServiceType AS LONG, _
                 BYVAL dwStartType AS LONG, BYVAL dwErrorControl AS LONG, lpBinaryPathName AS ASCIIZ, lpLoadOrderGroup AS ASCIIZ, lpdwTagId AS LONG, lpDependencies AS ASCIIZ, lp AS ASCIIZ, lpPassword AS ASCIIZ) AS LONG
DECLARE FUNCTION DeleteAce LIB "ADVAPI32.DLL" ALIAS "DeleteAce" (pAcl AS ACL, BYVAL dwAceIndex AS LONG) AS LONG
DECLARE FUNCTION DeleteService LIB "ADVAPI32.DLL" ALIAS "DeleteService" (BYVAL hService AS LONG) AS LONG
DECLARE FUNCTION DeregisterEventSource LIB "ADVAPI32.DLL" ALIAS "DeregisterEventSource" (BYVAL hEventLog AS LONG) AS LONG
DECLARE FUNCTION DestroyPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "DestroyPrivateObjectSecurity" (ObjectDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION DuplicateToken LIB "ADVAPI32.DLL" ALIAS "DuplicateToken" (BYVAL ExistingTokenHandle AS LONG, ImpersonationLevel AS LONG, DuplicateTokenHandle AS LONG) AS LONG
DECLARE FUNCTION EnumDependentServices LIB "ADVAPI32.DLL" ALIAS "EnumDependentServicesA" (BYVAL hService AS LONG, BYVAL dwServiceState AS LONG, lpServices AS ENUM_SERVICE_STATUS, BYVAL cbBufSize AS LONG, pcbBytesNeeded AS LONG, _
                 lpServicesReturned AS LONG) AS LONG
DECLARE FUNCTION EnumServicesStatus LIB "ADVAPI32.DLL" ALIAS "EnumServicesStatusA" (BYVAL hSCManager AS LONG, BYVAL dwServiceType AS LONG, BYVAL dwServiceState AS LONG, lpServices AS ENUM_SERVICE_STATUS, BYVAL cbBufSize AS LONG, _
                 pcbBytesNeeded AS LONG, lpServicesReturned AS LONG, lpResumeHandle AS LONG) AS LONG
DECLARE FUNCTION EqualPrefixSid LIB "ADVAPI32.DLL" ALIAS "EqualPrefixSid" (pSid1 AS ANY, pSid2 AS ANY) AS LONG
DECLARE FUNCTION EqualSid LIB "ADVAPI32.DLL" ALIAS "EqualSid" (pSid1 AS ANY, pSid2 AS ANY) AS LONG
DECLARE FUNCTION FindFirstFreeAce LIB "ADVAPI32.DLL" ALIAS "FindFirstFreeAce" (pAcl AS ACL, pAce AS LONG) AS LONG
DECLARE FUNCTION GetAce LIB "ADVAPI32.DLL" ALIAS "GetAce" (pAcl AS ACL, BYVAL dwAceIndex AS LONG, pAce AS ANY) AS LONG
DECLARE FUNCTION GetAclInformation LIB "ADVAPI32.DLL" ALIAS "GetAclInformation" (pAcl AS ACL, pAclInformation AS ANY, BYVAL nAclInformationLength AS LONG, BYVAL dwAclInformationClass AS LONG) AS LONG
DECLARE FUNCTION GetFileSecurity LIB "ADVAPI32.DLL" ALIAS "GetFileSecurityA" (lpFileName AS ASCIIZ, BYVAL RequestedInformation AS LONG, pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL nLength AS LONG, lpnLengthNeeded AS LONG) AS LONG
DECLARE FUNCTION GetKernelObjectSecurity LIB "ADVAPI32.DLL" ALIAS "GetKernelObjectSecurity" (BYVAL xHandle AS LONG, BYVAL RequestedInformation AS LONG, pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL nLength AS LONG, _
                 lpnLengthNeeded AS LONG) AS LONG
DECLARE FUNCTION GetLengthSid LIB "ADVAPI32.DLL" ALIAS "GetLengthSid" (pSid AS ANY) AS LONG
DECLARE FUNCTION GetNumberOfEventLogRecords LIB "ADVAPI32.DLL" ALIAS "GetNumberOfEventLogRecords" (BYVAL hEventLog AS LONG, NumberOfRecords AS LONG) AS LONG
DECLARE FUNCTION GetOldestEventLogRecord LIB "ADVAPI32.DLL" ALIAS "GetOldestEventLogRecord" (BYVAL hEventLog AS LONG, OldestRecord AS LONG) AS LONG
DECLARE FUNCTION GetPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "GetPrivateObjectSecurity" (ObjectDescriptor AS SECURITY_DESCRIPTOR, BYVAL SecurityInformation AS LONG, ResultantDescriptor AS SECURITY_DESCRIPTOR, BYVAL DescriptorLength AS LONG, _
                 ReturnLength AS LONG) AS LONG
DECLARE FUNCTION GetSecurityDescriptorControl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorControl" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, pControl AS LONG, lpdwRevision AS LONG) AS LONG
DECLARE FUNCTION GetSecurityDescriptorDacl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorDacl" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, lpbDaclPresent AS LONG, pDacl AS ACL, lpbDaclDefaulted AS LONG) AS LONG
DECLARE FUNCTION GetSecurityDescriptorGroup LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorGroup" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, pGroup AS ANY, BYVAL lpbGroupDefaulted AS LONG) AS LONG
DECLARE FUNCTION GetSecurityDescriptorLength LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorLength" (pSecurityDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION GetSecurityDescriptorOwner LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorOwner" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, pOwner AS ANY, BYVAL lpbOwnerDefaulted AS LONG) AS LONG
DECLARE FUNCTION GetSecurityDescriptorSacl LIB "ADVAPI32.DLL" ALIAS "GetSecurityDescriptorSacl" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL lpbSaclPresent AS LONG, pSacl AS ACL, BYVAL lpbSaclDefaulted AS LONG) AS LONG
DECLARE FUNCTION GetSecurityInfo LIB "ADVAPI32.DLL" ALIAS "GetSecurityInfo" (BYVAL hHandle AS LONG, BYVAL ObjectType AS LONG, BYVAL SecurityInformation AS LONG, pSidOwner AS ANY, pSidGroup _
                 AS ANY, pDacl AS LONG, pSacl AS LONG, pSecurityDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION GetServiceDisplayName LIB "ADVAPI32.DLL" ALIAS "GetServiceDisplayNameA" (BYVAL hSCManager AS LONG, lpServiceName AS ASCIIZ, lpDisplayName AS ASCIIZ, lpcchBuffer AS LONG) AS LONG
DECLARE FUNCTION GetServiceKeyName LIB "ADVAPI32.DLL" ALIAS "GetServiceKeyNameA" (BYVAL hSCManager AS LONG, lpDisplayName AS ASCIIZ, lpServiceName AS ASCIIZ, lpcchBuffer AS LONG) AS LONG
DECLARE FUNCTION GetSidIdentifierAuthority LIB "ADVAPI32.DLL" ALIAS "GetSidIdentifierAuthority" (pSid AS ANY) AS DWORD
DECLARE FUNCTION GetSidLengthRequired LIB "ADVAPI32.DLL" ALIAS "GetSidLengthRequired" (BYVAL nSubAuthorityCount AS BYTE) AS LONG
DECLARE FUNCTION GetSidSubAuthority LIB "ADVAPI32.DLL" ALIAS "GetSidSubAuthority" (pSid AS ANY, BYVAL nSubAuthority AS LONG) AS LONG
DECLARE FUNCTION GetSidSubAuthorityCount LIB "ADVAPI32.DLL" ALIAS "GetSidSubAuthorityCount" (pSid AS ANY) AS BYTE
DECLARE FUNCTION GetTokenInformation LIB "ADVAPI32.DLL" ALIAS "GetTokenInformation" (BYVAL TokenHandle AS LONG, TokenInformationClass AS LONG, TokenInformation AS ANY, BYVAL TokenInformationLength AS LONG, ReturnLength AS LONG) AS LONG
DECLARE FUNCTION GetUserName LIB "ADVAPI32.DLL" ALIAS "GetUserNameA" (lpBuffer AS ASCIIZ, nSize AS LONG) AS LONG
DECLARE FUNCTION ImpersonateNamedPipeClient LIB "ADVAPI32.DLL" ALIAS "ImpersonateNamedPipeClient" (BYVAL hNamedPipe AS LONG) AS LONG
DECLARE FUNCTION ImpersonateSelf LIB "ADVAPI32.DLL" ALIAS "ImpersonateSelf" (ImpersonationLevel AS LONG) AS LONG
DECLARE FUNCTION InitializeAcl LIB "ADVAPI32.DLL" ALIAS "InitializeAcl" (pAcl AS ACL, BYVAL nAclLength AS LONG, BYVAL dwAclRevision AS LONG) AS LONG
DECLARE FUNCTION InitializeSecurityDescriptor LIB "ADVAPI32.DLL" ALIAS "InitializeSecurityDescriptor" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL dwRevision AS LONG) AS LONG
DECLARE FUNCTION InitializeSid LIB "ADVAPI32.DLL" ALIAS "InitializeSid" (Sid AS ANY, pIdentifierAuthority AS SID_IDENTIFIER_AUTHORITY, BYVAL nSubAuthorityCount AS BYTE) AS LONG
DECLARE FUNCTION InitiateSystemShutdown LIB "ADVAPI32.DLL" ALIAS "InitiateSystemShutdownA" (lpMachineName AS ASCIIZ, lpMessage AS ASCIIZ, BYVAL dwTimeout AS LONG, BYVAL bForceAppsClosed AS LONG, BYVAL bRebootAfterShutdown AS LONG) AS LONG
DECLARE FUNCTION IsTextUnicode LIB "ADVAPI32.DLL" ALIAS "IsTextUnicode" (lpBuffer AS ANY, BYVAL cb AS LONG, lpi AS LONG) AS LONG
DECLARE FUNCTION IsValidAcl LIB "ADVAPI32.DLL" ALIAS "IsValidAcl" (pAcl AS ACL) AS LONG
DECLARE FUNCTION IsValidSecurityDescriptor LIB "ADVAPI32.DLL" ALIAS "IsValidSecurityDescriptor" (pSecurityDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION IsValidSid LIB "ADVAPI32.DLL" ALIAS "IsValidSid" (pSid AS ANY) AS LONG
DECLARE FUNCTION LockServiceDatabase LIB "ADVAPI32.DLL" ALIAS "LockServiceDatabase" (BYVAL hSCManager AS LONG) AS LONG
DECLARE FUNCTION LookupAccountName LIB "ADVAPI32.DLL" ALIAS "LookupAccountNameA" (lpSystemName AS ASCIIZ, lpAccountName AS ASCIIZ, Sid AS LONG, cbSid AS LONG, ReferencedDomainName AS ASCIIZ, cbReferencedDomainName AS LONG, peUse AS LONG) AS LONG
DECLARE FUNCTION LookupAccountSid LIB "ADVAPI32.DLL" ALIAS "LookupAccountSidA" (lpSystemName AS ASCIIZ, Sid AS ANY, xName AS ASCIIZ, cbName AS LONG, ReferencedDomainName AS ASCIIZ, cbReferencedDomainName AS LONG, peUse AS LONG) AS LONG
DECLARE FUNCTION LookupPrivilegeDisplayName LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeDisplayNameA" (lpSystemName AS ASCIIZ, lpName AS ASCIIZ, lpDisplayName AS ASCIIZ, cbDisplayName AS LONG, lpLanguageID AS LONG) AS LONG
DECLARE FUNCTION LookupPrivilegeName LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeNameA" (lpSystemName AS ASCIIZ, lpLuid AS LARGE_INTEGER, lpName AS ASCIIZ, cbName AS LONG) AS LONG
DECLARE FUNCTION LookupPrivilegeValue LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeValueA" (lpSystemName AS ASCIIZ, lpName AS ASCIIZ, lpLuid AS LARGE_INTEGER) AS LONG
DECLARE FUNCTION MakeAbsoluteSD LIB "ADVAPI32.DLL" ALIAS "MakeAbsoluteSD" (pSelfRelativeSecurityDescriptor AS SECURITY_DESCRIPTOR, pAbsoluteSecurityDescriptor AS SECURITY_DESCRIPTOR, lpdwAbsoluteSecurityDescriptorSize AS LONG, pDacl AS ACL, _
                 lpdwDaclSize AS LONG, pSacl AS ACL, lpdwSaclSize AS LONG, pOwner AS ANY, lpdwOwnerSize AS LONG, pPrimaryGroup AS ANY, lpdwPrimaryGroupSize AS LONG) AS LONG
DECLARE FUNCTION MakeSelfRelativeSD LIB "ADVAPI32.DLL" ALIAS "MakeSelfRelativeSD" (pAbsoluteSecurityDescriptor AS SECURITY_DESCRIPTOR, pSelfRelativeSecurityDescriptor AS SECURITY_DESCRIPTOR, lpdwBufferLength AS LONG) AS LONG
DECLARE FUNCTION NotifyBootConfigStatus LIB "ADVAPI32.DLL" ALIAS "NotifyBootConfigStatus" (BYVAL BootAcceptable AS LONG) AS LONG
DECLARE FUNCTION NotifyChangeEventLog LIB "ADVAPI32.DLL" ALIAS "NotifyChangeEventLog" (BYVAL hEventLog AS LONG, BYVAL hEvent AS LONG) AS LONG
DECLARE FUNCTION ObjectCloseAuditAlarm LIB "ADVAPI32.DLL" ALIAS "ObjectCloseAuditAlarmA" (SubsystemName AS ASCIIZ, HandleId AS ANY, BYVAL GenerateOnClose AS LONG) AS LONG
DECLARE FUNCTION ObjectPrivilegeAuditAlarm LIB "ADVAPI32.DLL" ALIAS "ObjectPrivilegeAuditAlarmA" (SubsystemName AS ASCIIZ, HandleId AS ANY, BYVAL ClientToken AS LONG, BYVAL DesiredAccess AS LONG, Privileges AS PRIVILEGE_SET, _
                 BYVAL AccessGranted AS LONG) AS LONG
DECLARE FUNCTION OpenBackupEventLog LIB "ADVAPI32.DLL" ALIAS "OpenBackupEventLogA" (lpUNCServerName AS ASCIIZ, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION OpenEventLog LIB "ADVAPI32.DLL" ALIAS "OpenEventLogA" (lpUNCServerName AS ASCIIZ, lpSourceName AS ASCIIZ) AS LONG
DECLARE FUNCTION OpenProcessToken LIB "ADVAPI32.DLL" ALIAS "OpenProcessToken" (BYVAL ProcessHandle AS LONG, BYVAL DesiredAccess AS LONG, TokenHandle AS LONG) AS LONG
DECLARE FUNCTION OpenSCManager LIB "ADVAPI32.DLL" ALIAS "OpenSCManagerA" (lpMachineName AS ASCIIZ, lpDatabaseName AS ASCIIZ, BYVAL dwDesiredAccess AS LONG) AS LONG
DECLARE FUNCTION OpenService LIB "ADVAPI32.DLL" ALIAS "OpenServiceA" (BYVAL hSCManager AS LONG, lpServiceName AS ASCIIZ, BYVAL dwDesiredAccess AS LONG) AS LONG
DECLARE FUNCTION OpenThreadToken LIB "ADVAPI32.DLL" ALIAS "OpenThreadToken" (BYVAL ThreadHandle AS LONG, BYVAL DesiredAccess AS LONG, BYVAL OpenAsSelf AS LONG, TokenHandle AS LONG) AS LONG
DECLARE FUNCTION PrivilegeCheck LIB "ADVAPI32.DLL" ALIAS "PrivilegeCheck" (BYVAL ClientToken AS LONG, RequiredPrivileges AS PRIVILEGE_SET, BYVAL pfResult AS LONG) AS LONG
DECLARE FUNCTION PrivilegedServiceAuditAlarm LIB "ADVAPI32.DLL" ALIAS "PrivilegedServiceAuditAlarmA" (SubsystemName AS ASCIIZ, ServiceName AS ASCIIZ, BYVAL ClientToken AS LONG, Privileges AS PRIVILEGE_SET, BYVAL AccessGranted AS LONG) AS LONG
DECLARE FUNCTION QueryServiceConfig LIB "ADVAPI32.DLL" ALIAS "QueryServiceConfigA" (BYVAL hService AS LONG, lpServiceConfig AS QUERY_SERVICE_CONFIG, BYVAL cbBufSize AS LONG, pcbBytesNeeded AS LONG) AS LONG
DECLARE FUNCTION QueryServiceLockStatus LIB "ADVAPI32.DLL" ALIAS "QueryServiceLockStatusA" (BYVAL hSCManager AS LONG, lpLockStatus AS QUERY_SERVICE_LOCK_STATUS, BYVAL cbBufSize AS LONG, pcbBytesNeeded AS LONG) AS LONG
DECLARE FUNCTION QueryServiceObjectSecurity LIB "ADVAPI32.DLL" ALIAS "QueryServiceObjectSecurity" (BYVAL hService AS LONG, BYVAL dwSecurityInformation AS LONG, lpSecurityDescriptor AS ANY, BYVAL cbBufSize AS LONG, pcbBytesNeeded AS LONG) AS LONG
DECLARE FUNCTION QueryServiceStatus LIB "ADVAPI32.DLL" ALIAS "QueryServiceStatus" (BYVAL hService AS LONG, lpServiceStatus AS SERVICE_STATUS) AS LONG
DECLARE FUNCTION ReadEventLog LIB "ADVAPI32.DLL" ALIAS "ReadEventLogA" (BYVAL hEventLog AS LONG, BYVAL dwReadFlags AS LONG, BYVAL dwRecordOffset AS LONG, lpBuffer AS EVENTLOGRECORD, BYVAL nNumberOfBytesToRead AS LONG, pnBytesRead AS LONG, _
                 pnMinNumberOfBytesNeeded AS LONG) AS LONG
DECLARE FUNCTION RegCloseKey LIB "ADVAPI32.DLL" ALIAS "RegCloseKey" (BYVAL hKey AS LONG) AS LONG
DECLARE FUNCTION RegConnectRegistry LIB "ADVAPI32.DLL" ALIAS "RegConnectRegistryA" (lpMachineName AS ASCIIZ, BYVAL hKey AS LONG, phkResult AS LONG) AS LONG
DECLARE FUNCTION RegCreateKey LIB "ADVAPI32.DLL" ALIAS "RegCreateKeyA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, phkResult AS LONG) AS LONG
DECLARE FUNCTION RegCreateKeyEx LIB "ADVAPI32.DLL" ALIAS "RegCreateKeyExA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, BYVAL Reserved AS LONG, lpClass AS ASCIIZ, BYVAL dwOptions AS LONG, BYVAL samDesired AS LONG, _
                 lpSecurityAttributes AS SECURITY_ATTRIBUTES, phkResult AS LONG, lpdwDisposition AS LONG) AS LONG
DECLARE FUNCTION RegDeleteKey LIB "ADVAPI32.DLL" ALIAS "RegDeleteKeyA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ) AS LONG
DECLARE FUNCTION RegDeleteValue LIB "ADVAPI32.DLL" ALIAS "RegDeleteValueA" (BYVAL hKey AS LONG, lpValueName AS ASCIIZ) AS LONG
DECLARE FUNCTION RegEnumKey LIB "ADVAPI32.DLL" ALIAS "RegEnumKeyA" (BYVAL hKey AS LONG, BYVAL dwIndex AS LONG, lpName AS ASCIIZ, BYVAL cbName AS LONG) AS LONG
DECLARE FUNCTION RegEnumKeyEx LIB "ADVAPI32.DLL" ALIAS "RegEnumKeyExA" (BYVAL hKey AS LONG, BYVAL dwIndex AS LONG, lpName AS ASCIIZ, lpcbName AS LONG, BYVAL lpReserved AS LONG, lpClass AS ASCIIZ, lpcbClass AS LONG, lpftLastWriteTime AS FILETIME) AS LONG
DECLARE FUNCTION RegEnumValue LIB "ADVAPI32.DLL" ALIAS "RegEnumValueA" (BYVAL hKey AS LONG, BYVAL dwIndex AS LONG, lpValueName AS ASCIIZ, lpcbValueName AS LONG, BYVAL lpReserved AS LONG, lpType AS LONG, lpData AS BYTE, lpcbData AS LONG) AS LONG
DECLARE FUNCTION RegFlushKey LIB "ADVAPI32.DLL" ALIAS "RegFlushKey" (BYVAL hKey AS LONG) AS LONG
DECLARE FUNCTION RegGetKeySecurity LIB "ADVAPI32.DLL" ALIAS "RegGetKeySecurity" (BYVAL hKey AS LONG, BYVAL SecurityInformation AS LONG, pSecurityDescriptor AS SECURITY_DESCRIPTOR, lpcbSecurityDescriptor AS LONG) AS LONG
DECLARE FUNCTION RegLoadKey LIB "ADVAPI32.DLL" ALIAS "RegLoadKeyA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, lpFile AS ASCIIZ) AS LONG
DECLARE FUNCTION RegNotifyChangeKeyValue LIB "ADVAPI32.DLL" ALIAS "RegNotifyChangeKeyValue" (BYVAL hKey AS LONG, BYVAL bWatchSubtree AS LONG, BYVAL dwNotifyFilter AS LONG, BYVAL hEvent AS LONG, BYVAL fAsynchronus AS LONG) AS LONG
DECLARE FUNCTION RegOpenKey LIB "ADVAPI32.DLL" ALIAS "RegOpenKeyA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, phkResult AS LONG) AS LONG
DECLARE FUNCTION RegOpenKeyEx LIB "ADVAPI32.DLL" ALIAS "RegOpenKeyExA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, BYVAL ulOptions AS LONG, BYVAL samDesired AS LONG, phkResult AS LONG) AS LONG
DECLARE FUNCTION RegQueryInfoKey LIB "ADVAPI32.DLL" ALIAS "RegQueryInfoKeyA" (BYVAL hKey AS LONG, lpClass AS ASCIIZ, lpcbClass AS LONG, lpReserved AS LONG, lpcSubKeys AS LONG, lpcbMaxSubKeyLen AS LONG, lpcbMaxClassLen AS LONG, lpcValues AS LONG, _
                 lpcbMaxValueNameLen AS LONG, lpcbMaxValueLen AS LONG, lpcbSecurityDescriptor AS LONG, lpftLastWriteTime AS FILETIME) AS LONG
DECLARE FUNCTION RegQueryValue LIB "ADVAPI32.DLL" ALIAS "RegQueryValueA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, lpValue AS ASCIIZ, lpcbValue AS LONG) AS LONG
DECLARE FUNCTION RegQueryValueEx LIB "ADVAPI32.DLL" ALIAS "RegQueryValueExA" (BYVAL hKey AS LONG, lpValueName AS ASCIIZ, BYVAL lpReserved AS LONG, lpType AS LONG, lpData AS ANY, lpcbData AS LONG) AS LONG
DECLARE FUNCTION RegReplaceKey LIB "ADVAPI32.DLL" ALIAS "RegReplaceKeyA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, lpNewFile AS ASCIIZ, lpOldFile AS ASCIIZ) AS LONG
DECLARE FUNCTION RegRestoreKey LIB "ADVAPI32.DLL" ALIAS "RegRestoreKeyA" (BYVAL hKey AS LONG, lpFile AS ASCIIZ, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION RegSaveKey LIB "ADVAPI32.DLL" ALIAS "RegSaveKeyA" (BYVAL hKey AS LONG, lpFile AS ASCIIZ, lpSecurityAttributes AS SECURITY_ATTRIBUTES) AS LONG
DECLARE FUNCTION RegSetKeySecurity LIB "ADVAPI32.DLL" ALIAS "RegSetKeySecurity" (BYVAL hKey AS LONG, BYVAL SecurityInformation AS LONG, pSecurityDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION RegSetValue LIB "ADVAPI32.DLL" ALIAS "RegSetValueA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ, BYVAL dwType AS LONG, lpData AS ASCIIZ, BYVAL cbData AS LONG) AS LONG
DECLARE FUNCTION RegSetValueEx LIB "ADVAPI32.DLL" ALIAS "RegSetValueExA" (BYVAL hKey AS LONG, lpValueName AS ASCIIZ, BYVAL Reserved AS LONG, BYVAL dwType AS LONG, lpData AS ANY, BYVAL cbData AS LONG) AS LONG
DECLARE FUNCTION RegUnLoadKey LIB "ADVAPI32.DLL" ALIAS "RegUnLoadKeyA" (BYVAL hKey AS LONG, lpSubKey AS ASCIIZ) AS LONG
DECLARE FUNCTION RegisterEventSource LIB "ADVAPI32.DLL" ALIAS "RegisterEventSourceA" (lpUNCServerName AS ASCIIZ, lpSourceName AS ASCIIZ) AS LONG
DECLARE FUNCTION RegisterServiceCtrlHandler LIB "ADVAPI32.DLL" ALIAS "RegisterServiceCtrlHandlerA" (lpServiceName AS ASCIIZ, BYVAL lpHandlerProc AS LONG) AS LONG
DECLARE FUNCTION ReportEvent LIB "ADVAPI32.DLL" ALIAS "ReportEventA" (BYVAL hEventLog AS LONG, BYVAL wType AS LONG, BYVAL wCategory AS LONG, BYVAL dwEventID AS LONG, lpUserSid AS ANY, BYVAL wNumStrings AS LONG, BYVAL dwDataSize AS LONG, _
                 lpStrings AS LONG, lpRawData AS ANY) AS LONG
DECLARE FUNCTION RevertToSelf LIB "ADVAPI32.DLL" ALIAS "RevertToSelf" () AS LONG
DECLARE FUNCTION SetAclInformation LIB "ADVAPI32.DLL" ALIAS "SetAclInformation" (pAcl AS ACL, pAclInformation AS ANY, BYVAL nAclInformationLength AS LONG, BYVAL dwAclInformationClass AS LONG) AS LONG
DECLARE FUNCTION SetFileSecurity LIB "ADVAPI32.DLL" ALIAS "SetFileSecurityA" (lpFileName AS ASCIIZ, BYVAL SecurityInformation AS LONG, pSecurityDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION SetKernelObjectSecurity LIB "ADVAPI32.DLL" ALIAS "SetKernelObjectSecurity" (BYVAL xHandle AS LONG, BYVAL SecurityInformation AS LONG, SecurityDescriptor AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION SetPrivateObjectSecurity LIB "ADVAPI32.DLL" ALIAS "SetPrivateObjectSecurity" (BYVAL SecurityInformation AS LONG, ModificationDescriptor AS SECURITY_DESCRIPTOR, ObjectsSecurityDescriptor AS SECURITY_DESCRIPTOR, _
                 GenericMapping AS GENERIC_MAPPING, BYVAL Token AS LONG) AS LONG
DECLARE FUNCTION SetSecurityDescriptorDacl LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorDacl" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL bDaclPresent AS LONG, pDacl AS ACL, BYVAL bDaclDefaulted AS LONG) AS LONG
DECLARE FUNCTION SetSecurityDescriptorGroup LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorGroup" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, pGroup AS ANY, BYVAL bGroupDefaulted AS LONG) AS LONG
DECLARE FUNCTION SetSecurityDescriptorOwner LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorOwner" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, pOwner AS ANY, BYVAL bOwnerDefaulted AS LONG) AS LONG
DECLARE FUNCTION SetSecurityDescriptorSacl LIB "ADVAPI32.DLL" ALIAS "SetSecurityDescriptorSacl" (pSecurityDescriptor AS SECURITY_DESCRIPTOR, BYVAL bSaclPresent AS LONG, pSacl AS ACL, BYVAL bSaclDefaulted AS LONG) AS LONG
DECLARE FUNCTION SetServiceBits LIB "ADVAPI32.DLL" ALIAS "SetServiceBits" (BYVAL hServiceStatus AS LONG, BYVAL dwServiceBits AS LONG, BYVAL bSetBitsOn AS LONG, BYVAL bUpdateImmediately AS LONG) AS LONG
DECLARE FUNCTION SetServiceObjectSecurity LIB "ADVAPI32.DLL" ALIAS "SetServiceObjectSecurity" (BYVAL hService AS LONG, BYVAL dwSecurityInformation AS LONG, lpSecurityDescriptor AS ANY) AS LONG
DECLARE FUNCTION SetServiceStatus LIB "ADVAPI32.DLL" ALIAS "SetServiceStatus" (BYVAL hServiceStatus AS LONG, lpServiceStatus AS SERVICE_STATUS) AS LONG
DECLARE FUNCTION SetThreadToken LIB "ADVAPI32.DLL" ALIAS "SetThreadToken" (hThread AS LONG, BYVAL Token AS LONG) AS LONG
DECLARE FUNCTION SetTokenInformation LIB "ADVAPI32.DLL" ALIAS "SetTokenInformation" (BYVAL TokenHandle AS LONG, TokenInformationClass AS LONG, TokenInformation AS ANY, BYVAL TokenInformationLength AS LONG) AS LONG
DECLARE FUNCTION StartService LIB "ADVAPI32.DLL" ALIAS "StartServiceA" (BYVAL hService AS LONG, BYVAL dwNumServiceArgs AS LONG, BYVAL lpServiceArgVectors AS LONG) AS LONG
DECLARE FUNCTION StartServiceCtrlDispatcher LIB "ADVAPI32.DLL" ALIAS "StartServiceCtrlDispatcherA" (lpServiceStartTable AS SERVICE_TABLE_ENTRY) AS LONG
DECLARE FUNCTION UnlockServiceDatabase LIB "ADVAPI32.DLL" ALIAS "UnlockServiceDatabase" (ScLock AS ANY) AS LONG
DECLARE SUB FreeSid LIB "ADVAPI32.DLL" ALIAS "FreeSid" (pSid AS ANY)
DECLARE SUB MapGenericMask LIB "ADVAPI32.DLL" ALIAS "MapGenericMask" (AccessMask AS LONG, GenericMapping AS GENERIC_MAPPING)

'
' ** GDI32.DLL Declares
'
DECLARE FUNCTION AbortDoc LIB "GDI32.DLL" ALIAS "AbortDoc" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION AbortPath LIB "GDI32.DLL" ALIAS "AbortPath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION AddFontResource LIB "GDI32.DLL" ALIAS "AddFontResourceA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION AngleArc LIB "GDI32.DLL" ALIAS "AngleArc" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL dwRadius AS LONG, BYVAL eStartAngle AS Double, BYVAL eSweepAngle AS Double) AS LONG
DECLARE FUNCTION AnimatePalette LIB "GDI32.DLL" ALIAS "AnimatePaletteA" (BYVAL hPalette AS LONG, BYVAL wStartIndex AS LONG, BYVAL wNumEntries AS LONG, lpPaletteColors AS PALETTEENTRY) AS LONG
DECLARE FUNCTION Arc LIB "GDI32.DLL" ALIAS "Arc" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG, BYVAL X3 AS LONG, BYVAL Y3 AS LONG, BYVAL X4 AS LONG, BYVAL Y4 AS LONG) AS LONG
DECLARE FUNCTION ArcTo LIB "GDI32.DLL" ALIAS "ArcTo" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG, BYVAL X3 AS LONG, BYVAL Y3 AS LONG, BYVAL X4 AS LONG, BYVAL Y4 AS LONG) AS LONG
DECLARE FUNCTION BeginPath LIB "GDI32.DLL" ALIAS "BeginPath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS LONG, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, BYVAL dwRop AS LONG) AS LONG
DECLARE FUNCTION CancelDC LIB "GDI32.DLL" ALIAS "CancelDC" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION CheckColorsInGamut LIB "GDI32.DLL" ALIAS "CheckColorsInGamut" (BYVAL hdc AS LONG, lpv AS ANY, lpv2 AS ANY, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION ChoosePixelFormat LIB "GDI32.DLL" ALIAS "ChoosePixelFormat" (BYVAL hDC AS LONG, pPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG
DECLARE FUNCTION Chord LIB "GDI32.DLL" ALIAS "Chord" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG, BYVAL X3 AS LONG, BYVAL Y3 AS LONG, BYVAL X4 AS LONG, BYVAL Y4 AS LONG) AS LONG
DECLARE FUNCTION CloseEnhMetaFile LIB "GDI32.DLL" ALIAS "CloseEnhMetaFile" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION CloseFigure LIB "GDI32.DLL" ALIAS "CloseFigure" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION CloseMetaFile LIB "GDI32.DLL" ALIAS "CloseMetaFile" (BYVAL hMF AS LONG) AS LONG
DECLARE FUNCTION ColorMatchToTarget LIB "GDI32.DLL" ALIAS "ColorMatchToTarget" (BYVAL hdc AS LONG, BYVAL hdc2 AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION CombineRgn LIB "GDI32.DLL" ALIAS "CombineRgn" (BYVAL hDestRgn AS LONG, BYVAL hSrcRgn1 AS LONG, BYVAL hSrcRgn2 AS LONG, BYVAL nCombineMode AS LONG) AS LONG
DECLARE FUNCTION CombineTransform LIB "GDI32.DLL" ALIAS "CombineTransform" (lpxformResult AS xform, lpxform1 AS xform, lpxform2 AS xform) AS LONG
DECLARE FUNCTION CopyEnhMetaFile LIB "GDI32.DLL" ALIAS "CopyEnhMetaFileA" (BYVAL hemfSrc AS LONG, lpszFile AS ASCIIZ) AS LONG
DECLARE FUNCTION CopyMetaFile LIB "GDI32.DLL" ALIAS "CopyMetaFileA" (BYVAL hMF AS LONG, lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateBitmap LIB "GDI32.DLL" ALIAS "CreateBitmap" (BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL nPlanes AS LONG, BYVAL nBitCount AS LONG, lpBits AS ANY) AS LONG
DECLARE FUNCTION CreateBitmapIndirect LIB "GDI32.DLL" ALIAS "CreateBitmapIndirect" (lpBitmap AS BITMAP) AS LONG
DECLARE FUNCTION CreateBrushIndirect LIB "GDI32.DLL" ALIAS "CreateBrushIndirect" (lpLogBrush AS LOGBRUSH) AS LONG
DECLARE FUNCTION CreateColorSpace LIB "GDI32.DLL" ALIAS "CreateColorSpaceA" (lplogcolorspace AS LOGCOLORSPACE) AS LONG
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" (BYVAL hdc AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS LONG
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION CreateDC LIB "GDI32.DLL" ALIAS "CreateDCA" (lpDriverName AS ASCIIZ, lpDeviceName AS ASCIIZ, lpOutput AS ASCIIZ, lpInitData AS DEVMODE) AS LONG
DECLARE FUNCTION CreateDIBPatternBrush LIB "GDI32.DLL" ALIAS "CreateDIBPatternBrush" (BYVAL hPackedDIB AS LONG, BYVAL wUsage AS LONG) AS LONG
DECLARE FUNCTION CreateDIBPatternBrushPt LIB "GDI32.DLL" ALIAS "CreateDIBPatternBrushPt" (lpPackedDIB AS ANY, BYVAL iUsage AS LONG) AS LONG
DECLARE FUNCTION CreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" (BYVAL hDC AS LONG, pBitmapInfo AS BITMAPINFO, BYVAL un AS LONG, BYVAL lplpVoid AS LONG, BYVAL xHandle AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION CreateDIBitmap LIB "GDI32.DLL" ALIAS "CreateDIBitmap" (BYVAL hdc AS LONG, lpInfoHeader AS BITMAPINFOHEADER, BYVAL dwUsage AS LONG, lpInitBits AS ANY, lpInitInfo AS BITMAPINFO, BYVAL wUsage AS LONG) AS LONG
DECLARE FUNCTION CreateDiscardableBitmap LIB "GDI32.DLL" ALIAS "CreateDiscardableBitmap" (BYVAL hdc AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS LONG
DECLARE FUNCTION CreateEllipticRgn LIB "GDI32.DLL" ALIAS "CreateEllipticRgn" (BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION CreateEllipticRgnIndirect LIB "GDI32.DLL" ALIAS "CreateEllipticRgnIndirect" (lpRect AS Rect) AS LONG
DECLARE FUNCTION CreateEnhMetaFile LIB "GDI32.DLL" ALIAS "CreateEnhMetaFileA" (BYVAL hdcRef AS LONG, lpFileName AS ASCIIZ, lpRect AS RECT, lpDescription AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateFont LIB "GDI32.DLL" ALIAS "CreateFontA" (BYVAL H AS LONG, BYVAL W AS LONG, BYVAL E AS LONG, BYVAL O AS LONG, BYVAL W AS LONG, BYVAL I AS LONG, BYVAL u AS LONG, BYVAL S AS LONG, BYVAL C AS LONG, BYVAL OP AS LONG, _
                 BYVAL CP AS LONG, BYVAL Q AS LONG, BYVAL PAF AS LONG, F AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateFontIndirect LIB "GDI32.DLL" ALIAS "CreateFontIndirectA" (lpLogFont AS LOGFONT) AS LONG
DECLARE FUNCTION CreateHalftonePalette LIB "GDI32.DLL" ALIAS "CreateHalftonePalette" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION CreateHatchBrush LIB "GDI32.DLL" ALIAS "CreateHatchBrush" (BYVAL nIndex AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION CreateIC LIB "GDI32.DLL" ALIAS "CreateICA" (lpDriverName AS ASCIIZ, lpDeviceName AS ASCIIZ, lpOutput AS ASCIIZ, lpInitData AS DEVMODE) AS LONG
DECLARE FUNCTION CreateMetaFile LIB "GDI32.DLL" ALIAS "CreateMetaFileA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION CreatePalette LIB "GDI32.DLL" ALIAS "CreatePalette" (lpLogPalette AS LOGPALETTE) AS LONG
DECLARE FUNCTION CreatePatternBrush LIB "GDI32.DLL" ALIAS "CreatePatternBrush" (BYVAL hBitmap AS LONG) AS LONG
DECLARE FUNCTION CreatePen LIB "GDI32.DLL" ALIAS "CreatePen" (BYVAL nPenStyle AS LONG, BYVAL nWidth AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION CreatePenIndirect LIB "GDI32.DLL" ALIAS "CreatePenIndirect" (lpLogPen AS LOGPEN) AS LONG
DECLARE FUNCTION CreatePolyPolygonRgn LIB "GDI32.DLL" ALIAS "CreatePolyPolygonRgn" (lpPoint AS POINTAPI, lpPolyCounts AS LONG, BYVAL nCount AS LONG, BYVAL nPolyFillMode AS LONG) AS LONG
DECLARE FUNCTION CreatePolygonRgn LIB "GDI32.DLL" ALIAS "CreatePolygonRgn" (lpPoint AS POINTAPI, BYVAL nCount AS LONG, BYVAL nPolyFillMode AS LONG) AS LONG
DECLARE FUNCTION CreateRectRgn LIB "GDI32.DLL" ALIAS "CreateRectRgn" (BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION CreateRectRgnIndirect LIB "GDI32.DLL" ALIAS "CreateRectRgnIndirect" (lpRect AS RECT) AS LONG
DECLARE FUNCTION CreateRoundRectRgn LIB "GDI32.DLL" ALIAS "CreateRoundRectRgn" (BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG, BYVAL X3 AS LONG, BYVAL Y3 AS LONG) AS LONG
DECLARE FUNCTION CreateScalableFontResource LIB "GDI32.DLL" ALIAS "CreateScalableFontResourceA" (BYVAL fHidden AS LONG, lpszResourceFile AS ASCIIZ, lpszFontFile AS ASCIIZ, lpszCurrentPath AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateSolidBrush LIB "GDI32.DLL" ALIAS "CreateSolidBrush" (BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION DPtoLP LIB "GDI32.DLL" ALIAS "DPtoLP" (BYVAL hdc AS LONG, lpPoint AS POINTAPI, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION DeleteColorSpace LIB "GDI32.DLL" ALIAS "DeleteColorSpace" (BYVAL hcolorspace AS LONG) AS LONG
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION DeleteEnhMetaFile LIB "GDI32.DLL" ALIAS "DeleteEnhMetaFile" (BYVAL hemf AS LONG) AS LONG
DECLARE FUNCTION DeleteMetaFile LIB "GDI32.DLL" ALIAS "DeleteMetaFile" (BYVAL hMF AS LONG) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS LONG) AS LONG
DECLARE FUNCTION DescribePixelFormat LIB "GDI32.DLL" ALIAS "DescribePixelFormat" (BYVAL hDC AS LONG, BYVAL n AS LONG, BYVAL un AS LONG, lpPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG
DECLARE FUNCTION DrawEscape LIB "GDI32.DLL" ALIAS "DrawEscape" (BYVAL hdc AS LONG, BYVAL nEscape AS LONG, BYVAL cbInput AS LONG, lpszInData AS ASCIIZ) AS LONG
DECLARE FUNCTION Ellipse LIB "GDI32.DLL" ALIAS "Ellipse" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION EndDoc LIB "GDI32.DLL" ALIAS "EndDoc" (BYVAL hDC AS LONG) AS LONG
DECLARE FUNCTION EndDoc LIB "GDI32.DLL" ALIAS "EndDoc" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION EndPage LIB "GDI32.DLL" ALIAS "EndPage" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION EndPath LIB "GDI32.DLL" ALIAS "EndPath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION EnumEnhMetaFile LIB "GDI32.DLL" ALIAS "EnumEnhMetaFile" (BYVAL hdc AS LONG, BYVAL hemf AS LONG, BYVAL lpEnhMetaFunc AS LONG, lpData AS ANY, lpRect AS RECT) AS LONG
DECLARE FUNCTION EnumFontFamilies LIB "GDI32.DLL" ALIAS "EnumFontFamiliesA" (BYVAL hdc AS LONG, lpszFamily AS ASCIIZ, BYVAL lpEnumFontFamProc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumFontFamiliesEx LIB "GDI32.DLL" ALIAS "EnumFontFamiliesExA" (BYVAL hdc AS LONG, lpLogFont AS LOGFONT, BYVAL lpEnumFontProc AS LONG, BYVAL lParam AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION EnumFonts LIB "GDI32.DLL" ALIAS "EnumFontsA" (BYVAL hDC AS LONG, lpsz AS ASCIIZ, BYVAL lpFontEnumProc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumICMProfiles LIB "GDI32.DLL" ALIAS "EnumICMProfilesA" (BYVAL hdc AS LONG, BYVAL icmEnumProc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumMetaFile LIB "GDI32.DLL" ALIAS "EnumMetaFile" (BYVAL hDC AS LONG, BYVAL hMetafile AS LONG, BYVAL lpMFEnumProc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumObjects LIB "GDI32.DLL" ALIAS "EnumObjects" (BYVAL hDC AS LONG, BYVAL n AS LONG, BYVAL lpGOBJEnumProc AS LONG, lpVoid AS ANY) AS LONG
DECLARE FUNCTION EqualRgn LIB "GDI32.DLL" ALIAS "EqualRgn" (BYVAL hSrcRgn1 AS LONG, BYVAL hSrcRgn2 AS LONG) AS LONG
DECLARE FUNCTION Escape LIB "GDI32.DLL" ALIAS "Escape" (BYVAL hdc AS LONG, BYVAL nEscape AS LONG, BYVAL nCount AS LONG, lpInData AS ASCIIZ, lpOutData AS ANY) AS LONG
DECLARE FUNCTION ExcludeClipRect LIB "GDI32.DLL" ALIAS "ExcludeClipRect" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION ExtCreatePen LIB "GDI32.DLL" ALIAS "ExtCreatePen" (BYVAL dwPenStyle AS LONG, BYVAL dwWidth AS LONG, lplb AS LOGBRUSH, BYVAL dwStyleCount AS LONG, lpStyle AS LONG) AS LONG
'DECLARE FUNCTION ExtCreateRegion LIB "GDI32.DLL" ALIAS "ExtCreateRegion" (lpXform AS xform, BYVAL nCount AS LONG, lpRgnData AS RGNDATA) AS LONG
DECLARE FUNCTION ExtCreateRegion LIB "GDI32.DLL" ALIAS "ExtCreateRegion" (lpXform AS Any, BYVAL nCount AS LONG, lpRgnData AS Any) AS LONG
DECLARE FUNCTION ExtEscape LIB "GDI32.DLL" ALIAS "ExtEscape" (BYVAL hdc AS LONG, BYVAL nEscape AS LONG, BYVAL cbInput AS LONG, lpszInData AS ASCIIZ, BYVAL cbOutput AS LONG, lpszOutData AS ASCIIZ) AS LONG
DECLARE FUNCTION ExtFloodFill LIB "GDI32.DLL" ALIAS "ExtFloodFill" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL crColor AS LONG, BYVAL wFillType AS LONG) AS LONG
DECLARE FUNCTION ExtSelectClipRgn LIB "GDI32.DLL" ALIAS "ExtSelectClipRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG, BYVAL fnMode AS LONG) AS LONG
DECLARE FUNCTION ExtTextOut LIB "GDI32.DLL" ALIAS "ExtTextOutA" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL wOptions AS LONG, lpRect AS Rect, lpString AS ASCIIZ, BYVAL nCount AS LONG, lpDx AS LONG) AS LONG
DECLARE FUNCTION FillPath LIB "GDI32.DLL" ALIAS "FillPath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION FillRgn LIB "GDI32.DLL" ALIAS "FillRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG, BYVAL hBrush AS LONG) AS LONG
DECLARE FUNCTION FixBrushOrgEx LIB "GDI32.DLL" ALIAS "FixBrushOrgEx" (BYVAL hDC AS LONG, BYVAL n1 AS LONG, BYVAL n2 AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION FlattenPath LIB "GDI32.DLL" ALIAS "FlattenPath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION FloodFill LIB "GDI32.DLL" ALIAS "FloodFill" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION FrameRgn LIB "GDI32.DLL" ALIAS "FrameRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG, BYVAL hBrush AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS LONG
DECLARE FUNCTION GdiComment LIB "GDI32.DLL" ALIAS "GdiComment" (BYVAL hdc AS LONG, BYVAL cbSize AS LONG, lpData AS BYTE) AS LONG
DECLARE FUNCTION GdiFlush LIB "GDI32.DLL" ALIAS "GdiFlush" () AS LONG
DECLARE FUNCTION GdiGetBatchLimit LIB "GDI32.DLL" ALIAS "GdiGetBatchLimit" () AS LONG
DECLARE FUNCTION GdiSetBatchLimit LIB "GDI32.DLL" ALIAS "GdiSetBatchLimit" (BYVAL dwLimit AS LONG) AS LONG
DECLARE FUNCTION GetArcDirection LIB "GDI32.DLL" ALIAS "GetArcDirection" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetAspectRatioFilterEx LIB "GDI32.DLL" ALIAS "GetAspectRatioFilterEx" (BYVAL hdc AS LONG, lpAspectRatio AS SIZEL) AS LONG
DECLARE FUNCTION GetBitmapBits LIB "GDI32.DLL" ALIAS "GetBitmapBits" (BYVAL hBitmap AS LONG, BYVAL dwCount AS LONG, lpBits AS ANY) AS LONG
DECLARE FUNCTION GetBitmapDimensionEx LIB "GDI32.DLL" ALIAS "GetBitmapDimensionEx" (BYVAL hBitmap AS LONG, lpDimension AS SIZEL) AS LONG
DECLARE FUNCTION GetBkColor LIB "GDI32.DLL" ALIAS "GetBkColor" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetBkMode LIB "GDI32.DLL" ALIAS "GetBkMode" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetBoundsRect LIB "GDI32.DLL" ALIAS "GetBoundsRect" (BYVAL hdc AS LONG, lprcBounds AS RECT, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION GetBrushOrgEx LIB "GDI32.DLL" ALIAS "GetBrushOrgEx" (BYVAL hDC AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetCharABCWidths LIB "GDI32.DLL" ALIAS "GetCharABCWidthsA" (BYVAL hdc AS LONG, BYVAL uFirstChar AS LONG, BYVAL uLastChar AS LONG, lpabc AS ABC) AS LONG
DECLARE FUNCTION GetCharABCWidthsFloat LIB "GDI32.DLL" ALIAS "GetCharABCWidthsFloatA" (BYVAL hdc AS LONG, BYVAL iFirstChar AS LONG, BYVAL iLastChar AS LONG, lpABCF AS ABCFLOAT) AS LONG
DECLARE FUNCTION GetCharWidth LIB "GDI32.DLL" ALIAS "GetCharWidthA" (BYVAL hDC AS LONG, BYVAL un1 AS LONG, BYVAL un2 AS LONG, lpn AS LONG) AS LONG
DECLARE FUNCTION GetCharWidth LIB "GDI32.DLL" ALIAS "GetCharWidthA" (BYVAL hdc AS LONG, BYVAL wFirstChar AS LONG, BYVAL wLastChar AS LONG, lpBuffer AS LONG) AS LONG
DECLARE FUNCTION GetCharWidth32 LIB "GDI32.DLL" ALIAS "GetCharWidth32A" (BYVAL hdc AS LONG, BYVAL iFirstChar AS LONG, BYVAL iLastChar AS LONG, lpBuffer AS LONG) AS LONG
DECLARE FUNCTION GetCharWidthFloat LIB "GDI32.DLL" ALIAS "GetCharWidthFloatA" (BYVAL hdc AS LONG, BYVAL iFirstChar AS LONG, BYVAL iLastChar AS LONG, pxBuffer AS Double) AS LONG
DECLARE FUNCTION GetCharacterPlacement LIB "GDI32.DLL" ALIAS "GetCharacterPlacementA" (BYVAL hdc AS LONG, lpsz AS ASCIIZ, BYVAL n1 AS LONG, BYVAL n2 AS LONG, lpGcpResults AS GCP_RESULTS, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION GetClipBox LIB "GDI32.DLL" ALIAS "GetClipBox" (BYVAL hdc AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetClipRgn LIB "GDI32.DLL" ALIAS "GetClipRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION GetColorAdjustment LIB "GDI32.DLL" ALIAS "GetColorAdjustment" (BYVAL hdc AS LONG, lpca AS COLORADJUSTMENT) AS LONG
DECLARE FUNCTION GetColorSpace LIB "GDI32.DLL" ALIAS "GetColorSpace" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetCurrentObject LIB "GDI32.DLL" ALIAS "GetCurrentObject" (BYVAL hdc AS LONG, BYVAL uObjectType AS LONG) AS LONG
DECLARE FUNCTION GetCurrentPositionEx LIB "GDI32.DLL" ALIAS "GetCurrentPositionEx" (BYVAL hdc AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDCOrgEx LIB "GDI32.DLL" ALIAS "GetDCOrgEx" (BYVAL hdc AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDIBColorTable LIB "GDI32.DLL" ALIAS "GetDIBColorTable" (BYVAL hDC AS LONG, BYVAL un1 AS LONG, BYVAL un2 AS LONG, pRGBQuad AS RGBQUAD) AS LONG
DECLARE FUNCTION GetDIBits LIB "GDI32.DLL" ALIAS "GetDIBits" (BYVAL aHDC AS LONG, BYVAL hBitmap AS LONG, BYVAL nStartScan AS LONG, BYVAL nNumScans AS LONG, lpBits AS ANY, lpBI AS BITMAPINFO, BYVAL wUsage AS LONG) AS LONG
DECLARE FUNCTION GetDeviceCaps LIB "GDI32.DLL" ALIAS "GetDeviceCaps" (BYVAL hdc AS LONG, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetDeviceGammaRamp LIB "GDI32.DLL" ALIAS "GetDeviceGammaRamp" (BYVAL hdc AS LONG, lpv AS ANY) AS LONG
DECLARE FUNCTION GetEnhMetaFile LIB "GDI32.DLL" ALIAS "GetEnhMetaFileA" (lpszMetaFile AS ASCIIZ) AS LONG
DECLARE FUNCTION GetEnhMetaFileBits LIB "GDI32.DLL" ALIAS "GetEnhMetaFileBits" (BYVAL hemf AS LONG, BYVAL cbBuffer AS LONG, lpbBuffer AS BYTE) AS LONG
DECLARE FUNCTION GetEnhMetaFileDescription LIB "GDI32.DLL" ALIAS "GetEnhMetaFileDescriptionA" (BYVAL hemf AS LONG, BYVAL cchBuffer AS LONG, lpszDescription AS ASCIIZ) AS LONG
DECLARE FUNCTION GetEnhMetaFileHeader LIB "GDI32.DLL" ALIAS "GetEnhMetaFileHeader" (BYVAL hemf AS LONG, BYVAL cbBuffer AS LONG, lpemh AS ENHMETAHEADER) AS LONG
DECLARE FUNCTION GetEnhMetaFilePaletteEntries LIB "GDI32.DLL" ALIAS "GetEnhMetaFilePaletteEntries" (BYVAL hemf AS LONG, BYVAL cEntries AS LONG, lppe AS PALETTEENTRY) AS LONG
DECLARE FUNCTION GetFontData LIB "GDI32.DLL" ALIAS "GetFontDataA" (BYVAL hdc AS LONG, BYVAL dwTable AS LONG, BYVAL dwOffset AS LONG, lpvBuffer AS ANY, BYVAL cbData AS LONG) AS LONG
DECLARE FUNCTION GetFontLanguageInfo LIB "GDI32.DLL" ALIAS "GetFontLanguageInfo" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetGlyphOutline LIB "GDI32.DLL" ALIAS "GetGlyphOutlineA" (BYVAL hdc AS LONG, BYVAL uChar AS LONG, BYVAL fuFormat AS LONG, lpgm AS GLYPHMETRICS, BYVAL cbBuffer AS LONG, lpBuffer AS ANY, lpmat2 AS MAT2) AS LONG
DECLARE FUNCTION GetGraphicsMode LIB "GDI32.DLL" ALIAS "GetGraphicsMode" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetICMProfile LIB "GDI32.DLL" ALIAS "GetICMProfileA" (BYVAL hdc AS LONG, BYVAL dw AS LONG, lpStr AS ASCIIZ) AS LONG
DECLARE FUNCTION GetKerningPairs LIB "GDI32.DLL" ALIAS "GetKerningPairsA" (BYVAL hdc AS LONG, BYVAL cPairs AS LONG, lpkrnpair AS KERNINGPAIR) AS LONG
DECLARE FUNCTION GetLogColorSpace LIB "GDI32.DLL" ALIAS "GetLogColorSpaceA" (BYVAL hcolorspace AS LONG, lplogcolorspace AS LOGCOLORSPACE, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION GetMapMode LIB "GDI32.DLL" ALIAS "GetMapMode" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetMetaFile LIB "GDI32.DLL" ALIAS "GetMetaFileA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetMetaFileBitsEx LIB "GDI32.DLL" ALIAS "GetMetaFileBitsEx" (BYVAL hMF AS LONG, BYVAL nSize AS LONG, lpvData AS ANY) AS LONG
DECLARE FUNCTION GetMetaRgn LIB "GDI32.DLL" ALIAS "GetMetaRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION GetMiterLimit LIB "GDI32.DLL" ALIAS "GetMiterLimit" (BYVAL hdc AS LONG, peLimit AS Double) AS LONG
DECLARE FUNCTION GetNearestColor LIB "GDI32.DLL" ALIAS "GetNearestColor" (BYVAL hdc AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION GetNearestPaletteIndex LIB "GDI32.DLL" ALIAS "GetNearestPaletteIndex" (BYVAL hPalette AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION GetObject LIB "GDI32.DLL" ALIAS "GetObjectA" (BYVAL hObject AS LONG, BYVAL nCount AS LONG, lpObject AS ANY) AS LONG
DECLARE FUNCTION GetObjectType LIB "GDI32.DLL" ALIAS "GetObjectType" (BYVAL hgdiobj AS LONG) AS LONG
DECLARE FUNCTION GetOutlineTextMetrics LIB "GDI32.DLL" ALIAS "GetOutlineTextMetricsA" (BYVAL hdc AS LONG, BYVAL cbData AS LONG, lpotm AS OUTLINETEXTMETRIC) AS LONG
DECLARE FUNCTION GetPaletteEntries LIB "GDI32.DLL" ALIAS "GetPaletteEntries" (BYVAL hPalette AS LONG, BYVAL wStartIndex AS LONG, BYVAL wNumEntries AS LONG, lpPaletteEntries AS PALETTEENTRY) AS LONG
DECLARE FUNCTION GetPath LIB "GDI32.DLL" ALIAS "GetPath" (BYVAL hdc AS LONG, lpPoint AS POINTAPI, lpTypes AS BYTE, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetPixel LIB "GDI32.DLL" ALIAS "GetPixel" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION GetPixelFormat LIB "GDI32.DLL" ALIAS "GetPixelFormat" (BYVAL hDC AS LONG) AS LONG
DECLARE FUNCTION GetPolyFillMode LIB "GDI32.DLL" ALIAS "GetPolyFillMode" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetROP2 LIB "GDI32.DLL" ALIAS "GetROP2" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetRasterizerCaps LIB "GDI32.DLL" ALIAS "GetRasterizerCaps" (lpraststat AS RASTERIZER_STATUS, BYVAL cb AS LONG) AS LONG
DECLARE FUNCTION GetRegionData LIB "GDI32.DLL" ALIAS "GetRegionDataA" (BYVAL hRgn AS LONG, BYVAL dwCount AS LONG, lpRgnData AS RgnData) AS LONG
DECLARE FUNCTION GetRgnBox LIB "GDI32.DLL" ALIAS "GetRgnBox" (BYVAL hRgn AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetStretchBltMode LIB "GDI32.DLL" ALIAS "GetStretchBltMode" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetSystemPaletteEntries LIB "GDI32.DLL" ALIAS "GetSystemPaletteEntries" (BYVAL hdc AS LONG, BYVAL wStartIndex AS LONG, BYVAL wNumEntries AS LONG, lpPaletteEntries AS PALETTEENTRY) AS LONG
DECLARE FUNCTION GetSystemPaletteUse LIB "GDI32.DLL" ALIAS "GetSystemPaletteUse" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetTextAlign LIB "GDI32.DLL" ALIAS "GetTextAlign" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetTextCharacterExtra LIB "GDI32.DLL" ALIAS "GetTextCharacterExtra" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetTextCharset LIB "GDI32.DLL" ALIAS "GetTextCharset" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetTextCharsetInfo LIB "GDI32.DLL" ALIAS "GetTextCharsetInfo" (BYVAL hdc AS LONG, lpSig AS FONTSIGNATURE, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION GetTextColor LIB "GDI32.DLL" ALIAS "GetTextColor" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION GetTextExtentExPoint LIB "GDI32.DLL" ALIAS "GetTextExtentExPointA" (BYVAL hdc AS LONG, lpszStr AS ASCIIZ, BYVAL cchString AS LONG, BYVAL nMaxExtent AS LONG, lpnFit AS LONG, alpDx AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION GetTextExtentPoint LIB "GDI32.DLL" ALIAS "GetTextExtentPointA" (BYVAL hdc AS LONG, lpszString AS ASCIIZ, BYVAL cbString AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION GetTextExtentPoint32 LIB "GDI32.DLL" ALIAS "GetTextExtentPoint32A" (BYVAL hdc AS LONG, lpsz AS ASCIIZ, BYVAL cbString AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION GetTextFace LIB "GDI32.DLL" ALIAS "GetTextFaceA" (BYVAL hdc AS LONG, BYVAL nCount AS LONG, lpFacename AS ASCIIZ) AS LONG
DECLARE FUNCTION GetTextMetrics LIB "GDI32.DLL" ALIAS "GetTextMetricsA" (BYVAL hdc AS LONG, lpMetrics AS TEXTMETRIC) AS LONG
DECLARE FUNCTION GetViewportExtEx LIB "GDI32.DLL" ALIAS "GetViewportExtEx" (BYVAL hdc AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION GetViewportOrgEx LIB "GDI32.DLL" ALIAS "GetViewportOrgEx" (BYVAL hdc AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetWinMetaFileBits LIB "GDI32.DLL" ALIAS "GetWinMetaFileBits" (BYVAL hemf AS LONG, BYVAL cbBuffer AS LONG, lpbBuffer AS BYTE, BYVAL fnMapMode AS LONG, BYVAL hdcRef AS LONG) AS LONG
DECLARE FUNCTION GetWindowExtEx LIB "GDI32.DLL" ALIAS "GetWindowExtEx" (BYVAL hdc AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION GetWindowOrgEx LIB "GDI32.DLL" ALIAS "GetWindowOrgEx" (BYVAL hdc AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetWorldTransform LIB "GDI32.DLL" ALIAS "GetWorldTransform" (BYVAL hdc AS LONG, lpXform AS xform) AS LONG
DECLARE FUNCTION IntersectClipRect LIB "GDI32.DLL" ALIAS "IntersectClipRect" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION InvertRgn LIB "GDI32.DLL" ALIAS "InvertRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION LPtoDP LIB "GDI32.DLL" ALIAS "LPtoDP" (BYVAL hdc AS LONG, lpPoint AS POINTAPI, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION LineDDA LIB "GDI32.DLL" ALIAS "LineDDA" (BYVAL n1 AS LONG, BYVAL n2 AS LONG, BYVAL n3 AS LONG, BYVAL n4 AS LONG, BYVAL lpLineDDAProc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION LineTo LIB "GDI32.DLL" ALIAS "LineTo" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION MaskBlt LIB "GDI32.DLL" ALIAS "MaskBlt" (BYVAL hdcDest AS LONG, BYVAL nXDest AS LONG, BYVAL nYDest AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hdcSrc AS LONG, BYVAL nXSrc AS LONG, BYVAL nYSrc AS LONG, _
                 BYVAL hbmMask AS LONG, BYVAL xMask AS LONG, BYVAL yMask AS LONG, BYVAL dwRop AS LONG) AS LONG
DECLARE FUNCTION ModifyWorldTransform LIB "GDI32.DLL" ALIAS "ModifyWorldTransform" (BYVAL hdc AS LONG, lpXform AS xform, BYVAL iMode AS LONG) AS LONG
DECLARE FUNCTION MoveToEx LIB "GDI32.DLL" ALIAS "MoveToEx" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, lpPoint AS POINTAPI) AS LONG

$IF NOT %DEF(%pb_cc32)
FUNCTION MoveTo(BYVAL hDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
  FUNCTION = MoveToEx(hDC, x, y, BYVAL %NULL)
END FUNCTION
$ENDIF

DECLARE FUNCTION OffsetClipRgn LIB "GDI32.DLL" ALIAS "OffsetClipRgn" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION OffsetRgn LIB "GDI32.DLL" ALIAS "OffsetRgn" (BYVAL hRgn AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION OffsetViewportOrgEx LIB "GDI32.DLL" ALIAS "OffsetViewportOrgEx" (BYVAL hdc AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION OffsetWindowOrgEx LIB "GDI32.DLL" ALIAS "OffsetWindowOrgEx" (BYVAL hdc AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION PaintRgn LIB "GDI32.DLL" ALIAS "PaintRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION PatBlt LIB "GDI32.DLL" ALIAS "PatBlt" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL dwRop AS LONG) AS LONG
DECLARE FUNCTION PathToRegion LIB "GDI32.DLL" ALIAS "PathToRegion" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION Pie LIB "GDI32.DLL" ALIAS "Pie" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG, BYVAL X3 AS LONG, BYVAL Y3 AS LONG, BYVAL X4 AS LONG, BYVAL Y4 AS LONG) AS LONG
DECLARE FUNCTION PlayEnhMetaFile LIB "GDI32.DLL" ALIAS "PlayEnhMetaFile" (BYVAL hdc AS LONG, BYVAL hemf AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION PlayEnhMetaFileRecord LIB "GDI32.DLL" ALIAS "PlayEnhMetaFileRecord" (BYVAL hdc AS LONG, lpHandletable AS HANDLETABLE, lpEnhMetaRecord AS ENHMETARECORD, BYVAL nHandles AS LONG) AS LONG
DECLARE FUNCTION PlayMetaFile LIB "GDI32.DLL" ALIAS "PlayMetaFile" (BYVAL hdc AS LONG, BYVAL hMF AS LONG) AS LONG
DECLARE FUNCTION PlayMetaFileRecord LIB "GDI32.DLL" ALIAS "PlayMetaFileRecord" (BYVAL hdc AS LONG, lpHandletable AS HANDLETABLE, lpMetaRecord AS METARECORD, BYVAL nHandles AS LONG) AS LONG
DECLARE FUNCTION PlgBlt LIB "GDI32.DLL" ALIAS "PlgBlt" (BYVAL hdcDest AS LONG, lpPoint AS POINTAPI, BYVAL hdcSrc AS LONG, BYVAL nXSrc AS LONG, BYVAL nYSrc AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hbmMask AS LONG, _
                 BYVAL xMask AS LONG, BYVAL yMask AS LONG) AS LONG
DECLARE FUNCTION PolyBezier LIB "GDI32.DLL" ALIAS "PolyBezier" (BYVAL hdc AS LONG, lppt AS POINTAPI, BYVAL cPoints AS LONG) AS LONG
DECLARE FUNCTION PolyBezierTo LIB "GDI32.DLL" ALIAS "PolyBezierTo" (BYVAL hdc AS LONG, lppt AS POINTAPI, BYVAL cCount AS LONG) AS LONG
DECLARE FUNCTION PolyDraw LIB "GDI32.DLL" ALIAS "PolyDraw" (BYVAL hdc AS LONG, lppt AS POINTAPI, lpbTypes AS BYTE, BYVAL cCount AS LONG) AS LONG
DECLARE FUNCTION PolyPolygon LIB "GDI32.DLL" ALIAS "PolyPolygon" (BYVAL hdc AS LONG, lpPoint AS POINTAPI, lpPolyCounts AS LONG, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION PolyPolyline LIB "GDI32.DLL" ALIAS "PolyPolyline" (BYVAL hdc AS LONG, lppt AS POINTAPI, lpdwPolyPoints AS LONG, BYVAL cCount AS LONG) AS LONG
DECLARE FUNCTION PolyTextOut LIB "GDI32.DLL" ALIAS "PolyTextOutA" (BYVAL hdc AS LONG, pptxt AS POLYTEXT, cStrings AS LONG) AS LONG
DECLARE FUNCTION Polygon LIB "GDI32.DLL" ALIAS "Polygon" (BYVAL hdc AS LONG, lpPoint AS POINTAPI, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION Polyline LIB "GDI32.DLL" ALIAS "Polyline" (BYVAL hdc AS LONG, lpPoint AS POINTAPI, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION PolylineTo LIB "GDI32.DLL" ALIAS "PolylineTo" (BYVAL hdc AS LONG, lppt AS POINTAPI, BYVAL cCount AS LONG) AS LONG
DECLARE FUNCTION PtInRegion LIB "GDI32.DLL" ALIAS "PtInRegion" (BYVAL hRgn AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION PtVisible LIB "GDI32.DLL" ALIAS "PtVisible" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION RealizePalette LIB "GDI32.DLL" ALIAS "RealizePalette" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION RectInRegion LIB "GDI32.DLL" ALIAS "RectInRegion" (BYVAL hRgn AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION RectVisible LIB "GDI32.DLL" ALIAS "RectVisible" (BYVAL hdc AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION Rectangle LIB "GDI32.DLL" ALIAS "Rectangle" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION RemoveFontResource LIB "GDI32.DLL" ALIAS "RemoveFontResourceA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION ResetDC LIB "GDI32.DLL" ALIAS "ResetDCA" (BYVAL hdc AS LONG, lpInitData AS DEVMODE) AS LONG
DECLARE FUNCTION ResizePalette LIB "GDI32.DLL" ALIAS "ResizePalette" (BYVAL hPalette AS LONG, BYVAL nNumEntries AS LONG) AS LONG
DECLARE FUNCTION RestoreDC LIB "GDI32.DLL" ALIAS "RestoreDC" (BYVAL hdc AS LONG, BYVAL nSavedDC AS LONG) AS LONG
DECLARE FUNCTION RoundRect LIB "GDI32.DLL" ALIAS "RoundRect" (BYVAL hdc AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG, BYVAL X3 AS LONG, BYVAL Y3 AS LONG) AS LONG
DECLARE FUNCTION SaveDC LIB "GDI32.DLL" ALIAS "SaveDC" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION ScaleViewportExtEx LIB "GDI32.DLL" ALIAS "ScaleViewportExtEx" (BYVAL hdc AS LONG, BYVAL nXnum AS LONG, BYVAL nXdenom AS LONG, BYVAL nYnum AS LONG, BYVAL nYdenom AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION ScaleWindowExtEx LIB "GDI32.DLL" ALIAS "ScaleWindowExtEx" (BYVAL hdc AS LONG, BYVAL nXnum AS LONG, BYVAL nXdenom AS LONG, BYVAL nYnum AS LONG, BYVAL nYdenom AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION SelectClipPath LIB "GDI32.DLL" ALIAS "SelectClipPath" (BYVAL hdc AS LONG, BYVAL iMode AS LONG) AS LONG
DECLARE FUNCTION SelectClipRgn LIB "GDI32.DLL" ALIAS "SelectClipRgn" (BYVAL hdc AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS LONG, BYVAL hObject AS LONG) AS LONG
DECLARE FUNCTION SelectPalette LIB "GDI32.DLL" ALIAS "SelectPalette" (BYVAL hdc AS LONG, BYVAL hPalette AS LONG, BYVAL bForceBackground AS LONG) AS LONG
DECLARE FUNCTION SetAbortProc LIB "GDI32.DLL" ALIAS "SetAbortProc" (BYVAL hDC AS LONG, BYVAL lpAbortProc AS LONG) AS LONG
DECLARE FUNCTION SetArcDirection LIB "GDI32.DLL" ALIAS "SetArcDirection" (BYVAL hdc AS LONG, BYVAL ArcDirection AS LONG) AS LONG
DECLARE FUNCTION SetBitmapBits LIB "GDI32.DLL" ALIAS "SetBitmapBits" (BYVAL hBitmap AS LONG, BYVAL dwCount AS LONG, lpBits AS ANY) AS LONG
DECLARE FUNCTION SetBitmapDimensionEx LIB "GDI32.DLL" ALIAS "SetBitmapDimensionEx" (BYVAL hbm AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" (BYVAL hdc AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION SetBkMode LIB "GDI32.DLL" ALIAS "SetBkMode" (BYVAL hdc AS LONG, BYVAL nBkMode AS LONG) AS LONG
DECLARE FUNCTION SetBoundsRect LIB "GDI32.DLL" ALIAS "SetBoundsRect" (BYVAL hdc AS LONG, lprcBounds AS RECT, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION SetBrushOrgEx LIB "GDI32.DLL" ALIAS "SetBrushOrgEx" (BYVAL hdc AS LONG, BYVAL nXOrg AS LONG, BYVAL nYOrg AS LONG, lppt AS POINTAPI) AS LONG
DECLARE FUNCTION SetColorAdjustment LIB "GDI32.DLL" ALIAS "SetColorAdjustment" (BYVAL hdc AS LONG, lpca AS COLORADJUSTMENT) AS LONG
DECLARE FUNCTION SetColorSpace LIB "GDI32.DLL" ALIAS "SetColorSpace" (BYVAL hdc AS LONG, BYVAL hcolorspace AS LONG) AS LONG
DECLARE FUNCTION SetDIBColorTable LIB "GDI32.DLL" ALIAS "SetDIBColorTable" (BYVAL hDC AS LONG, BYVAL un1 AS LONG, BYVAL un2 AS LONG, pcRGBQuad AS RGBQUAD) AS LONG
DECLARE FUNCTION SetDIBits LIB "GDI32.DLL" ALIAS "SetDIBits" (BYVAL hdc AS LONG, BYVAL hBitmap AS LONG, BYVAL nStartScan AS LONG, BYVAL nNumScans AS LONG, lpBits AS ANY, lpBI AS BITMAPINFO, BYVAL wUsage AS LONG) AS LONG
DECLARE FUNCTION SetDIBitsToDevice LIB "GDI32.DLL" ALIAS "SetDIBitsToDevice" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL dx AS LONG, BYVAL dy AS LONG, BYVAL SrcX AS LONG, BYVAL SrcY AS LONG, BYVAL xScan AS LONG, _
                 BYVAL NumScans AS LONG, xBits AS ANY, BitsInfo AS BITMAPINFO, BYVAL wUsage AS LONG) AS LONG
DECLARE FUNCTION SetDeviceGammaRamp LIB "GDI32.DLL" ALIAS "SetDeviceGammaRamp" (BYVAL hdc AS LONG, lpv AS ANY) AS LONG
DECLARE FUNCTION SetEnhMetaFileBits LIB "GDI32.DLL" ALIAS "SetEnhMetaFileBits" (BYVAL cbBuffer AS LONG, lpData AS BYTE) AS LONG
DECLARE FUNCTION SetGraphicsMode LIB "GDI32.DLL" ALIAS "SetGraphicsMode" (BYVAL hdc AS LONG, BYVAL iMode AS LONG) AS LONG
DECLARE FUNCTION SetICMMode LIB "GDI32.DLL" ALIAS "SetICMMode" (BYVAL hdc AS LONG, BYVAL n AS LONG) AS LONG
DECLARE FUNCTION SetICMProfile LIB "GDI32.DLL" ALIAS "SetICMProfileA" (BYVAL hdc AS LONG, lpStr AS ASCIIZ) AS LONG
DECLARE FUNCTION SetMapMode LIB "GDI32.DLL" ALIAS "SetMapMode" (BYVAL hdc AS LONG, BYVAL nMapMode AS LONG) AS LONG
DECLARE FUNCTION SetMapperFlags LIB "GDI32.DLL" ALIAS "SetMapperFlags" (BYVAL hdc AS LONG, BYVAL dwFlag AS LONG) AS LONG
DECLARE FUNCTION SetMetaFileBitsEx LIB "GDI32.DLL" ALIAS "SetMetaFileBitsEx" (BYVAL nSize AS LONG, lpData AS BYTE) AS LONG
DECLARE FUNCTION SetMetaRgn LIB "GDI32.DLL" ALIAS "SetMetaRgn" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION SetMiterLimit LIB "GDI32.DLL" ALIAS "SetMiterLimit" (BYVAL hdc AS LONG, BYVAL eNewLimit AS Double, peOldLimit AS Double) AS LONG
DECLARE FUNCTION SetPaletteEntries LIB "GDI32.DLL" ALIAS "SetPaletteEntries" (BYVAL hPalette AS LONG, BYVAL wStartIndex AS LONG, BYVAL wNumEntries AS LONG, lpPaletteEntries AS PALETTEENTRY) AS LONG
DECLARE FUNCTION SetPixel LIB "GDI32.DLL" ALIAS "SetPixel" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION SetPixelFormat LIB "GDI32.DLL" ALIAS "SetPixelFormat" (BYVAL hDC AS LONG, BYVAL n AS LONG, pcPixelFormatDescriptor AS PIXELFORMATDESCRIPTOR) AS LONG
DECLARE FUNCTION SetPixelV LIB "GDI32.DLL" ALIAS "SetPixelV" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION SetPolyFillMode LIB "GDI32.DLL" ALIAS "SetPolyFillMode" (BYVAL hdc AS LONG, BYVAL nPolyFillMode AS LONG) AS LONG
DECLARE FUNCTION SetROP2 LIB "GDI32.DLL" ALIAS "SetROP2" (BYVAL hdc AS LONG, BYVAL nDrawMode AS LONG) AS LONG
DECLARE FUNCTION SetRectRgn LIB "GDI32.DLL" ALIAS "SetRectRgn" (BYVAL hRgn AS LONG, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION SetStretchBltMode LIB "GDI32.DLL" ALIAS "SetStretchBltMode" (BYVAL hdc AS LONG, BYVAL nStretchMode AS LONG) AS LONG
DECLARE FUNCTION SetSystemPaletteUse LIB "GDI32.DLL" ALIAS "SetSystemPaletteUse" (BYVAL hdc AS LONG, BYVAL wUsage AS LONG) AS LONG
DECLARE FUNCTION SetTextAlign LIB "GDI32.DLL" ALIAS "SetTextAlign" (BYVAL hdc AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION SetTextCharacterExtra LIB "GDI32.DLL" ALIAS "SetTextCharacterExtra" (BYVAL hdc AS LONG, BYVAL nCharExtra AS LONG) AS LONG
DECLARE FUNCTION SetTextColor LIB "GDI32.DLL" ALIAS "SetTextColor" (BYVAL hdc AS LONG, BYVAL crColor AS LONG) AS LONG
DECLARE FUNCTION SetTextJustification LIB "GDI32.DLL" ALIAS "SetTextJustification" (BYVAL hdc AS LONG, BYVAL nBreakExtra AS LONG, BYVAL nBreakCount AS LONG) AS LONG
DECLARE FUNCTION SetViewportExtEx LIB "GDI32.DLL" ALIAS "SetViewportExtEx" (BYVAL hdc AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION SetViewportOrgEx LIB "GDI32.DLL" ALIAS "SetViewportOrgEx" (BYVAL hdc AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SetWinMetaFileBits LIB "GDI32.DLL" ALIAS "SetWinMetaFileBits" (BYVAL cbBuffer AS LONG, lpbBuffer AS BYTE, BYVAL hdcRef AS LONG, lpmfp AS METAFILEPICT) AS LONG
DECLARE FUNCTION SetWindowExtEx LIB "GDI32.DLL" ALIAS "SetWindowExtEx" (BYVAL hdc AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpSize AS SIZEL) AS LONG
DECLARE FUNCTION SetWindowOrgEx LIB "GDI32.DLL" ALIAS "SetWindowOrgEx" (BYVAL hdc AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SetWorldTransform LIB "GDI32.DLL" ALIAS "SetWorldTransform" (BYVAL hdc AS LONG, lpXform AS xform) AS LONG
DECLARE FUNCTION StartDoc LIB "GDI32.DLL" ALIAS "StartDocA" (BYVAL hdc AS LONG, lpdi AS DOCINFO) AS LONG
DECLARE FUNCTION StartPage LIB "GDI32.DLL" ALIAS "StartPage" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION StretchBlt LIB "GDI32.DLL" ALIAS "StretchBlt" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS LONG, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL nSrcWidth AS LONG, BYVAL nSrcHeight AS LONG, BYVAL dwRop AS LONG) AS LONG
DECLARE FUNCTION StretchDIBits LIB "GDI32.DLL" ALIAS "StretchDIBits" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL dx AS LONG, BYVAL dy AS LONG, BYVAL SrcX AS LONG, BYVAL SrcY AS LONG, BYVAL wSrcWidth AS LONG, _
                 BYVAL wSrcHeight AS LONG, lpBits AS ANY, lpBitsInfo AS BITMAPINFO, BYVAL wUsage AS LONG, BYVAL dwRop AS LONG) AS LONG
DECLARE FUNCTION StrokeAndFillPath LIB "GDI32.DLL" ALIAS "StrokeAndFillPath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION StrokePath LIB "GDI32.DLL" ALIAS "StrokePath" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION SwapBuffers LIB "GDI32.DLL" ALIAS "SwapBuffers" (BYVAL hDC AS LONG) AS LONG
DECLARE FUNCTION TextOut LIB "GDI32.DLL" ALIAS "TextOutA" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, lpString AS ASCIIZ, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION TranslateCharsetInfo LIB "GDI32.DLL" ALIAS "TranslateCharsetInfo" (lpSrc AS LONG, lpcs AS CHARSETINFO, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION UnrealizeObject LIB "GDI32.DLL" ALIAS "UnrealizeObject" (BYVAL hObject AS LONG) AS LONG
DECLARE FUNCTION UpdateColors LIB "GDI32.DLL" ALIAS "UpdateColors" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION WidenPath LIB "GDI32.DLL" ALIAS "WidenPath" (BYVAL hdc AS LONG) AS LONG


'
' ** USER32.DLL Declares
'
DECLARE FUNCTION ActivateKeyboardLayout LIB "USER32.DLL" ALIAS "ActivateKeyboardLayout" (BYVAL HKL AS LONG, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION AdjustWindowRect LIB "USER32.DLL" ALIAS "AdjustWindowRect" (lpRect AS RECT, BYVAL dwStyle AS LONG, BYVAL bMenu AS LONG) AS LONG
DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS LONG) AS LONG
DECLARE FUNCTION AnyPopup LIB "USER32.DLL" ALIAS "AnyPopup" () AS LONG
DECLARE FUNCTION AppendMenu LIB "USER32.DLL" ALIAS "AppendMenuA" (BYVAL hMenu AS LONG, BYVAL wFlags AS LONG, BYVAL wIDNewItem AS LONG, lpNewItem AS ASCIIZ) AS LONG
DECLARE FUNCTION ArrangeIconicWindows LIB "USER32.DLL" ALIAS "ArrangeIconicWindows" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION AttachThreadInput LIB "USER32.DLL" ALIAS "AttachThreadInput" (BYVAL idAttach AS LONG, BYVAL idAttachTo AS LONG, BYVAL fAttach AS LONG) AS LONG
DECLARE FUNCTION BeginDeferWindowPos LIB "USER32.DLL" ALIAS "BeginDeferWindowPos" (BYVAL nNumWindows AS LONG) AS LONG
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hwnd AS LONG, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION BringWindowToTop LIB "USER32.DLL" ALIAS "BringWindowToTop" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION BroadcastSystemMessage LIB "USER32.DLL" ALIAS "BroadcastSystemMessage" (BYVAL dw AS LONG, pdw AS LONG, BYVAL un AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION CallMsgFilter LIB "USER32.DLL" ALIAS "CallMsgFilterA" (lpMsg AS tagMSG, BYVAL ncode AS LONG) AS LONG
DECLARE FUNCTION CallNextHookEx LIB "USER32.DLL" ALIAS "CallNextHookEx" (BYVAL hHook AS LONG, BYVAL ncode AS LONG, BYVAL wParam AS LONG, lParam AS ANY) AS LONG
DECLARE FUNCTION CallWindowProc LIB "USER32.DLL" ALIAS "CallWindowProcA" (BYVAL lpPrevWndFunc AS LONG, BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION CascadeWindows LIB "USER32.DLL" ALIAS "CascadeWindows" (BYVAL hwndParent AS LONG, BYVAL wHow AS LONG, lpRect AS RECT, BYVAL cKids AS LONG, lpkids AS LONG) AS LONG
DECLARE FUNCTION ChangeClipboardChain LIB "USER32.DLL" ALIAS "ChangeClipboardChain" (BYVAL hwnd AS LONG, BYVAL hWndNext AS LONG) AS LONG
DECLARE FUNCTION ChangeMenu LIB "USER32.DLL" ALIAS "ChangeMenuA" (BYVAL hMenu AS LONG, BYVAL cmd AS LONG, lpszNewItem AS ASCIIZ, BYVAL cmdInsert AS LONG, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION CharLower LIB "USER32.DLL" ALIAS "CharLowerA" (lpsz AS ASCIIZ) AS DWORD
DECLARE FUNCTION CharLowerBuff LIB "USER32.DLL" ALIAS "CharLowerBuffA" (lpsz AS ASCIIZ, BYVAL cchLength AS LONG) AS LONG
DECLARE FUNCTION CharNext LIB "USER32.DLL" ALIAS "CharNextA" (lpsz AS ASCIIZ) AS DWORD
DECLARE FUNCTION CharPrev LIB "USER32.DLL" ALIAS "CharPrevA" (lpszStart AS ASCIIZ, lpszCurrent AS ASCIIZ) AS DWORD
DECLARE FUNCTION CharToOem LIB "USER32.DLL" ALIAS "CharToOemA" (lpszSrc AS ASCIIZ, lpszDst AS ASCIIZ) AS LONG
DECLARE FUNCTION CharToOemBuff LIB "USER32.DLL" ALIAS "CharToOemBuffA" (lpszSrc AS ASCIIZ, lpszDst AS ASCIIZ, BYVAL cchDstLength AS LONG) AS LONG
DECLARE FUNCTION CharUpper LIB "USER32.DLL" ALIAS "CharUpperA" (lpsz AS ASCIIZ) AS DWORD
DECLARE FUNCTION CharUpperBuff LIB "USER32.DLL" ALIAS "CharUpperBuffA" (lpsz AS ASCIIZ, BYVAL cchLength AS LONG) AS LONG
DECLARE FUNCTION CheckDlgButton LIB "USER32.DLL" ALIAS "CheckDlgButton" (BYVAL hDlg AS LONG, BYVAL nIDButton AS LONG, BYVAL wCheck AS LONG) AS LONG
DECLARE FUNCTION CheckMenuItem LIB "USER32.DLL" ALIAS "CheckMenuItem" (BYVAL hMenu AS LONG, BYVAL wIDCheckItem AS LONG, BYVAL wCheck AS LONG) AS LONG
DECLARE FUNCTION CheckMenuRadioItem LIB "USER32.DLL" ALIAS "CheckMenuRadioItem" (BYVAL hMenu AS LONG, BYVAL un1 AS LONG, BYVAL un2 AS LONG, BYVAL un3 AS LONG, BYVAL un4 AS LONG) AS LONG
DECLARE FUNCTION CheckRadioButton LIB "USER32.DLL" ALIAS "CheckRadioButton" (BYVAL hDlg AS LONG, BYVAL nIDFirstButton AS LONG, BYVAL nIDLastButton AS LONG, BYVAL nIDCheckButton AS LONG) AS LONG
DECLARE FUNCTION ChildWindowFromPoint LIB "USER32.DLL" ALIAS "ChildWindowFromPoint" (BYVAL hWndParent AS LONG, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION ChildWindowFromPointEx LIB "USER32.DLL" ALIAS "ChildWindowFromPointEx" (BYVAL hWnd AS LONG, pt AS POINTAPI, BYVAL un AS LONG) AS LONG
DECLARE FUNCTION ClientToScreen LIB "USER32.DLL" ALIAS "ClientToScreen" (BYVAL hwnd AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION ClipCursor LIB "USER32.DLL" ALIAS "ClipCursor" (lpRect AS ANY) AS LONG
DECLARE FUNCTION CloseClipboard LIB "USER32.DLL" ALIAS "CloseClipboard" () AS LONG
DECLARE FUNCTION CloseDesktop LIB "USER32.DLL" ALIAS "CloseDesktop" (BYVAL hDesktop AS LONG) AS LONG
DECLARE FUNCTION CloseWindow LIB "USER32.DLL" ALIAS "CloseWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION CloseWindowStation LIB "USER32.DLL" ALIAS "CloseWindowStation" (BYVAL hWinSta AS LONG) AS LONG
DECLARE FUNCTION CopyAcceleratorTable LIB "USER32.DLL" ALIAS "CopyAcceleratorTableA" (BYVAL hAccelSrc AS LONG, lpAccelDst AS ACCEL, BYVAL cAccelEntries AS LONG) AS LONG
DECLARE FUNCTION CopyCursor LIB "USER32.DLL" ALIAS "CopyCursor" (BYVAL hcur AS LONG) AS LONG
DECLARE FUNCTION CopyIcon LIB "USER32.DLL" ALIAS "CopyIcon" (BYVAL hIcon AS LONG) AS LONG
DECLARE FUNCTION CopyImage LIB "USER32.DLL" ALIAS "CopyImage" (BYVAL xHandle AS LONG, BYVAL un1 AS LONG, BYVAL n1 AS LONG, BYVAL n2 AS LONG, BYVAL un2 AS LONG) AS LONG
DECLARE FUNCTION CopyRect LIB "USER32.DLL" ALIAS "CopyRect" (lpDestRect AS RECT, lpSourceRect AS RECT) AS LONG
DECLARE FUNCTION CountClipboardFormats LIB "USER32.DLL" ALIAS "CountClipboardFormats" () AS LONG
DECLARE FUNCTION CreateAcceleratorTable LIB "USER32.DLL" ALIAS "CreateAcceleratorTableA" (lpaccl AS ACCEL, BYVAL cEntries AS LONG) AS LONG
DECLARE FUNCTION CreateCaret LIB "USER32.DLL" ALIAS "CreateCaret" (BYVAL hwnd AS LONG, BYVAL hBitmap AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS LONG
DECLARE FUNCTION CreateCursor LIB "USER32.DLL" ALIAS "CreateCursor" (BYVAL hInstance AS LONG, BYVAL nXhotspot AS LONG, BYVAL nYhotspot AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, lpANDbitPlane AS ANY, lpXORbitPlane AS ANY) AS LONG
DECLARE FUNCTION CreateDesktop LIB "USER32.DLL" ALIAS "CreateDesktopA" (lpszDesktop AS ASCIIZ, lpszDevice AS ASCIIZ, pDevmode AS DEVMODE, BYVAL dwFlags AS LONG, BYVAL dwDesiredAccess AS LONG, lpsa AS SECURITY_ATTRIBUTES) AS LONG
DECLARE FUNCTION CreateDialogIndirectParam LIB "USER32.DLL" ALIAS "CreateDialogIndirectParamA" (BYVAL hInstance AS LONG, lpTemplate AS DLGTEMPLATE, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG, BYVAL dwInitParam AS LONG) AS LONG

$IF NOT %DEF(%pb_cc32)
FUNCTION CreateDialogIndirect (BYVAL hInstance AS LONG, lpTemplate AS DLGTEMPLATE, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG) AS LONG
  FUNCTION = CreateDialogIndirectParam(hInstance, lpTemplate, hWndParent, lpDialogFunc, %NULL)
END FUNCTION
$ENDIF

DECLARE FUNCTION CreateDialogParam LIB "USER32.DLL" ALIAS "CreateDialogParamA" (BYVAL hInstance AS LONG, lpName AS ASCIIZ, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG, BYVAL lParamInit AS LONG) AS LONG

$IF NOT %DEF(%pb_cc32)
FUNCTION CreateDialog (BYVAL hInstance AS LONG, lpName AS ASCIIZ, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG) AS LONG
  FUNCTION = CreateDialogParam(hInstance, lpName, hWndParent, lpDialogFunc, %NULL)
END FUNCTION
$ENDIF

DECLARE FUNCTION CreateIcon LIB "USER32.DLL" ALIAS "CreateIcon" (BYVAL hInstance AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL nPlanes AS BYTE, BYVAL nBitsPixel AS BYTE, lpANDbits AS BYTE, lpXORbits AS BYTE) AS LONG
DECLARE FUNCTION CreateIconFromResource LIB "USER32.DLL" ALIAS "CreateIconFromResource" (presbits AS BYTE, BYVAL dwResSize AS LONG, BYVAL fIcon AS LONG, BYVAL dwVer AS LONG) AS LONG
DECLARE FUNCTION CreateIconFromResource LIB "USER32.DLL" ALIAS "CreateIconFromResource" (presbits AS BYTE, BYVAL dwResSize AS LONG, BYVAL fIcon AS LONG, BYVAL dwVer AS LONG) AS LONG
DECLARE FUNCTION CreateIconIndirect LIB "USER32.DLL" ALIAS "CreateIconIndirect" (piconinfo AS ICONINFO) AS LONG
DECLARE FUNCTION CreateMDIWindow LIB "USER32.DLL" ALIAS "CreateMDIWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, _
                 BYVAL hWndParent AS LONG, BYVAL hInstance AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION CreateMenu LIB "USER32.DLL" ALIAS "CreateMenu" () AS LONG
DECLARE FUNCTION CreatePopupMenu LIB "USER32.DLL" ALIAS "CreatePopupMenu" () AS LONG

DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" _
   (BYVAL dwExStyle AS LONG, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS LONG, BYVAL hMenu AS LONG, BYVAL hInstance AS LONG, lpParam AS ANY) AS LONG

$IF NOT %DEF(%pb_cc32)
FUNCTION CreateWindow (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS LONG, BYVAL xx AS LONG, BYVAL yy AS LONG, BYVAL nWidth AS LONG, _
                       BYVAL nHeight AS LONG, BYVAL hWndParent AS LONG, BYVAL hMenu AS LONG, BYVAL hInstance AS LONG, BYVAL lpParam AS DWORD) AS LONG
  FUNCTION = CreateWindowEx(0, lpClassName, lpWindowName, dwStyle, xx, yy, nWidth, nHeight, hWndParent, hMenu, hInstance, BYVAL lpParam)
END FUNCTION
$ELSEIF %DEF(%CCWIN)
FUNCTION CreateWindow (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS LONG, BYVAL xx AS LONG, BYVAL yy AS LONG, BYVAL nWidth AS LONG, _
                       BYVAL nHeight AS LONG, BYVAL hWndParent AS LONG, BYVAL hMenu AS LONG, BYVAL hInstance AS LONG, BYVAL lpParam AS DWORD) AS LONG
  FUNCTION = CreateWindowEx(0, lpClassName, lpWindowName, dwStyle, xx, yy, nWidth, nHeight, hWndParent, hMenu, hInstance, BYVAL lpParam)
END FUNCTION
$ENDIF

DECLARE FUNCTION DdeAbandonTransaction LIB "USER32.DLL" ALIAS "DdeAbandonTransaction" (BYVAL idInst AS LONG, BYVAL hConv AS LONG, BYVAL idTransaction AS LONG) AS LONG
DECLARE FUNCTION DdeAccessData LIB "USER32.DLL" ALIAS "DdeAccessDataA" (BYVAL hData AS LONG, pcbDataSize AS LONG) AS LONG
DECLARE FUNCTION DdeAddData LIB "USER32.DLL" ALIAS "DdeAddDataA" (BYVAL hData AS LONG, pSrc AS BYTE, BYVAL cb AS LONG, BYVAL cbOff AS LONG) AS LONG
DECLARE FUNCTION DdeClientTransaction LIB "USER32.DLL" ALIAS "DdeClientTransaction" (pData AS BYTE, BYVAL cbData AS LONG, BYVAL hConv AS LONG, BYVAL hszItem AS LONG, BYVAL wFmt AS LONG, BYVAL wType AS LONG, BYVAL dwTimeout AS LONG, _
                 pdwResult AS LONG) AS LONG
DECLARE FUNCTION DdeCmpStringHandles LIB "USER32.DLL" ALIAS "DdeCmpStringHandles" (BYVAL hsz1 AS LONG, BYVAL hsz2 AS LONG) AS LONG
DECLARE FUNCTION DdeConnect LIB "USER32.DLL" ALIAS "DdeConnect" (BYVAL idInst AS LONG, BYVAL hszService AS LONG, BYVAL hszTopic AS LONG, pCC AS CONVCONTEXT) AS LONG
DECLARE FUNCTION DdeConnectList LIB "USER32.DLL" ALIAS "DdeConnectList" (BYVAL idInst AS LONG, BYVAL hszService AS LONG, BYVAL hszTopic AS LONG, BYVAL hConvList AS LONG, pCC AS CONVCONTEXT) AS LONG
DECLARE FUNCTION DdeCreateDataHandle LIB "USER32.DLL" ALIAS "DdeCreateDataHandle" (BYVAL idInst AS LONG, pSrc AS BYTE, BYVAL cb AS LONG, BYVAL cbOff AS LONG, BYVAL hszItem AS LONG, BYVAL wFmt AS LONG, BYVAL afCmd AS LONG) AS LONG
DECLARE FUNCTION DdeCreateStringHandle LIB "USER32.DLL" ALIAS "DdeCreateStringHandleA" (BYVAL idInst AS LONG, psz AS ASCIIZ, BYVAL iCodePage AS LONG) AS LONG
DECLARE FUNCTION DdeDisconnect LIB "USER32.DLL" ALIAS "DdeDisconnect" (BYVAL hConv AS LONG) AS LONG
DECLARE FUNCTION DdeDisconnectList LIB "USER32.DLL" ALIAS "DdeDisconnectList" (BYVAL hConvList AS LONG) AS LONG
DECLARE FUNCTION DdeEnableCallback LIB "USER32.DLL" ALIAS "DdeEnableCallback" (BYVAL idInst AS LONG, BYVAL hConv AS LONG, BYVAL wCmd AS LONG) AS LONG
DECLARE FUNCTION DdeFreeDataHandle LIB "USER32.DLL" ALIAS "DdeFreeDataHandle" (BYVAL hData AS LONG) AS LONG
DECLARE FUNCTION DdeFreeStringHandle LIB "USER32.DLL" ALIAS "DdeFreeStringHandle" (BYVAL idInst AS LONG, BYVAL hsz AS LONG) AS LONG
DECLARE FUNCTION DdeGetData LIB "USER32.DLL" ALIAS "DdeGetDataA" (BYVAL hData AS LONG, pDst AS BYTE, BYVAL cbMax AS LONG, BYVAL cbOff AS LONG) AS LONG
DECLARE FUNCTION DdeGetLastError LIB "USER32.DLL" ALIAS "DdeGetLastError" (BYVAL idInst AS LONG) AS LONG
DECLARE FUNCTION DdeImpersonateClient LIB "USER32.DLL" ALIAS "DdeImpersonateClient" (BYVAL hConv AS LONG) AS LONG
DECLARE FUNCTION DdeInitialize LIB "USER32.DLL" ALIAS "DdeInitializeA" (pidInst AS LONG, BYVAL pfnCallback AS LONG, BYVAL afCmd AS LONG, BYVAL ulRes AS LONG) AS LONG
DECLARE FUNCTION DdeKeepStringHandle LIB "USER32.DLL" ALIAS "DdeKeepStringHandle" (BYVAL idInst AS LONG, BYVAL hsz AS LONG) AS LONG
DECLARE FUNCTION DdeNameService LIB "USER32.DLL" ALIAS "DdeNameService" (BYVAL idInst AS LONG, BYVAL hsz1 AS LONG, BYVAL hsz2 AS LONG, BYVAL afCmd AS LONG) AS LONG
DECLARE FUNCTION DdePostAdvise LIB "USER32.DLL" ALIAS "DdePostAdvise" (BYVAL idInst AS LONG, BYVAL hszTopic AS LONG, BYVAL hszItem AS LONG) AS LONG
DECLARE FUNCTION DdeQueryConvInfo LIB "USER32.DLL" ALIAS "DdeQueryConvInfo" (BYVAL hConv AS LONG, BYVAL idTransaction AS LONG, pConvInfo AS CONVINFO) AS LONG
DECLARE FUNCTION DdeQueryNextServer LIB "USER32.DLL" ALIAS "DdeQueryNextServer" (BYVAL hConvList AS LONG, BYVAL hConvPrev AS LONG) AS LONG
DECLARE FUNCTION DdeQueryString LIB "USER32.DLL" ALIAS "DdeQueryStringA" (BYVAL idInst AS LONG, BYVAL hsz AS LONG, psz AS ASCIIZ, BYVAL cchMax AS LONG, BYVAL iCodePage AS LONG) AS LONG
DECLARE FUNCTION DdeReconnect LIB "USER32.DLL" ALIAS "DdeReconnect" (BYVAL hConv AS LONG) AS LONG
DECLARE FUNCTION DdeSetQualityOfService LIB "USER32.DLL" ALIAS "DdeSetQualityOfService" (BYVAL hWndClient AS LONG, pqosNew AS SECURITY_QUALITY_OF_SERVICE, pqosPrev AS SECURITY_QUALITY_OF_SERVICE) AS LONG
DECLARE FUNCTION DdeSetUserHandle LIB "USER32.DLL" ALIAS "DdeSetUserHandle" (BYVAL hConv AS LONG, BYVAL id AS LONG, BYVAL hUser AS LONG) AS LONG
DECLARE FUNCTION DdeUnaccessData LIB "USER32.DLL" ALIAS "DdeUnaccessDataA" (BYVAL hData AS LONG) AS LONG
DECLARE FUNCTION DdeUninitialize LIB "USER32.DLL" ALIAS "DdeUninitialize" (BYVAL idInst AS LONG) AS LONG
DECLARE FUNCTION DefDlgProc LIB "USER32.DLL" ALIAS "DefDlgProcA" (BYVAL hDlg AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DefFrameProc LIB "USER32.DLL" ALIAS "DefFrameProcA" (BYVAL hwnd AS LONG, BYVAL hWndMDIClient AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DefMDIChildProc LIB "USER32.DLL" ALIAS "DefMDIChildProcA" (BYVAL hwnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hwnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DeferWindowPos LIB "USER32.DLL" ALIAS "DeferWindowPos" (BYVAL hWinPosInfo AS LONG, BYVAL hwnd AS LONG, BYVAL hWndInsertAfter AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, _
                 BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION DeleteMenu LIB "USER32.DLL" ALIAS "DeleteMenu" (BYVAL hMenu AS LONG, BYVAL nPosition AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION DestroyAcceleratorTable LIB "USER32.DLL" ALIAS "DestroyAcceleratorTable" (BYVAL haccel AS LONG) AS LONG
DECLARE FUNCTION DestroyCaret LIB "USER32.DLL" ALIAS "DestroyCaret" () AS LONG
DECLARE FUNCTION DestroyCursor LIB "USER32.DLL" ALIAS "DestroyCursor" (BYVAL hCursor AS LONG) AS LONG
DECLARE FUNCTION DestroyIcon LIB "USER32.DLL" ALIAS "DestroyIcon" (BYVAL hIcon AS LONG) AS LONG
DECLARE FUNCTION DestroyMenu LIB "USER32.DLL" ALIAS "DestroyMenu" (BYVAL hMenu AS LONG) AS LONG
DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION DialogBoxParam LIB "USER32.DLL" ALIAS "DialogBoxParamA" (BYVAL hInstance AS LONG, lpTemplateName AS ASCIIZ, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG, BYVAL dwInitParam AS LONG) AS LONG

$IF NOT %DEF(%pb_cc32)
FUNCTION DialogBox (BYVAL hInstance AS LONG, lpTemplateName AS ASCIIZ, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG) AS LONG
  FUNCTION = DialogBoxParam(hInstance, lpTemplateName, hWndParent, lpDialogFunc, 0)
END FUNCTION
$ENDIF

DECLARE FUNCTION DialogBoxIndirectParam LIB "USER32.DLL" ALIAS "DialogBoxIndirectParamA" (BYVAL hInstance AS LONG, hDialogTemplate AS DLGTEMPLATE, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG, BYVAL dwInitParam AS LONG) AS LONG

$IF NOT %DEF(%pb_cc32)
FUNCTION DialogBoxIndirect(BYVAL hInstance AS LONG, hDialogTemplate AS DLGTEMPLATE, BYVAL hWndParent AS LONG, BYVAL lpDialogFunc AS LONG) AS LONG
  FUNCTION = DialogBoxIndirectParam(hInstance, hDialogTemplate, hWndParent, lpDialogFunc, 0)
END FUNCTION
$ENDIF

DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION DlgDirList LIB "USER32.DLL" ALIAS "DlgDirListA" (BYVAL hDlg AS LONG, lpPathSpec AS ASCIIZ, BYVAL nIDListBox AS LONG, BYVAL nIDStaticPath AS LONG, BYVAL wFileType AS LONG) AS LONG
DECLARE FUNCTION DlgDirListComboBox LIB "USER32.DLL" ALIAS "DlgDirListComboBoxA" (BYVAL hDlg AS LONG, lpPathSpec AS ASCIIZ, BYVAL nIDComboBox AS LONG, BYVAL nIDStaticPath AS LONG, BYVAL wFileType AS LONG) AS LONG
DECLARE FUNCTION DlgDirSelectComboBoxEx LIB "USER32.DLL" ALIAS "DlgDirSelectComboBoxExA" (BYVAL hWndDlg AS LONG, lpszPath AS ASCIIZ, BYVAL cbPath AS LONG, BYVAL idComboBox AS LONG) AS LONG
DECLARE FUNCTION DlgDirSelectEx LIB "USER32.DLL" ALIAS "DlgDirSelectExA" (BYVAL hWndDlg AS LONG, lpszPath AS ASCIIZ, BYVAL cbPath AS LONG, BYVAL idListBox AS LONG) AS LONG
DECLARE FUNCTION DragDetect LIB "USER32.DLL" ALIAS "DragDetect" (BYVAL hWnd AS LONG, pt AS POINTAPI) AS LONG
DECLARE FUNCTION DragObject LIB "USER32.DLL" ALIAS "DragObject" (BYVAL hWnd1 AS LONG, BYVAL hWnd2 AS LONG, BYVAL un AS LONG, BYVAL dw AS LONG, BYVAL hCursor AS LONG) AS LONG
DECLARE FUNCTION DrawAnimatedRects LIB "USER32.DLL" ALIAS "DrawAnimatedRects" (BYVAL hwnd AS LONG, BYVAL idAni AS LONG, lprcFrom AS Rect, lprcTo AS Rect) AS LONG
DECLARE FUNCTION DrawCaption LIB "USER32.DLL" ALIAS "DrawCaption" (BYVAL hWnd AS LONG, BYVAL hDC AS LONG, pcRect AS Rect, BYVAL un AS LONG) AS LONG
DECLARE FUNCTION DrawEdge LIB "USER32.DLL" ALIAS "DrawEdge" (BYVAL hdc AS LONG, qrc AS RECT, BYVAL edge AS LONG, BYVAL grfFlags AS LONG) AS LONG
DECLARE FUNCTION DrawFocusRect LIB "USER32.DLL" ALIAS "DrawFocusRect" (BYVAL hdc AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION DrawFrameControl LIB "USER32.DLL" ALIAS "DrawFrameControl" (BYVAL hDC AS LONG, lpRect AS RECT, BYVAL un1 AS LONG, BYVAL un2 AS LONG) AS LONG
DECLARE FUNCTION DrawIcon LIB "USER32.DLL" ALIAS "DrawIcon" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL hIcon AS LONG) AS LONG
DECLARE FUNCTION DrawIconEx LIB "USER32.DLL" ALIAS "DrawIconEx" (BYVAL hdc AS LONG, BYVAL xLeft AS LONG, BYVAL yTop AS LONG, BYVAL hIcon AS LONG, BYVAL cxWidth AS LONG, BYVAL cyWidth AS LONG, BYVAL istepIfAniCur AS LONG, _
                 BYVAL hbrFlickerFreeDraw AS LONG, BYVAL diFlags AS LONG) AS LONG
DECLARE FUNCTION DrawMenuBar LIB "USER32.DLL" ALIAS "DrawMenuBar" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION DrawState LIB "USER32.DLL" ALIAS "DrawStateA" (BYVAL hDC AS LONG, BYVAL hBrush AS LONG, BYVAL lpDrawStateProc AS LONG, BYVAL lParam AS LONG, BYVAL wParam AS LONG, BYVAL n1 AS LONG, BYVAL n2 AS LONG, BYVAL n3 AS LONG, _
                 BYVAL n4 AS LONG, BYVAL un AS LONG) AS LONG
DECLARE FUNCTION DrawText LIB "USER32.DLL" ALIAS "DrawTextA" (BYVAL hdc AS LONG, lpStr AS ASCIIZ, BYVAL nCount AS LONG, lpRect AS RECT, BYVAL wFormat AS LONG) AS LONG
DECLARE FUNCTION DrawTextEx LIB "USER32.DLL" ALIAS "DrawTextExA" (BYVAL hDC AS LONG, lpsz AS ASCIIZ, BYVAL n AS LONG, lpRect AS RECT, BYVAL un AS LONG, lpDrawTextParams AS DRAWTEXTPARAMS) AS LONG
DECLARE FUNCTION EmptyClipboard LIB "USER32.DLL" ALIAS "EmptyClipboard" () AS LONG
DECLARE FUNCTION EnableMenuItem LIB "USER32.DLL" ALIAS "EnableMenuItem" (BYVAL hMenu AS LONG, BYVAL wIDEnableItem AS LONG, BYVAL wEnable AS LONG) AS LONG
DECLARE FUNCTION EnableScrollBar LIB "USER32.DLL" ALIAS "EnableScrollBar" (BYVAL hwnd AS LONG, BYVAL wSBflags AS LONG, BYVAL wArrows AS LONG) AS LONG
DECLARE FUNCTION EnableWindow LIB "USER32.DLL" ALIAS "EnableWindow" (BYVAL hwnd AS LONG, BYVAL fEnable AS LONG) AS LONG
DECLARE FUNCTION EndDeferWindowPos LIB "USER32.DLL" ALIAS "EndDeferWindowPos" (BYVAL hWinPosInfo AS LONG) AS LONG
DECLARE FUNCTION EndDialog LIB "USER32.DLL" ALIAS "EndDialog" (BYVAL hDlg AS LONG, BYVAL nResult AS LONG) AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hwnd AS LONG, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION EnumChildWindows LIB "USER32.DLL" ALIAS "EnumChildWindows" (BYVAL hWndParent AS LONG, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumClipboardFormats LIB "USER32.DLL" ALIAS "EnumClipboardFormats" (BYVAL wFormat AS LONG) AS LONG
DECLARE FUNCTION EnumDesktopWindows LIB "USER32.DLL" ALIAS "EnumDesktopWindows" (BYVAL hDesktop AS LONG, BYVAL lpfn AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumDesktops LIB "USER32.DLL" ALIAS "EnumDesktopsA" (BYVAL hwinsta AS LONG, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumProps LIB "USER32.DLL" ALIAS "EnumPropsA" (BYVAL hWnd AS LONG, BYVAL lpEnumFunc AS LONG) AS LONG
DECLARE FUNCTION EnumPropsEx LIB "USER32.DLL" ALIAS "EnumPropsExA" (BYVAL hWnd AS LONG, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumThreadWindows LIB "USER32.DLL" ALIAS "EnumThreadWindows" (BYVAL dwThreadId AS LONG, BYVAL lpfn AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumWindows LIB "USER32.DLL" ALIAS "EnumWindows" (BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumWindowStations LIB "USER32.DLL" ALIAS "EnumWindowStationsA" (BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EqualRect LIB "USER32.DLL" ALIAS "EqualRect" (lpRect1 AS RECT, lpRect2 AS RECT) AS LONG
DECLARE FUNCTION ExcludeUpdateRgn LIB "USER32.DLL" ALIAS "ExcludeUpdateRgn" (BYVAL hdc AS LONG, BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION ExitWindows LIB "USER32.DLL" ALIAS "ExitWindows" (BYVAL dwReserved AS LONG, BYVAL uReturnCode AS LONG) AS LONG
DECLARE FUNCTION ExitWindowsEx LIB "USER32.DLL" ALIAS "ExitWindowsEx" (BYVAL uFlags AS LONG, BYVAL dwReserved AS LONG) AS LONG
DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" (BYVAL hdc AS LONG, lpRect AS RECT, BYVAL hBrush AS LONG) AS LONG
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION FindWindowEx LIB "USER32.DLL" ALIAS "FindWindowExA" (BYVAL hWnd1 AS LONG, BYVAL hWnd2 AS LONG, lpsz1 AS ASCIIZ, lpsz2 AS ASCIIZ) AS LONG
DECLARE FUNCTION FlashWindow LIB "USER32.DLL" ALIAS "FlashWindow" (BYVAL hwnd AS LONG, BYVAL bInvert AS LONG) AS LONG
DECLARE FUNCTION FrameRect LIB "USER32.DLL" ALIAS "FrameRect" (BYVAL hdc AS LONG, lpRect AS RECT, BYVAL hBrush AS LONG) AS LONG
DECLARE FUNCTION FreeDDElParam LIB "USER32.DLL" ALIAS "FreeDDElParam" (BYVAL msg AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION GetActiveWindow LIB "USER32.DLL" ALIAS "GetActiveWindow" () AS LONG
DECLARE FUNCTION GetAsyncKeyState LIB "USER32.DLL" ALIAS "GetAsyncKeyState" (BYVAL vKey AS LONG) AS LONG
DECLARE FUNCTION GetCapture LIB "USER32.DLL" ALIAS "GetCapture" () AS LONG
DECLARE FUNCTION GetCaretBlinkTime LIB "USER32.DLL" ALIAS "GetCaretBlinkTime" () AS LONG
DECLARE FUNCTION GetCaretPos LIB "USER32.DLL" ALIAS "GetCaretPos" (lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetClassInfo LIB "USER32.DLL" ALIAS "GetClassInfoA" (BYVAL hInstance AS LONG, lpClassName AS ASCIIZ, lpWndClass AS WNDCLASS) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hWnd AS LONG, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClassLong LIB "USER32.DLL" ALIAS "GetClassLongA" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetClassName LIB "USER32.DLL" ALIAS "GetClassNameA" (BYVAL hwnd AS LONG, lpClassName AS ASCIIZ, BYVAL nMaxCount AS LONG) AS LONG
DECLARE FUNCTION GetClassWord LIB "USER32.DLL" ALIAS "GetClassWord" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetClipCursor LIB "USER32.DLL" ALIAS "GetClipCursor" (lprc AS RECT) AS LONG
DECLARE FUNCTION GetClipboardData LIB "USER32.DLL" ALIAS "GetClipboardData" (BYVAL wFormat AS LONG) AS LONG
DECLARE FUNCTION GetClipboardFormatName LIB "USER32.DLL" ALIAS "GetClipboardFormatNameA" (BYVAL wFormat AS LONG, lpString AS ASCIIZ, BYVAL nMaxCount AS LONG) AS LONG
DECLARE FUNCTION GetClipboardOwner LIB "USER32.DLL" ALIAS "GetClipboardOwner" () AS LONG
DECLARE FUNCTION GetClipboardViewer LIB "USER32.DLL" ALIAS "GetClipboardViewer" () AS LONG
DECLARE FUNCTION GetCursor LIB "USER32.DLL" ALIAS "GetCursor" () AS LONG
DECLARE FUNCTION GetCursorPos LIB "USER32.DLL" ALIAS "GetCursorPos" (lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetDCEx LIB "USER32.DLL" ALIAS "GetDCEx" (BYVAL hwnd AS LONG, BYVAL hrgnclip AS LONG, BYVAL fdwOptions AS LONG) AS LONG
DECLARE FUNCTION GetDesktopWindow LIB "USER32.DLL" ALIAS "GetDesktopWindow" () AS LONG
DECLARE FUNCTION GetDialogBaseUnits LIB "USER32.DLL" ALIAS "GetDialogBaseUnits" () AS LONG
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS LONG, BYVAL nIDDlgItem AS LONG) AS LONG
DECLARE FUNCTION GetDlgItemInt LIB "USER32.DLL" ALIAS "GetDlgItemInt" (BYVAL hDlg AS LONG, BYVAL nIDDlgItem AS LONG, BYVAL lpTranslated AS LONG, BYVAL bSigned AS LONG) AS LONG
DECLARE FUNCTION GetDlgItemText LIB "USER32.DLL" ALIAS "GetDlgItemTextA" (BYVAL hDlg AS LONG, BYVAL nIDDlgItem AS LONG, lpString AS ASCIIZ, BYVAL nMaxCount AS LONG) AS LONG
DECLARE FUNCTION GetDoubleClickTime LIB "USER32.DLL" ALIAS "GetDoubleClickTime" () AS LONG
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS LONG
DECLARE FUNCTION GetForegroundWindow LIB "USER32.DLL" ALIAS "GetForegroundWindow" () AS LONG
DECLARE FUNCTION GetIconInfo LIB "USER32.DLL" ALIAS "GetIconInfo" (BYVAL hIcon AS LONG, piconinfo AS ICONINFO) AS LONG
DECLARE FUNCTION GetInputState LIB "USER32.DLL" ALIAS "GetInputState" () AS LONG
DECLARE FUNCTION GetKBCodePage LIB "USER32.DLL" ALIAS "GetKBCodePage" () AS LONG
DECLARE FUNCTION GetKeyNameText LIB "USER32.DLL" ALIAS "GetKeyNameTextA" (BYVAL lParam AS LONG, lpBuffer AS ASCIIZ, BYVAL nSize AS LONG) AS LONG
DECLARE FUNCTION GetKeyState LIB "USER32.DLL" ALIAS "GetKeyState" (BYVAL nVirtKey AS LONG) AS LONG
DECLARE FUNCTION GetKeyboardLayout LIB "USER32.DLL" ALIAS "GetKeyboardLayout" (BYVAL dwLayout AS LONG) AS LONG
DECLARE FUNCTION GetKeyboardLayoutList LIB "USER32.DLL" ALIAS "GetKeyboardLayoutList" (BYVAL nBuff AS LONG, lpList AS LONG) AS LONG
DECLARE FUNCTION GetKeyboardLayoutName LIB "USER32.DLL" ALIAS "GetKeyboardLayoutNameA" (pwszKLID AS ASCIIZ) AS LONG
DECLARE FUNCTION GetKeyboardState LIB "USER32.DLL" ALIAS "GetKeyboardState" (pbKeyState AS BYTE) AS LONG
DECLARE FUNCTION GetKeyboardType LIB "USER32.DLL" ALIAS "GetKeyboardType" (BYVAL nTypeFlag AS LONG) AS LONG
DECLARE FUNCTION GetLastActivePopup LIB "USER32.DLL" ALIAS "GetLastActivePopup" (BYVAL hwndOwnder AS LONG) AS LONG
DECLARE FUNCTION GetMenu LIB "USER32.DLL" ALIAS "GetMenu" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetMenuCheckMarkDimensions LIB "USER32.DLL" ALIAS "GetMenuCheckMarkDimensions" () AS LONG
DECLARE FUNCTION GetMenuContextHelpId LIB "USER32.DLL" ALIAS "GetMenuContextHelpId" (BYVAL hMenu AS LONG) AS LONG
DECLARE FUNCTION GetMenuDefaultItem LIB "USER32.DLL" ALIAS "GetMenuDefaultItem" (BYVAL hMenu AS LONG, BYVAL fByPos AS LONG, BYVAL gmdiFlags AS LONG) AS LONG
DECLARE FUNCTION GetMenuItemCount LIB "USER32.DLL" ALIAS "GetMenuItemCount" (BYVAL hMenu AS LONG) AS LONG
DECLARE FUNCTION GetMenuItemID LIB "USER32.DLL" ALIAS "GetMenuItemID" (BYVAL hMenu AS LONG, BYVAL nPos AS LONG) AS LONG
DECLARE FUNCTION GetMenuItemInfo LIB "USER32.DLL" ALIAS "GetMenuItemInfoA" (BYVAL hMenu AS LONG, BYVAL un AS LONG, BYVAL b AS LONG, lpMenuItemInfo AS MENUITEMINFO) AS LONG
DECLARE FUNCTION GetMenuItemRect LIB "USER32.DLL" ALIAS "GetMenuItemRect" (BYVAL hWnd AS LONG, BYVAL hMenu AS LONG, BYVAL uItem AS LONG, lprcItem AS RECT) AS LONG
DECLARE FUNCTION GetMenuState LIB "USER32.DLL" ALIAS "GetMenuState" (BYVAL hMenu AS LONG, BYVAL wID AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION GetMenuString LIB "USER32.DLL" ALIAS "GetMenuStringA" (BYVAL hMenu AS LONG, BYVAL wIDItem AS LONG, lpString AS ASCIIZ, BYVAL nMaxCount AS LONG, BYVAL wFlag AS LONG) AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hwnd AS LONG, BYVAL wMsgFilterMin AS LONG, BYVAL wMsgFilterMax AS LONG) AS LONG
DECLARE FUNCTION GetMessageExtraInfo LIB "USER32.DLL" ALIAS "GetMessageExtraInfo" () AS LONG
DECLARE FUNCTION GetMessagePos LIB "USER32.DLL" ALIAS "GetMessagePos" () AS LONG
DECLARE FUNCTION GetMessageTime LIB "USER32.DLL" ALIAS "GetMessageTime" () AS LONG
DECLARE FUNCTION GetNextDlgGroupItem LIB "USER32.DLL" ALIAS "GetNextDlgGroupItem" (BYVAL hDlg AS LONG, BYVAL hCtl AS LONG, BYVAL bPrevious AS LONG) AS LONG
DECLARE FUNCTION GetNextDlgTabItem LIB "USER32.DLL" ALIAS "GetNextDlgTabItem" (BYVAL hDlg AS LONG, BYVAL hCtl AS LONG, BYVAL bPrevious AS LONG) AS LONG
DECLARE FUNCTION GetNextWindow LIB "USER32.DLL" ALIAS "GetNextWindow" (BYVAL hwnd AS LONG, BYVAL wFlag AS LONG) AS LONG
DECLARE FUNCTION GetOpenClipboardWindow LIB "USER32.DLL" ALIAS "GetOpenClipboardWindow" () AS LONG
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetPriorityClipboardFormat LIB "USER32.DLL" ALIAS "GetPriorityClipboardFormat" (lpPriorityList AS LONG, BYVAL nCount AS LONG) AS LONG
DECLARE FUNCTION GetProcessWindowStation LIB "USER32.DLL" ALIAS "GetProcessWindowStation" () AS LONG
DECLARE FUNCTION GetProp LIB "USER32.DLL" ALIAS "GetPropA" (BYVAL hwnd AS LONG, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION GetQueueStatus LIB "USER32.DLL" ALIAS "GetQueueStatus" (BYVAL fuFlags AS LONG) AS LONG
DECLARE FUNCTION GetScrollInfo LIB "USER32.DLL" ALIAS "GetScrollInfo" (BYVAL hWnd AS LONG, BYVAL n AS LONG, lpScrollInfo AS SCROLLINFO) AS LONG
DECLARE FUNCTION GetScrollPos LIB "USER32.DLL" ALIAS "GetScrollPos" (BYVAL hwnd AS LONG, BYVAL nBar AS LONG) AS LONG
DECLARE FUNCTION GetScrollRange LIB "USER32.DLL" ALIAS "GetScrollRange" (BYVAL hwnd AS LONG, BYVAL nBar AS LONG, lpMinPos AS LONG, lpMaxPos AS LONG) AS LONG
DECLARE FUNCTION GetSubMenu LIB "USER32.DLL" ALIAS "GetSubMenu" (BYVAL hMenu AS LONG, BYVAL nPos AS LONG) AS LONG
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSysColorBrush LIB "USER32.DLL" ALIAS "GetSysColorBrush" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSystemMenu LIB "USER32.DLL" ALIAS "GetSystemMenu" (BYVAL hwnd AS LONG, BYVAL bRevert AS LONG) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetTabbedTextExtent LIB "USER32.DLL" ALIAS "GetTabbedTextExtentA" (BYVAL hdc AS LONG, lpString AS ASCIIZ, BYVAL nCount AS LONG, BYVAL nTabPositions AS LONG, lpnTabStopPositions AS LONG) AS LONG
DECLARE FUNCTION GetThreadDesktop LIB "USER32.DLL" ALIAS "GetThreadDesktop" (BYVAL dwThread AS LONG) AS LONG
DECLARE FUNCTION GetTopWindow LIB "USER32.DLL" ALIAS "GetTopWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetUpdateRect LIB "USER32.DLL" ALIAS "GetUpdateRect" (BYVAL hwnd AS LONG, lpRect AS RECT, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION GetUpdateRgn LIB "USER32.DLL" ALIAS "GetUpdateRgn" (BYVAL hwnd AS LONG, BYVAL hRgn AS LONG, BYVAL fErase AS LONG) AS LONG
DECLARE FUNCTION GetUserObjectInformation LIB "USER32.DLL" ALIAS "GetUserObjectInformationA" (BYVAL hObj AS LONG, BYVAL nIndex AS LONG, pvInfo AS ANY, BYVAL nLength AS LONG, lpnLengthNeeded AS LONG) AS LONG
DECLARE FUNCTION GetUserObjectSecurity LIB "USER32.DLL" ALIAS "GetUserObjectSecurity" (BYVAL hObj AS LONG, pSIRequested AS LONG, pSd AS SECURITY_DESCRIPTOR, BYVAL nLength AS LONG, lpnLengthNeeded AS LONG) AS LONG
DECLARE FUNCTION GetWindow LIB "USER32.DLL" ALIAS "GetWindow" (BYVAL hwnd AS LONG, BYVAL wCmd AS LONG) AS LONG
DECLARE FUNCTION GetWindowContextHelpId LIB "USER32.DLL" ALIAS "GetWindowContextHelpId" (BYVAL hWnd AS LONG) AS LONG
DECLARE FUNCTION GetWindowDC LIB "USER32.DLL" ALIAS "GetWindowDC" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetWindowLong LIB "USER32.DLL" ALIAS "GetWindowLongA" (BYVAL hWnd AS LONG, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowPlacement LIB "USER32.DLL" ALIAS "GetWindowPlacement" (BYVAL hwnd AS LONG, lpwndpl AS WINDOWPLACEMENT) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hwnd AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetWindowRgn LIB "USER32.DLL" ALIAS "GetWindowRgn" (BYVAL hWnd AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hwnd AS LONG, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION GetWindowTextLength LIB "USER32.DLL" ALIAS "GetWindowTextLengthA" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION GetWindowThreadProcessId LIB "USER32.DLL" ALIAS "GetWindowThreadProcessId" (BYVAL hwnd AS LONG, lpdwProcessId AS LONG) AS LONG
DECLARE FUNCTION GetWindowWord LIB "USER32.DLL" ALIAS "GetWindowWord" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GrayString LIB "USER32.DLL" ALIAS "GrayStringA" (BYVAL hDC AS LONG, BYVAL hBrush AS LONG, BYVAL lpOutputFunc AS LONG, BYVAL lpData AS LONG, BYVAL nCount AS LONG, BYVAL X AS LONG, BYVAL Y AS LONG, BYVAL nWidth AS LONG, _
                 BYVAL nHeight AS LONG) AS LONG
DECLARE FUNCTION HideCaret LIB "USER32.DLL" ALIAS "HideCaret" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION HiliteMenuItem LIB "USER32.DLL" ALIAS "HiliteMenuItem" (BYVAL hwnd AS LONG, BYVAL hMenu AS LONG, BYVAL wIDHiliteItem AS LONG, BYVAL wHilite AS LONG) AS LONG
DECLARE FUNCTION ImpersonateDdeClientWindow LIB "USER32.DLL" ALIAS "ImpersonateDdeClientWindow" (BYVAL hWndClient AS LONG, BYVAL hWndServer AS LONG) AS LONG
DECLARE FUNCTION InSendMessage LIB "USER32.DLL" ALIAS "InSendMessage" () AS LONG
DECLARE FUNCTION InflateRect LIB "USER32.DLL" ALIAS "InflateRect" (lpRect AS RECT, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION InsertMenu LIB "USER32.DLL" ALIAS "InsertMenuA" (BYVAL hMenu AS LONG, BYVAL nPosition AS LONG, BYVAL wFlags AS LONG, BYVAL wIDNewItem AS LONG, lpNewItem AS ASCIIZ) AS LONG
DECLARE FUNCTION InsertMenuItem LIB "USER32.DLL" ALIAS "InsertMenuItemA" (BYVAL hMenu AS LONG, BYVAL un AS LONG, BYVAL bool AS LONG, lpcMenuItemInfo AS MENUITEMINFO) AS LONG
DECLARE FUNCTION IntersectRect LIB "USER32.DLL" ALIAS "IntersectRect" (lpDestRect AS RECT, lpSrc1Rect AS RECT, lpSrc2Rect AS RECT) AS LONG
DECLARE FUNCTION InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" (BYVAL hwnd AS LONG, lpRect AS RECT, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION InvalidateRgn LIB "USER32.DLL" ALIAS "InvalidateRgn" (BYVAL hwnd AS LONG, BYVAL hRgn AS LONG, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION InvertRect LIB "USER32.DLL" ALIAS "InvertRect" (BYVAL hdc AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION IsCharAlpha LIB "USER32.DLL" ALIAS "IsCharAlphaA" (BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION IsCharAlphaNumeric LIB "USER32.DLL" ALIAS "IsCharAlphaNumericA" (BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION IsCharLower LIB "USER32.DLL" ALIAS "IsCharLowerA" (BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION IsCharUpper LIB "USER32.DLL" ALIAS "IsCharUpperA" (BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION IsChild LIB "USER32.DLL" ALIAS "IsChild" (BYVAL hWndParent AS LONG, BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION IsClipboardFormatAvailable LIB "USER32.DLL" ALIAS "IsClipboardFormatAvailable" (BYVAL wFormat AS LONG) AS LONG
DECLARE FUNCTION IsDialogMessage LIB "USER32.DLL" ALIAS "IsDialogMessageA" (BYVAL hDlg AS LONG, lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION IsDlgButtonChecked LIB "USER32.DLL" ALIAS "IsDlgButtonChecked" (BYVAL hDlg AS LONG, BYVAL nIDButton AS LONG) AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION IsMenu LIB "USER32.DLL" ALIAS "IsMenu" (BYVAL hMenu AS LONG) AS LONG
DECLARE FUNCTION IsRectEmpty LIB "USER32.DLL" ALIAS "IsRectEmpty" (lpRect AS RECT) AS LONG
DECLARE FUNCTION IsWindow LIB "USER32.DLL" ALIAS "IsWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION IsWindowEnabled LIB "USER32.DLL" ALIAS "IsWindowEnabled" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION IsWindowUnicode LIB "USER32.DLL" ALIAS "IsWindowUnicode" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION IsZoomed LIB "USER32.DLL" ALIAS "IsZoomed" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (BYVAL hwnd AS LONG, BYVAL nIDEvent AS LONG) AS LONG
DECLARE FUNCTION LoadAccelerators LIB "USER32.DLL" ALIAS "LoadAcceleratorsA" (BYVAL hInstance AS LONG, lpTableName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadBitmap LIB "USER32.DLL" ALIAS "LoadBitmapA" (BYVAL hInstance AS LONG, lpBitmapName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS LONG, lpCursorName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadCursorFromFile LIB "USER32.DLL" ALIAS "LoadCursorFromFileA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS LONG, lpIconName AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadImage LIB "USER32.DLL" ALIAS "LoadImageA" (BYVAL hInst AS LONG, lpsz AS ASCIIZ, BYVAL un1 AS LONG, BYVAL n1 AS LONG, BYVAL n2 AS LONG, BYVAL un2 AS LONG) AS LONG
DECLARE FUNCTION LoadKeyboardLayout LIB "USER32.DLL" ALIAS "LoadKeyboardLayoutA" (pwszKLID AS ASCIIZ, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION LoadMenu LIB "USER32.DLL" ALIAS "LoadMenuA" (BYVAL hInstance AS LONG, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION LoadMenuIndirect LIB "USER32.DLL" ALIAS "LoadMenuIndirectA" (BYVAL lpMenuTemplate AS LONG) AS LONG
DECLARE FUNCTION LoadString LIB "USER32.DLL" ALIAS "LoadStringA" (BYVAL hInstance AS LONG, BYVAL wID AS LONG, lpBuffer AS ASCIIZ, BYVAL nBufferMax AS LONG) AS LONG
DECLARE FUNCTION LockWindowUpdate LIB "USER32.DLL" ALIAS "LockWindowUpdate" (BYVAL hwndLock AS LONG) AS LONG
DECLARE FUNCTION LookupIconIdFromDirectory LIB "USER32.DLL" ALIAS "LookupIconIdFromDirectory" (presbits AS BYTE, BYVAL fIcon AS LONG) AS LONG
DECLARE FUNCTION LookupIconIdFromDirectoryEx LIB "USER32.DLL" ALIAS "LookupIconIdFromDirectoryEx" (presbits AS BYTE, BYVAL fIcon AS LONG, BYVAL cxDesired AS LONG, BYVAL cyDesired AS LONG, BYVAL Flags AS LONG) AS LONG
DECLARE FUNCTION MapDialogRect LIB "USER32.DLL" ALIAS "MapDialogRect" (BYVAL hDlg AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION MapVirtualKey LIB "USER32.DLL" ALIAS "MapVirtualKeyA" (BYVAL wCode AS LONG, BYVAL wMapType AS LONG) AS LONG
DECLARE FUNCTION MapVirtualKeyEx LIB "USER32.DLL" ALIAS "MapVirtualKeyExA" (BYVAL uCode AS LONG, BYVAL uMapType AS LONG, BYVAL dwhkl AS LONG) AS LONG
DECLARE FUNCTION MapWindowPoints LIB "USER32.DLL" ALIAS "MapWindowPoints" (BYVAL hwndFrom AS LONG, BYVAL hwndTo AS LONG, lppt AS ANY, BYVAL cPoints AS LONG) AS LONG
DECLARE FUNCTION MenuItemFromPoint LIB "USER32.DLL" ALIAS "MenuItemFromPoint" (BYVAL hWnd AS LONG, BYVAL hMenu AS LONG, ptScreen AS POINTAPI) AS LONG
DECLARE FUNCTION MessageBeep LIB "USER32.DLL" ALIAS "MessageBeep" (BYVAL wType AS LONG) AS LONG
DECLARE FUNCTION MessageBox LIB "USER32.DLL" ALIAS "MessageBoxA" (BYVAL hwnd AS LONG, lpText AS ASCIIZ, lpCaption AS ASCIIZ, BYVAL wType AS LONG) AS LONG
DECLARE FUNCTION MessageBoxEx LIB "USER32.DLL" ALIAS "MessageBoxExA" (BYVAL hwnd AS LONG, lpText AS ASCIIZ, lpCaption AS ASCIIZ, BYVAL uType AS LONG, BYVAL wLanguageId AS LONG) AS LONG
DECLARE FUNCTION MessageBoxIndirect LIB "USER32.DLL" ALIAS "MessageBoxIndirectA" (lpMsgBoxParams AS MSGBOXPARAMS) AS LONG
DECLARE FUNCTION ModifyMenu LIB "USER32.DLL" ALIAS "ModifyMenuA" (BYVAL hMenu AS LONG, BYVAL nPosition AS LONG, BYVAL wFlags AS LONG, BYVAL wIDNewItem AS LONG, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hwnd AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION MsgWaitForMultipleObjects LIB "USER32.DLL" ALIAS "MsgWaitForMultipleObjects" (BYVAL nCount AS LONG, pHandles AS LONG, BYVAL fWaitAll AS LONG, BYVAL dwMilliseconds AS LONG, BYVAL dwWakeMask AS LONG) AS LONG
DECLARE FUNCTION OemKeyScan LIB "USER32.DLL" ALIAS "OemKeyScan" (BYVAL wOemChar AS LONG) AS LONG
DECLARE FUNCTION OemToChar LIB "USER32.DLL" ALIAS "OemToCharA" (lpszSrc AS ASCIIZ, lpszDst AS ASCIIZ) AS LONG
DECLARE FUNCTION OemToCharBuff LIB "USER32.DLL" ALIAS "OemToCharBuffA" (lpszSrc AS ASCIIZ, lpszDst AS ASCIIZ, BYVAL cchDstLength AS LONG) AS LONG
DECLARE FUNCTION OffsetRect LIB "USER32.DLL" ALIAS "OffsetRect" (lpRect AS RECT, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION OpenClipboard LIB "USER32.DLL" ALIAS "OpenClipboard" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION OpenDesktop LIB "USER32.DLL" ALIAS "OpenDesktopA" (lpszDesktop AS ASCIIZ, BYVAL dwFlags AS LONG, BYVAL fInherit AS LONG, BYVAL dwDesiredAccess AS LONG) AS LONG
DECLARE FUNCTION OpenIcon LIB "USER32.DLL" ALIAS "OpenIcon" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION OpenInputDesktop LIB "USER32.DLL" ALIAS "OpenInputDesktop" (BYVAL dwFlags AS LONG, BYVAL fInherit AS LONG, BYVAL dwDesiredAccess AS LONG) AS LONG
DECLARE FUNCTION OpenWindowStation LIB "USER32.DLL" ALIAS "OpenWindowStationA" (lpszWinSta AS ASCIIZ, BYVAL fInherit AS LONG, BYVAL dwDesiredAccess AS LONG) AS LONG
DECLARE FUNCTION PackDDElParam LIB "USER32.DLL" ALIAS "PackDDElParam" (BYVAL msg AS LONG, BYVAL uiLo AS LONG, BYVAL uiHi AS LONG) AS LONG
DECLARE FUNCTION PaintDesktop LIB "USER32.DLL" ALIAS "PaintDesktop" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hwnd AS LONG, BYVAL wMsgFilterMin AS LONG, BYVAL wMsgFilterMax AS LONG, BYVAL wRemoveMsg AS LONG) AS LONG
DECLARE FUNCTION PostMessage LIB "USER32.DLL" ALIAS "PostMessageA" (BYVAL hwnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION PostThreadMessage LIB "USER32.DLL" ALIAS "PostThreadMessageA" (BYVAL idThread AS LONG, BYVAL msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION PtInRect LIB "USER32.DLL" ALIAS "PtInRect" (lpRect AS RECT, BYVAL ptx AS LONG, BYVAL pty AS LONG) AS LONG
DECLARE FUNCTION RedrawWindow LIB "USER32.DLL" ALIAS "RedrawWindow" (BYVAL hwnd AS LONG, lprcUpdate AS RECT, BYVAL hrgnUpdate AS LONG, BYVAL fuRedraw AS LONG) AS LONG
DECLARE FUNCTION RegisterClass LIB "USER32.DLL" ALIAS "RegisterClassA" (pcWndClass AS WNDCLASS) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS LONG
DECLARE FUNCTION RegisterClipboardFormat LIB "USER32.DLL" ALIAS "RegisterClipboardFormatA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION RegisterHotKey LIB "USER32.DLL" ALIAS "RegisterHotKey" (BYVAL hwnd AS LONG, BYVAL id AS LONG, BYVAL fsModifiers AS LONG, BYVAL vk AS LONG) AS LONG
DECLARE FUNCTION RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION ReleaseCapture LIB "USER32.DLL" ALIAS "ReleaseCapture" () AS LONG
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hwnd AS LONG, BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION RemoveMenu LIB "USER32.DLL" ALIAS "RemoveMenu" (BYVAL hMenu AS LONG, BYVAL nPosition AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION RemoveProp LIB "USER32.DLL" ALIAS "RemovePropA" (BYVAL hwnd AS LONG, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION ReplyMessage LIB "USER32.DLL" ALIAS "ReplyMessage" (BYVAL lReply AS LONG) AS LONG
DECLARE FUNCTION ReuseDDElParam LIB "USER32.DLL" ALIAS "ReuseDDElParam" (BYVAL lParam AS LONG, BYVAL msgIn AS LONG, BYVAL msgOut AS LONG, BYVAL uiLo AS LONG, BYVAL uiHi AS LONG) AS LONG
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hwnd AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION ScrollDC LIB "USER32.DLL" ALIAS "ScrollDC" (BYVAL hdc AS LONG, BYVAL dx AS LONG, BYVAL dy AS LONG, lprcScroll AS RECT, lprcClip AS RECT, BYVAL hrgnUpdate AS LONG, lprcUpdate AS RECT) AS LONG
DECLARE FUNCTION ScrollWindow LIB "USER32.DLL" ALIAS "ScrollWindow" (BYVAL hWnd AS LONG, BYVAL XAmount AS LONG, BYVAL YAmount AS LONG, lpRect AS RECT, lpClipRect AS RECT) AS LONG
DECLARE FUNCTION ScrollWindowEx LIB "USER32.DLL" ALIAS "ScrollWindowEx" (BYVAL hwnd AS LONG, BYVAL dx AS LONG, BYVAL dy AS LONG, lprcScroll AS RECT, lprcClip AS RECT, BYVAL hrgnUpdate AS LONG, lprcUpdate AS RECT, BYVAL fuScroll AS LONG) AS LONG
DECLARE FUNCTION SendDlgItemMessage LIB "USER32.DLL" ALIAS "SendDlgItemMessageA" (BYVAL hDlg AS LONG, BYVAL nIDDlgItem AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hwnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SendMessageCallback LIB "USER32.DLL" ALIAS "SendMessageCallbackA" (BYVAL hwnd AS LONG, BYVAL msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG, BYVAL lpResultCallBack AS LONG, BYVAL dwData AS LONG) AS LONG
DECLARE FUNCTION SendMessageTimeout LIB "USER32.DLL" ALIAS "SendMessageTimeoutA" (BYVAL hwnd AS LONG, BYVAL msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG, BYVAL fuFlags AS LONG, BYVAL uTimeout AS LONG, lpdwResult AS LONG) AS LONG
DECLARE FUNCTION SendNotifyMessage LIB "USER32.DLL" ALIAS "SendNotifyMessageA" (BYVAL hwnd AS LONG, BYVAL msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetActiveWindow LIB "USER32.DLL" ALIAS "SetActiveWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION SetCapture LIB "USER32.DLL" ALIAS "SetCapture" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION SetCaretBlinkTime LIB "USER32.DLL" ALIAS "SetCaretBlinkTime" (BYVAL wMSeconds AS LONG) AS LONG
DECLARE FUNCTION SetCaretPos LIB "USER32.DLL" ALIAS "SetCaretPos" (BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION SetClassLong LIB "USER32.DLL" ALIAS "SetClassLongA" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG, BYVAL dwNewLong AS LONG) AS LONG
DECLARE FUNCTION SetClassWord LIB "USER32.DLL" ALIAS "SetClassWord" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG, BYVAL wNewWord AS LONG) AS LONG
DECLARE FUNCTION SetClipboardData LIB "USER32.DLL" ALIAS "SetClipboardData" (BYVAL wFormat AS LONG, BYVAL hMem AS LONG) AS LONG
DECLARE FUNCTION SetClipboardViewer LIB "USER32.DLL" ALIAS "SetClipboardViewer" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION SetCursor LIB "USER32.DLL" ALIAS "SetCursor" (BYVAL hCursor AS LONG) AS LONG
DECLARE FUNCTION SetCursorPos LIB "USER32.DLL" ALIAS "SetCursorPos" (BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE FUNCTION SetDlgItemInt LIB "USER32.DLL" ALIAS "SetDlgItemInt" (BYVAL hDlg AS LONG, BYVAL nIDDlgItem AS LONG, BYVAL wValue AS LONG, BYVAL bSigned AS LONG) AS LONG
DECLARE FUNCTION SetDlgItemText LIB "USER32.DLL" ALIAS "SetDlgItemTextA" (BYVAL hDlg AS LONG, BYVAL nIDDlgItem AS LONG, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION SetDoubleClickTime LIB "USER32.DLL" ALIAS "SetDoubleClickTime" (BYVAL wCount AS LONG) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION SetKeyboardState LIB "USER32.DLL" ALIAS "SetKeyboardState" (lppbKeyState AS BYTE) AS LONG
DECLARE FUNCTION SetMenu LIB "USER32.DLL" ALIAS "SetMenu" (BYVAL hwnd AS LONG, BYVAL hMenu AS LONG) AS LONG
DECLARE FUNCTION SetMenuContextHelpId LIB "USER32.DLL" ALIAS "SetMenuContextHelpId" (BYVAL hMenu AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION SetMenuDefaultItem LIB "USER32.DLL" ALIAS "SetMenuDefaultItem" (BYVAL hMenu AS LONG, BYVAL uItem AS LONG, BYVAL fByPos AS LONG) AS LONG
DECLARE FUNCTION SetMenuItemBitmaps LIB "USER32.DLL" ALIAS "SetMenuItemBitmaps" (BYVAL hMenu AS LONG, BYVAL nPosition AS LONG, BYVAL wFlags AS LONG, BYVAL hBitmapUnchecked AS LONG, BYVAL hBitmapChecked AS LONG) AS LONG
DECLARE FUNCTION SetMenuItemInfo LIB "USER32.DLL" ALIAS "SetMenuItemInfoA" (BYVAL hMenu AS LONG, BYVAL un AS LONG, BYVAL bool AS LONG, lpcMenuItemInfo AS MENUITEMINFO) AS LONG
DECLARE FUNCTION SetMessageExtraInfo LIB "USER32.DLL" ALIAS "SetMessageExtraInfo" (BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetMessageQueue LIB "USER32.DLL" ALIAS "SetMessageQueue" (BYVAL cMessagesMax AS LONG) AS LONG
DECLARE FUNCTION SetParent LIB "USER32.DLL" ALIAS "SetParent" (BYVAL hWndChild AS LONG, BYVAL hWndNewParent AS LONG) AS LONG
DECLARE FUNCTION SetProcessWindowStation LIB "USER32.DLL" ALIAS "SetProcessWindowStation" (BYVAL hWinSta AS LONG) AS LONG
DECLARE FUNCTION SetProp LIB "USER32.DLL" ALIAS "SetPropA" (BYVAL hwnd AS LONG, lpString AS ASCIIZ, BYVAL hData AS LONG) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION SetRectEmpty LIB "USER32.DLL" ALIAS "SetRectEmpty" (lpRect AS RECT) AS LONG
DECLARE FUNCTION SetScrollInfo LIB "USER32.DLL" ALIAS "SetScrollInfo" (BYVAL hWnd AS LONG, BYVAL n AS LONG, lpcScrollInfo AS SCROLLINFO, BYVAL bool AS LONG) AS LONG
DECLARE FUNCTION SetScrollPos LIB "USER32.DLL" ALIAS "SetScrollPos" (BYVAL hwnd AS LONG, BYVAL nBar AS LONG, BYVAL nPos AS LONG, BYVAL bRedraw AS LONG) AS LONG
DECLARE FUNCTION SetScrollRange LIB "USER32.DLL" ALIAS "SetScrollRange" (BYVAL hwnd AS LONG, BYVAL nBar AS LONG, BYVAL nMinPos AS LONG, BYVAL nMaxPos AS LONG, BYVAL bRedraw AS LONG) AS LONG
DECLARE FUNCTION SetSysColors LIB "USER32.DLL" ALIAS "SetSysColors" (BYVAL nChanges AS LONG, lpSysColor AS LONG, lpColorValues AS LONG) AS LONG
DECLARE FUNCTION SetSystemCursor LIB "USER32.DLL" ALIAS "SetSystemCursor" (BYVAL hcur AS LONG, BYVAL id AS LONG) AS LONG
DECLARE FUNCTION SetThreadDesktop LIB "USER32.DLL" ALIAS "SetThreadDesktop" (BYVAL hDesktop AS LONG) AS LONG
DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (BYVAL hWnd AS LONG, BYVAL nIDEvent AS LONG, BYVAL uElapse AS LONG, BYVAL lpTimerFunc AS LONG) AS LONG
DECLARE FUNCTION SetUserObjectInformation LIB "USER32.DLL" ALIAS "SetUserObjectInformationA" (BYVAL hObj AS LONG, BYVAL nIndex AS LONG, pvInfo AS ANY, BYVAL nLength AS LONG) AS LONG
DECLARE FUNCTION SetUserObjectSecurity LIB "USER32.DLL" ALIAS "SetUserObjectSecurity" (BYVAL hObj AS LONG, pSIRequested AS LONG, pSd AS SECURITY_DESCRIPTOR) AS LONG
DECLARE FUNCTION SetWindowContextHelpId LIB "USER32.DLL" ALIAS "SetWindowContextHelpId" (BYVAL hWnd AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG, BYVAL dwNewLong AS LONG) AS LONG
DECLARE FUNCTION SetWindowPlacement LIB "USER32.DLL" ALIAS "SetWindowPlacement" (BYVAL hwnd AS LONG, lpwndpl AS WINDOWPLACEMENT) AS LONG
DECLARE FUNCTION SetWindowPos LIB "USER32.DLL" ALIAS "SetWindowPos" (BYVAL hwnd AS LONG, BYVAL hWndInsertAfter AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION SetWindowRgn LIB "USER32.DLL" ALIAS "SetWindowRgn" (BYVAL hWnd AS LONG, BYVAL hRgn AS LONG, BYVAL bRedraw AS LONG) AS LONG
DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" (BYVAL hwnd AS LONG, lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION SetWindowWord LIB "USER32.DLL" ALIAS "SetWindowWord" (BYVAL hwnd AS LONG, BYVAL nIndex AS LONG, BYVAL wNewWord AS LONG) AS LONG
DECLARE FUNCTION SetWindowsHook LIB "USER32.DLL" ALIAS "SetWindowsHookA" (BYVAL nFilterType AS LONG, BYVAL pfnFilterProc AS LONG) AS LONG
DECLARE FUNCTION SetWindowsHookEx LIB "USER32.DLL" ALIAS "SetWindowsHookExA" (BYVAL idHook AS LONG, BYVAL lpfn AS LONG, BYVAL hmod AS LONG, BYVAL dwThreadId AS LONG) AS LONG
DECLARE FUNCTION ShowCaret LIB "USER32.DLL" ALIAS "ShowCaret" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION ShowCursor LIB "USER32.DLL" ALIAS "ShowCursor" (BYVAL bShow AS LONG) AS LONG
DECLARE FUNCTION ShowOwnedPopups LIB "USER32.DLL" ALIAS "ShowOwnedPopups" (BYVAL hwnd AS LONG, BYVAL fShow AS LONG) AS LONG
DECLARE FUNCTION ShowScrollBar LIB "USER32.DLL" ALIAS "ShowScrollBar" (BYVAL hwnd AS LONG, BYVAL wBar AS LONG, BYVAL bShow AS LONG) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hwnd AS LONG, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION ShowWindowAsync LIB "USER32.DLL" ALIAS "ShowWindowAsync" (BYVAL hWnd AS LONG, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION SubtractRect LIB "USER32.DLL" ALIAS "SubtractRect" (lprcDst AS RECT, lprcSrc1 AS RECT, lprcSrc2 AS RECT) AS LONG
DECLARE FUNCTION SwapMouseButton LIB "USER32.DLL" ALIAS "SwapMouseButton" (BYVAL bSwap AS LONG) AS LONG
DECLARE FUNCTION SwitchDesktop LIB "USER32.DLL" ALIAS "SwitchDesktop" (BYVAL hDesktop AS LONG) AS LONG
'DECLARE FUNCTION SystemParametersInfo LIB "USER32.DLL" ALIAS "SystemParametersInfoA" (BYVAL uAction AS LONG, BYVAL uParam AS LONG, BYVAL lpvParam AS ANY, BYVAL fuWinIni AS LONG) AS LONG
DECLARE FUNCTION SystemParametersInfo LIB "USER32.DLL" ALIAS "SystemParametersInfoA" (BYVAL uAction AS LONG, BYVAL uParam AS LONG, BYREF lpvParam AS ANY, BYVAL fuWinIni AS LONG) AS LONG
'patrice
DECLARE FUNCTION TabbedTextOut LIB "USER32.DLL" ALIAS "TabbedTextOutA" (BYVAL hdc AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, lpString AS ASCIIZ, BYVAL nCount AS LONG, BYVAL nTabPositions AS LONG, lpnTabStopPositions AS LONG, _
                 BYVAL nTabOrigin AS LONG) AS LONG
DECLARE FUNCTION TileWindows LIB "USER32.DLL" ALIAS "TileWindows" (BYVAL hwndParent AS LONG, BYVAL wHow AS LONG, lpRect AS Rect, BYVAL cKids AS LONG, lpKids AS LONG) AS LONG
DECLARE FUNCTION ToAscii LIB "USER32.DLL" ALIAS "ToAscii" (BYVAL uVirtKey AS LONG, BYVAL uScanCode AS LONG, lpbKeyState AS BYTE, lpwTransKey AS LONG, BYVAL fuState AS LONG) AS LONG
DECLARE FUNCTION ToAsciiEx LIB "USER32.DLL" ALIAS "ToAsciiEx" (BYVAL uVirtKey AS LONG, BYVAL uScanCode AS LONG, lpKeyState AS BYTE, lpChar AS LONG, BYVAL uFlags AS LONG, BYVAL dwhkl AS LONG) AS LONG
DECLARE FUNCTION ToUnicode LIB "USER32.DLL" ALIAS "ToUnicode" (BYVAL wVirtKey AS LONG, BYVAL wScanCode AS LONG, lpKeyState AS BYTE, pwszBuff AS ASCIIZ, BYVAL cchBuff AS LONG, BYVAL wFlags AS LONG) AS LONG
DECLARE FUNCTION TrackPopupMenu LIB "USER32.DLL" ALIAS "TrackPopupMenu" (BYVAL hMenu AS LONG, BYVAL wFlags AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nReserved AS LONG, BYVAL hwnd AS LONG, lprc AS Rect) AS LONG
DECLARE FUNCTION TrackPopupMenuEx LIB "USER32.DLL" ALIAS "TrackPopupMenuEx" (BYVAL hMenu AS LONG, BYVAL un AS LONG, BYVAL n1 AS LONG, BYVAL n2 AS LONG, BYVAL hWnd AS LONG, lpTPMParams AS TPMPARAMS) AS LONG
DECLARE FUNCTION TranslateAccelerator LIB "USER32.DLL" ALIAS "TranslateAcceleratorA" (BYVAL hwnd AS LONG, BYVAL hAccTable AS LONG, lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION TranslateMDISysAccel LIB "USER32.DLL" ALIAS "TranslateMDISysAccel" (BYVAL hWndClient AS LONG, lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION UnhookWindowsHook LIB "USER32.DLL" ALIAS "UnhookWindowsHook" (BYVAL nCode AS LONG, BYVAL pfnFilterProc AS LONG) AS LONG
DECLARE FUNCTION UnhookWindowsHookEx LIB "USER32.DLL" ALIAS "UnhookWindowsHookEx" (BYVAL hHook AS LONG) AS LONG
DECLARE FUNCTION UnionRect LIB "USER32.DLL" ALIAS "UnionRect" (lpDestRect AS RECT, lpSrc1Rect AS RECT, lpSrc2Rect AS RECT) AS LONG
DECLARE FUNCTION UnloadKeyboardLayout LIB "USER32.DLL" ALIAS "UnloadKeyboardLayout" (BYVAL HKL AS LONG) AS LONG
DECLARE FUNCTION UnpackDDElParam LIB "USER32.DLL" ALIAS "UnpackDDElParam" (BYVAL msg AS LONG, BYVAL lParam AS LONG, puiLo AS LONG, puiHi AS LONG) AS LONG
DECLARE FUNCTION UnregisterClass LIB "USER32.DLL" ALIAS "UnregisterClassA" (lpClassName AS ASCIIZ, BYVAL hInstance AS LONG) AS LONG
DECLARE FUNCTION UnregisterHotKey LIB "USER32.DLL" ALIAS "UnregisterHotKey" (BYVAL hwnd AS LONG, BYVAL id AS LONG) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION ValidateRect LIB "USER32.DLL" ALIAS "ValidateRect" (BYVAL hwnd AS LONG, lpRect AS RECT) AS LONG
DECLARE FUNCTION ValidateRgn LIB "USER32.DLL" ALIAS "ValidateRgn" (BYVAL hwnd AS LONG, BYVAL hRgn AS LONG) AS LONG
DECLARE FUNCTION VkKeyScan LIB "USER32.DLL" ALIAS "VkKeyScanA" (BYVAL cChar AS BYTE) AS LONG
DECLARE FUNCTION VkKeyScanEx LIB "USER32.DLL" ALIAS "VkKeyScanExA" (BYVAL ch AS BYTE, BYVAL dwhkl AS LONG) AS LONG
DECLARE FUNCTION WaitForInputIdle LIB "USER32.DLL" ALIAS "WaitForInputIdle" (BYVAL hProcess AS LONG, BYVAL dwMilliseconds AS LONG) AS LONG
DECLARE FUNCTION WaitMessage LIB "USER32.DLL" ALIAS "WaitMessage" () AS LONG
DECLARE FUNCTION WinHelp LIB "USER32.DLL" ALIAS "WinHelpA" (BYVAL hwnd AS LONG, lpHelpFile AS ASCIIZ, BYVAL wCommand AS LONG, BYVAL dwData AS LONG) AS LONG
DECLARE FUNCTION WindowFromDC LIB "USER32.DLL" ALIAS "WindowFromDC" (BYVAL hdc AS LONG) AS LONG
DECLARE FUNCTION WindowFromPoint LIB "USER32.DLL" ALIAS "WindowFromPoint" (BYVAL xPoint AS LONG, BYVAL yPoint AS LONG) AS LONG
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)
DECLARE SUB keybd_event LIB "USER32.DLL" ALIAS "keybd_event" (BYVAL bVk AS BYTE, BYVAL bScan AS BYTE, BYVAL dwFlags AS LONG, BYVAL dwExtraInfo AS LONG)
DECLARE SUB mouse_event LIB "USER32.DLL" ALIAS "mouse_event" (BYVAL dwFlags AS LONG, BYVAL dx AS LONG, BYVAL dy AS LONG, BYVAL cButtons AS LONG, BYVAL dwExtraInfo AS LONG)
DECLARE SUB SetDebugErrorLevel LIB "USER32.DLL" ALIAS "SetDebugErrorLevel" (BYVAL dwLevel AS LONG)
DECLARE SUB SetLastErrorEx LIB "USER32.DLL" ALIAS "SetLastErrorEx" (BYVAL dwErrCode AS LONG, BYVAL dwType AS LONG)

DECLARE FUNCTION wsprintf CDECL LIB "USER32.DLL" ALIAS "wsprintfA" (lpOutput AS ASCIIZ, lpFormat AS ASCIIZ, x AS ANY[, x AS ANY]) AS LONG

'
' ** WINMM.DLL Declares (Multimedia)
'
DECLARE FUNCTION CloseDriver LIB "WINMM.DLL" ALIAS "CloseDriver" (BYVAL hDriver AS LONG, BYVAL lParam1 AS LONG, BYVAL lParam2 AS LONG) AS LONG
DECLARE FUNCTION DefDriverProc LIB "WINMM.DLL" ALIAS "DefDriverProc" (BYVAL dwDriverIdentifier AS LONG, BYVAL hdrvr AS LONG, BYVAL uMsg AS LONG, BYVAL lParam1 AS LONG, BYVAL lParam2 AS LONG) AS LONG
DECLARE FUNCTION DrvGetModuleHandle LIB "WINMM.DLL" ALIAS "DrvGetModuleHandle" (BYVAL hDriver AS LONG) AS LONG
DECLARE FUNCTION GetDriverModuleHandle LIB "WINMM.DLL" ALIAS "GetDriverModuleHandle" (BYVAL hDriver AS LONG) AS LONG
DECLARE FUNCTION OpenDriver LIB "WINMM.DLL" ALIAS "OpenDriver" (szDriverName AS ASCIIZ, szSectionName AS ASCIIZ, BYVAL lParam2 AS LONG) AS LONG
DECLARE FUNCTION PlaySound LIB "WINMM.DLL" ALIAS "PlaySoundA" (lpszName AS ASCIIZ, BYVAL hModule AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION SendDriverMessage LIB "WINMM.DLL" ALIAS "SendDriverMessage" (BYVAL hDriver AS LONG, BYVAL message AS LONG, BYVAL lParam1 AS LONG, BYVAL lParam2 AS LONG) AS LONG

DECLARE FUNCTION auxGetDevCaps LIB "WINMM.DLL" ALIAS "auxGetDevCapsA" (BYVAL uDeviceID AS LONG, lpCaps AS AUXCAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION auxGetNumDevs LIB "WINMM.DLL" ALIAS "auxGetNumDevs" () AS LONG
DECLARE FUNCTION auxGetVolume LIB "WINMM.DLL" ALIAS "auxGetVolume" (BYVAL uDeviceID AS LONG, lpdwVolume AS AuxVolume) AS LONG
DECLARE FUNCTION auxOutMessage LIB "WINMM.DLL" ALIAS "auxOutMessage" (BYVAL uDeviceID AS LONG, BYVAL msg AS LONG, BYVAL dw1 AS LONG, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION auxSetVolume LIB "WINMM.DLL" ALIAS "auxSetVolume" (BYVAL uDeviceID AS LONG, BYVAL dwVolume AS DWORD) AS LONG
DECLARE FUNCTION joyGetDevCaps LIB "WINMM.DLL" ALIAS "joyGetDevCapsA" (BYVAL id AS LONG, lpCaps AS JOYCAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION joyGetNumDevs LIB "WINMM.DLL" ALIAS "joyGetNumDev" () AS LONG
DECLARE FUNCTION joyGetPos LIB "WINMM.DLL" ALIAS "joyGetPos" (BYVAL uJoyID AS LONG, pji AS JOYINFO) AS LONG
DECLARE FUNCTION joyGetPosEx LIB "WINMM.DLL" ALIAS "joyGetPosEx" (BYVAL uJoyID AS LONG, pji AS JOYINFOEX) AS LONG
DECLARE FUNCTION joyGetThreshold LIB "WINMM.DLL" ALIAS "joyGetThreshold" (BYVAL id AS LONG, lpuThreshold AS LONG) AS LONG
DECLARE FUNCTION joyReleaseCapture LIB "WINMM.DLL" ALIAS "joyReleaseCapture" (BYVAL id AS LONG) AS LONG
DECLARE FUNCTION joySetCapture LIB "WINMM.DLL" ALIAS "joySetCapture" (BYVAL hwnd AS LONG, BYVAL uID AS LONG, BYVAL uPeriod AS LONG, BYVAL bChanged AS LONG) AS LONG
DECLARE FUNCTION joySetThreshold LIB "WINMM.DLL" ALIAS "joySetThreshold" (BYVAL id AS LONG, BYVAL uThreshold AS LONG) AS LONG
DECLARE FUNCTION mciExecute LIB "WINMM.DLL" ALIAS "mciExecute" (lpstrCommand AS ASCIIZ) AS LONG
DECLARE FUNCTION mciGetCreatorTask LIB "WINMM.DLL" ALIAS "mciGetCreatorTask" (BYVAL wDeviceID AS LONG) AS LONG
DECLARE FUNCTION mciGetDeviceID LIB "WINMM.DLL" ALIAS "mciGetDeviceIDA" (lpstrName AS ASCIIZ) AS LONG
DECLARE FUNCTION mciGetDeviceIDFromElementID LIB "WINMM.DLL" ALIAS "mciGetDeviceIDFromElementIDA" (BYVAL dwElementID AS LONG, lpstrType AS ASCIIZ) AS LONG
DECLARE FUNCTION mciGetErrorString LIB "WINMM.DLL" ALIAS "mciGetErrorStringA" (BYVAL dwError AS LONG, lpstrBuffer AS ASCIIZ, BYVAL uLength AS LONG) AS LONG
DECLARE FUNCTION mciGetYieldProc LIB "WINMM.DLL" ALIAS "mciGetYieldProc" (BYVAL mciId AS LONG, pdwYieldData AS LONG) AS LONG
DECLARE FUNCTION mciSendCommand LIB "WINMM.DLL" ALIAS "mciSendCommandA" (BYVAL wDeviceID AS LONG, BYVAL uMessage AS LONG, BYVAL dwParam1 AS LONG, BYVAL dwParam2 AS LONG) AS LONG
DECLARE FUNCTION mciSendString LIB "WINMM.DLL" ALIAS "mciSendStringA" (lpstrCommand AS ASCIIZ, lpstrReturnString AS ASCIIZ, BYVAL uReturnLength AS LONG, BYVAL hwndCallback AS LONG) AS LONG
DECLARE FUNCTION mciSetYieldProc LIB "WINMM.DLL" ALIAS "mciSetYieldProc" (BYVAL mciId AS LONG, BYVAL fpYieldProc AS LONG, BYVAL dwYieldData AS LONG) AS LONG
DECLARE FUNCTION midiConnect LIB "WINMM.DLL" ALIAS "midiConnect" (BYVAL hmi AS LONG, BYVAL hmo AS LONG, pReserved AS ANY) AS LONG
DECLARE FUNCTION midiDisconnect LIB "WINMM.DLL" ALIAS "midiDisconnect" (BYVAL hmi AS LONG, BYVAL hmo AS LONG, pReserved AS ANY) AS LONG
DECLARE FUNCTION midiInAddBuffer LIB "WINMM.DLL" ALIAS "midiInAddBuffer" (BYVAL hMidiIn AS LONG, lpMidiInHdr AS MIDIHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiInClose LIB "WINMM.DLL" ALIAS "midiInClose" (BYVAL hMidiIn AS LONG) AS LONG
DECLARE FUNCTION midiInGetDevCaps LIB "WINMM.DLL" ALIAS "midiInGetDevCapsA" (BYVAL uDeviceID AS LONG, lpCaps AS MIDIINCAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiInGetErrorText LIB "WINMM.DLL" ALIAS "midiInGetErrorTextA" (BYVAL xerr AS LONG, lpText AS ASCIIZ, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiInGetID LIB "WINMM.DLL" ALIAS "midiInGetID" (BYVAL hMidiIn AS LONG, lpuDeviceID AS LONG) AS LONG
DECLARE FUNCTION midiInGetNumDevs LIB "WINMM.DLL" ALIAS "midiInGetNumDevs" () AS LONG
DECLARE FUNCTION midiInMessage LIB "WINMM.DLL" ALIAS "midiInMessage" (BYVAL hMidiIn AS LONG, BYVAL msg AS LONG, BYVAL dw1 AS LONG, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION midiInOpen LIB "WINMM.DLL" ALIAS "midiInOpen" (lphMidiIn AS LONG, BYVAL uDeviceID AS LONG, BYVAL dwCallback AS LONG, BYVAL dwInstance AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION midiInPrepareHeader LIB "WINMM.DLL" ALIAS "midiInPrepareHeader" (BYVAL hMidiIn AS LONG, lpMidiInHdr AS MIDIHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiInReset LIB "WINMM.DLL" ALIAS "midiInReset" (BYVAL hMidiIn AS LONG) AS LONG
DECLARE FUNCTION midiInStart LIB "WINMM.DLL" ALIAS "midiInStart" (BYVAL hMidiIn AS LONG) AS LONG
DECLARE FUNCTION midiInStop LIB "WINMM.DLL" ALIAS "midiInStop" (BYVAL hMidiIn AS LONG) AS LONG
DECLARE FUNCTION midiInUnprepareHeader LIB "WINMM.DLL" ALIAS "midiInUnprepareHeader" (BYVAL hMidiIn AS LONG, lpMidiInHdr AS MIDIHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiOutCacheDrumPatches LIB "WINMM.DLL" ALIAS "midiOutCacheDrumPatches" (BYVAL hMidiOut AS LONG, BYVAL uPatch AS LONG, lpKeyArray AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION midiOutCachePatches LIB "WINMM.DLL" ALIAS "midiOutCachePatches" (BYVAL hMidiOut AS LONG, BYVAL uBank AS LONG, lpPatchArray AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION midiOutClose LIB "WINMM.DLL" ALIAS "midiOutClose" (BYVAL hMidiOut AS LONG) AS LONG
DECLARE FUNCTION midiOutGetDevCaps LIB "WINMM.DLL" ALIAS "midiOutGetDevCapsA" (BYVAL uDeviceID AS LONG, lpCaps AS MIDIOUTCAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiOutGetErrorText LIB "WINMM.DLL" ALIAS "midiOutGetErrorTextA" (BYVAL xerr AS LONG, lpText AS ASCIIZ, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiOutGetID LIB "WINMM.DLL" ALIAS "midiOutGetID" (BYVAL hMidiOut AS LONG, lpuDeviceID AS LONG) AS LONG
DECLARE FUNCTION midiOutGetNumDevs LIB "WINMM.DLL" ALIAS "midiOutGetNumDevs" () AS LONG
DECLARE FUNCTION midiOutGetVolume LIB "WINMM.DLL" ALIAS "midiOutGetVolume" (BYVAL uDeviceID AS LONG, lpdwVolume AS LONG) AS LONG
DECLARE FUNCTION midiOutLongMsg LIB "WINMM.DLL" ALIAS "midiOutLongMsg" (BYVAL hMidiOut AS LONG, lpMidiOutHdr AS MIDIHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiOutMessage LIB "WINMM.DLL" ALIAS "midiOutMessage" (BYVAL hMidiOut AS LONG, BYVAL msg AS LONG, BYVAL dw1 AS LONG, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION midiOutOpen LIB "WINMM.DLL" ALIAS "midiOutOpen" (lphMidiOut AS LONG, BYVAL uDeviceID AS LONG, BYVAL dwCallback AS LONG, BYVAL dwInstance AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION midiOutPrepareHeader LIB "WINMM.DLL" ALIAS "midiOutPrepareHeader" (BYVAL hMidiOut AS LONG, lpMidiOutHdr AS MIDIHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiOutReset LIB "WINMM.DLL" ALIAS "midiOutReset" (BYVAL hMidiOut AS LONG) AS LONG
DECLARE FUNCTION midiOutSetVolume LIB "WINMM.DLL" ALIAS "midiOutSetVolume" (BYVAL uDeviceID AS LONG, BYVAL dwVolume AS LONG) AS LONG
DECLARE FUNCTION midiOutShortMsg LIB "WINMM.DLL" ALIAS "midiOutShortMsg" (BYVAL hMidiOut AS LONG, BYVAL dwMsg AS LONG) AS LONG
DECLARE FUNCTION midiOutUnprepareHeader LIB "WINMM.DLL" ALIAS "midiOutUnprepareHeader" (BYVAL hMidiOut AS LONG, lpMidiOutHdr AS MIDIHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION midiStreamClose LIB "WINMM.DLL" ALIAS "midiStreamClose" (BYVAL hms AS LONG) AS LONG
DECLARE FUNCTION midiStreamOpen LIB "WINMM.DLL" ALIAS "midiStreamOpen" (phms AS LONG, puDeviceID AS LONG, BYVAL cMidi AS LONG, BYVAL dwCallback AS LONG, BYVAL dwInstance AS LONG, BYVAL fdwOpen AS LONG) AS LONG
DECLARE FUNCTION midiStreamOut LIB "WINMM.DLL" ALIAS "midiStreamOut" (BYVAL hms AS LONG, pmh AS MIDIHDR, BYVAL cbmh AS LONG) AS LONG
DECLARE FUNCTION midiStreamPause LIB "WINMM.DLL" ALIAS "midiStreamPause" (BYVAL hms AS LONG) AS LONG
DECLARE FUNCTION midiStreamPosition LIB "WINMM.DLL" ALIAS "midiStreamPosition" (BYVAL hms AS LONG, lpmmt AS MMTIME, BYVAL cbmmt AS LONG) AS LONG
DECLARE FUNCTION midiStreamProperty LIB "WINMM.DLL" ALIAS "midiStreamProperty" (BYVAL hms AS LONG, lppropdata AS BYTE, BYVAL dwProperty AS LONG) AS LONG
DECLARE FUNCTION midiStreamRestart LIB "WINMM.DLL" ALIAS "midiStreamRestart" (BYVAL hms AS LONG) AS LONG
DECLARE FUNCTION midiStreamStop LIB "WINMM.DLL" ALIAS "midiStreamStop" (BYVAL hms AS LONG) AS LONG
DECLARE FUNCTION mixerClose LIB "WINMM.DLL" ALIAS "mixerClose" (BYVAL hmx AS LONG) AS LONG
DECLARE FUNCTION mixerGetControlDetails LIB "WINMM.DLL" ALIAS "mixerGetControlDetailsA" (BYVAL hmxobj AS LONG, pmxcd AS MIXERCONTROLDETAILS, BYVAL fdwDetails AS LONG) AS LONG
DECLARE FUNCTION mixerGetDevCaps LIB "WINMM.DLL" ALIAS "mixerGetDevCapsA" (BYVAL uMxId AS LONG, pmxcaps AS MIXERCAPS, BYVAL cbmxcaps AS LONG) AS LONG
DECLARE FUNCTION mixerGetID LIB "WINMM.DLL" ALIAS "mixerGetID" (BYVAL hmxobj AS LONG, pumxID AS LONG, BYVAL fdwId AS LONG) AS LONG
DECLARE FUNCTION mixerGetLineControls LIB "WINMM.DLL" ALIAS "mixerGetLineControlsA" (BYVAL hmxobj AS LONG, pmxlc AS MIXERLINECONTROLS, BYVAL fdwControls AS LONG) AS LONG
DECLARE FUNCTION mixerGetLineInfo LIB "WINMM.DLL" ALIAS "mixerGetLineInfoA" (BYVAL hmxobj AS LONG, pmxl AS MIXERLINE, BYVAL fdwInfo AS LONG) AS LONG
DECLARE FUNCTION mixerGetNumDevs LIB "WINMM.DLL" ALIAS "mixerGetNumDevs" () AS LONG
DECLARE FUNCTION mixerMessage LIB "WINMM.DLL" ALIAS "mixerMessage" (BYVAL hmx AS LONG, BYVAL uMsg AS LONG, BYVAL dwParam1 AS LONG, BYVAL dwParam2 AS LONG) AS LONG
DECLARE FUNCTION mixerOpen LIB "WINMM.DLL" ALIAS "mixerOpen" (phmx AS LONG, BYVAL uMxId AS LONG, BYVAL dwCallback AS LONG, BYVAL dwInstance AS LONG, BYVAL fdwOpen AS LONG) AS LONG
DECLARE FUNCTION mixerSetControlDetails LIB "WINMM.DLL" ALIAS "mixerSetControlDetails" (BYVAL hmxobj AS LONG, pmxcd AS MIXERCONTROLDETAILS, BYVAL fdwDetails AS LONG) AS LONG
DECLARE FUNCTION mmioAdvance LIB "WINMM.DLL" ALIAS "mmioAdvance" (BYVAL hmmio AS LONG, lpmmioinfo AS MMIOINFO, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioAscend LIB "WINMM.DLL" ALIAS "mmioAscend" (BYVAL hmmio AS LONG, lpck AS MMCKINFO, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioClose LIB "WINMM.DLL" ALIAS "mmioClose" (BYVAL hmmio AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioCreateChunk LIB "WINMM.DLL" ALIAS "mmioCreateChunk" (BYVAL hmmio AS LONG, lpck AS MMCKINFO, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioDescend LIB "WINMM.DLL" ALIAS "mmioDescend" (BYVAL hmmio AS LONG, lpck AS MMCKINFO, lpckParent AS MMCKINFO, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioFlush LIB "WINMM.DLL" ALIAS "mmioFlush" (BYVAL hmmio AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioGetInfo LIB "WINMM.DLL" ALIAS "mmioGetInfo" (BYVAL hmmio AS LONG, lpmmioinfo AS MMIOINFO, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioInstallIOProcA LIB "WINMM.DLL" ALIAS "mmioInstallIOProcA" (fccIOProc AS ASCIIZ * 4, BYVAL pIOProc AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION mmioOpen LIB "WINMM.DLL" ALIAS "mmioOpenA" (szFileName AS ASCIIZ, lpmmioinfo AS MMIOINFO, BYVAL dwOpenFlags AS LONG) AS LONG
DECLARE FUNCTION mmioRead LIB "WINMM.DLL" ALIAS "mmioRead" (BYVAL hmmio AS LONG, pch AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION mmioRename LIB "WINMM.DLL" ALIAS "mmioRenameA" (szFileName AS ASCIIZ, SzNewFileName AS ASCIIZ, lpmmioinfo AS MMIOINFO, BYVAL dwRenameFlags AS LONG) AS LONG
DECLARE FUNCTION mmioSeek LIB "WINMM.DLL" ALIAS "mmioSeek" (BYVAL hmmio AS LONG, BYVAL lOffset AS LONG, BYVAL iOrigin AS LONG) AS LONG
DECLARE FUNCTION mmioSendMessage LIB "WINMM.DLL" ALIAS "mmioSendMessage" (BYVAL hmmio AS LONG, BYVAL uMsg AS LONG, BYVAL lParam1 AS LONG, BYVAL lParam2 AS LONG) AS LONG
DECLARE FUNCTION mmioSetBuffer LIB "WINMM.DLL" ALIAS "mmioSetBuffer" (BYVAL hmmio AS LONG, pchBuffer AS ASCIIZ, BYVAL cchBuffer AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioSetInfo LIB "WINMM.DLL" ALIAS "mmioSetInfo" (BYVAL hmmio AS LONG, lpmmioinfo AS MMIOINFO, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioStringToFOURCC LIB "WINMM.DLL" ALIAS "mmioStringToFOURCCA" (sz AS ASCIIZ, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION mmioWrite LIB "WINMM.DLL" ALIAS "mmioWrite" (BYVAL hmmio AS LONG, pch AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION mmsystemGetVersion LIB "WINMM.DLL" ALIAS "mmsystemGetVersion" () AS LONG
DECLARE FUNCTION sndPlaySound LIB "WINMM.DLL" ALIAS "sndPlaySoundA" (lpszSoundName AS ASCIIZ, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION timeBeginPeriod LIB "WINMM.DLL" ALIAS "timeBeginPeriod" (BYVAL uPeriod AS LONG) AS LONG
DECLARE FUNCTION timeEndPeriod LIB "WINMM.DLL" ALIAS "timeEndPeriod" (BYVAL uPeriod AS LONG) AS LONG
DECLARE FUNCTION timeGetDevCaps LIB "WINMM.DLL" ALIAS "timeGetDevCaps" (lpTimeCaps AS TIMECAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION timeGetSystemTime LIB "WINMM.DLL" ALIAS "timeGetSystemTime" (lpTime AS MMTIME, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION timeGetTime LIB "WINMM.DLL" ALIAS "timeGetTime" () AS LONG
DECLARE FUNCTION timeKillEvent LIB "WINMM.DLL" ALIAS "timeKillEvent" (BYVAL uID AS LONG) AS LONG
DECLARE FUNCTION timeSetEvent LIB "WINMM.DLL" ALIAS "timeSetEvent" (BYVAL uDelay AS LONG, BYVAL uResolution AS LONG, BYVAL lpFunction AS LONG, BYVAL dwUser AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION waveInAddBuffer LIB "WINMM.DLL" ALIAS "waveInAddBuffer" (BYVAL hWaveIn AS LONG, lpWaveInHdr AS WAVEHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveInClose LIB "WINMM.DLL" ALIAS "waveInClose" (BYVAL hWaveIn AS LONG) AS LONG
DECLARE FUNCTION waveInGetDevCaps LIB "WINMM.DLL" ALIAS "waveInGetDevCapsA" (BYVAL uDeviceID AS LONG, lpCaps AS WAVEINCAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveInGetErrorText LIB "WINMM.DLL" ALIAS "waveInGetErrorTextA" (BYVAL xerr AS LONG, lpText AS ASCIIZ, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveInGetID LIB "WINMM.DLL" ALIAS "waveInGetID" (BYVAL hWaveIn AS LONG, lpuDeviceID AS LONG) AS LONG
DECLARE FUNCTION waveInGetNumDevs LIB "WINMM.DLL" ALIAS "waveInGetNumDevs" () AS LONG
DECLARE FUNCTION waveInGetPosition LIB "WINMM.DLL" ALIAS "waveInGetPosition" (BYVAL hWaveIn AS LONG, lpInfo AS MMTIME, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveInMessage LIB "WINMM.DLL" ALIAS "waveInMessage" (BYVAL hWaveIn AS LONG, BYVAL msg AS LONG, BYVAL dw1 AS LONG, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION waveInOpen LIB "WINMM.DLL" ALIAS "waveInOpen" (lphWaveIn AS LONG, BYVAL uDeviceID AS LONG, lpFormat AS WAVEFORMAT, BYVAL dwCallback AS LONG, BYVAL dwInstance AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION waveInPrepareHeader LIB "WINMM.DLL" ALIAS "waveInPrepareHeader" (BYVAL hWaveIn AS LONG, lpWaveInHdr AS WAVEHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveInReset LIB "WINMM.DLL" ALIAS "waveInReset" (BYVAL hWaveIn AS LONG) AS LONG
DECLARE FUNCTION waveInStart LIB "WINMM.DLL" ALIAS "waveInStart" (BYVAL hWaveIn AS LONG) AS LONG
DECLARE FUNCTION waveInStop LIB "WINMM.DLL" ALIAS "waveInStop" (BYVAL hWaveIn AS LONG) AS LONG
DECLARE FUNCTION waveInUnprepareHeader LIB "WINMM.DLL" ALIAS "waveInUnprepareHeader" (BYVAL hWaveIn AS LONG, lpWaveInHdr AS WAVEHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveOutBreakLoop LIB "WINMM.DLL" ALIAS "waveOutBreakLoop" (BYVAL hWaveOut AS LONG) AS LONG
DECLARE FUNCTION waveOutClose LIB "WINMM.DLL" ALIAS "waveOutClose" (BYVAL hWaveOut AS LONG) AS LONG
DECLARE FUNCTION waveOutGetDevCaps LIB "WINMM.DLL" ALIAS "waveOutGetDevCapsA" (BYVAL uDeviceID AS LONG, lpCaps AS WAVEOUTCAPS, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveOutGetErrorText LIB "WINMM.DLL" ALIAS "waveOutGetErrorTextA" (BYVAL xerr AS LONG, lpText AS ASCIIZ, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveOutGetID LIB "WINMM.DLL" ALIAS "waveOutGetID" (BYVAL hWaveOut AS LONG, lpuDeviceID AS LONG) AS LONG
DECLARE FUNCTION waveOutGetNumDevs LIB "WINMM.DLL" ALIAS "waveOutGetNumDevs" () AS LONG
DECLARE FUNCTION waveOutGetPitch LIB "WINMM.DLL" ALIAS "waveOutGetPitch" (BYVAL hWaveOut AS LONG, lpdwPitch AS LONG) AS LONG
DECLARE FUNCTION waveOutGetPlaybackRate LIB "WINMM.DLL" ALIAS "waveOutGetPlaybackRate" (BYVAL hWaveOut AS LONG, lpdwRate AS LONG) AS LONG
DECLARE FUNCTION waveOutGetPosition LIB "WINMM.DLL" ALIAS "waveOutGetPosition" (BYVAL hWaveOut AS LONG, lpInfo AS MMTIME, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveOutGetVolume LIB "WINMM.DLL" ALIAS "waveOutGetVolume" (BYVAL uDeviceID AS LONG, lpdwVolume AS LONG) AS LONG
DECLARE FUNCTION waveOutMessage LIB "WINMM.DLL" ALIAS "waveOutMessage" (BYVAL hWaveOut AS LONG, BYVAL msg AS LONG, BYVAL dw1 AS LONG, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION waveOutOpen LIB "WINMM.DLL" ALIAS "waveOutOpen" (lphWaveOut AS LONG, BYVAL uDeviceID AS LONG, lpFormat AS WAVEFORMAT, BYVAL dwCallback AS LONG, BYVAL dwInstance AS LONG, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION waveOutPause LIB "WINMM.DLL" ALIAS "waveOutPause" (BYVAL hWaveOut AS LONG) AS LONG
DECLARE FUNCTION waveOutPrepareHeader LIB "WINMM.DLL" ALIAS "waveOutPrepareHeader" (BYVAL hWaveOut AS LONG, lpWaveOutHdr AS WAVEHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveOutReset LIB "WINMM.DLL" ALIAS "waveOutReset" (BYVAL hWaveOut AS LONG) AS LONG
DECLARE FUNCTION waveOutRestart LIB "WINMM.DLL" ALIAS "waveOutRestart" (BYVAL hWaveOut AS LONG) AS LONG
DECLARE FUNCTION waveOutSetPitch LIB "WINMM.DLL" ALIAS "waveOutSetPitch" (BYVAL hWaveOut AS LONG, BYVAL dwPitch AS LONG) AS LONG
DECLARE FUNCTION waveOutSetPlaybackRate LIB "WINMM.DLL" ALIAS "waveOutSetPlaybackRate" (BYVAL hWaveOut AS LONG, BYVAL dwRate AS LONG) AS LONG
DECLARE FUNCTION waveOutSetVolume LIB "WINMM.DLL" ALIAS "waveOutSetVolume" (BYVAL uDeviceID AS LONG, BYVAL dwVolume AS LONG) AS LONG
DECLARE FUNCTION waveOutUnprepareHeader LIB "WINMM.DLL" ALIAS "waveOutUnprepareHeader" (BYVAL hWaveOut AS LONG, lpWaveOutHdr AS WAVEHDR, BYVAL uSize AS LONG) AS LONG
DECLARE FUNCTION waveOutWrite LIB "WINMM.DLL" ALIAS "waveOutWrite" (BYVAL hWaveOut AS LONG, lpWaveOutHdr AS WAVEHDR, BYVAL uSize AS LONG) AS LONG
DECLARE SUB OutputDebugStr LIB "WINMM.DLL" ALIAS "OutputDebugStr" (lpszOutputString AS ASCIIZ)


'
' ** WINSPOOL.DRV Declares (Printer Support)
'
DECLARE FUNCTION AbortPrinter LIB "WINSPOOL.DRV" ALIAS "AbortPrinter" (BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION AddForm LIB "WINSPOOL.DRV" ALIAS "AddFormA" (BYVAL hPrinter AS LONG, BYVAL Level AS LONG, pForm AS BYTE) AS LONG
DECLARE FUNCTION AddJob LIB "WINSPOOL.DRV" ALIAS "AddJobA" (BYVAL hPrinter AS LONG, BYVAL Level AS LONG, pData AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION AddMonitor LIB "WINSPOOL.DRV" ALIAS "AddMonitorA" (pName AS ASCIIZ, BYVAL Level AS LONG, pMonitors AS BYTE) AS LONG
DECLARE FUNCTION AddPort LIB "WINSPOOL.DRV" ALIAS "AddPortA" (pName AS ASCIIZ, BYVAL hwnd AS LONG, pMonitorName AS ASCIIZ) AS LONG
DECLARE FUNCTION AddPrintProcessor LIB "WINSPOOL.DRV" ALIAS "AddPrintProcessorA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, pPathName AS ASCIIZ, pPrintProcessorName AS ASCIIZ) AS LONG
DECLARE FUNCTION AddPrintProvidor LIB "WINSPOOL.DRV" ALIAS "AddPrintProvidorA" (pName AS ASCIIZ, BYVAL Level AS LONG, pProvidorInfo AS BYTE) AS LONG
DECLARE FUNCTION AddPrinter LIB "WINSPOOL.DRV" ALIAS "AddPrinterA" (pName AS ASCIIZ, BYVAL Level AS LONG, pPrinter AS BYTE) AS LONG
DECLARE FUNCTION AddPrinterConnection LIB "WINSPOOL.DRV" ALIAS "AddPrinterConnectionA" (pName AS ASCIIZ) AS LONG
DECLARE FUNCTION AddPrinterDriver LIB "WINSPOOL.DRV" ALIAS "AddPrinterDriverA" (pName AS ASCIIZ, BYVAL Level AS LONG, pDriverInfor AS BYTE) AS LONG
DECLARE FUNCTION AdvancedDocumentProperties LIB "WINSPOOL.DRV" ALIAS "AdvancedDocumentPropertiesA" (BYVAL hwnd AS LONG, BYVAL hPrinter AS LONG, pDeviceName AS ASCIIZ, pDevModeOutput AS DEVMODE, pDevModeInput AS DEVMODE) AS LONG
DECLARE FUNCTION ClosePrinter LIB "WINSPOOL.DRV" ALIAS "ClosePrinter" (BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION ConfigurePort LIB "WINSPOOL.DRV" ALIAS "ConfigurePortA" (pName AS ASCIIZ, BYVAL hwnd AS LONG, pPortName AS ASCIIZ) AS LONG
DECLARE FUNCTION ConnectToPrinterDlg LIB "WINSPOOL.DRV" ALIAS "ConnectToPrinterDlg" (BYVAL hwnd AS LONG, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION DeleteForm LIB "WINSPOOL.DRV" ALIAS "DeleteFormA" (BYVAL hPrinter AS LONG, pFormName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeleteMonitor LIB "WINSPOOL.DRV" ALIAS "DeleteMonitorA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, pMonitorName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeletePort LIB "WINSPOOL.DRV" ALIAS "DeletePortA" (pName AS ASCIIZ, BYVAL hwnd AS LONG, pPortName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeletePrintProcessor LIB "WINSPOOL.DRV" ALIAS "DeletePrintProcessorA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, pPrintProcessorName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeletePrintProvidor LIB "WINSPOOL.DRV" ALIAS "DeletePrintProvidorA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, pPrintProvidorName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeletePrinter LIB "WINSPOOL.DRV" ALIAS "DeletePrinter" (BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION DeletePrinterConnection LIB "WINSPOOL.DRV" ALIAS "DeletePrinterConnectionA" (pName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeletePrinterDriver LIB "WINSPOOL.DRV" ALIAS "DeletePrinterDriverA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, pDriverName AS ASCIIZ) AS LONG
DECLARE FUNCTION DeviceCapabilities LIB "WINSPOOL.DRV" ALIAS "DeviceCapabilitiesA" (lpDeviceName AS ASCIIZ, lpPort AS ASCIIZ, BYVAL iIndex AS LONG, lpOutput AS ASCIIZ, lpDevMode AS DEVMODE) AS LONG
DECLARE FUNCTION DocumentProperties LIB "WINSPOOL.DRV" ALIAS "DocumentPropertiesA" (BYVAL hwnd AS LONG, BYVAL hPrinter AS LONG, pDeviceName AS ASCIIZ, pDevModeOutput AS DEVMODE, pDevModeInput AS DEVMODE, BYVAL fMode AS LONG) AS LONG
DECLARE FUNCTION EndDocPrinter LIB "WINSPOOL.DRV" ALIAS "EndDocPrinter" (BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION EndPagePrinter LIB "WINSPOOL.DRV" ALIAS "EndPagePrinter" (BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION EnumForms LIB "WINSPOOL.DRV" ALIAS "EnumFormsA" (BYVAL hPrinter AS LONG, BYVAL Level AS LONG, pForm AS BYTE, BYVAL cbBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumJobs LIB "WINSPOOL.DRV" ALIAS "EnumJobsA" (BYVAL hPrinter AS LONG, BYVAL FirstJob AS LONG, BYVAL NoJobs AS LONG, BYVAL Level AS LONG, pJob AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumMonitors LIB "WINSPOOL.DRV" ALIAS "EnumMonitorsA" (pName AS ASCIIZ, BYVAL Level AS LONG, pMonitors AS BYTE, BYVAL cbBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumPorts LIB "WINSPOOL.DRV" ALIAS "EnumPortsA" (pName AS ASCIIZ, BYVAL Level AS LONG, BYVAL lpbPorts AS LONG, BYVAL cbBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumPrintProcessorDatatypes LIB "WINSPOOL.DRV" ALIAS "EnumPrintProcessorDatatypesA" (pName AS ASCIIZ, pPrintProcessorName AS ASCIIZ, BYVAL Level AS LONG, pDatatypes AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG, _
                 pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumPrintProcessors LIB "WINSPOOL.DRV" ALIAS "EnumPrintProcessorsA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, BYVAL Level AS LONG, pPrintProcessorInfo AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumPrinterDrivers LIB "WINSPOOL.DRV" ALIAS "EnumPrinterDriversA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, BYVAL Level AS LONG, pDriverInfo AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION EnumPrinterPropertySheets LIB "WINSPOOL.DRV" ALIAS "EnumPrinterPropertySheets" (hPrinter AS LONG, hwnd AS LONG, lpfnAdd AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION EnumPrinters LIB "WINSPOOL.DRV" ALIAS "EnumPrintersA" (BYVAL flags AS LONG, xname AS ASCIIZ, BYVAL Level AS LONG, pPrinterEnum AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG, pcReturned AS LONG) AS LONG
DECLARE FUNCTION FindClosePrinterChangeNotification LIB "WINSPOOL.DRV" ALIAS "FindClosePrinterChangeNotification" (BYVAL hChange AS LONG) AS LONG
DECLARE FUNCTION FindFirstPrinterChangeNotification LIB "WINSPOOL.DRV" ALIAS "FindFirstPrinterChangeNotification" (BYVAL hPrinter AS LONG, BYVAL fdwFlags AS LONG, BYVAL fdwOptions AS LONG, pPrinterNotifyOptions AS ASCIIZ) AS LONG
DECLARE FUNCTION FindNextPrinterChangeNotification LIB "WINSPOOL.DRV" ALIAS "FindNextPrinterChangeNotification" (BYVAL hChange AS LONG, pdwChange AS LONG, pvReserved AS ASCIIZ, BYVAL ppPrinterNotifyInfo AS LONG) AS LONG
DECLARE FUNCTION GetForm LIB "WINSPOOL.DRV" ALIAS "GetFormA" (BYVAL hPrinter AS LONG, pFormName AS ASCIIZ, BYVAL Level AS LONG, pForm AS BYTE, BYVAL cbBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION GetJob LIB "WINSPOOL.DRV" ALIAS "GetJobA" (BYVAL hPrinter AS LONG, BYVAL JobId AS LONG, BYVAL Level AS LONG, pJob AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION GetPrintProcessorDirectory LIB "WINSPOOL.DRV" ALIAS "GetPrintProcessorDirectoryA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, BYVAL Level AS LONG, pPrintProcessorInfo AS ASCIIZ, BYVAL cdBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION GetPrinter LIB "WINSPOOL.DRV" ALIAS "GetPrinterA" (BYVAL hPrinter AS LONG, BYVAL Level AS LONG, pPrinter AS BYTE, BYVAL cbBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION GetPrinterData LIB "WINSPOOL.DRV" ALIAS "GetPrinterDataA" (BYVAL hPrinter AS LONG, pValueName AS ASCIIZ, pType AS LONG, pData AS BYTE, BYVAL nSize AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION GetPrinterDriver LIB "WINSPOOL.DRV" ALIAS "GetPrinterDriverA" (BYVAL hPrinter AS LONG, pEnvironment AS ASCIIZ, BYVAL Level AS LONG, pDriverInfo AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION GetPrinterDriverDirectory LIB "WINSPOOL.DRV" ALIAS "GetPrinterDriverDirectoryA" (pName AS ASCIIZ, pEnvironment AS ASCIIZ, BYVAL Level AS LONG, pDriverDirectory AS BYTE, BYVAL cdBuf AS LONG, pcbNeeded AS LONG) AS LONG
DECLARE FUNCTION OpenPrinter LIB "WINSPOOL.DRV" ALIAS "OpenPrinterA" (pPrinterName AS ASCIIZ, phPrinter AS LONG, pDefault AS PRINTER_DEFAULTS) AS LONG
DECLARE FUNCTION PrinterMessageBox LIB "WINSPOOL.DRV" ALIAS "PrinterMessageBoxA" (BYVAL hPrinter AS LONG, BYVAL xerror AS LONG, BYVAL hwnd AS LONG, pText AS ASCIIZ, pCaption AS ASCIIZ, BYVAL dwType AS LONG) AS LONG
DECLARE FUNCTION PrinterProperties LIB "WINSPOOL.DRV" ALIAS "PrinterProperties" (BYVAL hwnd AS LONG, BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION ReadPrinter LIB "WINSPOOL.DRV" ALIAS "ReadPrinter" (BYVAL hPrinter AS LONG, pBuf AS ANY, BYVAL cdBuf AS LONG, pNoBytesRead AS LONG) AS LONG
DECLARE FUNCTION ResetPrinter LIB "WINSPOOL.DRV" ALIAS "ResetPrinterA" (BYVAL hPrinter AS LONG, pDefault AS PRINTER_DEFAULTS) AS LONG
DECLARE FUNCTION ScheduleJob LIB "WINSPOOL.DRV" ALIAS "ScheduleJob" (BYVAL hPrinter AS LONG, BYVAL JobId AS LONG) AS LONG
DECLARE FUNCTION SetForm LIB "WINSPOOL.DRV" ALIAS "SetFormA" (BYVAL hPrinter AS LONG, pFormName AS ASCIIZ, BYVAL Level AS LONG, pForm AS BYTE) AS LONG
DECLARE FUNCTION SetJob LIB "WINSPOOL.DRV" ALIAS "SetJobA" (BYVAL hPrinter AS LONG, BYVAL JobId AS LONG, BYVAL Level AS LONG, pJob AS BYTE, BYVAL Command AS LONG) AS LONG
DECLARE FUNCTION SetPrinter LIB "WINSPOOL.DRV" ALIAS "SetPrinterA" (BYVAL hPrinter AS LONG, BYVAL Level AS LONG, pPrinter AS BYTE, BYVAL Command AS LONG) AS LONG
DECLARE FUNCTION SetPrinterData LIB "WINSPOOL.DRV" ALIAS "SetPrinterDataA" (BYVAL hPrinter AS LONG, pValueName AS ASCIIZ, BYVAL dwType AS LONG, pData AS BYTE, BYVAL cbData AS LONG) AS LONG
DECLARE FUNCTION StartDocPrinter LIB "WINSPOOL.DRV" ALIAS "StartDocPrinterA" (BYVAL hPrinter AS LONG, BYVAL Level AS LONG, pDocInfo AS ANY) AS LONG
DECLARE FUNCTION StartPagePrinter LIB "WINSPOOL.DRV" ALIAS "StartPagePrinter" (BYVAL hPrinter AS LONG) AS LONG
DECLARE FUNCTION WaitForPrinterChange LIB "WINSPOOL.DRV" ALIAS "WaitForPrinterChange" (BYVAL hPrinter AS LONG, BYVAL flags AS LONG) AS LONG
DECLARE FUNCTION WritePrinter LIB "WINSPOOL.DRV" ALIAS "WritePrinter" (BYVAL hPrinter AS LONG, pBuf AS ANY, BYVAL cdBuf AS LONG, pcWritten AS LONG) AS LONG


'
' ** MPR.DLL Declares (Network support)
'
DECLARE FUNCTION WNetAddConnection LIB "MPR.DLL" ALIAS "WNetAddConnectionA" (lpszNetPath AS ASCIIZ, lpszPassword AS ASCIIZ, lpszLocalName AS ASCIIZ) AS LONG
DECLARE FUNCTION WNetAddConnection2 LIB "MPR.DLL" ALIAS "WNetAddConnection2A" (lpNetResource AS NETRESOURCE, lpPassword AS ASCIIZ, lpUserName AS ASCIIZ, BYVAL dwFlags AS LONG) AS LONG
DECLARE FUNCTION WNetCancelConnection LIB "MPR.DLL" ALIAS "WNetCancelConnectionA" (lpszName AS ASCIIZ, BYVAL bForce AS LONG) AS LONG
DECLARE FUNCTION WNetCancelConnection2 LIB "MPR.DLL" ALIAS "WNetCancelConnection2A" (lpName AS ASCIIZ, BYVAL dwFlags AS LONG, BYVAL fForce AS LONG) AS LONG
DECLARE FUNCTION WNetCloseEnum LIB "MPR.DLL" ALIAS "WNetCloseEnum" (BYVAL hEnum AS LONG) AS LONG
DECLARE FUNCTION WNetConnectionDialog LIB "MPR.DLL" ALIAS "WNetConnectionDialog" (BYVAL hwnd AS LONG, BYVAL dwType AS LONG) AS LONG
DECLARE FUNCTION WNetDisconnectDialog LIB "MPR.DLL" ALIAS "WNetDisconnectDialog" (BYVAL hwnd AS LONG, BYVAL dwType AS LONG) AS LONG
DECLARE FUNCTION WNetEnumResource LIB "MPR.DLL" ALIAS "WNetEnumResourceA" (BYVAL hEnum AS LONG, lpcCount AS LONG, lpBuffer AS ANY, lpBufferSize AS LONG) AS LONG
DECLARE FUNCTION WNetGetConnection LIB "MPR.DLL" ALIAS "WNetGetConnectionA" (lpszLocalName AS ASCIIZ, lpszRemoteName AS ASCIIZ, cbRemoteName AS LONG) AS LONG
DECLARE FUNCTION WNetGetLastError LIB "MPR.DLL" ALIAS "WNetGetLastErrorA" (lpError AS LONG, lpErrorBuf AS ASCIIZ, BYVAL nErrorBufSize AS LONG, lpNameBuf AS ASCIIZ, BYVAL nNameBufSize AS LONG) AS LONG
DECLARE FUNCTION WNetGetUniversalName LIB "MPR.DLL" ALIAS "WNetGetUniversalNameA" (lpLocalPath AS ASCIIZ, BYVAL dwInfoLevel AS LONG, lpBuffer AS ANY, lpBufferSize AS LONG) AS LONG
DECLARE FUNCTION WNetGetUser LIB "MPR.DLL" ALIAS "WNetGetUserA" (lpName AS ASCIIZ, lpUserName AS ASCIIZ, lpnLength AS LONG) AS LONG
DECLARE FUNCTION WNetOpenEnum LIB "MPR.DLL" ALIAS "WNetOpenEnumA" (BYVAL dwScope AS LONG, BYVAL dwType AS LONG, BYVAL dwUsage AS LONG, lpNetResource AS NETRESOURCE, lphEnum AS LONG) AS LONG


'
' ** NETAPI32.DLL Declares (Network support)
'
' ** Important: Most of the NetAPI calls will not work in Windows 95
'
DECLARE FUNCTION Netbios LIB "NETAPI32.DLL" ALIAS "Netbios" (pncb AS NCB) AS BYTE
DECLARE FUNCTION NetUserGetInfo LIB "NETAPI32.DLL" ALIAS "NetUserGetInfo" (lpServer AS ANY, UserName AS ANY, BYVAL Level AS LONG, lpBuffer AS DWORD) AS LONG
DECLARE FUNCTION NetApiBufferFree LIB "NETAPI32.DLL" ALIAS "NetApiBufferFree" (BYVAL pBuffer AS LONG) AS LONG
DECLARE FUNCTION NetGetAnyDCName LIB "NETAPI32.DLL" ALIAS "NetGetAnyDCName" ( uServer AS ANY, uDomain AS ANY, buffer AS LONG) AS LONG
DECLARE FUNCTION NetGetDCName LIB "NETAPI32.DLL" ALIAS "NetGetDCName" ( uServer AS ANY, uDomain AS ANY, buffer AS LONG) AS LONG
DECLARE FUNCTION NetUserChangePassword LIB "NETAPI32.DLL" ALIAS "NetUserChangePassword" ( Domain AS ANY, User AS ANY, OldPass AS ANY, NewPass AS ANY) AS LONG
DECLARE FUNCTION NetUserGetGroups LIB "NETAPI32.DLL" ALIAS "NetUserGetGroups" ( lpServer AS ANY, UserName AS ANY, BYVAL Level AS LONG, lpBuffer AS LONG, BYVAL PrefMaxLen AS LONG, lpEntriesRead AS LONG, lpTotalEntries AS LONG) AS LONG
DECLARE FUNCTION NetUserGetLocalGroups LIB "NETAPI32.DLL" ALIAS "NetUserGetLocalGroups" ( lpServer AS ANY, UserName AS ANY, BYVAL Level AS LONG, BYVAL Flags AS LONG, lpBuffer AS LONG, BYVAL MaxLen AS LONG, lpEntriesRead AS LONG, lpTotalEntries AS LONG) AS LONG
DECLARE FUNCTION NetRemoteTOD LIB "NETAPI32.DLL" ALIAS "NetRemoteTOD" ( yServer AS ANY, pBuffer AS LONG) AS LONG
DECLARE FUNCTION NetWkstaGetInfo LIB "NETAPI32.DLL" ALIAS "NetWkstaGetInfo" ( uServer AS ANY, BYVAL level AS LONG, lpBuffer AS DWORD) AS LONG
DECLARE FUNCTION NetWkstaUserGetInfo LIB "NETAPI32.DLL" ALIAS "NetWkstaUserGetInfo" ( uServer AS ANY, BYVAL level AS LONG, lpBuffer AS DWORD) AS LONG


'
' ** LZ32.DLL Declares
'
DECLARE FUNCTION CopyLZFile LIB "LZ32.DLL" ALIAS "CopyLZFile" (BYVAL n1 AS LONG, BYVAL n2 AS LONG) AS LONG
DECLARE FUNCTION GetExpandedName LIB "LZ32.DLL" ALIAS "GetExpandedNameA" (lpszSource AS ASCIIZ, lpszBuffer AS ASCIIZ) AS LONG
DECLARE FUNCTION LZCopy LIB "LZ32.DLL" ALIAS "LZCopy" (BYVAL hfSource AS LONG, BYVAL hfDest AS LONG) AS LONG
DECLARE FUNCTION LZInit LIB "LZ32.DLL" ALIAS "LZInit" (BYVAL hfSrc AS LONG) AS LONG
DECLARE FUNCTION LZOpenFile LIB "LZ32.DLL" ALIAS "LZOpenFileA" (lpszFile AS ASCIIZ, lpOf AS OFSTRUCT, BYVAL style AS LONG) AS LONG
DECLARE FUNCTION LZRead LIB "LZ32.DLL" ALIAS "LZRead" (BYVAL hfFile AS LONG, lpvBuf AS ASCIIZ, BYVAL cbread AS LONG) AS LONG
DECLARE FUNCTION LZSeek LIB "LZ32.DLL" ALIAS "LZSeek" (BYVAL hfFile AS LONG, BYVAL lOffset AS LONG, BYVAL nOrigin AS LONG) AS LONG
DECLARE FUNCTION LZStart LIB "LZ32.DLL" ALIAS "LZStart" () AS LONG
DECLARE SUB LZClose LIB "LZ32.DLL" ALIAS "LZClose" (BYVAL hfFile AS LONG)
DECLARE SUB LZDone LIB "LZ32.DLL" ALIAS "LZDone" ()


'
' ** IMM32.DLL Declares
'
DECLARE FUNCTION ImmAssociateContext LIB "IMM32.DLL" ALIAS "ImmAssociateContext" (BYVAL hwnd AS LONG, BYVAL himc AS LONG) AS LONG
DECLARE FUNCTION ImmConfigureIME LIB "IMM32.DLL" ALIAS "ImmConfigureIME" (BYVAL hkl AS LONG, BYVAL hwnd AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION ImmCreateContext LIB "IMM32.DLL" ALIAS "ImmCreateContext" () AS LONG
DECLARE FUNCTION ImmDestroyContext LIB "IMM32.DLL" ALIAS "ImmDestroyContext" (BYVAL himc AS LONG) AS LONG
DECLARE FUNCTION ImmEnumRegisterWord LIB "IMM32.DLL" ALIAS "ImmEnumRegisterWordA" (BYVAL hkl AS LONG, BYVAL RegisterWordEnumProc AS LONG, lpszReading AS ASCIIZ, BYVAL dw AS LONG, lpszRegister AS ASCIIZ, lpv AS ANY) AS LONG
DECLARE FUNCTION ImmEscape LIB "IMM32.DLL" ALIAS "ImmEscapeA" (BYVAL hkl AS LONG, BYVAL himc AS LONG, BYVAL un AS LONG, lpv AS ANY) AS LONG
DECLARE FUNCTION ImmGetCandidateList LIB "IMM32.DLL" ALIAS "ImmGetCandidateListA" (BYVAL himc AS LONG, BYVAL deIndex AS LONG, lpCandidateList AS CANDIDATELIST, BYVAL dwBufLen AS LONG) AS LONG
DECLARE FUNCTION ImmGetCandidateListCount LIB "IMM32.DLL" ALIAS "ImmGetCandidateListCountA" (BYVAL himc AS LONG, lpdwListCount AS LONG) AS LONG
DECLARE FUNCTION ImmGetCandidateWindow LIB "IMM32.DLL" ALIAS "ImmGetCandidateWindow" (BYVAL himc AS LONG, BYVAL dw AS LONG, lpCandidateForm AS CANDIDATEFORM) AS LONG
DECLARE FUNCTION ImmGetCompositionFont LIB "IMM32.DLL" ALIAS "ImmGetCompositionFontA" (BYVAL himc AS LONG, lpLogFont AS LOGFONT) AS LONG
DECLARE FUNCTION ImmGetCompositionString LIB "IMM32.DLL" ALIAS "ImmGetCompositionStringA" (BYVAL himc AS LONG, BYVAL dw AS LONG, lpv AS ANY, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION ImmGetCompositionWindow LIB "IMM32.DLL" ALIAS "ImmGetCompositionWindow" (BYVAL himc AS LONG, lpCompositionForm AS COMPOSITIONFORM) AS LONG
DECLARE FUNCTION ImmGetContext LIB "IMM32.DLL" ALIAS "ImmGetContext" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION ImmGetConversionList LIB "IMM32.DLL" ALIAS "ImmGetConversionListA" (BYVAL hkl AS LONG, BYVAL himc AS LONG, lpsz AS ASCIIZ, lpCandidateList AS CANDIDATELIST, BYVAL dwBufLen AS LONG, BYVAL uFlag AS LONG) AS LONG
DECLARE FUNCTION ImmGetConversionStatus LIB "IMM32.DLL" ALIAS "ImmGetConversionStatus" (BYVAL himc AS LONG, lpdw AS LONG, lpdw2 AS LONG) AS LONG
DECLARE FUNCTION ImmGetDefaultIMEWnd LIB "IMM32.DLL" ALIAS "ImmGetDefaultIMEWnd" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION ImmGetDescription LIB "IMM32.DLL" ALIAS "ImmGetDescriptionA" (BYVAL hkl AS LONG, lpsz AS ASCIIZ, BYVAL uBufLen AS LONG) AS LONG
DECLARE FUNCTION ImmGetGuideLine LIB "IMM32.DLL" ALIAS "ImmGetGuideLineA" (BYVAL himc AS LONG, BYVAL dwIndex AS LONG, lpStr AS ASCIIZ, BYVAL dwBufLen AS LONG) AS LONG
DECLARE FUNCTION ImmGetIMEFileName LIB "IMM32.DLL" ALIAS "ImmGetIMEFileNameA" (BYVAL hkl AS LONG, lpStr AS ASCIIZ, BYVAL uBufLen AS LONG) AS LONG
DECLARE FUNCTION ImmGetOpenStatus LIB "IMM32.DLL" ALIAS "ImmGetOpenStatus" (BYVAL himc AS LONG) AS LONG
DECLARE FUNCTION ImmGetProperty LIB "IMM32.DLL" ALIAS "ImmGetProperty" (BYVAL hkl AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION ImmGetRegisterWordStyle LIB "IMM32.DLL" ALIAS "ImmGetRegisterWordStyleA" (BYVAL hkl AS LONG, BYVAL nItem AS LONG, lpStyleBuf AS STYLEBUF) AS LONG
DECLARE FUNCTION ImmGetStatusWindowPos LIB "IMM32.DLL" ALIAS "ImmGetStatusWindowPos" (BYVAL himc AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION ImmGetVirtualKey LIB "IMM32.DLL" ALIAS "ImmGetVirtualKey" (BYVAL hwnd AS LONG) AS LONG
DECLARE FUNCTION ImmInstallIME LIB "IMM32.DLL" ALIAS "ImmInstallIMEA" (lpszIMEFileName AS ASCIIZ, lpszLayoutText AS ASCIIZ) AS LONG
DECLARE FUNCTION ImmIsIME LIB "IMM32.DLL" ALIAS "ImmIsIME" (BYVAL hkl AS LONG) AS LONG
DECLARE FUNCTION ImmIsUIMessage LIB "IMM32.DLL" ALIAS "ImmIsUIMessageA" (BYVAL hwnd AS LONG, BYVAL un AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION ImmNotifyIME LIB "IMM32.DLL" ALIAS "ImmNotifyIME" (BYVAL himc AS LONG, BYVAL dwAction AS LONG, BYVAL dwIndex AS LONG, BYVAL dwValue AS LONG) AS LONG
DECLARE FUNCTION ImmRegisterWord LIB "IMM32.DLL" ALIAS "ImmRegisterWordA" (BYVAL hkl AS LONG, lpszReading AS ASCIIZ, BYVAL dw AS LONG, lpszRegister AS ASCIIZ) AS LONG
DECLARE FUNCTION ImmReleaseContext LIB "IMM32.DLL" ALIAS "ImmReleaseContext" (BYVAL hwnd AS LONG, BYVAL himc AS LONG) AS LONG
DECLARE FUNCTION ImmSetCandidateWindow LIB "IMM32.DLL" ALIAS "ImmSetCandidateWindow" (BYVAL himc AS LONG, lpCandidateForm AS CANDIDATEFORM) AS LONG
DECLARE FUNCTION ImmSetCompositionFont LIB "IMM32.DLL" ALIAS "ImmSetCompositionFontA" (BYVAL himc AS LONG, lpLogFont AS LOGFONT) AS LONG
DECLARE FUNCTION ImmSetCompositionString LIB "IMM32.DLL" ALIAS "ImmSetCompositionStringA" (BYVAL himc AS LONG, BYVAL dwIndex AS LONG, lpComp AS ANY, BYVAL dw AS LONG, lpRead AS ANY, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION ImmSetCompositionWindow LIB "IMM32.DLL" ALIAS "ImmSetCompositionWindow" (BYVAL himc AS LONG, lpCompositionForm AS COMPOSITIONFORM) AS LONG
DECLARE FUNCTION ImmSetConversionStatus LIB "IMM32.DLL" ALIAS "ImmSetConversionStatus" (BYVAL himc AS LONG, BYVAL dw1 AS LONG, BYVAL dw2 AS LONG) AS LONG
DECLARE FUNCTION ImmSetOpenStatus LIB "IMM32.DLL" ALIAS "ImmSetOpenStatus" (BYVAL himc AS LONG, BYVAL b AS LONG) AS LONG
DECLARE FUNCTION ImmSetStatusWindowPos LIB "IMM32.DLL" ALIAS "ImmSetStatusWindowPos" (BYVAL himc AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION ImmSimulateHotKey LIB "IMM32.DLL" ALIAS "ImmSimulateHotKey" (BYVAL hwnd AS LONG, BYVAL dw AS LONG) AS LONG
DECLARE FUNCTION ImmUnregisterWord LIB "IMM32.DLL" ALIAS "ImmUnregisterWordA" (BYVAL hkl AS LONG, lpszReading AS ASCIIZ, BYVAL dw AS LONG, lpszUnregister AS ASCIIZ) AS LONG


'
' ** SHELL32.DLL Declares
'
DECLARE FUNCTION DoEnvironmentSubst LIB "SHELL32.DLL" ALIAS "DoEnvironmentSubstA" (szString AS ASCIIZ, BYVAL cbString AS LONG) AS LONG
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL HDROP AS LONG, BYVAL UINT AS LONG, lpStr AS ASCIIZ, BYVAL ch AS LONG) AS LONG
DECLARE FUNCTION DragQueryPoint LIB "SHELL32.DLL" ALIAS "DragQueryPoint" (BYVAL HDROP AS LONG, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION DuplicateIcon LIB "SHELL32.DLL" ALIAS "DuplicateIcon" (BYVAL hInst AS LONG, BYVAL hIcon AS LONG) AS LONG
DECLARE FUNCTION ExtractAssociatedIcon LIB "SHELL32.DLL" ALIAS "ExtractAssociateIconA" (BYVAL hInst AS LONG, lpIconPath AS ASCIIZ, lpiIcon AS LONG) AS LONG
DECLARE FUNCTION ExtractIcon LIB "SHELL32.DLL" ALIAS "ExtractIconA" (BYVAL hInst AS LONG, lpszExeFileName AS ASCIIZ, BYVAL nIconIndex AS LONG) AS LONG
DECLARE FUNCTION ExtractIconEx LIB "SHELL32.DLL" ALIAS "ExtractIconExA" (lpszFile AS ASCIIZ, BYVAL nIconIndex AS LONG, phiconLarge AS LONG, phiconSmall AS LONG, BYVAL nIcons AS LONG) AS LONG
DECLARE FUNCTION FindEnvironmentString LIB "SHELL32.DLL" ALIAS "FindEnvironmentStringA" (szEnvVar AS ASCIIZ) AS DWORD
DECLARE FUNCTION FindExecutable LIB "SHELL32.DLL" ALIAS "FindExecutableA" (lpFile AS ASCIIZ, lpDirectory AS ASCIIZ, lpResult AS ASCIIZ) AS LONG

DECLARE FUNCTION SHAppBarMessage LIB "SHELL32.DLL" ALIAS "SHAppBarMessage" (BYVAL dwMessage AS LONG, pData AS APPBARDATA) AS LONG
DECLARE FUNCTION SHFileOperation LIB "SHELL32.DLL" ALIAS "SHFileOperationA" (lpFileOp AS SHFILEOPSTRUCT) AS LONG
DECLARE FUNCTION SHGetFileInfo LIB "SHELL32.DLL" ALIAS "SHGetFileInfoA" (pszPath AS ASCIIZ, BYVAL dwFileAttributes AS LONG, psfi AS SHFILEINFO, BYVAL cbFileInfo AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION SHGetNewLinkInfo LIB "SHELL32.DLL" ALIAS "SHGetNewLinkInfoA" (pszLinkto AS ASCIIZ, pszDir AS ASCIIZ, pszName AS ASCIIZ, pfMustCopy AS LONG, BYVAL uFlags AS LONG) AS LONG
DECLARE FUNCTION SHFormatDrive LIB "SHELL32.DLL" ALIAS "SHFormatDrive" (BYVAL hWnd AS LONG, BYVAL drive AS LONG, BYVAL fmtID AS LONG, BYVAL options AS LONG) AS LONG

DECLARE FUNCTION ShellAbout LIB "SHELL32.DLL" ALIAS "ShellAboutA" (BYVAL hwnd AS LONG, szApp AS ASCIIZ, szOtherStuff AS ASCIIZ, BYVAL hIcon AS LONG) AS LONG
DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS LONG, lpOperation AS ASCIIZ, lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS LONG
DECLARE FUNCTION Shell_NotifyIcon LIB "SHELL32.DLL" ALIAS "Shell_NotifyIconA" (BYVAL dwMessage AS LONG, lpData AS NOTIFYICONDATA) AS LONG
DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS LONG, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS LONG)
DECLARE SUB SHFreeNameMappings LIB "SHELL32.DLL" ALIAS "SHFreeNameMappings" (BYVAL hNameMappings AS LONG)
DECLARE SUB WinExecError LIB "SHELL32.DLL" ALIAS "WinExecErrorA" (BYVAL hwnd AS LONG, BYVAL xerror AS LONG, lpstrFileName AS ASCIIZ, lpstrTitle AS ASCIIZ)


'
' ** OLEAUT32.DLL Declares
'
DECLARE FUNCTION VarDateFromStr LIB "OLEAUT32.DLL" ALIAS "VarDateFromStr" (BYVAL OleString AS LONG, BYVAL lcid AS LONG, BYVAL dwFlags AS LONG, pDate AS DOUBLE) AS LONG
DECLARE FUNCTION VariantTimeToSystemTime LIB "OLEAUT32.DLL" ALIAS "VariantTimeToSystemTime" (BYVAL vbtime AS DOUBLE, lpSystemTime AS SYSTEMTIME) AS LONG
DECLARE FUNCTION SystemTimeToVariantTime LIB "OLEAUT32.DLL" ALIAS "SystemTimeToVariantTime" (lpSystemTime AS SYSTEMTIME, BYVAL vbtime AS DOUBLE) AS LONG


'
' ** VERSION.DLL Declares
'
DECLARE FUNCTION VerFindFile LIB "VERSION.DLL" ALIAS "VerFindFileA" (BYVAL uFlags AS LONG, szFileName AS ASCIIZ, szWinDir AS ASCIIZ, szAppDir AS ASCIIZ, szCurDir AS ASCIIZ, lpuCurDirLen AS LONG, szDestDir AS ASCIIZ, lpuDestDirLen AS LONG) AS LONG
DECLARE FUNCTION VerInstallFile LIB "VERSION.DLL" ALIAS "VerInstallFileA" (BYVAL uFlags AS LONG, szSrcFileName AS ASCIIZ, szDestFileName AS ASCIIZ, szSrcDir AS ASCIIZ, szDestDir AS ASCIIZ, szCurDir AS ASCIIZ, szTmpFile AS ASCIIZ, _
                 lpuTmpFileLen AS LONG) AS LONG
DECLARE FUNCTION GetFileVersionInfoSize LIB "VERSION.DLL" ALIAS "GetFileVersionInfoSizeA" (lptstrFilename AS ASCIIZ, lpdwHandle AS LONG) AS LONG
DECLARE FUNCTION GetFileVersionInfo LIB "VERSION.DLL"  ALIAS "GetFileVersionInfoA" (lptstrFilename AS ASCIIZ, BYVAL dwHandle AS LONG, BYVAL dwLen AS LONG, lpData AS ANY) AS LONG
DECLARE FUNCTION VerQueryValue LIB "VERSION.DLL" ALIAS "VerQueryValueA" (BYVAL pBlock AS LONG, lpSubBlock AS ASCIIZ, lplpBuffer AS DWORD, puLen AS LONG) AS LONG
